[![build](https://github.com/hoppet-code/hoppet/actions/workflows/main.yml/badge.svg)](https://github.com/hoppet-code/hoppet/actions/workflows/main.yml)
<a href="https://pypi.org/project/HOPPET/"><img alt="PyPI" src="https://img.shields.io/pypi/v/HOPPET"/></a>

# HOPPET: Higher Order Perturbative Parton Evolution Toolkit

HOPPET is a Fortran package for carrying out DGLAP evolution and other
common manipulations of parton distribution functions (PDFs). It also
includes C++ and Python interfaces to many of the key features.

Within HOPPET, PDFs are represented on a grid in x-space so as to
avoid limitations on the functional form of input
distributions. Good speed and accuracy are obtained through the
representation of splitting functions in terms of their convolution
with a set of piecewise polynomial basis functions, and Runge-Kutta
techniques are used for the evolution in Q.

Key features include:

* unpolarized evolution in the MSbar scheme to N3LO including heavy-quark thresholds
* QED evolution
* massless structure function evaluation up to N3LO
* polarized evolution up to NLO
* simple access (in Fortran 90) to the objects representing splitting
  function and PDFs, making it possible for a user to extend the
  facilities already provided.

The latest version can always be obtained from

    git clone https://github.com/hoppet-code/hoppet

Summaries of main new features in each release are in
[NEWS.md](NEWS.md). More detailed lists of changes are in the
[ChangeLog](ChangeLog) file.


## Note on changes in v2 series

Starting from v2.0.0, backwards compatibility with the v1 series of
HOPPET has been broken in one significant way: `hoppet_v1`
has become `hoppet` in all places in the code. This in particular
applies to `libhoppet_v1` which is now `libhoppet`, `module hoppet_v1`
which is now `module hoppet` and the C++ namespace `hoppetv1` which
is now `hoppet`.

As of v2.1.0 the old hand-coded `./configure` script is no longer
supported, one must instead use CMake to build HOPPET.

Besides these changes most users should be able to start using the v2
series without any difficulties.


## Note on Fortran compilers

HOPPET requires support for Fortran 2008. It is developed and tested
with recent versions of the gfortran compiler (v10 and later) on Linux
and Mac, and also also gets tested with the Intel (ifx) compiler, as
part of the CI.

# Build


```bash
mkdir build
cmake -S . -B build <extra flags>
cmake --build  build -j 
ctest --test-dir build  -j
cmake --install build
```

Key `<extra flags>` include:
- generic CMake flags, e.g. 
  * `-DCMAKE_INSTALL_PREFIX=/my/home/dir`
  * `-DCMAKE_Fortran_COMPILER=ifx`,
  * `-DCMAKE_BUILD_TYPE=RelWithDebInfo` (default is `Release`, which gives highest speed; an additional `-g` is included by default to help with debugging), 
  * `-DCMAKE_EXPORT_COMPILE_COMMANDS=ON`, to see the exact compilation commands as a json file
- flags pointing to the dependencies, `-DLHAPDF_DIR=/where/the/LHAPDF/is`,
- `-DHOPPET_USE_EXACT_COEF=ON`:    Compile-in exact coefficient functions.

# Example programs

## Streamlined interface

The simplest way to use HOPPET is through its streamlined interface.
There are examples for basic QCD evolution in 
- modern Fortran:
[example_f90/tabulation_example_streamlined.f90](example_f90/tabulation_example_streamlined.f90)
- Fortran 77: [example_f77/tabulation_example.f](example_f77/tabulation_example.f) 
- C++: [example_cpp/tabulation_example.cc](example_cpp/tabulation_example.cc)
- Python: [example_py/tabulation_example.py](example_py/tabulation_example.py)

Other features illustrated in the examples include

- accessing convolutions with splitting functions ([Fortran](example_f77/convolution_example.f))
- QCD+QED evolution ([Fortran90](example_f90/tabulation_example_qed_streamlined.f90), [C++](example_cpp/tabulation_example_qed.cc), [Python](example_py/tabulation_example_qed.py))
- massless structure functions ([Fortran90](example_f90/structure_functions_example.f90), [C++](example_cpp/structure_functions_example.cc), [Python](example_py/structure_function_example.py))
- comparisons with LHAPDF ([Fortran](example_f77/compare_lhapdf_hoppet.f), [Fortran90](example_f90/with-lhapdf/lhapdf_to_hoppet.f90), [C++](example_cpp/with-lhapdf/lhapdf_to_hoppet.cc), [Python](example_py/lhapdf_to_hoppet.py))


## Full interface  
The Fortran examples also illustrate usage of the full lower-level interface,
allowing fine-grained access to the underlying objects, which provide a
powerful and flexible framework for convolution and evolution.
See for example
[example_f90/tabulation_example.f90](example_f90/tabulation_example.f90).
An equivalent program with the startup, pdf initialisation and
evolution spread across different subroutines is given as
[example_f90/tabulation_example_2.f90](example_f90/tabulation_example_2.f90).

## Building the examples

The Fortran and C++ examples are all
compiled by default (unless `-DHOPPET_BUILD_EXAMPLES=OFF`) and
executables are to be found in `build/example_*/` directories. 

Python examples require a build with `-DHOPPET_BUILD_PYINTERFACE=ON`,
HOPPET to be installed and for the HOPPET Python module to be in the
PYTHONPATH. Assuming `hoppet-config` is in your path, you can view the
correct path with `hoppet-config --pythonpath`.  Alternatively you can 
simply `pip install hoppet` and then run the Python examples.

# Compilation within your own projects

## Manual compilation and in Makefiles

The `hoppet-config` scripts provides flags to aid with compilation. E.g.

```sh
gfortran -O3 -g tabulation_example.f90 -o tabulation_example $(hoppet-config --fflags --libs)
```

Run `hoppet-config -h` to see the full list of flags.

## Usage in CMake-based projects

If hoppet was built with CMake, it is possible to import its targets into
other projects. Namely, a minimal working project 

```CMake
cmake_minimum_required(VERSION 3.12)
project(mytest LANGUAGES Fortran)
find_package(hoppet)
add_executable(tabulation_example tabulation_example.f90)
target_link_libraries(tabulation_example PUBLIC hoppet::hoppet_static)
```

could be configured with 

```sh
cmake -S . -B BUILD -Dhoppet_DIR=hoppet/installation/share/hoppet/cmake
```

# Documentation

Detailed documentation is available as
[doc/HOPPET-doc.tex](doc/HOPPET-doc.tex). If you use HOPPET in a
scientific publication, please refer to https://arxiv.org/abs/0804.3755
(original v1 release) and https://arxiv.org/abs/2510.09310 (v2 features).


# Other notes

## Benchmarking

The benchmarking/ directory contains the programs used for the full
benchmarking, accuracy and precision testing. 

## Compiler warnings

When the hoppet library is being built, on some systems the following
warnings may be reported 

```
    /usr/bin/ranlib: file: libhoppet_v1.a(hoppet_v1.o) has no symbols
    /usr/bin/ranlib: file: libhoppet_v1.a(types.o) has no symbols
    
    ranlib: file: libhoppet_v1.a(hoppet_v1.o) has no symbols
    ranlib: file: libhoppet_v1.a(types.o) has no symbols
```

These warnings do not indicate an actual problem. They are simply a
consequence of the fact that some of the source (.f90) files contain
only information about interfaces and constants, so that the resulting
object (.o) files are essentially empty.


## Branches

- The [dev](https://github.com/hoppet-code/hoppet/tree/dev) branch
provides the latest development version of HOPPET. 
- The [master](https://github.com/hoppet-code/hoppet/tree/branch) will
usually be a little behind the dev branch

hoppet benchmarking/ directory
==============================

- [evolution_n3lo_tests.f90](evolution_n3lo_tests.f90): for testing the
  N3LO evolution, including the scale variation 

- [prec_and_timing.f90](prec_and_timing.f90): for testing precision and
  timing

- [structure_functions_benchmark_checks.f90](structure_functions_benchmark_checks.f90): 
  for structure functions benchmarks as in [arXiv:2404.15711](https://arxiv.org/abs/2404.15711)

- [benchmark.f90](benchmark.f90): used for the benchmarks in [hep-ph/0511119](https://arxiv.org/abs/hep-ph/0511119)

- [compare2files_v2.f90](compare2files_v2.f90): used for comparing the output from two 
  runs of `prec_and_timing`

# external-code/

This directory contains external code. For anything using git subtrees, you _must_
record the remote and the commit hash, tag or branch used.

## libome

Added 2025-10-29, with the following command, run FROM THE TOP-LEVEL DIRECTORY

```
git subtree add --prefix=external-code/libome git@gitlab.com:hoppet-code/libome-fork.git libome-func_copy_and_log-quietnan.patch --squash -m "Added git@gitlab.com:hoppet-code/libome-fork.git, libome-func_copy_and_log-quietnan.patch"
```

# Fortran examples with HOPPET

If building with CMake, by default all the examples in this directory will be built.
Assuming CMake used a `build/` directory, the executables will be found
in the `build/example_f90/`.

## Normal QCD evolution

- [tabulation_example.f90](tabulation_example.f90): a basic example to create a table across x and Q, with the full modern Fortran interface

- [tabulation_example_streamlined.f90](tabulation_example_streamlined.f90): similar example, but using the simpler "streamlined" interface

- [tabulation_example_2.f90](tabulation_example_2.f90): a more structured alternative to `tabulation_example.f90`, illustrating how one might organise the different objects

- [tabulation_example_n3lo.f90](tabulation_example_n3lo.f90): similar to `tabulation_example.f90`, with N3LO evolution and internal options for variable-flavour vs. fixed-flavour number schemes

- [tabulation_example_up_and_down.f90](tabulation_example_up_and_down.f90): an example of carrying out evolution up in scale to create a pdf_table and then back down, to demonstrate the code's ability to carry out such operations

## QCD+QED evolution

- [tabulation_example_qed.f90](tabulation_example_qed.f90): an example with QCD+QED evolution in the full modern Fortran interface
- [tabulation_example_qed_streamlined.f90](tabulation_example_qed_streamlined.f90): an example with QCD+QED evolution in the streamlined interface


## Structure-function evaluation

- [structure_functions_example.f90](structure_functions_example.f90): example to illustrate determination of (massless) structure functions

- [structure_functions_example_flavour.f90](structure_functions_example_flavour.f90): example that shows how to access structure functions decomposed by flavour and then recombine them

- [structure_functions_example_n3lo_tests.f90](structure_functions_example_n3lo_tests.f90): writes a series of tables with different combinations of NNLO and N3LO coefficient functions and splitting functions, including scale variation in the coefficient functions.

## Loading a PDF set from LHAPDF

These examples are all in the [with-lhapdf/](with-lhapdf/) directory and are only
compiled if using the CMake build system and if LHAPDF has been found. The executables are placed in the `build/example_f90/` directory.

- [with-lhapdf/lhapdf_to_hoppet.f90](with-lhapdf/lhapdf_to_hoppet.f90):
  an example that transfers a single LHAPDF PDF into the HOPPET pdf_table 
  of the streamlined interface

- [with-lhapdf/lhapdf_to_hoppet_allmembers.f90](with-lhapdf/lhapdf_to_hoppet_allmembers.f90):
  an example that transfers all members of an LHAPDF set into a structure
  with an array of tables, allowing for faster evaluation of all members in one go

- [with-lhapdf/hoppet_lhapdf.f90](with-lhapdf/hoppet_lhapdf.f90):
  The module that is used to help with the above tasks. This module is not included
  in the HOPPET library. Instead, currently, a user should copy it to their
  own project

# HOPPET: A Higher Order Perturbative Parton Evolution Toolkit

HOPPET is a package for carrying out DGLAP evolution and other common
manipulations of parton distribution functions (PDFs) in particle
physics. The core package is written in Fortran. This Python interface
provides access to a key subset of the functionality, the part known 
in the documentation as the "streamlined" interface.

The full underlying code and documentation can be found at
https://github.com/hoppet-code/hoppet.

## Example usage

```Python
import hoppet as hp
import numpy as np

def main():
    # choose the underlying spacing in y=log(1/x): 
    # smaller spacing gives higher accuracy but slower evolution
    dy = 0.1  
    # choose NNLO evolution
    nloop = 3 
    # Start hoppet
    hp.Start(dy, nloop)
    
    asQ0 = 0.35
    Q0 = np.sqrt(2.0)
    # Do the evolution starting from a standard benchmark initial condition 
    hp.Evolve(asQ0, Q0, nloop, 1.0, hp.BenchmarkPDFunpol, Q0)

    # Evaluate the PDFs at some x values and print them
    xvals = [1e-5,1e-4,1e-3,1e-2,0.1,0.3,0.5,0.7,0.9]
    Q = 100.0

    print('')
    print('           Evaluating PDFs at Q =',Q, ' GeV')
    print('    x      u-ubar      d-dbar    2(ubr+dbr)    c+cbar       gluon')
    for ix in range(9):
        pdf_array = hp.Eval(xvals[ix], Q)
        print('{:7.1E} {:11.4E} {:11.4E} {:11.4E} {:11.4E} {:11.4E}'.format(
            xvals[ix],
            pdf_array[6 + 2] - pdf_array[6 - 2], 
            pdf_array[6 + 1] - pdf_array[6 - 1], 
            2 * (pdf_array[6 - 1] + pdf_array[6 - 2]),
            pdf_array[6 - 4] + pdf_array[6 + 4],
            pdf_array[6 + 0]
        ))

    hp.DeleteAll()
```   
For more examples take a look at
[example_py](https://github.com/hoppet-code/hoppet/tree/master/example_py).
The above example is essentially identical to
[tabulation_example.py](https://github.com/hoppet-code/hoppet/tree/master/example_py/tabulation_example.py)
and prints the output of a typical benchmark PDF.

## Citation policy

If you use this program in a scientific publication we ask that you cite

G.P. Salam, J. Rojo, 'A Higher Order Perturbative Parton Evolution Toolkit (HOPPET)', 
Comput. Phys. Commun. 180 (2009) 120-156, [arXiv:0804.3755](https://arxiv.org/abs/0804.3755)

and                                                       

A. Karlberg, P. Nason, G.P. Salam, G. Zanderighi & F. Dreyer [arXiv:2510.09310](https://arxiv.org/abs/2510.09310). 

# Examples for the Python interface to HOPPET

- [tabulation_example.py](tabulation_example.py): the standard benchmark
  evolution example

- [tabulation_example_qed.py](tabulation_example_qed.py): illustrates
  evolution including QED effects

- [structure_function_example.py](structure_function_example.py):
  illustrates evaluation of structure functions

- [lhapdf_to_hoppet.py](lhapdf_to_hoppet.py): shows how to read in an
  LHAPDF grid and use it from HOPPET. This gives PDF evaluation that is
  about 5 times faster that LHAPDF's Python interface in version 6.5.5.
  Requires the LHAPDF Python interface.

In this folder can be found the datafiles used to make comparisons
with Valerio Bertone (Feb 2023) against his implementation of the
strucutre functions in APPFEL++.

The code used to produce the datafiles can be found in
structure_functions_valerio_checks.f90.

We use the LHA toy pdf initialised at sqrt(2) GeV with αS(sqrt(2)) =
0.35 and with a variable flavour scheme.

In general we find that, up to NNLO, we have agreement at the or
better than permille level except close to zeroes. At N3LO the
discrepancies are slightly larger, but in general we do also agree at
the permille level. At this point we think it is due to numerical
limitations in the computaton of the rather wiggly functions. Further
tests are needed to see if we can get rid of these.

# libome

Implementation of massive operator matrix elements (OMEs) of the QCD twist-2
operators in x-space.

This library provides numerical implementations of the QCD corrections up to
three-loop order to the massive OMEs that enter both heavy-flavour Wilson
coefficients for deep-inelastic scattering and the matching relations for
variable flavour number scheme (VFNS) parton distribution functions (PDFs).

The results implemented here were obtained in a series of publications. If you
use this library, please cite those references, as provided in the file
[CITATION](CITATION). For your convenience, the BibTeX entries for these
references are collected in [CITATION.bib](CITATION.bib). The code is subject
to the GNU General Public License version 3.0 or later, see [LICENSE](LICENSE).

The library is written C++ and in addition offers a C interface that can also
be called from Fortran. See
[examples/use-c-interface.c](examples/use-c-interface.c) an
[examples/use-c-interface-from-fortran.f90](examples/use-c-interface-from-fortran.f90)
for examples of how to use it. Moreover, the library offers a couple of
convenience features that allow, e.g., to compute Mellin moments and Mellin
convolutions through numerical integration.

The results are implemented as generalised series expansions in the Bjorken
variable x around different expansion points, so that for most points the
evaluation should almost reach double precision.

## Dependencies

The library is written in C++17 and thus needs a C++ compiler that supports
this standard. In addition, it depends on:
- GNU Scientific Library (GSL) (tested with version 2.8)
- CMake (at least version 3.28)

If you want to compile the Fortran example, you also need a Fortran compiler,
but this is not built by default.

To build the documentation, you need Doxygen installed.

Finally, if you want to build the unit and integration tests, the GoogleTest
framework is automatically downloaded and built. Also this is not enabled by
default.

## Installation

To compile the library, first create a build directory and go there:
```
mkdir build
cd build
```
Then, run CMake to generate the build scripts. By default GNU Makefiles are
generated, but other build systems, like Ninja are also supported. In the
simplest case, running
```
cmake ..
```
should be enough. Details about what can be configured are discussed below.
Then actually compile the library using `make`
```
make
```
and finally install it using (may require root privileges; see below for how to
change the install directory)
```
make install
```

The CMake setup offers a couple of configuration options. They can be changed
using `-D...` command line options. The most important ones are
- `-DCMAKE_INSTALL_PREFIX=/path/to/install/to`
  Change the directory to install to. By default the library is installed to
  `/usr/local`, but if you want to install it elsewhere, this option allows
  you to change the install destination.
- `-DBUILD_EXAMPLES=true`
  Enable the compilation of the examples in the `examples/` directory. By
  default, examples are not built. Even when built, the example programs are
  never installed along with the library, but they can be found in the
  `build/examples` directory and can be run from there.
- `-DBUILD_FORTRAN_EXAMPLE=true`
  Enable the compilation of the example for how to use the C interface from
  Fortran (`examples/use-c-interface-from-fortran.f90`).
- `-DBUILD_TESTS=true`
  Enable building the unit and integration test suite. CMake will automatically
  download and build the GoogleTest framework that the test suite uses.
  The tests are built in `build/tests` and can be run by executing the command
  `ctest` in that directory.
- `-DCMAKE_BUILD_TYPE=Debug`
  If you need debug symbols, this option enables them. It also turns off
  compile time optimisation, which will make the code noticeably slower.
- `-DBUILD_SHARED_LIBS=Off`
  By default, the library is compiled as a shared library. If you use this
  option, a static library is built instead.

## Usage

Documentation about how to use the library in your own programs is available
via Doxygen and can be generated using
```
cd docs
doxygen
```
and viewed by pointing a browser to `docs/html/index.html`.

Simple usage examples can be found in the `examples/` directory. (See also the
`-DBUILD_EXAMPLES=true` CMake option explained above.)

The library is built as a shared library. To use it from another program, you
have to link to it. Assume you have written a program `example.cpp` with the
following contents
```
#include <iostream>
#include <cmath>
#include <ome/ome.h>

int main()
{
  double as = 0.118/(4.*M_PI), LM = std::log(1.59/100.), NF = 3., x = 0.2;
  std::cout << ome::AqqQPS_reg(as, LM, NF, x) << std::endl;
  return(0);
}
```

If the library is installed to a standard path (e.g,.
`/usr` or `/usr/local`) that is searched by default, it should be enough to just
specify the library (and its dependencies) at link time:
```
g++ -lome -o example example.cpp
```

If you have installed the library to a non-standard path, you will have to
tell the compiler where to find the header files and the linker where to find
the shared library. Suppose you have installed the library to `/opt/ome`. In
that case, you would have to use
```
g++ -I/opt/ome/include -L/opt/ome/lib -lome -o example example.cpp
```
In addition, you will need to specify the path to the shared library at runtime.
On Linux, this can, for example, be done using the `LD_LIBRARY_PATH` environment
variable.
```
LD_LIBRARY_PATH="/opt/lib:$LD_LIBRARY_PATH" ./example
```

Finally, the library also provides pkg-config information. If the installation
directory of libome is on the pkg-config search path (either because it is
installed in a standard location or by adding it to the `PKG_CONFIG_PATH`
environment variable) you can use the `pkg-config` command to obtain the
necessary compiler and linker flags. In the running example from above you can
use
```
export PKG_CONFIG_PATH="/opt/lib/pkgconfig:$PKG_CONFIG_PATH"
g++ `pkg-config --cflags --libs libome` -o example example.cpp
```

# README for the test_acc_2025/ directory

This directory contains the scripts used for the 2025 paper discussing
the v2 release of hoppet. The datafiles for the actual precision and
timing results are to be found at
https://github.com/hoppet-code/2025-prec-and-timing
For some plotting scripts, this is assumed to be in the
which is assumed to be in the `../../../2025-prec-and-timing/`
directory.

## Scripts for generating results

- `run-many.sh buildDir outputDir`: generates the reference runs and a 
  results for a range of grid spacings, and interpolation orders. 

- `run-many-lhapdf.sh buildDir outputDir`: generates lhapdf grids 
  as well as hoppet results for a range of grid spacing. Note that
  to use the lhapdf grids, your LHAPDF path should including directory
  that contains these files (or they should be moved into a standard
  LHAPDF location)

- `run-and-process-lhapdf-grids.sh buildDir refFile outputDir`:
  runs a LHAPDF to sample the different flavours at the same
  x,Q points as used in the hoppet precision tests, to allow
  comparisons of precision (compared to refFile). It also produces 
  timings.

These scripts use
[prec_and_timing.f90](../prec_and_timing.f90), 
[compare2files_v2.f90](../compare2files_v2.f90) and
[lhapdf_timings.cc](../lhapdf_timings.cc),
with the corresponding executables expected to be located in
`buildDir/benchmarking`.

This is an example of things look like if the scale cancellation is not properly done. 
The change was

               &                  + (twopi**3*beta2) * four * log(ev_muR_Q)))
               !&                  + (twopi**3*beta2) * two * log(ev_muR_Q)))

Tests of mass thresholds at N3LO, in particular the effect of the non-singlet minus
piece (post v. pre-NSm) around the b-threshold.

## Sum rule checks, across charm threshold, toy PDF

See `sumrule-Qmax1.42-postNSm.dat`, `sumrule-Qmax1.42-preNSm.dat`

prior to inclusion of NSm part in the threshold:
```
 Momentum sum rule =    1.0000000789329637      , expected 1, difference =    7.8932963720745875E-008
 uv + dv sum rule =    2.9997982067332973      , expected 3, difference =   -2.0179326670266562E-004
 uv - dv sum rule =   0.99993273630074975      , expected 1, difference =   -6.7263699250252884E-005
```

after inclusion of NSm part in the threshold:
```
 Momentum sum rule =    1.0000000789329637      , expected 1, difference =    7.8932963720745875E-008
 uv + dv sum rule =    2.9999999580394734      , expected 3, difference =   -4.1960526608875170E-008
 uv - dv sum rule =   0.99999998693845016      , expected 1, difference =   -1.3061549841708597E-008
```

## Full PDF checks, comparing to NNPDF40_an3lo_as_01180

All of these checks take the NNPDF LHAPDF initial condition just below
(4.919) the b threshold (4.920), evolve just above (4.921) and then
study various flavours.

See [MTM-NSm-test-plots.pdf](MTM-NSm-test-plots.pdf)

- p.5 shows the effect of the NS-minus piece on the down, up and strange
  valence contributions, showing the "post-NSm" versus "pre-NSm"
  difference just above the b threshold. The effect is at the few times
  $10^{-6}$ level

- p.2 shows that there seems to be a small-x issue in NNPDF's treatment
  of the b threshold (at NNLO things were fine). At $x=10^{-4}$
  NNPDF=$-0.135$ whereas we find $-0.08$ for $b+\bar b$. For comparison
  at 50GeV, $b+\bar b\simeq3.5$, so we're talking a likely ballpark of
  1.5% there.

- any other NNPDF "issues" look like they are small. To within accuracy
  we cannot reliably tell whether they have the NSminus piece in the
  mass thresholds.

!======================================================================
!! Module that provides tools for constructing a general (vector of)
!! running couplings, including coupled evolution and mass thresholds. 
!! 
!! Aims here are:
!!   - reasonable flexbility
!!   - decent performance on evaluating a coupling at a given scale
!!   - guaranteed accuracy
!!
!! Initialisation speed will however not be good since the routine
!! explicitly solves the differential equation for evolution to build
!! a grid from which it then interpolates the coupling. While better
!! methods exist for simple cases (e.g. inverting an equation for
!! lambda in terms of alpha up to NNLO in QCD), the method adopted
!! here has the advantage of being easily generalised.
!! 
!! To "create" a coupling it is necessary first to create the
!! CouplingTerm objects that go to making a CouplingDefinition
!!
module couplings
  use types; use consts_dp
  use warnings_and_errors
  use runge_kutta
  use assertions
  implicit none
  private

  !! this provides the definition for a term in coupling's evolution
  type CouplingTerm
     integer               :: itarget
     integer, allocatable  :: alpha_powers(:)
     real(dp)              :: coeff
  end type CouplingTerm
  public :: CouplingTerm
  

  !! this provides the definition for a coupling's evolution
  type CouplingDefinition
     integer            :: n_couplings, nf_lo, nf_hi
     logical, allocatable :: use_reciprocal(:)
     type(CouplingTerm), allocatable :: beta_terms(:,:)
     type(CouplingTerm), allocatable :: threshold_terms(:,:)
     type(CouplingTerm), allocatable :: reverse_threshold_terms(:,:)
     real(dp)  :: muMatch_M !! matching scale / mass scale
  end type CouplingDefinition
  public :: CouplingDefinition

  
  type(CouplingTerm),       pointer :: current_operation_glb(:)
  type(CouplingDefinition), pointer :: cpl_def_glb
  integer                           :: nf_glb

  
  !! Sub-Segment (fixed nf) in the evolution of a coupling
  type CouplingSubSegment
     real(dp) :: dt, t_lo, t_hi
     real(dp), allocatable :: ra(:,:)
  end type CouplingSubSegment
  public :: CouplingSubSegment

  !! Segment (fixed nf, multiple sub-segments) in the evolution of a coupling
  type CouplingSegment
     real(dp) :: dt, t_lo, t_hi, min_sub_dt
     type(CouplingSubSegment), allocatable :: subseg(:)
  end type CouplingSegment
  public :: CouplingSegment


  !--------- go from 0.5 GeV to over 10^20 GeV
  !real(dp), parameter :: default_t_lo = -1.3862944 !-3.2188758_dp
  !real(dp), parameter :: default_t_hi = 93.0_dp 
  ! for speed and stability, go from 0.71 GeV to about 10^6 GeV
  ! (as of 18/08/05 c. 3 ms on 1.7GHz P4 with Lahey)
  real(dp), parameter :: default_t_lo = -0.71_dp
  real(dp), parameter :: default_t_hi = 30.0_dp
  real(dp), parameter :: initial_dt = 0.4_dp, default_eps = 1e-8_dp
  real(dp), parameter :: subsegment_size = 2.5_dp
  ! something that we can safely divide by but that should
  ! not cause problems when adding things on
  real(dp), parameter :: fake_zero_dt = 1e-200_dp
  ! fraction of dt by which we will consider it to be safe to extrapolate
  real(dp), parameter :: safe_extrapolation = 0.02
  ! NOTE: this is not free, but should be >= than order of Runge-Kutta 
  ! routine used...
  integer,  parameter :: interp_ord = 4
  integer :: iii
  real(dp), parameter :: interp_resc_t(0:interp_ord)=(/(iii,iii=0,interp_ord)/)

  !! an (array of) couplings
  type Coupling
     type(CouplingDefinition)            :: def
     real(dp)                            :: t_lo, t_hi, eps
     !! segment_boundaries(nf) is tofQ(mass of object(nf)) -- or else
     !! t_lo, t_hi for outer reach.
     real(dp),              allocatable  :: segment_boundaries(:)
     type(CouplingSegment), allocatable  :: segments(:)
     integer                             :: n_points
  end type Coupling
  public :: Coupling

  public :: new_CouplingTerm, new_CouplingDefinition
  public :: new_Coupling
  public :: coupling_array, coupling_value
  public :: nf_at_Q, nf_at_t, nf_range, Q_Range_at_nf, t_Range_at_nf

  interface apply_operation
     module procedure apply_operation_alpha
  end interface
  public :: apply_operation
  public :: tofQ, Qoft

  ! some private interfaces
  interface segment_alpha
     module procedure segment_alpha_all, segment_alpha_sctn
  end interface

  interface in_range
     module procedure in_range_int, in_range_dp
  end interface

contains

  !======================================================================
  !! Returns a term for renorm group evolution of the form
  !!
  !! d alpha(itarget) / dln Q^2 = sum(alpha(:) ** alpha_powers(:)) * coeff
  !!
  !! Analogously, for mass thresholds we will have:
  !!
  !! delta alpha(itarget) = sum(alpha(:) ** alpha_powers(:)) * coeff
  !!
  function new_CouplingTerm(itarget,alpha_powers,coeff) result(term)
    integer,  intent(in) :: itarget, alpha_powers(:)
    real(dp), intent(in) :: coeff
    type(CouplingTerm) :: term
    term%itarget = itarget
    allocate(term%alpha_powers(size(alpha_powers)))
    term%alpha_powers = alpha_powers
    term%coeff        = coeff
  end function new_CouplingTerm


  !======================================================================
  !! Returns a definition object for a coupling which should have a 
  !! range of flavors going from nf_lo to nf_hi, with 
  !! beta_terms(:,nf_lo:nf_hi) for describing the renormalisation group
  !! evolution. 
  !!
  !! - If beta_terms is not supplied then when creating the
  !!   coupling object itself, the user will need to supply a
  !!   subprogram for calculating the derivative.
  !!
  !! - If the optional threshold_terms(:,nf_lo+1:nf_hi) are supplied then
  !!   these are used for transitions going both up and down in flavor
  !!   (using the lower-nf coupling as reference when going up in nf,
  !!   and the higher-nf coupling as reference when going down).
  !!
  !! - If at the desired accuracy that behaviour is not good enough, one
  !!   can supply reverse_threshold_terms(:,nflo+1:nf_hi) for going down
  !!   in nf, using the higher-nf coupling to compute the change.
  !!
  !! - by default evolution is carried out in 1/alpha; in some cases
  !!   this may not be viable (e.g. in certain coupled equations) and
  !!   one can then provide the array use_reciprocal which specifies
  !!   which couplings evolve in their reciprocal.
  function new_CouplingDefinition(n_couplings, &
       & nf_lo, nf_hi, beta_terms, threshold_terms,&
       & reverse_threshold_terms, muMatch_M, use_reciprocal)&
       &     result(def)
    integer,            intent(in) :: n_couplings, nf_lo, nf_hi
    type(CouplingTerm), intent(in), optional :: beta_terms(:,:)
    type(CouplingTerm), intent(in), optional :: threshold_terms(:,:)
    type(CouplingTerm), intent(in), optional :: reverse_threshold_terms(:,:)
    real(dp),           intent(in), optional :: muMatch_M
    logical,            intent(in), optional :: use_reciprocal(:)
    type(CouplingDefinition) :: def
    !---------------------------
    integer :: dummy
    
    
    def%n_couplings = n_couplings
    def%nf_lo = nf_lo
    def%nf_hi = nf_hi

    if (present(beta_terms)) then
       call check_CouplingTerms(def, beta_terms, is_threshold=.false., &
            &                   extra_info = '(while checking beta_terms)')
       allocate(def%beta_terms(size(beta_terms,1), nf_lo:nf_hi))
       def%beta_terms = beta_terms
    end if
    
    if (present(threshold_terms)) then
       call check_CouplingTerms(def, threshold_terms, is_threshold=.true., &
            &                   extra_info ='(while checking threshold_terms)')
       allocate(def%threshold_terms(size(threshold_terms,1), nf_lo+1:nf_hi))
       def%threshold_terms = threshold_terms
    end if

    if (present(reverse_threshold_terms)) then
       if (.not.present(threshold_terms)) call wae_error(&
            &'new_CouplingDefinition',&
            &'reverse_threshold_terms may only be supplied if &
            &threshold_terms also present')
       call check_CouplingTerms(def, reverse_threshold_terms, &
            & is_threshold=.true., &
            & extra_info = '(while checking reverse_threshold_terms)')
       allocate(def%reverse_threshold_terms(&
            &       size(reverse_threshold_terms,1), nf_lo+1:nf_hi))
       def%reverse_threshold_terms = reverse_threshold_terms
    end if

    allocate(def%use_reciprocal(1:def%n_couplings))
    if (present(use_reciprocal)) then
       if (size(use_reciprocal) /= n_couplings) call wae_error(&
            &'new_CouplingDefinition',&
            &'Size of use_reciprocal did not correspond to n_couplings')
       def%use_reciprocal = use_reciprocal
    else
       def%use_reciprocal = .true.
    end if
    

    def%muMatch_M = default_or_opt(one, muMatch_M)
  end function new_CouplingDefinition
  

  !======================================================================
  !! Checks a bunch of coupling terms to ensure that they make sense
  !! in the context of the (partially initialised) CouplingDefinition;
  !! tests differ (marginally) according to whether is_threshold =
  !! .true. or .false.
  !!
  subroutine check_CouplingTerms(def, terms, is_threshold, extra_info)
    type(CouplingDefinition), intent(in) :: def
    type(CouplingTerm),       intent(in) :: terms(:,:)
    logical,                  intent(in) :: is_threshold
    character(len=*),         intent(in) :: extra_info
    !------------
    character(len=100) :: our_info
    integer :: right_size_2, nf_lbound, nf, iterm
    
    if (is_threshold) then
       nf_lbound = def%nf_lo + 1
    else
       nf_lbound = def%nf_lo
    end if
    right_size_2 = def%nf_hi - nf_lbound + 1

    ! size!
    if (size(terms,2) /= right_size_2) then
       write(our_info,'(a,i0,a,i0)') &
            & 'Size (dim 2) of terms was ', size(terms,2), &
            & ' but expected ', right_size_2 
       call wae_error('check_CouplingTerms', trim(our_info), extra_info)
    end if
    
    ! sanity of range of alpha
    if (any(terms%itarget < 1 .or. terms%itarget > def%n_couplings)) then
       write(our_info,'(a,i0)') &
         &'There were target terms with indices outside expected range 1..',&
         & def%n_couplings
       call wae_error('check_CouplingTerms', trim(our_info), extra_info)
    end if

    ! sanity of size of alpha_powers
    do nf = nf_lbound, def%nf_hi
       do iterm = 1, size(terms,1)
          if (size(terms(iterm,nf-nf_lbound+1)%alpha_powers) &
               &/= def%n_couplings) then
             write(our_info,'(a,"(iterm=",i0,",nf=",i0,")",a,i0,a,i0)') &
             & "size of terms", iterm,nf,"%alpha_powers(:) should have been ",&
                 & def%n_couplings, " but was ",&
                 & size(terms(iterm,nf-nf_lbound+1)%alpha_powers)
             call wae_error('check_CouplingTerms', trim(our_info), extra_info)
          end if
       end do
    end do
  end subroutine check_CouplingTerms
  

  !======================================================================
  !! Returns a coupling type based on the definition def, with values
  !! alpha(:) at initial scale Q with masses(nf_lo+1:nf_hi).
  !!
  function new_Coupling(def,alpha,Q,masses, deriv_or_threshold, &
       &                    Q_lo, Q_hi, eps) result(cpl)
    type(CouplingDefinition), intent(in) :: def
    real(dp),              intent(in) :: alpha(:), Q, masses(def%nf_lo+1:)
    real(dp), optional,    intent(in) :: Q_lo !!default= exp(.5*default_t_lo)
    real(dp), optional,    intent(in) :: Q_hi !!default= exp(.5*default_t_hi)
    real(dp), optional,    intent(in) :: eps  !!deafult= default_eps
    type(Coupling) :: cpl
    interface
       !! function that returns either dalpha/dt (for nf_in=nf_out)
       !! or delta alpha when crossing a threshold from nf_in to nf_out
       function deriv_or_threshold(t, alpha, nf_in, nf_out)
         use types; implicit none
         real(dp), intent(in) :: t
         real(dp), intent(in) :: alpha(:)
         integer,  intent(in) :: nf_in, nf_out
         real(dp)             :: deriv_or_threshold(size(alpha))
       end function deriv_or_threshold
    end interface
    optional :: deriv_or_threshold
    !--------------------
    integer  :: dummy, nf_Q, nf
    real(dp) :: alpha_here(def%n_couplings), this_t

    cpl%def   = def
    
    dummy =assert_eq(size(alpha),def%n_couplings,'new_Coupling: size of alpha')
    dummy =assert_eq(size(masses),def%nf_hi - def%nf_lo,&
         &                                      'new_Coupling: size of masses')
    
    cpl%t_lo = tofQ(default_or_opt(Qoft(default_t_lo), Q_lo))
    cpl%t_hi = tofQ(default_or_opt(Qoft(default_t_hi), Q_hi))
    cpl%eps  = default_or_opt(default_eps, eps)

    allocate(cpl%segment_boundaries(def%nf_lo:def%nf_hi+1))
    cpl%segment_boundaries(def%nf_lo) = cpl%t_lo
    cpl%segment_boundaries(def%nf_hi+1) = cpl%t_hi
    cpl%segment_boundaries(def%nf_lo+1:def%nf_hi) = &
         & in_range(tofQ(masses(:)) + tofQ(def%muMatch_M), cpl%t_lo, cpl%t_hi)
    
    ! the following error message should now be redundant since all
    ! masses are put at edges (this means that results at edges
    ! may not be predictable).
    if (any(cpl%segment_boundaries > cpl%t_hi .or.&
         &  cpl%segment_boundaries < cpl%t_lo)) call wae_error('new_Coupling',&
         & 'A segment boundary has fallen outside Q_lo:Q_hi range')

    ! keep track of number of points we are storing
    cpl%n_points = 0
    
    allocate(cpl%segments(def%nf_lo:def%nf_hi))
    nf_Q = nf_at_Q(cpl, Q)

    ! fill "central" segment
    call fill_segment(cpl,nf_Q, alpha, tofQ(Q), deriv_or_threshold)

    ! fill segments above this one
    do nf = nf_Q + 1, def%nf_hi
       this_t = cpl%segment_boundaries(nf)
       alpha_here = segment_alpha(cpl, nf-1, this_t)

       ! go through various options
       if (present(deriv_or_threshold)) then
          alpha_here = alpha_here &
               & + deriv_or_threshold(this_t, alpha_here, nf-1, nf)
       else if (allocated(def%threshold_terms)) then
          alpha_here = alpha_here + &
               &apply_operation(def%threshold_terms(:,nf),alpha_here)
       end if
       call fill_segment(cpl,nf, alpha_here, this_t, deriv_or_threshold)
    end do
    
    ! fill segments below this one
    do nf = nf_Q - 1, def%nf_lo, -1
       this_t = cpl%segment_boundaries(nf+1)
       alpha_here = segment_alpha(cpl, nf+1, this_t)
       if (present(deriv_or_threshold)) then
          alpha_here = alpha_here &
               & + deriv_or_threshold(this_t, alpha_here, nf+1, nf)
       else if (allocated(def%reverse_threshold_terms)) then
          alpha_here = alpha_here + &
               &apply_operation(def%reverse_threshold_terms(:,nf+1),alpha_here)
       else if (allocated(def%threshold_terms)) then
          alpha_here = alpha_here - &
               &apply_operation(def%threshold_terms(:,nf+1),alpha_here)
       end if
       call fill_segment(cpl,nf, alpha_here, this_t, deriv_or_threshold)
    end do

  end function new_Coupling
  
  
  !======================================================================
  !! Fill a segment to the required precision -- algorithm used is
  !! to subdivide the segment into "bite-sized" pieces (subsegment_size)
  !! and for each subsegment to use an adaptive uniform grid.
  !! 
  !! Probably not the most efficient general approach in the world, but 
  !! should adequate for likely real-life uses.
  subroutine fill_segment(cpl, nf, alpha, t, deriv)
    type(Coupling), intent(inout), target :: cpl
    integer,        intent(in)    :: nf
    real(dp),       intent(in)    :: alpha(:), t
    interface
       !! function that returns either dalpha/dt (for nf_in=nf_out)
       !! or delta alpha when crossing a threshold from nf_in to nf_out
       function deriv(t, alpha, nf_in, nf_out)
         use types; implicit none
         real(dp), intent(in) :: t
         real(dp), intent(in) :: alpha(:)
         integer,  intent(in) :: nf_in, nf_out
         real(dp)             :: deriv(size(alpha))
       end function deriv
    end interface
    optional :: deriv
    !-------------------------------------------
    type(CouplingSegment), pointer :: seg
    integer  :: n
    integer  :: iseg_init, iseg
    real(dp) :: this_alpha(size(alpha))

    

    seg => cpl%segments(nf)
    ! maybe extend these limits later?
    seg%t_lo = cpl%segment_boundaries(nf)
    seg%t_hi = cpl%segment_boundaries(nf+1)

    ! having n >= 1 makes life simpler elswhere
    n = max(interp_ord+1,ceiling((seg%t_hi - seg%t_lo)/subsegment_size))
    seg%dt   = max(fake_zero_dt,(seg%t_hi - seg%t_lo)/n)
    allocate(seg%subseg(0:n-1))

    ! now fill up the subsegments.
    ! first their bounds
    do iseg = 0, n-1
       seg%subseg(iseg)%t_lo = seg%t_lo + iseg * seg%dt; 
       seg%subseg(iseg)%t_hi = seg%t_lo + (iseg+1) * seg%dt
       !write(0,*) nf, iseg, seg%subseg(iseg)%t_lo, seg%subseg(iseg)%t_hi
    end do

    ! then fill their contents:
    ! first do the one that contains the specific t value
    iseg_init = in_range(floor((t - seg%t_lo)/seg%dt), 0, n-1)
    
    call fill_subsegment(cpl, nf, seg%subseg(iseg_init), alpha, t, deriv)

    ! then do the ones above it
    do iseg =  iseg_init+1, n-1
       this_alpha= reciprocal_or_not(&
            &       seg%subseg(iseg-1)%ra(:,ubound(seg%subseg(iseg-1)%ra,2)))
       call fill_subsegment(cpl, nf, seg%subseg(iseg), &
            & this_alpha, seg%subseg(iseg-1)%t_hi, deriv)
    end do

    ! then below
    do iseg =  iseg_init-1, 0, -1
       this_alpha= reciprocal_or_not(seg%subseg(iseg+1)%ra(:,0))
       call fill_subsegment(cpl, nf, seg%subseg(iseg), &
            & this_alpha, seg%subseg(iseg+1)%t_lo, deriv)
    end do
    
    seg%min_sub_dt = minval(seg%subseg%dt)
  end subroutine fill_segment
  

  !======================================================================
  !! Fill this sub-segment with alpha values. The algorithm used
  !! is to do the fill based on a coarse grid and then a fine grid
  !! and if they differ by too much then halve the grid size and
  !! try again. In the end it is the finer grid that is taken.
  !!
  !! No doubt there exist better approaches -- but hopefully this
  !! will be reasonably robust.
  subroutine fill_subsegment(cpl, nf, subseg, alpha, t, deriv)
    type(Coupling), intent(inout), target   :: cpl
    type(CouplingSubSegment), intent(inout) :: subseg
    integer,        intent(in)    :: nf
    real(dp),       intent(in)    :: alpha(:), t
    interface
       !! function that returns either dalpha/dt (for nf_in=nf_out)
       !! or delta alpha when crossing a threshold from nf_in to nf_out
       function deriv(t, alpha, nf_in, nf_out)
         use types; implicit none
         real(dp), intent(in) :: t
         real(dp), intent(in) :: alpha(:)
         integer,  intent(in) :: nf_in, nf_out
         real(dp)             :: deriv(size(alpha))
       end function deriv
    end interface
    optional :: deriv
    !--------------------------
    integer  :: idiv, n
    real(dp), pointer :: coarse(:,:), fine(:,:)

    subseg%dt = initial_dt
    ! having n >= 1 makes life simpler elswhere
    n  = max(1,ceiling((subseg%t_hi - subseg%t_lo)/subseg%dt))
    subseg%dt = max(fake_zero_dt, (subseg%t_hi - subseg%t_lo)/n)
    idiv = 0
    do
       allocate(fine(size(alpha), 0:n))
       call fill_tentative_subsegment(cpl, nf, subseg, fine, alpha, t, deriv)
       if (idiv > 0) then
          !write(0,*) 'dt,diff', subseg%dt, maxval(abs(coarse-fine(:,::2)))
          !-- the funny rel + abs error
          !if (all (abs(coarse-fine(:,::2)) &
          !     & <= cpl%eps*(one+abs(fine(:,::2))))) exit
          !-- here instead just have a plain relative error
          if (all (abs(coarse-fine(:,::2)) <= cpl%eps*abs(fine(:,::2)))) exit
          deallocate(coarse)
       end if
       coarse => fine
       subseg%dt = half * subseg%dt; n = 2*n
       idiv = idiv + 1
       ! these are quite arbitrary conditions...
       if (n > 10000 .or. &
            &(subseg%dt > fake_zero_dt .and.subseg%dt < 1e-4_dp)) then
          call wae_error(&
            &'fill_subsegment',&
            &'Need too fine a grid for storing alpha',&
            &'Try reducing the required precision &
            &or restricing the evolution range')
       end if
       
    end do
    allocate(subseg%ra(size(alpha), 0:n))
    subseg%ra = fine
    !write(0,*) 'final dt is', nf, subseg%dt
    deallocate(coarse)
    deallocate(fine)
    cpl%n_points = cpl%n_points + n+1
  end subroutine fill_subsegment
  
  !======================================================================
  !! Fill the supplied array candidate for a segment given
  !! the supplied alpha and t initial conditions.
  !!
  !! It assumes that set%dt and t_lo, t_hi correspond to 
  !! the n chosen.
  subroutine fill_tentative_subsegment(cpl, nf, subseg, fine, alpha, t, deriv)
    type(Coupling), intent(inout), target :: cpl
    integer,        intent(in)    :: nf
    type(CouplingSubSegment), intent(inout) :: subseg
    real(dp),       intent(out)   :: fine(:,0:)
    real(dp),       intent(in)    :: alpha(:), t
    interface
       !! function that returns either dalpha/dt (for nf_in=nf_out)
       !! or delta alpha when crossing a threshold from nf_in to nf_out
       function deriv(t, alpha, nf_in, nf_out)
         use types; implicit none
         real(dp), intent(in) :: t
         real(dp), intent(in) :: alpha(:)
         integer,  intent(in) :: nf_in, nf_out
         real(dp)             :: deriv(size(alpha))
       end function deriv
    end interface
    optional :: deriv
    !--------
    real(dp) :: ra(size(alpha)), this_t, new_t
    integer :: dir(2), init_it(2), last_it(2), idir, it, n

    ! used within the D.E.
    if (allocated(cpl%def%beta_terms))&
         & current_operation_glb => cpl%def%beta_terms(:,nf)
    cpl_def_glb => cpl%def
    nf_glb = nf
    n = ubound(fine,2)

    init_it(1) = max(0,floor((t-subseg%t_lo)/subseg%dt))
    init_it(2) = min(n, init_it(1) + 1)
    init_it(1) = init_it(2) - 1
    dir(1:2)     = (/-1, 1/)
    last_it(1:2) = (/0, n/)

    do idir = 1, 2
       this_t = t
       ra = reciprocal_or_not(alpha)
       !write(0,*) 'doing',init_it(idir), last_it(idir), dir(idir)
       do it = init_it(idir), last_it(idir), dir(idir)
          new_t = it*subseg%dt + subseg%t_lo
          if (present(deriv)) then
             call rkstp_1d_special(new_t - this_t, this_t, ra, deriv)
          else
             call rkstp(new_t - this_t, this_t, ra, calc_dra)
          end if
          fine(:,it) = ra
       end do
    end do
    
  end subroutine fill_tentative_subsegment
  
  
  !======================================================================
  !! Calculates dra, the derivative of 1/alpha (ra)
  subroutine calc_dra(t, ra, dra)
    real(dp), intent(in)  :: t, ra(:)
    real(dp), intent(out) :: dra(:)
    !------------------
    real(dp) :: alpha(size(dra))

    alpha = reciprocal_or_not(ra)
    dra = apply_operation(current_operation_glb, alpha)
    where(cpl_def_glb%use_reciprocal)
       dra = -ra**2 * dra 
    end where
  end subroutine calc_dra

  !======================================================================
  !! Calculates dra, the derivative of 1/alpha (ra)
  subroutine calc_dra_special(t, ra, dra, deriv)
    real(dp), intent(in)  :: t, ra(:)
    real(dp), intent(out) :: dra(:)
    interface
       !! function that returns either dalpha/dt (for nf_in=nf_out)
       !! or delta alpha when crossing a threshold from nf_in to nf_out
       function deriv(t, alpha, nf_in, nf_out)
         use types; implicit none
         real(dp), intent(in) :: t
         real(dp), intent(in) :: alpha(:)
         integer,  intent(in) :: nf_in, nf_out
         real(dp)             :: deriv(size(alpha))
       end function deriv
    end interface
    !------------------
    real(dp) :: alpha(size(dra))

    alpha = reciprocal_or_not(ra)
    dra = deriv(t,alpha,nf_glb, nf_glb)
    where(cpl_def_glb%use_reciprocal)
       dra = -ra**2 * dra 
    end where

    !write(0,'(i3,f10.3,3es13.5," ",3es13.5)') nf_glb, t, ra, dra
  end subroutine calc_dra_special


  !======================================================================
  !! Returns the value of coupling icpl (default = 1)
  function coupling_array(cpl, Q, fix_nf) result(alpha)
    type(Coupling), intent(in) :: cpl
    real(dp),       intent(in) :: Q
    integer, optional, intent(in) :: fix_nf
    real(dp)                   :: alpha(cpl%def%n_couplings)
    !-----------------------
    integer  :: nf
    real(dp) :: t

    t = tofQ(Q)
    ! avoid using default_or_opt since nf_at_t(cpl,t) might add extra
    ! time delay? (Maybe this is exaggerated?)
    if (present(fix_nf)) then
       nf = fix_nf
    else
       nf = nf_at_t(cpl,t)
    end if
    alpha = segment_alpha(cpl, nf, t)
  end function coupling_array
  

  !======================================================================
  !! Returns the value of the first of the couplings (since this
  !! is often enough) -- NB not efficient if large array of couplings.
  !!
  !! On 1.7GHz P4 takes about 1.5ns with lf95.
  function coupling_value(cpl, Q, fix_nf) result(alpha)
    type(Coupling), intent(in) :: cpl
    real(dp),       intent(in) :: Q
    integer, optional, intent(in) :: fix_nf
    real(dp)                   :: alpha
    real(dp)                   :: alpha_arr(1:1)
    !-----------------------
    integer  :: nf
    real(dp) :: t

    t = tofQ(Q)
    ! avoid using default_or_opt since nf_at_t(cpl,t) might add extra
    ! time dealy? (Maybe this is exaggerated?)
    if (present(fix_nf)) then
       nf = fix_nf
    else
       nf = nf_at_t(cpl,t)
    end if
    alpha_arr = segment_alpha(cpl, nf, t, icpl_lo = 1, icpl_hi = 1)
    alpha = alpha_arr(1)
    !write(0,'(f15.10,i,f15.12)') t, nf, alpha ! TESTING!!!
  end function coupling_value


  !======================================================================
  !! Returns the value of the coupling array from the sepcific segment , 
  !! (seg_nf) at the given t value for the coupling cpl.
  function segment_alpha_all(cpl, seg_nf, t) result(alpha)
    use interpolation
    type(Coupling),    intent(in), target :: cpl
    integer,           intent(in) :: seg_nf
    real(dp),          intent(in) :: t
    real(dp)                      :: alpha(1:cpl%def%n_couplings)
    alpha = segment_alpha(cpl, seg_nf, t, 1, cpl%def%n_couplings)
  end function segment_alpha_all
  

  !======================================================================
  !! Returns the value the coupling array section (icpl_lo:icpl_hi) from
  !! the sepcific segment (seg_nf), at the given t value for the
  !! coupling cpl.
  !!
  !! Note that we have two routines segment_alpha_sctn and segment_alpha_all
  !! rather than optional arguments, so as to be able to define the
  !! size of the result without difficulty.
  function segment_alpha_sctn(cpl, seg_nf, t, icpl_lo, icpl_hi) result(alpha)
    use interpolation
    type(Coupling),    intent(in), target :: cpl
    integer,           intent(in) :: seg_nf
    real(dp),          intent(in) :: t
    integer,           intent(in) :: icpl_lo, icpl_hi
    real(dp)                      :: alpha(icpl_lo:icpl_hi)
    !-------------------------------
    real(dp) :: dalpha, t_resc
    type(CouplingSegment), pointer :: seg
    type(CouplingSubSegment), pointer :: subseg
    integer :: it_lo, it_hi, n, i, iseg
    real(dp) :: weights(0:interp_ord)
    character(len=100) :: error_msg
    
    seg => cpl%segments(seg_nf)
    ! sometimes rounding errors take us beyond the allowed limits, 
    ! especially with fix_nf option -- so allow some margin for going
    ! outside range.
    if (t > seg%t_hi + safe_extrapolation*seg%min_sub_dt&
         & .or. t < seg%t_lo - safe_extrapolation*seg%min_sub_dt) then
       write(error_msg,*) 't was', t, ', range was', seg%t_lo, seg%t_hi
       call wae_error(&
         &'segment_alpha: requested t out of segment range',&
         &trim(error_msg))
    end if
    
    iseg = in_range(floor((t-seg%t_lo)/seg%dt), 0, ubound(seg%subseg,1))
    subseg => seg%subseg(iseg)

    it_lo = max(0,floor((t - subseg%t_lo)/subseg%dt) - (interp_ord)/2)
    it_hi = min(ubound(subseg%ra,2),it_lo+interp_ord)
    it_lo = max(0,it_hi - interp_ord)

    n = it_hi - it_lo

    t_resc = (t - (subseg%t_lo+it_lo*subseg%dt))/subseg%dt

    ! efficient, but how accurate?
    ! alternatively: go via polint?
    call uniform_interpolation_weights(t_resc,weights(0:n))
    do i = icpl_lo, icpl_hi  !1, cpl%def%n_couplings
       alpha(i) = dot_product(weights(0:n),subseg%ra(i,it_lo:it_hi))
       !call polint(interp_resc_t(0:n),subseg%ra(i,it_lo:it_hi),t_resc,
       !alpha(i),dalpha)
    end do
    
    ! remember that not all couplings are stored as reciprocal
    cpl_def_glb => cpl%def
    alpha = reciprocal_or_not(alpha)
  end function segment_alpha_sctn
  


  !******************* extracing numbers of flav ************************
  !-------------------------------------------------------------
  !! Returns the number of flavours relevant for scale Q
  !! Optionally, returns also the range of Qvalues (Qlo, Qhi) for which 
  !! this value of nf remains the same.
  !!
  !! Use convention that AT the quark mass that flavor is considered active
  integer function nf_at_Q(cpl, Q, Q_lo, Q_hi, muMatch_M)
    type(Coupling),  target, intent(in)  :: cpl
    real(dp),        intent(in)  :: Q
    real(dp),        intent(out), optional :: Q_lo, Q_hi
    real(dp),        intent(in),  optional :: muMatch_M
    nf_at_Q = nf_at_t(cpl, tofQ(Q), Q_lo, Q_hi, muMatch_M)
  end function nf_at_Q
  

  !-------------------------------------------------------------
  !! Returns the number of flavours relevant for scale Q
  !! Optionally, returns also the range of Qvalues (Qlo, Qhi) for which 
  !! this value of nf remains the same.
  !!
  !! Use convention that AT the quark mass that flavor is considered active
  integer function nf_at_t(cpl, t, Q_lo, Q_hi, muMatch_M)
    type(Coupling),  target, intent(in)  :: cpl
    real(dp),        intent(in)  :: t
    real(dp),        intent(out), optional :: Q_lo, Q_hi
    real(dp),        intent(in),  optional :: muMatch_M
    !-----------------------------
    type(CouplingDefinition), pointer :: def
    real(dp) :: deltat_match
    integer  :: nf
    real(dp), pointer :: mod_bound(:)
    real(dp), pointer :: inr_bound(:)

    def => cpl%def

    if (present(muMatch_M)) then
       allocate(mod_bound(cpl%def%nf_lo:cpl%def%nf_hi+1))
       deltat_match = tofQ(default_or_opt(&
            &def%muMatch_M, muMatch_M)/def%muMatch_M)

       ! redefine limits so as to account for requested matching
       ! thresholds muMatch_M. Outer limits should not be modified
       ! since they are rigidly fixed?
       mod_bound = cpl%segment_boundaries
       inr_bound => mod_bound(def%nf_lo+1:def%nf_hi)
       inr_bound = inr_bound + deltat_match
       inr_bound = min(cpl%segment_boundaries(def%nf_hi+1),&
            &          max(cpl%segment_boundaries(def%nf_lo),inr_bound))
    else
       mod_bound => cpl%segment_boundaries
    end if
    
    do nf = def%nf_lo, def%nf_hi
       if (t >= mod_bound(nf) .and. t < mod_bound(nf+1)) exit
    end do
    
    if (nf > def%nf_hi) then
       call wae_error('nf_at_t: Specified t is not in supported range',dbleval=t)
    end if

    if (present(Q_lo)) Q_lo = Qoft(mod_bound(nf))
    if (present(Q_hi)) Q_hi = Qoft(mod_bound(nf+1))

    if (present(muMatch_M)) deallocate(mod_bound)

    nf_at_t = nf
  end function nf_at_t
  

  !======================================================================
  !! returns values for nf_lo and nf_hi for this coupling
  subroutine nf_range(cpl, nf_lo, nf_hi)
    type(Coupling), intent(in)  :: cpl
    integer,        intent(out) :: nf_lo, nf_hi
    nf_lo = cpl%def%nf_lo
    nf_hi = cpl%def%nf_hi
  end subroutine nf_range
  
  !-------------------------------------------------------------
  ! returns the Q range for a given value of nf. If supported.
  subroutine t_Range_at_nf(cpl, nf, t_lo, t_hi, muMatch_M)
    type(Coupling),  intent(in)  :: cpl
    integer,         intent(in)  :: nf
    real(dp),        intent(out) :: t_lo, t_hi
    real(dp), optional, intent(in) :: muMatch_M
    !---------------------------------------
    real(dp) :: deltat_match
    character(len=60) :: string

    if (nf < cpl%def%nf_lo .or. nf > cpl%def%nf_hi) then
       write(string,'(a,i0,a)') 'nf value ',nf,' not supported'
       call wae_Error('t_Range_at_nf', trim(string))
    end if

    deltat_match = tofQ(default_or_opt(&
         &cpl%def%muMatch_M, muMatch_M)/cpl%def%muMatch_M)

    ! remember that only internal boundaries get modified 
    ! by deltat_match
    t_lo = cpl%segment_boundaries(nf)
    if (nf > cpl%def%nf_lo) t_lo = t_lo + deltat_match
    t_lo = max(cpl%t_lo,min(cpl%t_hi,t_lo))

    t_hi = cpl%segment_boundaries(nf+1)
    if (nf < cpl%def%nf_hi) t_hi = t_hi + deltat_match
    t_hi = max(cpl%t_lo,min(cpl%t_hi,t_hi))
 
  end subroutine t_Range_at_nf


  !-------------------------------------------------------------
  ! returns the Q range for a given value of nf. If supported.
  subroutine Q_Range_at_nf(cpl, nf, Q_lo, Q_hi, muMatch_M)
    type(Coupling),  intent(in)  :: cpl
    integer,         intent(in)  :: nf
    real(dp),        intent(out) :: Q_lo, Q_hi
    real(dp), optional, intent(in) :: muMatch_M
    !---------------------------------------
    real(dp) :: t_lo, t_hi

    call t_Range_at_nf(cpl, nf, t_lo, t_hi, muMatch_M)
    Q_lo = Qoft(t_lo)
    Q_hi = Qoft(t_hi)
  end subroutine Q_Range_at_nf

  !======================================================================
  !! Return the result of the application to alpha of the operation
  !! implicitly contained in the supplied terms.
  function apply_operation_alpha(terms,alpha) result(dalpha)
    type(CouplingTerm), intent(in) :: terms(:)
    real(dp),           intent(in) :: alpha(:)
    real(dp)                       :: dalpha(size(alpha))
    integer  :: i, ia
    real(dp) :: term
    dalpha = zero
    do i = 1, size(terms)
       term = terms(i)%coeff
       if (term == zero) cycle
       do ia = 1, size(terms(i)%alpha_powers)
          if (terms(i)%alpha_powers(ia) /= 0) then
             term = term * alpha(ia)**terms(i)%alpha_powers(ia)
          end if
       end do
       dalpha(terms(i)%itarget) = dalpha(terms(i)%itarget) + term
    end do
  end function apply_operation_alpha
  

  !************************* ancillary stuff ******************************
  !! conversion from t to Q (helps avoid risk of forgetting factors of two)
  elemental function tOfQ(Q)
    real(dp), intent(in) :: Q
    real(dp)             :: tOfQ
    if (Q <= zero) then
       !write(0,*) "resetting Q", Q
       tofQ = -1e200_dp
    else
       tOfQ = two * log(Q)
    end if
  end function tOfQ
  !! conversion from Q to t (helps avoid risk of forgetting factors of two)
  elemental function QOft(t)
    real(dp), intent(in) :: t
    real(dp)             :: QOft
    QOft = exp(half*t)
  end function QOft

  !----------------------------------------------------------------------
  subroutine rkstp_1d_special(h,x,y, deriv)
    real(dp), intent(in)    :: h
    real(dp), intent(inout) :: x, y(:)
    interface
       !! function that returns either dalpha/dt (for nf_in=nf_out)
       !! or delta alpha when crossing a threshold from nf_in to nf_out
       function deriv(t, alpha, nf_in, nf_out) result(res)
         use types; implicit none
         real(dp), intent(in) :: t
         real(dp), intent(in) :: alpha(:)
         integer,  intent(in) :: nf_in, nf_out
         real(dp)             :: res(size(alpha))
       end function deriv
    end interface
    real(dp), parameter :: third = one/three
    !------------------------------------------------------------
    real(dp) :: w1(size(y)), w2(size(y)), w3(size(y))
    real(dp) :: hh
    hh = half * h
    call calc_dra_special(x,y,w1,deriv); w1 = w1 * hh            ! w1 = k1/2
    call calc_dra_special(x+hh, y + w1, w2,deriv); w2 = w2 * hh  ! w2 = k2/2
    call calc_dra_special(x+hh, y + w2, w3,deriv); w3 = w3 * h   ! w3 = k3
    w2 = w1 + two*w2                                       ! w2 = half*k1 + k2
    call calc_dra_special(x+h , y + w3, w1,deriv); w1 = w1 * hh  ! w1 = k4/2
    
    x = x + h
    !                k1/2 + k2  + k3 + k4/2
    y = y + third * (w2         + w3 + w1)
  end subroutine rkstp_1d_special


  
  !======================================================================
  !! returns the reciprocal of arg where cpl_def_glb%use_reciprocal = .true.
  !! otherwise returns arg itself
  function reciprocal_or_not(arg)
    real(dp), intent(in) :: arg(:)
    real(dp)             :: reciprocal_or_not(size(arg))
    where (cpl_def_glb%use_reciprocal)
       reciprocal_or_not = one/arg
    elsewhere
       reciprocal_or_not = arg
    end where
  end function reciprocal_or_not
  
  !======================================================================
  !! returns i unless it is outside the bounds imin imax, in which case
  !! it returns the closer bound, assuming imax > imin
  elemental integer function in_range_int(i, imin, imax) result(in_range)
    integer, intent(in) :: i, imin, imax
    in_range = max(imin, min(imax, i))
  end function in_range_int
  elemental real(dp) function in_range_dp(i, imin, imax)  result(in_range)
    real(dp), intent(in) :: i, imin, imax
    in_range = max(imin, min(imax, i))
  end function in_range_dp

end module couplings

!======================================================================
! $Id: coefficient_functions.f90,v 1.1 2001/06/27 14:15:16 gsalam Exp $
module coefficient_functions
  use types; use consts_dp; use convolution_communicator
  use qcd
  implicit none
  private


  public :: cf_CqF2MSbar, cf_CgF2MSbar
  public :: cf_CqFL, cf_CgFL

contains

  function cf_CqF2MSbar(y) result(res)
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x
    real(dp) :: lnx, ln1mx

    x = exp(-y)
    res = zero

    select case(cc_piece)
    case(cc_REAL,cc_REALVIRT)
       lnx = log(x); ln1mx = log(one - x)
       res = CF*(two*(ln1mx/(one-x)) - 1.5_dp/(one-x) - (one+x)*ln1mx&
            & - (one+x**2)/(one-x)*lnx + 3.0_dp + two*x)
    end select
    select case(cc_piece)
    case(cc_VIRT,cc_REALVIRT)
       ln1mx = log(one - x) ! spiacente di farlo due volte
       res = res - CF*(two*(ln1mx/(one-x)) - 1.5_dp/(one-x))
    case(cc_DELTA)
       res =  -CF*(pi**2/3.0_dp + 9.0_dp*half)
    end select

    if (cc_piece /= cc_DELTA) res = res * x
  end function cf_CqF2MSbar


  function cf_CgF2MSbar(y) result(res)
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x
    real(dp) :: lnx, ln1mx

    x = exp(-y)
    res = zero

    select case(cc_piece)
    case(cc_REAL,cc_REALVIRT)
       lnx = log(x); ln1mx = log(one - x)
       res = TR*(((one-x)**2+x**2)*(ln1mx-lnx)-8.0_dp*x**2+8.0_dp*x-one)
    end select
    select case(cc_piece)
    case(cc_VIRT,cc_REALVIRT)
    case(cc_DELTA)
       res = zero
    end select

    if (cc_piece /= cc_DELTA) res = res * x
  end function cf_CgF2MSbar

  function cf_CqFL(y) result(res)
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x

    x = exp(-y)
    res = zero

    select case(cc_piece)
    case(cc_REAL,cc_REALVIRT)
       res = two*CF*x
    end select
    select case(cc_piece)
    case(cc_VIRT,cc_REALVIRT)
    case(cc_DELTA)
       res = zero
    end select

    if (cc_piece /= cc_DELTA) res = res * x
  end function cf_CqFL

  function cf_CgFL(y) result(res)
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x

    x = exp(-y)
    res = zero

    select case(cc_piece)
    case(cc_REAL,cc_REALVIRT)
       res = four*TR * x*(one-x)
    end select
    select case(cc_piece)
    case(cc_VIRT,cc_REALVIRT)
    case(cc_DELTA)
       res = zero
    end select

    if (cc_piece /= cc_DELTA) res = res * x
  end function cf_CgFL
  
!.
!.
!.

end module coefficient_functions

!! Module to facilitate the transfer of LHAPDF PDF sets into HOPPET
!!
!! The main routines are:
!!
!! - LoadLHAPDF(name[,imem=0]): 
!!   Load a single LHAPDF member into streamlined interface (tables(0))
!!
!! - LoadLHAPDFSet(name):
!!   Load all members of an LHAPDF set, with member 0 going into tables(0)
!!   of the streamlined interface, and all members going into
!!   lhapdf_tables(0:max_mem) (where max_mem is the maximum member number
!!   of the set).  
!!
!!
module hoppet_lhapdf
  use streamlined_interface, InitPDF_hoppet => InitPDF
  use hoppet_term
  use hoppet_lhapdf_interfaces
  use types
  use pdf_tabulate
  use qcd_coupling
  use hoppet_to_string
  implicit none

  private

  !! a type to hold information about an LHAPDF set loaded into HOPPET
  type hoppet_lhapdf_set
    !! range of the original LHAPDF set
    real(dp) :: Qmin, Qmax, xmin, xmax

    !! quark masses for VFN scheme
    real(dp) :: mc, mb, mt

    !! index of the highest available member in the set
    integer  :: max_mem = -1

    !! name of the LHAPDF set (potentially truncated)
    character(len=300) :: name = ""

    !! PDF set metadata
    integer  :: orderPDF  !< orderPDF=1 means LO evolution
    integer  :: nloop     !< number of loops from a hoppet point of view
    integer  :: nfmax     !< maximum number of flavours in the set

    type(pdf_table),        pointer :: tables(:)    => null() ! array of tables
    type(running_coupling), pointer :: couplings(:) => null() ! array of couplings
    logical :: owns_data = .false.
  end type hoppet_lhapdf_set

  type(hoppet_lhapdf_set), target, save :: lhapdf_set

  character(len=*), parameter :: tfmt = '("'//blue//'",a,f8.2,a,"'//reset//'")'


  public :: LoadLHAPDF, LoadLHAPDFSet
  public :: hoppet_lhapdf_set
  public :: lhapdf_set

contains

  !! Load a single LHAPDF member into streamlined interface (tables(0))
  !! If imem is not given, member 0 is loaded
  !!
  !! The routine also starts up hoppet with the right range and sensible
  !! default parameters
  !! 
  subroutine LoadLHAPDF(name, imem)
    character(len=*),  intent(in) :: name
    integer, optional, intent(in) :: imem
    !---------------------------------------
    real(dp) :: Q2minPDF, Q2maxPDF
    type(hoppet_lhapdf_set), pointer :: set
    real(dp) :: ta1, ta2
    real(dp) :: ymax, dy, dlnlnQ!, Q0
    integer  :: order, yorder, lnlnQorder
    real(dp), parameter :: mz = 91.1880_dp

    set => lhapdf_set ! shorthand

    ! Load LHAPDF set
    call cpu_time(ta1)
    call initPDFSetByName(trim(name))
    if (present(imem)) then
      call initPDF(imem)
    else
      call initPDF(0)
    end if

    call numberpdf(set%max_mem)
    !call cpu_time(ta2)
    !write(*,tfmt) "Time to load LHAPDF sets: ", (ta2-ta1)*1e3_dp, " ms"
    write(*,'(a,i4,a)') "Number of members in set: 1 + ", set%max_mem

    call getQ2min(0,Q2minPDF)
    call getQ2max(0,Q2maxPDF)
    set%Qmin = sqrt(Q2minPDF)
    set%Qmax = sqrt(Q2maxPDF)
    call getxmin(0,set%xmin)
    call getxmax(0,set%xmax)
    call getorderas(set%orderPDF) ! NB: LHAPDF returns 0 for 1-loop running, 1 for 2-loop etc.
    set%nloop = 1 + set%orderPDF
    call getthreshold(4,set%mc)
    call getthreshold(5,set%mb)
    call getthreshold(6,set%mt)
    call getnf(set%nfmax)
    if (set%nfmax .lt. 6) set%mt = 2.0d0*set%Qmax ! If no top in PDF set threshold beyond table max

    write(*,'(a,i4,a)') bold//"LHAPDF set: "//trim(name)//", member ",imem," loaded successfully"//reset

    ! Now let us define some hoppet specific parameters. These are
    ! typical values, and should guarantee similar accuracy as can be
    ! expected from LHAPDF
    ymax = real(ceiling(-log(set%xmin)), kind=dp) ! To get a nice value of ymax that can contain the full LHAPDF grid
    dy = 0.05_dp
    dlnlnQ = dy/4.0_dp
    if(ymax > 15.0) dlnlnQ = dy/8.0_dp ! for large ymax we need a finer grid in Q
    order = -6 ! Default
    yorder = 2 ! Quadratic interpolation in y
    lnlnQorder = 2 ! Quadratic interpolation in lnlnQ

    call hoppetSetPoleMassVFN(set%mc,set%mb,set%mt) ! set the pole masses
    call hoppetSetYLnlnQInterpOrders(yorder, lnlnQorder) ! Set the interpolation orders
    call cpu_time(ta1)
    call hoppetStartExtended(ymax, dy, set%Qmin, set%Qmax, dlnlnQ, set%nloop, order, factscheme_MSbar) ! Start hoppet
    call cpu_time(ta2)
    write(*,tfmt) "Time to start HOPPET: ", (ta2-ta1)*1e3_dp, " ms"
    write(*,'(a)') "Hoppet started with:"
    write(*,*) " ymax:       ", ymax
    write(*,*) " dy:         ", dy
    write(*,*) " Qmin:       ", set%Qmin
    write(*,*) " Qmax:       ", set%Qmax
    write(*,*) " dlnlnQ:     ", dlnlnQ
    write(*,*) " nloop:      ", set%nloop
    write(*,*) " order:      ", order
    write(*,*) " yorder:     ", yorder
    write(*,*) " lnlnQorder: ", lnlnQorder

    ! Now we fill the hoppet grid using the LHAPDF grid directly,
    ! rather than evolving ourselves
    !Q0 = set%Qmin
    call hoppetSetCoupling(alphasPDF(mz), mz, set%nloop)
    call cpu_time(ta1)
    call hoppetAssign(EvolvePDF)
    call cpu_time(ta2)
    write(*,tfmt) "Time to fill HOPPET grid from LHAPDF: ", (ta2-ta1)*1e3_dp, " ms"
    write(*,*) ! a blank line for clarity

    set%tables(0:0) => tables(0:0)
    set%owns_data = .false.

  end subroutine LoadLHAPDF

  !---------------------------------------------------
  subroutine LoadLHAPDFSet(name)    
    character(len=*),  intent(in) :: name
    !---------------------------------------
    type(hoppet_lhapdf_set), pointer :: set
    real(dp) :: ta1, ta2
    integer :: imem

    set => lhapdf_set ! shorthand

    ! load member 0; this also starts up Hoppet and sets the global tables(0) object
    call LoadLHAPDF(name, 0)

    allocate(set%tables(0:set%max_mem))
    call AllocPdfTable(set%tables, tables(0)) ! allocate the tables based on tables(0) structure    
    set%owns_data = .true.


    write(*,'(a)') bold//"Loading "//to_string(set%max_mem+1)//&
                   " members into hoppet from LHAPDF set: "//trim(set%name)//reset
    call cpu_time(ta1)
    do imem = 0, set%max_mem
      call initPDF(imem)
      call FillPdfTable_LHAPDF(set%tables(imem), EvolvePDF)
    end do
    call cpu_time(ta2)
    write(*,tfmt) "Time to load and fill all members into HOPPET: ", (ta2-ta1)*1e3_dp, " ms"
    write(*,*) !
  end subroutine LoadLHAPDFSet
end module hoppet_lhapdf

!! code that is included in pdf_tabulate.f90, with __HOPPET_InterpOrder__
!! acting as a kind of template parameter, so as to help generate
!! efficient code (e.g. where hard-coded loop bounds facilitate
!! loop unrolling)
!!
!! This code gets included within pdf_tabulate module and so automatically
!! has access to all the module's variables and procedures.
!!

!! To test macro expansion try
!!   gfortran -E -D__HOPPET_InterpOrder__=4 ../src/inc/pdf_tabulate_OrderNNN.F90 -o /tmp/a.i
!! and inspect /tmp/a.i

! include the Fortran Template Library Macros, which define the CAT
! macro in a way that works across compilers
#include "ftlMacros.inc"
#include "pdf_tabulate.inc"

#ifndef __HOPPET_InterpOrderY__
#define __HOPPET_InterpOrderY__ __HOPPET_InterpOrder__
#endif
#ifndef __HOPPET_InterpOrderQ__
#define __HOPPET_InterpOrderQ__ __HOPPET_InterpOrder__
#endif


#if __HOPPET_InterpOrderY__ > __HOPPET_tab_min_subgrid_ny__
#error "Interpolation order is too high for the current grid configuration: __HOPPET_InterpOrder__ > __HOPPET_tab_min_subgrid_ny__"
#endif
#if __HOPPET_InterpOrderQ__ > __HOPPET_tab_min_nQ__
#error "Interpolation order is too high for the current grid configuration: __HOPPET_InterpOrder__ > __HOPPET_tab_min_nQ__"
#endif



! this definition refers to functions in the interpolation_coeffs module (interpolation.f90)
! It will expand, e.g., as fill_interp_weights3 if __HOPPET_InterpOrder__ is 3
#define fill_interp_weightsNNY   CAT(fill_interp_weights,__HOPPET_InterpOrderY__)
#define fill_interp_weightsNNQ   CAT(fill_interp_weights,__HOPPET_InterpOrderQ__)
! the next two definitions are shorthands for functions defined below.
! Again, NNNN -> __HOPPET_InterpOrder__
#define EvalPdfTable_get_weights_orderNNNN CAT3(EvalPdfTable_get_weights_order,__HOPPET_InterpOrderY__,__HOPPET_InterpOrderQ__)
#define EvalPdfTable_yQ_orderNNNN CAT3(EvalPdfTable_yQ_order,__HOPPET_InterpOrderY__,__HOPPET_InterpOrderQ__)
#define EvalPdfTable_yQf_orderNNNN CAT3(EvalPdfTable_yQf_order,__HOPPET_InterpOrderY__,__HOPPET_InterpOrderQ__)
#define EvalPdfTable1D_yQ_orderNNNN CAT3(EvalPdfTable1D_yQ_order,__HOPPET_InterpOrderY__,__HOPPET_InterpOrderQ__)

subroutine EvalPdfTable_get_weights_orderNNNN(tab,y,Q,y_wgts, lnlnQ_wgts, iylo, ilnlnQ)
  use interpolation_coeffs; use convolution
  type(pdf_table), intent(in), target :: tab
  real(dp),        intent(in)         :: y, Q
  real(dp),        intent(out)        :: y_wgts(0:__HOPPET_InterpOrderY__), lnlnQ_wgts(0:__HOPPET_InterpOrderQ__)
  integer,         intent(out)        :: iylo, ilnlnQ
  !----------------------------------------
  integer, parameter :: NNY = __HOPPET_InterpOrderY__, halfNNY=(NNY)/2 !halfNNY=(NNY-1)/2
  integer, parameter :: NNQ = __HOPPET_InterpOrderQ__, halfNNQ=(NNQ)/2 !halfNNQ=(NNQ-1)/2
  real(dp) :: lnlnQ
  type(grid_def),   pointer :: grid, subgd
  type(pdfseginfo), pointer :: seginfo
  integer  :: i_nf, igd, iy_offset, iQ
  real(dp) :: ynorm, lnlnQ_norm

  !----- get the info for the y interpolation
  ! (NB 2025-09-09, tried manually inlining the routine on M2Pro-gfortran15-O3,
  ! but made no difference to timing)
  call tab_get_grid_ptr(tab, y, subgd, iy_offset)

  ynorm = y / subgd%dy
  iylo = int(ynorm) - halfNNY
  if (iylo < 0) iylo = 0
  if (iylo + NNY > subgd%ny) iylo = subgd%ny - NNY
  call fill_interp_weightsNNY(ynorm - iylo, y_wgts)
  iylo = iylo + iy_offset

  !----- next deal with the Q interpolation
  lnlnQ = lnln(tab,Q)

  if (lnlnQ < tab%lnlnQ_min) then
    lnlnQ = tab%lnlnQ_min
    ilnlnQ = lbound(tab%lnlnQ_vals,1)
    lnlnQ_wgts = zero
    if (tab%freeze_at_Qmin) then
      lnlnQ_wgts(0) = one
    endif
    return
  else if (lnlnQ > tab%lnlnQ_max) then
    call wae_error("EvalPdfTable_yQ_orderNNNN","Q was too large",dbleval=Q)
  endif

  if (.not. tab%nf_info_associated) then
    seginfo => tab%seginfo_no_nf
  else
    do i_nf = tab%nflo, tab%nfhi-1
      if (lnlnQ < tab%seginfo(i_nf)%lnlnQ_hi) exit
    end do
    seginfo => tab%seginfo(i_nf)
  end if
  if (seginfo%ilnlnQ_hi == seginfo%ilnlnQ_lo) then
    lnlnQ_wgts = zero
    lnlnQ_wgts(0) = 1.0_dp
    return
  endif

  lnlnQ_norm = (lnlnQ - seginfo%lnlnQ_lo) * seginfo%inv_dlnlnQ
  if (seginfo%ilnlnQ_hi - seginfo%ilnlnQ_lo < NNQ) then
    call wae_error("EvalPdfTable_yQ_orderNNNN","not enough points in Q segment")
  end if
  ilnlnQ = int(lnlnQ_norm) + seginfo%ilnlnQ_lo - halfNNQ
  ! timing tests 2025-10-01: it seems to be faster to have an if here than
  ! to use min/max or merge (c. 1ns, M2Pro-gfortran15.1-O3)
  if (ilnlnQ    < seginfo%ilnlnQ_lo) ilnlnQ = seginfo%ilnlnQ_lo
  if (ilnlnQ+NNQ > seginfo%ilnlnQ_hi) ilnlnQ = seginfo%ilnlnQ_hi - NNQ
  call fill_interp_weightsNNQ(lnlnQ_norm - (ilnlnQ-seginfo%ilnlnQ_lo), lnlnQ_wgts)
end subroutine EvalPdfTable_get_weights_orderNNNN


! 2025-09-08 attempt to explore potential for speedup in PDF
! evaluation when we hard-code and inline as much as possible
subroutine EvalPdfTable_yQ_orderNNNN(tab,y,Q,res) 
  use interpolation_coeffs; use convolution
  type(pdf_table), intent(in), target :: tab
  real(dp),        intent(in)         :: y, Q
  real(dp),        intent(out)        :: res(iflv_min:)
  !----------------------------------------
  integer, parameter :: NNY = __HOPPET_InterpOrderY__
  integer, parameter :: NNQ = __HOPPET_InterpOrderQ__
  real(dp) :: y_wgts(0:NNY), lnlnQ_wgts(0:NNQ)
  integer  :: iylo, ilnlnQ, iQ, iflv

  call EvalPdfTable_get_weights_orderNNNN(tab, y, Q, y_wgts, lnlnQ_wgts, iylo, ilnlnQ)

  ! now do the interpolation.
  ! first do the flavours we know we will need (this loop is easier to unroll)
  do iflv = iflv_min, iflv_max
    res(iflv) = sum(tab%tab(iylo:iylo+NNY, iflv,ilnlnQ  ) * y_wgts) * lnlnQ_wgts(0)
    do iQ = 1, NNQ
      res(iflv) = res(iflv) + sum(tab%tab(iylo:iylo+NNY, iflv,ilnlnQ+iQ) * y_wgts) * lnlnQ_wgts(iQ)
    end do
    !res(iflv) = sum(tab%tab(iylo:iylo+NNY, iflv,ilnlnQ  ) * y_wgts) * lnlnQ_wgts(0) &
    !    + sum(tab%tab(iylo:iylo+NNY, iflv,ilnlnQ+1) * y_wgts) * lnlnQ_wgts(1) &
    !    + sum(tab%tab(iylo:iylo+NNY, iflv,ilnlnQ+2) * y_wgts) * lnlnQ_wgts(2)
  end do

  ! and then do any remaining flavours (separating things gains us a couple of ns)
  do iflv = iflv_max+1, tab%tab_iflv_max
    res(iflv) = sum(tab%tab(iylo:iylo+NNY, iflv,ilnlnQ  ) * y_wgts) * lnlnQ_wgts(0)
    do iQ = 1, NNQ
      res(iflv) = res(iflv) + sum(tab%tab(iylo:iylo+NNY, iflv,ilnlnQ+iQ) * y_wgts) * lnlnQ_wgts(iQ)
    end do
  end do
end subroutine EvalPdfTable_yQ_orderNNNN

subroutine EvalPdfTable1D_yQ_orderNNNN(tab,y,Q,res) 
  use interpolation_coeffs; use convolution
  type(pdf_table), intent(in), target :: tab(:)
  real(dp),        intent(in)         :: y, Q
  real(dp),        intent(out)        :: res(iflv_min:,:)
  !----------------------------------------
  integer, parameter :: NNY = __HOPPET_InterpOrderY__
  integer, parameter :: NNQ = __HOPPET_InterpOrderQ__
  real(dp) :: y_wgts(0:NNY), lnlnQ_wgts(0:NNQ)
  integer  :: iylo, ilnlnQ, iQ, iflv, itab
  integer :: iflv_max

  iflv_max = tab(1)%tab_iflv_max

  call EvalPdfTable_get_weights_orderNNNN(tab(1), y, Q, y_wgts, lnlnQ_wgts, iylo, ilnlnQ)

  do itab = 1, size(tab)
    ! now do the interpolation.
    ! first do the flavours we know we will need (this loop is easier to unroll)
    do iflv = iflv_min, iflv_max
      res(iflv, itab) = sum(tab(itab)%tab(iylo:iylo+NNY, iflv,ilnlnQ  ) * y_wgts) * lnlnQ_wgts(0)
      do iQ = 1, NNQ
        res(iflv, itab) = res(iflv, itab) + sum(tab(itab)%tab(iylo:iylo+NNY, iflv,ilnlnQ+iQ) * y_wgts) * lnlnQ_wgts(iQ)
      end do
      !res(iflv) = sum(tab%tab(iylo:iylo+NNY, iflv,ilnlnQ  ) * y_wgts) * lnlnQ_wgts(0) &
      !    + sum(tab%tab(iylo:iylo+NNY, iflv,ilnlnQ+1) * y_wgts) * lnlnQ_wgts(1) &
      !    + sum(tab%tab(iylo:iylo+NNY, iflv,ilnlnQ+2) * y_wgts) * lnlnQ_wgts(2)
    end do

    ! and then do any remaining flavours (separating things gains us a couple of ns)
    do iflv = iflv_max+1, iflv_max
      res(iflv, itab) = sum(tab(itab)%tab(iylo:iylo+NNY, iflv,ilnlnQ  ) * y_wgts) * lnlnQ_wgts(0)
      do iQ = 1, NNQ
        res(iflv, itab) = res(iflv, itab) + sum(tab(itab)%tab(iylo:iylo+NNY, iflv,ilnlnQ+iQ) * y_wgts) * lnlnQ_wgts(iQ)
      end do
    end do

  end do ! itab
end subroutine EvalPdfTable1D_yQ_orderNNNN


function EvalPdfTable_yQf_orderNNNN(tab,y,Q,iflv) result(res)
  use interpolation_coeffs; use convolution
  type(pdf_table), intent(in), target :: tab
  real(dp),        intent(in)         :: y, Q
  integer,         intent(in)         :: iflv
  real(dp)                            :: res
  !----------------------------------------
  integer, parameter :: NNY = __HOPPET_InterpOrderY__
  integer, parameter :: NNQ = __HOPPET_InterpOrderQ__
  real(dp) :: y_wgts(0:NNY), lnlnQ_wgts(0:NNQ)
  integer  :: iylo, ilnlnQ, iQ

  call EvalPdfTable_get_weights_orderNNNN(tab, y, Q, y_wgts, lnlnQ_wgts, iylo, ilnlnQ)

  ! diagnostics
  !write(6,*) "orderNNNN: iylo = ", iylo, "y_wgts = ", y_wgts
  !write(6,*) "orderNNNN: ilnlnQ = ", ilnlnQ, "lnlnQ_wgts = ", lnlnQ_wgts
  !write(6,*) "orderNNNN: Qvals = ", tab%Q_vals(ilnlnQ:ilnlnQ+NN)

  ! now do the interpolation.
  ! first do the flavours we know we will need (this loop is easier to unroll)
  res = sum(tab%tab(iylo:iylo+NNY, iflv,ilnlnQ  ) * y_wgts) * lnlnQ_wgts(0)
  do iQ = 1, NNQ
    res = res + sum(tab%tab(iylo:iylo+NNY, iflv,ilnlnQ+iQ) * y_wgts) * lnlnQ_wgts(iQ)
  end do
end function EvalPdfTable_yQf_orderNNNN

! clear up all definitions, both local and those that were supplied
#undef EvalPdfTable_yQ_orderNNNN
#undef EvalPdfTable_yQf_orderNNNN
#undef fill_interp_weightsNNNN
#undef __HOPPET_InterpOrderY__
#undef __HOPPET_InterpOrderQ__
#undef __HOPPET_InterpOrder__

!! Module containing dummy PDFs that are widely used for benchmarking
!! and other tests. Used notably as part of hep-ph/0511119 and 
!! follow-up work.
module pdfs_for_benchmarks
  use types; use consts_dp; use pdf_representation
  implicit none
  private

  public :: benchmark_pdf_unpolarized, benchmark_pdf_unpolarized_lha
  
contains
  !======================================================================
  !! The dummy PDF suggested by Vogt as the initial condition for the 
  !! unpolarized evolution, subsequently adopted in a wide range of
  !! of benchmarks
  pure subroutine benchmark_pdf_unpolarized_lha(x, Q, xpdf)
    real(dp), intent(in)  :: x,Q
    real(dp), intent(out) :: xpdf(-6:6)
    real(dp) :: uv, dv
    real(dp) :: ubar, dbar
    !---------------------
    real(dp), parameter :: N_g = 1.7_dp, N_ls = 0.387975_dp
    real(dp), parameter :: N_uv=5.107200_dp, N_dv = 3.064320_dp
    real(dp), parameter :: N_db = half*N_ls
  
    ! Set to zero the xpdf array
    xpdf = zero
    
  
    !-- remember that these are all x*q(x)
    uv = N_uv * x**0.8_dp * (1-x)**3
    dv = N_dv * x**0.8_dp * (1-x)**4
    dbar = N_db * x**(-0.1_dp) * (1-x)**6
    ubar = dbar * (1-x)
  
    ! labels iflv_g, etc., come from the hoppet module, inherited
    ! from the main program
    xpdf(iflv_g) = N_g * x**(-0.1_dp) * (1-x)**5
    xpdf(-iflv_s) = 0.2_dp*(dbar + ubar)
    xpdf(iflv_s) = xpdf(-iflv_s)
    xpdf(iflv_u) = uv + ubar
    xpdf(-iflv_u) = ubar
    xpdf(iflv_d) = dv + dbar
    xpdf(-iflv_d) = dbar
  end subroutine benchmark_pdf_unpolarized_lha
  

  !----------------------------------------------------------------------
  ! the same dummy PDF, in a slightly different interface
  function benchmark_pdf_unpolarized(xvals) result(pdf)
    real(dp), intent(in) :: xvals(:)
    real(dp)             :: pdf(size(xvals),ncompmin:ncompmax)
    !---------------------
    integer  :: iy
    real(dp) :: dummy_Q

    pdf = zero
    call LabelPdfAsHuman(pdf)
    dummy_Q = 10.0_dp

    do iy = 1, size(xvals)
       call benchmark_pdf_unpolarized_lha(xvals(iy), dummy_Q, pdf(iy, iflv_min:iflv_max))
    end do
  end function benchmark_pdf_unpolarized

end module pdfs_for_benchmarks

! $Id: interpolation.f90,v 1.3 2002/12/30 17:20:26 gsalam Exp $
module interpolation
  use types
  implicit none
  private

  public :: uniform_interpolation_weights
contains


  !--------------------------------------------------------------------
  ! returns the weights for the uniform interpolation,
  ! where the first entry of weights corresponds to x=1
  ! and the spacing is 1.
  !
  ! formula should be weight(i) = [Prod_{j/=i} (x-j)] (-1)^(n-1) / (i! (n-i)!)
  !
  ! Algorithm uses instead [Prod_{j} (x-j)] / (x-i) unless one
  ! of the x-i==0 in which case the result is just 0,...,0,,1,0...,0
  !
  ! For simplicity of caching, n == ubound(weights), is limited .le. nmax
  subroutine uniform_interpolation_weights(x,weights)
    use warnings_and_errors; use consts_dp
    real(dp), intent(in)  :: x
    real(dp), intent(out) :: weights(0:)
    !-----------------------------------------
    integer,  parameter :: nmax = 9
    !                                           order=n
    real(dp), save      :: normalisation(0:nmax,0:nmax) = zero
    real(dp)            :: dists(0:nmax)
    real(dp)            :: prod
    integer             :: n, i
    
    n = ubound(weights,dim=1)
    if (n > nmax) call wae_error('uniform_interpolation_weights',&
         &'ubound of weights is too large:',intval=n)

    !-- intialise once for each n
    if (normalisation(0,n) == zero) then
       !-- calculate factorial
       normalisation(0,n) = one
       do i = 1, n
         normalisation(0,n) = normalisation(0,n) * (-i)
       end do
       !-- calculate inverse weight "normalisations"
       do i = 1, n
         normalisation(i,n) = (normalisation(i-1,n) * i)/(i-1-n)
       end do
       normalisation(:n,n) = one / normalisation(:n,n)
    end if
    
    prod = one
    do i = 0, n
      dists(i) = x - i
      if (dists(i) == zero) then
        weights(:) = zero
        weights(i) = one
        return
      end if
      prod = prod * dists(i)
    end do
    !prod = product(dists)
    do i = 0, n
      weights(i) = prod * normalisation(i,n) / dists(i)
    end do
    
  end subroutine uniform_interpolation_weights
  
end module interpolation

!! Module with coefficients for interpolation of uniformly spaced points. 
!! 
!! With Nth order interpolation, points at x=0,...,N, 
!! interp_coeffsN(i) should multiply $f(x=i) \prod_{j=0,j\neq i}^N (x-j)$
!!
!! When speed is critical, using these hard-coded coefficients will be
!! faster than calling uniform_interpolation_weights. Faster still
!! is to use the precomputed values directly in your code, avoiding
!! any overhead from function calls.
module interpolation_coeffs
  use types
  implicit none
  private

  ! shorthands for factorials, kept private
  real(dp), parameter :: f(0:6) = [1.0_dp, 1.0_dp, 2.0_dp, 6.0_dp, 24.0_dp, 120.0_dp, 720.0_dp]
  real(dp), parameter :: nn(0:6) = [0.0_dp, 1.0_dp, 2.0_dp, 3.0_dp, 4.0_dp, 5.0_dp, 6.0_dp]

  !! Interp_coeffsN(i) should multiply $f(x=i) \prod_{j=0,j\neq i}^N (x-j)$
  real(dp), parameter :: interp_coeffs1(0:1) = [-1.0_dp, 1.0_dp]
  real(dp), parameter :: interp_coeffs2(0:2) = [ 0.5_dp, -1.0_dp, 0.5_dp ]
  real(dp), parameter :: interp_coeffs3(0:3) = [ -1.0_dp/6.0_dp, 1.0_dp/2.0_dp, -1.0_dp/2.0_dp, 1.0_dp/6.0_dp ]
  real(dp), parameter :: interp_coeffs4(0:4) = [ 1.0_dp/24.0_dp, -1.0_dp/6.0_dp, 1.0_dp/4.0_dp, -1.0_dp/6.0_dp,  1.0_dp/24.0_dp ]
  real(dp), parameter :: interp_coeffs5(0:5) = 1.0_dp/[ -f(0)*f(5), f(1)*f(4), -f(2)*f(3), f(3)*f(2), -f(4)*f(1), f(5)*f(0) ]
  real(dp), parameter :: interp_coeffs6(0:6) = 1.0_dp/[f(0)*f(6),-f(1)*f(5),f(2)*f(4),-f(3)*f(3),f(4)*f(2),-f(5)*f(1),f(6)*f(0)]

  public :: interp_coeffs1, interp_coeffs2, interp_coeffs3
  public :: interp_coeffs4, interp_coeffs5, interp_coeffs6
  public :: fill_interp_weights1, fill_interp_weights2, fill_interp_weights3
  public :: fill_interp_weights4, fill_interp_weights5, fill_interp_weights6

contains

  pure subroutine fill_interp_weights1(x, weights)
    real(dp), intent(in)  :: x
    real(dp), intent(out) :: weights(0:1)
    !-----------------------------------------
    weights(0) = (x-1.0_dp) * interp_coeffs1(0)
    weights(1) = (x       ) * interp_coeffs1(1)
  end subroutine fill_interp_weights1

  pure subroutine fill_interp_weights2(x, weights)
    real(dp), intent(in)  :: x
    real(dp), intent(out) :: weights(0:2)
    !-----------------------------------------
    real(dp) :: xm1,xm2
    xm1 = x-1.0_dp
    xm2 = x-2.0_dp
    weights(0) = xm1*xm2 * interp_coeffs2(0)
    weights(1) = x  *xm2 * interp_coeffs2(1)
    weights(2) = x  *xm1 * interp_coeffs2(2)
  end subroutine fill_interp_weights2

  pure subroutine fill_interp_weights3(x, weights)
    real(dp), intent(in)  :: x
    real(dp), intent(out) :: weights(0:3)
    !-----------------------------------------
    real(dp) :: xm1,xm2,xm3
    xm1 = x-1.0_dp
    xm2 = x-2.0_dp
    xm3 = x-3.0_dp
    weights(0) = xm1*xm2*xm3 * interp_coeffs3(0)
    weights(1) = x  *xm2*xm3 * interp_coeffs3(1)
    weights(2) = x  *xm1*xm3 * interp_coeffs3(2)
    weights(3) = x  *xm1*xm2 * interp_coeffs3(3)
  end subroutine fill_interp_weights3

  pure subroutine fill_interp_weights4(x, weights)
    real(dp), intent(in)  :: x
    real(dp), intent(out) :: weights(0:4)
    !-----------------------------------------
    real(dp) :: xm1,xm2,xm3,xm4, xm34, xm01
    xm1 = x-1.0_dp
    xm2 = x-2.0_dp
    xm3 = x-3.0_dp
    xm4 = x-4.0_dp
    ! on M2Pro-gfortran15-O3, pre-computing just these two seems to give
    ! the best speed
    xm34 = xm3 * xm4
    xm01 = x * xm1
    weights(0) = xm1*xm2*xm34 * interp_coeffs4(0)
    weights(1) = x  *xm2*xm34 * interp_coeffs4(1)
    weights(2) = xm01*xm34    * interp_coeffs4(2)
    weights(3) = xm01*xm2*xm4 * interp_coeffs4(3)
    weights(4) = xm01*xm2*xm3 * interp_coeffs4(4)
  end subroutine fill_interp_weights4

  ! this variant is a bit slower, by about 1ns on M2Pro-gfortran15-O3
  !pure subroutine fill_interp_weights4(x, weights)
  !  integer,  parameter   :: N=4
  !  real(dp), intent(in)  :: x
  !  real(dp), intent(out) :: weights(0:N)
  !  !-----------------------------------------
  !  real(dp) :: xm(0:N), prodsl(0:N), prodsr(0:N)
  !  integer  :: i
  !  xm = x - nn(0:N)
  !  prodsl(0) = 1.0_dp
  !  prodsr(N) = 1.0_dp
  !  do i = 1,N
  !    prodsl(i)     = prodsl(i-1) * xm(i-1)
  !    prodsr(N-i) = prodsr(N+1-i) * xm(N+1-i)
  !  end do
  !  weights = prodsl * prodsr * interp_coeffs4
  !end subroutine fill_interp_weights4

  pure subroutine fill_interp_weights5(x, weights)
    real(dp), intent(in)  :: x
    real(dp), intent(out) :: weights(0:5)
    !-----------------------------------------
    real(dp) :: xm1,xm2,xm3,xm4,xm5,xm012,xm345
    xm1 = x-1.0_dp
    xm2 = x-2.0_dp
    xm3 = x-3.0_dp
    xm4 = x-4.0_dp
    xm5 = x-5.0_dp
    ! speed of the following has not been tested
    xm012 = x * xm1 * xm2
    xm345 = xm3 * xm4 * xm5

    weights(0) = xm1*xm2*xm345 * interp_coeffs5(0)
    weights(1) = x  *xm2*xm345 * interp_coeffs5(1)
    weights(2) = x*xm1  *xm345 * interp_coeffs5(2)
    weights(3) = xm012*xm4*xm5 * interp_coeffs5(3)
    weights(4) = xm012*xm3*xm5 * interp_coeffs5(4)
    weights(5) = xm012*xm3*xm4 * interp_coeffs5(5)
  end subroutine fill_interp_weights5

  pure subroutine fill_interp_weights6(x, weights)
    real(dp), intent(in)  :: x
    real(dp), intent(out) :: weights(0:6)
    !-----------------------------------------
    real(dp) :: xm1,xm2,xm3,xm4,xm5,xm6,xm012,xm456
    !real(dp) :: xm23, xm34
    xm1 = x-1.0_dp
    xm2 = x-2.0_dp
    xm3 = x-3.0_dp
    xm4 = x-4.0_dp
    xm5 = x-5.0_dp
    xm6 = x-6.0_dp
    ! On M2Pro-gfortran15-O3, no discernible advantage
    ! to adding xm23 and xm34 intermediates, tested
    ! with the code in hoppet_unit_tests::test_interpolation_coeffs
    xm012 = x * xm1 * xm2
    xm456 = xm4 * xm5 * xm6  
    weights(0) = xm1*xm2*xm3*xm456 * interp_coeffs6(0)
    weights(1) = x  *xm2*xm3*xm456 * interp_coeffs6(1)
    weights(2) = x*xm1  *xm3*xm456 * interp_coeffs6(2)
    weights(3) = xm012      *xm456 * interp_coeffs6(3)
    weights(4) = xm012*xm3*xm5*xm6 * interp_coeffs6(4)
    weights(5) = xm012*xm3*xm4*xm6 * interp_coeffs6(5)
    weights(6) = xm012*xm3*xm4*xm5 * interp_coeffs6(6)
    !xm23 = xm2*xm3
    !xm34 = xm3*xm4
    !weights(0) = xm1*xm23   *xm456 * interp_coeffs6(0)
    !weights(1) = x  *xm23   *xm456 * interp_coeffs6(1)
    !weights(2) = x*xm1  *xm3*xm456 * interp_coeffs6(2)
    !weights(3) = xm012      *xm456 * interp_coeffs6(3)
    !weights(4) = xm012*xm3*xm5*xm6 * interp_coeffs6(4)
    !weights(5) = xm012*xm34   *xm6 * interp_coeffs6(5)
    !weights(6) = xm012*xm34   *xm5 * interp_coeffs6(6)
  end subroutine fill_interp_weights6


  ! On M2Pro-gfortran15-O3 this variant seems to be about 3ns slower
  ! than the hard-coded one above, cf. the timing code 
  ! in hoppet_unit_tests::test_interpolation_coeffs
!  pure subroutine fill_interp_weights6(x, weights)
!    integer,  parameter   :: N=6
!    real(dp), intent(in)  :: x
!    real(dp), intent(out) :: weights(0:N)
!    !-----------------------------------------
!    real(dp) :: xm(0:N), prodsl(0:N), prodsr(0:N)
!    integer  :: i
!    xm = x - nn(0:N)
!    prodsl(0) = 1.0_dp
!    prodsr(N) = 1.0_dp
!    do i = 1,N 
!      prodsl(i)   = prodsl(i-1) * xm(i-1)
!      prodsr(N-i) = prodsr(N+1-i) * xm(N+1-i)
!    end do
!    weights = prodsl * prodsr * interp_coeffs6
!  end subroutine fill_interp_weights6

end module interpolation_coeffs

!-----------------------------------------------------------
!! Routines related to allocation and initialisation of parton 
!! distributions.
module pdf_general
  use types; use consts_dp
  !-- do some recycling (actually only the 2d versions will
  !   be of any use, but hopefully that will not cause problems)
  use convolution
  use pdf_representation
  implicit none
  private

  interface AllocPDF
     module procedure pdfgen_AllocPDF_0d, pdfgen_AllocPDF_1d
  end interface
  public :: AllocPDF


  interface InitPDF
     module procedure pdfgen_InitPDF_, pdfgen_InitPDF_a,&
          & pdfgen_InitPDF_ai
  end interface
  public :: InitPDF

  interface InitPDFSub
     module procedure pdfgen_InitPDFSub_, pdfgen_InitPDFSub_a,&
          & pdfgen_InitPDFSub_ai
  end interface
  public :: InitPDFSub

  public :: InitPDF_LHAPDF

  interface AllocInitPDF
     module procedure pdfgen_AllocInitPDF_, pdfgen_AllocInitPDF_a,&
          & pdfgen_AllocInitPDF_ai
  end interface
  public :: AllocInitPDF

  interface AllocInitPDFSub
     module procedure pdfgen_AllocInitPDFSub_, &
          & pdfgen_AllocInitPDFSub_a, pdfgen_AllocInitPDFSub_ai
  end interface
  public :: AllocInitPDFSub

  interface operator(.anti.)
     module procedure pdfgen_anti_0d, pdfgen_anti_1d
  end interface
  public :: operator(.anti.)
contains
  !-------------------------------------------------------
  ! allocate a parton distribution; dimensionality refers
  ! to extra directions over and above (x,nf).
  subroutine pdfgen_AllocPDF_0d(grid,q)
    type(grid_def), intent(in) :: grid
    real(dp),       pointer    :: q(:,:)

    call AllocGridQuant(grid,q,ncompmin, ncompmax)
    call LabelPdfAsRep(q,pdfr_Human)
  end subroutine pdfgen_AllocPDF_0d

  !-------------------------------------------------------
  subroutine pdfgen_AllocPDF_1d(grid,q, nl, nh)
    type(grid_def), intent(in) :: grid
    real(dp),       pointer    :: q(:,:,:)
    integer ,       intent(in) :: nl, nh
    integer :: i

    call AllocGridQuant(grid,q,ncompmin, ncompmax, nl, nh)
    do i = nl, nh
       call LabelPdfAsRep(q(:,:,i),pdfr_Human)
    end do
  end subroutine pdfgen_AllocPDF_1d



  !----------------------------------------------------------------------
  ! All of these routine just redirect to the official routine, with
  ! the added features that if it's a standard QCD PDF, then they
  ! redirect only the components iflv_min:iflv_max.
  !
  ! They also label the result as being in the "Human" representation
  recursive subroutine pdfgen_InitPDF_(grid, gq, func)
    real(dp),         intent(inout) :: gq(0:,ncompmin:)
    type(grid_def),   intent(in)    :: grid
    interface
       function func(x,n)
         use types; implicit none
         real(dp), intent(in) :: x
         integer , intent(in) :: n
         real(dp)             :: func(n)
       end function func
    end interface
    !-----------------------------------------
    if (ubound(gq,dim=2) == ncompmax) then
       ! if it's a standard QCD-only PDF, then pass just -6:6 to the subroutine
       call InitGridQuant(grid, gq(:,iflv_min:iflv_max), func)
    else
       ! otherwise pass the whole thing; the subroutine must be aware that
       ! index 7 is a special ("representation") index
       call InitGridQuant(grid, gq(:,iflv_min:iflv_max), func)
    end if
    call LabelPdfAsRep(gq(:,ncompmin:ncompmax),pdfr_Human)
  end subroutine pdfgen_InitPDF_

  !----------------------------------------------------------------------
  ! version intended for use when there is an extra argument whose
  ! value is fixed and needs to be passed to func
  !
  ! updated for multi
  recursive subroutine pdfgen_InitPDF_a(grid, gq, func, axtra)
    real(dp),         intent(inout) :: gq(0:,ncompmin:)
    type(grid_def),   intent(in)    :: grid
    real(dp),         intent(in)    :: axtra
    interface
       function func(x,axtra,n)
         use types; implicit none
         real(dp), intent(in) :: x,axtra
         integer , intent(in) :: n
         real(dp)             :: func(n)
       end function func
    end interface
    !-----------------------------------------
    if (ubound(gq,dim=2) == ncompmax) then
       ! if it's a standard QCD-only PDF, then pass just -6:6 to the subroutine
       call InitGridQuant(grid, gq(:,iflv_min:iflv_max), func, axtra)
    else
       ! otherwise pass the whole thing; the subroutine must be aware that
       ! index 7 is a special ("representation") index
       call InitGridQuant(grid, gq(:,iflv_min:iflv_max), func, axtra)
    end if
    call LabelPdfAsRep(gq(:,ncompmin:ncompmax),pdfr_Human)
  end subroutine pdfgen_InitPDF_a

  !----------------------------------------------------------------------
  ! version intended for use when there is an extra argument whose
  ! value is fixed and needs to be passed to func
  !
  ! updated for multi
  recursive subroutine pdfgen_InitPDF_ai(grid, gq, func, axtra, ixtra)
    real(dp),         intent(inout) :: gq(0:,ncompmin:)
    type(grid_def),   intent(in)    :: grid
    real(dp),         intent(in)    :: axtra
    integer,          intent(in)    :: ixtra
    interface
       function func(x,axtra,ixtra,n)
         use types; implicit none
         real(dp), intent(in) :: x,axtra
         integer , intent(in) :: ixtra,n
         real(dp)             :: func(n)
       end function func
    end interface
    !-----------------------------------------
    if (ubound(gq,dim=2) == ncompmax) then
       ! if it's a standard QCD-only PDF, then pass just -6:6 to the subroutine
       call InitGridQuant(grid, gq(:,iflv_min:iflv_max), func, axtra, ixtra)
    else
       ! otherwise pass the whole thing; the subroutine must be aware that
       ! index 7 is a special ("representation") index
       call InitGridQuant(grid, gq(:,iflv_min:iflv_max), func, axtra, ixtra)
    end if
    call LabelPdfAsRep(gq(:,ncompmin:ncompmax),pdfr_Human)
  end subroutine pdfgen_InitPDF_ai


  !----------------------------------------------------------------------
  ! updated for multi
  recursive subroutine pdfgen_InitPDFSub_(grid, gq, sub)
    real(dp),         intent(inout) :: gq(0:,ncompmin:)
    type(grid_def),   intent(in)    :: grid
    interface
       subroutine sub(y,res)
         use types; implicit none
         real(dp), intent(in)  :: y
         real(dp), intent(out) :: res(:)
       end subroutine sub
    end interface
    !-----------------------------------------
    call InitGridQuantSub(grid, gq(:,iflv_min:iflv_max), sub)
    call LabelPdfAsRep(gq,pdfr_Human)
  end subroutine pdfgen_InitPDFSub_

  recursive subroutine pdfgen_InitPDFSub_a(grid, gq, sub, axtra)
    real(dp),         intent(inout) :: gq(0:,ncompmin:)
    type(grid_def),   intent(in)    :: grid
    real(dp),         intent(in)    :: axtra
    interface
       subroutine sub(y, axtra, res)
         use types; implicit none
         real(dp), intent(in)  :: y, axtra
         real(dp), intent(out) :: res(:)
       end subroutine sub
    end interface
    !-----------------------------------------
    call InitGridQuantSub(grid, gq(:,iflv_min:iflv_max), sub, axtra)
    call LabelPdfAsRep(gq,pdfr_Human)
  end subroutine pdfgen_InitPDFSub_a

  recursive subroutine pdfgen_InitPDFSub_ai(grid, gq, sub, axtra, ixtra)
    real(dp),         intent(inout) :: gq(0:,ncompmin:)
    type(grid_def),   intent(in)    :: grid
    real(dp),         intent(in)    :: axtra
    integer,          intent(in)    :: ixtra
    interface
       subroutine sub(y, axtra, ixtra, res)
         use types; implicit none
         real(dp), intent(in)  :: y, axtra
         integer,  intent(in)  :: ixtra
         real(dp), intent(out) :: res(:)
       end subroutine sub
    end interface
    !-----------------------------------------
    call InitGridQuantSub(grid, gq(:,iflv_min:iflv_max), sub, axtra, ixtra)
    call LabelPdfAsRep(gq,pdfr_Human)
  end subroutine pdfgen_InitPDFSub_ai



  !======================================================================
  !! Initialise the subroutine using an LHAPDF style subroutine
  !!
  !! It expects LHAsub to set components -6:6 with plain QCD
  !! evolution, but the full size of the flavour dimension if the
  !! upper limit is anything other than ncompax=7 (e.g. for QED
  !! evolution it should go from -6 to ncompmaxLeptons=11).
  subroutine InitPDF_LHAPDF(grid, gq, LHAsub, Q)
    real(dp),         intent(inout) :: gq(0:,ncompmin:)
    type(grid_def),   intent(in)    :: grid
    real(dp),         intent(in)    :: Q
    interface
       subroutine LHAsub(x,Q,res)
         use types; implicit none
         real(dp), intent(in)  :: x,Q
         real(dp), intent(out) :: res(*)
       end subroutine LHAsub
    end interface
    !-------------------------------------------
    integer :: ncompmax_lcl

    ! if the upper bound of gq(:,:) is the usual ncompmax
    ! then assume the user's routine will fill -6:6.
    ! Otherwise the user should fill -6:ubound(gq,dim=2)
    ncompmax_lcl = ubound(gq,dim=2)
    if (ncompmax_lcl == ncompmax) ncompmax_lcl = iflv_max

    !call InitGridQuantLHAPDF(grid, gq(:,iflv_min:iflv_max), LHAsub, Q)
    ! PN & GZ: the following modification is needed for the streamlined interface with QED evolution
    call InitGridQuantLHAPDF(grid, gq(:,iflv_min:ncompmax_lcl), LHAsub, Q)        
    call LabelPdfAsRep(gq,pdfr_Human)
  end subroutine InitPDF_LHAPDF
  



  !------------------------------------------------------
  ! allocate and initialise in various forms!
  subroutine pdfgen_AllocInitPDF_(grid,q, func)
    type(grid_def), intent(in) :: grid
    real(dp),       pointer    :: q(:,:)
    interface
       function func(y,n)
         use types; implicit none
         real(dp), intent(in) :: y
         integer , intent(in) :: n
         real(dp)             :: func(n)
       end function func
    end interface
    !-----------------------------------------

    call AllocPDF(grid,q)
    call InitPDF(grid, q, func)
  end subroutine pdfgen_AllocInitPDF_

  !--------------------------------------------------
  subroutine pdfgen_AllocInitPDF_a(grid,q, func, axtra)
    type(grid_def), intent(in) :: grid
    real(dp),       pointer    :: q(:,:)
    real(dp),       intent(in) :: axtra
    interface
       function func(y,axtra,n)
         use types; implicit none
         real(dp), intent(in) :: y,axtra
         integer , intent(in) :: n
         real(dp)             :: func(n)
       end function func
    end interface
    !-----------------------------------------

    call AllocPDF(grid,q)
    call InitPDF(grid, q, func, axtra)
  end subroutine pdfgen_AllocInitPDF_a

  !-------------------------------------------------------------
  subroutine pdfgen_AllocInitPDF_ai(grid,q, func, axtra, ixtra)
    type(grid_def), intent(in) :: grid
    real(dp),       pointer    :: q(:,:)
    real(dp),       intent(in) :: axtra
    integer,        intent(in) :: ixtra
    interface
       function func(y,axtra,ixtra,n)
         use types; implicit none
         real(dp), intent(in) :: y,axtra
         integer , intent(in) :: ixtra,n
         real(dp)             :: func(n)
       end function func
    end interface
    !-----------------------------------------

    call AllocPDF(grid,q)
    call InitPDF(grid, q, func, axtra, ixtra)
  end subroutine pdfgen_AllocInitPDF_ai

  !------------------------------------------------------
  ! allocate and initialise in various forms!
  subroutine pdfgen_AllocInitPDFSub_(grid,q, sub)
    type(grid_def), intent(in) :: grid
    real(dp),       pointer    :: q(:,:)
    interface
       subroutine sub(y,res)
         use types; implicit none
         real(dp), intent(in) :: y
         real(dp), intent(out):: res(:)
       end subroutine sub
    end interface
    !-----------------------------------------

    call AllocPDF(grid,q)
    call InitPDFSub(grid, q, sub)
  end subroutine pdfgen_AllocInitPDFSub_

  !--------------------------------------------------
  subroutine pdfgen_AllocInitPDFSub_a(grid,q, sub, axtra)
    type(grid_def), intent(in) :: grid
    real(dp),       pointer    :: q(:,:)
    real(dp),       intent(in) :: axtra
    interface
       subroutine sub(y,axtra,res)
         use types; implicit none
         real(dp), intent(in) :: y,axtra
         real(dp), intent(out):: res(:)
       end subroutine sub
    end interface
    !-----------------------------------------

    call AllocPDF(grid,q)
    call InitPDFSub(grid, q, sub, axtra)
  end subroutine pdfgen_AllocInitPDFSub_a

  !-------------------------------------------------------------
  subroutine pdfgen_AllocInitPDFSub_ai(grid,q, sub, axtra, ixtra)
    type(grid_def), intent(in) :: grid
    real(dp),       pointer    :: q(:,:)
    real(dp),       intent(in) :: axtra
    integer,        intent(in) :: ixtra
    interface
       subroutine sub(y,axtra,ixtra,res)
         use types; implicit none
         real(dp), intent(in) :: y,axtra
         integer , intent(in) :: ixtra
         real(dp), intent(out):: res(:)
       end subroutine sub
    end interface
    !-----------------------------------------

    call AllocPDF(grid,q)
    call InitPDFSub(grid, q, sub, axtra, ixtra)
  end subroutine pdfgen_AllocInitPDFSub_ai

  !---------------------------------------------------
  ! write it out in full rather than using f90 array
  ! notation shortcuts to reduce need for assumptions about
  ! relation between iflv_min and ncompmin
  function pdfgen_anti_0d(q) result(antiq)
    real(dp), intent(in) :: q(:,ncompmin:)
    real(dp)             :: antiq(size(q,1),lbound(q,2):ubound(q,2))
    integer :: i

    !-- try to catch stupid and illegal uses...
    if (ubound(q,2) /= ncompmax) call wae_error('pdfgen_anti_0d',&
         &'ubound of second dimension of q should be ncompmax, instead it is',&
         &intval=ubound(q,2))

    do i = ncompmin, ncompmax
       if (i >= iflv_min .and. i <= iflv_max) then
          antiq(:,i) = q(:,-i)
       else
          antiq(:,i) = q(:,i)
       end if
    end do
  end function pdfgen_anti_0d
  
  !---------------------------------------------------
  function pdfgen_anti_1d(q) result(antiq)
    real(dp), intent(in) :: q(:,ncompmin:,:)
    real(dp)             :: antiq(size(q,1),lbound(q,2):ubound(q,2),size(q,3))
    integer :: i
    do i = 1, size(q,dim=3)
       antiq(:,:,i) = pdfgen_anti_0d(q(:,:,i))
    end do
  end function pdfgen_anti_1d
  
end module pdf_general

C----------------------------------------------------------------------
C
C Program that takes an initial condition from LHAPDF at some scale,
C creates a hoppet tabulation by evolving it from that scale, and
C then compares the result at some other scale.
C
C This provdes a way of cross checking the evolution implicitly
C contained in public PDF sets
C 
C----------------------------------------------------------------------
      program compare_lhapdf_hoppet
      implicit none
      !--- variables defining the grid and evolution parameters
      double precision dy, ymax, Qmin, Qmax, dlnlnQ
      integer          nloop, order
      !---------------
      double precision alphasPDF
      external         evolvePDF, alphasPDF
      double precision x, Q, lhapdf(-6:6), ourpdf(-6:6)
      double precision mz, asmz, Q0, xmu
      integer          iloop,  nf, iflv, i, scheme

      ! initialise an LHAPDF set
      !call InitPDFsetByName("cteq61.LHgrid")
      !call InitPDFsetByName("CT10nlo.LHgrid")
      !call InitPDFsetByName("PDF4LHC15_nnlo_30")
      call InitPDFsetByName("CT18NNLO")
      call InitPDF(0)

      ! start the dglap evolution/convolution package 
      ymax  = 14d0      ! max value of ln 1/x
      dy    = 0.1d0     ! the internal grid spacing (smaller->higher accuarcy)
                        ! 0.1 should provide at least 10^{-3} accuracy 
      Qmin  = 1.0d0     ! smallest Q value in tabulation
      Qmax  = 1d4       ! largest Q value in tabulation
      dlnlnQ = dy/4.0d0 ! tabulation spacing in dlnlnQ (dy/4 recommended)
      nloop = 3         ! the number of loops to initialise (max=3!)
      order = -6        ! numerical interpolation order (-6 is a good choice)
      scheme = 1        ! 1=unpol-MSbar, 2=unpol-DIS, 3=Pol-MSbar

      ! call this once at the beginning of your program
      call hoppetStartExtended(ymax,dy,Qmin,Qmax,dlnlnQ,nloop,order,
     $                         scheme)

      ! initialise our PDF using the LHAPDF subroutine for PDF-access
      ! at the starting scale Q0, assuming as(mz)=0.118 and evolve to 
      ! the other scales. You can replace the LHAPDF routine with your
      ! own one (with the same interface)
      !
      ! Call this routine each time you want to change 
      ! input PDFs
      mz = 91.1876d0
      asmz = alphasPDF(mz)
      write(6,*) "alpha_s(MZ) = ", asmz
      Q0   = 20.0d0
      xmu  = 1.0d0
      !call hoppetSetVFN(1.5d0,4.7d0,175d0)
      call hoppetEvolve(asmz,mz,nloop,xmu,evolvePDF,Q0)
      ! alternatively if you need to repeat the same evolution on very
      ! many pdf sets, used a cached evolution (set up once, use many times
      ! and gain a factor 3-4 in speed.
      !call hoppetPreEvolve(asmz,91.2d0,nloop,xmu,Q0)
      !call hoppetCachedEvolve(evolvePDF) 
      !x = 0.7d0
      x = 1d-3
      Q = 100.0d0

      ! extract the pdf at this x,Q directly from LHAPDF
      call evolvePDF(x,Q,lhapdf)

      ! extract the pdf at this x,Q via our copy of the pdf
      call hoppetEval(x,Q,ourpdf)

      ! print it all
      write(6,*) 'x = ', x, ',   Q = ', Q
      write(6,'(a5,4a17)') 'iflv','lhapdf','hoppet'
      do iflv = -6, 6
         write(6,'(i5,4f17.7)') iflv,
     $        lhapdf(iflv),ourpdf(iflv)
      end do
      end

program test_qed_lhapdf
  use hoppet; use convolution
  use io_utils
  implicit none
  real(dp) :: ymax = 20.0_dp, dy = 0.10_dp
  type(grid_def) :: grid
  character(len=200) :: pdfname
  real(dp), pointer :: pdf(:,:)
  real(dp)          :: moments(-6:8), Q
  integer           :: imem
  
  call InitGridDefDefault(grid, dy, ymax)
  call AllocGridQuant(grid, pdf, -6, 8)


  
  pdfname = string_val_opt("-pdf")
  imem    = int_val_opt("-imem",0)
  Q       = dble_val_opt("-Q", 2.0_dp)
  call InitPDFsetByName(trim(pdfname))
  call InitPDFm(1,imem)
  call fill_from_lhapdf(pdf, Q)

  moments = TruncatedMoment(grid, pdf(:,:), one)
  write(6,*) moments
  write(6,*) sum(moments) - one
contains

  !----------------------------------------------------------------------
  subroutine fill_from_lhapdf(this_pdf, Q)
    real(dp), intent(out) :: this_pdf(0:,-6:)
    real(dp), intent(in)  :: Q
    !---------
    real(dp) :: xv(0:grid%ny)
    integer  :: i

    xv = xValues(grid)
    this_pdf(:,7) = zero
    do i = 0, grid%ny
       call EvolvePDFPhoton(xv(i), Q, this_pdf(i,-6:6), this_pdf(i,8))
       !write(6,*) xv(i), this_pdf(i,8)
    end do
    
  end subroutine fill_from_lhapdf
  
end program test_qed_lhapdf

module daind_fake
  use types
  implicit none

contains

  !************************************************************************
  ! The following are the interface parameters from the original daind.f file
  ! provided to the hoppet authors by Johannes Blumlein, which itself
  ! quotes CF. Piessens, R., An Algorithm for Automatic Integration. 
  ! Angewandte Informatik, 9 (1973), 399--401.
  !
  !  INPUTPARAMETERS
  !  A,B      LIMITS OF THE INTEGRATION INTERVAL
  !  FUN      FUNCTION TO BE INTEGRATED (TO BE DECLARED EXTERNAL IN THE MAIN PR.)
  !  EPS      ABSOLUTE OR RELATIVE TOLERANCE,DEPENDING OF THE VALUE OF 'KEY'
  !  KEY      =1 THEN 'EPS' DENOTES AN ABSOLUTE, =2 THEN A RELATIVE TOLERANCE
  !  MAX      UPPER BOUND ON THE NUMBERS OF INTEGRAND EVALUATIONS (MAX.LE.10000)
  !
  !  OUTPUTPARAMETERS
  !  KOUNT    NUMBER OF INTEGRAND EVALUATIONS
  !  EST      ESTIMATION OF THE ABSOLUTE ERROR OF THE APPROXIMATION
  !
  ! Here, the interface just maps to hoppet's ig_LinWeight (CERNLIB dgauss variant)
  ! with the following adaptations relative to the original DAIND
  ! 
  !  - EPS is treated as in dgauss, i.e. as an absolute tolerance if |result| < 1
  !    relative otherwise
  !  - KEY and MAX are ignored
  !  - KOUNT is returned as 0
  !  - EST is returned as 0.0_dp
  function daind(a, b, fun, eps, key, max, kount, est)
    use integrator
    real(dp) :: daind
    real(dp), intent(in) :: a, b, eps
    external fun
    real(dp) :: fun
    !interface 
    !  function fun(x)
    !    use types; implicit none
    !    real(dp) :: x
    !    real(dp) :: fun
    !  end function fun
    !end interface
    integer, intent(in) :: key, max
    integer, intent(out) :: kount
    real(dp), intent(out) :: est

    kount = 0
    est = 0.0_dp

    daind = ig_LinWeight(fun, a, b, 1.0_dp, 1.0_dp, eps)
  end function daind
  
end module daind_fake

module coefficient_functions_holder_internal
  use types; 
  use convolution_communicator
  use dglap_objects
  use coefficient_functions 
  implicit none
 
  type coef_holder
    integer        :: nloop
    integer        :: nf, nflo, nfhi
    real(dp)       :: C2LO,   CLLO,   C3LO
    type(split_mat), pointer :: C2NLO,  CLNLO,  C3NLO
    type(split_mat), pointer :: C2NNLO, CLNNLO, C3NNLO
    type(split_mat), pointer :: C2N3LO, CLN3LO, C3N3LO
    type(split_mat), pointer :: C2N3LO_fl11, CLN3LO_fl11
    type(split_mat), pointer :: C_NLO(:,:), C_NNLO(:,:), C_N3LO(:,:)
  end type coef_holder

end module coefficient_functions_holder_internal

! Module that contains the coefficient functions up to N3LO
!
! Useful references:
!
! - http://www.liv.ac.uk/~avogt/coeff.html
!   (this is the source of the xc*.f 2- and 3-loop coefficient functions)
!
! - hep-ph/9907472 and hep-ph/0006154, which contain the
!   parametrisations and some amount of definition of
!   what it is we're doing.
!
! - Original van Neerven and Zijlstra papers
module coefficient_functions_holder
  use types; use warnings_and_errors
  use consts_dp; use convolution_communicator
  use qcd
  use convolution
  use dglap_objects
  use coefficient_functions 
  use coefficient_functions_holder_internal
  implicit none
  !private
  
  public :: coef_holder, InitCoefHolder, SetNfCoefHolder
  
  real(dp), parameter  :: tiny = 1D-10
  
  !! to facilitate conditional compilation of exact coefficient functions
  !! (which add about 20s to the compilation time), we define an
  !! external function that handles the exact coefficient functions.
  !! If support is not compiled in, it should simply give an error.
  interface
     subroutine InitCoefHolderExact(grid, ch)
        use types; use coefficient_functions_holder_internal
        implicit none
        type(grid_def), intent(in) :: grid
        type(coef_holder), intent(inout), target :: ch
     end subroutine InitCoefHolderExact
  end interface

contains

  !----------------------------------------------------------------------
  ! Set up all the coefficient functions
  subroutine InitCoefHolder(grid, ch, nloop, use_exact_cf, nflo, nfhi)
    type(grid_def),    intent(in) :: grid
    type(coef_holder), intent(inout), target :: ch
    integer, optional, intent(in) :: nloop
    logical, optional, intent(in) :: use_exact_cf
    integer, optional, intent(in) :: nflo, nfhi
    !------------------------------
    integer :: nfstore, nf_lcl
    logical :: use_exact

    ! default settings
    ch%nloop  = 4
    use_exact = .false.
    ch%nf     = nf_int
    ch%nflo   = nf_int
    ch%nfhi   = nf_int

    ! if specified, use inputs
    if (present(nloop)) ch%nloop = nloop
    if (present(use_exact_cf)) use_exact = use_exact_cf
    if (present(nflo)) ch%nflo = nflo
    if (present(nfhi)) ch%nfhi = nfhi
    
    if (ch%nloop > 4 .or. ch%nloop < 1) then
       call wae_error('InitCoefHolder: nloop must be between 1 and 4')
    end if
    
    ! now allocate the arrays
    if (nloop.ge.2) then
       allocate(ch%C_NLO(3,ch%nflo:ch%nfhi))
    endif
    if (nloop.ge.3) then
       allocate(ch%C_NNLO(3,ch%nflo:ch%nfhi))
    endif
    if (nloop.ge.4) then
       allocate(ch%C_N3LO(5,ch%nflo:ch%nfhi))
    endif

    ! first initialise the LO coefficient "functions" (just a number, since delta-fn)
    ! they don't depend on nf, so set them up now
    ch%C2LO = one
    ch%CLLO = zero
    ch%C3LO = one

    ! store nf value so that we can reset it afterwards
    nfstore = nf_int
    
    ! loop over nf values and set up coefficient functions
    do nf_lcl = ch%nflo, ch%nfhi
       call SetNfCoefHolder(ch, nf_lcl)
       if (ch%nloop.ge.2) then
          call InitC2NLO(grid, ch%C2NLO)
          call InitCLNLO(grid, ch%CLNLO)
          call InitC3NLO(grid, ch%C3NLO)
       end if

       if (use_exact_cf) then
         call InitCoefHolderExact(grid, ch)
       else
         if (nloop.ge.3) then
            ! either with the exact functions
            !if (use_exact_cf) then
            !   call InitC2NNLO_e(grid, ch%C2NNLO)
            !   call InitCLNNLO_e(grid, ch%CLNNLO)
            !   call InitC3NNLO_e(grid, ch%C3NNLO)
            !else
               ! or the parametrised version
               call InitC2NNLO(grid, ch%C2NNLO)
               call InitCLNNLO(grid, ch%CLNNLO)
               call InitC3NNLO(grid, ch%C3NNLO) 
            !endif
         endif
         if (nloop.ge.4) then
            !if (use_exact_cf) then
            !   call InitC2N3LO_e(grid, ch%C2N3LO)
            !   call InitCLN3LO_e(grid, ch%CLN3LO)
            !   call InitC3N3LO_e(grid, ch%C3N3LO)
            !   ! including the fl11 terms for Z/photon exchanges
            !   call InitC2N3LO_fl11_e(grid, ch%C2N3LO_fl11)
            !   call InitCLN3LO_fl11_e(grid, ch%CLN3LO_fl11)
            !else
               call InitC2N3LO(grid, ch%C2N3LO)
               call InitCLN3LO(grid, ch%CLN3LO)
               call InitC3N3LO(grid, ch%C3N3LO)
               ! including the fl11 terms for Z/photon exchanges
               call InitC2N3LO_fl11(grid, ch%C2N3LO_fl11)
               call InitCLN3LO_fl11(grid, ch%CLN3LO_fl11)
            !endif
         endif
      end if
    end do

    ! reset nf value to initial value
    ! and set all the pointers accordingly
    call SetNfCoefHolder(ch, nfstore)
    
  end subroutine InitCoefHolder

  !----------------------------------------------------------------------
  ! Set the internal nf to specified value
  subroutine SetNfCoefHolder(ch, nflcl)
    type(coef_holder), intent(inout), target :: ch
    integer, intent(in) :: nflcl

    if ((nflcl.lt.ch%nflo) .or. (nflcl.gt.ch%nfhi)) then
       call wae_Error('SetNfCoefHolder: tried to set unsupported nf; request val was',intval=nflcl)
    end if
    
    ch%nf   = nflcl
    call qcd_SetNf(nflcl)

    ! now set the pointers
    if (ch%nloop.ge.2) then
       ch%C2NLO => ch%C_NLO(1,nflcl)
       ch%CLNLO => ch%C_NLO(2,nflcl)
       ch%C3NLO => ch%C_NLO(3,nflcl)
    endif
    if (ch%nloop.ge.3) then
       ch%C2NNLO => ch%C_NNLO(1,nflcl)
       ch%CLNNLO => ch%C_NNLO(2,nflcl)
       ch%C3NNLO => ch%C_NNLO(3,nflcl)
    endif
    if (ch%nloop.ge.4) then
       ch%C2N3LO => ch%C_N3LO(1,nflcl)
       ch%CLN3LO => ch%C_N3LO(2,nflcl)
       ch%C3N3LO => ch%C_N3LO(3,nflcl)
       ch%C2N3LO_fl11 => ch%C_N3LO(4,nflcl)
       ch%CLN3LO_fl11 => ch%C_N3LO(5,nflcl)
    endif
    
  end subroutine SetNfCoefHolder

  
  !======================================================================
  ! NLO coefficient functions
  !======================================================================

  !======================================================================
  ! NLO C2 coefficient function as a splitting matrix
  subroutine InitC2NLO(grid, C)
    type(grid_def),  intent(in)    :: grid
    type(split_mat), intent(inout) :: C

    C%nf_int = nf_int
    call cobj_InitSplitLinks(C)

    call InitGridConv(grid, C%qq, cf_CqF2MSbar)
    call InitGridConv(grid, C%qg, cf_CgF2MSbar)
    call InitGridConv(grid, C%gg)  ! zero
    call InitGridConv(grid, C%gq)  ! zero

    !-- now fix up pieces so that they can be directly used as a matrix
    call Multiply(C%qg, 2*nf)

    ! all non-singlet pieces are equal to singlet ones
    call InitGridConv(C%NS_plus,  C%qq)
    call InitGridConv(C%NS_minus, C%qq)
    call InitGridConv(C%NS_V, C%NS_minus)
  end subroutine InitC2NLO
  
  !======================================================================
  ! NLO CL coefficient function as a splitting matrix
  subroutine InitCLNLO(grid, C)
    type(grid_def),  intent(in)    :: grid
    type(split_mat), intent(inout) :: C

    C%nf_int = nf_int
    call cobj_InitSplitLinks(C)

    call InitGridConv(grid, C%qq, cf_CqFL)
    call InitGridConv(grid, C%qg, cf_CgFL)
    call InitGridConv(grid, C%gq)  ! zero
    call InitGridConv(grid, C%gg)  ! zero

    !-- now fix up pieces so that they can be directly used as a matrix
    call Multiply(C%qg, 2*nf)

    ! all non-singlet pieces are equal to singlet ones
    call InitGridConv(C%NS_plus,  C%qq)
    call InitGridConv(C%NS_minus, C%qq)
    call InitGridConv(C%NS_V, C%NS_minus)
  end subroutine InitCLNLO
  
  !======================================================================
  ! NLO C3 coefficient function as a splitting matrix
  subroutine InitC3NLO(grid, C)
    type(grid_def),  intent(in)    :: grid
    type(split_mat), intent(inout) :: C

    C%nf_int = nf_int
    call cobj_InitSplitLinks(C)

    call InitGridConv(grid, C%qq, cf_CqF3)
    call InitGridConv(grid, C%qg)  ! zero
    call InitGridConv(grid, C%gq)  ! zero
    call InitGridConv(grid, C%gg)  ! zero

    !-- now fix up pieces so that they can be directly used as a matrix
    call Multiply(C%qg, 2*nf)

    ! all non-singlet pieces are equal to singlet ones
    call InitGridConv(C%NS_plus,  C%qq)
    call InitGridConv(C%NS_minus, C%qq)
    call InitGridConv(C%NS_V, C%NS_minus)

    ! The following line helps tests to see if it makes a difference
    ! if we set the singlet qq piece to zero.
    !
    ! Conclusion:
    ! - it makes no difference for Z
    ! - it makes a difference for W with an odd number of (light) flavours
    ! - but W with an odd number of flavours isn't really a consistent thing
    !
    ! Since we're going to be running with an even # of flavours for W, we
    ! should be good whatever we put here.
    !
    !call InitGridConv(grid, C%qq)  ! zero
  end subroutine InitC3NLO
  
  !======================================================================
  ! NNLO parametrised coefficient functions
  !======================================================================

  !======================================================================
  ! NNLO C2 coefficient function as a splitting matrix
  subroutine InitC2NNLO(grid, C)
    type(grid_def),  intent(in)    :: grid
    type(split_mat), intent(inout) :: C

    C%nf_int = nf_int
    call cobj_InitSplitLinks(C)

    call InitGridConv(grid, C%NS_plus, cfNNLO_F2NS_plus)
    call InitGridConv(grid, C%NS_minus, cfNNLO_F2NS_minus)
    ! valence shouldn't come in to F2, so it shouldn't matter
    ! what we put here (explicitly verified for F2Z and F2Wp*F2Wm)
    call InitGridConv(C%NS_V, C%NS_minus) 
    !call InitGridConv(grid, C%NS_V) 

    ! singlet qq is NS+ + pure_singlet
    call InitGridConv(C%qq, C%NS_plus)    ! start with NS+
    call AddWithCoeff(C%qq, cfNNLO_F2PS)  ! add in pure singlet piece
    call InitGridConv(grid, C%qg, cfNNLO_F2G)   ! the part driven by the gluon
    call InitGridConv(grid, C%gq)  ! zero
    call InitGridConv(grid, C%gg)  ! zero

  end subroutine InitC2NNLO

  !======================================================================
  ! NNLO CL coefficient function as a splitting matrix
  subroutine InitCLNNLO(grid, C)
    type(grid_def),  intent(in)    :: grid
    type(split_mat), intent(inout) :: C

    C%nf_int = nf_int
    call cobj_InitSplitLinks(C)

    call InitGridConv(grid, C%NS_plus, cfNNLO_FLNS_plus)
    call InitGridConv(grid, C%NS_minus, cfNNLO_FLNS_minus)
    ! valence shouldn't come in to F2, so it shouldn't matter
    ! what we put here (explicitly verified for F2Z and F2Wp*F2Wm)
    call InitGridConv(C%NS_V, C%NS_minus) 
    !call InitGridConv(grid, C%NS_V) 

    ! singlet qq is NS+ + pure_singlet
    call InitGridConv(C%qq, C%NS_plus)    ! start with NS+
    call AddWithCoeff(C%qq, cfNNLO_FLPS)  ! add in pure singlet piece
    call InitGridConv(grid, C%qg, cfNNLO_FLG)   ! the part driven by the gluon
    call InitGridConv(grid, C%gq)  ! zero
    call InitGridConv(grid, C%gg)  ! zero

  end subroutine InitCLNNLO

  !======================================================================
  ! NNLO C3 coefficient function as a splitting matrix
  subroutine InitC3NNLO(grid, C)
    type(grid_def),  intent(in)    :: grid
    type(split_mat), intent(inout) :: C

    C%nf_int = nf_int
    call cobj_InitSplitLinks(C)

    ! singlet piece should have no impact on Z case and for the W case
    ! has no impact for even numbers of flavours (odd numbers of light
    ! flavours don't make sense with W, except potentially inside
    ! certain loops). So we simply set it to zero
    call InitGridConv(grid, C%qq)  ! zero
    call InitGridConv(grid, C%qg)  ! zero
    call InitGridConv(grid, C%gq)  ! zero
    call InitGridConv(grid, C%gg)  ! zero

    !-- now fix up pieces so that they can be directly used as a matrix
    call Multiply(C%qg, 2*nf)

    ! all non-singlet pieces are equal to singlet ones
    call InitGridConv(grid, C%NS_plus, cfNNLO_F3NS_plus)
    call InitGridConv(grid, C%NS_minus, cfNNLO_F3NS_minus)
    ! NS_minus and NS_V are identical according to sentence before
    ! Eq.(3.15) of 1109.3717v2
    call InitGridConv(C%NS_V, C%NS_minus) 

  end subroutine InitC3NNLO
  
  
  !======================================================================
  ! N3LO parametrised coefficient functions
  !======================================================================

  !======================================================================
  ! N3LO C2 coefficient function as a splitting matrix
  subroutine InitC2N3LO(grid, C)
    type(grid_def),  intent(in)    :: grid
    type(split_mat), intent(inout) :: C

    C%nf_int = nf_int
    call cobj_InitSplitLinks(C)

    call InitGridConv(grid, C%NS_plus, cfN3LO_F2NS_plus)
    call InitGridConv(grid, C%NS_minus, cfN3LO_F2NS_minus)
    ! valence shouldn't come in to F2, so it shouldn't matter
    ! what we put here (explicitly verified for F2Z and F2Wp*F2Wm)
    call InitGridConv(C%NS_V, C%NS_minus) 
    !call InitGridConv(grid, C%NS_V) 

    ! singlet qq is NS+ + pure_singlet
    call InitGridConv(C%qq, C%NS_plus)    ! start with NS+
    call AddWithCoeff(C%qq, cfN3LO_F2PS)  ! add in pure singlet piece
    call InitGridConv(grid, C%qg, cfN3LO_F2G)   ! the part driven by the gluon
    call InitGridConv(grid, C%gq)  ! zero
    call InitGridConv(grid, C%gg)  ! zero

  end subroutine InitC2N3LO

  !======================================================================
  ! N3LO C2 fl11 coefficient function as a splitting matrix
  ! Only the part that is different for Z boson exchange
  subroutine InitC2N3LO_fl11(grid, C)
    type(grid_def),  intent(in)    :: grid
    type(split_mat), intent(inout) :: C

    C%nf_int = nf_int
    call cobj_InitSplitLinks(C)

    call InitGridConv(grid, C%NS_plus, cfN3LO_F2NS_plus_fl11)
    call InitGridConv(grid, C%NS_minus, cfN3LO_F2NS_minus_fl11)
    ! valence shouldn't come in to F2, so it shouldn't matter
    ! what we put here (explicitly verified for F2Z and F2Wp*F2Wm)
    call InitGridConv(C%NS_V, C%NS_minus) 
    !call InitGridConv(grid, C%NS_V) 

    ! singlet qq is NS+ + pure_singlet
    call InitGridConv(C%qq, C%NS_plus)    ! start with NS+
    call AddWithCoeff(C%qq, cfN3LO_F2PS_fl11)  ! add in pure singlet piece
    call InitGridConv(grid, C%qg, cfN3LO_F2G_fl11)   ! the part driven by the gluon
    call InitGridConv(grid, C%gq)  ! zero
    call InitGridConv(grid, C%gg)  ! zero

  end subroutine InitC2N3LO_fl11

  !======================================================================
  ! N3LO CL coefficient function as a splitting matrix
  subroutine InitCLN3LO(grid, C)
    type(grid_def),  intent(in)    :: grid
    type(split_mat), intent(inout) :: C

    C%nf_int = nf_int
    call cobj_InitSplitLinks(C)

    call InitGridConv(grid, C%NS_plus, cfN3LO_FLNS_plus)
    call InitGridConv(grid, C%NS_minus, cfN3LO_FLNS_minus)
    ! valence shouldn't come in to F2, so it shouldn't matter
    ! what we put here (explicitly verified for F2Z and F2Wp*F2Wm)
    call InitGridConv(C%NS_V, C%NS_minus) 
    !call InitGridConv(grid, C%NS_V) 

    ! singlet qq is NS+ + pure_singlet
    call InitGridConv(C%qq, C%NS_plus)    ! start with NS+
    call AddWithCoeff(C%qq, cfN3LO_FLPS)  ! add in pure singlet piece
    call InitGridConv(grid, C%qg, cfN3LO_FLG)   ! the part driven by the gluon
    call InitGridConv(grid, C%gq)  ! zero
    call InitGridConv(grid, C%gg)  ! zero

  end subroutine InitCLN3LO


  !======================================================================
  ! N3LO CL coefficient function as a splitting matrix
  subroutine InitCLN3LO_fl11(grid, C)
    type(grid_def),  intent(in)    :: grid
    type(split_mat), intent(inout) :: C

    C%nf_int = nf_int
    call cobj_InitSplitLinks(C)

    call InitGridConv(grid, C%NS_plus, cfN3LO_FLNS_plus_fl11)
    call InitGridConv(grid, C%NS_minus, cfN3LO_FLNS_minus_fl11)
    ! valence shouldn't come in to F2, so it shouldn't matter
    ! what we put here (explicitly verified for F2Z and F2Wp*F2Wm)
    call InitGridConv(C%NS_V, C%NS_minus) 
    !call InitGridConv(grid, C%NS_V) 

    ! singlet qq is NS+ + pure_singlet
    call InitGridConv(C%qq, C%NS_plus)    ! start with NS+
    call AddWithCoeff(C%qq, cfN3LO_FLPS_fl11)  ! add in pure singlet piece
    call InitGridConv(grid, C%qg, cfN3LO_FLG_fl11)   ! the part driven by the gluon
    call InitGridConv(grid, C%gq)  ! zero
    call InitGridConv(grid, C%gg)  ! zero

  end subroutine InitCLN3LO_fl11

  !======================================================================
  ! N3LO C3 coefficient function as a splitting matrix
  subroutine InitC3N3LO(grid, C)
    type(grid_def),  intent(in)    :: grid
    type(split_mat), intent(inout) :: C

    C%nf_int = nf_int
    call cobj_InitSplitLinks(C)

    ! singlet piece should have no impact on Z case and for the W case
    ! has no impact for even numbers of flavours (odd numbers of light
    ! flavours don't make sense with W, except potentially inside
    ! certain loops). So we simply set it to zero
    call InitGridConv(grid, C%qq)  ! zero
    call InitGridConv(grid, C%qg)  ! zero
    call InitGridConv(grid, C%gq)  ! zero
    call InitGridConv(grid, C%gg)  ! zero

    !-- now fix up pieces so that they can be directly used as a matrix
    call Multiply(C%qg, 2*nf)

    ! all non-singlet pieces are equal to singlet ones
    call InitGridConv(grid, C%NS_plus, cfN3LO_F3NS_plus)
    call InitGridConv(grid, C%NS_minus, cfN3LO_F3NS_minus)
    ! NS_minus and NS_V are not identical at N3LO
    call InitGridConv(grid, C%NS_V, cfN3LO_F3NS_val) 

  end subroutine InitC3N3LO
  

  !======================================================================
  ! this is the part that needs to be added to Hoppet's
  ! cf_CqF2MSbar in order to get the F3 coefficient function
  !
  ! It is taken from Eq.(155) of hep-ph/9912355, keeping in mind that
  ! the result there multiplies as/4pi (we multiply as/2pi, so include
  ! an extra factor of 1/2).
  function cf_CqF3minusF2(y) result(res)
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x
    real(dp) :: lnx, ln1mx

    x = exp(-y)
    res = zero

    select case(cc_piece)
    case(cc_REAL,cc_REALVIRT)
       res = res - CF * (1+x)
    end select

    if (cc_piece /= cc_DELTA) res = res * x
  end function cf_CqF3minusF2


  function cf_CqF3 (y) result(res)
    real(dp), intent(in) :: y
    real(dp)             :: res
    
    res = cf_CqF3minusF2(y) + cf_CqF2MSbar(y)
    
  end function cf_CqF3


  !======================================================================
  !======================================================================
  ! NNLO PIECES (parametrised version)
  !======================================================================
  !======================================================================

  !----------------------------------------------------------------------
  ! This is the coefficient function for the sum F3(nu)+F3(nubar),
  ! corresponding to C3NSP-C3NSN in W. van Neerven's program.
  function cfNNLO_F3NS_minus(y) result(res)
    use xc3ns2p
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x
    
    x = exp(-y)
    res = zero

    select case(cc_piece)
    case(cc_REAL)
       res = C3NM2A(x, nf_int) + C3NS2B(x, nf_int)
    case(cc_REALVIRT)
       res = C3NM2A(x, nf_int)
    case(cc_VIRT)
       res = - C3NS2B(x, nf_int)
    case(cc_DELTA)
       res = C3NM2C(zero, nf_int)
    end select
    
    res = res * 0.25_dp ! since our convention is to multiply (as/2pi)^2, theirs is to multiply (as/4pi)^2
    if (cc_piece /= cc_DELTA) res = res * x
  end function cfNNLO_F3NS_minus

  !----------------------------------------------------------------------
  ! This is the coefficient function for the sum F3(nu)-F3(nubar),
  ! corresponding to C3NSP-C3NSN in W. van Neerven's program.
  function cfNNLO_F3NS_plus(y) result(res)
    use xc3ns2p
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x
    
    x = exp(-y)
    res = zero

    select case(cc_piece)
    case(cc_REAL)
       res = C3NP2A(x, nf_int) + C3NS2B(x, nf_int)
    case(cc_REALVIRT)
       res = C3NP2A(x, nf_int)
    case(cc_VIRT)
       res = - C3NS2B(x, nf_int)
    case(cc_DELTA)
       res = C3NP2C(zero, nf_int)
    end select

    res = res * 0.25_dp ! since our convention is to multiply (as/2pi)^2, theirs is to multiply (as/4pi)^2
    if (cc_piece /= cc_DELTA) res = res * x
  end function cfNNLO_F3NS_plus
  

  !----------------------------------------------------------------------
  ! This is the "plus" non-singlet coefficient function (Vogt's
  ! comments say it applies to the electromagnetic F2, and, in
  ! addition to the singlet, that involves (u+ubar) - (d+dbar) type
  ! contributions, which is precisely what a NS+ coefficient function
  ! multiplies.
  function cfNNLO_F2NS_plus(y) result(res)
    use xc2ns2p
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x
    
    x = exp(-y)
    res = zero

    select case(cc_piece)
    case(cc_REAL)
       res = C2NN2A(x, nf_int) + C2NS2B(x, nf_int)
    case(cc_REALVIRT)
       res = C2NN2A(x, nf_int)
    case(cc_VIRT)
       res = - C2NS2B(x, nf_int)
    case(cc_DELTA)
       res = C2NN2C(zero, nf_int)
    end select

    res = res * 0.25_dp ! since our convention is to multiply (as/2pi)^2, theirs is to multiply (as/4pi)^2
    if (cc_piece /= cc_DELTA) res = res * x
  end function cfNNLO_F2NS_plus

  !----------------------------------------------------------------------
  ! This is the "minus" non-singlet coefficient function (Vogt's
  ! comments say it applies to the charged-current F2, and, in
  ! addition to the singlet, that involves (u-ubar) - (d-dbar) type
  ! contributions, which is precisely what a NS- coefficient function
  ! multiplies.
  function cfNNLO_F2NS_minus(y) result(res)
    use xc2ns2p
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x
    
    x = exp(-y)
    res = zero

    select case(cc_piece)
    case(cc_REAL)
       res = C2NC2A(x, nf_int) + C2NS2B(x, nf_int)
    case(cc_REALVIRT)
       res = C2NC2A(x, nf_int)
    case(cc_VIRT)
       res = - C2NS2B(x, nf_int)
    case(cc_DELTA)
       res = C2NC2C(zero, nf_int)
    end select

    res = res * 0.25_dp ! since our convention is to multiply (as/2pi)^2, theirs is to multiply (as/4pi)^2
    if (cc_piece /= cc_DELTA) res = res * x
  end function cfNNLO_F2NS_minus

  !----------------------------------------------------------------------
  ! Pure singlet piece of F2 NNLO coefficient function. To get the full
  ! singlet result, this is to be added to NS_plus (cf. relation just after
  ! Eq.(3.18) of 1109.3717v2
  function cfNNLO_F2PS(y) result(res)
    use xc2sg2p
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x
    
    x = exp(-y)
    res = zero

    select case(cc_piece)
    case(cc_REAL)
       res = C2S2A(x, nf_int)
    case(cc_REALVIRT)
       res = C2S2A(x, nf_int)
    case(cc_VIRT)
       res = zero
    case(cc_DELTA)
       res = zero
    end select

    res = res * 0.25_dp ! since our convention is to multiply (as/2pi)^2, theirs is to multiply (as/4pi)^2
    if (cc_piece /= cc_DELTA) res = res * x
  end function cfNNLO_F2PS

  !----------------------------------------------------------------------
  ! Pure singlet piece of F2 NNLO coefficient function. To get the full
  ! singlet result, this is to be added to NS_plus (cf. relation just after
  ! Eq.(3.18) of 1109.3717v2
  function cfNNLO_F2G(y) result(res)
    use xc2sg2p
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x
    
    x = exp(-y)
    res = zero

    select case(cc_piece)
    case(cc_REAL)
       res = C2G2A(x, nf_int)
    case(cc_REALVIRT)
       res = C2G2A(x, nf_int)
    case(cc_VIRT)
       res = zero
    case(cc_DELTA)
       res = C2G2C(zero, nf_int)
    end select

    res = res * 0.25_dp ! since our convention is to multiply (as/2pi)^2, theirs is to multiply (as/4pi)^2
    if (cc_piece /= cc_DELTA) res = res * x
  end function cfNNLO_F2G

  !----------------------------------------------------------------------
  ! This is the "plus" non-singlet coefficient function (Vogt's
  ! comments say it applies to the electromagnetic FL, and, in
  ! addition to the singlet, that involves (u+ubar) - (d+dbar) type
  ! contributions, which is precisely what a NS+ coefficient function
  ! multiplies.
  function cfNNLO_FLNS_plus(y) result(res)
    use xclns2p
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x
    
    x = exp(-y)
    res = zero

    select case(cc_piece)
    case(cc_REAL)
       res = CLNN2A(x, nf_int)
    case(cc_REALVIRT)
       res = CLNN2A(x, nf_int)
    case(cc_VIRT)
       res = zero
    case(cc_DELTA)
       res = CLNN2C(zero)
    end select

    res = res * 0.25_dp ! since our convention is to multiply (as/2pi)^2, theirs is to multiply (as/4pi)^2
    if (cc_piece /= cc_DELTA) res = res * x
  end function cfNNLO_FLNS_plus

  !----------------------------------------------------------------------
  ! This is the "minus" non-singlet coefficient function (Vogt's
  ! comments say it applies to the charged-current FL, and, in
  ! addition to the singlet, that involves (u-ubar) - (d-dbar) type
  ! contributions, which is precisely what a NS- coefficient function
  ! multiplies.
  function cfNNLO_FLNS_minus(y) result(res)
    use xclns2p
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x
    
    x = exp(-y)
    res = zero

    select case(cc_piece)
    case(cc_REAL)
       res = CLNC2A(x, nf_int)
    case(cc_REALVIRT)
       res = CLNC2A(x, nf_int)
    case(cc_VIRT)
       res = zero
    case(cc_DELTA)
       res = CLNC2C(zero)
    end select

    res = res * 0.25_dp ! since our convention is to multiply (as/2pi)^2, theirs is to multiply (as/4pi)^2
    if (cc_piece /= cc_DELTA) res = res * x
  end function cfNNLO_FLNS_minus

  !----------------------------------------------------------------------
  ! Pure singlet piece of FL NNLO coefficient function. To get the full
  ! singlet result, this is to be added to NS_plus (cf. relation just after
  ! Eq.(3.18) of 1109.3717v2
  function cfNNLO_FLPS(y) result(res)
    use xclsg2p
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x
    
    x = exp(-y)
    res = zero

    select case(cc_piece)
    case(cc_REAL)
       res = CLS2A(x, nf_int)
    case(cc_REALVIRT)
       res = CLS2A(x, nf_int)
    case(cc_VIRT)
       res = zero
    case(cc_DELTA)
       res = zero
    end select

    res = res * 0.25_dp ! since our convention is to multiply (as/2pi)^2, theirs is to multiply (as/4pi)^2
    if (cc_piece /= cc_DELTA) res = res * x
  end function cfNNLO_FLPS

  !----------------------------------------------------------------------
  ! Pure singlet piece of FL NNLO coefficient function. To get the full
  ! singlet result, this is to be added to NS_plus (cf. relation just after
  ! Eq.(3.18) of 1109.3717v2
  function cfNNLO_FLG(y) result(res)
    use xclsg2p
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x
    
    x = exp(-y)
    res = zero

    select case(cc_piece)
    case(cc_REAL)
       res = CLG2A(x, nf_int)
    case(cc_REALVIRT)
       res = CLG2A(x, nf_int)
    case(cc_VIRT)
       res = zero
    case(cc_DELTA)
       res = zero
    end select

    res = res * 0.25_dp ! since our convention is to multiply (as/2pi)^2, theirs is to multiply (as/4pi)^2
    if (cc_piece /= cc_DELTA) res = res * x
  end function cfNNLO_FLG

  

  
  !======================================================================
  !======================================================================
  ! N3LO PIECES (parametrised)
  !======================================================================
  !======================================================================

  !----------------------------------------------------------------------
  ! This is the coefficient function for the sum F3(nu)+F3(nubar),
  ! corresponding to C3NSP-C3NSN in W. van Neerven's program.
  function cfN3LO_F3NS_val(y) result(res)
    use xc3ns3p
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x
    
    x = exp(-y)
    res = zero
    
    select case(cc_piece)
    case(cc_REAL)
       res = C3NM3A(x, -y, nf_int, 1) + C3NS3B(x, -y, nf_int)
    case(cc_REALVIRT)
       res = C3NM3A(x, -y, nf_int, 1)
    case(cc_VIRT)
       res = - C3NS3B(x, -y, nf_int)
    case(cc_DELTA)
       !res = C3NS3C(zero, nf_int)
       res = C3NM3C(zero, nf_int) ! FD: Why is this C3NM3C instead of C3NS3C as in the NNLO case ???
                                  !     and where is the diff piece between C3NM3C and C3NP3C ?
    end select
    
    res = res * 0.125_dp ! since our convention is to multiply (as/2pi)^3, theirs is to multiply (as/4pi)^3
    if (cc_piece /= cc_DELTA) res = res * x
  end function cfN3LO_F3NS_val

  !----------------------------------------------------------------------
  ! This is the coefficient function for the sum F3(nu)+F3(nubar),
  ! corresponding to C3NSP-C3NSN in W. van Neerven's program.
  function cfN3LO_F3NS_minus(y) result(res)
    use xc3ns3p
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x
    
    x = exp(-y)
    res = zero
    
    select case(cc_piece)
    case(cc_REAL)
       res = C3NM3A(x, -y, nf_int, 0) + C3NS3B(x, -y, nf_int)
    case(cc_REALVIRT)
       res = C3NM3A(x, -y, nf_int, 0)
    case(cc_VIRT)
       res = - C3NS3B(x, -y, nf_int)
    case(cc_DELTA)
       !res = C3NS3C(zero, nf_int)
       res = C3NM3C(zero, nf_int) ! FD: Why is this C3NM3C instead of C3NS3C as in the NNLO case ???
                                  !     and where is the diff piece between C3NM3C and C3NP3C ?
    end select
    
    res = res * 0.125_dp ! since our convention is to multiply (as/2pi)^3, theirs is to multiply (as/4pi)^3
    if (cc_piece /= cc_DELTA) res = res * x
  end function cfN3LO_F3NS_minus

  !----------------------------------------------------------------------
  ! This is the coefficient function for the sum F3(nu)-F3(nubar),
  ! corresponding to C3NSP-C3NSN in W. van Neerven's program.
  function cfN3LO_F3NS_plus(y) result(res)
    use xc3ns3p
    use xcdiff3pnew
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x
    
    x = exp(-y)
    res = zero
    
    select case(cc_piece)
    case(cc_REAL)
       res = C3NM3A(x, -y, nf_int, 0) + C3Q3DFP(x, -y, nf_int) + C3NS3B(x, -y, nf_int)
    case(cc_REALVIRT)
       res = C3NM3A(x, -y, nf_int, 0) + C3Q3DFP(x, -y, nf_int)
    case(cc_VIRT)
       res = - C3NS3B(x, -y, nf_int)
    case(cc_DELTA)
       !res = C3NS3C(zero, nf_int)
       res = C3NM3C(zero, nf_int) + c3q3dfPC (zero, nf_int) 
    end select

    res = res * 0.125_dp ! since our convention is to multiply (as/2pi)^3, theirs is to multiply (as/4pi)^3
    if (cc_piece /= cc_DELTA) res = res * x
  end function cfN3LO_F3NS_plus
  

  !----------------------------------------------------------------------
  ! This is the "plus" non-singlet coefficient function (Vogt's
  ! comments say it applies to the electromagnetic F2, and, in
  ! addition to the singlet, that involves (u+ubar) - (d+dbar) type
  ! contributions, which is precisely what a NS+ coefficient function
  ! multiplies.
  function cfN3LO_F2NS_plus(y) result(res)
    use xc2ns3p
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x
    
    x = exp(-y)
    res = zero
    select case(cc_piece)
    case(cc_REAL)
       res = C2NP3A(x, -y, nf_int, 1) + C2NS3B(x, -y, nf_int)
    case(cc_REALVIRT)
       res = C2NP3A(x, -y, nf_int, 1)
    case(cc_VIRT)
       res = - C2NS3B(x, -y, nf_int)
    case(cc_DELTA)
       res = C2NP3C(zero, nf_int, 1) ! FD: Why is this C2NP3C instead of C2NS3C as in the NNLO case ???       
    end select

    res = res * 0.125_dp ! since our convention is to multiply (as/2pi)^3, theirs is to multiply (as/4pi)^3
    if (cc_piece /= cc_DELTA) res = res * x
  end function cfN3LO_F2NS_plus
  
  !----------------------------------------------------------------------
  ! This is the "plus" non-singlet coefficient function, but only the fl11 part
  ! 
  function cfN3LO_F2NS_plus_fl11(y) result(res)
    use xc2ns3p
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x
    
    x = exp(-y)
    res = zero
    select case(cc_piece)
    case(cc_REAL)
       res = C2NP3A(x, -y, nf_int, 0)
    case(cc_REALVIRT)
       res = C2NP3A(x, -y, nf_int, 0)
    case(cc_VIRT)
       res = res
    case(cc_DELTA)
       res = C2NP3C(zero, nf_int, 0) ! FD: Why is this C2NP3C instead of C2NS3C as in the NNLO case ???       
    end select

    res = res * 0.125_dp ! since our convention is to multiply (as/2pi)^3, theirs is to multiply (as/4pi)^3
    if (cc_piece /= cc_DELTA) res = res * x
  end function cfN3LO_F2NS_plus_fl11

  !----------------------------------------------------------------------
  ! This is the "minus" non-singlet coefficient function (Vogt's
  ! comments say it applies to the charged-current F2, and, in
  ! addition to the singlet, that involves (u-ubar) - (d-dbar) type
  ! contributions, which is precisely what a NS- coefficient function
  ! multiplies.
  function cfN3LO_F2NS_minus(y) result(res)
    use xc2ns3p
    use xcdiff3pnew
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x
    
    x = exp(-y)
    res = zero
    
    select case(cc_piece)
    case(cc_REAL)
       res = C2NP3A(x, -y, nf_int, 1) - C2Q3DFP(x, -y, nf_int) + C2NS3B(x, -y, nf_int)
    case(cc_REALVIRT)
       res = C2NP3A(x, -y, nf_int, 1) - C2Q3DFP(x, -y, nf_int)
    case(cc_VIRT)
       res = - C2NS3B(x, -y, nf_int)
    case(cc_DELTA)
       res = C2NP3C(zero, nf_int, 1) - c2q3dfPC (zero, nf_int) ! FD: Why is this C2NP3C instead of C2NS3C as in the NNLO case ???
    end select

    res = res * 0.125_dp ! since our convention is to multiply (as/2pi)^3, theirs is to multiply (as/4pi)^3
    if (cc_piece /= cc_DELTA) res = res * x
  end function cfN3LO_F2NS_minus


  !----------------------------------------------------------------------
  ! This is the "minus" non-singlet coefficient function but only the fl11 part
  ! 
  function cfN3LO_F2NS_minus_fl11(y) result(res)
    use xc2ns3p
    ! use xcdiff3pnew
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x
    
    x = exp(-y)
    res = zero
    
    select case(cc_piece)
    case(cc_REAL)
       res = C2NP3A(x, -y, nf_int, 0)
    case(cc_REALVIRT)
       res = C2NP3A(x, -y, nf_int, 0)
    case(cc_VIRT)
       res = res
    case(cc_DELTA)
       res = C2NP3C(zero, nf_int, 0) ! FD: Why is this C2NP3C instead of C2NS3C as in the NNLO case ???
    end select

    res = res * 0.125_dp ! since our convention is to multiply (as/2pi)^3, theirs is to multiply (as/4pi)^3
    if (cc_piece /= cc_DELTA) res = res * x
  end function cfN3LO_F2NS_minus_fl11

  !----------------------------------------------------------------------
  ! Pure singlet piece of F2 N3LO coefficient function. To get the full
  ! singlet result, this is to be added to NS_plus (cf. relation just after
  ! Eq.(3.18) of 1109.3717v2
  function cfN3LO_F2PS(y) result(res)
    use xc2sg3p
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x
    
    x = exp(-y)
    res = zero

    select case(cc_piece)
    case(cc_REAL)
       res = C2S3A(x, -y, nf_int, 1)
    case(cc_REALVIRT)
       res = C2S3A(x, -y, nf_int, 1)
    case(cc_VIRT)
       res = zero
    case(cc_DELTA)
       res = zero
    end select

    res = res * 0.125_dp ! since our convention is to multiply (as/2pi)^3, theirs is to multiply (as/4pi)^3
    if (cc_piece /= cc_DELTA) res = res * x
  end function cfN3LO_F2PS
  
  !----------------------------------------------------------------------
  ! Pure singlet piece of F2 N3LO coefficient function.
  ! This is just the fl11 piece
  function cfN3LO_F2PS_fl11(y) result(res)
    use xc2sg3p
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x
    
    x = exp(-y)
    res = zero

    select case(cc_piece)
    case(cc_REAL)
       res = C2S3A(x, -y, nf_int, 0)
    case(cc_REALVIRT)
       res = C2S3A(x, -y, nf_int, 0)
    case(cc_VIRT)
       res = zero
    case(cc_DELTA)
       res = C2S3C(zero, nf_int) !  This piece has an fl11 contribution only
    end select

    res = res * 0.125_dp ! since our convention is to multiply (as/2pi)^3, theirs is to multiply (as/4pi)^3
    if (cc_piece /= cc_DELTA) res = res * x
  end function cfN3LO_F2PS_fl11

  !----------------------------------------------------------------------
  ! Pure singlet piece of F2 N3LO coefficient function. To get the full
  ! singlet result, this is to be added to NS_plus (cf. relation just after
  ! Eq.(3.18) of 1109.3717v2
  function cfN3LO_F2G(y) result(res)
    use xc2sg3p
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x
    
    x = exp(-y)
    res = zero

    select case(cc_piece)
    case(cc_REAL)
       res = C2G3A(x, -y, nf_int, 1)
    case(cc_REALVIRT)
       res = C2G3A(x, -y, nf_int, 1)
    case(cc_VIRT)
       res = zero
    case(cc_DELTA)
       res = C2G3C(zero, nf_int)
    end select

    res = res * 0.125_dp ! since our convention is to multiply (as/2pi)^3, theirs is to multiply (as/4pi)^3
    if (cc_piece /= cc_DELTA) res = res * x
  end function cfN3LO_F2G

  !----------------------------------------------------------------------
  ! Pure singlet piece of F2 N3LO coefficient function.
  ! this is just the fl11 piece
  function cfN3LO_F2G_fl11(y) result(res)
    use xc2sg3p
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x
    
    x = exp(-y)
    res = zero

    select case(cc_piece)
    case(cc_REAL)
       res = C2G3A(x, -y, nf_int, 0)
    case(cc_REALVIRT)
       res = C2G3A(x, -y, nf_int, 0)
    case(cc_VIRT)
       res = zero
    case(cc_DELTA)
       res = zero
    end select

    res = res * 0.125_dp ! since our convention is to multiply (as/2pi)^3, theirs is to multiply (as/4pi)^3
    if (cc_piece /= cc_DELTA) res = res * x
  end function cfN3LO_F2G_fl11

  !----------------------------------------------------------------------
  ! This is the "plus" non-singlet coefficient function (Vogt's
  ! comments say it applies to the electromagnetic FL, and, in
  ! addition to the singlet, that involves (u+ubar) - (d+dbar) type
  ! contributions, which is precisely what a NS+ coefficient function
  ! multiplies.
  function cfN3LO_FLNS_plus(y) result(res)
    use xclns3p
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x
    
    x = exp(-y)
    res = zero

    select case(cc_piece)
    case(cc_REAL)
       res = CLNP3A(x, -y, nf_int, 1)
    case(cc_REALVIRT)
       res = CLNP3A(x, -y, nf_int, 1)
    case(cc_VIRT)
       res = zero
    case(cc_DELTA)
       res = CLNP3C(zero, nf_int)
    end select

    res = res * 0.125_dp ! since our convention is to multiply (as/2pi)^3, theirs is to multiply (as/4pi)^3
    if (cc_piece /= cc_DELTA) res = res * x
  end function cfN3LO_FLNS_plus
  
  !----------------------------------------------------------------------
  ! This is the "plus" non-singlet coefficient function.
  ! this is the fl11 part.
  function cfN3LO_FLNS_plus_fl11(y) result(res)
    use xclns3p
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x
    
    x = exp(-y)
    res = zero

    select case(cc_piece)
    case(cc_REAL)
       res = CLNP3A(x, -y, nf_int, 0)
    case(cc_REALVIRT)
       res = CLNP3A(x, -y, nf_int, 0)
    case(cc_VIRT)
       res = zero
    case(cc_DELTA)
       res = zero
    end select

    res = res * 0.125_dp ! since our convention is to multiply (as/2pi)^3, theirs is to multiply (as/4pi)^3
    if (cc_piece /= cc_DELTA) res = res * x
  end function cfN3LO_FLNS_plus_fl11

  !----------------------------------------------------------------------
  ! This is the "minus" non-singlet coefficient function (Vogt's
  ! comments say it applies to the charged-current FL, and, in
  ! addition to the singlet, that involves (u-ubar) - (d-dbar) type
  ! contributions, which is precisely what a NS- coefficient function
  ! multiplies.
  function cfN3LO_FLNS_minus(y) result(res)
    use xclns3p
    use xcdiff3pnew
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x
    
    x = exp(-y)
    res = zero
    select case(cc_piece)
    case(cc_REAL)
       res = CLNP3A(x, -y, nf_int, 1) - CLQ3DFP(x, -y, nf_int)
    case(cc_REALVIRT)
       res = CLNP3A(x, -y, nf_int, 1) - CLQ3DFP(x, -y, nf_int)
    case(cc_VIRT)
       res = zero
    case(cc_DELTA)
       res = CLNP3C(zero, nf_int)
    end select

    res = res * 0.125_dp ! since our convention is to multiply (as/2pi)^3, theirs is to multiply (as/4pi)^3
    if (cc_piece /= cc_DELTA) res = res * x
  end function cfN3LO_FLNS_minus
  
  !----------------------------------------------------------------------
  ! This is the "minus" non-singlet coefficient function
  ! this is the fl11 part
  function cfN3LO_FLNS_minus_fl11(y) result(res)
    use xclns3p
    use xcdiff3pnew
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x
    
    x = exp(-y)
    res = zero
    select case(cc_piece)
    case(cc_REAL)
       res = CLNP3A(x, -y, nf_int, 0) 
    case(cc_REALVIRT)
       res = CLNP3A(x, -y, nf_int, 0) 
    case(cc_VIRT)
       res = zero
    case(cc_DELTA)
       res = zero
    end select

    res = res * 0.125_dp ! since our convention is to multiply (as/2pi)^3, theirs is to multiply (as/4pi)^3
    if (cc_piece /= cc_DELTA) res = res * x
  end function cfN3LO_FLNS_minus_fl11

  !----------------------------------------------------------------------
  ! Pure singlet piece of FL N3LO coefficient function. To get the full
  ! singlet result, this is to be added to NS_plus (cf. relation just after
  ! Eq.(3.18) of 1109.3717v2
  function cfN3LO_FLPS(y) result(res)
    use xclsg3p
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x
    
    x = exp(-y)
    res = zero

    select case(cc_piece)
    case(cc_REAL)
       res = CLS3A(x, -y, nf_int, 1)
    case(cc_REALVIRT)
       res = CLS3A(x, -y, nf_int, 1)
    case(cc_VIRT)
       res = zero
    case(cc_DELTA)
       res = zero
    end select

    res = res * 0.125_dp ! since our convention is to multiply (as/2pi)^3, theirs is to multiply (as/4pi)^3
    if (cc_piece /= cc_DELTA) res = res * x
  end function cfN3LO_FLPS

  !----------------------------------------------------------------------
  ! Pure singlet piece of FL N3LO coefficient function.
  ! this is the fl11 part
  function cfN3LO_FLPS_fl11(y) result(res)
    use xclsg3p
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x
    
    x = exp(-y)
    res = zero

    select case(cc_piece)
    case(cc_REAL)
       res = CLS3A(x, -y, nf_int, 0)
    case(cc_REALVIRT)
       res = CLS3A(x, -y, nf_int, 0)
    case(cc_VIRT)
       res = zero
    case(cc_DELTA)
       res = zero
    end select

    res = res * 0.125_dp ! since our convention is to multiply (as/2pi)^3, theirs is to multiply (as/4pi)^3
    if (cc_piece /= cc_DELTA) res = res * x
  end function cfN3LO_FLPS_fl11

  !----------------------------------------------------------------------
  ! Pure singlet piece of FL N3LO coefficient function. To get the full
  ! singlet result, this is to be added to NS_plus (cf. relation just after
  ! Eq.(3.18) of 1109.3717v2
  function cfN3LO_FLG(y) result(res)
    use xclsg3p
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x
    
    x = exp(-y)
    res = zero

    select case(cc_piece)
    case(cc_REAL)
       res = CLG3A(x, -y, nf_int, 1)
    case(cc_REALVIRT)
       res = CLG3A(x, -y, nf_int, 1)
    case(cc_VIRT)
       res = zero
    case(cc_DELTA)
       res = zero
    end select

    res = res * 0.125_dp ! since our convention is to multiply (as/2pi)^3, theirs is to multiply (as/4pi)^3
    if (cc_piece /= cc_DELTA) res = res * x
  end function cfN3LO_FLG

  !----------------------------------------------------------------------
  ! Pure singlet piece of FL N3LO coefficient function.
  ! this is the fl11 part
  function cfN3LO_FLG_fl11(y) result(res)
    use xclsg3p
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x
    
    x = exp(-y)
    res = zero

    select case(cc_piece)
    case(cc_REAL)
       res = CLG3A(x, -y, nf_int, 0)
    case(cc_REALVIRT)
       res = CLG3A(x, -y, nf_int, 0)
    case(cc_VIRT)
       res = zero
    case(cc_DELTA)
       res = zero
    end select

    res = res * 0.125_dp ! since our convention is to multiply (as/2pi)^3, theirs is to multiply (as/4pi)^3
    if (cc_piece /= cc_DELTA) res = res * x
  end function cfN3LO_FLG_fl11


end module coefficient_functions_holder

!---------------------------------------------------------------
!! provides facilities related to the calculation of the QED coupling
!! with plain 1-loop running (no QCD corrections)
!!  
!-------------------------------------------------------------------
module qed_coupling_module
  use types; use consts_dp
  use warnings_and_errors
  use qcd
  implicit none
  private

  !! use 0.109 to get alpha(mZ) = 1/127.952 at mZ=91.1880 GeV,
  !! which is close to the 2022/23 PDG value of 1/127.951 +- 0.009
  real(dp), parameter, public :: m_light_quarks_default_2023 = 0.109_dp 

  !! use 0.1055 to get alpha(mZ) = 1/127.938 at mZ=91.1880 GeV,
  !! which is within 1 sigma of the 2025 PDG value of 1/127.930 +- 0.008
  !! (see comments below for more details)
  real(dp), parameter, public :: m_light_quarks_default_2025 = 0.1055_dp 

  !! the global defaullt, which as of 2025-10-10 is set to the 2025 value
  real(dp), parameter, public :: m_light_quarks_default = m_light_quarks_default_2025

  ! lepton masses from from 2022 PDG (plus 2023 update)
  real(dp), parameter, public :: pdg2023_m_electron = 0.51099895000e-3_dp ! +-(15) MeV
  real(dp), parameter, public :: pdg2023_m_muon     = 105.6583755e-3_dp   ! +-(23)
  real(dp), parameter, public :: pdg2023_m_tau      = 1776.86e-3_dp ! +-0.12e-3_dp
  ! 2022 PDG: summary table + EW review
  ! - 1/alpha(0)    = 137.035999180(10)
  ! - 1/alpha(mtau) = 133.471 ± 0.007
  ! - 1/alpha(mZ)   = 127.951 ± 0.009
  real(dp), parameter, public :: pdg2023_alpha_qed_scale_0 = one/137.035999180_dp ! +-(10) is uncertainty


  ! lepton masses from from 2025 PDG
  ! 
  real(dp), parameter, public :: pdg2025_m_electron = 0.51099895000e-3_dp ! ± 0.00000000015e-3
  real(dp), parameter, public :: pdg2025_m_muon     = 105.6583755e-3_dp   ! ± 0.0000023e-3_dp
  real(dp), parameter, public :: pdg2025_m_tau      = 1776.93e-3_dp       ! ± 0.09e-3_dp
  ! 2024/25 PDG: EW review, https://pdg.lbl.gov/2025/reviews/rpp2024-rev-standard-model.pdf
  ! - 1/alpha(0)    = 137.035999178(8) 
  ! - 1/alpha(mtau) = 133.450 ± 0.006  [MSbar scheme]
  ! - 1/alpha(mZ)   = 127.930 ± 0.008  [MSbar scheme]
  real(dp), parameter, public :: pdg2025_alpha_qed_scale_0 = one/137.035999178  !(8)


  real(dp), parameter, public :: m_electron        = pdg2025_m_electron
  real(dp), parameter, public :: m_muon            = pdg2025_m_muon
  real(dp), parameter, public :: m_tau             = pdg2025_m_tau
  real(dp), parameter, public :: alpha_qed_scale_0 = pdg2025_alpha_qed_scale_0

  real(dp), parameter, public :: e_dn2 = (one/three)**2
  real(dp), parameter, public :: e_up2 = (two/three)**2

  
  integer, parameter :: n_thresholds = 7

  public :: IQEDThresholdAtQ
  public :: qed_squared_charge
  
  type qed_coupling 
     !private
     real(dp) :: m_light_quarks
     real(dp) :: mc, mb, mt
     integer  :: n_thresholds
     integer  :: nflav(3, 0:n_thresholds) ! first index: 1 = nleptons, 2=ndown, 3=nup
     real(dp) :: thresholds(0:n_thresholds+1)  !
     real(dp) :: b0_values(n_thresholds)
     real(dp) :: alpha_values(n_thresholds)
  end type qed_coupling
  public :: qed_coupling


  ! bring these under one interface to maintain backwards compatibility
  ! but also incorporate a more sensible new interface
  interface InitQEDCoupling
    module procedure  InitQEDCoupling_old, InitQEDCoupling_new
  end interface InitQEDCoupling
  public :: InitQEDCoupling

  interface Value
     module procedure  QEDCouplingValue
  end interface Value
  public :: Value

  interface Delete
     module procedure  DeleteQEDCoupling 
  end interface
  public :: Delete

contains

!----------------------------------------------------------------------
!! Initialises a QED coupling. New interface, which explicitly includes
!! the effective light quark mass, which can be tuned to reproduce the
!! correct high-scale QED behaviour
subroutine InitQEDCoupling_new(coupling, m_light_quarks, m_heavy_quarks, value_at_scale_0)
    use assertions
    type(qed_coupling), intent(out) :: coupling
    real(dp),           intent(in)  :: m_light_quarks, m_heavy_quarks(4:6)
    real(dp), optional, intent(in)  :: value_at_scale_0 ! defaults to alpha_qed_scale_0
    !--------------------------------------------
    real(dp) :: mc, mb, mt
    integer :: i
    
    mc = m_heavy_quarks(4)
    mb = m_heavy_quarks(5)
    mt = m_heavy_quarks(6)
    
    if (mc > m_tau) call wae_error("InitQEDCoupling", "mc > m_tau, but that is not currently supported")
    !if (m_light_quarks < m_muon) call wae_error("InitQEDCoupling", "m_light_quarks < m_muon, but that is not currently supported")
    if (m_light_quarks > mc) call wae_error("InitQEDCoupling", "m_light_quarks > mc, but that is not physical (or supported)")

    coupling%n_thresholds = n_thresholds
    
    ! set up the thresholds
    coupling%thresholds(0) = zero
    coupling%thresholds(1) = m_electron
    if (m_light_quarks >= m_muon) then
      coupling%thresholds(2) = m_muon
      coupling%thresholds(3) = m_light_quarks
    else
      coupling%thresholds(2) = m_light_quarks
      coupling%thresholds(3) = m_muon
    end if
    coupling%thresholds(4) = mc
    coupling%thresholds(5) = m_tau
    coupling%thresholds(6) = mb
    coupling%thresholds(7) = mt
    coupling%thresholds(8) = 1e200_dp

    ! set up the numbers of flavours just above each threshold
    !                       nlept  ndown  nup
    coupling%nflav(:,0) = (/   0,    0,    0 /)
    coupling%nflav(:,1) = (/   1,    0,    0 /)
    if (m_light_quarks >= m_muon) then
      coupling%nflav(:,2) = (/   2,    0,    0 /)
      coupling%nflav(:,3) = (/   2,    2,    1 /)
    else
      coupling%nflav(:,2) = (/   1,    2,    1 /)
      coupling%nflav(:,3) = (/   2,    2,    1 /)
    end if
    coupling%nflav(:,4) = (/   2,    2,    2 /)
    coupling%nflav(:,5) = (/   3,    2,    2 /)
    coupling%nflav(:,6) = (/   3,    3,    2 /)
    coupling%nflav(:,7) = (/   3,    3,    3 /)

    ! set up the b0 values by first setting the squared charges
    do i = 1, n_thresholds
       coupling%b0_values(i) = qed_squared_charge(coupling%nflav(1,i),&
            &                                     coupling%nflav(2,i),&
            &                                     coupling%nflav(3,i))
    end do
    ! then include the normalisation
    coupling%b0_values = -two/(6*pi) * coupling%b0_values

    ! finally set up the alpha values at the threshold
    coupling%alpha_values(1) = default_or_opt(alpha_qed_scale_0, value_at_scale_0)
    do i = 2, n_thresholds
       coupling%alpha_values(i) = coupling%alpha_values(i-1)/&
            &  (1 + coupling%b0_values(i-1) * coupling%alpha_values(i-1) &
            &        * two*log(coupling%thresholds(i)/coupling%thresholds(i-1)))
    end do
  end subroutine InitQEDCoupling_new

  !----------------------------------------------------------------------
  !! Initialises a QED coupling. This interface is deprecated because it
  !! uses a default fairly large value for the effective light quark masses,
  !! resulting in a QED coupling that is about 1% too large at mZ
  subroutine InitQEDCoupling_old(coupling, mc, mb, mt, value_at_scale_0)
    type(qed_coupling), intent(out) :: coupling
    real(dp),           intent(in)  :: mc, mb, mt
    real(dp), optional, intent(in)  :: value_at_scale_0 ! defaults to alpha_qed_scale_0
    call InitQEDCoupling_new(coupling, m_light_quarks_default, (/mc,mb,mt/), value_at_scale_0)
  end subroutine InitQEDCoupling_old
      

  !----------------------------------------------------------------------
  !! returns the qed squared charge, including colour factors
  function qed_squared_charge(nleptons, ndown, nup) result(e2sum)
    real(dp)            :: e2sum
    integer, intent(in) :: nleptons, ndown, nup
    e2sum = nleptons + ca * (nup*e_up2 + ndown * e_dn2)
  end function qed_squared_charge
  
  !----------------------------------------------------------------------
  !! returns which threshold we are dealing with at a given scale
  !! (linear time in the number of thresholds, i.e. not super optimal...)
  function IQEDThresholdAtQ(coupling, mu)
    integer :: IQEDThresholdAtQ
    type(qed_coupling), intent(in) :: coupling
    real(dp)          , intent(in) :: mu
    !------------------------------
    integer i

    IQEDThresholdAtQ = 0
    do i = 1, n_thresholds
       if (mu < coupling%thresholds(i)) exit
       IQEDThresholdAtQ = i
    end do
  end function IQEDThresholdAtQ

  !----------------------------------------------------------------------
  !! 
  function QEDCouplingValue(coupling, mu)
    real(dp)                       :: QEDCouplingValue
    type(qed_coupling), intent(in) :: coupling
    real(dp)          , intent(in) :: mu
    !----------------------------------
    integer :: i

    i = IQEDThresholdAtQ(coupling,mu)
    if (i == 0) then
       ! coupling is frozen below the electron mass
       QEDCouplingValue = coupling%alpha_values(1)
    else
       ! run it from the threshold below
       QEDCouplingValue = coupling%alpha_values(i)/&
            &  (1 + coupling%b0_values(i) * coupling%alpha_values(i) &
            &        * two*log(mu/coupling%thresholds(i)))
    end if
  end function QEDCouplingValue

  !----------------------------------------------------------------------
  subroutine DeleteQEDCoupling(coupling)
    type(qed_coupling), intent(in) :: coupling
    ! this routine does nothing but is there for consistency with
    ! interfaces to other objects
  end subroutine DeleteQEDCoupling
  
end module qed_coupling_module

!!$program astest
!!$  use types; use consts_dp
!!$  use qcd_coupling
!!$  implicit none
!!$  integer  :: i
!!$  real(dp) :: Q
!!$
!!$  call InitRunningCoupling(alfas=0.118_dp,nloop=2)
!!$  do i = 0,100
!!$     Q = 91.2_dp**(i/100.0_dp)
!!$     write(6,*) Q, Value(Q)
!!$  end do
!!$  
!!$end program astest

!======================================================================
!
! Program for preparing info for accuracy tests and for carrying out
! timing tests.
!
! A high-accuracy reference grid as used in the documentation can be
! prepared with the instructions
!
!  ./prec_and_timing -outputgrid -nxQ 5000 -nopreev -nloop 3 -dy 0.025 -o refgrid.dat
!
! Fig. 2 and fig.3(left) of the doc can be obtained by comparing
! this with the output from 
!
!   ./prec_and_timing -nrep 1 -nxQ 5000 -outputgrid -dy 0.2 -nopreev -o testgrid.dat
!
! To compare the outputs, use the command
!
!   ./compare2files_v2 testgrid.dat refgrid.dat -channel 11 [-protect]
!
! Other options of interest in prec_and_timing include
!   -eps [1e-7]       precision of adaptive integration for preparing split.fn.
!   -asdt [0.2]       step for evolution of alpha_s
!   -exact-nnlo-sp    use exact 3-loop split-fns
!   -exact-nnlo-th    use exact 3-loop mass thresholds
!
! BEWARE: older copies of executables have ymax=5 and Qmax=100(?). Explicitly
!         specify -ymax 11.5 and -Qmax 1e4 to get sensible timings.
!
! NB: hoppet v1 used the following command for the test grid
!
!   ./prec_and_timing -nrep 1 -nxQ 5000 -outputgrid -dy 0.2 -order -6 \
!                     -nopreev -4grids -dlnlnQ 0.05 -du 0.4 -olnlnQ 4 -o testgrid.dat
!
! LHAPDF output
! -------------
! This code can also produce an LHAPDF output file, for example, assuming
! your LHAPDF sets are kept in ~/LHAPDF, then the following will produce a dummy
! set corresponding to the standard Les Houches PDF benchmark
!
! ./benchmarking/prec_and_timing  -nloop 3 -dy 0.05 -lhapdf-out ~/LHAPDF/dummy/dummy -o ~/LHAPDF/dummy/hoppet.log
!
program prec_and_timing
  use hoppet
  use hoppet_git_state
  use pdfs_for_benchmarks
  use io_utils
  use NameSelect

  implicit none
  !-------------------------------
  type(grid_def)     :: grid, gridarray(4)
  type(dglap_holder) :: dh
  type(running_coupling) :: coupling
  real(dp), allocatable  :: yvals(:), Qvals(:)
  integer            :: order, order1, order2, nloop, i, j, nrep, nrep_orig, nxQ,olnlnQ
  integer            :: nrep_eval, n_alphas, ny, nQ, nrep_interp
  integer            :: hires
  real(dp)           :: dy, Qinit, Qmin, Qmax, du, dlnlnQ
  real(dp)           :: ymax, pdfval(-6:6)
  real(dp)           :: time_start, time_init_done, time_prev_done, time_ev_done, time_interp_start, time_end
  real(dp), pointer  :: initial_condition(:,:)
  type(pdf_table)    :: table
  logical            :: output, outputgrid, output_benchmark, preev, auto_nrep
  logical            :: write_lhapdf
  character(len=999) :: lhapdf_out = ""
  integer            :: idev, y_interp_order
  integer, parameter :: lhapdf_unit = 99
  integer            :: lhapdf_iyinc
  character(len=300) :: hostname

  idev = idev_open_opt("-o","/dev/stdout")    ! output file (required)

  ! set the details of the y=ln1/x grid
  dy    = dble_val_opt('-dy',0.10_dp)         ! grid spacing in y = ln(1/x)
  ymax  = dble_val_opt('-ymax',12.0_dp)       ! maximum y = ln(1/x)
  order = int_val_opt('-order',-6)            ! interpolation order for splitting-function rep
  dlnlnQ = dble_val_opt('-dlnlnQ',dy/4.0_dp)  ! table spacing in ln(ln(Q))
  olnlnQ = int_val_opt('-olnlnQ',4)           ! table interpolation order for ln(ln(Q))
  y_interp_order = int_val_opt('-yinterp-order',-1) ! table interpolation order for y
  Qmax = dble_val_opt('-Qmax',1e4_dp)

  du = dble_val_opt('-du',0.1_dp) ! evolution step, overriden by dlnlnQ

  order2 = int_val_opt('-order2',order) ! override interp order for finest grid
  order1 = int_val_opt('-order1',order) ! override interp order for finest second grid

  preev = log_val_opt('-preev',.true.)        ! use pre-evolution (cached evolution)

  lhapdf_out = string_val_opt("-lhapdf-out","") ! write out an LHAPDF file
  lhapdf_iyinc = int_val_opt("-lhapdf-iyinc",1)

  if (log_val_opt('-eps')) call SetDefaultConvolutionEps(dble_val_opt('-eps')) ! precision for split.fn. adaptive integration 
  if (log_val_opt('-asdt')) call SetDefaultCouplingDt(dble_val_opt('-asdt')) ! spacing for coupling ev.

  if (log_val_opt('-alt7')) then
    call InitGridDef(gridarray(3),dy/7.0_dp, 1.0_dp, order=order2)
    call InitGridDef(gridarray(2),dy/2.0_dp, 3.0_dp, order=order1)
    call InitGridDef(gridarray(1),dy,        ymax, order=order)
    call InitGridDef(grid,gridarray(1:3),locked=.true.)
  else if (log_val_opt('-4grids')) then
    call InitGridDef(gridarray(4),dy/27.0_dp, 0.2_dp, order=order2)
    call InitGridDef(gridarray(3),dy/9.0_dp, 0.5_dp, order=order1)
    call InitGridDef(gridarray(2),dy/3.0_dp, 2.0_dp, order=order )
    call InitGridDef(gridarray(1),dy,        ymax,   order=order )
    call InitGridDef(grid,gridarray(1:4),locked=.true.)
  else if (log_val_opt('-4grids-wider')) then
    call InitGridDef(gridarray(4),dy/27.0_dp, 0.24_dp, order=order2)
    call InitGridDef(gridarray(3),dy/9.0_dp, 0.6_dp, order=order1)
    call InitGridDef(gridarray(2),dy/3.0_dp, 2.4_dp, order=order )
    call InitGridDef(gridarray(1),dy,        ymax,   order=order )
    call InitGridDef(grid,gridarray(1:4),locked=.true.)
  else if (log_val_opt('-3grids')) then
    hires = int_val_opt('-hires',9)
    call InitGridDef(gridarray(3),dy/hires, 0.5_dp, order=order2)
    call InitGridDef(gridarray(2),dy/3.0_dp, 2.0_dp, order=order1)
    call InitGridDef(gridarray(1),dy,        ymax,   order=order )
    call InitGridDef(grid,gridarray(1:3),locked=.true.)
  else 
    if (order1 /= order .or. order2 /= order) then
       call wae_error("order1 and order2 != order not suppoed with default grid")
    end if
    ! this is like 4 grids and is the standard, without control over order1 and order2
    call InitGridDefDefault(grid, dy, ymax, order=order)
  end if
  ! set parameter for evolution step in Q
  call SetDefaultEvolutionDu(du)


  ! set up the splitting functions
  nloop = int_val_opt('-nloop',3)
  if (log_val_opt('-exact-nnlo-th')) &
       &   call dglap_Set_nnlo_nfthreshold(nnlo_nfthreshold_exact)
  if (log_val_opt('-exact-nnlo-sp')) &
       &   call dglap_Set_nnlo_splitting(nnlo_splitting_exact)
 

  ! decide how many repetitions, and what form of output
  n_alphas = int_val_opt("-n-alphas",1)
  nrep  = int_val_opt('-nrep',1)
  auto_nrep = log_val_opt('-auto-nrep',.false.)
  nrep_eval = int_val_opt('-nrep-eval',10)
  nrep_interp = int_val_opt('-nrep-interp',1000)
  nxQ = int_val_opt('-nxQ',0)
  output = log_val_opt('-output') .or. log_val_opt('-outputgrid')
  outputgrid  = log_val_opt('-outputgrid')
  output_benchmark = log_val_opt('-output-benchmark')
  !-- security ----------------------
  if (.not. CheckAllArgsUsed(0)) error stop
  !----------------------------------

  if (output .or. trim(lhapdf_out) /= "") call output_info
  write(idev,'(a)',advance='no') "# "
  call time_stamp(idev)
  call get_hostname(hostname)  
  write(idev,'(a)') "# host: "//trim(hostname)
  call hoppet_print_git_state(idev,prefix="#")

  call cpu_time(time_start)
  call InitDglapHolder(grid, dh, factscheme=factscheme_MSbar, &
       &                              nloop=nloop, nflo=3, nfhi=6)
  call cpu_time(time_init_done)


  ! first way to get the initial distribution
  !call AllocInitPDFSub(grid,vogt_init,VogtInitSub)
  ! alternative way to get the initial distribution
  call AllocPDF(grid,initial_condition)
  initial_condition = benchmark_pdf_unpolarized(xValues(grid))

  ! set up the coupling
  Qinit = sqrt(two)
  Qmin = one
  do i = 1, n_alphas 
     if (i /= 1) call Delete(coupling)
     call InitRunningCoupling(coupling, alfas=0.35_dp, Q=Qinit, &
          &nloop=nloop)
  end do
  !AV commented out because it is an error in non-GNU compilers 
  !write(0,*) Value(coupling,91.2d0)

  ! set up the table
  call AllocPdfTable(grid,table,Qmin,Qmax,dlnlnQ,lnlnQ_order=olnlnQ)
  call AddNfInfoToPdfTable(table,coupling)
  if (preev) call PreEvolvePdfTable(table,Qinit,dh,coupling)
  call cpu_time(time_prev_done)

  !call PDFTableSetYInterpOrder(y_interp_order)
  if (y_interp_order > 0 .and. olnlnQ >0) then
    call PdfTableOverrideInterpOrders(y_interp_order,olnlnQ)
  end if

  ! record info about the cpu
  !call system("grep -e name -e cache -e MHz /proc/cpuinfo | sed 's/^/# /'")

  ! evolution & output
  do i = 1, nrep
     if (preev) then
        call EvolvePdfTable(table,initial_condition)
     else
        call EvolvePdfTable(table,Qinit,initial_condition,dh,coupling)
     end if     
  end do
  call cpu_time(time_ev_done)

  ! auto-timing refinement of nrep
  if (auto_nrep .and. time_ev_done-time_prev_done < 0.05_dp) then
     nrep_orig = nrep
     nrep = 0.1_dp / ((time_ev_done-time_prev_done)/nrep_orig)
     do i = nrep_orig+1, nrep
        if (preev) then
           call EvolvePdfTable(table,initial_condition)
        else
           call EvolvePdfTable(table,Qinit,initial_condition,dh,coupling)
        end if     
     end do
     call cpu_time(time_ev_done)
  end if

  ! Here we compute a list of y and Q values to use when interpolating
  ! the grid. We use ceiling(sqrt(nrep)) points in each direction.
  ny = nint(sqrt(four*nrep_interp))
  nQ = nint(sqrt(0.25_dp*nrep_interp))-1
  if (ny > 0) then
    ALLOCATE(yvals(ny))
    do i = 1, ny
       yvals(i) = i*ymax/ny
    end do
  end if 
  if (nQ > 0) then
    ALLOCATE(Qvals(nQ))
    do i = 1, nQ
       Qvals(i) = Qinit + i*(Qmax-Qinit)/nQ
    end do
  end if

  call cpu_time(time_interp_start)
  do i = 1, ny
     do j = 1, nQ
        call EvalPdfTable_yQ(table,yvals(i),Qvals(j),pdfval)
     end do
  end do
  call cpu_time(time_end)

  if (output_benchmark) then
    call write_benchmark_output()
  end if

  ! one form of output
  if (outputgrid) then
     call eval_output_grid()
  else
     call eval_output_lines()
  end if

  write(6,'(a,4f16.11," s, nrep=",i7, ", nrep_interp=", i7)') "Timings (init, preevln, evln, interp) = ", &
       &   time_init_done-time_start, &
       &   time_prev_done-time_init_done, &
       &   (time_ev_done-time_prev_done)/nrep, &
       &   (time_end - time_interp_start)/ny/nQ, nrep , nrep_interp
  if (output) write(idev,'(a,4f16.11," s, nrep=",i7, ", nrep_interp=", i7)') "# Init Timings (init, preevln, evln, interp) = ", &
       &   time_init_done-time_start, &
       &   time_prev_done-time_init_done, &
       &   (time_ev_done-time_prev_done)/nrep,  &
       &   (time_end - time_interp_start)/ny/nQ, nrep, nrep_interp
  write(idev,'(a,f10.5," s")') "# Initialisation time = ", time_init_done-time_start
  write(idev,'(a,f10.5," s")') "# Pre-evolution time = ", time_prev_done-time_init_done
  write(idev,'(a,f10.5," s, nrep = ",i7)') "# Evolution time = ", (time_ev_done-time_prev_done)/nrep, nrep
  write(idev,'(a,f10.5," ns, nrep_interp =", i7)') "# Interpolation time = ", (time_end - time_interp_start)/ny/nQ*1d9, nrep_interp

  !call get_evaluation_times()
  call get_evaluation_times_new()

  if (trim(lhapdf_out) /= "") then
    call WriteLHAPDFFromPdfTable(table, coupling, lhapdf_out, &
           pdf_index = 0, iy_increment = lhapdf_iyinc)
  end if


  ! clean up
  call Delete(table)
  call Delete(initial_condition)  ! here can also use deallocate(vogt_init)
  call Delete(dh)
  call Delete(coupling)
  call Delete(grid)
  call Delete(gridarray)

contains

  !---------------------------------------------------------------
  !! some basic commentary
  subroutine output_info
    write(idev,'(a)') '# '//trim(command_line())
    write(idev,'(a)') '# Grid properties:'
    write(idev,'(a,4f10.6)')  '# dymax = ', maxval(grid%subgd(:)%dy)
    write(idev,'(a,4i10)')    '# dnsty = ', nint(maxval(grid%subgd(:)%dy)/grid%subgd(:)%dy)
    write(idev,'(a,4f10.6)')  '# ymax  = ', grid%subgd(:)%ymax
    write(idev,'(a,4i10)'  )  '# order = ', grid%subgd(:)%order
    write(idev,'(a,4es10.2)') '# eps   = ', grid%subgd(:)%eps
    
    write(idev,'(a,f10.5,a,f10.5)') '# Evolution: du = ',du, ",   coupling dt = ", DefaultCouplingDt()
    write(idev,'(a,f10.5,a,i5)') '# Tabulation: dlnlnQ = ',dlnlnQ, ', olnlnQ = ',olnlnQ

    if (nloop >= 3) then
       write(idev,'(a)') '# nnlo_spltting = '//trim(NameOfCode(nnlo_splitting_variant,'nnlo_splitting'))
    else   
       write(idev,'(a)') '# nnlo_spltting = N/A'
    end if
    if (nloop >= 4) then
       !write(idev,'(a)') '# n3lo_spltting = '//trim(NameOfCode(n3lo_splitting_variant,'n3lo_splitting'))
      write(idev,'(a)') '# n3lo_spltting = '// &
      &       trim(NameOfCode(n3lo_splitting_variant,'n3lo_splitting'))
      write(idev,'(a)') '# n3lo_spltting_approx = '// &
      &       trim(NameOfCode(n3lo_splitting_approximation,'n3lo_splitting_approx'))
    else 
      write(idev,'(a)') '# n3lo_spltting = N/A'
      write(idev,'(a)') '# n3lo_spltting_approx = N/A'
    end if
  end subroutine output_info


  !-------------------------------------------------------------------
  !! output 4 lines in the y,Q plane, each with Q relating to y in a different
  !! way
  subroutine eval_output_lines()
    integer nn, j
    real(dp) :: y, Q, pdfval(-6:6)
    character(len=*), parameter :: header = "# y=ln1/x Q xf(x,0:4)"
    if (.not. output) return

    nn = nxQ/4
    write(idev,'(a)') "# Q = Qmax - j*(Qmax-Qinit)/nn"
    write(idev,'(a)') header
    do j = 1, nn
       y = j*ymax/nn
       Q = Qmax - j*(Qmax-Qinit)/nn
       call EvalPdfTable_yQ(table,y,Q,pdfval)
       write(idev,'(20es20.10)') y,Q,pdfval(0:4)
       !if (output .and. i==1) write(idev,'(20es20.8)') y,Q,vogt_init(:,0:3).atx.(grid.with.exp(-y))
    end do

    write(idev,*)
    write(idev,*)
    write(idev,'(a)') "# Q = 4.0_dp + j*5.0_dp/nn"
    write(idev,'(a)') header
    do j = nn,1,-1
       y = j*ymax/nn
       Q = 4.0_dp + j*5.0_dp/nn
       call EvalPdfTable_yQ(table,y,Q,pdfval) 
       write(idev,'(20es20.10)') y,Q,pdfval(0:4)
    end do

    write(idev,*)
    write(idev,*)
    write(idev,'(a)') "# Q = Qmax*(1-j*0.2_dp/nn)"
    write(idev,'(a)') header
    do j = nn,1,-1
       y = j*ymax/nn
       Q = Qmax*(1-j*0.2_dp/nn)
       call EvalPdfTable_yQ(table,y,Q,pdfval) 
       write(idev,'(20es20.10)') y,Q,pdfval(0:4)
    end do

    write(idev,*)
    write(idev,*)
    write(idev,'(a)') "# Q = sqrt(Qinit*Qmax)*(1+j*0.2_dp/nn)"
    write(idev,'(a)') header
    do j = nn,1,-1
       y = j*ymax/nn
       Q = sqrt(Qinit*Qmax)*(1+j*0.2_dp/nn)
       call EvalPdfTable_yQ(table,y,Q,pdfval) 
       write(idev,'(20es20.10)') y,Q,pdfval(0:4)
    end do
  end subroutine eval_output_lines


  !----------------------------------------------------------------
  !! output the results on a grid uniform in 
  !! zeta = ln 1/x + grid_a*(1-x)
  subroutine eval_output_grid()
    integer  :: nz, nQ, iz, iQ
    real(dp) :: zmax, zeta, y, Q, zQ, zQmax, pdfval(-6:6)
    real(dp), parameter :: grid_a = 9, gridQ_a = 3

    nz = nint(sqrt(four*nxQ))
    nQ = nint(sqrt(0.25_dp*nxQ))-1

    zmax = zeta_of_y(ymax, grid_a)
    zQmax = zeta_of_y(log(Qmax/Qinit), gridQ_a)
    write(6,*) 'nQ = ', nQ, ' nz = ', nz
    write(idev,'(a)') "# y=ln1/x Q pdf(-5:5)"
    do iQ = 0, nQ
       do iz = 1, nz
          zeta = iz * zmax/nz
          y    = y_of_zeta(zeta, grid_a)
          zQ = (iQ+zeta/zmax) * zQmax / nQ
          Q = max(Qinit,min(Qmax,Qinit * exp(y_of_zeta(zQ, gridQ_a))))
          call EvalPdfTable_yQ(table,y,Q,pdfval) 
          write(idev,'(20es20.10)') y,Q,pdfval(-5:5)
       end do
       write(idev,'(a)') 
    end do
    
  end subroutine eval_output_grid
  

  
  !-----------------------------------------------------------------
  !! return zeta = ln 1/x + a*(1-x)  (x = exp(-y))
  pure function zeta_of_y(y, a) result(zeta)
    real(dp), intent(in) :: y, a
    real(dp)             :: zeta
    zeta = y + a*(one - exp(-y))
  end function zeta_of_y

  
  !-----------------------------------------------------------------
  !! return inversion of zeta = ln 1/x + a*(1-x)  (x = exp(-y))
  function y_of_zeta(zeta, a) result(y)
    real(dp), intent(in) :: zeta, a
    real(dp)             :: y, x, diff_from_zero, deriv
    integer             :: iter
    real(dp), parameter :: eps = 1e-12_dp
    integer,  parameter :: maxiter = 100

    ! starting condition (and soln if a = 0)
    y = zeta 
    if (a /= zero) then
       do iter = 0, maxiter
          x = exp(-y);
          diff_from_zero = zeta - y - a*(one-x);
          ! we have found good solution
          if (abs(diff_from_zero) < eps) exit
          deriv = -one  - a*x;
          y = y - diff_from_zero / deriv;
       end do
    end if
    
    if (iter > maxiter) write(0,*) "y_of_zeta reached maxiter"

  end function y_of_zeta
  

  !-----------------------------------------------------------------
  !! new (2025) routine for getting evaluation times, which uses a table
  !! of y,Q values, to reduce the likelihood of being biased by some
  !! special case.
  subroutine get_evaluation_times_new()
    real(dp) :: pdf_g, pdf_g_sum, pdf_all(-6:6), pdf_sum(-6:6)
    integer, parameter :: n = 100
    real(dp) :: yvals(n), Qvals(n), y, Q
    integer :: i, irep, iQ, iy, nvals
    character(len=*), parameter :: fmt = '(a,f6.1," ",a)'

    ! set up the y and Q values
    do i = 1, n
      yvals(i) = i*ymax/n
      Qvals(i) = Qinit + i*(Qmax-Qinit)/n
    end do

    ! then loop over 
    pdf_sum = zero
    call cpu_time(time_start)
    do irep = 1, nrep_eval
      do iQ = 1, n
        Q = Qvals(iQ)
        do iy = 1, n
          y = yvals(iy)
          call EvalPdfTable_yQ(table,y,Q,pdf_all)
          pdf_sum = pdf_sum + pdf_all ! prevent compiler from optimising this out
        end do
      end do
    end do
    call cpu_time(time_end)
    write(idev,fmt) "# Evaluation (all flav)", (time_end-time_start)/(nrep_eval*n**2)*1e9_dp, "ns"
    write(0   ,fmt) "# Evaluation (all flav)", (time_end-time_start)/(nrep_eval*n**2)*1e9_dp, "ns"

    ! then loop over 
    pdf_sum = zero
    call cpu_time(time_start)
    do irep = 1, nrep_eval
      do iQ = 1, n
        Q = Qvals(iQ)
        do iy = 1, n
          y = yvals(iy)
          call EvalPdfTable_yQ_order22(table,y,Q,pdf_all)
          pdf_sum = pdf_sum + pdf_all ! prevent compiler from optimising this out
        end do
      end do
    end do
    call cpu_time(time_end)
    write(idev,fmt) "# Evaluation (all flav,o2)", (time_end-time_start)/(nrep_eval*n**2)*1e9_dp, "ns"
    write(0   ,fmt) "# Evaluation (all flav,o2)", (time_end-time_start)/(nrep_eval*n**2)*1e9_dp, "ns"
    
    ! then loop over 
    pdf_sum = zero
    call cpu_time(time_start)
    do irep = 1, nrep_eval
      do iQ = 1, n
        Q = Qvals(iQ)
        do iy = 1, n
          y = yvals(iy)
          call EvalPdfTable_yQ_order33(table,y,Q,pdf_all)
          pdf_sum = pdf_sum + pdf_all ! prevent compiler from optimising this out
        end do
      end do
    end do
    call cpu_time(time_end)
    write(idev,fmt) "# Evaluation (all flav,o3)", (time_end-time_start)/(nrep_eval*n**2)*1e9_dp, "ns"
    write(0   ,fmt) "# Evaluation (all flav,o3)", (time_end-time_start)/(nrep_eval*n**2)*1e9_dp, "ns"
    
    ! then loop over 
    pdf_sum = zero
    call cpu_time(time_start)
    do irep = 1, nrep_eval
      do iQ = 1, n
        Q = Qvals(iQ)
        do iy = 1, n
          y = yvals(iy)
          call EvalPdfTable_yQ_order44(table,y,Q,pdf_all)
          pdf_sum = pdf_sum + pdf_all ! prevent compiler from optimising this out
        end do
      end do
    end do
    call cpu_time(time_end)
    write(idev,fmt) "# Evaluation (all flav,o4)", (time_end-time_start)/(nrep_eval*n**2)*1e9_dp, "ns"
    write(0   ,fmt) "# Evaluation (all flav,o4)", (time_end-time_start)/(nrep_eval*n**2)*1e9_dp, "ns"


    call cpu_time(time_start)
    pdf_g_sum = zero
    do irep = 1, nrep_eval
      do iQ = 1, n
        Q = Qvals(iQ)
        do iy = 1, n
          y = yvals(iy)
          pdf_g_sum = pdf_g_sum + EvalPdfTable_yQf(table,y,Q,0)
          !call EvalPdfTable_yQ(table,y,Q,pdf_all)
          !pdf_sum = pdf_sum + pdf_all ! prevent compiler from optimising this out
        end do
      end do
    end do
    !do i = 1, nrep_eval
    !  pdf_g_sum = pdf_g_sum + EvalPdfTable_yQf(table,y,Q,0)
    !end do  
    call cpu_time(time_end)
    write(idev,fmt) "# Evaluation (one flav)", (time_end-time_start)/(nrep_eval*n**2)*1e9_dp, "ns"
    write(0   ,fmt) "# Evaluation (one flav)", (time_end-time_start)/(nrep_eval*n**2)*1e9_dp, "ns"


    call cpu_time(time_start)
    pdf_g_sum = zero
    do irep = 1, nrep_eval
      do iQ = 1, n
        Q = Qvals(iQ)
        do iy = 1, n
          y = yvals(iy)
          pdf_g_sum = pdf_g_sum + EvalPdfTable_yQf_order22(table,y,Q,0)
          !call EvalPdfTable_yQ(table,y,Q,pdf_all)
          !pdf_sum = pdf_sum + pdf_all ! prevent compiler from optimising this out
        end do
      end do
    end do
    call cpu_time(time_end)
    write(idev,fmt) "# Evaluation (1fl,ord2)", (time_end-time_start)/(nrep_eval*n**2)*1e9_dp, "ns"
    write(0   ,fmt) "# Evaluation (1fl,ord2)", (time_end-time_start)/(nrep_eval*n**2)*1e9_dp, "ns"

  end subroutine get_evaluation_times_new


  ! old routine for getting evaluation times, which uses just a single y,Q combination
  subroutine get_evaluation_times()
    real(dp) :: pdf_g, pdf_g_sum, pdf_all(-6:6), pdf_sum(-6:6)
    real(dp) :: y = 0.5d0, Q = 10.0d0
    character(len=*), parameter :: fmt = '(a,f6.1," ",a)'
    call cpu_time(time_start)
    pdf_sum = zero
    do i = 1, nrep_eval
      call EvalPdfTable_yQ(table,y,Q,pdf_all)
      pdf_sum = pdf_sum + pdf_all
    end do  
    call cpu_time(time_end)
    write(idev,fmt) "# Evaluation (all flav)", (time_end-time_start)/nrep_eval*1e9_dp, "ns"
    write(0   ,fmt) "# Evaluation (all flav)", (time_end-time_start)/nrep_eval*1e9_dp, "ns"

    call cpu_time(time_start)
    pdf_g_sum = zero
    do i = 1, nrep_eval
      pdf_g_sum = pdf_g_sum + EvalPdfTable_yQf(table,y,Q,0)
    end do  
    call cpu_time(time_end)
    write(idev,fmt) "# Evaluation (one flav)", (time_end-time_start)/nrep_eval*1e9_dp, "ns"
    write(0   ,fmt) "# Evaluation (one flav)", (time_end-time_start)/nrep_eval*1e9_dp, "ns"

  end subroutine get_evaluation_times

  subroutine write_benchmark_output

    real(dp), parameter :: heralhc_xvals(9) = &
       & (/1e-5_dp,1e-4_dp,1e-3_dp,1e-2_dp,0.1_dp,0.3_dp,0.5_dp,0.7_dp,0.9_dp/)
    integer  :: ix    ! get the value of the tabulation at some point
    real(dp) :: Q, pdf_at_xQ(-6:6)
    Q = 100.0_dp
    write(6,'(a)')
    write(6,'(a,f8.3,a)') "           Evaluating PDFs at Q = ",Q," GeV"
    write(6,'(a5,2a12,a14,a10,a12)') "x",&
         & "u-ubar","d-dbar","2(ubr+dbr)","c+cbar","gluon"
    do ix = 1, size(heralhc_xvals)
      call EvalPdfTable_xQ(table,heralhc_xvals(ix),Q,pdf_at_xQ)
      write(6,'(es7.1,5es12.4)') heralhc_xvals(ix), &
            &  pdf_at_xQ(2)-pdf_at_xQ(-2), &
            &  pdf_at_xQ(1)-pdf_at_xQ(-1), &
            &  2*(pdf_at_xQ(-1)+pdf_at_xQ(-2)), &
            &  (pdf_at_xQ(-4)+pdf_at_xQ(4)), &
            &  pdf_at_xQ(0)
    end do
  end subroutine write_benchmark_output
end program prec_and_timing

! $Id: qcd.f90,v 1.13 2004/09/18 14:39:29 salam Exp $
module qcd
  use types; use consts_dp

  integer,  parameter :: nf_def = 5
  real(dp), parameter :: ca_def = 3, cf_def = four/three, tr_def = half
  real(dp), parameter :: tf_def = tr_def * nf_def

  !-- the following are all modifiable, but have default values
  real(dp), public :: ca = ca_def
  real(dp), public :: cf = cf_def
  real(dp), public :: tr = tr_def

  integer,  public :: nf_int = nf_def
  integer,  public :: nf_u = nf_def/2
  integer,  public :: nf_d = (nf_def+1)/2
  real(dp), public :: nf = nf_def, tf = tf_def
  ! HACK TO GET GLUON + SINGLET EVOLUTION in 0 & 1
  ! For it to work, quark component in 2 must be zero.
  !integer, parameter, public :: nf_u = nf_def, nf_d = 0

  ! beta2 is from Tarasov JINR P2-82-900 (Dubna 1982)
  ! Larin & Vermaseren NIKHEF-H/92-17 hep-ph/9302208
  real(dp), public :: beta0 = (11*ca_def - four*tf_def)/(12*pi)
  real(dp), public :: twopi_beta0 = (11*ca_def - four*tf_def)/6.0_dp
  real(dp), public :: beta1 = (17*ca_def**2 - tf_def*(10*ca_def + 6*cf_def))&
       &                        / (24*pisq)
  real(dp), public :: beta2 = (2857*ca_def**3  &
       & + (54*cf_def**2-615*cf_def*ca_def-1415*ca_def**2)*two*tf_def&
       & + (66*cf_def + 79*ca_def)*(two*tf_def)**2)/(3456*pi**3)

  ! beta3 taken from RunDec paper (hep-ph/0004189v1). Note that there is
  ! no control over the colour factors in this expression
  real(dp), public :: beta3 =  (149753._dp/6._dp + 3564._dp*zeta3 + &
       &        (-1078361._dp/162._dp-6508._dp/27._dp*zeta3) * nf_def + &
       &        (50065._dp/162._dp+6472._dp/81._dp*zeta3) * nf_def**2 + &
       &        1093._dp/729._dp * nf_def**3)/256._dp/pi**4

  !--- nomenclature is: 
  !  alpha_s(nf+1,mu) = alpha_s(nf,mu) + 
  !               sum_{mn} alphastep_mn * (alphas)^(m+1) ln^n(mu^2/m(mu^2)^2)
  !
  ! taken from hep-ph/9411260; should also refer to 
  ! Bernreuther, Wetzel, NPB197 (1982) 228
  ! Bernreuther, Annals of Phys. 151 (1983) 127
  !
  ! Only use this if (mass_steps_on)?
  logical,  public :: mass_steps_on = .true.
  !logical,  public, parameter :: mass_steps_on = .false.
  !---- the following is for the MSbar mass
  ! taken from hep-ph/9411260; should also refer to 
  ! Bernreuther, Wetzel, NPB197 (1982) 228
  ! Bernreuther, Annals of Phys. 151 (1983) 127
  real(dp), public :: alphastep11 = four*tr_def/(12*pi)
  real(dp), public :: alphastep22 = (four*tr_def/(12*pi))**2
  real(dp), public :: alphastep21 = tr_def*(10*ca_def + 6*cf_def)/(24*pisq)
  real(dp), public :: alphastep20_msbar=&
       &(13.0_dp/48.0_dp*cf_def-two/9.0_dp*ca_def) *tr_def/pisq
  !-- for the pole mass, take this from hep-ph/9706430 
  !   (Chetyrkin, Kniehl and Steinhauser), PRL 79 (1997) 2184
  !   though it is not the original referece, just a "container"
  !-- expression not known for variable colour factors?
  !   NB: they express nf-1 in terms of nf...
  real(dp), public :: alphastep20_pole  = &
       &(15.0_dp/16.0_dp*cf_def-two/9.0_dp*ca_def) * tr_def/pisq
  !--All taken from RunDec paper (SI and OS). Full colour dependence
  ! not known. At 3-loop order we also need separate coefficients
  ! for the inverted expressions. cf. Eq 23-25 in the RunDec paper.
  real(dp), public :: alphastep33=&
       &1._dp/216._dp/picb
  real(dp), public :: alphastep32=&
       &131._dp/576._dp/picb
  real(dp), public :: alphastep32_inv=&
       &511._dp/576._dp/picb ! For the inverted expression
  ! SI scheme (MSbar)
  real(dp), public :: alphastep31_msbar=&
       &6793._dp/1728._dp/picb
  real(dp), public :: alphastep31_msbar_inv=&
       &2191._dp/1728._dp/picb ! For the inverted expression
  real(dp), public :: alphastep31_msbar_nl=&
       &281._dp/1728._dp/picb !Multiplies the number of light flavours (nl)
  real(dp), public :: alphastep30_msbar=&
       &(-82043._dp/27648._dp*zeta3 + 564731._dp/124416._dp)/picb
  real(dp), public :: alphastep30_msbar_nl=&
       &-2633._dp/31104._dp/picb !Multiplies the number of light flavours (nl)
  ! OS scheme (pole)  
  real(dp), public :: alphastep31_pole=&
       &8521._dp/1728._dp/picb
  real(dp), public :: alphastep31_pole_inv=&
       &8941._dp/1728._dp/picb ! For the inverted expression
  real(dp), public :: alphastep31_pole_nl=&
       &409._dp/1728._dp/picb !Multiplies the number of light flavours (nl)
  real(dp), public :: alphastep30_pole=&
       &(-80507._dp/27648._dp*zeta3 - 58933._dp/124416._dp&
       &-two/three*zeta2 * (one + one/three*log(two)))/picb
  real(dp), public :: alphastep30_pole_nl=&
       &(2479._dp/31104._dp + zeta2/9._dp)/picb !Multiplies the number of light flavours (nl)
  
  real(dp), public :: cmw_K = ca_def*(67.0_dp/18.0_dp - pisq/6.0_dp) &
       &                      - tf_def * 10.0_dp/9.0_dp
  
  !!!! Taken from Moch, Vermaseren & Vogt: NB TR dependence not in...
  real(dp), parameter :: cmw_K2_def = &
       &  ca_def**2 * ( 245._dp/24._dp - 67._dp/9._dp*zeta2 &
       &             + 11.0_dp/6._dp * zeta3 + 11.0_dp/5._dp * zeta2**2)&
       &+ two*cf_def*tf_def * (-55._dp/24._dp + 2*zeta3)&
       &+ two*ca_def*tf_def * (-209._dp/108._dp + 10._dp/9._dp*zeta2 &
       &                   - 7._dp/3._dp * zeta3)&
       &- four*tf_def**2 /27._dp
  real(dp), public :: cmw_K2  = cmw_K2_def
  real(dp), public :: mvv_A3  = 16*cf_def*cmw_K2_def
  real(dp), public :: mvv_A3G = 16*ca_def*cmw_K2_def


  !--- is it useful to have a fake upper entry?
  ! put charm quark mass just above sqrt(2)
  real(dp), public, parameter :: &
       &        quark_masses_def(6) = (/1e-10_dp,1e-10_dp,0.15_dp,&
       &                           1.414213563_dp, 4.5_dp, 175.0_dp/)


  public :: qcd_SetNf, qcd_SetGroup!, qcd_SetVogtImod
  
contains

  !----------------------------------------------------------------------
  subroutine qcd_SetNf(nf_in)
    integer :: nf_in
    nf_int = nf_in
    nf     = nf_int
    nf_u   = nf_int/2
    nf_d   = (nf_int+1)/2
    tf     = tr * nf
    call qcd_set_beta0
  end subroutine qcd_SetNf
  
  !----------------------------------------------------------------------
  subroutine qcd_SetGroup(ca_in,cf_in,tr_in)
    real(dp), intent(in) :: ca_in,cf_in,tr_in
    ca = ca_in
    cf = cf_in
    tr = tr_in
    tf = nf * tr
    call qcd_set_beta0
  end subroutine qcd_SetGroup

  !----------------------------------------------------------------------
  subroutine qcd_set_beta0
    beta0       = (11*ca - four*tf)/(12*pi)
    twopi_beta0 = twopi * beta0
    beta1       = (17*ca**2 - tf*(10*ca + 6*cf)) / (24*pisq)
    beta2       = (2857*ca**3 + (54*cf**2-615*CF*CA-1415*ca**2)*two*tf&
         &           + (66*cf + 79*ca)*(two*tf)**2)/(3456*pi**3)
    beta3 =  (149753._dp/6._dp + 3564._dp*zeta3 + &
       &        (-1078361._dp/162._dp-6508._dp/27._dp*zeta3) * nf + &
       &        (50065._dp/162._dp+6472._dp/81._dp*zeta3) * nf**2 + &
       &        1093._dp/729._dp * nf**3)/256._dp/pi**4
    !-- matching thresholds -----------------
    alphastep11 = four*tr/(12*pi)
    alphastep22 = (four*tr/(12*pi))**2
    alphastep21 = tr*(10*ca + 6*cf)/(24*pisq)
    alphastep20_msbar = (13.0_dp/48.0_dp*cf-two/9.0_dp*ca)*tr/pisq    
    !  -11.0_dp/72.0_dp/pisq    
    !-- expression not know for variable colour factors
    !alphastep20_pole  = 7.0_dp/24.0_dp/pisq
    alphastep20_pole  = (15.0_dp/16.0_dp*cf-two/9.0_dp*ca)*tr/pisq
    cmw_K       = ca*(67.0_dp/18.0_dp - pisq/6.0_dp) - tf*10.0_dp/9.0_dp
    cmw_K2 = &
       &  ca**2 * ( 245._dp/24._dp - 67._dp/9._dp*zeta2 &
       &             + 11.0_dp/6._dp * zeta3 + 11.0_dp/5._dp * zeta2**2)&
       &+ two*cf*tf * (-55._dp/24._dp + 2*zeta3)&
       &+ two*ca*tf * (-209._dp/108._dp + 10._dp/9._dp*zeta2 &
       &                   - 7._dp/3._dp * zeta3)&
       &- four*tf**2 /27._dp
    mvv_A3  = 16*cf*cmw_K2
    mvv_A3G = 16*ca*cmw_K2
  end subroutine qcd_set_beta0
  
!!$  !-------- overkill ----------------------------------------
!!$  subroutine qcd_SetVogtImod(imod)
!!$    integer, intent(in) :: imod
!!$    vogt_imod = imod
!!$  end subroutine qcd_SetVogtImod
  
end module qcd

!! An example program using structure functions up to N3LO. !!
!!
program structure_functions_example
  use hoppet
  use pdfs_for_benchmarks
  use streamlined_interface
  use structure_functions
  use io_utils, int_value => value
  implicit none
  character (len=400) :: filename,dirname
  real(dp) :: Qmax, Qmin, ymax, Q, mc, mb, mt, asQ0, Q0,&
  & muR_Q, dy, dlnlnQ, minQval, maxQval
  integer  :: order, nloop_max = 4
  real(dp) :: xmur_evolv_vals(3) = (/1.0_dp, 0.5_dp, 2.0_dp/)
  integer  :: ixmur_evolv
  integer  :: idev
  logical  :: vfn = .false.

  idev = idev_open_opt("-o")
  write(idev,'(a,a)') "# ", trim(command_line())
  nloop_max = int_val_opt("-nloop", 4); write(idev,'(a,i4)') "# nloop = ", nloop_max
  Q  = dble_val_opt("-Q", 100.0_dp); write(idev,'(a,f10.4)') "# Q = ", Q
  Q0 = dble_val_opt("-Q0", sqrt(two)) ; write(idev,'(a,f22.16)') "# Q0 = ", Q0
  Qmax = Q
  Qmin = Q0
  asQ0 =dble_val_opt("-asQ0", 0.30_dp); write(idev,'(a,f10.4)') "# asQ0 = ", asQ0

  vfn = log_val_opt("-vfn", .true.); write(idev,'(a,l1)') "# vfn = ", vfn

  if (.not. CheckAllArgsUsed(0)) stop "Unused arguments"


  ! Set heavy flavour scheme
  if (vfn) then
    mc = 1.414213563_dp   ! sqrt(2.0_dp) + epsilon
    mb = 4.5_dp
    mt = 175.0_dp
    call hoppetSetPoleMassVFN(mc, mb, mt)
  else
    call hoppetSetFFN(5)
  end if
  
  ! Streamlined initialization
  ! including  parameters for x-grid
  order = -6 ! interpolation order, not perturbative order in alphas!
  ymax  = 12.0_dp
  dy    = dble_val_opt("-dy",0.05_dp)
  dlnlnQ = dy/4.0_dp
  minQval = Qmin
  maxQval = Qmax 

  ! initialise the grid and dglap holder, using the streamlined
  ! interface for simplicity
  call hoppetStartExtended(ymax,dy,minQval,maxQval,dlnlnQ,nloop_max,&
    &         order,factscheme_MSbar)

  do ixmur_evolv = 1, size(xmur_evolv_vals)
     write(idev,"(a,f10.4)") "# xmuR = ", xmur_evolv_vals(ixmur_evolv)
     call hoppetEvolve(asQ0, Q0, nloop_max, xmur_evolv_vals(ixmur_evolv), benchmark_pdf_unpolarized_lha, Q0)
     call write_pdf(Q, 100)
  end do



contains
  
  ! write the time since the last call to this routine (or since start of the program)
  subroutine write_time()
    implicit none
    real(dp), save :: time, last_time = 0.0_dp
    call cpu_time(time)
    write(6,'(a,f10.4)') "Time since last call: ", time - last_time
    last_time = time
  end subroutine write_time

  !> @brief write the F1 structure function to idev
  !!
  !! Writes the W and Z F1 structure functions to a file with equal spacing in log(x)
  !!
  !! @param[in]     idev     file/device to write to
  !! @param[in]     Qtest    Value of Q to use
  !! @param[in]     ymax     Largest value of y = - log(x) to print
  !! @param[in]     ny       number of bins in y to print
  !!
  subroutine write_pdf(Qtest, ny)
    real(dp), intent(in) :: Qtest
    integer, intent(in)  :: ny
    real(dp) :: ytest, xval, xpdf_at_xQ(-6:6)
    integer  :: iy
    !F1 Wp Wm Z
    write(idev,'(a,f10.4,a,f10.4)') '# Q = ', Qtest
    write(idev,'(a)') '# x pdf(-6:6)'
    
    do iy = ny, 1, -1
       ytest = iy * ymax / ny
       xval = exp(-ytest)
       call hoppetEval(xval,Qtest,xpdf_at_xQ)
       write(idev,'(14es16.8)') xval, xpdf_at_xQ
    end do
    write(idev,*)
    write(idev,*)
  end subroutine write_pdf
  

  
end program structure_functions_example

program test_qed_obj
  use hoppet; use convolution
  use qed_objects
  use qed_coupling_module
  use io_utils
  implicit none
  type(grid_def)     :: grid
  type(qed_split_mat) :: qed_split
  real(dp) :: ymax = 25.0_dp, dy = 0.10_dp
  real(dp), pointer :: pdf(:,:), dpdf(:,:), moments(:)
  integer :: ncompmaxQED = 11 ! 8 without leptons, 11 with leptons
  type(qed_coupling) :: qed_alpha
  
  call InitGridDefDefault(grid, dy, ymax)
  call InitQEDSplitMat(grid, qed_split)
  !call qed_split%SetNf(3,3,2)
  call QEDSplitMatSetNf(qed_split, 3,3,2)
  
  call AllocGridQuant(grid,  pdf, -6, ncompmaxQED)
  call AllocGridQuant(grid, dpdf, -6, ncompmaxQED)
  allocate(moments(ncompmin:ncompmaxQED))
  
  pdf = zero
  pdf(:,ncompmin:ncompmax) = unpolarized_dummy_pdf(xValues(grid))
  pdf(:,8) = (one - xValues(grid))**4
  if (ncompmaxQED >= 9) pdf(:,9) = (one - xValues(grid))**5
  
  dpdf = qed_split%lo * pdf
  moments = TruncatedMoment(grid, dpdf, one)
  write(6,*) '*********** LO QED splitting checks **************'
  write(6,*) '1st moment of dflavours = ', moments
  write(6,*) 'sum of dflavours = ', sum(moments)
  write(6,*)
  moments(1:6) = TruncatedMoment(grid, dpdf(:,1:6)-dpdf(:,-1:-6:-1), zero)
  write(6,*) 'zeroth moment of dflav-dantiflav = ', moments(1:6)
  write(6,*)

  dpdf = qed_split%nlo * pdf
  moments = TruncatedMoment(grid, dpdf, one)
  write(6,*) '*********** NLO QED splitting checks **************'
  write(6,*) '1st moment of dflavours = ', moments
  write(6,*) 'sum of dflavours = ', sum(moments)
  write(6,*)
  moments(1:6) = TruncatedMoment(grid, dpdf(:,1:6)-dpdf(:,-1:-6:-1), zero)
  write(6,*) 'zeroth moment of dflav-dantiflav = ', moments(1:6)
  write(6,*)


  ! now check the pure photon-branching parts
  call InitQEDCoupling(qed_alpha, 1.5_dp, 4.5_dp, 173.2_dp)
  pdf(:,-6:6) = zero
  if (ncompmaxQED == ncompmaxLeptons) pdf(:,9:11) = zero
  dpdf = qed_split%lo * pdf
  moments(8) = TruncatedMoment(grid, dpdf(:,8), two)
  moments(7) = TruncatedMoment(grid,  pdf(:,8), two)
  write(6,*) 'LO fractional dpdf/pdf for photon is', moments(8)/moments(7)
  write(6,*) 'LO qed beta function is ', qed_alpha%b0_values(6) * twopi
  dpdf = qed_split%nlo * pdf
  moments(8) = TruncatedMoment(grid, dpdf(:,8), two)
  moments(7) = TruncatedMoment(grid,  pdf(:,8), two)
  write(6,*) 'NLO fractional dpdf/pdf for photon is', moments(8)/moments(7)
  !write(6,*) 'NLO qed beta function is ', qed_alpha%b0_values(6) * twopi
  write(6,*)
contains

  !======================================================================
  !! The dummy PDF suggested by Vogt as the initial condition for the 
  !! unpolazrized evolution
  function unpolarized_dummy_pdf(xvals) result(pdf)
    real(dp), intent(in) :: xvals(:)
    real(dp)             :: pdf(size(xvals),ncompmin:ncompmax)
    real(dp) :: uv(size(xvals)), dv(size(xvals))
    real(dp) :: ubar(size(xvals)), dbar(size(xvals))
    !---------------------
    real(dp), parameter :: N_g = 1.7_dp, N_ls = 0.387975_dp
    real(dp), parameter :: N_uv=5.107200_dp, N_dv = 3.064320_dp
    real(dp), parameter :: N_db = half*N_ls
  
    pdf = zero
    ! clean method for labelling as PDF as being in the human representation
    call LabelPdfAsHuman(pdf)

    !-- remember that these are all xvals*q(xvals)
    uv = N_uv * xvals**0.8_dp * (1-xvals)**3
    dv = N_dv * xvals**0.8_dp * (1-xvals)**4
    dbar = N_db * xvals**(-0.1_dp) * (1-xvals)**6
    ubar = dbar * (1-xvals)
    pdf(:,iflv_g) = N_g * xvals**(-0.1_dp) * (1-xvals)**5
        
    pdf(:,-iflv_s) = 0.2_dp*(dbar + ubar)
    pdf(:, iflv_s) = pdf(:,-iflv_s)
    pdf(:, iflv_u) = uv + ubar
    pdf(:,-iflv_u) = ubar
    pdf(:, iflv_d) = dv + dbar
    pdf(:,-iflv_d) = dbar
  end function unpolarized_dummy_pdf

end program test_qed_obj

module hoppet_libome_fortran
  use types
  use convolution, only: conv_ignd
  use, intrinsic :: iso_c_binding
  implicit none

  ! Pointers to the various A[...] objects in libome, initialised in 
  ! the hoppet_libome_interface.cc file
  type(c_ptr), bind(C, name="ome_AggQ"      ) :: AggQ_ptr ;  
  type(c_ptr), bind(C, name="ome_AgqQ"      ) :: AgqQ_ptr ; 
  type(c_ptr), bind(C, name="ome_AQg"       ) :: AQg_ptr ; 
  type(c_ptr), bind(C, name="ome_AqgQ"      ) :: AqgQ_ptr ; 
  type(c_ptr), bind(C, name="ome_AQqPS"     ) :: AQqPS_ptr ;  
  type(c_ptr), bind(C, name="ome_AqqQNSEven") :: AqqQNSEven_ptr ; 
  type(c_ptr), bind(C, name="ome_AqqQNSOdd ") :: AqqQNSOdd_ptr ;  
  type(c_ptr), bind(C, name="ome_AqqQPS"    ) :: AqqQPS_ptr ; 


  !! interface to the ome_piece_hoppet function in libome
  !! which provides the piecewise components of the splitting functions
  !! in the form required by hoppet
  interface 
    function ome_piece_hoppet(ptr,y,piece,order,LM,NF) bind(C, name="ome_piece_hoppet") result(res)
      use, intrinsic :: iso_c_binding
      real(c_double)                    :: res     !< return value: coefficient of (as/2pi)**order for xP(x), for given hoppet piece
      type(c_ptr)   , value, intent(in) :: ptr     !< pointer to one of the A[...] objects, i.e. an rpd_distribution object
      real(c_double),        intent(in) :: y       !< y = ln(1/x)
      integer(c_int),        intent(in) :: piece   !< which piece (cc_REAL, cc_REALVIRT, cc_PLUS, cc_DELTA)
      integer(c_int),        intent(in) :: order   !< order in as (0,1,2,3); returns a coefficient of (as/2pi)**order
      real(c_double),        intent(in) :: LM      !< LM = log(m^2/mu^2)
      real(c_double),        intent(in) :: NF      !< number of light flavours
    end function
  end interface

  !! Derived type implementing the conv_ignd abstract type
  !! using the libome library.
  !!
  !! Initialise an object as conv_OME(A..._ptr, order, ...) with
  !! parameters as follows
  !!
  !! \param ptr      pointer to one of the A..._ptr objects above
  !! \param order    the order in alphas to use (0,1,2,3)
  !! \param nf_light if >0, use this number of light flavours, otherwise the global nf-1 (defaults to global)
  !! \param LM       the LM value to use (default 0.0)  
  !!
  !! Example usage:
  !!
  !!    type(grid_conv) :: A3ggQ
  !!    call InitGridConv(grid, A3ggQ, conv_OME(AggQ_ptr,order=3))
  !!
  type, extends(conv_ignd) :: conv_OME
    type(c_ptr)    :: ptr                !< pointer to one of the A[...]_ptr objects
    integer(c_int) :: order              !< the order in alphas    
    real(c_double) :: nf_light = -1.0_c_double !< if >0, use this nf instead of the one from qcd module
    real(c_double) :: LM = 0.0_c_double  !< the LM value to use (mainly for testing)
  contains
    procedure :: f => conv_OME__f !< f(y,piece) function
  end type

contains
  
  !! Implementation of the conv_ignd%f(y,piece) function for the
  !! conv_OME derived type
  function conv_OME__f(this, y, piece) result(res)
    use qcd, only: nf
    implicit none
    class(conv_OME), intent(in) :: this
    real(dp), intent(in) :: y
    integer , intent(in) :: piece
    real(c_double) :: res, nf_c, lm_c

    if (this%nf_light > 0.0_c_double) then
      nf_c = this%nf_light
    else
      nf_c = real(nf, c_double) - 1.0_c_double ! subtract 1 to get number of light flavours, as per hoppet convention
    end if

    ! Call the ome_piece_hoppet function with the stored pointer and order
    res = ome_piece_hoppet(this%ptr, y, piece, this%order, this%LM, nf_c)
  end function conv_OME__f
end module hoppet_libome_fortran

!! program to test coding of time-like splitting functions
!! against 3rd party (e.g. Apfel++)
!!
program timelike_tests
  use types; use consts_dp
  use convolution_communicator;
  use splitting_functions
  use qcd
  use io_utils
  implicit none
  !---------------------
  integer  :: i
  integer  :: n=100
  real(dp) :: x, y, splitfn

  call qcd_SetNf(5)
  cc_piece = cc_REAL
  do i = 1, n-1
     x = (i-0.9_dp)*one/n
     y = -log(x)
     !splitfn = 2*nf*sf_TP1gq(y)
     !splitfn = sf_P1qqV(y) + sf_P1qqbarV(y) + sf_TmSP1qqNS(y) + 2*nf*sf_P1qqS(y)
     !splitfn = sf_P1qqV(y) + sf_P1qqbarV(y) + 2*nf*sf_P1qqS(y) + sf_TmSP1qqNS(y)
     !splitfn = sf_TP1qq(y)
     splitfn = sf_TP1qg(y)/(2*nf)
     write(6,*) x, splitfn/x
  end do
  
end program timelike_tests

module unit_tests
  use types
  use hoppet_to_string
  use hoppet_term
  use io_utils
  implicit none

  ! anything matching this will be timed
  character(len=max_arg_len):: timing_name = "fill_interp_weights6:x4"
  logical :: list_timing = .false.

  interface check_approx_eq
     module procedure check_approx_eq_0d, check_approx_eq_1d
  end interface

  integer :: unit_test_failures = 0
  integer :: unit_test_successes = 0

  character(len=:), allocatable :: current_test_group
  character(len=:), allocatable :: test_only
  logical :: verbose = .false.

contains

  logical function do_test(test_group)
    character(len=*), intent(in) :: test_group
    current_test_group = test_group
    if (allocated(test_only)) then
      if (len_trim(test_only) == 0) then
        do_test = .true.
      else
        do_test = (index(test_group, trim(test_only)) > 0)
      end if
    else
      do_test = .true.
    end if
    if (do_test) then
      print '(a)', blue//bold//"Running test group: "//trim(test_group)//reset
    else
      print '(a)', yellow//bold//"Skipping test group: "//trim(test_group)//reset//" (not in -only)"
    end if

  end function do_test

  subroutine check_approx_eq_0d(testname, answer, expected, tol_abs, tol_rel, tol_choice_or)
    use assertions
    implicit none
    character(len=*), intent(in) :: testname
    real(dp), intent(in) :: answer
    real(dp), intent(in) :: expected
    real(dp), intent(in) :: tol_abs
    real(dp), intent(in), optional :: tol_rel
    logical, intent(in),  optional :: tol_choice_or ! if true, use OR for tol checks, else (default) AND
    logical :: is_equal, is_equal_abs, is_equal_rel

    is_equal_abs = (abs(answer - expected) < tol_abs)
    if (present(tol_rel)) then
      is_equal_rel = (abs(answer - expected) < tol_rel*max(abs(expected), abs(answer)))
      if (default_or_opt(.false., tol_choice_or)) then
        is_equal = is_equal_abs .or. is_equal_rel
      else
        is_equal = is_equal_abs .and. is_equal_rel
      end if
    else
      is_equal = is_equal_abs
    end if

    if (.not. is_equal) then
      print *, ""
      print '(a)', red//bold//"Failed: "//trim(testname)//reset
      print *, "  Expected: ", expected
      print *, "  Actual:   ", answer
      print *, "  abs tol:  ", tol_abs
      if (present(tol_rel)) print *, "  rel tol:  ", tol_rel
      print *, "  difference: ", answer - expected,  ", rel diff: ", (answer - expected)/max(abs(expected), abs(answer))
      print *, ""
      unit_test_failures = unit_test_failures + 1
    else
      unit_test_successes = unit_test_successes + 1
      if (verbose) print '(a)', green//"Passed: "//testname//reset//" ans = "//&
                          trim(to_string(answer))//" matches expected = "//trim(to_string(expected))//reset
    end if
  end subroutine check_approx_eq_0d

  subroutine check_approx_eq_1d(testname, answer, expected, tol_abs, tol_rel)
    implicit none
    character(len=*), intent(in) :: testname
    real(dp), intent(in) :: answer(:)
    real(dp), intent(in) :: expected(:)
    real(dp), intent(in) :: tol_abs
    real(dp), intent(in), optional :: tol_rel
    logical :: is_equal

    is_equal = all(abs(answer - expected) < tol_abs)
    if (present(tol_rel)) then
      is_equal = is_equal .and. all(abs(answer - expected) < tol_rel*max(abs(expected), abs(answer)))
    end if

    if (.not. is_equal) then
      print *, red//"Failed: ", testname,reset
      print *, "  Expected: ", expected
      print *, "  Actual:   ", answer
      unit_test_failures = unit_test_failures + 1
    else
      unit_test_successes = unit_test_successes + 1
    end if

  end subroutine check_approx_eq_1d

  subroutine fail(testname)
    implicit none
    character(len=*), intent(in) :: testname
    print *, red//"Failed: ", testname, reset
    unit_test_failures = unit_test_failures + 1
  end subroutine fail



end module unit_tests

#include "inc/ftlMacros.inc"
module test_convolution
  use integrator
  use convolution
  use streamlined_interface
  use unit_tests  
  implicit none

  ! common objects that will be allocated once and then
  ! reused in the various tests
  real(dp), pointer :: xq(:), xq_conv1(:), xq_conv2(:)

  ! interface to the C functions we want to test
  abstract interface
    function ig_func_c(x) result(func) bind(C)
      use iso_c_binding, only: c_double
      real(c_double), intent(in), value :: x
      real(c_double)             :: func
    end function ig_func_c
  end interface
  public :: ig_func_c

  procedure(ig_func_c), bind(C, name="pqq_c"  ) :: pqq_c
  procedure(ig_func_c), bind(C, name="xpqqy_c") :: xpqqy_c
  
  ! a wrapper that converts from dp to c_double and back;
  ! on most systems this is a redundant copy, but it is the
  ! recommended way to work when interfacing with C
  !
  ! (actual use is below in the "contains" section)
#define MAKE_WRAPPER(NAME) \
  function CAT(NAME,_wrapper)(x) result(func); \
    use iso_c_binding, only: c_double; \
    real(dp), intent(in) :: x; \
    real(dp) :: func; \
    func = real(CAT(NAME,_c)(real(x,c_double)),dp); \
  end function


contains

  MAKE_WRAPPER(pqq)
  MAKE_WRAPPER(xpqqy)


  subroutine test_InitGridConv()
    real(dp) :: res

    ! make sure we have a few PDF objects
    call AllocGridQuant(grid, xq)
    call AllocGridQuant(grid, xq_conv1)
    call AllocGridQuant(grid, xq_conv2)
    xq = ff(yValues(grid))
    
    call test_mvv_interfaces()

    if (.not. do_test("test_InitGridConv")) return

    ! first a test that the integrating a simple function works fine
    block
      real(dp) :: aa= 0.1_dp, bb= 0.8_dp
      res = ig_LinWeight(pqq_wrapper, aa,bb, 1.0_dp, 1.0_dp, 1e-10_dp)
      call check_approx_eq("test_InitGridConv-pqq_c-int", res, pqq_int_res(aa,bb), 1e-10_dp)
    end block

    ! now a test of InitGridConv with a simple C++ function for Pqq,
    ! comparing to the standard LO result that we have in the DGLAP holder
    block
      type(grid_conv) :: pqq_gc
      call InitGridConv(grid, pqq_gc, xpqqy_wrapper)
      ! set up some simple x distribution on the grid
      ! convolute with P_qq from the DGLAP holder and from the C++ version
      xq_conv1 = dh%P_LO%NS_plus * xq
      xq_conv2 = pqq_gc * xq
      ! check the results agree
      call check_approx_eq_1d("test_InitGridConv-conv", xq_conv1, xq_conv2, 1e-10_dp)
      call Delete(pqq_gc)
    end block

  contains
  
    function pqq_int_res(a, b) result(rr)
      real(dp), intent(in) :: a, b
      real(dp) :: rr
      rr = 0.5_dp * (a - b) * (2.0_dp + a + b) + 2.0_dp * log((-1.0_dp + a)/(-1.0_dp + b))
    end function pqq_int_res
    
    elemental function ff(y) result(res)
      real(dp), intent(in) :: y
      real(dp) :: res
      real(dp) :: x
      x = exp(-y)
      res = x**(-0.5_dp) * (1.0_dp - x)**3
    end function ff

  end subroutine test_InitGridConv



  !! Routines to test the mvv_splitting_function type
  !! against their original implementation 
  subroutine test_mvv_interfaces()
    use hoppet_splitting_function_interfaces
    use splitting_functions_nnlo_p
    use convolution_communicator
    use xpij2p
    type(grid_conv) :: pgg_orig, pqg_orig
    type(grid_conv) :: pgg_OO,  pqg_OO
    real(dp), pointer :: xq1(:), xq2(:)
    real(dp) :: res_mvv, res_orig
    integer  :: piece
    type(mvv_splitting_function) :: pgg_mvv, pqg_mvv

    if (.not. do_test("test_mvv_interfaces")) return

    pgg_mvv = mvv_splitting_function(P2GGA, P2GGB , P2GGC , 0.5_dp**3)
    pqg_mvv = mvv_splitting_function(P2QGA, null(), null(), 0.5_dp**3)

    do piece = 1, 4
      cc_piece = piece
      res_mvv = pgg_mvv%f(0.5_dp, piece)
      res_orig = sf_P2gg(0.5_dp) 
      !write(6,*) "test_mvv_interfaces-pgg: piece=", piece, " res_mvv=", res_mvv, " res_orig=", res_orig
      call check_approx_eq("test_mvv_interfaces-pgg", res_mvv, res_orig, 1e-10_dp)

      res_mvv = pqg_mvv%f(0.5_dp, piece)
      res_orig = sf_P2qg2nf(0.5_dp) 
      !write(6,*) "test_mvv_interfaces-pqg: piece=", piece, " res_mvv=", res_mvv, " res_orig=", res_orig
      call check_approx_eq("test_mvv_interfaces-pqg", res_mvv, res_orig, 1e-10_dp)
    end do

    call InitGridConv(grid, pgg_orig, sf_P2gg)
    call InitGridConv(grid, pqg_orig, sf_P2qg2nf)

    call InitGridConv(grid, pgg_OO, mvv_splitting_function(P2GGA, P2GGB , P2GGC , 0.5_dp**3))
    call InitGridConv(grid, pqg_OO, mvv_splitting_function(P2QGA, null(), null(), 0.5_dp**3))

    xq_conv1 = pgg_orig * xq
    xq_conv2 = pgg_OO   * xq
    call check_approx_eq_1d("test_mvv_interfaces-pgg", xq_conv2, xq_conv1, 1e-10_dp)

    xq_conv1 = pqg_orig * xq
    xq_conv2 = pqg_OO   * xq
    call check_approx_eq_1d("test_mvv_interfaces-pqg", xq_conv2, xq_conv1, 1e-10_dp)

    call Delete(pgg_orig); call Delete(pqg_orig)
    call Delete(pgg_OO);   call Delete(pqg_OO)
  end subroutine test_mvv_interfaces

end module test_convolution

!----------------------------------------------------------------------
!
! This routine stores info about numbers of components used, 
! labelling of those components, and more importantly to a general
! used it contains routines for converting between the evolution storage
! format and the "human" storage format
!
!
! $Id: pdf_representation.f90,v 1.5 2003/11/22 00:45:39 salam Exp $
!----------------------------------------------------------------------
module pdf_representation
  use types; use consts_dp; use assertions; use warnings_and_errors
  implicit none
  !----------------------------------------------------------------------
  ! As of 6/01/2003, ncompmax and iflv_max must be the same (actually
  ! not anymore since we added extra representation iflv_info)
  integer, parameter, public :: iflv_max=6
  integer, parameter, public :: iflv_min=-iflv_max
  integer, parameter, public :: ncomponents=iflv_max
  !------------------------------------------------------
  integer, parameter, public :: iflv_g=0, iflv_sigma=1, iflv_V=-1
  integer, parameter, public :: iflv_d = 1, iflv_u = 2, iflv_s = 3, iflv_c = 4
  integer, parameter, public :: iflv_b = 5, iflv_t = 6
  integer, parameter, public :: iflv_dbar = -iflv_d
  integer, parameter, public :: iflv_ubar = -iflv_u
  integer, parameter, public :: iflv_sbar = -iflv_s
  integer, parameter, public :: iflv_cbar = -iflv_c
  integer, parameter, public :: iflv_bbar = -iflv_b
  integer, parameter, public :: iflv_tbar = -iflv_t
  integer, parameter, public :: iflv_info =  iflv_max + 1
  integer, parameter, public :: ncompmin = iflv_min
  integer, parameter, public :: ncompmax = iflv_info

  integer, parameter, public :: pdfr_Human = -1000001
  !integer, parameter, public :: pdfr_Evln  = 1

  integer, parameter :: default_ibase = 1


  type pdf_rep
     integer :: nf, ibase
  end type pdf_rep
  
  public :: pdf_rep

  interface CopyHumanPdfToEvln
     module procedure pdfr_HumanToEvln_sc, pdfr_HumanToEvln_1d
     module procedure pdfr_HumanToEvln_nf_sc, pdfr_HumanToEvln_nf_1d
  end interface
  
  interface CopyEvlnPdfToHuman
     module procedure pdfr_EvlnToHuman_sc, pdfr_EvlnToHuman_1d
     module procedure pdfr_EvlnToHuman_nf_sc, pdfr_EvlnToHuman_nf_1d
  end interface

  public :: CopyHumanPdfToEvln, CopyEvlnPdfToHuman
  public :: GetPdfRep, LabelPdfAsRep
  public :: LabelPdfAsHuman
  public :: DefaultEvlnRep

contains

  !======================================================================
  !! return the pdf_rep object corresponding to the default Evln
  !! representation for the specified value of nf.
  function DefaultEvlnRep(nf_lcl) 
    integer, intent(in) :: nf_lcl
    type(pdf_rep)       :: DefaultEvlnRep
    DefaultEvlnRep%nf    = nf_lcl
    DefaultEvlnRep%ibase = default_ibase
  end function DefaultEvlnRep


  
  !-------------------------------------------------------------------
  !! Take a "human format" pdf set and convert it to a format
  !! suitable for evolution, as described near the beginning of
  !! dglap_objects.
  !!
  !! What is called "k" there, here is known as prep%ibase
  !!
  !! Human format is that produced by the pdf_general module.
  !! i.e. (tbar, bbar, cbar, sbar, ubar, dbar, g, d, u, s, c, b, t)
  subroutine pdfr_HumanToEvln_sc(prep, qh, qe)
    type(pdf_rep), intent(in)  :: prep
    real(dp),      intent(in)  :: qh(ncompmin:)
    real(dp),      intent(out) :: qe(ncompmin:)
    !----------------------------------------------
    real(dp) :: tmp
    real(dp) :: qplus_base, qminus_base
    integer  :: i, j

    qe(iflv_g) = qh(iflv_g)
    qe(iflv_sigma) = sum(qh(1:prep%nf))
    tmp          = sum(qh(-prep%nf:-1))
    qe(iflv_V)     = qe(iflv_sigma) - tmp
    qe(iflv_sigma) = qe(iflv_sigma) + tmp
    
    qplus_base  = qh(prep%ibase) + qh(-prep%ibase)
    qminus_base = qh(prep%ibase) - qh(-prep%ibase)
    do i = 2, prep%nf
       if (i > prep%ibase) then
          j = i
       else
          j = i-1
       end if
       qe( i) = qh(j) + qh(-j) - qplus_base
       qe(-i) = qh(j) - qh(-j) - qminus_base
    end do
    !-- keep the rest clean...
    do i = prep%nf+1, ncomponents
       qe(i) = qh(i)
       qe(-i) = qh(-i)
    end do
    
  end subroutine pdfr_HumanToEvln_sc

  !------------------------------------------------
  !! a vector version of the above
  subroutine pdfr_HumanToEvln_1d(prep, qh, qe)
    type(pdf_rep), intent(in)  :: prep
    real(dp),      intent(in)  :: qh(:,ncompmin:)
    real(dp),      intent(out) :: qe(:,ncompmin:)
    integer :: n, i

    n = assert_eq(size(qh,dim=1),size(qe,dim=1),'pdfr_HumanToEvln_1d')
    if (GetPdfRep(qh) /= pdfr_Human) call wae_error('pdfr_HumanToEvln_1d',&
         &'qh is not in "Human" format')

    do i = 1, n
       call pdfr_HumanToEvln_sc(prep, qh(i,:), qe(i,:))
    end do
    !call LabelPdfAsRep(qe,pdfr_Evln)
    call LabelPdfAsRep(qe,prep%nf)
  end subroutine pdfr_HumanToEvln_1d
  

  !---------------------------------------------------------
  !! Take a pdf set in "evolution format" and convert it back
  !! to "human format".
  subroutine pdfr_EvlnToHuman_sc(prep, qe, qh)
    type(pdf_rep), intent(in)  :: prep
    real(dp),      intent(in)  :: qe(ncompmin:)
    real(dp),      intent(out) :: qh(ncompmin:)
    !---------------------------------------------
    integer  :: i, j
    real(dp) :: tmp
    
    qh(iflv_g) = qe(iflv_g)
    !-- first construct individual + and - distributions
    qh( prep%ibase) = (qe(iflv_sigma) - sum(qe(2:prep%nf))   )/prep%nf
    qh(-prep%ibase) = (qe(iflv_V)     - sum(qe(-prep%nf:-2)) )/prep%nf

    do i = 2, prep%nf
       if (i > prep%ibase) then
          j = i
       else
          j = i-1
       end if
       qh( j) = qe( i) + qh( prep%ibase)
       qh(-j) = qe(-i) + qh(-prep%ibase)
    end do

    !-- then go from + and - to q and qbar
    do i = 1, prep%nf
       tmp = qh(-i)
       qh(-i) = half*(qh(i) - tmp)
       qh( i) = half*(qh(i) + tmp)
    end do
    
    !-- make sure the rest is zero
    do i = prep%nf+1, iflv_max
       qh( i) = qe(i)
       qh(-i) = qe(-i)
    end do
    
  end subroutine pdfr_EvlnToHuman_sc
  

  !------------------------------------------------
  !! a vector version of the above
  subroutine pdfr_EvlnToHuman_1d(prep, qe, qh)
    type(pdf_rep), intent(in)  :: prep
    real(dp),      intent(in)  :: qe(:,ncompmin:)
    real(dp),      intent(out) :: qh(:,ncompmin:)
    integer :: n, i
    n = assert_eq(size(qh,dim=1),size(qe,dim=1),'pdfr_EvlnToHuman_1d')
    !if (GetPdfRep(qe) /= pdfr_Evln) &
    if (GetPdfRep(qe) /= prep%nf) &
         &call wae_error('pdf_EvlnToHuman_1d', 'qe is not in correct "Evln" format')
    do i = 1, n
       call pdfr_EvlnToHuman_sc(prep, qe(i,:), qh(i,:))
    end do
    call LabelPdfAsRep(qh,pdfr_Human)
  end subroutine pdfr_EvlnToHuman_1d
  

  !=== next follow overloaded versions with integer (nf) spec of rep
  subroutine pdfr_HumanToEvln_nf_sc(nf_lcl, qh, qe)
    integer ,      intent(in)  :: nf_lcl
    real(dp),      intent(in)  :: qh(:)
    real(dp),      intent(out) :: qe(:)
    call CopyHumanPdfToEvln(DefaultEvlnRep(nf_lcl), qh, qe)
  end subroutine pdfr_HumanToEvln_nf_sc
  !
  subroutine pdfr_HumanToEvln_nf_1d(nf_lcl, qh, qe)
    integer ,      intent(in)  :: nf_lcl
    real(dp),      intent(in)  :: qh(:,:)
    real(dp),      intent(out) :: qe(:,:)
    call CopyHumanPdfToEvln(DefaultEvlnRep(nf_lcl), qh, qe)
  end subroutine pdfr_HumanToEvln_nf_1d
  !
  subroutine pdfr_EvlnToHuman_nf_sc(nf_lcl, qe, qh)
    integer ,      intent(in)  :: nf_lcl
    real(dp),      intent(in)  :: qe(:)
    real(dp),      intent(out) :: qh(:)
    call CopyEvlnPdfToHuman(DefaultEvlnRep(nf_lcl), qe, qh)
  end subroutine pdfr_EvlnToHuman_nf_sc
  !
  subroutine pdfr_EvlnToHuman_nf_1d(nf_lcl, qe, qh)
    integer ,      intent(in)  :: nf_lcl
    real(dp),      intent(in)  :: qe(:,:)
    real(dp),      intent(out) :: qh(:,:)
    call CopyEvlnPdfToHuman(DefaultEvlnRep(nf_lcl), qe, qh)
  end subroutine pdfr_EvlnToHuman_nf_1d
  


  !--------------------------------------------------------------
  !! Label the pdf with a "key" corresponding to the representation
  !! Make part of Evln the key random so that if we subtract two pdfs
  !! in the Evln representation they will not accidentally give
  !! something in the human representation.
  subroutine LabelPdfAsRep(q,irep)
    use hoppetrandom
    real(dp), intent(inout) :: q(0:,ncompmin:)
    integer,  intent(in)    :: irep

    !PN&GZ: need to comment this out for streamlined interface with QED evolution     
    !if (ubound(q,dim=2) /= ncompmax) call wae_error('LabelPdfAsRep',&
    !     &'upper bound of q does not correspond to ncompmax; it is:',&
    !     &intval=ubound(q,dim=2))

    if (ubound(q,dim=1) < 4) call wae_error('LabelPdfAsRep',&
         &'grid is too small to hold pdf flavour representation info; size is:',&
         &intval=ubound(q,dim=1))

    ! very wasteful labelling, but in f90 it is hard to see 
    ! what else can be done...
    select case(irep)
    case(pdfr_Human)  
       q(:,iflv_info) = zero
    case(1:iflv_max)
       !q(0,iflv_info)  = pi*1e-1_dp
       !q(1,iflv_info)  = one+ran()
       !q(2:,iflv_info) = zero
       q(0,iflv_info)   = pi*1e-1_dp
       q(1,iflv_info)   = one+ran_one()
       q(2:3,iflv_info) = irep*q(0:1,iflv_info)
       q(4:,iflv_info) = zero
    case default
       call wae_error('LabelPdfAsRep','Unrecognized irep:',intval=irep)
    end select
  end subroutine LabelPdfAsRep

  
  !======================================================================
  !! Label the PDF as being in the human representation
  subroutine LabelPdfAsHuman(q)
    real(dp), intent(inout) :: q(0:,ncompmin:)
    call LabelPdfAsRep(q,pdfr_human)
  end subroutine LabelPdfAsHuman
  
  !-------------------------------------------------------------
  !! This tells us what representation it is in.
  !! 
  !! If it is in hte human representation, then it will return
  !! pdfr_Human, otherwise it will return the number of flavours
  !! associated with the current representation
  function GetPdfRep(q) result(irep)
    real(dp), intent(in) :: q(0:,ncompmin:)
    integer              :: irep
    real(dp)             :: drep
    real(dp), parameter  :: rep_tolerance = 1e-7_dp

    !PN&GZ: need to comment this out for streamlined interface with QED evolution         
    !if (ubound(q,dim=2) /= ncompmax) call wae_error('GetPdfRep',&
    !     &'upper bound of q does not correspond to ncompmax; it is:',&
    !     &intval=ubound(q,dim=2))

    !if (q(0,iflv_info) == zero .neqv. q(1,iflv_info) == zero) then
    !   call wae_error('GetPdfRep', 'Inconsistent behaviour in iflv_info')
    !else 
    if (q(0,iflv_info) == zero .and. q(1,iflv_info) == zero) then
       irep = pdfr_Human
    else
       !irep = pdfr_Evln
       ! we now get the number of flavours as a ratio of different
       ! entries in index ncompmax, to help distinguish the different
       ! representation for each separate nf value
       drep = (abs(q(2,iflv_info))+abs(q(3,iflv_info)))/&
            & (abs(q(0,iflv_info))+abs(q(1,iflv_info)))
       irep = nint(drep)
       if (abs(drep - irep) > rep_tolerance) then
          call wae_error('GetPdfRep',&
               &'representation seems to be inconsistent (non-integer):',&
               &dbleval=drep)
       end if
    end if
  end function GetPdfRep
  
  
end module pdf_representation

#include "timing.inc"

module test_interpolation
  use types
  use unit_tests
  implicit none

contains

  !! checks equivalence between interpolation weights from
  !! uniform_interpolation_weights and fill_interp_weightsN
  subroutine test_interpolation_coeffs()
    use interpolation
    use interpolation_coeffs
    real(dp) :: x
    real(dp) :: weights(0:4)
    integer   :: i, ix
    integer, parameter :: nlo = 1, nhi = 6
    real(dp) :: weights1(0:nhi), weights2(0:nhi)
    real(dp), parameter :: xvals(*) = [0.2_dp,1.5_dp,3.4_dp, 1.0_dp]

    if (.not. do_test("test_interpolation_coeffs")) return

    do ix = 1, size(xvals)
      x = xvals(ix)
      do i = nlo, nhi
        weights1 = 0.0_dp
        call uniform_interpolation_weights(x, weights1(0:i))
        select case (i)
          case (1)
            call fill_interp_weights1(x, weights2)
          case (2)
            call fill_interp_weights2(x, weights2)
          case (3)
            call fill_interp_weights3(x, weights2)
          case (4)
            call fill_interp_weights4(x, weights2)
          case (5)
            call fill_interp_weights5(x, weights2)
          case (6)
            call fill_interp_weights6(x, weights2)
          case Default
            call fail("Unsupported order "//trim(to_string(i))//" in test_interpolation_coeffs")
            continue
        end select

        call check_approx_eq("fill_interp_weightsN, order = "//trim(to_string(i))//", x="//trim(to_string(x)), &
                              weights2(0:i), weights1(0:i), tol_abs = 1e-10_dp)
      end do
    end do

  ! some basic timing code
  ! NB: it only runs if timing_name=="fill_interp_weights6:x4"
  TIME_START("fill_interp_weights6:x4",10**5)
  real(dp) :: weights_sum(0:6) = 0.0_dp
  TIME_LOOP
    ! cover a range of x values to include special cases & not
    do ix = 1, size(xvals)
      call fill_interp_weights6(xvals(ix), weights2)
      weights_sum = weights_sum + weights2
    end do
  TIME_END(weights_sum(0))

  end subroutine test_interpolation_coeffs


end module test_interpolation  

!! ------------------------------------------------------------
!!
!! An example program which shows how to compute
!! sum rules (and general moments) for a given set of PDFS.
!! 
!! This example also illustrates how to use the evolution
!! in cases where one wishes to bypass a pdf_table.
!!
!! Another example showing sum rules with a pdf_table is present 
!! in tabulation_example_2
!! -----------------------------------------------------

program sumrules

     use hoppet
  use hoppet_git_state
  use io_utils
  !! if using LHAPDF, rename a couple of hoppet functions which
  !! would otherwise conflict with LHAPDF 
     !use hoppet, EvolvePDF_hoppet => EvolvePDF, InitPDF_hoppet => InitPDF

  implicit none
  real(dp) :: dy, ymax
  integer  :: order, nloop
  !! holds information about the grid
  type(grid_def) :: grid, gdarray(4)
  !! holds the splitting functions
  type(dglap_holder) :: dh
  !! hold the coupling
  real(dp)               :: quark_masses(4:6)
  type(running_coupling) :: coupling
  !! hold the initial pdf
  real(dp), pointer :: pdf0(:,:)
  real(dp), pointer :: pdf_flav(:)
  real(dp) :: Q0
  !! hold results at some x, Q
  real(dp) :: Q
  real(dp), parameter :: heralhc_xvals(9) = &
       & (/1e-5_dp,1e-4_dp,1e-3_dp,1e-2_dp,0.1_dp,0.3_dp,0.5_dp,0.7_dp,0.9_dp/)


  write(6,'(a)') trim(command_line())
  call hoppet_print_git_state(6) 
  ! set up parameters for grid
  order = -6
  ymax  = dble_val_opt("-ymax",20.0_dp)  ! you may see significant violations with too small a ymax
  dy    = dble_val_opt("-dy",  0.1_dp )


  call SetDefaultEvolutionDu(dy/6.0_dp)  ! generally a good choice

  ! set up the grid itself -- we use 4 nested subgrids
  call InitGridDef(gdarray(4),dy/27.0_dp,0.2_dp, order=order)
  call InitGridDef(gdarray(3),dy/9.0_dp,0.5_dp, order=order)
  call InitGridDef(gdarray(2),dy/3.0_dp,2.0_dp, order=order)
  call InitGridDef(gdarray(1),dy,       ymax  ,order=order)
  call InitGridDef(grid,gdarray(1:4),locked=.true.)

  Q0 = dble_val_opt("-Q0",sqrt(2.0_dp))  ! the initial scale
  Q  = dble_val_opt("-Q", 100.0_dp)


  ! initialise the splitting-function holder
  nloop = int_val_opt("-nloop",3)
  !call dglap_Set_n3lo_nfthreshold(n3lo_nfthreshold_off)


  if (.not. CheckAllArgsUsed(0)) stop

  call InitDglapHolder(grid,dh,factscheme=factscheme_MSbar,&
       &                      nloop=nloop,nflo=3,nfhi=6)
  write(6,'(a)') "Splitting functions initialised!"
  write(6,*) "ymax = ", ymax, " dy = ", dy
  write(6,*) "nloop = ", nloop
  if (nloop >=4) then 
    write(6,*) "n3lo_splitting_approximation = ", n3lo_splitting_approximation
    write(6,*) "n3lo_nfthreshold = " , n3lo_nfthreshold
  endif

  ! initialise a PDF from the function below (must be contained,
  ! in a "used" module, or with an explicitly defined interface)
  call AllocPDF(grid, pdf0)
  pdf0 = unpolarized_dummy_pdf(xValues(grid))


  ! Compute sum rules of the initial PDF set
  write(6,'(a)') "  "
  write(6,'(a,1x,f11.5,1x,a)') "Sum rules at Q02 =  ",&
       & Q0**2," GeV^2"
  write(6,'(a)') "  "

  ! Allocate a grid quantity for the pdf combination
  call AllocGridQuant(grid,pdf_flav)
  
  
  ! Compute various sum rules
   call truncated_sum_rules(grid,pdf0)

  !
  ! Sum rules at arbitrary values of Q
  ! Note that if sum rules at satisfied at the input evolution
  ! scale Q0, they will also be satisfied for any Q > Q0
  ! 

  !Q=1.42_dp
  Q=100.0_dp
  write(6,'(a)') "  "
  write(6,'(a,1x,f11.5,1x,a)') "Sum rules at Q2 =  ",&
       & Q**2," GeV^2"
  write(6,'(a)') "  "
  

  ! allocate and initialise the running coupling with a given
  ! set of quark masses (NB: charm mass just above Q0).
  quark_masses(4:6) = (/1.414213563_dp, 4.5_dp, 175.0_dp/)
  call InitRunningCoupling(coupling,alfas=0.35_dp,Q=Q0,nloop=nloop,&
       &                   quark_masses = quark_masses)

  ! Evolve the initial PDF up to scale Q to test sum rules
  call EvolvePDF(dh,pdf0,coupling,Q0,Q)

  ! Compute various sum rules at the scale Q
  call truncated_sum_rules(grid,pdf0)
 
 
  ! Some cleaning
  call Delete(pdf0)
  call Delete(dh)
  call Delete(coupling)
  call Delete(grid)

contains 
  !======================================================================
  !! The dummy PDF suggested by Vogt as the initial condition for the 
  !! unpolarized evolution (as used in hep-ph/0511119).
  function unpolarized_dummy_pdf(xvals) result(pdf)
    real(dp), intent(in) :: xvals(:)
    real(dp)             :: pdf(size(xvals),ncompmin:ncompmax)
    real(dp) :: uv(size(xvals)), dv(size(xvals))
    real(dp) :: ubar(size(xvals)), dbar(size(xvals))
    !---------------------
    real(dp), parameter :: N_g = 1.7_dp, N_ls = 0.387975_dp
    real(dp), parameter :: N_uv=5.107200_dp, N_dv = 3.064320_dp
    real(dp), parameter :: N_db = half*N_ls
  
    pdf = zero
    ! clean method for labelling as PDF as being in the human representation
    ! (not actually needed after setting pdf=0
    call LabelPdfAsHuman(pdf)

    !pdf(:,iflv_g) = 6.0_dp * (1-xvals)**5
    !pdf(:,iflv_u) = 20.0_dp * xvals * (1-xvals)**3
    !return

    !-- remember that these are all xvals*q(xvals)
    uv = N_uv * xvals**0.8_dp * (1-xvals)**3
    dv = N_dv * xvals**0.8_dp * (1-xvals)**4
    dbar = N_db * xvals**(-0.1_dp) * (1-xvals)**6
    ubar = dbar * (1-xvals)

    ! labels iflv_g, etc., come from the hoppet module, inherited
    ! from the main program
    pdf(:, iflv_g) = N_g * xvals**(-0.1_dp) * (1-xvals)**5
    pdf(:,-iflv_s) = 0.2_dp*(dbar + ubar)
    pdf(:, iflv_s) = pdf(:,-iflv_s)
    pdf(:, iflv_u) = uv + ubar
    pdf(:,-iflv_u) = ubar
    pdf(:, iflv_d) = dv + dbar
    pdf(:,-iflv_d) = dbar
  end function unpolarized_dummy_pdf

!--------------------------------------------

  !======================================================================
  ! Routines which computes the momentum and valence (truncated)
  ! sum rules from a given pdf set in an arbitary representation
  ! See table 1 in doc for the summary of PDF representation
  !======================================================================
  subroutine truncated_sum_rules(gd,pdf_sr)
    implicit none
    integer :: nf_rep, ipdf
    type(grid_def), intent(in)      :: gd
    ! remember lower bounds of (non-pointer) array arguments default
    ! to 1 unless explicitly specified; here we specify them
    ! because we want to access individual flavours below
    real(dp), intent(in)            :: pdf_sr(0:,-6:)
    real(dp), pointer               :: pdf_flav(:)
    real(dp)                        :: moment_index, sum_rule
    !--------------------------------------------

    write(6,*) "       ---       "
    write(6,*) "Computation of (truncated) sum rules"
    write(6,*) "              "

    !
    ! (Truncated) moments are defined in terms of y as
    ! 
    !  M(moment_index) = \int_0^ymax dy exp( - y * moment_index) * xpdf(y)
    ! 
    ! or in terms of x, where y = ln(1/x)
    !
    !   M(moment_index) = \int_xmin^1 dx x^( moment_index - 1) * xpdf(x)
    !

    ! Allocate space for pdf_flav
    call AllocGridQuant(gd,pdf_flav)
        
    ! Compute the (truncated) momentum sum rule

    nf_rep = GetPdfRep(pdf_sr)
    ! Construct the appropiate combination for the
    ! given PDF representation
    if(nf_rep == pdfr_Human) then
       ! PDF set in human representation -> Sum all pdfs
       pdf_flav(:)=sum(pdf_sr(:,-6:6),dim=2)
    elseif(nf_rep.ge.0) then
       ! PDF in evln representation -> Singlet + Gluon
       pdf_flav(:)=pdf_sr(:,0) + pdf_sr(:,1)
    endif

    moment_index = 1.0_dp ! See definition of truncated moments above
    sum_rule = TruncatedMoment(gd,pdf_flav,moment_index)
  
    write(6,*) "Momentum sum rule = ",sum_rule, ", expected 1, difference = ", &
         & sum_rule - 1.0_dp

    ! Compute the (truncated) valence sum rules

    ! Total valence sum rule 
    ! Construct the appropiate combination for the
    ! given PDF representation
    if(nf_rep == pdfr_Human) then
       ! PDF set in human representation 
       pdf_flav(:)= pdf_sr(:,1) - pdf_sr(:,-1)
       do ipdf = 2,6
          pdf_flav(:) = pdf_flav(:) + ( pdf_sr(:,ipdf) - pdf_sr(:,-ipdf) )
       enddo
    elseif(nf_rep.ge.0) then
       ! PDF in evln representation
       pdf_flav(:)=pdf_sr(:,-1)
    endif
    
    moment_index = 0.0_dp
    sum_rule = TruncatedMoment(gd,pdf_flav,moment_index)
    
    write(6,*) "uv + dv sum rule = ",sum_rule, ", expected 3, difference = ", &
         & sum_rule - 3.0_dp

    ! uv - dv sum rule
    if(nf_rep == pdfr_Human) then
       ! PDF set in human representation 
       pdf_flav(:)= pdf_sr(:,2) - pdf_sr(:,-2) - & 
            & ( pdf_sr(:,1) - pdf_sr(:,-1) ) 
    elseif(nf_rep.ge.0) then
       ! PDF in evln representation 
       pdf_flav(:)=pdf_sr(:,-2) 
    endif
    
    moment_index = 0.0_dp
    sum_rule = TruncatedMoment(gd,pdf_flav,moment_index)
    
    write(6,*) "uv - dv sum rule = ",sum_rule, ", expected 1, difference = ", &
         & sum_rule - 1.0_dp
    write(6,*) " "


  end subroutine truncated_sum_rules

end program sumrules

module streamlined_interface
  use types; use consts_dp
  use pdf_tabulate
  use convolution; use pdf_general; use dglap_objects
  use dglap_holders; use pdf_general; use dglap_choices
  use qcd_coupling
  use qed_evolution
  use qed_objects
  use qed_coupling_module
  use qcd, only: quark_masses_def
  use pdfs_for_benchmarks
  use warnings_and_errors
  implicit none

  !! holds information about the grid
  type(grid_def),     save :: grid, gdarray(4)

  !! holds the splitting functions
  type(dglap_holder), save :: dh

  !! table_index_from_iloop tells us which table to loop up for a give
  !! iloop value; most of the iloop values are illegal (index -1), but
  !! for those that are allowed (e.g. 1, 2, 3, 12, 111) this gives
  !! quick access to the relevant table (without having to store 111
  !! tables, most of which would be redundant)
  !!
  !! The array gets initialised in hoppetStartExtended
  integer, save :: table_index_from_iloop(1:1111) = -1
  integer, parameter :: max_table_index = 15

  !!
  !! NB (2012-12-24): 
  !!     in future evolution of the code, we should aim to guarantee
  !!     that tables(0) remains the default PDF, even if the other
  !!     entries change
  type(pdf_table), save, target :: tables(0:max_table_index)
  logical,         save :: setup_done(0:max_table_index) = .false.
  integer,         save :: setup_nf(max_table_index)     = 0
  logical,         save :: alloc_already_done = .false.
  
  !! coupling
  logical,                save :: coupling_initialised = .false.
  type(running_coupling), save :: coupling
  integer,  save :: ffn_nf = -1
  logical,  save :: quark_masses_are_MSbar = .false.
  real(dp), save :: masses(4:6) = quark_masses_def(4:6)
  !! Additional things for QED
  !integer,  save            :: nqcdloop_qed
  type(qed_coupling),  save :: coupling_qed
  type(qed_split_mat), save :: qed_split
  logical,  save :: with_qed = .false.
  real(dp), save :: effective_light_quark_masses = m_light_quarks_default ! from qed_coupling_module
  integer,  save :: with_nqcdloop_qed = 0
  logical,  save :: with_Plq_nnloqed = .false.

contains
  
  !----------------------------------------------------------------------
  ! returns the value of the table index for the given iloop and
  ! ensures that the table is actually set up (working down recursively
  ! when iloop is composite)
  recursive integer function tableIndexValue(iloop, nf) result(tabindex)
    use warnings_and_errors
    integer, intent(in) :: iloop, nf
    !------------------------------
    integer :: table_index_source, iloop_P, iQ

    ! first establish if iloop is "legal"
    if (iloop < 1 .or. iloop > ubound(table_index_from_iloop,dim=1)) then
       call wae_error('tableIndexValue','illegal value for iloop (out of bounds):',&
            &intval=iloop)
    else if (table_index_from_iloop(iloop) < 0) then
       call wae_error('tableIndexValue','illegal value for iloop (lookup < 0):',&
            &intval=iloop)
    end if
    tabindex = table_index_from_iloop(iloop)

    !write(0,*) 'iloop, tabindex ', iloop, tabindex
    if (.not. setup_done(tabindex) .or. setup_nf(tabindex) /= nf) then

       if (iloop < 10) then
          table_index_source = 0
          iloop_P = iloop
       else if (iloop < 100) then
          table_index_source = tableIndexValue(mod(iloop,10), nf)
          iloop_P = iloop / 10
       else if (iloop < 1000) then
          table_index_source = tableIndexValue(mod(iloop,100), nf)
          iloop_P = iloop / 100
       else if (iloop < 10000) then
          table_index_source = tableIndexValue(mod(iloop,1000), nf)
          iloop_P = iloop / 1000
       else 
          call wae_error('tableIndexValue','unsupported value for iloop (source & iloop_P determination):',&
            &intval=iloop)
       end if
       !write(0,*) 'setting up with source and iloop_P = ', table_index_source, iloop_P
       
       if (nf < 0) then
          ! use whatever nf is relevant 
          if (.not. tables(0)%nf_info_associated) call wae_error(&
               & 'hoppetEvalSplit','automatic choice of nf (nf<0) but the tabulation has no information on nf')
          do iQ = 0, tables(0)%nQ
             tables(tabindex)%tab(:,:,iQ) = dh%allP(iloop_P, tables(0)%nf_int(iQ)) &
                  &             .conv. tables(table_index_source)%tab(:,:,iQ)
          end do
       else
          ! use a fixed nf
          if (nf < lbound(dh%allP,dim=2) .or. nf > ubound(dh%allP,dim=2)) &
               &call wae_error('hoppetEvalSplit','illegal value for nf:',&
               &intval=nf)
          
          tables(tabindex)%tab = dh%allP(iloop_P, nf) .conv. tables(table_index_source)%tab
       end if
       
       setup_done(tabindex) = .true.
       setup_nf(tabindex)   = nf
  end if

  end function tableIndexValue

  
  
end module streamlined_interface

!======================================================================
!! This routine should be called before hoppetStart if one wants
!! to include QED evolution. Note that it affects expected upper
!! bounds for all routines that set and access the PDFs
!!
!! - use_qed: if true, QED evolution will be included
!! - use_qcd_qed: if true, the mixed alpha_s*alpha splitting functions will be included
!! - use_Plq_nnlo: if true, the NNLO Plq splitting functions will be included
subroutine hoppetSetQED(use_qed, use_qcd_qed, use_Plq_nnlo)
  use streamlined_interface
  use qed_evolution
  implicit none
  logical, intent(in)  :: use_qed
  logical, intent(in)  :: use_qcd_qed, use_Plq_nnlo
  write(*,*) 'hoppetSetQED: use_qed, use_qcd_qed, use_Plq_nnlo=', &
       & use_qed, use_qcd_qed, use_Plq_nnlo
  with_qed = use_qed
  if (use_qcd_qed) then 
    with_nqcdloop_qed = 1
  else
    with_nqcdloop_qed = 0
  end if
  with_Plq_nnloqed = use_Plq_nnlo
end subroutine hoppetSetQED

subroutine hoppetSetQED_c(use_qed, use_qcd_qed, use_Plq_nnlo) bind(C,name="hoppetSetQED_c")
  use streamlined_interface
  use qed_evolution
  use iso_c_binding
  implicit none
  logical(c_bool), intent(in)  :: use_qed
  logical(c_bool), intent(in)  :: use_qcd_qed, use_Plq_nnlo
  logical :: use_qed_f
  logical :: use_qcd_qed_f, use_Plq_nnlo_f

  use_qed_f = merge(.true._1, .false._1, use_qed)
  use_qcd_qed_f = merge(.true._1, .false._1, use_qcd_qed)
  use_Plq_nnlo_f = merge(.true._1, .false._1, use_Plq_nnlo)
  call hoppetSetQED(use_qed_f, use_qcd_qed_f, use_Plq_nnlo_f)
end subroutine hoppetSetQED_c

!======================================================================
!! initialise the underlying grid, splitting functions and pdf-table
!! objects, using the dy and nloop parameters as explained below.
subroutine hoppetStart(dy,nloop)
  use streamlined_interface
  implicit none
  !--------------------------------------
  real(dp), intent(in) :: dy     !! internal grid spacing: 0.1 is a sensible value
  integer,  intent(in) :: nloop  !! the maximum number of loops we'll want (<=4)
  !--------------------------------------
  real(dp) :: ymax, Qmin, Qmax, dlnlnQ
  integer  :: order
  ymax = 12.0d0
  Qmin = 1.0d0
  Qmax = 28000d0 ! twice LHC c.o.m.
  dlnlnQ = dy/4.0_dp  ! min(0.5_dp*dy,0.07_dp)
  order = -6
  call hoppetStartExtended(ymax,dy,Qmin,Qmax,dlnlnQ,nloop,order,factscheme_MSbar)
end subroutine hoppetStart


!======================================================================
!! initialise the underlying grid, splitting functions and pdf-table
!! objects, using an extended set of parameters, as described below
subroutine hoppetStartExtended(ymax,dy,Qmin,Qmax,dlnlnQ,nloop,order,factscheme)
  use streamlined_interface
  implicit none
  real(dp), intent(in) :: ymax   !! highest value of ln1/x user wants to access
  real(dp), intent(in) :: dy     !! internal grid spacing: 0.1 is a sensible value
  real(dp), intent(in) :: Qmin, Qmax !! range in Q
  real(dp), intent(in) :: dlnlnQ !! internal table spacing in lnlnQ
  integer,  intent(in) :: nloop  !! the maximum number of loops we'll want (<=4)
  integer,  intent(in) :: order  !! order of numerical interpolation (+ve v. -ve: see below)
  integer,  intent(in) :: factscheme !! 1=unpol-MSbar, 2=unpol-DIS, 3=Pol-MSbar
  !-------------------------------------
  integer :: iloop

  ! if the allocation has already been done previously, delete
  ! the existing tables and dglap holder, etc. to avoid a memory leak
  if (alloc_already_done) call hoppetDeleteAll()  
  
  ! initialise our grids

  ! the internal interpolation order (with a minus sign allows
  ! interpolation to take fake zero points beyond x=1 -- convolution
  ! times are unchanged, initialisation time is much reduced and
  ! accuracy is slightly reduced)
  !order = -5 
  ! Now create a nested grid
  !call InitGridDef(gdarray(4),dy/27.0_dp,0.2_dp, order=order)
  !call InitGridDef(gdarray(3),dy/9.0_dp,0.5_dp, order=order)
  !call InitGridDef(gdarray(2),dy/3.0_dp,2.0_dp, order=order)
  !call InitGridDef(gdarray(1),dy,       ymax  ,order=order)
  !call InitGridDef(grid,gdarray(1:4),locked=.true.)

  ! as of 2016-05-26, better to use the "central" facility for
  ! producing a nested grid (which has the same nested grid structure
  ! as above)
  call InitGridDefDefault(grid, dy, ymax, order)
  
  ! Fill the array that will be used for table index lookup (e.g. 21 is PNLO*PLO).
  ! For now do it by hand; one day we might automate this;
  ! entries that aren't filled are automatically -1

  ! First fill the bare splitting functions
  do iloop = 1, nloop
     table_index_from_iloop(iloop) = iloop
  end do
  ! Now fill entries where the sum is 2
  table_index_from_iloop(11)                   = nloop + 1
  ! Then the entries where the sum is 3
  table_index_from_iloop(111)                  = nloop + 2
  if (nloop >= 2) table_index_from_iloop(12)   = nloop + 3
  if (nloop >= 2) table_index_from_iloop(21)   = nloop + 4
  ! Finally the entries where the sum is 4
  table_index_from_iloop(1111)                 = nloop + 5
  if (nloop >= 2) table_index_from_iloop(112)  = nloop + 6
  if (nloop >= 2) table_index_from_iloop(121)  = nloop + 7
  if (nloop >= 2) table_index_from_iloop(211)  = nloop + 8
  if (nloop >= 2) table_index_from_iloop(22)   = nloop + 9
  if (nloop >= 3) table_index_from_iloop(13)   = nloop + 10
  if (nloop >= 3) table_index_from_iloop(31)   = nloop + 11 ! which is 15 if nloop = 14
  
  ! create the tables that will contain our copy of the user's pdf
  ! as well as the convolutions with the pdf.

  if(with_qed) then
     call AllocPdfTableWithLeptons(grid, tables(:), Qmin, Qmax, & 
          & dlnlnQ = dlnlnQ, freeze_at_Qmin=.true.)
  else
     call AllocPdfTable(grid, tables(:), Qmin, Qmax, & 
          & dlnlnQ = dlnlnQ, freeze_at_Qmin=.true.)
  endif

  ! initialise splitting-function holder
  call InitDglapHolder(grid,dh,factscheme=factscheme,&
       &                      nloop=nloop,nflo=3,nfhi=6)

  if(with_qed) then
     call InitQEDSplitMat(grid, qed_split)
  endif
  
  ! choose a sensible default number of flavours.
  call SetNfDglapHolder(dh,nflcl=5)

  ! indicate that allocations have already been done,
  ! to allow for cleanup if hoppetStartExtended is
  ! called a second time
  alloc_already_done = .true.

  ! indicate the pdfs and convolutions have not been initialised...
  setup_done = .false.
end subroutine hoppetStartExtended


!! Delete all hoppet objects associated with the streamlined interface,
!! including grid definitions, PDF tables, couplings, etc.
!!
!! NB: this does not delete anything associated with the structure function
!! part of the interface
subroutine hoppetDeleteAll()
  use streamlined_interface
  implicit none
  if (alloc_already_done) then
    call Delete(tables)
    call Delete(dh)
    if (with_qed) call Delete(qed_split)
    call Delete(grid)
    if (coupling_initialised) then
      call Delete(coupling) 
      if (with_qed) call Delete(coupling_qed)
      coupling_initialised = .false.
    end if
    alloc_already_done = .false.
  end if
end subroutine hoppetDeleteAll

!======================================================================
!! Given a pdf_subroutine with the interface shown below, initialise
!! our internal pdf table.
subroutine hoppetAssign(pdf_subroutine)
  use streamlined_interface ! this module which provides access to the array of tables
  implicit none
  interface ! indicate what "interface" pdf_subroutine is expected to have
    !! It expects pdf_subroutine to set components -6:6 with plain QCD evolution,
	  !! but the full size of the flavour dimension if the upper limit
	  !! is anything other than ncompax=7 (e.g. for QED evolution 
	  !! it should go from -6 to ncompmaxLeptons=11).
    subroutine pdf_subroutine(x,Q,res)
       use types; implicit none
       real(dp), intent(in)  :: x,Q
       real(dp), intent(out) :: res(*)
     end subroutine pdf_subroutine
  end interface
  !-----------------------------------

  if (ffn_nf < 0 .and. (.not. coupling_initialised)) then
    call wae_error('hoppetAssign','Since v2 of hoppet, if you assign a PDF with hoppet''s VFN option turned on (default) '//&
    'you must first set the quark masses (hoppetSetPoleMassVFN(...)) and then the coupling (hoppetSetCoupling(...)). ')
  end if

  ! set up table(0) by copying the values returned by pdf_subroutine onto 
  ! the x-Q grid in table(0)
  call FillPdfTable_LHAPDF(tables(0), pdf_subroutine)
  ! indicate that table(0) has been set up
  setup_done(0)  = .true.
  ! indicate that table(1), table(2), etc... (which will contain the
  ! convolutions with splitting matrices) have yet to be set up [they
  ! get set up "on demand" later].
  setup_done(1:) = .false.
end subroutine hoppetAssign

!======================================================================
!! Set up the strong coupling such that alphas(Q)=alphas_Q, with the
!! given number of loops (nloop).
!!
!! The user should have set the quark masses or requested a FFN scheme
!! prior to calling this function.
!!
!! This function is provided mainly for use in conjunction with hoppetAssign.
!! In particular, it has the side effect of modifying the structure of the
!! PDF tables to make sure they know about the mass thresholds.
!!
!! If QED has been requested, a QED coupling will also be set up
!! (its value is not currently configurable from this interface).
!!
!! If you call hoppetEvolve (below), there is no need to separately call
!! hoppetSetCoupling.
subroutine hoppetSetCoupling(alphas_Q,Q,nloop)
  use streamlined_interface
  implicit none
  real(dp), intent(in) :: alphas_Q, Q
  integer, intent(in) :: nloop

  ! get a running coupling with the desired scale
  if (coupling_initialised) then
    call Delete(coupling) 
    if (with_qed) call Delete(coupling_qed)
  end if
  if (ffn_nf > 0) then
     call InitRunningCoupling(coupling, alfas=alphas_Q, Q=Q, nloop=nloop, &
          &                   fixnf=ffn_nf)
  else 
     call InitRunningCoupling(coupling, alfas=alphas_Q, Q=Q, nloop=nloop, &
          &                   quark_masses=masses, &
          &                   masses_are_MSbar = quark_masses_are_MSbar)
  end if
  if(with_qed) then
     call InitQEDCoupling(coupling_qed, effective_light_quark_masses, masses(4:6))
  endif
  call AddNfInfoToPdfTable(tables,coupling)
  coupling_initialised = .true.

end subroutine hoppetSetCoupling

!======================================================================
!! Given a pdf_subroutine with the interface shown below, fill the 
!! table by evolving the PDF from scale Q0pdf, with alphas provided 
!! at scale Q0alphas
subroutine hoppetEvolve(asQ0, Q0alphas, nloop,  muR_Q, pdf_subroutine, Q0pdf)
  use streamlined_interface ! this module which provides access to the array of tables
  use pdf_representation
  implicit none
  real(dp), intent(in) :: asQ0, Q0alphas, muR_Q, Q0pdf
  integer,  intent(in) :: nloop
  interface ! indicate what "interface" pdf_subroutine is expected to have
    !! It expects pdf_subroutine to set components -6:6 with plain QCD evolution,
	  !! but the full size of the flavour dimension if the upper limit
	  !! is anything other than ncompax=7 (e.g. for QED evolution 
	  !! it should go from -6 to ncompmaxLeptons=11).
    subroutine pdf_subroutine(x,Q,res)
       use types; implicit none
       real(dp), intent(in)  :: x,Q
       real(dp), intent(out) :: res(*)
     end subroutine pdf_subroutine
  end interface
  !! hold the initial pdf
  real(dp), pointer :: pdf0(:,:)
  ! create our internal pdf object for the initial condition
  if(with_qed) then
     !write(*,*)'***********HoppetEvolve, before AllocPDFWithLeptons'
     call AllocPDFWithLeptons(grid, pdf0)
  else
     call AllocPDF(grid, pdf0)
  endif

  !write(*,*)'***********HoppetEvolve, before InitPDF_LHAPDF'
  call InitPDF_LHAPDF(grid, pdf0, pdf_subroutine, Q0pdf)

  call hoppetSetCoupling(asQ0,Q0alphas,nloop)

  ! create the tabulation
  if(with_qed) then
     if(muR_Q /= 1) then
        call wae_error("hoppetEvolve", "muR_Q /= 1 not allowed if qed is included")
     endif
     !write(*,*)'***********HoppetEvolve, before EvolvePdfTableQED'
     call EvolvePdfTableQED(tables(0), Q0pdf, pdf0, dh, qed_split, &
          coupling, coupling_qed, nloop, with_nqcdloop_qed, with_Plq_nnloqed)
  else
     call EvolvePdfTable(tables(0), Q0pdf, pdf0, dh, muR_Q=muR_Q, &
          &              coupling=coupling, nloop=nloop)
  endif

  ! indicate that table(0) has been set up
  setup_done(0)  = .true.
  ! indicate that table(1), table(2), etc... (which will contain the
  ! convolutions with splitting matrices) have yet to be set up [they
  ! get set up "on demand" later].
  setup_done(1:) = .false.

  ! clean up
  call Delete(pdf0) 
  
end subroutine hoppetEvolve


!======================================================================
!! Prepare a cached evolution
subroutine hoppetPreEvolve(asQ0, Q0alphas, nloop, muR_Q, Q0pdf)
  use streamlined_interface
  implicit none
  real(dp), intent(in) :: asQ0, Q0alphas, muR_Q, Q0pdf
  integer,  intent(in) :: nloop

  if (with_qed) call wae_error("hoppetPreEvolve","Does not support QED evolution")

  ! get a running coupling with the desired scale
  if (coupling_initialised) call Delete(coupling) 
  if (ffn_nf > 0) then
     call InitRunningCoupling(coupling, alfas=asQ0, Q=Q0alphas, nloop=nloop, &
          &                   fixnf=ffn_nf)
  else 
     call InitRunningCoupling(coupling, alfas=asQ0, Q=Q0alphas, nloop=nloop, &
          &                   quark_masses=masses)
  end if
  call AddNfInfoToPdfTable(tables,coupling)
  coupling_initialised = .true.

  ! create the tabulation
  call PreEvolvePdfTable(tables(0), Q0pdf, dh, muR_Q=muR_Q, &
       &                 coupling=coupling, nloop=nloop)
end subroutine hoppetPreEvolve


!======================================================================
!! Carry out a cached evolution based on the initial condition
!! that can be obtained from pdf_subroutine at the scale Q0pdf set in
!! PreEvolve
subroutine hoppetCachedEvolve(pdf_subroutine)
  use streamlined_interface
  implicit none
  interface ! indicate what "interface" pdf_subroutine is expected to have
     subroutine pdf_subroutine(x,Q,res)
       use types; implicit none
       real(dp), intent(in)  :: x,Q
       real(dp), intent(out) :: res(*)
     end subroutine pdf_subroutine
  end interface
  !! hold the initial pdf
  real(dp), pointer :: pdf0(:,:)

  if (with_qed) call wae_error("hoppetCachedEvolve","Does not support QED evolution")

  ! create our internal pdf object for the initial condition
  call AllocPDF(grid, pdf0)
  call InitPDF_LHAPDF(grid, pdf0, pdf_subroutine, tables(0)%StartScale)

  ! create the tabulation
  call EvolvePdfTable(tables(0), pdf0)

  ! indicate that table(0) has been set up
  setup_done(0)  = .true.
  ! indicate that table(1), table(2), etc... (which will contain the
  ! convolutions with splitting matrices) have yet to be set up [they
  ! get set up "on demand" later].
  setup_done(1:) = .false.

  ! clean up
  call Delete(pdf0)
end subroutine hoppetCachedEvolve


!======================================================================
!! Return the coupling at scale Q
function hoppetAlphaS(Q)
  use streamlined_interface ! this module which provides access to the array of tables
  use warnings_and_errors
  implicit none
  real(dp)             :: hoppetAlphaS
  real(dp), intent(in) :: Q

  if (.not. coupling_initialised) call wae_error('hoppetAlphaS',&
       &'coupling is not yet initialised (and will remain so until',&
       &'first call to an evolution routine).')
  hoppetAlphaS = Value(coupling, Q)
end function hoppetAlphaS


!======================================================================
!! Set up things to be a fixed-flavour number scheme with the given
!! fixed_nf number of flavours
subroutine hoppetSetFFN(fixed_nf)
  use streamlined_interface ! this module which provides access to the array of tables
  implicit none
  integer,  intent(in) :: fixed_nf

  ffn_nf = fixed_nf
end subroutine hoppetSetFFN


!======================================================================
!! Set up things to be a variable-flavour number scheme with the given
!! quark masses in the pole mass scheme.
!!
!! This interface retained for legacy purposes. Preferred interface is
!! via hoppetSetPoleMassVFN(mc,mb,mt)
subroutine hoppetSetVFN(mc,mb,mt)
  use streamlined_interface ! this module which provides access to the array of tables
  implicit none
  real(dp) :: mc, mb, mt
  call hoppetSetPoleMassVFN(mc,mb,mt)
end subroutine hoppetSetVFN


!======================================================================
!! Set up things to be a variable-flavour number scheme with the given
!! quark masses in the pole mass scheme. Thresholds are crossed at the
!! pole masses, both for the coupling and the PDF evolution.
subroutine hoppetSetPoleMassVFN(mc,mb,mt)
  use streamlined_interface ! this module which provides access to the array of tables
  implicit none
  real(dp) :: mc, mb, mt

  ffn_nf = -1
  masses = (/mc,mb,mt/)
  quark_masses_are_MSbar = .false.
end subroutine hoppetSetPoleMassVFN


!======================================================================
!! Set up things to be a variable-flavour number scheme with the given
!! quark masses in the MSbar mass scheme, i.e. m(m). Thresholds are
!! crossed at the MSbar masses, both for the coupling and the PDF
!! evolution.
subroutine hoppetSetMSbarMassVFN(mc,mb,mt)
  use streamlined_interface ! this module which provides access to the array of tables
  implicit none
  real(dp) :: mc, mb, mt

  ffn_nf = -1
  masses = (/mc,mb,mt/)
  quark_masses_are_MSbar = .true.
end subroutine hoppetSetMSbarMassVFN

!======================================================================
!! Arrange for the use of exact NNLO splitting and mass-threshold
!! functions.
subroutine hoppetSetExactDGLAP(exact_nfthreshold, exact_splitting)
  use streamlined_interface ! this module which provides access to the array of tables
  implicit none
  logical :: exact_nfthreshold, exact_splitting

  if(exact_nfthreshold) call dglap_Set_nnlo_nfthreshold(nnlo_nfthreshold_exact)
  if(exact_splitting) call dglap_Set_nnlo_splitting(nnlo_splitting_exact)

end subroutine hoppetSetExactDGLAP

subroutine hoppetSetExactDGLAP_c(exact_nfthreshold, exact_splitting) bind(C,name="hoppetSetExactDGLAP_c")
  use streamlined_interface ! this module which provides access to the array of tables
  use iso_c_binding
  implicit none
  logical(c_bool) :: exact_nfthreshold, exact_splitting
  logical :: exact_nfthreshold_f, exact_splitting_f

  exact_nfthreshold_f = merge(.true._1,.false._1,exact_nfthreshold)
  exact_splitting_f = merge(.true._1,.false._1,exact_splitting)

  call hoppetSetExactDGLAP(exact_nfthreshold_f, exact_splitting_f)

end subroutine hoppetSetExactDGLAP_c

!======================================================================
!! Arrange for the use of various approximate N3LO splitting functions.
subroutine hoppetSetApproximateDGLAPN3LO(splitting_variant)
  ! splitting_variant can be one of
  ! n3lo_splitting_approximation_up_to_2310_05744
  ! n3lo_splitting_approximation_up_to_2404_09701 
  ! n3lo_splitting_approximation_up_to_2410_08089 (default)
  use streamlined_interface ! this module which provides access to the array of tables
  implicit none
  integer :: splitting_variant

  call dglap_Set_n3lo_splitting_approximation(splitting_variant)

end subroutine hoppetSetApproximateDGLAPN3LO
!======================================================================

!! Arrange for the use of N3LO splitting functions, either exact (not currently available), parametrised not currently available) or based on upper or lower values of the aproximation
subroutine hoppetSetSplittingN3LO(splitting_variant)
  ! splitting_variant can be one of
  !n3lo_splitting_exact = -2;
  !n3lo_splitting_param = -1;
  !n3lo_splitting_Nfitav   =  0;
  !n3lo_splitting_Nfiterr1 =  1;
  !n3lo_splitting_Nfiterr2 =  2;
  use streamlined_interface ! this module which provides access to the array of tables
  implicit none
  integer :: splitting_variant

  call dglap_Set_n3lo_splitting(splitting_variant)

end subroutine hoppetSetSplittingN3LO

!! Arrange for the use of N3LO splitting functions, either exact (not currently available), parametrised not currently available) or based on upper or lower values of the aproximation
subroutine hoppetSetSplittingNNLO(splitting_variant)
  ! splitting_variant can be one of
  !nnlo_splitting_exact = -2;
  !nnlo_splitting_param = -1;
  !nnlo_splitting_Nfitav   =  0;
  !nnlo_splitting_Nfiterr1 =  1;
  !nnlo_splitting_Nfiterr2 =  2;
  use streamlined_interface ! this module which provides access to the array of tables
  implicit none
  integer :: splitting_variant

  call dglap_Set_nnlo_splitting(splitting_variant)

end subroutine hoppetSetSplittingNNLO


!======================================================================
!! Arrange for the use of N3LO mass thresholds or not.
subroutine hoppetSetN3LOnfthresholds(variant)
  ! variant can be one of
  ! integer, parameter, public :: n3lo_nfthreshold_on  = 1
  ! integer, parameter, public :: n3lo_nfthreshold_off = 0
  use streamlined_interface ! this module which provides access to the array of tables
  implicit none
  integer :: variant

  call dglap_Set_n3lo_nfthreshold(variant)

end subroutine hoppetSetN3LOnfthresholds

!======================================================================
!! Override the default interpolation order in y and lnlnQ. Should be
!! called before hoppetStart
subroutine hoppetSetYLnlnQInterpOrders(yorder, lnlnQorder)
  ! Defaults are
  ! yorder = -1 (hoppet makes a sensible choice in the ranges 4 to 10)
  ! lnlnQorder = 4
  ! For fast cubic interpolation with similar accuracy to LHAPDF one can set
  ! yorder = 3
  ! lnlnQorder = 3
  use streamlined_interface ! this module which provides access to the array of tables
  implicit none
  integer :: yorder, lnlnQorder

  call PdfTableOverrideInterpOrders(yorder, lnlnQorder)
  !call PDFTableSetYInterpOrder(yorder)
  def_lnlnQ_order = lnlnQorder

end subroutine hoppetSetYLnlnQInterpOrders




!======================================================================
!! Assuming this is called with an array starting at index -6, return in f(-6:6) 
!! the value of the internally stored pdf at the
!! given x,Q, with the usual LHApdf meanings for the indices -6:6.
!!
!! If QED has been enabled, the indices that will be set are 
!! f(-6:ncompmaxLeptons), where ncompmaxLeptons=11.
!! NB: f(7) is a dummy entry, f(8) is the photon and f(9:11) are 
!! of (e+ + e-), (mu+ + mu-) and (tau+ + tau-)
subroutine hoppetEval(x,Q,f)
  use streamlined_interface; use pdf_representation
  implicit none
  real(dp), intent(in)  :: x, Q
  ! the interface does pass the size of the array, but the functions we
  ! call have interfaces that do need the size; so here give it a dummy
  ! value that is the largest that could ever be used. The functions
  ! that we call will fill -6:6 with normal QCD evolution set and
  ! -6:ncompmaxLeptons with QED evolution set.
  !real(dp), intent(out) :: f(-6:ncompmaxLeptons) ! QED-TBD [check it still works without QED]
  !call EvalPdfTable_xQ(tables(0),x,Q,f)

  real(dp), intent(out) :: f(*) ! QED-TBD [check it still works without QED]
  call EvalPdfTable_xQ(tables(0),x,Q,f(1:tables(0)%tab_iflv_max-ncompmin+1))
end subroutine hoppetEval

!======================================================================
!! Assuming this is called with an array starting at index -6, return in f(-6:6) 
!! the value of the internally stored pdf at the
!! given x,Q, and for the hoppet iflv (iflv_glu, etc. as defined in pdf_representation.f90)
function hoppetEvalIFlv(x,Q,iflv) 
  use streamlined_interface; use pdf_representation
  implicit none
  real(dp), intent(in)  :: x, Q
  integer, intent(in) :: iflv
  real(dp) :: hoppetEvalIFlv

  hoppetEvalIFlv = EvalPdfTable_xQf(tables(0),x,Q,iflv)
end function hoppetEvalIFlv



!======================================================================
!! Return in f(-6:6) the value of 
!!
!!    [P(iloop,nf) \otimes pdf] (x,Q)
!!
!! where P(iloop,nf) is the iloop-splitting function for the given
!! value of nf, and pdf is our internally stored pdf.
!!
!! The normalisation is such that the nloop dglap evolution equation is
!!
!!     dpdf/dlnQ^2 = sum_{iloop=1}^nloop 
!!                        (alphas/(2*pi))^iloop * P(iloop,nf) \otimes pdf
!!
!! Note that each time nf changes relative to a previous call for the
!! same iloop, the convolution has to be repeated for the whole
!! table. So for efficient results when requiring multiple nf values,
!! calls with the same nf value should be grouped together.
!!
!! In particular, for repeated calls with the same value of nf, the
!! convolutions are carried out only on the first call (i.e. once for
!! each value of iloop). Multiple calls with different values for
!! iloop can be carried out without problems.
!!
!! Note that iloop can also be of the form ij or ijk, which means
!! P(i)*P(j)*pdf or P(i)*P(j)*P(k)*pdf. The sum of i+j+k is currently
!! bounded to be <= 4.
!!
!! The number of loops must be consistent with iloop
subroutine hoppetEvalSplit(x,Q,iloop,nf,f)
  use streamlined_interface; use warnings_and_errors
  implicit none
  real(dp), intent(in)  :: x, Q
  integer,  intent(in)  :: iloop, nf
  real(dp), intent(out) :: f(-6:6)
  integer :: iQ, tabindex

  if (with_qed) call wae_error("hoppetEvalSplit","Does not support QED evolution")

  tabindex = tableIndexValue(iloop, nf)
  call EvalPdfTable_xQ(tables(tabindex),x,Q,f)

end subroutine hoppetEvalSplit

!======================================================================
!! Write out the contents of tables(0) (assumed to be the PDF) in the
!! LHAPDF format
!! 
!! - basename: the basename of the LHAPDF file; the full name will be
!!   basename_nnnn.dat, where nnnn is given by pdf_index.
!!   
!! - pdf_index is the index that will be used for the LHAPDF .dat file
!!   If it is zero, the routing will also output the .info file and
!!   and the .dat will be declared a central member; otherwise the
!!   .dat file will be declared an error member.
subroutine hoppetWriteLHAPDFGrid(basename, pdf_index)
  use streamlined_interface; use warnings_and_errors
  implicit none
  character(len=*),       intent(in) :: basename
  integer,                intent(in) :: pdf_index

  if(.not.setup_done(0)) call wae_error("hoppetWriteLHAPDFgrid:"&
       &,"Trying to write out contents of tables(0) from the&
       & streamlined interface, but the table has not been filled.&
       & Did you forget to run hoppetAssign or hoppetEvolve?")

  call WriteLHAPDFFromPdfTable(tables(0), coupling, basename, pdf_index)
  
end subroutine hoppetWriteLHAPDFGrid


subroutine hoppetWriteLHAPDFWithLen(basename_len, basename, pdf_index) bind(C, name="hoppetwritelhapdfwithlen_")
  use streamlined_interface; use warnings_and_errors
  use iso_c_binding
  implicit none
  integer(c_int), value :: basename_len
  character(kind=c_char), dimension(*), intent(in) :: basename
  integer(c_int), value :: pdf_index
  character(len=:), allocatable :: f_basename
  integer :: i

  ! Convert C string to Fortran string
  allocate(character(len=basename_len) :: f_basename)
  do i = 1, basename_len
    f_basename(i:i) = basename(i)
  end do

  call hoppetWriteLHAPDFGrid(f_basename, pdf_index)
  deallocate(f_basename)
end subroutine hoppetWriteLHAPDFWithLen

!======================================================================
!! The dummy PDF suggested by Vogt as the initial condition for the 
!! unpolarized evolution, subsequently adopted in a wide range of
!! of benchmarks
subroutine hoppetBenchmarkPDFunpol(x, Q, xpdf)
  use streamlined_interface; use warnings_and_errors
  implicit none
  real(dp) :: x, Q, xpdf(-6:6)
  
  call benchmark_pdf_unpolarized_lha(x, Q, xpdf)

end subroutine hoppetBenchmarkPDFunpol

  

! An example in Fortran90 showing how to replace LHAPDF interpolation with
! (faster) hoppet interpolation using the streamlined interface
!

module time_format
  use hoppet_term
  implicit none

  character(len=*), parameter :: tfmt = '("'//blue//'",a,f8.2,a,"'//reset//'")'
end module time_format


program lhapdf_to_hoppet_allmembers
  use hoppet, EvolvePDF_hoppet => EvolvePDF, InitPDF_hoppet => InitPDF ! Avoid namespace clashes with LHAPDF
  use streamlined_interface, InitPDF_hoppet => InitPDF
  use hoppet_lhapdf
  use hoppet_to_string
  use time_format
  use new_as
  use pdf_tabulate

  implicit none
  character(len=200) :: pdfname
  integer :: imem
  real(dp) :: x, Q, lhapdf(-6:6), hoppetpdf(-6:6)
  real(dp), allocatable :: hoppetpdf1D(:,:), values(:)
  integer, parameter :: npoints = 500
  real(dp), parameter :: xmin = 1d-5, xmax = 0.9_dp, Qmin = 1.5_dp, Qmax = 100000.0_dp
  real(dp) :: central, err_up, err_down, err_symm
  real(dp), allocatable :: xvals(:), qvals(:)
  real(dp), external :: hoppetAlphaS, alphasPDF, hoppetEvalIFlv
  real(dp) :: aslhapdf, ashoppet
  integer :: i, j
  character(len=*), parameter :: dfmt = '(f10.6)'
  real(dp) :: t1, t2
  external :: InitPDF

  ! Interface to LHAPDF as needed by hoppetAssign

  pdfname = "PDF4LHC21_40"
  call LoadLHAPDFSet(pdfname)
  !call load_lhapdf_assign_many_hoppet(trim(pdfname))
  x = 0.01_dp
  Q = 13.0_dp
 
  ! Standard LHAPDF call
  call initPDF(0) ! load the central member
  call EvolvePDF(x, Q, lhapdf) ! Get the PDF from LHAPDF

  ! Equivalent hoppet call
  call EvalPdfTable_xQ(lhapdf_set%tables(0), x, Q, hoppetpdf)  
  !call hoppetEval(x, Q, hoppetpdf)

  ! Print the two PDFs
  write(*,'(a)') bold // "PDFs at x = " // to_string(x,dfmt) // ", Q = " // to_string(Q,dfmt) // reset
  write(*,'(a,11f12.8)') "LHAPDF(-5:5): ", lhapdf(-5:5)
  write(*,'(a,11f12.8)') "Hoppet(-5:5): ", hoppetpdf(-5:5)
  write(*,'(a,11f12.8)') "Difference  : ", hoppetpdf(-5:5)-lhapdf(-5:5)


  !!------- check that we get the same uncertainty as direct calls to LHAPDF
  allocate(hoppetpdf1D(-6:6,0:ubound(lhapdf_set%tables,1) ))
  allocate(values(0:ubound(lhapdf_set%tables,1)))
  call EvalPdfTable_xQ(lhapdf_set%tables(:), x, Q, hoppetpdf1D(:,:))
  call GetPDFUncertainty(hoppetpdf1D(iflv_g,:), central, err_up, err_down, err_symm)
  do imem = 0, ubound(values,1)
    call initPDF(imem)
    call EvolvePDF(x, Q, lhapdf)
    values(imem) = lhapdf(iflv_g)
  end do
  call GetPDFUncertainty(values(0:), central, err_up, err_down, err_symm)
  write(*,'(a)') 'LHAPDF gluon: central = '//to_string(central,dfmt)// &
                ', err_up = '//to_string(err_up,dfmt)// &
                ', err_down = '//to_string(err_down,dfmt)// &
                ', err_symm = '//to_string(err_symm,dfmt)

  write(*,'(a)') 'HOPPET gluon: central = '//to_string(central,dfmt)// &
                ', err_up = '//to_string(err_up,dfmt)// &
                ', err_down = '//to_string(err_down,dfmt)// &
                ', err_symm = '//to_string(err_symm,dfmt)

  write(*,*) ! a blank line for clarity

  !!------- carry out timing tests
  allocate(xvals(npoints), qvals(npoints))
  do i = 1, npoints
    xvals(i) = exp(log(xmin) + (i-1) * (log(xmax) - log(xmin)) / real(npoints-1, dp))
    qvals(i) = exp(log(Qmin) + (i-1) * (log(Qmax) - log(Qmin)) / real(npoints-1, dp))
  end do

  ! Benchmark hoppetEval
  ! All flavours at once
  call cpu_time(t1)
  write(*,'(a,i4,a)') bold//"Timing evaluation of all", size(lhapdf_set%tables), " PDF members with HOPPET"//reset
  do i = 1, npoints
    do j = 1, npoints
      do imem = 0, ubound(lhapdf_set%tables,1)
        call EvalPdfTable_xQ(lhapdf_set%tables(imem), xvals(i), qvals(j), hoppetpdf)
      end do
    end do
  end do
  call cpu_time(t2)
  write(*,tfmt) blue//"EvalPdfTable_xQ(0D) time per mem (all flav): ", (t2-t1)/npoints/npoints*1d9/size(lhapdf_set%tables), " ns"//reset


  call cpu_time(t1)
  !write(*,*) "Benchmarking all", size(many_tables), " PDF members"
  do i = 1, npoints
    do j = 1, npoints
      call EvalPdfTable_xQ(lhapdf_set%tables(:), xvals(i), qvals(j), hoppetpdf1D(:,:))
    end do
  end do
  call cpu_time(t2)
  write(*,tfmt) blue//"EvalPdfTable_xQ(1D) time per mem (all flav): ", (t2-t1)/npoints/npoints*1d9/size(lhapdf_set%tables), " ns"//reset


  !! ! One flavour at a time
  !! call cpu_time(t1)
  !! do i = 1, npoints
  !!   do j = 1, npoints
  !!     hoppetpdf(0) = hoppetEvalIFlv(xvals(i), qvals(j), mod(j,6))
  !!     ! if pdf_tabulate is "use"d, this is slightly faster
  !!     !hoppetpdf(0) = EvalPdfTable_xQf(tables(0),xvals(i),qvals(j),mod(j,6))
  !!   end do
  !! end do
  !! call cpu_time(t2)
  !! write(*,tfmt) "hoppetEvalIFlv time (one flav): ", (t2-t1)/npoints/npoints*1d9, " ns"

  ! Benchmark EvolvePDF (LHAPDF)
  write(*,'(a,i4,a)') bold//"Timing evaluation of all", size(lhapdf_set%tables), " PDF members with LHAPDF"//reset
  call cpu_time(t1)
  do i = 1, npoints
    do j = 1, npoints
      do imem = 0, ubound(lhapdf_set%tables,1)
        call InitPDF(imem) ! load the table into hoppet
        call EvolvePDF(xvals(i), qvals(j), lhapdf)
      end do
    end do
  end do
  call cpu_time(t2)
  write(*,tfmt) "LHAPDF EvolvePDF time per mem (all flav): ", (t2-t1)/npoints/npoints*1d9/size(lhapdf_set%tables), " ns"

  ! Now let's check the timing of hoppetAlphaS vs LHAPDF alphaS
  write(*,'(a)') bold//"Timing alpha_s"//reset

  call cpu_time(t1)
  do i = 1, npoints
    do j = 1, npoints
      ashoppet = hoppetAlphaS(qvals(j))
      !! GPS M2Pro 2025-09-06: this variant saves only 0.4ns per call
      !! out of about 31.7
      !ashoppet = na_Value(coupling%nah, qvals(j))
      !ashoppet = na_Value_faster(coupling%nah, qvals(j))
      !if (i == 1) write(6,*) qvals(j), hoppetAlphaS(qvals(j)), na_Value_faster(coupling%nah, qvals(j))
    end do
  end do
  call cpu_time(t2)
  write(*,tfmt) "hoppet alphaS time: ", (t2-t1)/npoints/npoints*1d9, " ns"
  
  call cpu_time(t1)
  do i = 1, npoints
    do j = 1, npoints
      aslhapdf = alphasPDF(qvals(j))
      !alphasPDF(qvals(j))
    end do
  end do
  call cpu_time(t2)
  write(*,tfmt) "LHAPDF alphaS time: ", (t2-t1)/npoints/npoints*1d9, " ns" 
  write(*,*) ! a blank line for clarity

  call hoppetDeleteAll()

end program lhapdf_to_hoppet_allmembers

module hoppet_pdf_table_array
  use types
  use pdf_tabulate
  use iso_c_binding
  implicit none
  
  type pdf_table_array
    type(pdf_table), allocatable :: tables(:) ! array of tables
  end type pdf_table_array

contains 

  !! creates a pdf_table_array object with space for ntables tables, indexed 0..ntables-1
  !! and returns a c_ptr to it
  function hoppet_pta_create(ntables) bind(c,name="hoppet_pta_create") result(ptr)
    integer(c_int), intent(in) :: ntables
    type(c_ptr) :: ptr

    type(pdf_table_array), pointer :: obj
    allocate(obj)
    allocate(obj%tables(0:ntables-1))    
    ptr = c_loc(obj)
  end function hoppet_pta_create

  !! returns the size of the array of tables in the pdf_table_array object pointed to by ptr
  function hoppet_pta_size(ptr) bind(c,name="hoppet_pta_size") result(sz)
    type(c_ptr), value, intent(in) :: ptr
    integer(c_int) :: sz

    type(pdf_table_array), pointer :: obj
    call c_f_pointer(ptr, obj)
    sz = size(obj%tables)
  end function hoppet_pta_size

end module hoppet_pdf_table_array

!! module with 
module hoppet_splitting_function_interfaces
  use types, only: dp
  use convolution, only: conv_ignd
  implicit none
  private
  

  !! the interface for MVV functions like X2NSPA etc in xpns2e etc.
  !! 
  !! Note that the arguments are const in practice, but not
  !! declared as such, so to ensure we match the exact form
  !! of the functions in the splitting function modules
  abstract interface
    !! returns P(x) for given nf
    real(dp) function P_x_nfint(x, nf) 
      import dp
      implicit none
      real(dp) :: x   !< x value
      integer  :: nf  !< number of light flavours
    end function P_x_nfint
  end interface

  !! a type that holds pointers to the regular, plus and delta parts
  !! of an MVV splitting function and implements the conv_ignd%f(y,piece) 
  !! interface
  !!
  !! Users would typically create an mvv_splitting_function via the
  !! as 
  !!
  !!     mvv_splitting_function(P2GGA, P2GGB , P2GGC , 0.5_dp**3)
  !!
  !! where the last argument is the multiplier, e.g. here to convert from
  !! (alpha_s/4pi)**order to (alpha_s/2pi)**order
  !!
  !! Where a part is not present, the corresponding argument should be null()
  !! e.g. 
  !!
  !!     mvv_splitting_function(P2QGA, null(), null(), 0.5_dp**3)
  !!
  type, extends(conv_ignd) :: mvv_splitting_function
    procedure(P_x_nfint), pointer, nopass :: reg   => null()  !< A, regular part 
    procedure(P_x_nfint), pointer, nopass :: plus  => null()  !< B, plus part
    procedure(P_x_nfint), pointer, nopass :: delta => null()  !< C, delta-function part (call with x=0)    
    real(dp) :: multiplier !< multiplier for the function
  contains
    procedure :: f => mvv_splitting_function__f  !< f(y=ln1/x, piece)
  end type mvv_splitting_function
  
  public :: mvv_splitting_function, P_x_nfint

contains


  !! implementation of the mvv_splitting_function%f
  function mvv_splitting_function__f(this, y, piece) result(res)
    use qcd, only: nf_int
    use convolution_pieces
    class(mvv_splitting_function), intent(in) :: this
    real(dp),                      intent(in) :: y
    integer,                       intent(in) :: piece
    real(dp) :: res
    real(dp) :: x
    integer  :: nf_lcl

    x = exp(-y)
    nf_lcl = nf_int ! get the global nf_int
    res = 0.0_dp

    select case(piece)
    case(cc_REAL)
      if (associated(this%reg  )) res =       this%reg (x, nf_lcl)
      if (associated(this%plus )) res = res + this%plus(x, nf_lcl)
    case(cc_REALVIRT)
      if (associated(this%reg  )) res = res + this%reg (x, nf_lcl)
    case(cc_VIRT)
      if (associated(this%plus )) res =     - this%plus(x, nf_lcl)
    case(cc_DELTA)
      if (associated(this%delta)) res =       this%delta(0.0_dp, nf_lcl)
    end select
    if (piece /= cc_DELTA) res = res * x

    res = res * this%multiplier

    !write(6,*) y, piece, nf_lcl, res
  end function mvv_splitting_function__f
end module hoppet_splitting_function_interfaces

!! program to test implementation of MSbar-mass thresholds
!!
!!
program msbar_tests
  use hoppet; use io_utils
  implicit none
  !-- for alpha_s
  type(running_coupling) :: coupling_pole, coupling_ms
  real(dp) :: asQ0, Q0, asQ_ms, asQ_pole, Q, dt
  real(dp) :: pole_masses(3), msbar_masses(3)
  real(dp) :: test_scales(4) = (/1.0_dp, 3.0_dp, 10.0_dp, 200.0_dp /)
  integer  :: i
  !-- for PDFs
  type(grid_def) :: grid
  type(dglap_holder) :: dh
  type(pdf_table)    :: table_pole, table_ms
  real(dp), pointer  :: pdf_init(:,:), pdf_final(:,:)
  real(dp) :: x, pdf_pole(-6:6), pdf_ms(-6:6)
  integer  :: iflv


  dt = dble_val_opt("-dt", 0.2_dp)
  call SetDefaultCouplingDt(dt)

  Q0 = 3.0_dp
  asQ0 = dble_val_opt('-asQ0',0.255786_dp)

  pole_masses(1:3) = (/1.414213563_dp, 4.5_dp, 175.0_dp /)
  
  ! get a coupling with pole masses
  call InitRunningCoupling(coupling_pole, asQ0, Q0, nloop=3, quark_masses = pole_masses,&
       &                   masses_are_MSbar = .false.)
  
  ! get the conversion of pole masses to MSbar masses (requires an initialised coupling)
  do i = 1, 3
    msbar_masses(i) = pole_masses(i)*(1 - four/three/pi*value(coupling_pole, pole_masses(i)))
    write(6,*) 'pole, MSbar masses are:', pole_masses(i), msbar_masses(i)
  end do

  ! get the coupling with the MSbar masses
  call InitRunningCoupling(coupling_ms, asQ0, Q0, nloop=3, quark_masses = msbar_masses,&
       &                   masses_are_MSbar = .true.)

  ! verify that the difference between the two couplings scales as as^4
  ! (since matching is provided at relative O(as^2), i.e. absolute as^3)
  do i = 1, size(test_scales)
    Q = test_scales(i)
    asQ_pole = value(coupling_pole, Q)
    asQ_ms = value(coupling_ms, Q)
    write(6,*) 'Q, as(Q,pole), as(Q,msbar):', &
         & Q, asQ_pole, asQ_ms, (asQ_pole-asQ_ms)/asQ0**4
  end do
  

  !======================================================================
  ! now set up 
  call SetDefaultEvolutionDu(0.05_dp)
  call InitGridDef(grid,ymax=10.0_dp, dy=0.1_dp,order=-5)
  call InitDglapHolder(grid,dh,nloop=3,nflo=3,nfhi=6)
  call AllocPDF(grid, pdf_init)
  call AllocPDF(grid, pdf_final)
  pdf_init = unpolarized_dummy_pdf(xValues(grid))

  call AllocPDFTable(grid, table_pole, 1.0_dp, 1e4_dp)
  call AddNfInfoToPDFTable(table_pole, coupling_pole)
  !call EvolvePDFTable(table_pole, Q0, pdf_init, dh, coupling_pole)
  call PreEvolvePDFTable(table_pole, Q0, dh, coupling_pole)

  call AllocPDFTable(grid, table_ms, 1.0_dp, 1e4_dp)
  call AddNfInfoToPDFTable(table_ms, coupling_ms)
  !call EvolvePDFTable(table_ms, Q0, pdf_init, dh, coupling_ms)
  call PreEvolvePDFTable(table_ms, Q0, dh, coupling_ms)


  call EvolvePDFTable(table_pole, pdf_init)
  call EvolvePDFTable(table_ms, pdf_init)
  
  x = 1e-1_dp
  iflv = int_val_opt("-iflv",0)
  
  do i = 1, size(test_scales)
    Q = test_scales(i)
    call EvalPDFTable_xQ(table_pole, x, Q, pdf_pole)
    call EvalPDFTable_xQ(table_ms  , x, Q, pdf_ms)
    write(6,*) 'Q, pdf_pole(iflv), pdf_ms(iflv):', &
         & Q, pdf_pole(iflv), pdf_ms(iflv), (pdf_pole(iflv)-pdf_ms(iflv))/asQ0**3
  end do



contains
  !======================================================================
  !! The dummy PDF suggested by Vogt as the initial condition for the 
  !! unpolazrized evolution
  function unpolarized_dummy_pdf(xvals) result(pdf)
    real(dp), intent(in) :: xvals(:)
    real(dp)             :: pdf(size(xvals),ncompmin:ncompmax)
    real(dp) :: uv(size(xvals)), dv(size(xvals))
    real(dp) :: ubar(size(xvals)), dbar(size(xvals))
    !---------------------
    real(dp), parameter :: N_g = 1.7_dp, N_ls = 0.387975_dp
    real(dp), parameter :: N_uv=5.107200_dp, N_dv = 3.064320_dp
    real(dp), parameter :: N_db = half*N_ls
  
    pdf = zero
    ! clean method for labelling as PDF as being in the human representation
    call LabelPdfAsHuman(pdf)

    !-- remember that these are all xvals*q(xvals)
    uv = N_uv * xvals**0.8_dp * (1-xvals)**3
    dv = N_dv * xvals**0.8_dp * (1-xvals)**4
    dbar = N_db * xvals**(-0.1_dp) * (1-xvals)**6
    ubar = dbar * (1-xvals)
    pdf(:,iflv_g) = N_g * xvals**(-0.1_dp) * (1-xvals)**5
        
    pdf(:,-iflv_s) = 0.2_dp*(dbar + ubar)
    pdf(:, iflv_s) = pdf(:,-iflv_s)
    pdf(:, iflv_u) = uv + ubar
    pdf(:,-iflv_u) = ubar
    pdf(:, iflv_d) = dv + dbar
    pdf(:,-iflv_d) = dbar
  end function unpolarized_dummy_pdf

end program msbar_tests

!!
!! Module generated automatically by ../scripts/NameSelect.pl ../src/dglap_choices.f90
!! Provides conversion from string codes to integer codes
!!
module NameSelect
  use dglap_choices
  
  implicit none
  private

  public :: CodeOfName
  public :: NameOfCode
  public :: code_val_opt

  integer, parameter :: maxlen_name = 180
  integer, parameter, public :: NameSelect_maxlen_name = maxlen_name

contains

  !!
  !! Returns the code associated with 'name'; if status dummy arg
  !! is present a non-zero result indicates failure to find the name.
  !! Otherwise failure results in a hard error.
  !!
  function CodeOfName(name, status) result(code)
    character(len=*), intent(in)   :: name
    integer                        :: code
    integer, optional, intent(out) :: status

    if (present(status)) status = 0

    ! now follows code generated specifically for above used modules
    select case(trim(name))
    case('nnlo_splitting_exact')
      code = nnlo_splitting_exact
    case('nnlo_splitting_param')
      code = nnlo_splitting_param
    case('nnlo_splitting_Nfitav')
      code = nnlo_splitting_Nfitav
    case('nnlo_splitting_Nfiterr1')
      code = nnlo_splitting_Nfiterr1
    case('nnlo_splitting_Nfiterr2')
      code = nnlo_splitting_Nfiterr2
    case('n3lo_splitting_exact')
      code = n3lo_splitting_exact
    case('n3lo_splitting_param')
      code = n3lo_splitting_param
    case('n3lo_splitting_Nfitav')
      code = n3lo_splitting_Nfitav
    case('n3lo_splitting_Nfiterr1')
      code = n3lo_splitting_Nfiterr1
    case('n3lo_splitting_Nfiterr2')
      code = n3lo_splitting_Nfiterr2
    case('n3lo_splitting_approximation_up_to_2310_05744')
      code = n3lo_splitting_approximation_up_to_2310_05744
    case('n3lo_splitting_approximation_up_to_2404_09701')
      code = n3lo_splitting_approximation_up_to_2404_09701
    case('n3lo_splitting_approximation_up_to_2410_08089')
      code = n3lo_splitting_approximation_up_to_2410_08089
    case('nnlo_nfthreshold_exact')
      code = nnlo_nfthreshold_exact
    case('nnlo_nfthreshold_param')
      code = nnlo_nfthreshold_param
    case('n3lo_nfthreshold_on')
      code = n3lo_nfthreshold_on
    case('n3lo_nfthreshold_off')
      code = n3lo_nfthreshold_off
    case('factscheme_MSbar')
      code = factscheme_MSbar
    case('factscheme_DIS')
      code = factscheme_DIS
    case('factscheme_PolMSbar')
      code = factscheme_PolMSbar
    case('factscheme_FragMSbar')
      code = factscheme_FragMSbar
    case default
      if (present(status)) then
        status = -1
      else
        write(0,*) 'ERROR. CodeOfName: unrecognized name "'//name//'"'
        stop
      endif
    end select
  end function CodeOfName


  ! standard code (independent of used modules)
  !!
  !! looks for the command-line argument 'option' and if it is
  !! present its value (optionally prefixed with 'prefix') is
  !! fed to CodeOfName
  !!
  function code_val_opt(option, default, prefix) result(code)
    use io_utils
    character(len=*),           intent(in) :: option
    integer, optional,          intent(in) :: default
    character(len=*), optional, intent(in) :: prefix
    integer                                :: code
    !---------------------------------------
    character(len=maxlen_name) :: opt_val

    if (log_val_opt(option)) then
       opt_val = string_val_opt(option)
       if (present(prefix)) then
         code = CodeOfName(prefix//trim(opt_val))
       else
         code = CodeOfName(trim(opt_val))
       end if
    else
       if (present(default)) then
          code = default
       else
          write(0,*) 'Error in code_val_opt: command-line option '&
               &//option//' absent and no default provided'
       end if
    end if
  end function code_val_opt

  !!
  !! Returns the name of the given integer code which has
  !! the (optional) specified prefix
  !!
  function NameOfCode(code,prefix,longname) result(name)
    integer,          intent(in)            :: code
    character(len=*), intent(in),  optional :: prefix
    character(len=*), intent(out), optional :: longname
    character(len=maxlen_name)              :: name
    !----------------------------------------------
    integer :: nocc

    nocc = 0
    if (present(longname)) longname = ''

    ! code specific to used modules starts here
    if (PrefixMatches('nnlo_splitting_exact',prefix) &
        .and. code == nnlo_splitting_exact) then
       nocc = nocc + 1; name = 'nnlo_splitting_exact'
    end if

    if (PrefixMatches('nnlo_splitting_param',prefix) &
        .and. code == nnlo_splitting_param) then
       nocc = nocc + 1; name = 'nnlo_splitting_param'
    end if

    if (PrefixMatches('nnlo_splitting_Nfitav',prefix) &
        .and. code == nnlo_splitting_Nfitav) then
       nocc = nocc + 1; name = 'nnlo_splitting_Nfitav'
    end if

    if (PrefixMatches('nnlo_splitting_Nfiterr1',prefix) &
        .and. code == nnlo_splitting_Nfiterr1) then
       nocc = nocc + 1; name = 'nnlo_splitting_Nfiterr1'
    end if

    if (PrefixMatches('nnlo_splitting_Nfiterr2',prefix) &
        .and. code == nnlo_splitting_Nfiterr2) then
       nocc = nocc + 1; name = 'nnlo_splitting_Nfiterr2'
    end if

    if (PrefixMatches('n3lo_splitting_exact',prefix) &
        .and. code == n3lo_splitting_exact) then
       nocc = nocc + 1; name = 'n3lo_splitting_exact'
    end if

    if (PrefixMatches('n3lo_splitting_param',prefix) &
        .and. code == n3lo_splitting_param) then
       nocc = nocc + 1; name = 'n3lo_splitting_param'
    end if

    if (PrefixMatches('n3lo_splitting_Nfitav',prefix) &
        .and. code == n3lo_splitting_Nfitav) then
       nocc = nocc + 1; name = 'n3lo_splitting_Nfitav'
    end if

    if (PrefixMatches('n3lo_splitting_Nfiterr1',prefix) &
        .and. code == n3lo_splitting_Nfiterr1) then
       nocc = nocc + 1; name = 'n3lo_splitting_Nfiterr1'
    end if

    if (PrefixMatches('n3lo_splitting_Nfiterr2',prefix) &
        .and. code == n3lo_splitting_Nfiterr2) then
       nocc = nocc + 1; name = 'n3lo_splitting_Nfiterr2'
    end if

    if (PrefixMatches('n3lo_splitting_approximation_up_to_2310_05744',prefix) &
        .and. code == n3lo_splitting_approximation_up_to_2310_05744) then
       nocc = nocc + 1; name = 'n3lo_splitting_approximation_up_to_2310_05744'
    end if

    if (PrefixMatches('n3lo_splitting_approximation_up_to_2404_09701',prefix) &
        .and. code == n3lo_splitting_approximation_up_to_2404_09701) then
       nocc = nocc + 1; name = 'n3lo_splitting_approximation_up_to_2404_09701'
    end if

    if (PrefixMatches('n3lo_splitting_approximation_up_to_2410_08089',prefix) &
        .and. code == n3lo_splitting_approximation_up_to_2410_08089) then
       nocc = nocc + 1; name = 'n3lo_splitting_approximation_up_to_2410_08089'
    end if

    if (PrefixMatches('nnlo_nfthreshold_exact',prefix) &
        .and. code == nnlo_nfthreshold_exact) then
       nocc = nocc + 1; name = 'nnlo_nfthreshold_exact'
    end if

    if (PrefixMatches('nnlo_nfthreshold_param',prefix) &
        .and. code == nnlo_nfthreshold_param) then
       nocc = nocc + 1; name = 'nnlo_nfthreshold_param'
    end if

    if (PrefixMatches('n3lo_nfthreshold_on',prefix) &
        .and. code == n3lo_nfthreshold_on) then
       nocc = nocc + 1; name = 'n3lo_nfthreshold_on'
    end if

    if (PrefixMatches('n3lo_nfthreshold_off',prefix) &
        .and. code == n3lo_nfthreshold_off) then
       nocc = nocc + 1; name = 'n3lo_nfthreshold_off'
    end if

    if (PrefixMatches('factscheme_MSbar',prefix) &
        .and. code == factscheme_MSbar) then
       nocc = nocc + 1; name = 'factscheme_MSbar'
    end if

    if (PrefixMatches('factscheme_DIS',prefix) &
        .and. code == factscheme_DIS) then
       nocc = nocc + 1; name = 'factscheme_DIS'
    end if

    if (PrefixMatches('factscheme_PolMSbar',prefix) &
        .and. code == factscheme_PolMSbar) then
       nocc = nocc + 1; name = 'factscheme_PolMSbar'
    end if

    if (PrefixMatches('factscheme_FragMSbar',prefix) &
        .and. code == factscheme_FragMSbar) then
       nocc = nocc + 1; name = 'factscheme_FragMSbar'
    end if

    ! common-code resumes
    if (nocc == 0) then
       if (present(prefix)) then
          write(0,*) 'Error in NameOfCode: could not find code',&
               &code,' with prefix "'//prefix//'"'
       else
          write(0,*) 'Error in NameOfCode: could not find code',&
               &code,' (without prefix)'
       end if
       stop
    end if

    if (nocc > 1) then
       if (present(prefix)) then
          write(0,*) 'Error in NameOfCode: several meanings for code',&
               &code,' with prefix "'//prefix//'"'
       else
          write(0,*) 'Error in NameOfCode: several meanings for code',&
               &code,' (without prefix)'
       end if
       stop
    end if

  end function NameOfCode



  !!
  !! for establishing whether a prefix matches a given string
  !!
  logical function PrefixMatches(string,prefix)
    character(len=*), intent(in)           :: string
    character(len=*), intent(in), optional :: prefix

    if (present(prefix)) then
       PrefixMatches = (index(string,prefix) == 1)
    else
       PrefixMatches = .true.
    end if
  end function PrefixMatches


end module NameSelect

!******************************************************************************
!* This file is part of libome                                                *
!* Copyright (C) 2025 Arnd Behring, Kay Schoenwald                            *
!* SPDX-License-Identifier: GPL-3.0-or-later                                  *
!******************************************************************************

program FortranExample
  use, intrinsic :: iso_c_binding
  implicit none

  interface
    function ome_AqqQNSEven_reg(as, LM, NF, x) bind(C, name="ome_AqqQNSEven_reg") result(res)
      import c_double
      real(c_double), value, intent(in) :: as, LM, NF, x
      real(c_double) :: res
    end function
  end interface

  real(kind=kind(1d0)) :: pi, as, m2, mu2, NF, LM, x

  ! Pi
  pi = 3.1415926535897932d0
  ! strong coupling, as = \alpha_s/(4 \pi)
  as = 0.118d0/(4d0*pi)
  ! squared quark mass (on-shell scheme)
  m2 = 1.59d0**2
  ! squared renormalisation scale
  mu2 = 100.d0**2
  ! number of massless quark flavours
  NF = 3d0
  ! precompute the mass logarithm
  LM = log(m2/mu2)
  ! Bjorken x
  x = 0.2

  write (*,*) ome_AqqQNSEven_reg(as, LM, NF, x)
end program

!! program to test parton luminosities
!!
!!
module lumi_elements
  use hoppet
  use integrator
  use interpolation
  implicit none

  real(dp), pointer :: gq_copy(:), gq2_copy(:)
  type(grid_def) :: grid_copy
  real(dp) :: y_copy

contains

  !----------------------------------------------------------------------
  ! a straightforward dgauss integration of the two PDFs to get the lumi
  ! function at a specific x value
  function lumi_dgauss(grid, gq1, gq2, y) result(res)
    type(grid_def), intent(in) :: grid
    real(dp),        intent(in), target  :: gq1(0:), gq2(0:)
    real(dp), intent(in) :: y
    real(dp) :: res
    gq_copy => gq1
    gq2_copy => gq2
    grid_copy = grid
    y_copy = y

    res = ig_LinWeight(lumi_dgauss_integrand, zero, y, one, one, 1e-10_dp)
  end function lumi_dgauss
  

  function lumi_dgauss_integrand(y) result(res)
    real(dp), intent(in) :: y
    real(dp) :: res

    res = EvalGridQuant(grid_copy, gq_copy, y) &
         &       * EvalGridQuant(grid_copy, gq2_copy, y_copy-y)
  end function lumi_dgauss_integrand
  


  recursive subroutine conv_AddGridConv_alt(gc, gq)
    type(grid_conv), intent(inout) :: gc
    real(dp),        intent(in), target    :: gq(0:)

    gq_copy => gq
    grid_copy = gc%grid
    call AddWithCoeff(gc, conv_AddGridConv_integrand)
  end subroutine conv_AddGridConv_alt
  
  function conv_AddGridConv_integrand(y) result(res)
    use convolution_communicator
    real(dp), intent(in) :: y
    real(dp)             :: res
    
    select case(cc_piece)
    case(cc_REAL,cc_REALVIRT)
       res = EvalGridQuant(grid_copy, gq_copy, y)
    end select
    select case(cc_piece)
    case(cc_VIRT,cc_REALVIRT)
       res = res - zero
    case(cc_DELTA)
       res = zero
    end select
  end function conv_AddGridConv_integrand
  
  !----------------------------------------------------------------------
  ! a simple routine for testing the polypoly integrator
  subroutine polypoly_test()
    integer, parameter :: nA = 5, nB = 6
    real(dp) :: nodesA(nA), nodesB(nB), result, piece
    real(dp) :: matrix(size(nodesA),size(nodesB))
    integer :: i, j
    nodesA = (/ (0.37_dp*i-1.0_dp, i = 1, nA) /)
    nodesB = (/ (2.0_dp-0.89_dp*i, i = 1, nB) /)
    matrix = ig_UniPolyPolyMatrix(zero, half, nodesA, nodesB)
    result = 0.0_dp
    do i = 1, size(nodesA)
      do j = 1, size(nodesB)
        piece = ig_PolyPoly(zero, half, nodesA, i, nodesB, j)
        !write(0,*) i, j, piece, matrix(i,j)
        result = result + piece
      end do
    end do
    
    write(0,*) result, sum(matrix)

  end subroutine polypoly_test
  

  !----------------------------------------------------------------------
  !! function that integrates the product of two interpolation
  !! polynomials, specified by nodesA and nodesB and the "1" nodes
  !! inodeA_one and inodeB_one
  !!
  Recursive FUNCTION ig_PolyPoly(A,B,nodesA,inodeA_one,&
       &                             nodesB,inodeB_one) result(cgauss64)
    real(dp), intent(in) :: A,B,nodesA(:),nodesB(:)
    integer,  intent(in) :: inodeA_one, inodeB_one
    real(dp) :: zero_nodesA(size(nodesA)-1)
    real(dp) :: zero_nodesB(size(nodesB)-1)
    real(dp) :: norm_nodes
    integer  :: i, j
    REAL(dp) :: AA,BB,U,C1,C2,S8,S16,H, CGAUSS64, pmult,mmult,Const
    real(dp), parameter :: z1 = 1, hf = half*z1, cst = 5*Z1/1000
    real(dp) :: X(12), W(12)
    CHARACTER(len=*), parameter ::  NAME = 'cgauss64'
    
    DATA X( 1) /9.6028985649753623D-1/, W( 1) /1.0122853629037626D-1/ 
    DATA X( 2) /7.9666647741362674D-1/, W( 2) /2.2238103445337447D-1/ 
    DATA X( 3) /5.2553240991632899D-1/, W( 3) /3.1370664587788729D-1/ 
    DATA X( 4) /1.8343464249564980D-1/, W( 4) /3.6268378337836198D-1/ 
    DATA X( 5) /9.8940093499164993D-1/, W( 5) /2.7152459411754095D-2/ 
    DATA X( 6) /9.4457502307323258D-1/, W( 6) /6.2253523938647893D-2/ 
    DATA X( 7) /8.6563120238783174D-1/, W( 7) /9.5158511682492785D-2/ 
    DATA X( 8) /7.5540440835500303D-1/, W( 8) /1.2462897125553387D-1/ 
    DATA X( 9) /6.1787624440264375D-1/, W( 9) /1.4959598881657673D-1/ 
    DATA X(10) /4.5801677765722739D-1/, W(10) /1.6915651939500254D-1/ 
    DATA X(11) /2.8160355077925891D-1/, W(11) /1.8260341504492359D-1/ 
    DATA X(12) /9.5012509837637440D-2/, W(12) /1.8945061045506850D-1/ 

    !-- first set up the structure for the polynomial interpolation--
    j = 0
    do i = 1, size(nodesA)
       if (i /= inodeA_one) then
          j = j + 1
          zero_nodesA(j) = nodesA(i)
       end if
    end do
    j = 0
    do i = 1, size(nodesB)
       if (i /= inodeB_one) then
          j = j + 1
          zero_nodesB(j) = nodesB(i)
       end if
    end do
    norm_nodes = 1.0_dp / product(nodesA(inodeA_one) - zero_nodesA)
    norm_nodes = norm_nodes / product(nodesB(inodeB_one) - zero_nodesB)

    H=0 
    IF(B .EQ. A) GO TO 99 
    CONST=CST/ABS(B-A) 
    BB=A 
1   AA=BB 
    BB=B 
2   C1=HF*(BB+AA) 
    C2=HF*(BB-AA) 
    ! Gaussian integration with 8 points should work up to
    ! order 16, so we only need the 8-point version if the
    ! polynomial we're integrating isn't of too high order
    if (size(nodesA)+size(nodesB) < 15) then
      S8=0 
      DO I = 1,4 
        U=C2*X(I) 
        pmult = product(c1+u - zero_nodesA)*product(c1+u - zero_nodesB)
        mmult = product(c1-u - zero_nodesA)*product(c1-u - zero_nodesB)
        S8=S8+W(I)*(pmult+mmult) * norm_nodes
      end do
      H = S8*C2
    else
      S16=0 
      DO I = 5,12 
        U=C2*X(I) 
        pmult = product(c1+u - zero_nodesA)*product(c1+u - zero_nodesB)
        mmult = product(c1-u - zero_nodesA)*product(c1-u - zero_nodesB)
        S16=S16+W(I)*(pmult+mmult) * norm_nodes
      end do
      H = C2*S16 
    end if
    !write(0,*) C2*S8, C2*S16
99  cgauss64=H 
  end function ig_PolyPoly


  !======================================================================
  !> Given two sets of uniformly spaced nodes, nodesA and nodesB, that are
  !> used for interpolating, return the integral of the matrix of 
  !> interpolating functions.
  Recursive FUNCTION ig_UniPolyPolyMatrix(A,B,nodesA, nodesB) result(H)
    real(dp), intent(in) :: A,B,nodesA(:),nodesB(:)
    real(dp) :: H(size(nodesA),size(nodesB))
    real(dp) :: weightsA(size(nodesA)), weightsB(size(nodesB))
    integer  :: i
    real(dp) :: spacingA, spacingB
    REAL(dp) :: AA,BB,U,C1,C2,Const
    real(dp), parameter :: z1 = 1, hf = half*z1, cst = 5*Z1/1000
    real(dp) :: X(12), W(12), WC2
    CHARACTER(len=*), parameter ::  NAME = 'ig_UniPolyPolyMatrix'
    real(dp), parameter :: spacing_eps = 1e-10_dp

    DATA X( 1) /9.6028985649753623D-1/, W( 1) /1.0122853629037626D-1/ 
    DATA X( 2) /7.9666647741362674D-1/, W( 2) /2.2238103445337447D-1/ 
    DATA X( 3) /5.2553240991632899D-1/, W( 3) /3.1370664587788729D-1/ 
    DATA X( 4) /1.8343464249564980D-1/, W( 4) /3.6268378337836198D-1/ 
    DATA X( 5) /9.8940093499164993D-1/, W( 5) /2.7152459411754095D-2/ 
    DATA X( 6) /9.4457502307323258D-1/, W( 6) /6.2253523938647893D-2/ 
    DATA X( 7) /8.6563120238783174D-1/, W( 7) /9.5158511682492785D-2/ 
    DATA X( 8) /7.5540440835500303D-1/, W( 8) /1.2462897125553387D-1/ 
    DATA X( 9) /6.1787624440264375D-1/, W( 9) /1.4959598881657673D-1/ 
    DATA X(10) /4.5801677765722739D-1/, W(10) /1.6915651939500254D-1/ 
    DATA X(11) /2.8160355077925891D-1/, W(11) /1.8260341504492359D-1/ 
    DATA X(12) /9.5012509837637440D-2/, W(12) /1.8945061045506850D-1/ 

    ! preconditions: nodes must have size >=2 and involve uniform spacing
    if (size(nodesA) < 2 .or. size(nodesB) < 2) then
      write(0,*) "Error: ig_UniPolyPolyMatrix requires both node sets to have size > 1"
      stop
    end if
    spacingA = nodesA(2) - nodesA(1)
    do i = 2, size(nodesA)-1
      if (abs(nodesA(i+1)-nodesA(i) - spacingA) > spacing_eps) then
        write(0,*) "Error in ig_UniPolyPolyMatrix: nodesA were not uniform "
        stop
      end if
    end do
    spacingB = nodesB(2) - nodesB(1)
    do i = 2, size(nodesB)-1
      if (abs(nodesB(i+1)-nodesB(i) - spacingB) > spacing_eps) then
        write(0,*) "Error in ig_UniPolyPolyMatrix: nodesB were not uniform "
        stop
      end if
    end do
    

    H=0 
    IF(B .EQ. A) return
    CONST=CST/ABS(B-A) 
    BB=A 
1   AA=BB 
    BB=B 
2   C1=HF*(BB+AA) 
    C2=HF*(BB-AA) 
    ! Gaussian integration with 8 points should work up to
    ! order 16, so we only need the 8-point version if the
    ! polynomial we're integrating isn't of too high order
    if (size(nodesA)+size(nodesB) < 15) then
      DO I = 1,4 
        U=C2*X(I) 
        WC2 = W(I)*C2
        
        call uniform_interpolation_weights((c1+u-nodesA(1))/spacingA,weightsA)
        call uniform_interpolation_weights((c1+u-nodesB(1))/spacingB,weightsB)
        H = H + spread(WC2*weightsA,dim=2,ncopies=size(weightsB))*&
             &  spread(    weightsB,dim=1,ncopies=size(weightsA))

        call uniform_interpolation_weights((c1-u-nodesA(1))/spacingA,weightsA)
        call uniform_interpolation_weights((c1-u-nodesB(1))/spacingB,weightsB)
        H = H + spread(WC2*weightsA,dim=2,ncopies=size(weightsB))*&
             &  spread(    weightsB,dim=1,ncopies=size(weightsA))

        !pmult = product(c1+u - zero_nodesA)*product(c1+u - zero_nodesB)
        !mmult = product(c1-u - zero_nodesA)*product(c1-u - zero_nodesB)
        !S8=S8+W(I)*(pmult+mmult)
      end do
    else
      DO I = 5,12 
        U=C2*X(I) 
        WC2 = W(I)*C2

        call uniform_interpolation_weights((c1+u-nodesA(1))/spacingA,weightsA)
        call uniform_interpolation_weights((c1+u-nodesB(1))/spacingB,weightsB)
        H = H + spread(WC2*weightsA,dim=2,ncopies=size(weightsB))*&
             &  spread(     weightsB,dim=1,ncopies=size(weightsA))

        call uniform_interpolation_weights((c1-u-nodesA(1))/spacingA,weightsA)
        call uniform_interpolation_weights((c1-u-nodesB(1))/spacingB,weightsB)
        H = H + spread(WC2*weightsA,dim=2,ncopies=size(weightsB))*&
             &  spread(     weightsB,dim=1,ncopies=size(weightsA))

        !pmult = product(c1+u - zero_nodesA)*product(c1+u - zero_nodesB)
        !mmult = product(c1-u - zero_nodesA)*product(c1-u - zero_nodesB)
        !S16=S16+W(I)*(pmult+mmult) 
      end do
    end if
  end function ig_UniPolyPolyMatrix
  

  recursive subroutine conv_AddGridConv_plain(gc, gq)
    type(grid_conv), intent(inout) :: gc
    real(dp),        intent(in)    :: gq(0:)
    integer :: ny, isub
    ny = assert_eq(gc%grid%ny, ubound(gq,1),"conv_AddGridConv_gq")
    if (gc%grid%nsub == 0) then
      gc%conv(:,1) = gq * gc%grid%dy
    else
      do isub = 1, gc%grid%nsub
        call conv_AddGridConv_plain(gc%subgc(isub), &
                  &              gq(gc%grid%subiy(isub):gc%grid%subiy(isub+1)-1))
      end do
    end if
  end subroutine conv_AddGridConv_plain
  
  recursive subroutine conv_AddGridConv_gq(gc, gq)
    type(grid_conv), intent(inout) :: gc
    real(dp),        intent(in)    :: gq(0:)
    real(dp), allocatable :: matrix(:,:), nodesA(:), nodesB(:)
    integer :: ny, isub, i, j, k, order, n

    ny = assert_eq(gc%grid%ny, ubound(gq,1),"conv_AddGridConv_gq")
    if (gc%grid%nsub == 0) then
      ! now prepare an interpolating setup
      order = abs(gc%grid%order)
      allocate(matrix(order+1, order+1))
      allocate(nodesA(order+1))
      allocate(nodesB(order+1))
      nodesA = (/ (j,  j=0, order) /) * gc%grid%dy
      nodesB = (/ (1-j,j=0, order) /) * gc%grid%dy
      do i = 1, order+1
        do j = 1, order+1
          matrix(i,j) = ig_PolyPoly(zero, gc%grid%dy, nodesA, i, nodesB, j)
        end do
      end do
      gc%conv(:,1) = zero
      do i = 0, ny-1
        !     6-5-4-3-2-1-0        PDF with which we will later convolute
        !           ==========      <- interpolation region (point where add to conv)
        !           ---             <- integration region             |
        !     =========             <- interpolation region           ^
        !         0-1-2-3-4-5-6    PDF converted to splitting fn      k
        do j = 1, order+1
          k = i + j-1          ! entry in conv
          if (k > ny) exit
          n = min(order+1,i+2) ! number of gq entries to use
          gc%conv(k,1) = gc%conv(k,1) + sum(matrix(j,1:n) * gq(i+1:i-n+2:-1))
          !write(0,*) ny, i, j, k, n, gq(i), sum(matrix(:,:)), sum(matrix(j,1:n) * gq(i:i-n+1:-1))
        end do
      end do
      !gc%conv(:,1) = gq * gc%grid%dy
      !write(0,*) gc%conv(20,1), gq(20) * gc%grid%dy
      !write(0,*) 'matrix: ', matrix
    else
      do isub = 1, gc%grid%nsub
        call conv_AddGridConv_gq(gc%subgc(isub), &
                  &              gq(gc%grid%subiy(isub):gc%grid%subiy(isub+1)-1))
      end do
    end if
    
  end subroutine conv_AddGridConv_gq
  
  !======================================================================
  !> Evaluate luminosity using tricks to improve accuracy of the multi-grid
  !> case. In particular for a fine grid going from 0:yfine, the coarse
  !> lumi evaluation uses the fine grid information up to 2*yfine, with
  !> interpolation (according to grid%order) of the coarser grid in the regions
  !> where fine information is lacking.
  !> 
  function lumi_multi(grid, gq1, gq2) result(lumi)
    type(grid_def), intent(in) :: grid
    real(dp), intent(in) :: gq1(0:), gq2(0:)
    real(dp)             :: lumi(0:ubound(gq1,1))
    !-----------------------
    type(grid_def), pointer :: fine, coarse
    integer  :: isub, iy, step


    ! if the grid doesn't have the right structure, we just give up
    if (grid%nsub == 0 .or. .not. grid%locked) then
      ! get our usual guess for the luminosity function and then return
      lumi = lumi_plain(grid, gq1, gq2)
      return
    end if

    ! first do lowest isub (has finest spacing)
    lumi(0:grid%subgd(1)%ny) = lumi_plain(grid%subgd(1), &
         &                                gq1(0:grid%subgd(1)%ny), &
         &                                gq2(0:grid%subgd(1)%ny))

    ! then do non-trivial bits isub by isub
    do isub = 1, grid%nsub-1
      ! write(6,'(a,i5)') '# isub = ', isub
      fine => grid%subgd(isub)
      coarse => grid%subgd(isub+1)
      call lumi_multi_do_sub(fine,&
           &                 gq1(grid%subiy(isub):grid%subiy(isub)+fine%ny),&
           &                 gq2(grid%subiy(isub):grid%subiy(isub)+fine%ny),&
           &                 coarse,&
           &                 gq1(grid%subiy(isub+1):grid%subiy(isub+1)+coarse%ny),&
           &                 gq2(grid%subiy(isub+1):grid%subiy(isub+1)+coarse%ny),&
           &                 lumi(grid%subiy(isub+1):grid%subiy(isub+1)+coarse%ny))
    end do

    !-- decant information from finer grids into coarser grids (just copied from 
    !   conv_ConvGridQuant_scalar)
    ! (remember: finest grid has lowest isub)
    do isub = 2, grid%nsub
      ! the ratio should be an exact integer, but use
      ! nint() to avoid the dangers of rounding errors
      step = nint(grid%subgd(isub)%dy / grid%subgd(isub-1)%dy)
      do iy = 0, grid%subgd(isub-1)%ny / step
        lumi(grid%subiy(isub)+iy) = lumi(grid%subiy(isub-1)+iy*step)
      end do
    end do
    
  end function lumi_multi
  
  !----------------------------------------------------------------------
  !> helper function for lumi_multi, which is responsible for handling
  !> the combined use of fine and coarse grids.
  subroutine lumi_multi_do_sub(grid_fine, gq1_fine, gq2_fine,&
       &                       grid_coarse, gq1_coarse, gq2_coarse, lumi_coarse)
    type(grid_def), intent(in) :: grid_fine, grid_coarse
    real(dp), intent(in) :: gq1_fine(0:), gq2_fine(0:)
    real(dp), intent(in) :: gq1_coarse(0:), gq2_coarse(0:)
    real(dp), intent(inout) :: lumi_coarse(0:)
    !--------------------------------------
    integer  :: ny_fine, ny_coarse, max_ny_coarse
    real(dp) :: gq1_tmp(0:2*ubound(gq1_fine,1))
    real(dp) :: gq2_tmp(0:2*ubound(gq2_fine,1))
    !real(dp) :: gq1_tmp(0:nint(grid_coarse%dy / grid_fine%dy)*grid_coarse%ny)
    !real(dp) :: gq2_tmp(0:nint(grid_coarse%dy / grid_fine%dy)*grid_coarse%ny)
    integer  :: order, range_up, range_down, range_down_last
    integer, parameter :: nmax = 9 ! max order, as uniform_interpolation_weights
    !real(dp) :: weights(0:nmax,nint(grid_coarse%dy / grid_fine%dy)-1)
    real(dp) :: weights(0:nmax,nint(grid_coarse%dy / grid_fine%dy)-1)
    integer  :: i, step, iy_coarse, iy_fine
    integer  :: offset, last_offset

    step = nint(grid_coarse%dy / grid_fine%dy)

    ! make sure the ny we use is a multiple of step
    ny_coarse = (grid_fine%ny/step)
    ny_fine   = ny_coarse * step

    ! first copy the high-resolution piece across to a temporary array
    gq1_tmp(0:ny_fine) = gq1_fine(0:ny_fine)
    gq2_tmp(0:ny_fine) = gq2_fine(0:ny_fine)
    
    ! next get take the low resolution part and interpolate it
    ! first establish the appropriate range
    max_ny_coarse = min(2*ny_coarse, grid_coarse%ny)
    !max_ny_coarse = grid_coarse%ny
    
    ! decide where we will interpolate
    order = abs(grid_coarse%order)
    if (grid_coarse%ny < order) call wae_error("lumi_multi_do_sub",&
         &"grid_coarse%ny < order, grid_fine%dy = ", dbleval=grid_fine%dy)

    ! first do the trivial points
    gq1_tmp(ny_fine+step:max_ny_coarse*step:step) = &
         &                      gq1_coarse(ny_coarse+1:max_ny_coarse)
    gq2_tmp(ny_fine+step:max_ny_coarse*step:step) = &
         &                      gq2_coarse(ny_coarse+1:max_ny_coarse)

    ! populate the fine grids by interpolation
    last_offset = 2000000000 ! semaphore for first round
    do iy_coarse = ny_coarse, max_ny_coarse-1
      range_down = max(0, iy_coarse-(order)/2)
      range_up   = min(grid_coarse%ny, range_down + order)
      range_down = range_up - order  ! our order check earlier on ensures saftey here
      offset = iy_coarse-range_down
      
      ! now get the weights
      do i = 1, step-1
        if (offset /= last_offset) then
          ! NB: with a tiny bit more work, could avoid repetitive determination
          !     of interpolation weights; but for now ignore this 
          call uniform_interpolation_weights(i*(one/step)+offset, weights(0:order,i))
        end if
        gq1_tmp(iy_coarse*step+i) = sum(weights(0:order,i)*gq1_coarse(range_down:range_up))
        gq2_tmp(iy_coarse*step+i) = sum(weights(0:order,i)*gq2_coarse(range_down:range_up))
      end do
      last_offset = offset
    end do

    ! now do the actual convolutions
    do iy_coarse = ny_coarse+1, max_ny_coarse
      lumi_coarse(iy_coarse) = sum(gq1_tmp(0:iy_coarse*step)&
           &                        * gq2_tmp(iy_coarse*step:0:-1)) * grid_fine%dy
    end do

    ! and then the rest
    do iy_coarse = max_ny_coarse+1, grid_coarse%ny
      lumi_coarse(iy_coarse) = sum(gq1_coarse(0:iy_coarse)&
           &                        * gq2_coarse(iy_coarse:0:-1)) * grid_coarse%dy
    end do
    
    ! ! for testing
    ! do iy_fine = 0, max_ny_coarse*step
    !   write(6,*) iy_fine * grid_fine%dy, gq1_tmp(iy_fine), gq2_tmp(iy_fine)
    ! end do
    ! write(6,*)
    ! write(6,*)
    

  end subroutine lumi_multi_do_sub
  

  !======================================================================
  !> Evaluate luminosity in a multi-grid context, always using
  !> the finer grid to perform the large-z and large x/z parts of the 
  !> integration. 
  !> 
  !> This function is NOT MATURE
  function lumi_multi2(grid, gq1, gq2) result(lumi)
    type(grid_def), intent(in) :: grid
    real(dp), intent(in) :: gq1(0:), gq2(0:)
    real(dp)             :: lumi(0:ubound(gq1,1))
    !-----------------------
    type(grid_def), pointer :: fine, coarse
    integer  :: isub, iy, step

    ! get our first guess for the luminosity function
    lumi = lumi_plain(grid, gq1, gq2)

    ! if the grid doesn't have the right structure, we just give up
    if (grid%nsub == 0 .or. .not. grid%locked) return

    ! patch things up isub by isub (lowest isub has finest spacing)
    do isub = 1, grid%nsub-1
      ! write(6,'(a,i5)') '# isub = ', isub
      fine => grid%subgd(isub)
      coarse => grid%subgd(isub+1)
      call lumi_multi2_do_sub(fine,&
           &                 gq1(grid%subiy(isub):grid%subiy(isub)+fine%ny),&
           &                 gq2(grid%subiy(isub):grid%subiy(isub)+fine%ny),&
           &                 coarse,&
           &                 gq1(grid%subiy(isub+1):grid%subiy(isub+1)+coarse%ny),&
           &                 gq2(grid%subiy(isub+1):grid%subiy(isub+1)+coarse%ny),&
           &                 lumi(grid%subiy(isub+1):grid%subiy(isub+1)+coarse%ny))
    end do

    !-- decant information from finer grids into coarser grids
    call lumi_lock(grid,lumi)
  end function lumi_multi2

  !----------------------------------------------------------------------
  subroutine lumi_multi2_do_sub(fine, gq1_fine, gq2_fine,&
       &                        coarse, gq1_coarse, gq2_coarse, lumi_coarse)
    type(grid_def), intent(in) :: fine, coarse
    real(dp), intent(in) :: gq1_fine(0:), gq2_fine(0:)
    real(dp), intent(in) :: gq1_coarse(0:), gq2_coarse(0:)
    real(dp), intent(inout) :: lumi_coarse(0:)
    !--------------------------------------
    real(dp) :: convolutor1(0:abs(coarse%order), 0:coarse%ny)
    real(dp) :: convolutor2(0:abs(coarse%order), 0:coarse%ny)
    real(dp) :: bin
    integer  :: i, j, n
    
    integer :: offset = 2

    call lumi_multi2_convert(fine, coarse, gq1_fine, gq1_coarse, convolutor1)
    call lumi_multi2_convert(fine, coarse, gq2_fine, gq2_coarse, convolutor2)
    
    lumi_coarse(0) = zero
    do i = 1, coarse%ny  ! could up lower limit here given that we'll decant
      lumi_coarse(i) = zero
      ! DEBUGGING:
      !  - it sort of works OK when j is odd
      !  - fails 
      do j = 0, (i-1)/2 ! only i/2 because we symmetrise between 1*2 and 2*1
        n = min(i+offset-j, abs(coarse%order)) ! ensure don't go below lower bound
        bin =  sum(convolutor1(0:n,j)*gq2_coarse(i+offset-j:i+offset-j-n:-1)) +&
             & sum(convolutor2(0:n,j)*gq1_coarse(i+offset-j:i+offset-j-n:-1))
        if (j == i/2) bin = bin * half
        lumi_coarse(i) = lumi_coarse(i) + bin
      end do
      
    end do
    
  end subroutine lumi_multi2_do_sub
  

  !----------------------------------------------------------------------
  !> Take a grid quantity with fine and coarse binnings and convert it
  !> into a "convolutor" to be used specifically for carrying out lumi
  !> convolutions. (Structure still to be determined)
  subroutine lumi_multi2_convert(fine, coarse, gq_fine, gq_coarse, convolutor)
    type(grid_def), intent(in) :: fine, coarse
    real(dp), intent(in)  :: gq_fine(0:)
    real(dp), intent(in)  :: gq_coarse(0:)
    real(dp), intent(out) :: convolutor(0:, 0:)
    !-----------------------------------------
    integer  :: ny_fine, ny_coarse, max_ny_coarse, step
    real(dp) :: interp(0:abs(fine%order), 0:abs(coarse%order))
    real(dp) :: interp_coarse(0:abs(fine%order), 0:abs(coarse%order))
    real(dp) :: nodes_fine(0:abs(fine%order)), nodes_coarse(0:abs(coarse%order))
    real(dp) :: nodes_coarse_conv(0:abs(coarse%order))
    integer  :: i, j, n, upper
    integer  :: ii, k, range_up, range_down

    integer :: offset = 2

    ! figure out the number of fine steps per coarse one and the upper
    ! edge of the fine grid in coarse units.
    step = nint(coarse%dy / fine%dy)
    ny_coarse = (fine%ny/step)
    ny_fine   = ny_coarse * step

    if (abs(fine%order)+1 < step) then
      write(0,*) "fine%order+1 < step; temporary simplified approach won't work"
      write(0,*) 'fine%order = ', fine%order, ', step = ', step
      stop
    end if
    
    ! Here we structure the interpolation. First the fine/coarse part
    !
    ! Suppose we have the following fine/coarse structure:
    !
    !                            y=0 (coarse)
    !                    j=0      ^      j=4
    !                     +   +   +   +   +   <- 4th order coarse interpolation
    ! coarse:     |   |   |   |   |
    ! fine:               |||||||||||||||||
    !                    ++++++          <- 5th order fine interpolation
    !                     =====          <- integration region (i=0)
    !                     ^
    !                    y=0 (fine)
    !
    ! Both interpolations extend towards smaller y (potentially going
    ! off beyond y = 0). The above diagram indicates what will fill
    ! the convolutor(j,i) matrix.
    ! 
    forall (i=0:abs(fine%order))   nodes_fine(i) = fine%dy*(step-i)
    forall (i=0:abs(coarse%order)) nodes_coarse(i) = coarse%dy*(i-offset)
    interp = ig_UniPolyPolyMatrix(zero, coarse%dy, nodes_fine, nodes_coarse)
    do i = 0, ny_coarse-1
      n = min((i+1)*step, abs(fine%order)) ! how many fine elements we have
      forall (j=0:abs(coarse%order)) convolutor(j,i) = &
           &     sum(interp(0:n,j)*gq_fine((i+1)*step:(i+1)*step-n:-1))
    end do

!     convolutor = zero
!     forall (i=0:abs(coarse%order)) nodes_coarse(i) = coarse%dy*i
!     do i = 0, ny_coarse-1
!       do ii = 0, step-1
!         range_down = max(0, i*step+ii-abs(fine%order)/2)
!         range_up   = min(fine%ny, range_down+abs(fine%order))
!         range_down = range_up-abs(fine%order)
! 
!         forall (k=range_down:range_up) nodes_fine(k-range_down) = (k-i*step)*fine%dy
!         interp = ig_UniPolyPolyMatrix(ii*fine%dy, &
!              &                        (ii+1)*fine%dy, nodes_fine, nodes_coarse)
! 
!         forall (j=0:abs(coarse%order)) convolutor(j,i) = convolutor(j,i) + &
!              &     sum(interp(:,j)*gq_fine(range_down:range_up))
!       end do
!     end do
    

    ! next we should do the coarse/coarse part of the interpolation
    !                                  y=0 (coarse)
    !                          j=0      ^      j=4
    !                           +   +   +   +   +   <- 4th order coarse interpolation
    ! coarse:   ... |   |   |   |   |   |
    ! coarse_conv:  |||||   |   |   |   |   |   | ...
    !                   +   +   +   +   +      <- 4th order coarse interpolation
    !                           =====          <- integration region (i=XX)
    !                           ^
    !                         y=XX*dy
    !
    ! Note that coarse_conv interpolation is a more symmetric choice
    ! than usual: since we will only ever use the convolutor as far as
    ! ny/2, we need not worry about the interpolation going beyond ny
    ! 
    upper = (abs(coarse%order)+1)/2
    forall (i=0:abs(coarse%order)) nodes_coarse_conv(i) = coarse%dy*(upper-i)
    interp_coarse = ig_UniPolyPolyMatrix(zero,coarse%dy, nodes_coarse_conv, nodes_coarse)
    ! extend only up to ny/2 because beyond we will use the convolutor
    ! from the other flavour to cover the other side of things
    do i = ny_coarse, coarse%ny/2
      n = min(i*upper, abs(coarse%order)) ! how many coarse elements we have
      forall (j=0:abs(coarse%order)) &
           &convolutor(j,i) = sum(interp_coarse(0:n,j)*gq_coarse(i+upper:i+upper-n:-1))
    end do
    
  end subroutine lumi_multi2_convert
  
  

  ! !----------------------------------------------------------------------
  ! function lumi_plain(grid, gq1, gq2) result(lumi)
  !   type(grid_def), intent(in) :: grid
  !   real(dp), intent(in) :: gq1(0:), gq2(0:)
  !   real(dp)             :: lumi(0:ubound(gq1,1))
  !   type(grid_conv) :: gc
  !   call InitGridConv(grid,gc) ! sets it to zero
  !   call conv_AddGridConv_plain(gc, gq1)
  !   lumi = gc .conv. gq2
  ! end function lumi_plain

  !======================================================================
  !> Evaluates the partonic luminosity associated with two grid quantities
  !> gq1 and gq2 using a "plain" method involving a straightforward sum
  !> of the products of the two (oppositely-ordered) vectors.
  !>
  !> This method can only be used for PDFs that go smoothly to zero for y->0.
  !> Reasonable accuracy of the result is then a consequence of the fact that
  !> integrals that go to zero smoothly at both extremities of the integration
  !> region converge as dy^n with n very high, even without any fancy 
  !> higher-order tricks. Actually, fancy higher-order tricks do worse often.
  recursive function lumi_plain(grid, gq1, gq2) result(lumi)
    type(grid_def), intent(in) :: grid
    real(dp), intent(in) :: gq1(0:), gq2(0:)
    real(dp)             :: lumi(0:grid%ny)
    integer :: i, isub, lo, hi, ny

    ny = assert_eq(grid%ny, ubound(gq1,1),ubound(gq2,1),"lumi_plain")
    if (grid%nsub == 0) then
      lumi(0) = zero
      do i = 1, ny
        lumi(i) = sum(gq1(0:i)*gq2(i:0:-1))*grid%dy
      end do
    else 
      do isub = 1, grid%nsub
        lo = grid%subiy(isub)
        hi = lo + grid%subgd(isub)%ny
        lumi(lo:hi) = lumi_plain(grid%subgd(isub), gq1(lo:hi), gq2(lo:hi))
      end do
      if (grid%locked) call lumi_lock(grid,lumi)
    end if
  end function lumi_plain
  
  !----------------------------------------------------------------------
  subroutine lumi_lock(grid, lumi)
    type(grid_def), intent(in) :: grid
    real(dp), intent(inout) :: lumi(0:)
    integer :: isub, step, iy
    !-- decant information from finer grids into coarser grids (just copied from 
    !   conv_ConvGridQuant_scalar)
    ! (remember: finest grid has lowest isub)
    do isub = 2, grid%nsub
      ! the ratio should be an exact integer, but use
      ! nint() to avoid the dangers of rounding errors
      step = nint(grid%subgd(isub)%dy / grid%subgd(isub-1)%dy)
      do iy = 0, grid%subgd(isub-1)%ny / step
        lumi(grid%subiy(isub)+iy) = lumi(grid%subiy(isub-1)+iy*step)
      end do
    end do
  end subroutine lumi_lock
  



  function lumi_simple(grid, gq1, gq2) result(lumi)
    type(grid_def), intent(in) :: grid
    real(dp), intent(in) :: gq1(0:), gq2(0:)
    real(dp)             :: lumi(0:ubound(gq1,1))
    integer :: i, ny

    type(grid_conv) :: gc
    call InitGridConv(grid,gc) ! sets it to zero
    call conv_AddGridConv_gq(gc, gq1)
    !call conv_AddGridConv_alt(gc, gq1)
    !call conv_AddGridConv_plain(gc, gq1)
    !gc%conv(:,1) = gq1*grid%dy
    lumi = gc .conv. gq2

    ! write(0,*) grid%ny, ubound(gq1,1),ubound(gq2,1)
    ! ny = assert_eq(grid%ny, ubound(gq1,1),ubound(gq2,1),"lumi_simple")
    ! if (grid%nsub == 0) then
    !   do i = 0, ny
    !     lumi(i) = sum(gq1(0:i)*gq2(i:0:-1))*grid%dy
    !   end do
    ! end if
  end function lumi_simple
    
  
end module lumi_elements


program lumi_tests
  use hoppet; use io_utils
  use lumi_elements
  implicit none
  !-- for PDFs
  type(grid_def) :: grid, gdarray(4)
  real(dp), pointer  :: pdf(:,:), lumi(:), lumi_p(:)
  real(dp) :: dy, ymax, sum, element, lumi1, lumi2, lumi_p_aty
  integer  :: i, n, order, j
  integer  :: flv1, flv2, repeat

  call polypoly_test()

  dy = dble_val_opt('-dy',0.1_dp)
  ymax = 10.0_dp
  order = int_val_opt("-order",-5)
  flv1 = int_val_opt("-flv1",iflv_g)
  flv2 = int_val_opt("-flv2",iflv_u)
  repeat = int_val_opt("-repeat",1)

  if (log_val_opt("-single-grid")) then
    write(0,*) "grid with single spacing"
    call InitGridDef(grid,ymax=10.0_dp, dy=dy, order=order)
  else
    write(0,*) "grid with multiple spacings"
    call InitGridDef(gdarray(4),dy/27.0_dp, 0.2_dp, order=order)
    call InitGridDef(gdarray(3),dy/9.0_dp,  0.5_dp, order=order)
    call InitGridDef(gdarray(2),dy/3.0_dp,  2.0_dp, order=order)
    call InitGridDef(gdarray(1),dy,         ymax  ,order=order)
    call InitGridDef(grid,gdarray(1:4),locked=.true.)
  end if

  call AllocPDF(grid, pdf)
  call AllocGridQuant(grid, lumi)
  call AllocGridQuant(grid, lumi_p)

  pdf = unpolarized_dummy_pdf(xValues(grid))

  n = ubound(pdf, 1)
  sum = 0.0_dp
  do i = 0, n
    element = pdf(i,iflv_g)*pdf(n-i,iflv_u)
    !write(6,*) i*dy, element
    sum = sum + element
  end do
  sum = sum * dy

  ! do i = 0, n, nint(0.2_dp/grid%dy)
  !   write(6,*) i*grid%dy, lumi(i)
  ! end do
  lumi_p = lumi_plain(grid, pdf(:,flv1), pdf(:,flv2))
  do j = 1, repeat
    lumi = PartonLuminosity(grid, pdf(:,flv1), pdf(:,flv2))
    !lumi = lumi_multi(grid, pdf(:,flv1), pdf(:,flv2))
    !lumi = lumi_plain(grid, pdf(:,flv1), pdf(:,flv2))
  end do

  do i = 0, 50
    lumi1 = EvalGridQuant(grid, lumi, i*0.2_dp)
    lumi_p_aty = EvalGridQuant(grid, lumi_p, i*0.2_dp)
    lumi2 = zero
    ! do j = 1, 1
    !   lumi2 = lumi_dgauss(grid, pdf(:,flv1), pdf(:,flv2), i*0.2_dp) 
    ! end do
    write(6,*) i*0.2_dp, lumi_p_aty, lumi1, lumi2
  end do

contains
  !======================================================================
  !! The dummy PDF suggested by Vogt as the initial condition for the 
  !! unpolazrized evolution
  function unpolarized_dummy_pdf(xvals) result(pdf)
    real(dp), intent(in) :: xvals(:)
    real(dp)             :: pdf(size(xvals),ncompmin:ncompmax)
    real(dp) :: uv(size(xvals)), dv(size(xvals))
    real(dp) :: ubar(size(xvals)), dbar(size(xvals))
    !---------------------
    real(dp), parameter :: N_g = 1.7_dp, N_ls = 0.387975_dp
    real(dp), parameter :: N_uv=5.107200_dp, N_dv = 3.064320_dp
    real(dp), parameter :: N_db = half*N_ls
  
    pdf = zero
    ! clean method for labelling as PDF as being in the human representation
    call LabelPdfAsHuman(pdf)

    !-- remember that these are all xvals*q(xvals)
    uv = N_uv * xvals**0.8_dp * (1-xvals)**3
    dv = N_dv * xvals**0.8_dp * (1-xvals)**4
    dbar = N_db * xvals**(-0.1_dp) * (1-xvals)**6
    ubar = dbar * (1-xvals)
    pdf(:,iflv_g) = N_g * xvals**(-0.1_dp) * (1-xvals)**5
        
    pdf(:,-iflv_s) = 0.2_dp*(dbar + ubar)
    pdf(:, iflv_s) = pdf(:,-iflv_s)
    pdf(:, iflv_u) = uv + ubar
    pdf(:,-iflv_u) = ubar
    pdf(:, iflv_d) = dv + dbar
    pdf(:,-iflv_d) = dbar
  end function unpolarized_dummy_pdf

end program lumi_tests

! program to test our incorporation of the N3LO mass-threshold matching
! code from Johannes Blumlein
program test_blumlein
  use types; use consts_dp
  use blumlein_interfaces
  use mass_thresholds_n3lo
  use vfnsmod
  use daind_fake
  use convolution_communicator
  use splitting_functions
  !use A3PSqq_He
  !use A3Sqg_He
  !use A3PSqq_Hp
  !use A3Sqg_Hp
  use io_utils
  use streamlined_interface
  use dglap_choices
  use vfnsmod
  implicit none
  real(dp) :: GGPLU_a2, GGPLU_a3
  real(dp) :: a4pi(2)= (/0.1_dp, 1.0_dp/), ggplu_arr(2), coeffs(2:3), a2pi
  real(dp) :: x = 0.1_dp, lnmQmu2 = zero, res_aps1, res_aps2, res1, res2, res3
  integer  :: i, momN
  integer  :: nflcl = 4, nf_light, nf_heavy
  real(dp) :: nf_light_dp, nf_heavy_dp
  type(comparator) :: comparators(11)
  type(JB) :: A2Sgg_H
  type(JB) :: A3Sgg_H
  type(JB) :: A3NSm_H
  type(grid_conv) :: gc_A2Sgg_H_JB, gc_A2Sgg_H_HP, gc_A3Sgg_H, gc_A3NSm_H
  real(dp), pointer :: powx(:), conv_res(:)
  !--------------------------
  real(dp) :: dy
  integer  :: nloop
  real(dp) :: ymax, Qmin, Qmax, dlnlnQ
  integer  :: order
  real(dp) :: PSL_res(2:3)
  integer  :: idev
  dy = 0.05_dp
  nloop = 4
  ymax = dble_val_opt("-ymax",22.0d0) ! go to quite high y, to avoid finite-y effects in moments
  Qmin = 1.0d0
  Qmax = 28000d0 ! twice LHC c.o.m.
  dlnlnQ = dy/4.0_dp  ! min(0.5_dp*dy,0.07_dp)
  order = -6

  idev = idev_open_opt("-o")
  x = dble_val_opt("-x", x)
  a4pi(1) = dble_val_opt("-a4pi", a4pi(1))
  nflcl = int_val_opt("-nf", nflcl)
  if (.not.CheckAllArgsUsed(0)) stop

  call dglap_Set_nnlo_nfthreshold(nnlo_nfthreshold_exact)
  call hoppetStartExtended(ymax,dy,Qmin,Qmax,dlnlnQ,nloop,order,factscheme_MSbar)

  !write(6,*) AGGPLU(0.1_dp, 4, 1.0_dp, lnmQmu2)
  !write(6,*) AGGPLU(0.1_dp, 4, 2.0_dp, lnmQmu2) / 8.0_dp
  

  !call hoppetStart(0.05_dp, 4)
  ! make sure SetNf comes after hoppetStart (which resets it)
  call qcd_SetNf(nflcl)
  call SetNfDglapHolder(dh, nflcl)
  nf_heavy = nf_int
  nf_light = nf_heavy - 1
  nf_light_dp = real(nf_light, dp)
  nf_heavy_dp = real(nf_heavy, dp)

  write(6,*) "-------------- Running tests that came with VFNS.f ---------------"
  ! The moment tests are designed to work with the following parameters
  ! nf,as,LL,   3.0000000000000000       0.10000000000000001        10.000000000000000
  call VFNS3sub(z_in=0.1_dp, nflightdp_in=3.0_dp, a4pi_in=0.1_dp, LL_in=10.0_dp)

  write(6,*) "-------------- comparing Bluemlein α^2 with Hoppet's α^2 ---------------"
  write(6,*) "nf_light = ", nf_light, " nf_heavy = ", nf_heavy
  comparators( 1) = comparator("GGPLU", GGPLU, sf_A2Sgg_H , cc_VIRT    )
  comparators( 2) = comparator("GGREG", GGREG, sf_A2Sgg_H , cc_REALVIRT)
  comparators( 3) = comparator("GGDEL", GGDEL, sf_A2Sgg_H , cc_DELTA   )
  comparators( 4) = comparator("NSPLU", NSPLU, sf_A2NSqq_H, cc_VIRT    )
  comparators( 5) = comparator("NSREG", NSREG, sf_A2NSqq_H, cc_REALVIRT)
  comparators( 6) = comparator("NSDEL", NSDEL, sf_A2NSqq_H, cc_DELTA   )

  comparators( 7) = comparator("QGL  ", QGL  , null()     , CC_REAL    )
  comparators( 8) = comparator("PSL  ", PSL  , null()     , CC_REAL    )
  comparators( 9) = comparator("GQ   ", GQ   , sf_A2Sgq_H , CC_REAL    )
  comparators(10) = comparator("QG   ", QG   , sf_A2PShg  , CC_REAL    )
  comparators(11) = comparator("PS   ", PS   , sf_A2PShq  , CC_REAL    )

  write(6,'(a)') "   piece     x        Blumlein's code           hoppet code                 difference"
  do i = 1, size(comparators)
    call comparators(i)%compare(x)
  end do

  !write(6,*) separate_orders(x, nf_light, QGL), AQG(x, nf_light, one, zero)
  write(6,*) "AQG = ", AQG(x, nf_light_dp, a4pi(1), zero)
  !write(6,*) A3Sqg_H_exact(x, nf_light)
  write(6,*) PSL(x, nf_light_dp, a4pi(1), zero)

  write(6,*) "Results including the a^3 factor:"
  res_aps1 = APS1(x, nf_light_dp, a4pi(1), 0.0_dp)
  res_aps2 = APS2(x, nf_light_dp, a4pi(1), zero)
  write(6,*) "PS separate orders ", separate_orders(x, nf_light, PS) * a4pi(1)**(/2,3/)
  write(6,*) "APS1, APS2: ", res_aps1, res_aps2
  !write(6,*) "A3PSqq_H_exact: ", A3PSqq_H_exact(x, nf_light) * a4pi(1)**3

  ! AK additions:
  ! I think PSL corresponds to PSqq_H and QGL to Sqg_H
  ! So this should be the comparison
  write(6,*) '----------------Comparison between AKs functions and Blumleins------------'
  write(6,*) "PSL separate orders ", separate_orders(x, nf_light, PSL) * a4pi(1)**(/2,3/)
  !write(6,*) "A3PSqq_H_exact: ", A3PSqq_H_exact(x, nf_light) * a4pi(1)**3
  !write(6,*) "A3PSqq_H_exact: ", A3PSqq_H_param(x, nf_light) * a4pi(1)**3
  write(6,*) "QGL separate orders ", separate_orders(x, nf_light, QGL) * a4pi(1)**(/2,3/)
  !write(6,*) "A3Sqg_H_exact: ", A3Sqg_H_exact(x, nf_light) * a4pi(1)**3
  !write(6,*) "A3Sqg_H_param: ", A3Sqg_H_param(x, nf_light) * a4pi(1)**3
  ! Here we print out the functions, without the a2pi pieces
  do i = 1, 100
     x = 0.01_dp ** (i/100.0_dp)
!     PSL_res = separate_orders(x, nf_light, QG)
!     write(idev,*) x, PSL_res(2), PSL_res(3) + AQGtotal(x, nf_light_dp, a4pi(2), zero)
     PSL_res = separate_orders(x, nf_light, GGDEL)
     write(idev,*) x, PSL_res(2), PSL_res(3) + AGGDEL(x, nf_light_dp, a4pi(2), zero)
  end do
  write(6,*) '--------------------------------------------------------------------------'
  
  write(6,*) "AGGREG0, AGGREG1: ", AGGREG0(x, nf_light_dp, a4pi(1), zero), AGGREG1(x, nf_light_dp, a4pi(1), zero)

  A3Sgg_H = JB(GGREG, GGPLU, GGDEL, 3) !!<< this is not the full answer, but the part without the A
  A2Sgg_H = JB(GGREG, GGPLU, GGDEL, order=2)
  cc_piece = cc_DELTA
  res1 = A2Sgg_H%integrand(log(1/x))
  res2 = sf_A2Sgg_H(log(1/x))
  write(6,*) "A2Sgg_H: ", res1, res2, res1-res2

  
  !call InitGridConv(grid, gc_A2Sgg_H_JB, A2Sgg_H)
  !call InitGridConv(grid, gc_A2Sgg_H_HP, sf_A2Sgg_H)
  !call InitGridConv(grid, gc_A2Sgg_H_JB, JB(GGREG,  GGPLU,  GGDEL,  order=2))
  !call InitGridConv(grid, gc_A3Sgg_H   , JB(GGREG,  GGPLU,  GGDEL,  order=3))
  !call AddWithCoeff(      gc_A3Sgg_H   , JB(AGGREG, AGGPLU, AGGDEL, order=3))
  ! call InitGridConv(grid, gc_A2Sgg_H_JB, JB(null() , null(),  GGDEL,  order=2))
  ! call InitGridConv(grid, gc_A3Sgg_H   , JB(null() , null(),  GGDEL,  order=3))
  ! call AddWithCoeff(      gc_A3Sgg_H   , JB(null() , null(), AGGDEL,  order=3))
  ! temporarily misuse some variable names
  !call InitGridConv(grid, gc_A2Sgg_H_JB, JB(reg=QG, a=AQG, order=2))
  !call InitGridConv(grid, gc_A3Sgg_H   , JB(reg=QG, a=AQG, order=3))

  write(6,*) "------------------------- preparing MTM_N3LO -------------------------"
  !call InitMTMN3LO(grid, dh%MTM_N3LO)
  write(6,*) "------------------------- done preparing MTM_N3LO -------------------------"

  call AllocGridQuant(grid, powx)
  call AllocGridQuant(grid, conv_res)
  a2pi = a4pi(1)*2

  write(6,*) "----------------------- AQG(z) -----------------------"
  do i = 1, 100
    x = 0.01_dp ** (i/100.0_dp)
    write(6,*) x, AQGtotal(x, nf_light_dp, a4pi(1), zero), "AQGtotal"
  end do

  ! do non-singlet moment with N=1 (other moments are infinite)
  write(6,*) "------------------------------------------------"
  momN = 1
  write(6,*) "momN = ", momN
  call compare_mom("NSqq_H", momN, dh%MTM_NNLO%NSqq_H, dh%MTM_N3LO%NSqq_H, MOMNS , .true.)

  do momN = 2, 6, 2

    write(6,*) "------------------------------------------------"
    write(6,*) "momN = ", momN

    call compare_mom("PShq  ", momN, dh%MTM_NNLO%PShq  , dh%MTM_N3LO%PShq  , MOMPS , .false.,MOMAPS)
    call compare_mom("PShg  ", momN, dh%MTM_NNLO%PShg  , dh%MTM_N3LO%PShg  , MOMQG , .false.)
    call compare_mom("PSqq_H", momN, dh%MTM_NNLO%PSqq_H, dh%MTM_N3LO%PSqq_H, MOMPSL, .false.)
    call compare_mom("NSqq_H", momN, dh%MTM_NNLO%NSqq_H, dh%MTM_N3LO%NSqq_H, MOMNS , .true.)
    call compare_mom("Sgg_H ", momN, dh%MTM_NNLO%Sgg_H , dh%MTM_N3LO%Sgg_H , MOMGG , .true.)
    call compare_mom("Sgq_H ", momN, dh%MTM_NNLO%Sgq_H , dh%MTM_N3LO%Sgq_H , MOMGQ , .false.,MOMAGQ)
    call compare_mom("Sqg_H ", momN, dh%MTM_NNLO%Sqg_H , dh%MTM_N3LO%Sqg_H , MOMQGL, .false.)
  end do

  ! set up a non-singlet object
  A3NSm_H = JB(OREG_znfasLL, OPLUS_znfasLL, ODEL_znfasLL, 203)
  call InitGridConv(grid, gc_A3NSm_H, A3NSm_H)
  do momN = 1, 7, 2
    write(6,*) "Odd moment momN = ", momN
    !                                this is dummy=0
    if (momN/=1) call compare_mom("NSm_H(hard-coded)", momN, dh%MTM_NNLO%NSqq_h, gc_A3NSm_H, ODDMOMNS_NxnfasLL , .true.)
    call compare_mom("NSm_H(integrated)", momN, dh%MTM_NNLO%NSqq_h, gc_A3NSm_H, ODDMOMNSint_NxnfasLL , .true.)
  end do


contains

  function ODDMOMNS_NxnfasLL(momN, x, nf_light_dp, a4pi, LL) result(res)
    integer   :: momN
    real(dp)  :: x, nf_light_dp, a4pi, LL
    !------------------------------
    real(dp) :: res
    res = ODDMOMNS(momN,a4pi,LL,nf_light_dp)
  end function ODDMOMNS_NxnfasLL

  function ODDMOMNSint_NxnfasLL(momN, x, nf_light_dp, a4pi, LL) result(res)
    integer   :: momN
    real(dp)  :: x, nf_light_dp, a4pi, LL
    !------------------------------
    real(dp) :: res
    res = MOMREG(a4pi,LL,nf_light_dp,momN) + ODEL(a4pi,LL,nf_light_dp)
    if (momN /= 1) res = res + MOMPLUS(a4pi,LL,nf_light_dp,momN)
  end function ODDMOMNSint_NxnfasLL


  subroutine compare_mom(name, momN, MTM2, MTM3, momfn, delta_one, momfn2)
    character(len=*), intent(in) :: name
    integer,          intent(in) :: momN
    type(grid_conv),  intent(in) :: MTM2, MTM3
    procedure(JBmom)             :: momfn
    logical,          intent(in) :: delta_one
    procedure(JBmom), optional   :: momfn2
    !------------------------------
    real(dp) :: res2,res3,HPsum, JBsums(1:2),JBcoeffs_a2pi(2:3), LL
    integer  :: i
    character(len=5) :: bad
    real(dp), parameter :: tolerance = 1e-4

    LL = zero
    do i = 1,2
      JBsums(i) = momfn(momN, x, nf_light_dp, a4pi(i), LL)
      if (present(momfn2)) JBsums(i) = JBsums(i) + momfn2(momN, x, nf_light_dp, a4pi(i), LL)
    end do
    JBcoeffs_a2pi = separate23(a4pi, JBsums, delta_one) / two**[2,3]

    res2 = gc_moment(MTM2, one * momN)
    res3 = gc_moment(MTM3, one * momN)
    HPsum = merge(1,0,delta_one) + a2pi**2*res2 + a2pi**3 * res3
    bad = ""
    if (any(abs(JBcoeffs_a2pi - (/res2,res3/)) > tolerance)) bad = "*BAD*"
    if (abs(HPsum - JBsums(1))                 > tolerance)  bad = "*BAD*"

    write(6,*) name, " JB : res2,3,sum:", JBcoeffs_a2pi, JBsums(1)
    write(6,*) name, " MTM: res2,3,sum:", res2, res3, HPsum, bad
  end subroutine compare_mom
end program test_blumlein

!======================================================================
!!
!! Module for providing access to the deep inelastic scattering
!! structure functions up to N3LO
!!

module structure_functions
  use pdf_representation
  use streamlined_interface
  use splitting_functions
  use coefficient_functions_holder
  use qcd
  implicit none

  private
  !!
  !! public functions
  !! those for initialisation and I/O
  public :: InitStrFct, StartStrFct, write_f1, write_f2, write_f3
  !!
  !! those for evaluating the structure functions
  !!
  public :: F_LO, F_NLO, F_NNLO, F_N3LO, StrFct
  public :: F_LO_flav, F_NLO_flav, StrFct_flav
  !!
  !! those for querying the scale choices being used
  !!
  public :: sf_muR, sf_muF
  
  !!
  !! indices for the different structure functions (D=d,s,b, U=u,c)
  !!
  public :: iF1Wp, iF2Wp, iF3Wp, iF1Wm, iF2Wm, iF3Wm, iF1Z, iF2Z,&
       & iF3Z, iF1EM, iF2EM, iF1gZ, iF2gZ, iF3gZ
  integer, parameter :: iF1Wp = 1 !< F1 W+ : D + Ubar 
  integer, parameter :: iF2Wp = 2 !< F2 W+ : D + Ubar 
  integer, parameter :: iF3Wp = 3 !< F3 W+ : D + Ubar 
  integer, parameter :: iF1Wm =-1 !< F1 W- : Dbar + U 
  integer, parameter :: iF2Wm =-2 !< F2 W- : Dbar + U 
  integer, parameter :: iF3Wm =-3 !< F3 W- : Dbar + U 
  integer, parameter :: iF1Z  = 4 !< F1 Z  : (D + Dbar) * v_i^2a_i^2_down    + (U + Ubar) * v_i^2a_i^2_up
  integer, parameter :: iF2Z  = 5 !< F2 Z  : (D + Dbar) * v_i^2a_i^2_down    + (U + Ubar) * v_i^2a_i^2_up
  integer, parameter :: iF3Z  = 6 !< F3 Z  : (D + Dbar) * 2v_i_a_i_down      + (U + Ubar) * 2v_i_a_i_up
  integer, parameter :: iF1EM =-4 !< F1 γ  : (D + Dbar) * e2_down            + (U + Ubar) * e2_up
  integer, parameter :: iF2EM =-5 !< F2 γ  : (D + Dbar) * e2_down            + (U + Ubar) * e2_up
  integer, parameter :: iF1gZ = 0 !< F1 γZ : (D + Dbar) * e_down * 2v_i_down + (U + Ubar) * e_up * 2v_i_up
  integer, parameter :: iF2gZ =-6 !< F2 γZ : (D + Dbar) * e_down * 2v_i_down + (U + Ubar) * e_up * 2v_i_up
  integer, parameter :: iF3gZ = 7 !< F3 γZ : (D + Dbar) * e_down * 2a_i_down + (U + Ubar) * e_up * 2a_i_up

  character(len=4), parameter, public :: SF_names(-6:7) = &
          ['F2gZ', 'F2EM', 'F1EM', 'F3Wm', 'F2Wm', 'F1Wm',&
           'F1gZ', 'F1Wp', 'F2Wp', 'F3Wp', 'F1Z ', 'F2Z ', 'F3Z ', 'F3gZ']

  !!
  !! coupling constants and fixed parameters
  !!
  ! public indices for scale choice options
  integer, parameter, public :: scale_choice_fixed     = 0 !< muR,muF scales predetermined in the StartStrFct call
  integer, parameter, public :: scale_choice_Q         = 1 !< muR,muF scales equal to xR,xQ * Q (xR,xQ to be set in StartStrFct)
  integer, parameter, public :: scale_choice_arbitrary = 2 !< muR,muF scales can be chosen freely in the F_LO (etc.) and StrFct calls

  !!
  !! holds the coefficient functions
  !!
  type(coef_holder), save :: ch

  !!
  !! Holds the structure functions. The tables are identical to the
  !! streamlined tables, but separate such that one can use the
  !! streamlined tables at the same time as the structure functions.
  !!
  !! These contain the SF summed over flavour, and dressed with
  !! quark couplings according to the indices above (iF1Wp etc)
  type(pdf_table), save :: sf_tables(0:max_table_index) 
  !! These contained the SF decomposed by flavour, WITHOUT
  !! couplings. For now functionality for these are somewhat
  !! limited. They are only available at LO/NLO.
  type(pdf_table), save :: sf_tables_flav(0:max_table_index)
  logical,         save :: sf_alloc_already_done = .false.

  !!
  !! constants and fixed parameters
  !!
  logical,  save      :: use_mass_thresholds
  real(dp), parameter :: viW = 1/sqrt(two), aiW = viW
  real(dp), save      :: vi2_ai2_avg_W, two_vi_ai_avg_W
  real(dp), save      :: vi2_ai2_Z_down, vi2_ai2_Z_up
  real(dp), save      :: two_vi_ai_Z_down, two_vi_ai_Z_up
  real(dp), save      :: two_vi_Z_down, two_vi_Z_up
  real(dp), save      :: two_ai_Z_down, two_ai_Z_up
  real(dp), parameter :: e_up = 2.0_dp/3.0_dp, e_down = - 1.0_dp/3.0_dp
  real(dp), parameter :: e2_up = 4.0_dp/9.0_dp, e2_down = 1.0_dp/9.0_dp

  !!
  !! these log terms are only used for scale_choice = 0,1, to speed up the code
  !!
  real(dp), save      :: log_muF2_over_Q2, log_muR2_over_Q2
  !real(dp), save      :: Qmin
  real(dp), public, save :: toy_alphas_Q0 = 0.35_dp ! Roughly αS(sqrt(2))
  type(running_coupling), public, save :: toy_coupling

  !!
  !! scale choices
  !!
  real(dp), save :: cst_mu, xmuR, xmuF
  integer, save  :: scale_choice_save
  
  logical, save  :: use_sep_orders, inc_flavour_decomposition
  logical, save  :: exact_coefs
  integer :: nf_lcl, order_setup

contains
  !> @brief Setup of constants and parameters needed for structure functions
  !!
  !! @param[in]      order_max      highest order in QCD to compute (1: LO, 2: NLO, etc)
  !! @param[opt]     nflav          integer number of flavours (if not present use variable flavour)
  !! @param[opt]     scale_choice   (0: fixed scale, 1: use Q, 2: use arbitrary scale)
  !! @param[opt]     constant_mu    if scale_choice = scale_choice_fixed (= 0) then this is the fixed scale
  !! @param[opt]     param_coefs    if .true. use parametrised coefficients functions
  !! @param[opt]     wmass          Mass of the W boson
  !! @param[opt]     zmass          Mass of the z boson
  !!
  subroutine StartStrFct(order_max, nflav, scale_choice, constant_mu,&
       & param_coefs, wmass, zmass)
    integer, intent(in)  :: order_max
    integer, optional    :: nflav, scale_choice
    real(dp), optional   :: constant_mu, wmass, zmass
    logical, optional    :: param_coefs
    !----------------------------------------------------------------------
    real(dp) :: sin_thw_sq, mw, mz

    if(.not.alloc_already_done) then
       call wae_error('StartStrFct', 'hoppetStart not called!')
    endif

    ! Read input
    ! mW and mZ defaults are taken from the 2022 PDG 
    mw                = default_or_opt(80.377_dp, wmass)
    mz                = default_or_opt(91.1876_dp, zmass)
    scale_choice_save = default_or_opt(scale_choice_Q, scale_choice)
    exact_coefs       = .not.default_or_opt(.true., param_coefs)
    cst_mu            = default_or_opt(zero, constant_mu)
        
    ! compute sin(\theta_w) from W/Z mass
    sin_thw_sq = 1.0_dp - (mw/mz)**2
    
    ! evaluate parameters needed for the structure functions
    ! cf. Eqs. (3.10+11) of 1109.3717
    vi2_ai2_Z_up     = one/four + (half - (four/three) * sin_thw_sq)**2
    vi2_ai2_Z_down   = one/four + (half - (two/three)  * sin_thw_sq)**2
    two_vi_ai_Z_up   = half - (four/three) * sin_thw_sq
    two_vi_ai_Z_down = half - (two/three)  * sin_thw_sq

    ! cf. Eq.3.20 + 3.17 & 3.18
    ! 1/nf \sum_j=1^nf (vj^2 + aj^2)
    vi2_ai2_avg_W = viW**2 + aiW**2
    ! 1/nf \sum_j=1^nf 2*vj*aj
    two_vi_ai_avg_W = two * viW * aiW

    ! these parameters are needed explicitly for the gamma-Z structure function
    two_vi_Z_up = one - (8.0_dp/three) * sin_thw_sq
    two_vi_Z_down   = -one + (four/three) * sin_thw_sq
    two_ai_Z_up = one
    two_ai_Z_down   = -one

    if (default_or_opt(-1, nflav) > 0) then
       ! if nflav is present, then use a fixed flavour number
       call qcd_SetNf(nflav)
       call InitCoefHolder(grid, ch, order_max, exact_coefs)
       use_mass_thresholds = .false.
       nf_lcl = nf_int
       write(6,'(a)'   ) "Starting the structure functions with fixed number of flavours"
       write(6,'(a,i2)') "nf = ", nf_lcl
    else
       ! otherwise, use variable flavour number scheme
       !    call InitCoefHolder(grid, ch, order_max, exact_coefs, nflo=3, nfhi=5)
       call InitCoefHolder(grid, ch, order_max, exact_coefs, nflo=3, nfhi=6)
       use_mass_thresholds = .true.
       
       write(6,'(a)'      ) "Starting the structure functions with mass thresholds at"
       write(6,'(a,f12.5)') "mc = ", masses(4) 
       write(6,'(a,f12.5)') "mb = ", masses(5)
       write(6,'(a,f12.5)') "mt = ", masses(6) 
       ! and start with a sensible local nf (which will be 5 here) 
       nf_lcl = nf_int
    endif
    
    ! if mass thresholds are used in the structure functions, only scale_choice 0 and 1 are allowed
    if ((use_mass_thresholds).and.(scale_choice_save.ge.scale_choice_arbitrary)) then
       call wae_error('StartStrFct', 'illegal value for scale_choice with mass thresholds turned on', intval = scale_choice_save)
    end if
 
  end subroutine StartStrFct

  !> @brief Initialize the structure functions up to specified order
  !!
  !! Initialize the structure functions up to specified order
  !! this requires the tabulated PDF to have been set up beforehand in the
  !! the streamlined interface. 
  !!
  !! By default, separate_orders = .false., which means that one
  !! can only access the sum over all orders. If separate_orders = .true.
  !! then one can access each order separately, but this is slower.
  !!
  !! @param[in]      order              order at which we initialise the structure functions
  !! @param[opt]     separate_orders    if .true. separate into individual orders rather than summing
  !! @param[opt]     xR             factor to multiply renormalisation scale
  !! @param[opt]     xF             factor to multiply factorisation scale
  !!
  subroutine InitStrFct(order, separate_orders, xR, xF, flavour_decomposition)
    integer, intent(in) :: order
    real(dp), optional   :: xR, xF
    logical, optional :: separate_orders, flavour_decomposition

    if(.not.setup_done(0)) then
       call wae_error('InitStrFct', 'hoppetEvolve not called!')
    endif

    xmuR              = default_or_opt(one, xR)
    xmuF              = default_or_opt(one, xF)

    inc_flavour_decomposition = .false.
    inc_flavour_decomposition = default_or_opt(inc_flavour_decomposition, flavour_decomposition)

    if(sf_alloc_already_done) then
       call Delete(sf_tables)
       if (inc_flavour_decomposition) call Delete(sf_tables_flav)
    endif

    ! Now we set up the tables. HoppetStart already called, so we can copy over the structure
    call AllocPdfTable(sf_tables, tables(0))
    if(inc_flavour_decomposition) call AllocPdfTable(sf_tables_flav, tables(0))
    ! Finally we need to set tab_iflv_max = 7. We don't change tables(0) as it contains the PDF
    !sf_tables(0) = tables(0)
    !sf_tables_flav(0) = tables(0)
    sf_tables(1:)%tab_iflv_max = 7
    if(inc_flavour_decomposition) sf_tables_flav(1:)%tab_iflv_max = 6
    sf_alloc_already_done = .true. ! Signals that the tables have been set up.

    ! To turn off b quarks completely (only for testing and comparison)
    ! uncomment following two lines:
    ! tables(0)%tab(:,-5,:) = zero
    ! tables(0)%tab(:,+5,:) = zero

    ! default is to sum each order before convolutions (it's faster)
    if (scale_choice_save == scale_choice_arbitrary) then
       use_sep_orders = .true.
    else
       use_sep_orders = .false.
    endif
    use_sep_orders = default_or_opt(use_sep_orders, separate_orders)

    if (use_sep_orders) then
       ! First we treat the case where we want to separate out each order in
       ! the final structure functions.
       ! This is slower, but is needed e.g. for VBFH
       if (scale_choice_save == scale_choice_Q .or. scale_choice_save == scale_choice_fixed) then
          ! if scale_choice = 0,1 use fast implementation
          ! tables is saved as an array in Q, and only tables(0),
          ! sf_tables(1), sf_tables(2), sf_tables(4), sf_tables(8) are non zero
          if (order.ge.1) call set_LO_structure_functions()
          if (order.ge.2) call set_NLO_structure_functions()
          if (order.ge.3) call set_NNLO_structure_functions()
          if (order.ge.4) call set_N3LO_structure_functions()
       else if(scale_choice_save == scale_choice_arbitrary) then
          ! if scale_choice >= 2 use slower implementation with full
          ! scale choices, such as sqrt(Q1*Q2)
          ! tables is saved as an array in muF now, and all components
          ! of sf_tables are non zero.
          if (order.ge.1) call set_LO_structure_functions_anyscale()
          if (order.ge.2) call set_NLO_structure_functions_anyscale()
          if (order.ge.3) call set_NNLO_structure_functions_anyscale()
          if (order.ge.4) call set_N3LO_structure_functions_anyscale()
       else
          call wae_error('InitStrFct', 'illegal value for scale_choice', intval = scale_choice_save)
       endif
    else
       ! Now set up the default case where we sum up everything right away.
       if (scale_choice_save >= scale_choice_arbitrary) & ! only allow for scale_choice = 0,1
            & call wae_error('InitStrFct', &
            & 'with scale_choice_arbitrary (or higher), separate_orders must be true, but was false; scale_choice=', &
            & intval = scale_choice_save)
       call set_structure_functions_upto(order)
    endif
    
    ! Now for flavour decomposed SFs
    if(inc_flavour_decomposition) then
       if (use_sep_orders) then
          ! First we treat the case where we want to separate out each order in
          ! the final structure functions.
          ! This is slower, but is needed e.g. for VBFH
          if (scale_choice_save == scale_choice_Q .or. scale_choice_save == scale_choice_fixed) then
             ! if scale_choice = 0,1 use fast implementation
             ! tables is saved as an array in Q, and only tables(0),
             ! sf_tables(1), sf_tables(2), sf_tables(4), sf_tables(8) are non zero
             if (order.ge.1) call set_LO_structure_functions_flav()
             if (order.ge.2) call set_NLO_structure_functions_flav()
          else if(scale_choice_save == scale_choice_arbitrary) then
             ! if scale_choice >= 2 use slower implementation with full
             ! scale choices, such as sqrt(Q1*Q2)
             ! tables is saved as an array in muF now, and all components
             ! of sf_tables are non zero.
             if (order.ge.1) call set_LO_structure_functions_anyscale_flav()
             if (order.ge.2) call set_NLO_structure_functions_anyscale_flav()
          else
             call wae_error('InitStrFct', 'illegal value for scale_choice', intval = scale_choice_save)
          endif
       else
          ! Now set up the default case where we sum up everything right away.
          if (scale_choice_save >= scale_choice_arbitrary) & ! only allow for scale_choice = 0,1
               & call wae_error('InitStrFct', &
               & 'with scale_choice_arbitrary (or higher), separate_orders must be true, but was false; scale_choice=', &
               & intval = scale_choice_save)
          call set_structure_functions_upto_flav(order)
       endif
    endif

    ! To rescale PDF by the N3LO F2 structure function (evaluated at 8 GeV)
    ! as a check of the size of missing N3LO PDFs, uncomment following line:
    ! call rescale_pdf_nnlo(8.0_dp,order)
    ! call rescale_pdf_n3lo(8.0_dp,order)

    setup_done(1:) = .true.
    order_setup = order
    
  end subroutine InitStrFct
  
  !> @brief write the F1 structure function to idev
  !!
  !! Writes the W and Z F1 structure functions to a file with equal spacing in log(x)
  !!
  !! @param[in]     idev     file/device to write to
  !! @param[in]     Qtest    Value of Q to use
  !! @param[in]     ymax     Largest value of y = - log(x) to print
  !! @param[in]     ny       number of bins in y to print
  !!
  subroutine write_f1 (idev, Qtest, ymax, ny, muF, muR)
    real(dp), intent(in) :: Qtest, ymax
    real(dp), intent(in), optional :: muF, muR
    integer, intent(in)  :: idev, ny
    real(dp) :: ytest, xval, mR, mF, F1Z_LO, F1Z_NLO, F1Z_NNLO, F1Z_N3LO, res(-6:7)
    real(dp) :: F1EM_LO, F1EM_NLO, F1EM_NNLO, F1EM_N3LO, F1gZ_LO, F1gZ_NLO, F1gZ_NNLO, F1gZ_N3LO 
    integer  :: iy
    !F1 Wp Wm Z
    write(idev,'(a,f10.4,a,f10.4)') '# Q = ', Qtest
    if (use_sep_orders) then
       write(idev,'(a,a)') '#     x        F1Wp(LO)    F1Wm(LO)    F1Wp(NLO)   F1Wm(NLO)  F1Wp(NNLO)  F1Wm(NNLO)', &
            & '  F1Wp(N3LO)  F1Wm(N3LO)    F1Z(LO)    F1Z(NLO)    F1Z(NNLO)&
            &   F1Z(N3LO)    F1γ(LO)    F1γ(NLO)    F1γ(NNLO)   F1γ(N3LO)   F1γZ(LO)&
            &   F1γZ(NLO)   F1γZ(NNLO)  F1γZ(N3LO)'
    else
       write(idev,'(a)') '# x F1Wp F1Wm F1Z F1γ F1γZ'
    endif
    mF = default_or_opt(sf_muF(Qtest),muF)
    mR = default_or_opt(sf_muR(Qtest),muR)
    do iy = ny, 1, -1
       ytest = iy * ymax / ny
       xval = exp(-ytest)
       if (use_sep_orders) then
          res = F_LO(xval, Qtest, mR, mF)
          write(idev,'(3es12.4)',advance='no') xval, res(iF1Wp),res(iF1Wm)
          F1Z_LO = res(iF1Z)
          F1EM_LO = res(iF1EM)
          F1gZ_LO = res(iF1gZ)
          res = F_NLO(xval, Qtest, mR, mF)
          write(idev,'(2es12.4)',advance='no') res(iF1Wp), res(iF1Wm)
          F1Z_NLO = res(iF1Z)
          F1EM_NLO = res(iF1EM)
          F1gZ_NLO = res(iF1gZ)
          res = F_NNLO(xval, Qtest, mR, mF)
          write(idev,'(2es12.4)',advance='no') res(iF1Wp), res(iF1Wm)
          F1Z_NNLO = res(iF1Z)
          F1EM_NNLO = res(iF1EM)
          F1gZ_NNLO = res(iF1gZ)
          res = F_N3LO(xval, Qtest, mR, mF)
          write(idev,'(2es12.4)',advance='no') res(iF1Wp), res(iF1Wm)
          F1Z_N3LO = res(iF1Z)
          F1EM_N3LO = res(iF1EM)
          F1gZ_N3LO = res(iF1gZ)
          write(idev,'(12es12.4)',advance='no') F1Z_LO, F1Z_NLO,&
               & F1Z_NNLO, F1Z_N3LO, F1EM_LO, F1EM_NLO, F1EM_NNLO,&
               & F1EM_N3LO, F1gZ_LO, F1gZ_NLO, F1gZ_NNLO, F1gZ_N3LO 
       else
          res = StrFct(xval, Qtest, mR, mF)
          write(idev,'(6es12.4)',advance='no') xval, res(iF1Wp),res(iF1Wm), res(iF1Z), res(iF1EM), res(iF1gZ)
       endif
       write(idev,*)
    end do
    write(idev,*)
    write(idev,*)
  end subroutine write_f1
  
  !> @brief write the F2 structure function to idev
  !!
  !! Writes the W and Z F2 structure functions to a file with equal spacing in log(x)
  !!
  !! @param[in]     idev     file/device to write to
  !! @param[in]     Qtest    Value of Q to use
  !! @param[in]     ymax     Largest value of y = - log(x) to print
  !! @param[in]     ny       number of bins in y to print
  !!
  subroutine write_f2 (idev, Qtest, ymax, ny, muF, muR)
    real(dp), intent(in) :: Qtest, ymax
    real(dp), intent(in), optional :: muF, muR
    integer, intent(in)  :: idev, ny
    real(dp) :: ytest, xval, mR, mF, F2Z_LO, F2Z_NLO, F2Z_NNLO, F2Z_N3LO, res(-6:7)
    real(dp) :: F2EM_LO, F2EM_NLO, F2EM_NNLO, F2EM_N3LO, F2gZ_LO, F2gZ_NLO, F2gZ_NNLO, F2gZ_N3LO 
    integer  :: iy
    !F2 Wp Wm Z
    write(idev,'(a,f20.4,a,f20.4)') '# Q = ', Qtest
    if (use_sep_orders) then
       write(idev,'(a,a)') '#     x        F2Wp(LO)    F2Wm(LO)    F2Wp(NLO)   F2Wm(NLO)  F2Wp(NNLO)  F2Wm(NNLO)', &
            & '  F2Wp(N3LO)  F2Wm(N3LO)    F2Z(LO)    F2Z(NLO)    F2Z(NNLO)&
            &   F2Z(N3LO)    F2γ(LO)    F2γ(NLO)    F2γ(NNLO)   F2γ(N3LO)   F2γZ(LO)&
            &   F2γZ(NLO)   F2γZ(NNLO)  F2γZ(N3LO)'
    else
       write(idev,'(a)') '# x F2Wp F2Wm F2Z F2γ F2γZ'
    endif
    mF = default_or_opt(sf_muF(Qtest),muF)
    mR = default_or_opt(sf_muR(Qtest),muR)
    do iy = ny, 1, -1
       ytest = iy * ymax / ny
       xval = exp(-ytest)
       if (use_sep_orders) then
          res = F_LO(xval, Qtest, mR, mF)
          write(idev,'(3es12.4)',advance='no') xval, res(iF2Wp),res(iF2Wm)
          F2Z_LO = res(iF2Z)
          F2EM_LO = res(iF2EM)
          F2gZ_LO = res(iF2gZ)
          res = F_NLO(xval, Qtest, mR, mF)
          write(idev,'(2es12.4)',advance='no') res(iF2Wp), res(iF2Wm)
          F2Z_NLO = res(iF2Z)
          F2EM_NLO = res(iF2EM)
          F2gZ_NLO = res(iF2gZ)
          res = F_NNLO(xval, Qtest, mR, mF)
          write(idev,'(2es12.4)',advance='no') res(iF2Wp), res(iF2Wm)
          F2Z_NNLO = res(iF2Z)
          F2EM_NNLO = res(iF2EM)
          F2gZ_NNLO = res(iF2gZ)
          res = F_N3LO(xval, Qtest, mR, mF)
          write(idev,'(2es12.4)',advance='no') res(iF2Wp), res(iF2Wm)
          F2Z_N3LO = res(iF2Z)
          F2EM_N3LO = res(iF2EM)
          F2gZ_N3LO = res(iF2gZ)
          write(idev,'(12es12.4)',advance='no') F2Z_LO, F2Z_NLO,&
               & F2Z_NNLO, F2Z_N3LO, F2EM_LO, F2EM_NLO, F2EM_NNLO,&
               & F2EM_N3LO, F2gZ_LO, F2gZ_NLO, F2gZ_NNLO, F2gZ_N3LO 
       else
          res = StrFct(xval, Qtest, mR, mF)
          write(idev,'(6es12.4)',advance='no') xval, res(iF2Wp),res(iF2Wm), res(iF2Z), res(iF2EM), res(iF2gZ)
       endif
       write(idev,*)
    end do
    write(idev,*)
    write(idev,*)
  end subroutine write_f2
!  subroutine write_f2 (idev, Qtest, ymax, ny, muF, muR)
!    real(dp), intent(in) :: Qtest, ymax
!    real(dp), intent(in), optional :: muF, muR
!    integer, intent(in)  :: idev, ny
!    real(dp) :: ytest, xval, mR, mF, F2Z_LO, F2Z_NLO, F2Z_NNLO, F2Z_N3LO, res(-6:7)
!    integer  :: iy
!    !F2 Wp Wm Z
!    write(idev,'(a,f10.4,a,f10.4)') '# Q = ', Qtest
!    if (use_sep_orders) then
!       write(idev,'(a,a)') '# x  F2Wp(LO) F2Wm(LO) F2Wp(NLO) F2Wm(NLO) F2Wp(NNLO) F2Wm(NNLO)', &
!            & ' F2Wp(N3LO) F2Wm(N3LO) F2Z(LO) F2Z(NLO) F2Z(NNLO) F2Z(N3LO)'
!    else
!       write(idev,'(a)') '# x F2Wp F2Wm F2Z'
!    endif
!    mF = default_or_opt(sf_muF(Qtest),muF)
!    mR = default_or_opt(sf_muR(Qtest),muR)
!    do iy = ny, 1, -1
!       ytest = iy * ymax / ny
!       xval = exp(-ytest)
!       if (use_sep_orders) then
!          res = F_LO(xval, Qtest, mR, mF)
!          write(idev,'(3es12.4)',advance='no') xval, res(iF2Wp),res(iF2Wm)
!          F2Z_LO = res(iF2Z)
!          res = F_NLO(xval, Qtest, mR, mF)
!          write(idev,'(2es12.4)',advance='no') res(iF2Wp), res(iF2Wm)
!          F2Z_NLO = res(iF2Z)
!          res = F_NNLO(xval, Qtest, mR, mF)
!          write(idev,'(2es12.4)',advance='no') res(iF2Wp), res(iF2Wm)
!          F2Z_NNLO = res(iF2Z)
!          res = F_N3LO(xval, Qtest, mR, mF)
!          write(idev,'(2es12.4)',advance='no') res(iF2Wp), res(iF2Wm)
!          F2Z_N3LO = res(iF2Z)
!          write(idev,'(4es12.4)',advance='no') F2Z_LO, F2Z_NLO, F2Z_NNLO, F2Z_N3LO
!       else
!          res = StrFct(xval, Qtest, mR, mF)
!          write(idev,'(4es12.4)',advance='no') xval, res(iF2Wp),res(iF2Wm), res(iF2Z)
!       endif
!       write(idev,*)
!    end do
!    write(idev,*)
!    write(idev,*)
!  end subroutine write_f2

  !> @brief write the F3 structure function to idev
  !!
  !! Writes the W and Z F3 structure functions to a file with equal spacing in log(x)
  !!
  !! @param[in]     idev     file/device to write to
  !! @param[in]     Qtest    Value of Q to use
  !! @param[in]     ymax     Largest value of y = - log(x) to print
  !! @param[in]     ny       number of bins in y to print
  !!
    subroutine write_f3 (idev, Qtest, ymax, ny, muF, muR)
    real(dp), intent(in) :: Qtest, ymax
    real(dp), intent(in), optional :: muF, muR
    integer, intent(in)  :: idev, ny
    real(dp) :: ytest, xval, mR, mF, F3Z_LO, F3Z_NLO, F3Z_NNLO, F3Z_N3LO, res(-6:7)
    real(dp) :: F3gZ_LO, F3gZ_NLO, F3gZ_NNLO, F3gZ_N3LO 
    integer  :: iy
    !F3 Wp Wm Z
    write(idev,'(a,f30.4,a,f30.4)') '# Q = ', Qtest
    if (use_sep_orders) then
       write(idev,'(a,a)') '#     x        F3Wp(LO)    F3Wm(LO)    F3Wp(NLO)   F3Wm(NLO)  F3Wp(NNLO)  F3Wm(NNLO)', &
            & '  F3Wp(N3LO)  F3Wm(N3LO)    F3Z(LO)    F3Z(NLO)    F3Z(NNLO)&
            &   F3Z(N3LO)    F3γZ(LO)&
            &   F3γZ(NLO)  F3γZ(NNLO)  F3γZ(N3LO)'
    else
       write(idev,'(a)') '# x F3Wp F3Wm F3Z F3γZ'
    endif
    mF = default_or_opt(sf_muF(Qtest),muF)
    mR = default_or_opt(sf_muR(Qtest),muR)
    do iy = ny, 1, -1
       ytest = iy * ymax / ny
       xval = exp(-ytest)
       if (use_sep_orders) then
          res = F_LO(xval, Qtest, mR, mF)
          write(idev,'(3es12.4)',advance='no') xval, res(iF3Wp),res(iF3Wm)
          F3Z_LO = res(iF3Z)
          F3gZ_LO = res(iF3gZ)
          res = F_NLO(xval, Qtest, mR, mF)
          write(idev,'(2es12.4)',advance='no') res(iF3Wp), res(iF3Wm)
          F3Z_NLO = res(iF3Z)
          F3gZ_NLO = res(iF3gZ)
          res = F_NNLO(xval, Qtest, mR, mF)
          write(idev,'(2es12.4)',advance='no') res(iF3Wp), res(iF3Wm)
          F3Z_NNLO = res(iF3Z)
          F3gZ_NNLO = res(iF3gZ)
          res = F_N3LO(xval, Qtest, mR, mF)
          write(idev,'(2es12.4)',advance='no') res(iF3Wp), res(iF3Wm)
          F3Z_N3LO = res(iF3Z)
          F3gZ_N3LO = res(iF3gZ)
          write(idev,'(8es12.4)',advance='no') F3Z_LO, F3Z_NLO,&
               & F3Z_NNLO, F3Z_N3LO, F3gZ_LO, F3gZ_NLO, F3gZ_NNLO,&
               & F3gZ_N3LO 
       else
          res = StrFct(xval, Qtest, mR, mF)
          write(idev,'(6es12.4)',advance='no') xval, res(iF3Wp),res(iF3Wm), res(iF3Z), res(iF3gZ)
       endif
       write(idev,*)
    end do
    write(idev,*)
    write(idev,*)
  end subroutine write_f3

!  subroutine write_f3 (idev, Qtest, ymax, ny, muF, muR)
!    real(dp), intent(in) :: Qtest, ymax
!    real(dp), intent(in), optional :: muF, muR
!    integer, intent(in)  :: idev, ny
!    real(dp) :: ytest, xval, mR, mF, F3Z_LO, F3Z_NLO, F3Z_NNLO, F3Z_N3LO, res(-6:7)
!    integer  :: iy
!    !F3 Wp Wm Z
!    write(idev,'(a,f10.4,a,f10.4)') '# Q = ', Qtest
!    if (use_sep_orders) then
!       write(idev,'(a,a)') '# x  F3Wp(LO) F3Wm(LO) F3Wp(NLO) F3Wm(NLO) F3Wp(NNLO) F3Wm(NNLO)', &
!            & ' F3Wp(N3LO) F3Wm(N3LO) F3Z(LO) F3Z(NLO) F3Z(NNLO) F3Z(N3LO)'
!    else
!       write(idev,'(a)') '# x F3Wp F3Wm F3Z'
!    endif
!    mF = default_or_opt(sf_muF(Qtest),muF)
!    mR = default_or_opt(sf_muR(Qtest),muR)
!    do iy = ny, 1, -1
!       ytest = iy * ymax / ny
!       xval = exp(-ytest)
!       if (use_sep_orders) then
!          res = F_LO(xval, Qtest, mR, mF)
!          write(idev,'(3es12.4)',advance='no') xval, res(iF3Wp),res(iF3Wm)
!          F3Z_LO = res(iF3Z)
!          res = F_NLO(xval, Qtest, mR, mF)
!          write(idev,'(2es12.4)',advance='no') res(iF3Wp), res(iF3Wm)
!          F3Z_NLO = res(iF3Z)
!          res = F_NNLO(xval, Qtest, mR, mF)
!          write(idev,'(2es12.4)',advance='no') res(iF3Wp), res(iF3Wm)
!          F3Z_NNLO = res(iF3Z)
!          res = F_N3LO(xval, Qtest, mR, mF)
!          write(idev,'(2es12.4)',advance='no') res(iF3Wp), res(iF3Wm)
!          F3Z_N3LO = res(iF3Z)
!          write(idev,'(4es12.4)',advance='no') F3Z_LO, F3Z_NLO, F3Z_NNLO, F3Z_N3LO
!       else
!          res = StrFct(xval, Qtest, mR, mF)
!          write(idev,'(4es12.4)',advance='no') xval, res(iF3Wp),res(iF3Wm), res(iF3Z)
!       endif
!       write(idev,*)
!    end do
!    write(idev,*)
!    write(idev,*)
!  end subroutine write_f3

  !----------------------------------------------------------------------
  ! set up structure functions for scale_choice = 0, 1, adding up each order
  subroutine set_structure_functions_upto (order)
    integer, intent(in) :: order
    integer :: iQ
    real(dp) :: Q, as2pi
    real(dp) :: f(0:grid%ny,ncompmin:ncompmax)
    real(dp) :: f2(0:grid%ny,ncompmin:ncompmax)
    real(dp) :: fL(0:grid%ny,ncompmin:ncompmax)
    real(dp) :: f3(0:grid%ny,ncompmin:ncompmax)
    real(dp) :: f2_fl11(0:grid%ny,ncompmin:ncompmax)
    real(dp) :: fL_fl11(0:grid%ny,ncompmin:ncompmax)
    real(dp) :: PLO_f (0:grid%ny,ncompmin:ncompmax)
    real(dp) :: PNLO_f(0:grid%ny,ncompmin:ncompmax)
    real(dp) :: PLO2_f(0:grid%ny,ncompmin:ncompmax)
    real(dp) :: PNNLO_f(0:grid%ny,ncompmin:ncompmax)
    real(dp) :: PLONLO_f(0:grid%ny,ncompmin:ncompmax)
    real(dp) :: PNLOLO_f(0:grid%ny,ncompmin:ncompmax)
    real(dp) :: PLO3_f(0:grid%ny,ncompmin:ncompmax)
    
    do iQ = 0, tables(0)%nQ
       
       Q = tables(0)%Q_vals(iQ)
       call EvalPdfTable_Q(tables(0),sf_muF(Q),f)
       call set_scale_logs(Q)
       
       as2pi = alphasLocal(sf_muR(Q)) / (twopi)
       
       if (use_mass_thresholds) then
          call use_vfns(f, Q)
       endif
   
       ! start with LO
       if (order.ge.1) then
          sf_tables(1)%tab(:,:,iQ) = structure_function_general(ch%C2LO*f, ch%CLLO*f, ch%C3LO*f)
       endif
       
       ! now add NLO terms
       if (order.ge.2) then
          if ((scale_choice_save.eq.scale_choice_Q).and.(xmuR.eq.one).and.(xmuF.eq.one)) then
             ! For central scale with scale_choice=1, we don't need to do all
             ! the convolutions of the splitting functions
             f2 = ch%C2NLO * f
             fL = ch%CLNLO * f
             f3 = ch%C3NLO * f
          else
             ! do the convolution with the coefficient functions and also the
             ! corresponding splitting-function contributions when scales
             ! are not equal to Q
             PLO_f = dh%P_LO * f
             f2 = CxNLO_with_logs(ch%C2LO, ch%C2NLO, f, PLO_f)
             fL = CxNLO_with_logs(ch%CLLO, ch%CLNLO, f, PLO_f)
             f3 = CxNLO_with_logs(ch%C3LO, ch%C3NLO, f, PLO_f)
          endif

          sf_tables(1)%tab(:,:,iQ) = sf_tables(1)%tab(:,:,iQ) + &
               & as2pi * structure_function_general(f2, fL, f3)
       endif

       ! now add NNLO terms
       if (order.ge.3) then
          if ((scale_choice_save.eq.scale_choice_Q).and.(xmuR.eq.one).and.(xmuF.eq.one)) then
             ! For central scale with scale_choice=1, we don't need to do all
             ! the convolutions of the splitting functions
             f2 = ch%C2NNLO * f
             fL = ch%CLNNLO * f
             f3 = ch%C3NNLO * f
          else
             ! do the convolution with the coefficient functions and also the
             ! corresponding splitting-function contributions when scales
             ! are not equal to Q
             PLO_f   = dh%P_LO  * f
             PNLO_f  = dh%P_NLO * f
             PLO2_f  = dh%P_LO  * PLO_f
             f2 = CxNNLO_with_logs(ch%C2LO, ch%C2NLO, ch%C2NNLO, f, PLO_f, PNLO_f, PLO2_f)
             fL = CxNNLO_with_logs(ch%CLLO, ch%CLNLO, ch%CLNNLO, f, PLO_f, PNLO_f, PLO2_f)
             f3 = CxNNLO_with_logs(ch%C3LO, ch%C3NLO, ch%C3NNLO, f, PLO_f, PNLO_f, PLO2_f)
          endif

          sf_tables(1)%tab(:,:,iQ) = sf_tables(1)%tab(:,:,iQ) + &
               (as2pi**2) * structure_function_general(f2, fL, f3)
       endif

       ! and finally, add the N3LO terms
       if (order.ge.4) then
          if ((scale_choice_save.eq.scale_choice_Q).and.(xmuR.eq.one).and.(xmuF.eq.one)) then
             ! For central scale with scale_choice=1 (i.e. mur=muf=Q), we don't
             ! need to do all the convolutions of the splitting functions
             f2 = ch%C2N3LO * f
             fL = ch%CLN3LO * f
             f3 = ch%C3N3LO * f
          else
             ! do the convolution with the coefficient functions and also the
             ! corresponding splitting-function contributions when scales
             ! are not equal to Q
             PLO_f    = dh%P_LO   * f
             PNLO_f   = dh%P_NLO  * f
             PLO2_f   = dh%P_LO   * PLO_f
             PNNLO_f  = dh%P_NNLO * f
             PLONLO_f = dh%P_LO   * PNLO_f
             PNLOLO_f = dh%P_NLO  * PLO_f
             PLO3_f   = dh%P_LO   * PLO2_f

             f2 = CxN3LO_with_logs(ch%C2LO, ch%C2NLO, ch%C2NNLO, ch%C2N3LO, f, PLO_f, PNLO_f, PLO2_f, &
                  &                PNNLO_f, PLONLO_f, PNLOLO_f, PLO3_f)
             fL = CxN3LO_with_logs(ch%CLLO, ch%CLNLO, ch%CLNNLO, ch%CLN3LO, f, PLO_f, PNLO_f, PLO2_f, &
                  &                PNNLO_f, PLONLO_f, PNLOLO_f, PLO3_f)
             f3 = CxN3LO_with_logs(ch%C3LO, ch%C3NLO, ch%C3NNLO, ch%C3N3LO, f, PLO_f, PNLO_f, PLO2_f, &
                  &                PNNLO_f, PLONLO_f, PNLOLO_f, PLO3_f)
          endif

          ! now the fl_11 piece
          f2_fl11 = ch%C2N3LO_fl11 * f
          fL_fl11 = ch%CLN3LO_fl11 * f

          sf_tables(1)%tab(:,:,iQ) = sf_tables(1)%tab(:,:,iQ) + &
               & (as2pi**3) * structure_function_general_full(f2, fL, f3, f2_fl11, fL_fl11)
       endif
    end do
  end subroutine set_structure_functions_upto


  !----------------------------------------------------------------------
  ! set up structure functions for scale_choice = 0, 1, adding up each order
  subroutine set_structure_functions_upto_flav (order)
    integer, intent(in) :: order
    integer :: iQ
    real(dp) :: Q, as2pi
    real(dp) :: f(0:grid%ny,ncompmin:ncompmax)
    real(dp) :: f2(0:grid%ny,ncompmin:ncompmax)
    real(dp) :: fL(0:grid%ny,ncompmin:ncompmax)
    real(dp) :: f3(0:grid%ny,ncompmin:ncompmax)
    real(dp) :: f2_fl11(0:grid%ny,ncompmin:ncompmax)
    real(dp) :: fL_fl11(0:grid%ny,ncompmin:ncompmax)
    real(dp) :: PLO_f (0:grid%ny,ncompmin:ncompmax)
    real(dp) :: PNLO_f(0:grid%ny,ncompmin:ncompmax)
    real(dp) :: PLO2_f(0:grid%ny,ncompmin:ncompmax)
    real(dp) :: PNNLO_f(0:grid%ny,ncompmin:ncompmax)
    real(dp) :: PLONLO_f(0:grid%ny,ncompmin:ncompmax)
    real(dp) :: PNLOLO_f(0:grid%ny,ncompmin:ncompmax)
    real(dp) :: PLO3_f(0:grid%ny,ncompmin:ncompmax)
    
    do iQ = 0, tables(0)%nQ
       
       Q = tables(0)%Q_vals(iQ)
       call EvalPdfTable_Q(tables(0),sf_muF(Q),f)
       call set_scale_logs(Q)
       
       as2pi = alphasLocal(sf_muR(Q)) / (twopi)
       
       if (use_mass_thresholds) then
          call use_vfns(f, Q)
       endif
   
       ! start with LO
       if (order.ge.1) then
          sf_tables_flav(1)%tab(:,:,iQ) = ch%CLLO*f
          sf_tables_flav(2)%tab(:,:,iQ) = ch%C2LO*f
          sf_tables_flav(3)%tab(:,:,iQ) = ch%C3LO*f
       endif
       
       ! now add NLO terms
       if (order.ge.2) then
          if ((scale_choice_save.eq.scale_choice_Q).and.(xmuR.eq.one).and.(xmuF.eq.one)) then
             ! For central scale with scale_choice=1, we don't need to do all
             ! the convolutions of the splitting functions
             f2 = ch%C2NLO * f
             fL = ch%CLNLO * f
             f3 = ch%C3NLO * f
          else
             ! do the convolution with the coefficient functions and also the
             ! corresponding splitting-function contributions when scales
             ! are not equal to Q
             PLO_f = dh%P_LO * f
             f2 = CxNLO_with_logs(ch%C2LO, ch%C2NLO, f, PLO_f)
             fL = CxNLO_with_logs(ch%CLLO, ch%CLNLO, f, PLO_f)
             f3 = CxNLO_with_logs(ch%C3LO, ch%C3NLO, f, PLO_f)
          endif

          sf_tables_flav(1)%tab(:,:,iQ) = sf_tables_flav(1)%tab(:,:,iQ) + &
               & as2pi * fl
          sf_tables_flav(2)%tab(:,:,iQ) = sf_tables_flav(2)%tab(:,:,iQ) + &
               & as2pi * f2
          sf_tables_flav(3)%tab(:,:,iQ) = sf_tables_flav(3)%tab(:,:,iQ) + &
               & as2pi * f3
       endif

       if(order.ge.3) call wae_error("Flavour decomposed SFs only implemented up to NLO.")
    end do
  end subroutine set_structure_functions_upto_flav

  
  !----------------------------------------------------------------------
  ! set up LO structure functions for scale_choice = 0, 1
  subroutine set_LO_structure_functions()
    integer :: iQ
    real(dp) :: f(0:grid%ny,ncompmin:ncompmax)
    real(dp) :: Q

    ! all coefficient functions at LO are delta functions (F2, FL and F3),
    ! so simply pass table(0) for each of the pieces
    do iQ = 0, tables(0)%nQ
       Q = tables(0)%Q_vals(iQ)
       ! explicitly evaluate the PDF at scale sf_muF(Q)
       call EvalPdfTable_Q(tables(0),sf_muF(Q),f)
       if (use_mass_thresholds) then
          call use_vfns(f, Q)
       endif
       sf_tables(1)%tab(:,:,iQ) = structure_function_general(ch%C2LO*f, ch%CLLO*f, ch%C3LO*f)
    end do
    
  end subroutine set_LO_structure_functions
  
  !----------------------------------------------------------------------
  ! set up LO structure functions for scale_choice = 0, 1 decomposed in flavour
  subroutine set_LO_structure_functions_flav()
    integer :: iQ
    real(dp) :: f(0:grid%ny,ncompmin:ncompmax)
    real(dp) :: Q

    ! all coefficient functions at LO are delta functions (F2, FL and F3),
    ! so simply pass table(0) for each of the pieces
    do iQ = 0, tables(0)%nQ
       Q = tables(0)%Q_vals(iQ)
       ! explicitly evaluate the PDF at scale sf_muF(Q)
       call EvalPdfTable_Q(tables(0),sf_muF(Q),f)
       if (use_mass_thresholds) then
          call use_vfns(f, Q)
       endif
       sf_tables_flav(1)%tab(:,:,iQ) = ch%CLLO*f
       sf_tables_flav(2)%tab(:,:,iQ) = ch%C2LO*f
       sf_tables_flav(3)%tab(:,:,iQ) = ch%C3LO*f
    end do
    
  end subroutine set_LO_structure_functions_flav
  
  !----------------------------------------------------------------------
  ! Set up the LO structure functions for any scale choice
  subroutine set_LO_structure_functions_anyscale()
    integer :: iQ
    real(dp) :: f (0:grid%ny,ncompmin:ncompmax)

    ! all coefficient functions at LO are delta functions (F2, FL and F3),
    ! so simply pass table(0) for each of the pieces
    do iQ = 0, tables(0)%nQ
       f = tables(0)%tab(:,:,iQ)
       
       if (use_mass_thresholds) then
          call use_vfns(f, tables(0)%Q_vals(iQ))
       endif
       
       sf_tables(1)%tab(:,:,iQ) = structure_function_general(&
            & f * ch%C2LO, &
            & f * ch%CLLO, &
            & f * ch%C3LO)       
    end do
    
  end subroutine set_LO_structure_functions_anyscale
  !----------------------------------------------------------------------
  ! Set up the LO structure functions for any scale choice flavour decomposed
  subroutine set_LO_structure_functions_anyscale_flav()
    integer :: iQ
    real(dp) :: f (0:grid%ny,ncompmin:ncompmax)

    ! all coefficient functions at LO are delta functions (F2, FL and F3),
    ! so simply pass table(0) for each of the pieces
    do iQ = 0, tables(0)%nQ
       f = tables(0)%tab(:,:,iQ)
       
       if (use_mass_thresholds) then
          call use_vfns(f, tables(0)%Q_vals(iQ))
       endif
       
       sf_tables_flav(1)%tab(:,:,iQ) = ch%CLLO*f
       sf_tables_flav(2)%tab(:,:,iQ) = ch%C2LO*f
       sf_tables_flav(3)%tab(:,:,iQ) = ch%C3LO*f
    end do
    
  end subroutine set_LO_structure_functions_anyscale_flav
  
  !----------------------------------------------------------------------
  ! set up NLO structure functions for scale_choice = 0, 1
  subroutine set_NLO_structure_functions()
    integer :: iQ
    real(dp) :: f (0:grid%ny,ncompmin:ncompmax)
    real(dp) :: f2(0:grid%ny,ncompmin:ncompmax)
    real(dp) :: fL(0:grid%ny,ncompmin:ncompmax)
    real(dp) :: f3(0:grid%ny,ncompmin:ncompmax)
    real(dp) :: PLO_f(0:grid%ny,ncompmin:ncompmax)
    real(dp) :: Q
    
    do iQ = 0, tables(0)%nQ
       
       Q = tables(0)%Q_vals(iQ)
       call EvalPdfTable_Q(tables(0),sf_muF(Q),f)
       call set_scale_logs(Q)
       
       if (use_mass_thresholds) then
          call use_vfns(f, Q)
       endif

       if ((scale_choice_save.eq.scale_choice_Q).and.(xmuR.eq.one).and.(xmuF.eq.one)) then
       ! For central scale with scale_choice=1, we don't need to do all
       ! the convolutions of the splitting functions
          f2 = ch%C2NLO * f
          fL = ch%CLNLO * f
          f3 = ch%C3NLO * f
       else
       ! do the convolution with the coefficient functions and also the
       ! corresponding splitting-function contributions when scales
       ! are not equal to Q
          PLO_f = dh%P_LO * f
          f2 = CxNLO_with_logs(ch%C2LO, ch%C2NLO, f, PLO_f)
          fL = CxNLO_with_logs(ch%CLLO, ch%CLNLO, f, PLO_f)
          f3 = CxNLO_with_logs(ch%C3LO, ch%C3NLO, f, PLO_f)
       endif
          
       sf_tables(2)%tab(:,:,iQ) = structure_function_general(f2, fL, f3)

    end do

  end subroutine set_NLO_structure_functions

  !----------------------------------------------------------------------
  ! set up NLO structure functions for scale_choice = 0, 1 with flavour decomposition
  subroutine set_NLO_structure_functions_flav()
    integer :: iQ
    real(dp) :: f (0:grid%ny,ncompmin:ncompmax)
    real(dp) :: f2(0:grid%ny,ncompmin:ncompmax)
    real(dp) :: fL(0:grid%ny,ncompmin:ncompmax)
    real(dp) :: f3(0:grid%ny,ncompmin:ncompmax)
    real(dp) :: PLO_f(0:grid%ny,ncompmin:ncompmax)
    real(dp) :: Q
    
    do iQ = 0, tables(0)%nQ
       
       Q = tables(0)%Q_vals(iQ)
       call EvalPdfTable_Q(tables(0),sf_muF(Q),f)
       call set_scale_logs(Q)
       
       if (use_mass_thresholds) then
          call use_vfns(f, Q)
       endif

       if ((scale_choice_save.eq.scale_choice_Q).and.(xmuR.eq.one).and.(xmuF.eq.one)) then
       ! For central scale with scale_choice=1, we don't need to do all
       ! the convolutions of the splitting functions
          f2 = ch%C2NLO * f
          fL = ch%CLNLO * f
          f3 = ch%C3NLO * f
       else
       ! do the convolution with the coefficient functions and also the
       ! corresponding splitting-function contributions when scales
       ! are not equal to Q
          PLO_f = dh%P_LO * f
          f2 = CxNLO_with_logs(ch%C2LO, ch%C2NLO, f, PLO_f)
          fL = CxNLO_with_logs(ch%CLLO, ch%CLNLO, f, PLO_f)
          f3 = CxNLO_with_logs(ch%C3LO, ch%C3NLO, f, PLO_f)
       endif
          
       sf_tables_flav(4)%tab(:,:,iQ) = fL
       sf_tables_flav(5)%tab(:,:,iQ) = f2
       sf_tables_flav(6)%tab(:,:,iQ) = f3

    end do

  end subroutine set_NLO_structure_functions_flav

  !----------------------------------------------------------------------
  ! Set up the NLO structure functions for any scale choice
  subroutine set_NLO_structure_functions_anyscale()
    integer :: iQ
    real(dp) :: f (0:grid%ny,ncompmin:ncompmax)
    real(dp) :: f2(0:grid%ny,ncompmin:ncompmax)
    real(dp) :: fL(0:grid%ny,ncompmin:ncompmax)
    real(dp) :: f3(0:grid%ny,ncompmin:ncompmax)
    real(dp) :: PLO_f(0:grid%ny,ncompmin:ncompmax)
    real(dp) :: Q
    
    do iQ = 0, tables(0)%nQ
       ! Internal Q value effectively corresponds to sf_muF(Q1,Q2)
       Q = tables(0)%Q_vals(iQ)
       f = tables(0)%tab(:,:,iQ)

       ! Save the NLO pieces in sf_tables(2) and sf_tables(3)
      
       ! Get the NLO coefficient function, (C_NLO x f) 
       f2 = (ch%C2NLO * f)
       fL = (ch%CLNLO * f)
       f3 = (ch%C3NLO * f)
       sf_tables(2)%tab(:,:,iQ) = structure_function_general(f2, fL, f3)

       ! Now compute the (C_LO x P_LO x f) term
       PLO_f = dh%P_LO * f
       f2 = (ch%C2LO * PLO_f)
       fL = (ch%CLLO * PLO_f)
       f3 = (ch%C3LO * PLO_f)
       sf_tables(3)%tab(:,:,iQ) = structure_function_general(f2, fL, f3)
    end do

  end subroutine set_NLO_structure_functions_anyscale
  
  !----------------------------------------------------------------------
  ! Set up the NLO structure functions for any scale choice
  subroutine set_NLO_structure_functions_anyscale_flav()
    integer :: iQ
    real(dp) :: f (0:grid%ny,ncompmin:ncompmax)
    real(dp) :: f2(0:grid%ny,ncompmin:ncompmax)
    real(dp) :: fL(0:grid%ny,ncompmin:ncompmax)
    real(dp) :: f3(0:grid%ny,ncompmin:ncompmax)
    real(dp) :: PLO_f(0:grid%ny,ncompmin:ncompmax)
    real(dp) :: Q
    
    do iQ = 0, tables(0)%nQ
       ! Internal Q value effectively corresponds to sf_muF(Q1,Q2)
       Q = tables(0)%Q_vals(iQ)
       f = tables(0)%tab(:,:,iQ)

       ! Save the NLO pieces in sf_tables(2) and sf_tables(3)
      
       ! Get the NLO coefficient function, (C_NLO x f) 
       f2 = (ch%C2NLO * f)
       fL = (ch%CLNLO * f)
       f3 = (ch%C3NLO * f)
       sf_tables_flav(4)%tab(:,:,iQ) = fL
       sf_tables_flav(5)%tab(:,:,iQ) = f2
       sf_tables_flav(6)%tab(:,:,iQ) = f3

       ! Now compute the (C_LO x P_LO x f) term
       PLO_f = dh%P_LO * f
       f2 = (ch%C2LO * PLO_f)
       fL = (ch%CLLO * PLO_f)
       f3 = (ch%C3LO * PLO_f)
       sf_tables_flav(7)%tab(:,:,iQ) = fL
       sf_tables_flav(8)%tab(:,:,iQ) = f2
       sf_tables_flav(9)%tab(:,:,iQ) = f3
    end do

  end subroutine set_NLO_structure_functions_anyscale_flav
  
  !----------------------------------------------------------------------
  ! returns the convolution of coefficient and splitting functions
  ! for NLO, with scale dependence; leading factor of as2pi left out.
  !
  ! This routine assumes that set_scale_logs(Q) has been called
  ! beforehand.
  function CxNLO_with_logs(CxLO, CxNLO, f, PLO_f) result(res)
    real(dp),        intent(in) :: CxLO
    type(split_mat), intent(in) :: CxNLO
    real(dp),        intent(in) :: f    (0:grid%ny,ncompmin:ncompmax)
    real(dp),        intent(in) :: PLO_f(0:grid%ny,ncompmin:ncompmax)
    real(dp)                    :: res  (0:grid%ny,ncompmin:ncompmax)
    !----------------------------------------------------------------

    res = CxNLO * f - (CxLO * log_muF2_over_Q2) * PLO_f
  end function CxNLO_with_logs
  
  !----------------------------------------------------------------------
  ! set up the NNLO structure functions for scale_choice = 0, 1
  subroutine set_NNLO_structure_functions()
    integer :: iQ
    real(dp) :: f (0:grid%ny,ncompmin:ncompmax)
    real(dp) :: f2(0:grid%ny,ncompmin:ncompmax)
    real(dp) :: fL(0:grid%ny,ncompmin:ncompmax)
    real(dp) :: f3(0:grid%ny,ncompmin:ncompmax)
    real(dp) :: PLO_f (0:grid%ny,ncompmin:ncompmax)
    real(dp) :: PNLO_f(0:grid%ny,ncompmin:ncompmax)
    real(dp) :: PLO2_f(0:grid%ny,ncompmin:ncompmax)
    real(dp) :: Q
    
    do iQ = 0, tables(0)%nQ

       Q = tables(0)%Q_vals(iQ)
       call EvalPdfTable_Q(tables(0),sf_muF(Q),f)
       call set_scale_logs(Q)
       
       if (use_mass_thresholds) then
          call use_vfns(f, Q)
       endif
       
       if ((scale_choice_save.eq.scale_choice_Q).and.(xmuR.eq.one).and.(xmuF.eq.one)) then
       ! For central scale with scale_choice=1, we don't need to do all
       ! the convolutions of the splitting functions
          f2 = ch%C2NNLO * f
          fL = ch%CLNNLO * f
          f3 = ch%C3NNLO * f
       else
       ! do the convolution with the coefficient functions and also the
       ! corresponding splitting-function contributions when scales
       ! are not equal to Q
          PLO_f   = dh%P_LO  * f
          PNLO_f  = dh%P_NLO * f
          PLO2_f  = dh%P_LO  * PLO_f
          f2 = CxNNLO_with_logs(ch%C2LO, ch%C2NLO, ch%C2NNLO, f, PLO_f, PNLO_f, PLO2_f)
          fL = CxNNLO_with_logs(ch%CLLO, ch%CLNLO, ch%CLNNLO, f, PLO_f, PNLO_f, PLO2_f)
          f3 = CxNNLO_with_logs(ch%C3LO, ch%C3NLO, ch%C3NNLO, f, PLO_f, PNLO_f, PLO2_f)
       endif

       sf_tables(4)%tab(:,:,iQ) = structure_function_general(f2, fL, f3)
     
    end do

  end subroutine set_NNLO_structure_functions
  
  !----------------------------------------------------------------------
  ! returns the convolution of coefficient and splitting functions
  ! for NNLO, with scale dependence; leading factor of as2pi left out.
  !
  ! This routine assumes that set_scale_logs(Q) has been called
  ! beforehand.
  function CxNNLO_with_logs(CxLO, CxNLO, CxNNLO, f, PLO_f, PNLO_f, PLO2_f) result(res)
    real(dp),        intent(in) :: CxLO
    type(split_mat), intent(in) :: CxNLO
    type(split_mat), intent(in) :: CxNNLO
    real(dp),        intent(in) :: f    (0:grid%ny,ncompmin:ncompmax)
    real(dp),        intent(in) :: PLO_f(0:grid%ny,ncompmin:ncompmax)
    real(dp),        intent(in) :: PNLO_f(0:grid%ny,ncompmin:ncompmax)
    real(dp),        intent(in) :: PLO2_f(0:grid%ny,ncompmin:ncompmax)
    real(dp)                    :: res  (0:grid%ny,ncompmin:ncompmax)
    !----------------------------------------------------------------
    real(dp) :: f_NLO(0:grid%ny,ncompmin:ncompmax)
    real(dp) :: f_NNLO(0:grid%ny,ncompmin:ncompmax)
    real(dp) :: LR, LF

    LR = log_muR2_over_Q2
    LF = log_muF2_over_Q2
    
    f_NLO  = - LF * PLO_f

    f_NNLO = + half * LF**2 * PLO2_f &
         &   - LF * PNLO_f &
         &   - (twopi*beta0*(LR*LF - half * LF**2)) * PLO_f
    
    res = CxNNLO * f  +  CxNLO * f_NLO  +  CxLO * f_NNLO  +  (twopi*beta0*LR) * (CxNLO * f)
  end function CxNNLO_with_logs


  !----------------------------------------------------------------------
  ! set up the NNLO structure functions
  subroutine set_NNLO_structure_functions_anyscale()
    integer :: iQ
    real(dp) :: f (0:grid%ny,ncompmin:ncompmax)
    real(dp) :: f2(0:grid%ny,ncompmin:ncompmax)
    real(dp) :: fL(0:grid%ny,ncompmin:ncompmax)
    real(dp) :: f3(0:grid%ny,ncompmin:ncompmax)
    real(dp) :: PLO_f (0:grid%ny,ncompmin:ncompmax)
    real(dp) :: PNLO_f(0:grid%ny,ncompmin:ncompmax)
    real(dp) :: PLO2_f(0:grid%ny,ncompmin:ncompmax)
    real(dp) :: Q

    do iQ = 0, tables(0)%nQ

       Q = tables(0)%Q_vals(iQ)
       f = tables(0)%tab(:,:,iQ)
       
       ! save the NNLO pieces in sf_tables(4:7)
       
       PLO2_f  = dh%P_LO  * (dh%P_LO * f)
       PLO_f   = dh%P_LO  * f
       PNLO_f  = dh%P_NLO * f

       ! first calculate the pure NNLO term, (C_NNLO x f) 
       f2 = (ch%C2NNLO * f)
       fL = (ch%CLNNLO * f)
       f3 = (ch%C3NNLO * f)
       sf_tables(4)%tab(:,:,iQ) = structure_function_general(f2, fL, f3)

       ! Now calculate the (C_LO x P_LO^2 x f) term
       f2 =  (ch%C2LO * PLO2_f)
       fL =  (ch%CLLO * PLO2_f)
       f3 =  (ch%C3LO * PLO2_f)
       sf_tables(5)%tab(:,:,iQ) = structure_function_general(f2, fL, f3)

       ! Now calculate the (C_LO x P_NLO) term
       f2 = (ch%C2LO * PNLO_f)
       fL = (ch%CLLO * PNLO_f)
       f3 = (ch%C3LO * PNLO_f)
       sf_tables(6)%tab(:,:,iQ) = structure_function_general(f2, fL, f3)

       ! Now calculate the (C_NLO x P_LO) term
       f2 = (ch%C2NLO * PLO_f)
       fL = (ch%CLNLO * PLO_f)
       f3 = (ch%C3NLO * PLO_f)
       sf_tables(7)%tab(:,:,iQ) = structure_function_general(f2, fL, f3)

    end do

  end subroutine set_NNLO_structure_functions_anyscale

  !----------------------------------------------------------------------
  ! set up the N3LO structure functions for scale_choice = 0, 1
  ! Warning : for now factorisation and renormalisation scale are set to Q
  subroutine set_N3LO_structure_functions()
    integer :: iQ
    real(dp) :: f (0:grid%ny,ncompmin:ncompmax)
    real(dp) :: f2(0:grid%ny,ncompmin:ncompmax)
    real(dp) :: fL(0:grid%ny,ncompmin:ncompmax)
    real(dp) :: f3(0:grid%ny,ncompmin:ncompmax)
    real(dp) :: f2_fl11(0:grid%ny,ncompmin:ncompmax)
    real(dp) :: fL_fl11(0:grid%ny,ncompmin:ncompmax)
    real(dp) :: PLO_f (0:grid%ny,ncompmin:ncompmax)
    real(dp) :: PNLO_f(0:grid%ny,ncompmin:ncompmax)
    real(dp) :: PLO2_f(0:grid%ny,ncompmin:ncompmax)
    real(dp) :: PNNLO_f(0:grid%ny,ncompmin:ncompmax)
    real(dp) :: PLONLO_f(0:grid%ny,ncompmin:ncompmax)
    real(dp) :: PNLOLO_f(0:grid%ny,ncompmin:ncompmax)
    real(dp) :: PLO3_f(0:grid%ny,ncompmin:ncompmax)
    real(dp) :: Q
    
    do iQ = 0, tables(0)%nQ

       Q = tables(0)%Q_vals(iQ)
       call EvalPdfTable_Q(tables(0),sf_muF(Q),f)
       call set_scale_logs(Q)
       
       if (use_mass_thresholds) then
          call use_vfns(f, Q)
       endif
       
       if ((scale_choice_save.eq.scale_choice_Q).and.(xmuR.eq.one).and.(xmuF.eq.one)) then
       ! For central scale with scale_choice=1 (i.e. mur=muf=Q), we don't
       ! need to do all the convolutions of the splitting functions
          f2 = ch%C2N3LO * f
          fL = ch%CLN3LO * f
          f3 = ch%C3N3LO * f
       else
       ! do the convolution with the coefficient functions and also the
       ! corresponding splitting-function contributions when scales
       ! are not equal to Q
          PLO_f    = dh%P_LO   * f
          PNLO_f   = dh%P_NLO  * f
          PLO2_f   = dh%P_LO   * PLO_f
          PNNLO_f  = dh%P_NNLO * f
          PLONLO_f = dh%P_LO   * PNLO_f
          PNLOLO_f = dh%P_NLO  * PLO_f
          PLO3_f   = dh%P_LO   * PLO2_f
          
          f2 = CxN3LO_with_logs(ch%C2LO, ch%C2NLO, ch%C2NNLO, ch%C2N3LO, f, PLO_f, PNLO_f, PLO2_f, &
               &                PNNLO_f, PLONLO_f, PNLOLO_f, PLO3_f)
          fL = CxN3LO_with_logs(ch%CLLO, ch%CLNLO, ch%CLNNLO, ch%CLN3LO, f, PLO_f, PNLO_f, PLO2_f, &
               &                PNNLO_f, PLONLO_f, PNLOLO_f, PLO3_f)
          f3 = CxN3LO_with_logs(ch%C3LO, ch%C3NLO, ch%C3NNLO, ch%C3N3LO, f, PLO_f, PNLO_f, PLO2_f, &
               &                PNNLO_f, PLONLO_f, PNLOLO_f, PLO3_f)
       endif
       
       ! now the fl_11 piece
       f2_fl11 = ch%C2N3LO_fl11 * f
       fL_fl11 = ch%CLN3LO_fl11 * f

       !sf_tables(8)%tab(:,:,iQ) = structure_function_general(f2, fL, f3)
       sf_tables(8)%tab(:,:,iQ) = structure_function_general_full(f2, fL, f3, f2_fl11, fL_fl11)
     
    end do

  end subroutine set_N3LO_structure_functions
  

  !----------------------------------------------------------------------
  ! returns the convolution of coefficient and splitting functions
  ! for N3LO, with scale dependence; leading factor of as2pi left out.
  !
  ! This routine assumes that set_scale_logs(Q) has been called
  ! beforehand.
  function CxN3LO_with_logs(CxLO, CxNLO, CxNNLO, CxN3LO, f, PLO_f, PNLO_f, PLO2_f, &
       &                    PNNLO_f, PLONLO_f, PNLOLO_f, PLO3_f) result(res)
    real(dp),        intent(in) :: CxLO
    type(split_mat), intent(in) :: CxNLO
    type(split_mat), intent(in) :: CxNNLO
    type(split_mat), intent(in) :: CxN3LO
    real(dp),        intent(in) :: f    (0:grid%ny,ncompmin:ncompmax)
    real(dp),        intent(in) :: PLO_f(0:grid%ny,ncompmin:ncompmax)
    real(dp),        intent(in) :: PNLO_f(0:grid%ny,ncompmin:ncompmax)
    real(dp),        intent(in) :: PLO2_f(0:grid%ny,ncompmin:ncompmax)
    real(dp),        intent(in) :: PNNLO_f(0:grid%ny,ncompmin:ncompmax)
    real(dp),        intent(in) :: PLONLO_f(0:grid%ny,ncompmin:ncompmax)
    real(dp),        intent(in) :: PNLOLO_f(0:grid%ny,ncompmin:ncompmax)
    real(dp),        intent(in) :: PLO3_f(0:grid%ny,ncompmin:ncompmax)
    real(dp)                    :: res  (0:grid%ny,ncompmin:ncompmax)
    !----------------------------------------------------------------
    real(dp) :: f_NLO(0:grid%ny,ncompmin:ncompmax)
    real(dp) :: f_NNLO(0:grid%ny,ncompmin:ncompmax)
    real(dp) :: f_N3LO(0:grid%ny,ncompmin:ncompmax)
    real(dp) :: LR, LF

    LR = log_muR2_over_Q2
    LF = log_muF2_over_Q2
    
    f_NLO  = - LF * PLO_f

    f_NNLO = + half * LF**2 * PLO2_f &
         &   - LF * PNLO_f &
         &   - (twopi*beta0*(LR*LF - half * LF**2)) * PLO_f

    f_N3LO = -(1.0_dp/6.0_dp) * LF * ( &
         & - three * twopi**2 * beta1 * (LF - two * LR) * PLO_f &
         & + two * (twopi*beta0)**2 * (LF**2 - three * LF * LR + three * LR**2) * PLO_f &
         & + LF**2 * PLO3_f &
         & + three * twopi * beta0 * (LF - two * LR) * (LF * PLO2_f - two * PNLO_f) &
         & - 3.0_dp * LF * (PLONLO_f + PNLOLO_f) + 6.0_dp * PNNLO_f)
    
    res = CxN3LO * f  &
         & + (1.0_dp/6.0_dp) * LR * (6.0_dp * twopi**2 * beta1 * (CxNLO * f) &
         & + twopi*beta0 * (12.0_dp * (CxNNLO * f) + 6.0_dp * twopi * beta0 * LR * (CxNLO * f))) &
         & + CxNNLO * f_NLO + twopi * beta0 * LR * (CxNLO * f_NLO) &
         & + CxNLO * f_NNLO + CxLO * f_N3LO
  end function CxN3LO_with_logs

  !----------------------------------------------------------------------
  ! set up the N3LO structure functions
  subroutine set_N3LO_structure_functions_anyscale()
    integer :: iQ
    real(dp) :: f (0:grid%ny,ncompmin:ncompmax)
    real(dp) :: f2(0:grid%ny,ncompmin:ncompmax)
    real(dp) :: fL(0:grid%ny,ncompmin:ncompmax)
    real(dp) :: f3(0:grid%ny,ncompmin:ncompmax)
    real(dp) :: f2_fl11(0:grid%ny,ncompmin:ncompmax)
    real(dp) :: fL_fl11(0:grid%ny,ncompmin:ncompmax)
    real(dp) :: PLO_f (0:grid%ny,ncompmin:ncompmax)
    real(dp) :: PNLO_f(0:grid%ny,ncompmin:ncompmax)
    real(dp) :: PLO2_f(0:grid%ny,ncompmin:ncompmax)
    real(dp) :: PNNLO_f(0:grid%ny,ncompmin:ncompmax)
    real(dp) :: PLONLO_f(0:grid%ny,ncompmin:ncompmax)
    real(dp) :: PNLOLO_f(0:grid%ny,ncompmin:ncompmax)
    real(dp) :: PLO3_f(0:grid%ny,ncompmin:ncompmax)
    real(dp) :: Q

    do iQ = 0, tables(0)%nQ

       Q = tables(0)%Q_vals(iQ)
       f = tables(0)%tab(:,:,iQ)
       
       ! save the N3LO pieces in sf_tables(8:15)
       
       PLO_f    = dh%P_LO  * f
       PLO2_f   = dh%P_LO  * PLO_f
       PNLO_f   = dh%P_NLO * f
       PNNLO_f  = dh%P_NNLO * f
       PLONLO_f = dh%P_LO   * PNLO_f
       PNLOLO_f = dh%P_NLO  * PLO_f
       PLO3_f   = dh%P_LO   * PLO2_f

       ! first calculate the pure N3LO term, (C_N3LO x f) 
       f2 = (ch%C2N3LO * f)
       fL = (ch%CLN3LO * f)
       f3 = (ch%C3N3LO * f)
       f2_fl11 = (ch%C2N3LO_fl11 * f)
       fL_fl11 = (ch%CLN3LO_fl11 * f)
       ! sf_tables(8)%tab(:,:,iQ) = structure_function_general(f2, fL, f3)
       sf_tables(8)%tab(:,:,iQ) = structure_function_general_full(f2, fL, f3, f2_fl11, fL_fl11)

       ! Now calculate the (C_LO x P_LO^3 x f) term
       f2 =  (ch%C2LO * PLO3_f)
       fL =  (ch%CLLO * PLO3_f)
       f3 =  (ch%C3LO * PLO3_f)
       sf_tables(9)%tab(:,:,iQ) = structure_function_general(f2, fL, f3)

       ! Now calculate the (C_LO x P_LO x P_NLO x f) term
       f2 =  (ch%C2LO * PLONLO_f)
       fL =  (ch%CLLO * PLONLO_f)
       f3 =  (ch%C3LO * PLONLO_f)
       sf_tables(10)%tab(:,:,iQ) = structure_function_general(f2, fL, f3)

       ! Now calculate the (C_LO x P_NLO x P_LO x f) term
       f2 =  (ch%C2LO * PNLOLO_f)
       fL =  (ch%CLLO * PNLOLO_f)
       f3 =  (ch%C3LO * PNLOLO_f)
       sf_tables(11)%tab(:,:,iQ) = structure_function_general(f2, fL, f3)

       ! Now calculate the (C_NLO x P_LO^2 x f) term
       f2 =  (ch%C2NLO * PLO2_f)
       fL =  (ch%CLNLO * PLO2_f)
       f3 =  (ch%C3NLO * PLO2_f)
       sf_tables(12)%tab(:,:,iQ) = structure_function_general(f2, fL, f3)

       ! Now calculate the (C_NLO x P_NLO) term
       f2 = (ch%C2NLO * PNLO_f)
       fL = (ch%CLNLO * PNLO_f)
       f3 = (ch%C3NLO * PNLO_f)
       sf_tables(13)%tab(:,:,iQ) = structure_function_general(f2, fL, f3)

       ! Now calculate the (C_NNLO x P_LO) term
       f2 = (ch%C2NNLO * PLO_f)
       fL = (ch%CLNNLO * PLO_f)
       f3 = (ch%C3NNLO * PLO_f)
       sf_tables(14)%tab(:,:,iQ) = structure_function_general(f2, fL, f3)

       ! Now calculate the (C_LO x P_NNLO) term
       f2 = (ch%C2LO * PNNLO_f)
       fL = (ch%CLLO * PNNLO_f)
       f3 = (ch%C3LO * PNNLO_f)
       sf_tables(15)%tab(:,:,iQ) = structure_function_general(f2, fL, f3)

    end do

  end subroutine set_N3LO_structure_functions_anyscale


 !----------------------------------------------------------------------
 ! Structure function valid up to NNLO
  function structure_function_general(C2_f, CL_f, C3_f) result(res)
    real(dp), intent(in) :: C2_f(0:,ncompmin:), CL_f(0:,ncompmin:), C3_f(0:,ncompmin:)
    real(dp) :: C2_f_fl11(0:grid%ny,ncompmin:ncompmax)
    real(dp) :: CL_f_fl11(0:grid%ny,ncompmin:ncompmax)
    real(dp) :: res(0:ubound(C2_f,dim=1), -6:7)
    C2_f_fl11 = zero
    CL_f_fl11 = zero
    res = structure_function_general_full(C2_f, CL_f, C3_f, C2_f_fl11, CL_f_fl11)
  end function structure_function_general


 !----------------------------------------------------------------------
 ! Structure function including N3LO fl_11 piece for neutral current
  function structure_function_general_full(C2_f, CL_f, C3_f, C2_f_fl11, CL_f_fl11) result(res)
    real(dp), intent(in) :: C2_f(0:,ncompmin:), CL_f(0:,ncompmin:), C3_f(0:,ncompmin:)
    real(dp), intent(in) :: C2_f_fl11(0:,ncompmin:), CL_f_fl11(0:,ncompmin:)
    real(dp) :: C2_f_NC(0:grid%ny,ncompmin:ncompmax)
    real(dp) :: CL_f_NC(0:grid%ny,ncompmin:ncompmax)
    real(dp)             :: res(0:ubound(C2_f,dim=1), -6:7)
    !----------------------
    ! not just up and down, but the sum 
    real(dp) :: u(0:grid%ny), d(0:grid%ny), ubar(0:grid%ny), dbar(0:grid%ny) 
    real(dp) :: two_xvals(0:grid%ny)
    integer  :: nf_save
    
    two_xvals = two*xValues(grid) ! move this outside at some point
    C2_f_NC = C2_f + C2_f_fl11
    CL_f_NC = CL_f + CL_f_fl11

    res = zero
    !--- deal with Z case -----------------------------------------
    res(:,iF2Z) = (dlike(C2_f_NC) + dbarlike(C2_f_NC))*vi2_ai2_Z_down + &
         &       (ulike(C2_f_NC) + ubarlike(C2_f_NC))*vi2_ai2_Z_up

    ! temporarily put FL into F1;
    res(:,iF1Z) = (dlike(CL_f_NC) + dbarlike(CL_f_NC))*vi2_ai2_Z_down + &
         &       (ulike(CL_f_NC) + ubarlike(CL_f_NC))*vi2_ai2_Z_up
    ! then convert to F1
    res(:,iF1Z) = (res(:,iF2Z) - res(:,iF1Z)) / two_xvals

    res(:,iF3Z) = (dlike(C3_f) - dbarlike(C3_f))*two_vi_ai_Z_down + &
         &       (ulike(C3_f) - ubarlike(C3_f))*two_vi_ai_Z_up
    res(:,iF3Z) = res(:,iF3Z)/xValues(grid)

    !--- deal with EM case -----------------------------------------
    res(:,iF2EM) = (dlike(C2_f_NC) + dbarlike(C2_f_NC))*e2_down + &
         &        (ulike(C2_f_NC) + ubarlike(C2_f_NC))*e2_up
    
    ! temporarily put FL into F1;
    res(:,iF1EM) = (dlike(CL_f_NC) + dbarlike(CL_f_NC))*e2_down + &
         &        (ulike(CL_f_NC) + ubarlike(CL_f_NC))*e2_up
    ! then convert to F1
    res(:,iF1EM) = (res(:,iF2EM) - res(:,iF1EM)) / two_xvals
    
    !--- deal with gamma-Z case -----------------------------------------
    ! equations taken from section 19 of PDG (19.18)
    res(:,iF2gZ) = (dlike(C2_f_NC) + dbarlike(C2_f_NC))*e_down*two_vi_Z_down + &
         &        (ulike(C2_f_NC) + ubarlike(C2_f_NC))*e_up * two_vi_Z_up
    
    ! temporarily put FL into F1;
    res(:,iF1gZ) = (dlike(CL_f_NC) + dbarlike(CL_f_NC))*e_down*two_vi_Z_down + &
         &        (ulike(CL_f_NC) + ubarlike(CL_f_NC))*e_up * two_vi_Z_up
    ! then convert to F1
    res(:,iF1gZ) = (res(:,iF2gZ) - res(:,iF1gZ)) / two_xvals
    
    res(:,iF3gZ) = (dlike(C3_f) - dbarlike(C3_f))*e_down*two_ai_Z_down + &
         &        (ulike(C3_f) - ubarlike(C3_f))*e_up * two_ai_Z_up
    res(:,iF3gZ) = res(:,iF3gZ)/xValues(grid)

    ! for the W cases, it only makes sense to sum over an even number
    ! of light flavours; so save the actual number of flavours, switch
    ! the module-local nf_lcl variable to the nearest (lower) event number
    ! for our W calculations; switch back later
    nf_save = nf_lcl
    nf_lcl = (nf_lcl/2) * 2

    ! AK It looks like we have swapped the meaning of Wp and
    !Wm. Looking at eq. 18.19 in the PDF and eq. 8 in 1206.7007 W-
    !should couple to u + dbar

    ! --- deal with Wm case
    !-----------------------------------------
    res(:,iF2Wm) = (ulike(C2_f) + dbarlike(C2_f))*vi2_ai2_avg_W
    ! temporarily put FL into F1;
    res(:,iF1Wm) = (ulike(CL_f) + dbarlike(CL_f))*vi2_ai2_avg_W
    ! then convert to F1
    res(:,iF1Wm) = (res(:,iF2Wm) - res(:,iF1Wm)) / two_xvals
    res(:,iF3Wm) = (ulike(C3_f) - dbarlike(C3_f))*two_vi_ai_avg_W
    res(:,iF3Wm) = res(:,iF3Wm)/xValues(grid)

    !--- deal with Wp case -----------------------------------------
    res(:,iF2Wp) = (dlike(C2_f) + ubarlike(C2_f))*vi2_ai2_avg_W
    ! temporarily put FL into F1;
    res(:,iF1Wp) = (dlike(CL_f) + ubarlike(CL_f))*vi2_ai2_avg_W
    ! then convert to F1
    res(:,iF1Wp) = (res(:,iF2Wp) - res(:,iF1Wp)) / two_xvals
    res(:,iF3Wp) = (dlike(C3_f) - ubarlike(C3_f))*two_vi_ai_avg_W
    res(:,iF3Wp) = res(:,iF3Wp)/xValues(grid)

!    ! --- deal with Wp case
!    !-----------------------------------------
!    res(:,iF2Wp) = (ulike(C2_f) + dbarlike(C2_f))*vi2_ai2_avg_W
!    ! temporarily put FL into F1;
!    res(:,iF1Wp) = (ulike(CL_f) + dbarlike(CL_f))*vi2_ai2_avg_W
!    ! then convert to F1
!    res(:,iF1Wp) = (res(:,iF2Wp) - res(:,iF1Wp)) / two_xvals
!    res(:,iF3Wp) = (ulike(C3_f) - dbarlike(C3_f))*two_vi_ai_avg_W
!    res(:,iF3Wp) = res(:,iF3Wp)/xValues(grid)
!
!    !--- deal with Wm case -----------------------------------------
!    res(:,iF2Wm) = (dlike(C2_f) + ubarlike(C2_f))*vi2_ai2_avg_W
!    ! temporarily put FL into F1;
!    res(:,iF1Wm) = (dlike(CL_f) + ubarlike(CL_f))*vi2_ai2_avg_W
!    ! then convert to F1
!    res(:,iF1Wm) = (res(:,iF2Wm) - res(:,iF1Wm)) / two_xvals
!    res(:,iF3Wm) = (dlike(C3_f) - ubarlike(C3_f))*two_vi_ai_avg_W
!    res(:,iF3Wm) = res(:,iF3Wm)/xValues(grid)

    ! reset nf_lcl to the full (possibly odd) saved value
    nf_lcl = nf_save

    ! AK 16-08-2023: The factor of two is included in SF in the VBF
    ! paper by Maltoni et al. It was kept here until today since the
    ! structure functions were only used with VBF. Now it has been
    ! removed. WARNING: If running with a version of proVBFH pre this
    ! fix then a factor of 2 will be missing...

    ! overall factor of two that we still haven't fully looked into as
    ! of 2015-02-24 [GPS TMP] 
    ! res = res * two
    !! GPS+AK TMP: we have just included a factor of 2 but this plainly
    !! should not be present for the electromagnetic part; so here
    !! we eliminate it again...
    !res(:,iF2EM) = half * res(:,iF2EM)
    !res(:,iF1EM) = half * res(:,iF1EM)

  end function structure_function_general_full
  

  !----------------------------------------------------------------------
  function ulike(f) result(res)
    real(dp), intent(in) :: f(0:,ncompmin:)
    real(dp)             :: res(0:ubound(f,dim=1))
    res = sum(f(:, 2: nf_lcl: 2), dim=2)
  end function ulike
  !----------------------------------------------------------------------
  function dlike(f) result(res)
    real(dp), intent(in) :: f(0:,ncompmin:)
    real(dp)             :: res(0:ubound(f,dim=1))
    res = sum(f(:, 1: nf_lcl: 2), dim=2)
  end function dlike
  !----------------------------------------------------------------------
  function ubarlike(f) result(res)
    real(dp), intent(in) :: f(0:,ncompmin:)
    real(dp)             :: res(0:ubound(f,dim=1))
    res = sum(f(:,-2:-nf_lcl:-2), dim=2)
  end function ubarlike
  !----------------------------------------------------------------------
  function dbarlike(f) result(res)
    real(dp), intent(in) :: f(0:,ncompmin:)
    real(dp)             :: res(0:ubound(f,dim=1))
    res = sum(f(:,-1:-nf_lcl:-2), dim=2)
  end function dbarlike
  
  
  !----------------------------------------------------------------------
  real(dp) function alphasLocal(muR)
    real(dp), intent(in) :: muR
    !real(dp) :: muR_lcl
    !muR_lcl = max(muR,Qmin)
    ! we use alphas from the LHAPDF PDF
    ! alphasLocal = alphasPDF(muR_lcl)
    ! we use alphas from HOPPET
    alphasLocal = Value(coupling, muR)
  end function alphasLocal
  

  subroutine GetStrFctScales(Q, muR, muF, muR_lcl, muF_lcl, mu_table)
   real(dp), intent(in)  :: Q
   real(dp), intent(in),  optional :: muR, muF
   real(dp), intent(out) :: muR_lcl, muF_lcl, mu_table

   ! run a bunch of checks to make sure that the requested scales are consistent
   ! with what is needed here
   if (scale_choice_save == scale_choice_Q) then
      muR_lcl = xmuR * Q
      muF_lcl = xmuF * Q
      mu_table = Q
      if (present(muR)) then
         if (abs(muR/muR_lcl-1).gt.1e-10) call wae_error("GetStrFctScales (scale_choice_Q): ",&
               "requested muR inconsistent with initialisation, muR/(xmuR*Q) = ", &
               dbleval = muR/muR_lcl)
      endif 
      if (present(muF)) then
         if (abs(muF/muF_lcl-1).gt.1e-10) call wae_error("GetStrFctScales (scale_choice_Q): ",&
               "requested muR inconsistent with initialisation, muF/(xmuF*Q) = ", &
               dbleval = muF/muF_lcl)
      endif 
    else if (scale_choice_save == scale_choice_fixed) then
      muR_lcl = xmuR * cst_mu
      muF_lcl = xmuF * cst_mu
      mu_table = Q
      if (present(muR)) then
         if (abs(muR/muR_lcl-1).gt.1e-10) call wae_error("GetStrFctScales (scale_choice_fixed): ",&
               "requested muR inconsistent with initialisation, muR/(xmuR*cst_mu) = ", &
               dbleval = muR/muR_lcl)
      endif 
      if (present(muF)) then
         if (abs(muF/muF_lcl-1).gt.1e-10) call wae_error("GetStrFctScales (scale_choice_fixed): ",&
               "requested muR inconsistent with initialisation, muF/(xmuF*cst_mu) = ", &
               dbleval = muF/muF_lcl)
      endif 
    else if (scale_choice_save == scale_choice_arbitrary) then
      if (.not. present(muR)) call wae_error("GetStrFctScales: muR not present but required for scale_choice_arbitrary")
      if (.not. present(muF)) call wae_error("GetStrFctScales: muF not present but required for scale_choice_arbitrary")
      muR_lcl = muR
      muF_lcl = muF
      mu_table = muF
    else
      call wae_error("GetStrFctScales: scale_choice_save not recognised", intval = scale_choice_save)
    endif

    ! consistency check for use_sep_orders and scale choice
    if (.not. use_sep_orders .and. mu_table .ne. Q) then 
      call wae_error("GetStrFctScales: mu_table /= Q but use_sep_orders = .false.")
    end if
  end subroutine GetStrFctScales

  !---------------------------------------------------------------------
  !> @brief calculate the structure function at x, Q, muR, muF summed over all orders
  !!
  !! Calculate the structure function at x, Q, muR, muF summed over
  !! all orders. muR and muF are only needed if we are using the
  !! scale_choice_arbitrary, as otherwise they are already included in
  !! the sf_tables.
  !!
  !! @param[in]       x          x value
  !! @param[in]       Q          Q value
  !! @param[in]       muR        renormalisation scale 
  !! @param[in]       muF        factorisation scale
  !! @return          an array of all structure functions summed over orders
  !!
  function StrFct (x, Q, muR, muF) result(res)
    real(dp), intent(in)  :: x, Q
    real(dp), intent(in), optional  :: muR, muF
    real(dp) :: res(-6:7)
    real(dp) :: muR_lcl, muF_lcl, mu_table

    call GetStrFctScales(Q, muR, muF, muR_lcl, muF_lcl, mu_table)

    if (use_sep_orders) then
      ! if we kept each order separate, then add up all the fixed order terms one by one
      if (order_setup.ge.1) res =       F_LO  (x, Q, muR_lcl, muF_lcl)
      if (order_setup.ge.2) res = res + F_NLO (x, Q, muR_lcl, muF_lcl)
      if (order_setup.ge.3) res = res + F_NNLO(x, Q, muR_lcl, muF_lcl)
      if (order_setup.ge.4) res = res + F_N3LO(x, Q, muR_lcl, muF_lcl)
    else
      ! if we haven't kept each order separate, then everything is in sf_tables(1)
      call EvalPdfTable_xQ(sf_tables(1), x, mu_table, res)
    endif
    
  end function StrFct

  !---------------------------------------------------------------------
  !> @brief calculate the structure function at x, Q, muR, muF summed over all orders
  !!
  !! Calculate the structure function at x, Q, muR, muF summed over
  !! all orders. muR and muF are only needed if we are using the
  !! scale_choice_arbitrary, as otherwise they are already included in
  !! the sf_tables.
  !!
  !! @param[in]       x          x value
  !! @param[in]       Q          Q value
  !! @param[in,opt]   muR        renormalisation scale 
  !! @param[in,opt]   muF        factorisation scale
  !! @param[in]       iflav      parton-flavour
  !! @return          an array of FL, F2, F3 for the given flavour without couplings to the parton
  !!
  function StrFct_flav (x, Q, muR, muF, iflav) result(res)
    real(dp), intent(in) :: x, Q
    real(dp), intent(in), optional :: muR, muF
    integer, intent(in) :: iflav
    real(dp) :: res(1:3)
    real(dp) :: muR_lcl, muF_lcl, mu_table

    if(.not.inc_flavour_decomposition) call wae_error('StrFct_flav', &
               'You did not initialise the Structure Functions with flavour decomposition. Exiting.')

    call GetStrFctScales(Q, muR, muF, muR_lcl, muF_lcl, mu_table)

    if (use_sep_orders) then
      ! if we kept each order separate, then add up all the fixed order terms one by one
      if (order_setup.ge.1) res =       F_LO_flav  (x, Q, muR_lcl, muF_lcl, iflav)
      if (order_setup.ge.2) res = res + F_NLO_flav (x, Q, muR_lcl, muF_lcl, iflav)
      if (order_setup.ge.3) call wae_error('StrFct_flav: Flavour decomposed structure functions only implemneted up to NLO.')
    else
      ! if we haven't kept each order separate, then everything is in sf_tables(1:3)
      res(1) = EvalPdfTable_xQf(sf_tables_flav(1), x, mu_table, iflav)
      res(2) = EvalPdfTable_xQf(sf_tables_flav(2), x, mu_table, iflav)
      res(3) = EvalPdfTable_xQf(sf_tables_flav(3), x, mu_table, iflav)
    endif
    
  end function StrFct_Flav

  !> @brief calculate the leading order structure function at x, Q, muR, muF 
  !!
  !! Calculate the leading order structure function at x, Q, muR,
  !! muF. muR and muF are only needed if we are using the
  !! scale_choice_arbitrary, as otherwise they are already included in
  !! the sf_tables.
  !!
  !! @param[in]       x          x value
  !! @param[in]       Q          Q value
  !! @param[in]       muR        renormalisation scale 
  !! @param[in]       muF        factorisation scale
  !! @return          an array of all the leading order structure functions
  !!
  function F_LO (x, Q, muR, muF) result(res)
    real(dp), intent(in)  :: x, Q, muR, muF
    real(dp) :: res(-6:7)
    real(dp) :: muR_lcl, muF_lcl, mu_table

    call GetStrFctScales(Q, muR, muF, muR_lcl, muF_lcl, mu_table)

    if(.not.use_sep_orders) then 
      call wae_error('F_LO: you did not initialise the Structure Functions with separate orders. Exiting.')
    endif
    
    call EvalPdfTable_xQ(sf_tables(1), x, mu_table, res)
    
  end function F_LO

  !> @brief calculate the leading order structure function at x, Q, muR, muF 
  !!
  !! Calculate the leading order structure function at x, Q, muR,
  !! muF. muR and muF are only needed if we are using the
  !! scale_choice_arbitrary, as otherwise they are already included in
  !! the sf_tables.
  !!
  !! @param[in]       x          x value
  !! @param[in]       Q          Q value
  !! @param[in]       muR        renormalisation scale 
  !! @param[in]       muF        factorisation scale
  !! @param[in]       iflav      parton-flavour
  !! @return          an array of FL, F2, F3 for the given flavour without couplings to the parton
  !!
  function F_LO_flav (x, Q, muR, muF, iflav) result(res)
    real(dp), intent(in)  :: x, Q, muR, muF
    integer, intent(in) :: iflav
    real(dp) :: res(1:3)
    real(dp) :: muR_lcl, muF_lcl, mu_table

    call GetStrFctScales(Q, muR, muF, muR_lcl, muF_lcl, mu_table)

    if(.not.use_sep_orders) call wae_error('F_LO_flav: you did not   &
         &       initialise the Structure Functions with separate&
         & orders.                   Exiting.')
    
    if(.not.inc_flavour_decomposition) call wae_error('F_LO_flav',&
         & 'You          did not initialise the Structure Functions&
         & with flavour          decomposition. Exiting.')

    res(1) = EvalPdfTable_xQf(sf_tables_flav(1), x, mu_table, iflav)
    res(2) = EvalPdfTable_xQf(sf_tables_flav(2), x, mu_table, iflav)
    res(3) = EvalPdfTable_xQf(sf_tables_flav(3), x, mu_table, iflav)
    
  end function F_LO_FLAV

  !> @brief calculate the NLO structure function at x, Q, muR, muF 
  !!
  !! Calculate the pure NLO contribution to the structure function at x, Q, muR, muF. muR and
  !! muF are only needed if we are using the scale_choice_arbitrary,
  !! as otherwise they are already included in the sf_tables.
  !!
  !! The result includes a factor of (as/2pi)
  !!
  !! @param[in]       x          x value
  !! @param[in]       Q          Q value
  !! @param[in]       muR        renormalisation scale 
  !! @param[in]       muF        factorisation scale
  !! @return          an array of all the NLO structure functions
  !!
  function F_NLO (x, Q, muR, muF) result(res)
    real(dp), intent(in)  :: x, Q, muR, muF
    real(dp) :: res(-6:7), as2pi, LFQ2
    real(dp) :: C1f(-6:7), C0P0f(-6:7)
    real(dp) :: muR_lcl, muF_lcl, mu_table

    call GetStrFctScales(Q, muR, muF, muR_lcl, muF_lcl, mu_table)

    if(.not.use_sep_orders) call wae_error('F_NLO', &
               'You did not initialise the Structure Functions with separate orders. Exiting.')
    
    if (order_setup < 2) then
      res = zero
      return
    end if

    as2pi = alphasLocal(muR) / (twopi)
    
    ! C_NLO x f (x) in C1f(:) 
    call EvalPdfTable_xQ(sf_tables(2), x, mu_table, C1f)
    res = C1f
    
    ! if scale_choice = 0,1 then this term is already taken care of
    if (scale_choice_save.ge.scale_choice_arbitrary) then
       LFQ2 = two*log(muF/Q)
       ! C_LO x P_LO x f (x) in C0P0f(:)
       call EvalPdfTable_xQ(sf_tables(3), x, mu_table, C0P0f)
       res = res - C0P0f * LFQ2
    endif
    
    res = res * as2pi
    
  end function F_NLO

  !> @brief calculate the NLO structure function at x, Q, muR, muF 
  !!
  !! Calculate the pure NLO contribution to the structure function at x, Q, muR, muF. muR and
  !! muF are only needed if we are using the scale_choice_arbitrary,
  !! as otherwise they are already included in the sf_tables.
  !!
  !! The result includes a factor of (as/2pi)
  !!
  !! @param[in]       x          x value
  !! @param[in]       Q          Q value
  !! @param[in]       muR        renormalisation scale 
  !! @param[in]       muF        factorisation scale
  !! @param[in]       iflav      parton-flavour
  !! @return          an array of FL, F2, F3 for the given flavour without couplings to the parton
  !!
  function F_NLO_flav (x, Q, muR, muF, iflav) result(res)
    real(dp), intent(in)  :: x, Q, muR, muF
    integer, intent(in) :: iflav
    real(dp) :: res(1:3), as2pi, LFQ2
    real(dp) :: C1f(1:3), C0P0f(1:3)
    real(dp) :: muR_lcl, muF_lcl, mu_table

    call GetStrFctScales(Q, muR, muF, muR_lcl, muF_lcl, mu_table)

    if(.not.use_sep_orders) call wae_error('F_NLO_flav', 'You did not&
         & initialise the Structure Functions with separate orders.&
         & Exiting.')
    
    if(.not.inc_flavour_decomposition) call wae_error('F_NLO_flav',&
         & 'You did not initialise the Structure Functions with&
         & flavour decomposition. Exiting.')
    
    if (order_setup < 2) then
      res = zero
      return
    end if

    as2pi = alphasLocal(muR) / (twopi)
    
    ! C_NLO x f (x) in C1f(:)
    res(1) = EvalPdfTable_xQf(sf_tables_flav(4), x, mu_table, iflav)
    res(2) = EvalPdfTable_xQf(sf_tables_flav(5), x, mu_table, iflav)
    res(3) = EvalPdfTable_xQf(sf_tables_flav(6), x, mu_table, iflav)
    
    ! if scale_choice = 0,1 then this term is already taken care of
    if (scale_choice_save.ge.scale_choice_arbitrary) then
       LFQ2 = two*log(muF/Q)
       ! C_LO x P_LO x f (x) in C0P0f(:)
       C0P0f(1) = EvalPdfTable_xQf(sf_tables_flav(7), x, mu_table, iflav)
       C0P0f(2) = EvalPdfTable_xQf(sf_tables_flav(8), x, mu_table, iflav)
       C0P0f(3) = EvalPdfTable_xQf(sf_tables_flav(9), x, mu_table, iflav)
       res = res - C0P0f * LFQ2
    endif
    
    res = res * as2pi
    
  end function F_NLO_flav


  !> @brief calculate the NNLO structure function at x, Q, muR, muF 
  !!
  !! Calculate the pure NNLO contribution to the structure function at x, Q, muR, muF. muR and
  !! muF are only needed if we are using the scale_choice_arbitrary,
  !! as otherwise they are already included in the sf_tables.
  !!
  !! The result includes a factor of (as/2pi)**2
  !!
  !! @param[in]       x          x value
  !! @param[in]       Q          Q value
  !! @param[in]       muR        renormalisation scale 
  !! @param[in]       muF        factorisation scale
  !! @return          an array of all the NNLO structure functions
  !!
  function F_NNLO (x, Q, muR, muF) result(res)
    real(dp), intent(in)  :: x, Q, muR, muF
    real(dp) :: res(-6:7), as2pi, LRQ2, LFQ2
    real(dp) :: C1f(-6:7), C0P0f(-6:7), C2f(-6:7), C0P0sqf(-6:7)
    real(dp) :: C0P1f(-6:7), C1P0f(-6:7)
    real(dp) :: muR_lcl, muF_lcl, mu_table

    call GetStrFctScales(Q, muR, muF, muR_lcl, muF_lcl, mu_table)

    if(.not.use_sep_orders) call wae_error('F_NNLO',&
            'You did not initialise the Structure Functions with separate orders. Exiting.')
        
    if (order_setup < 3) then
      res = zero
      return
    end if

    as2pi = alphasLocal(muR) / (twopi)
    
    ! C_NNLO x f (x) in C2f(:,3) 
    call EvalPdfTable_xQ(sf_tables(4), x, mu_table, C2f)
    res = C2f

    ! if scale_choice = 0,1 then these terms are already taken care of
    if (scale_choice_save.ge.scale_choice_arbitrary) then
       LRQ2 = two*log(muR/Q)
       LFQ2 = two*log(muF/Q)
       ! C_NLO x f (x) in C1f
       call EvalPdfTable_xQ(sf_tables(2), x, mu_table, C1f)
       ! C_LO x P_LO x f (x) in C0P0f
       call EvalPdfTable_xQ(sf_tables(3), x, mu_table, C0P0f)
       ! C_LO x P_LO^2 x f (x) in C0P0sqf
       call EvalPdfTable_xQ(sf_tables(5), x, mu_table, C0P0sqf)
       ! C_LO x P_NLO x f (x) in C0P1f
       call EvalPdfTable_xQ(sf_tables(6), x, mu_table, C0P1f)
       ! C_NLO x P_LO x f (x) in C1P1f
       call EvalPdfTable_xQ(sf_tables(7), x, mu_table, C1P0f)
       ! add up all the different pieces
       res = res - C1P0f * LFQ2 + C0P0sqf * half * LFQ2**2 &
            & - twopi * beta0 * C0P0f * (LRQ2*LFQ2 - half*LFQ2**2) &
            & - C0P1f * LFQ2 + twopi * beta0 * C1f * LRQ2
    endif
    
    res = res * (as2pi)**2
    
  end function F_NNLO

  
  !> @brief calculate the pure N3LO contribution to the structure function at x, Q, muR, muF 
  !!
  !! Calculate the pure N3LO contribution to the structure function at x, Q, muR, muF. 
  !! muR and muF are only needed if we are using the scale_choice_arbitrary,
  !! as otherwise they are already included in the sf_tables.
  !!
  !! The result includes a factor of (as/2pi)**3
  !!
  !! @param[in]       x          x value
  !! @param[in]       Q          Q value
  !! @param[in]       muR        renormalisation scale 
  !! @param[in]       muF        factorisation scale
  !! @return          an array of all the N3LO structure functions
  !!
  function F_N3LO (x, Q, muR, muF) result(res)
    real(dp), intent(in)  :: x, Q, muR, muF
    real(dp) :: res(-6:7), as2pi, LRQ2, LFQ2
    real(dp) :: C1f(-6:7), C0P0f(-6:7), C3f(-6:7), C0P0sqf(-6:7), C2f(-6:7)
    real(dp) :: C0P1f(-6:7), C1P0f(-6:7), C0P0cbf(-6:7), C0P01f(-6:7), C0P10f(-6:7)
    real(dp) :: C1P0sqf(-6:7), C1P1f(-6:7), C2P0f(-6:7), C0P2f(-6:7)
    real(dp) :: muR_lcl, muF_lcl, mu_table

    call GetStrFctScales(Q, muR, muF, muR_lcl, muF_lcl, mu_table)
    
    if(.not.use_sep_orders) call wae_error('F_N3LO',&
          'You did not initialise the Structure Functions with separate orders. Exiting.')
    
    if (order_setup < 4) then
      res = zero
      return
    end if

    as2pi = alphasLocal(muR) / (twopi)

    ! C_N3LO x f (x) in C2f(:,8) 
    call EvalPdfTable_xQ(sf_tables(8), x, mu_table, C3f)
    res = C3f

    ! if scale_choice = 0,1 then these terms are already taken care of
    if (scale_choice_save.ge.scale_choice_arbitrary) then
       LRQ2 = two*log(muR/Q)
       LFQ2 = two*log(muF/Q)
       ! C_NLO x f (x) in C1f
       call EvalPdfTable_xQ(sf_tables(2), x, mu_table, C1f)
       ! C_LO x P_LO x f (x) in C0P0f
       call EvalPdfTable_xQ(sf_tables(3), x, mu_table, C0P0f)
       ! C_NNLO x f (x) in C2f(:,3) 
       call EvalPdfTable_xQ(sf_tables(4), x, mu_table, C2f)
       ! C_LO x P_LO^2 x f (x) in C0P0sqf
       call EvalPdfTable_xQ(sf_tables(5), x, mu_table, C0P0sqf)
       ! C_LO x P_NLO x f (x) in C0P1f
       call EvalPdfTable_xQ(sf_tables(6), x, mu_table, C0P1f)
       ! C_NLO x P_LO x f (x) in C1P1f
       call EvalPdfTable_xQ(sf_tables(7), x, mu_table, C1P0f)
       
       ! C_LO x P_LO^3 x f (x) in C0P0cbf
       call EvalPdfTable_xQ(sf_tables(9), x, mu_table, C0P0cbf)
       ! C_LO x P_LO x P_NLO x f (x) in C0P01f
       call EvalPdfTable_xQ(sf_tables(10), x, mu_table, C0P01f)
       ! C_LO x P_LO x P_NLO x f (x) in C0P10f
       call EvalPdfTable_xQ(sf_tables(11), x, mu_table, C0P10f)
       ! C_NLO x P_LO^2 x f (x) in C1P0sqf
       call EvalPdfTable_xQ(sf_tables(12), x, mu_table, C1P0sqf)
       ! C_NLO x P_NLO x f (x) in C1P1f
       call EvalPdfTable_xQ(sf_tables(13), x, mu_table, C1P1f)
       ! C_NNLO x P_LO x f (x) in C2P0f
       call EvalPdfTable_xQ(sf_tables(14), x, mu_table, C2P0f)
       ! C_LO x P_NNLO x f (x) in C0P2f
       call EvalPdfTable_xQ(sf_tables(15), x, mu_table, C0P2f)
    
       ! add up all the different pieces
       ! The commented lines are copy/pasted from mathematica
       ! CpN3LO fmuF + b1 CpNLO fmuF LRQ + 2 b0 CpNNLO fmuF LRQ 
       res = res + twopi**2 * beta1 * C1f * LRQ2 + two * twopi * beta0 * C2f * LRQ2 &
       ! + b0^2 CpNLO fmuF LRQ^2 - CpNNLO fmuF LFQ PLO 
           & + (twopi*beta0)**2 * C1f * LRQ2**2 - C2P0f * LFQ2 &
       ! + 1/2 b1 CpLO fmuF LFQ^2 PLO + 1/2 b0 CpNLO fmuF LFQ^2 PLO  
           & + half * twopi**2 * beta1 * C0P0f * LFQ2**2 + half * twopi * beta0 * C1P0f * LFQ2**2 &
       ! - 1/3 b0^2 CpLO fmuF LFQ^3 PLO - b1 CpLO fmuF LFQ LRQ PLO 
           & - (one/three)*(twopi*beta0)**2 * C0P0f * LFQ2**3 - twopi**2 * beta1 * C0P0f * LFQ2 * LRQ2 &
       ! - 2 b0 CpNLO fmuF LFQ LRQ PLO + b0^2 CpLO fmuF LFQ^2 LRQ PLO 
           & - two * twopi * beta0 * C1P0f * LFQ2 * LRQ2 + (twopi*beta0)**2 * C0P0f * LFQ2**2 * LRQ2 &
       ! - b0^2 CpLO fmuF LFQ LRQ^2 PLO + 1/2 CpNLO fmuF LFQ^2 PLO^2 
           & - (twopi*beta0)**2 * C0P0f * LFQ2 * LRQ2**2 + half * C1P0sqf * LFQ2**2 &
       ! - 1/2 b0 CpLO fmuF LFQ^3 PLO^2 + b0 CpLO fmuF LFQ^2 LRQ PLO^2  
           & - half * twopi*beta0 * C0P0sqf * LFQ2**3 + twopi*beta0 * C0P0sqf * LRQ2 * LFQ2**2 &
       ! - 1/6 CpLO fmuF LFQ^3 PLO^3 - CpNLO fmuF LFQ PNLO 
           & - (one/6.0_dp) * C0P0cbf * LFQ2**3 - C1P1f * LFQ2 &
       ! + b0 CpLO fmuF LFQ^2 PNLO - 2 b0 CpLO fmuF LFQ LRQ PNLO
           & + twopi*beta0 * C0P1f * LFQ2**2 - two*twopi*beta0 * C0P1f * LFQ2 * LRQ2 &
       ! + CpLO fmuF LFQ^2 PLO PNLO - CpLO fmuF LFQ PNNLO
           & + half*(C0P01f+C0P10f) * LFQ2**2 - C0P2f * LFQ2

    endif

    res = res * (as2pi)**3
    
  end function F_N3LO

  !----------------------------------------------------------------------
  ! set_scale_logs is only used for scale_choice = 0,1
  subroutine set_scale_logs(Q)
    real(dp), intent(in) :: Q

    log_muF2_over_Q2 = two * log(sf_muF(Q) / Q)
    log_muR2_over_Q2 = two * log(sf_muR(Q) / Q)
  end subroutine set_scale_logs
  
  !> @brief returns the renormalisation scale used in the structure function sf_tables at Q
  !!
  !! Returns the renormalisation scale used in the structure function
  !! sf_tables at Q. In the case of scale_choice_arbitrary this function
  !! returns Q, as that is the scale at which the structure functions
  !! have been set up.
  !!
  !! @param[in]       Q          Q value
  !! @return          the renormalisation scale used in the structure function sf_tables at Q
  !!
  real(dp) function sf_muR(Q)
    real(dp), intent(in) :: Q
    sf_muR = zero
    if (scale_choice_save.eq.scale_choice_fixed) then
       ! scale_choice = 0 : muF = xmuF * cst_mu
       sf_muR = xmuR * cst_mu
    elseif (scale_choice_save.eq.scale_choice_Q) then
       ! scale_choice = 1 : mu_R = xmuR * Q
       sf_muR = xmuR * Q
    elseif (scale_choice_save.eq.scale_choice_arbitrary) then
       ! scale_choice = 2 : arbitary, return Q
       sf_muR = Q
    else
       call wae_error('sf_muR(Q)', 'illegal value for scale_choice', intval = scale_choice_save)
    endif
  end function sf_muR

  !> @brief returns the factorisation scale used in the structure function sf_tables at Q
  !!
  !! Returns the factorisation scale used in the structure function
  !! sf_tables at Q. In the case of scale_choice_arbitrary this function
  !! returns Q, as that is the scale at which the structure functions
  !! have been set up.
  !!
  !! @param[in]       Q          Q value
  !! @return          the factorisation scale used in the structure function sf_tables at Q
  !!
  real(dp) function sf_muF(Q)
    real(dp), intent(in) :: Q
    sf_muF = zero
    if (scale_choice_save.eq.scale_choice_fixed) then
       ! scale_choice = 0 : muF = xmuF * cst_mu
       sf_muF = xmuF * cst_mu
    elseif (scale_choice_save.eq.scale_choice_Q) then
       ! scale_choice = 1 : muF = xmuF * Q
       sf_muF = xmuF * Q
    elseif (scale_choice_save.eq.scale_choice_arbitrary) then
       ! scale_choice = 2 : arbitary, return Q
       sf_muF = Q
    else
       call wae_error('sf_muF(Q)', 'illegal value for scale_choice', intval = scale_choice_save)
    endif
  end function sf_muF
  
  subroutine use_vfns (f, Q)
    implicit none
    real(dp), intent(in) :: Q
    real(dp), intent(inout) :: f(0:grid%ny,ncompmin:ncompmax)
    integer :: inf, current_nf, dummy!, nfhi

    if(ch%nflo.lt.3) call wae_error('use_vfns',&
      'Do you really want to run with fewer than 3 light flavours?? ch%nflo=', intval=ch%nflo)

    ! First set current nf equal to the smallest value it can take
    current_nf = ch%nflo
    if(Q.lt.masses(4)) then   
      current_nf = 3
    elseif(Q.lt.masses(5)) then 
      current_nf = 4
    elseif(Q.lt.masses(6)) then  
      current_nf = 5
    elseif(Q.ge.masses(6)) then  
      current_nf = 6
    endif      

    current_nf = min(current_nf,ch%nfhi) ! In case we run we force fewer than 6 flavours

    do inf = current_nf + 1, 6 
      f(:,-inf) = zero
      f(:, inf) = zero
    enddo
    
    nf_lcl = current_nf

    ! set nf in coeff fct to current number of flavours above threshold
    call SetNfCoefHolder(ch, current_nf)
    
  end subroutine use_vfns

  
  !----------------------------------------------------------------------
  ! Rescale the PDF by F2 NNLO / F2 N3LO
  subroutine rescale_pdf_n3lo (Qval, order)
    real(dp), intent(in) :: Qval
    integer, intent(in)  :: order
    real(dp) :: mF, mR, factor
    real(dp) :: str_fct(-6:7), f2nnlo, f2n3lo, y(0:grid%ny)
    integer :: iy, ii
    mF = sf_muF(Qval)
    mR = sf_muR(Qval)
    y = yValues(grid)
    do iy = 0, grid%ny
       str_fct(:) = F_LO(y(iy), Qval, mR, mF) + F_NLO(y(iy), Qval, mR, mF) + F_NNLO(y(iy), Qval, mR, mF)
       f2nnlo = str_fct(iF2Z)
       str_fct(:) = str_fct(:) + F_N3LO(y(iy), Qval, mR, mF)
       f2n3lo = str_fct(iF2Z)
       factor = 1.0_dp
       if (f2n3lo.gt.0.0_dp) factor = f2nnlo/f2n3lo
       do ii = ncompmin, ncompmax
          tables(0)%tab(iy,ii,:) = tables(0)%tab(iy,ii,:) * factor
       enddo
       
    enddo

    ! Re-set the structure functions using updated PDF
    if (scale_choice_save.eq.scale_choice_Q.or.scale_choice_save.eq.scale_choice_fixed) then
       if (order.ge.1) call set_LO_structure_functions()
       if (order.ge.2) call set_NLO_structure_functions()
       if (order.ge.3) call set_NNLO_structure_functions()
       if (order.ge.4) call set_N3LO_structure_functions()
    else if(scale_choice_save.eq.scale_choice_arbitrary) then
       if (order.ge.1) call set_LO_structure_functions_anyscale()
       if (order.ge.2) call set_NLO_structure_functions_anyscale()
       if (order.ge.3) call set_NNLO_structure_functions_anyscale()
       if (order.ge.4) call set_N3LO_structure_functions_anyscale()
    else
       call wae_error('rescale_pdf_n3lo', 'illegal value for scale_choice', intval = scale_choice_save)
    endif

  end subroutine rescale_pdf_n3lo
  
  !---------------------------------------------------------------------- 
  ! Rescale the PDF by F2 NLO / F2 NNLO
  subroutine rescale_pdf_nnlo (Qval, order)
    real(dp), intent(in) :: Qval
    integer, intent(in)  :: order
    real(dp) :: mF, mR, factor
    real(dp) :: str_fct(-6:7), f2nlo, f2nnlo, y(0:grid%ny) 
    integer :: iy, ii
    mF = sf_muF(Qval) 
    mR = sf_muR(Qval)
    y = yValues(grid)
    do iy = 0, grid%ny              
       str_fct(:) = F_LO(y(iy), Qval, mR, mF) + F_NLO(y(iy), Qval, mR, mF)
       f2nlo = str_fct(iF2Z) 
       str_fct(:) = str_fct(:) + F_NNLO(y(iy), Qval, mR, mF)
       f2nnlo = str_fct(iF2Z)
       factor = 1.0_dp
       if (f2nnlo.gt.0.0_dp) factor = f2nlo/f2nnlo
       do ii = ncompmin, ncompmax
          tables(0)%tab(iy,ii,:) = tables(0)%tab(iy,ii,:) * factor
       enddo
    enddo
    
    ! Re-set the structure functions using updated PDF
    if (scale_choice_save.eq.scale_choice_Q.or.scale_choice_save.eq.scale_choice_fixed) then
       if (order.ge.1) call set_LO_structure_functions()
       if (order.ge.2) call set_NLO_structure_functions()
       if (order.ge.3) call set_NNLO_structure_functions()
       if (order.ge.4) call set_N3LO_structure_functions()
    else if(scale_choice_save.eq.scale_choice_arbitrary) then
       if (order.ge.1) call set_LO_structure_functions_anyscale()
       if (order.ge.2) call set_NLO_structure_functions_anyscale()
       if (order.ge.3) call set_NNLO_structure_functions_anyscale()
       if (order.ge.4) call set_N3LO_structure_functions_anyscale()
    else
       call wae_error('rescale_pdf_n3lo', 'illegal value for scale_choice', intval = scale_choice_save)
    endif
  end subroutine rescale_pdf_nnlo


end module structure_functions


!> @brief  Minimal setup of structure functions
!!
!! @param[in]      order_max      highest order in QCD to compute (1: LO, 2: NLO, etc)
!!
subroutine hoppetStartStrFct(order_max)
  use streamlined_interface; use structure_functions
  implicit none
  integer, intent(in)  :: order_max
  !----------------------------------------------------------------------
  
  call StartStrFct(order_max)
  
end subroutine hoppetStartStrFct

!> @brief  Setup of constants and parameters needed for structure functions
!!
!! @param[in]      order_max      highest order in QCD to compute (1: LO, 2: NLO, etc)
!! @param[opt]     nflav          integer number of flavours (if not present use variable flavour)
!! @param[opt]     scale_choice   (0: fixed scale, 1: use Q, 2: use arbitrary scale)
!! @param[opt]     constant_mu    if scale_choice = scale_choice_fixed (= 0) then this is the fixed scale
!! @param[opt]     param_coefs    if .true. use parametrised coefficients functions
!! @param[opt]     wmass          Mass of the W boson
!! @param[opt]     zmass          Mass of the z boson
!!
subroutine hoppetStartStrFctExtended(order_max, nflav, scale_choice,&
     & constant_mu, param_coefs, wmass, zmass)
  use streamlined_interface; use structure_functions
  implicit none
  real(dp), intent(in) :: constant_mu, wmass, zmass
  integer, intent(in)  :: order_max, nflav, scale_choice
  logical, intent(in) :: param_coefs
  !----------------------------------------------------------------------

  call StartStrFct(order_max, nflav, scale_choice, constant_mu, &
     & param_coefs, wmass, zmass)

  
end subroutine hoppetStartStrFctExtended

subroutine hoppetStartStrFctExtended_c(order_max, nflav, scale_choice,&
     & constant_mu, param_coefs, wmass, zmass) bind(C, name="hoppetStartStrFctExtended_c")
  use streamlined_interface; use structure_functions
  use iso_c_binding
  implicit none
  real(c_double), intent(in) :: constant_mu, wmass, zmass
  integer(c_int), intent(in)  :: order_max, nflav, scale_choice
  logical(c_bool) , intent(in) :: param_coefs
  real(dp) :: constant_mu_f, wmass_f, zmass_f
  integer :: order_max_f, nflav_f, scale_choice_f
  logical :: param_coefs_f
  !----------------------------------------------------------------------

  ! Need to convert the c_bool to a fortran bool before passing it
  constant_mu_f = constant_mu
  wmass_f = wmass
  zmass_f = zmass
  order_max_f = order_max
  nflav_f = nflav
  scale_choice_f = scale_choice
  param_coefs_f = merge(.true._1, .false._1, param_coefs)
  call StartStrFct(order_max_f, nflav_f, scale_choice_f, constant_mu_f, &
     & param_coefs_f, wmass_f, zmass_f)

end subroutine hoppetStartStrFctExtended_c

!> @brief Initialize the structure functions up to specified order
!!
!! Initialize the structure functions up to specified order
!! this requires the tabulated PDF to have been set up beforehand in the
!! the streamlined interface. 
!!
!! By default, separate_orders = .false., which means that one
!! can only access the sum over all orders. If separate_orders = .true.
!! then one can access each order separately, but this is slower.
!!
!! @param[in]      order              order at which we initialise the structure functions
!! @param[opt]     separate_orders    if .true. separate into individual orders rather than summing
!! @param[opt]     xR             factor to multiply renormalisation scale
!! @param[opt]     xF             factor to multiply factorisation scale
!!
subroutine hoppetInitStrFct(order, separate_orders, xR, xF)
  use streamlined_interface; use structure_functions
  implicit none
  integer, intent(in) :: order
  logical, intent(in) :: separate_orders
  real(dp), intent(in) :: xR, xF

  call InitStrFct(order, separate_orders, xR, xF, .false.)

end subroutine hoppetInitStrFct

subroutine hoppetInitStrFct_c(order, separate_orders, xR, xF) bind(C, name="hoppetInitStrFct_c")
  use streamlined_interface; use structure_functions
  use iso_c_binding
  implicit none
  integer(c_int), intent(in) :: order
  logical(c_bool), intent(in) :: separate_orders
  logical :: separate_orders_f
  real(c_double), intent(in) :: xR, xF
  real(dp) :: xR_f, xF_f
  integer :: order_f
  !----------------------------------------------------------------------

  ! Need to convert the c_bool to a fortran bool before passing it
  xR_f = xR
  xF_f = xF
  order_f = order
  separate_orders_f = merge(.true._1, .false._1, separate_orders)
  call InitStrFct(order_f, separate_orders_f, xR_f, xF_f, .false.)

end subroutine hoppetInitStrFct_c

!> @brief Initialize the structure functions up to specified order
!!
!! Initialize the structure functions up to specified order
!! this requires the tabulated PDF to have been set up beforehand in the
!! the streamlined interface. 
!!
!! By default, separate_orders = .false., which means that one
!! can only access the sum over all orders. If separate_orders = .true.
!! then one can access each order separately, but this is slower.
!!
!! @param[in]      order              order at which we initialise the structure functions
!! @param[opt]     separate_orders    if .true. separate into individual orders rather than summing
!! @param[opt]     xR             factor to multiply renormalisation scale
!! @param[opt]     xF             factor to multiply factorisation scale
!!
subroutine hoppetInitStrFctFlav(order, separate_orders, xR, xF)
  use streamlined_interface; use structure_functions
  implicit none
  integer, intent(in) :: order
  logical, intent(in) :: separate_orders
  real(dp), intent(in) :: xR, xF

  call InitStrFct(order, separate_orders, xR, xF, .true.)

end subroutine hoppetInitStrFctFlav

subroutine hoppetInitStrFctFlav_c(order, separate_orders, xR, xF) bind(C, name="hoppetInitStrFctFlav_c")
  use streamlined_interface; use structure_functions
  use iso_c_binding
  implicit none
  integer(c_int), intent(in) :: order
  logical(c_bool), intent(in) :: separate_orders
  logical :: separate_orders_f
  real(c_double), intent(in) :: xR, xF
  real(dp) :: xR_f, xF_f
  integer :: order_f

  ! Need to convert the c_bool to a fortran bool before passing it
  xR_f = xR
  xF_f = xF
  order_f = order
  separate_orders_f = merge(.true._1, .false._1, separate_orders)
  call InitStrFct(order_f, separate_orders_f, xR_f, xF_f, .true.)

end subroutine hoppetInitStrFctFlav_c

!> @brief calculate the structure function at x, Q, muR, muF summed over all orders
!!
!! Calculate the structure function at x, Q, muR, muF summed over
!! all orders. If using a scale choice other than scale_choice_arbitrary,
!! muR and muF must be consistent with the scale choice made in the 
!! hoppetStartStrFct call. See also hoppetStrFctNoMu for a variant
!! that does not take muR and muF arguments.
!!
!! @param[in]       x          x value
!! @param[in]       Q          Q value
!! @param[in]       muR        renormalisation scale 
!! @param[in]       muF        factorisation scale
!! @return          an array of all structure functions summed over orders
!!
subroutine hoppetStrFct(x, Q, muR_in, muF_in, res) 
  use streamlined_interface; use structure_functions
  real(dp) :: x, Q
  real(dp) :: muR_in, muF_in
  real(dp) :: res(-6:7)

  res = StrFct(x, Q, muR_in, muF_in)
end subroutine hoppetStrFct

!> @brief calculate the structure function at x, Q, muR, muF summed over all orders
!!
!! Calculate the structure function at x, Q, muR, muF summed over
!! all orders. If using a scale choice other than scale_choice_arbitrary,
!! muR and muF must be consistent with the scale choice made in the 
!! hoppetStartStrFct call. See also hoppetStrFctNoMu for a variant
!! that does not take muR and muF arguments.
!!
!! @param[in]       x          x value
!! @param[in]       Q          Q value
!! @param[in]       muR        renormalisation scale 
!! @param[in]       muF        factorisation scale
!! @param[in]       iflav      parton flavour
!! @return          an array of all structure functions summed over orders decomposed in flavour
!!
subroutine hoppetStrFctFlav(x, Q, muR_in, muF_in, iflav, res) 
  use streamlined_interface; use structure_functions
  real(dp) :: x, Q
  real(dp) :: muR_in, muF_in
  integer  :: iflav
  real(dp) :: res(1:3)

  res = StrFct_flav(x, Q, muR_in, muF_in, iflav)
end subroutine hoppetStrFctFlav

!> @brief calculate the structure function at x, Q, summed over all orders
!!
!! Calculate the structure function at x, Q, for the scale choice as indicated
!! in hoppetStartStrFct. This can only be used with scale_choice_Q and scale_choice_fixed. 
!! See also hoppetStrFct for a variant with muR and muF choice. 
!!
!! @param[in]       x          x value
!! @param[in]       Q          Q value
!! @return          an array of all structure functions summed over orders
!!
subroutine hoppetStrFctNoMu(x, Q, res) 
  use streamlined_interface; use structure_functions
  real(dp) :: x, Q
  real(dp) :: res(-6:7)
  
  res = StrFct(x, Q)
end subroutine hoppetStrFctNoMu

!> @brief calculate the structure function at x, Q, summed over all orders
!!
!! Calculate the structure function at x, Q, for the scale choice as indicated
!! in hoppetStartStrFct. This can only be used with scale_choice_Q and scale_choice_fixed. 
!! See also hoppetStrFct for a variant with muR and muF choice. 
!!
!! @param[in]       x          x value
!! @param[in]       Q          Q value
!! @param[in]       iflav      parton flavour
!! @return          an array of all structure functions summed over orders decomposed in flavour
!!
subroutine hoppetStrFctNoMuFlav(x, Q, iflav, res)
  use streamlined_interface; use structure_functions
  real(dp) :: x, Q
  integer :: iflav
  real(dp) :: res(1:3)
  
  res = StrFct_flav(x, Q, iflav = iflav)
end subroutine hoppetStrFctNoMuFlav


!> @brief calculate the leading order structure function at x, Q, muR, muF 
!!
!! Calculate the leading order structure function at x, Q, muR,
!! muF. muR and muF are only needed if we are using the
!! scale_choice_arbitrary, as otherwise they are already included in
!! the sf_tables.
!!
!! @param[in]       x          x value
!! @param[in]       Q          Q value
!! @param[in]       muR        renormalisation scale 
!! @param[in]       muF        factorisation scale
!! @return          an array of all the leading order structure functions
!!
subroutine hoppetStrFctLO(x, Q, muR_in, muF_in, res) 
  use streamlined_interface; use structure_functions
  real(dp) :: x, Q
  real(dp) :: muR_in, muF_in
  real(dp) :: res(-6:7)

  res = F_LO(x, Q, muR_in, muF_in)
end subroutine hoppetStrFctLO

!> @brief calculate the leading order structure function at x, Q, muR, muF 
!!
!! Calculate the leading order structure function at x, Q, muR,
!! muF. muR and muF are only needed if we are using the
!! scale_choice_arbitrary, as otherwise they are already included in
!! the sf_tables.
!!
!! @param[in]       x          x value
!! @param[in]       Q          Q value
!! @param[in]       muR        renormalisation scale 
!! @param[in]       muF        factorisation scale
!! @param[in]       iflav      partonflavour
!! @return          an array of all the leading order structure functions summed over orders
!!
subroutine hoppetStrFctLOFlav(x, Q, muR_in, muF_in, iflav, res) 
  use streamlined_interface; use structure_functions
  real(dp) :: x, Q
  real(dp) :: muR_in, muF_in
  integer  :: iflav
  real(dp) :: res(1:3)

  res = F_LO_flav(x, Q, muR_in, muF_in, iflav)
end subroutine hoppetStrFctLOFlav

!> @brief calculate the NLO structure function at x, Q, muR, muF 
!!
!! Calculate the NLO structure function at x, Q, muR, muF. muR and
!! muF are only needed if we are using the scale_choice_arbitrary,
!! as otherwise they are already included in the sf_tables.
!!
!! @param[in]       x          x value
!! @param[in]       Q          Q value
!! @param[in]       muR        renormalisation scale 
!! @param[in]       muF        factorisation scale
!! @return          an array of all the NLO structure functions
!!
subroutine hoppetStrFctNLO(x, Q, muR_in, muF_in, res) 
  use streamlined_interface; use structure_functions
  real(dp) :: x, Q
  real(dp) :: muR_in, muF_in
  real(dp) :: res(-6:7)

  res = F_NLO(x, Q, muR_in, muF_in)
end subroutine hoppetStrFctNLO

!> @brief calculate the NLO structure function at x, Q, muR, muF 
!!
!! Calculate the NLO structure function at x, Q, muR, muF. muR and
!! muF are only needed if we are using the scale_choice_arbitrary,
!! as otherwise they are already included in the sf_tables.
!!
!! @param[in]       x          x value
!! @param[in]       Q          Q value
!! @param[in]       muR        renormalisation scale 
!! @param[in]       muF        factorisation scale
!! @return          an array of all the NLO structure functions
!!
subroutine hoppetStrFctNLOFlav(x, Q, muR_in, muF_in, iflav, res) 
  use streamlined_interface; use structure_functions
  real(dp) :: x, Q
  real(dp) :: muR_in, muF_in
  integer  :: iflav
  real(dp) :: res(1:3)

  res = F_NLO_flav(x, Q, muR_in, muF_in, iflav)
end subroutine hoppetStrFctNLOFlav

!> @brief calculate the NNLO structure function at x, Q, muR, muF 
!!
!! Calculate the NNLO structure function at x, Q, muR, muF. muR and
!! muF are only needed if we are using the scale_choice_arbitrary,
!! as otherwise they are already included in the sf_tables.
!!
!! @param[in]       x          x value
!! @param[in]       Q          Q value
!! @param[in]       muR        renormalisation scale 
!! @param[in]       muF        factorisation scale
!! @return          an array of all the NNLO structure functions
!!
subroutine hoppetStrFctNNLO(x, Q, muR_in, muF_in, res) 
  use streamlined_interface; use structure_functions
  real(dp) :: x, Q
  real(dp) :: muR_in, muF_in
  real(dp) :: res(-6:7)

  res = F_NNLO(x, Q, muR_in, muF_in)
end subroutine hoppetStrFctNNLO

!> @brief calculate the N3LO structure function at x, Q, muR, muF 
!!
!! Calculate the N3LO structure function at x, Q, muR, muF. muR and
!! muF are only needed if we are using the scale_choice_arbitrary,
!! as otherwise they are already included in the sf_tables.
!!
!! @param[in]       x          x value
!! @param[in]       Q          Q value
!! @param[in]       muR        renormalisation scale 
!! @param[in]       muF        factorisation scale
!! @return          an array of all the N3LO structure functions
!!
subroutine hoppetStrFctN3LO(x, Q, muR_in, muF_in, res) 
  use streamlined_interface; use structure_functions
  real(dp) :: x, Q
  real(dp) :: muR_in, muF_in
  real(dp) :: res(-6:7)

  res = F_N3LO(x, Q, muR_in, muF_in)
end subroutine hoppetStrFctN3LO

C----------------------------------------------------------------------
C
C  An f77 example program using a tabulation. It outputs a subset of
C  table 15 of hep-ph/0511119 and this output should be identical
C  to the contents of the file tabulation_example.default_output
C 
C  NB: for the full functionality used in generating the HeraLHC and
C      Les Houches comparison tables, see ../benchmarks/benchmarks.f90
C      and carefully read the comments at the beginning. Subtleties
C      exist in particular wrt the treatment of scales muF/=muR.
C
C  This program can be compiled with a plain f77 compiler (e.g. g77),
C  but then the appropriate f95 libraries must be included at
C  link-time. The Makefile contains illustrations of which libraries are
C  needed, for a range of compilers
C
C----------------------------------------------------------------------
      program tabulation_example
      implicit none
      !--- variables defining the grid and evolution parameters
      double precision dy, ymax, Qmin, Qmax, dlnlnQ
      integer          nloop, order
      !---------------
      external         heralhc_init
      double precision Q, ourpdf(-6:6)
      double precision asQ0, Q0, xmu
      integer          ix, scheme
      double precision heralhc_xvals(9)
      data heralhc_xvals/1d-5,1d-4,1d-3,1d-2,0.1d0,
     $                   0.3d0,0.5d0,0.7d0,0.9d0/

      ! start the dglap evolution/convolution package 
      ymax  = 12d0      ! max value of ln 1/x
      dy    = 0.1d0     ! the internal grid spacing (smaller->higher accuarcy)
                        ! 0.1 should provide at least 10^{-3} accuracy 
      Qmin  = 1.0d0     ! smallest Q value in tabulation
      Qmax  = 1d4       ! largest Q value in tabulation
      dlnlnQ = dy/4     ! tabulation spacing in dlnlnQ (dy/4 recommended)
      nloop  = 3        ! the number of loops to initialise (max=3!)
      order  = -6       ! numerical interpolation order (-6 is a good choice)
      scheme = 1        ! 1=unpol-MSbar, 2=unpol-DIS, 3=Pol-MSbar

      ! call this once at the beginning of your program
      call hoppetStartExtended(ymax,dy,Qmin,Qmax,dlnlnQ,nloop,order,
     $                         scheme)
      write(6,'(a)') "Splitting functions initialised!"

      ! tell hoppet to use a variable flavour number scheme with
      ! the following c,b,t quark masses
      call hoppetSetVFN(1.414213563d0,4.5d0,175d0)

      ! set the initial scale and the coupling there (in general the PDF
      ! and coupling may be specified at different scales -- this is not
      ! done here) and 
      Q0   = sqrt(2d0)
      asQ0 = 0.35d0
      ! the ratio xmu = mu_F/mu_R to be used in the evolution.
      xmu  = 1.0d0
      
      ! carry out the evolution to create a tabulation, corresponding
      ! to the initial condition heralhc_init(...) given below
      call hoppetEvolve(asQ0,Q0,nloop,xmu,heralhc_init,Q0)
      ! alternatively if you need to repeat the same evolution on very
      ! many pdf sets, used a cached evolution (set up once, use many times
      ! and gain a factor 3-4 in speed.
      !call hoppetPreEvolve(asQ0,Q0,nloop,xmu,Q0)
      !call hoppetCachedEvolve(heralhc_init) 
      write(6,'(a)') "Evolution done!"

      ! print out some results
      Q = 100.0d0
      write(6,'(a)')
      write(6,'(a,f8.3,a)')"           Evaluating PDFs at Q = ",Q," GeV"
      write(6,'(a5,2a12,a14,a10,a12)') "x",
     $     "u-ubar","d-dbar","2(ubr+dbr)","c+cbar","gluon"
      do ix = 1, 9
         call hoppetEval(heralhc_xvals(ix),Q,ourpdf)
         write(6,'(1p,e7.1,5e12.4)') heralhc_xvals(ix),
     $        ourpdf(2)-ourpdf(-2), 
     $        ourpdf(1)-ourpdf(-1), 
     $        2*(ourpdf(-1)+ourpdf(-2)),
     $        (ourpdf(-4)+ourpdf(4)),
     $        ourpdf(0)
      end do

      ! free all memory that was allocated by hoppet
      call hoppetDeleteAll()
      
      end


      !--------------------------------------------------------------
      ! The initial condition used in hep-ph/0511119.
      !
      ! The subroutine returns x*q(x) in the array pdf(-6:6), containing
      ! flavours (tbar,bbar,cbar,sbar,ubar,dbar,g,d,u,s,c,b,t)
      !
      ! The variable Q is set by the calling routine to be equal to the
      ! scale at which the PDF is being requested. Below it is unused
      ! because the initial condition is here provided only for scale
      ! Q0=sqrt(2)GeV.
      !
      subroutine heralhc_init(x,Q,pdf)
      double precision x,Q,pdf(-6:6)
      double precision uv, dv
      double precision ubar, dbar
      !---------------------
      double precision N_g, N_ls, N_uv, N_dv, N_db
      data N_g,N_ls,N_uv,N_dv/1.7d0, 0.387975d0, 5.107200d0,3.064320d0/

      N_db = 0.5d0 * N_ls
      uv = N_uv * x**0.8d0 * (1d0-x)**3
      dv = N_dv * x**0.8d0 * (1d0-x)**4
      dbar = N_db * x**(-0.1d0) * (1d0-x)**6
      ubar = dbar * (1d0-x)

      pdf(0) = N_g * x**(-0.1d0) * (1d0-x)**5
      pdf(-3) = 0.2d0*(dbar + ubar)
      pdf( 3) = pdf(-3)
      pdf( 2) = uv + ubar
      pdf(-2) = ubar
      pdf( 1) = dv + dbar
      pdf(-1) = dbar

      pdf( 4) = 0
      pdf( 5) = 0
      pdf( 6) = 0
      pdf(-4) = 0
      pdf(-5) = 0
      pdf(-6) = 0
      end 

module xpgq3a
  character(len=*), parameter :: name_xpgq3 = "xpgq3a"
contains
!
! ..File: xPgq3a.f   
!
! ..The 4-loop MSbar quark-to-gluon splitting function P_{gq}^(3) 
!    for the evolution of the flavour-singlet parton distributions.
!    The expansion parameter is alpha_s/(4 pi), the scale mu_r = mu_f.
!
! ..These are approximations for fixed nf = 3, 4 and 5 based on the 
!    first five even moments together with small-x/large-x constraints.
!    The two sets providing the error estimate are called via IMOD = 1 
!    and IMOD = 2.  Any other value of IMOD invokes their average.
!
!    Reference: Additional moments and x-space approximations
!                 of four-loop splitting functions in QCD
!               S. Moch, B. Ruijl, T. Ueda, J. Vermaseren and A. Vogt
!               DESY 23-150, Nikhef 2023-016, LTH 1354   
!
! =====================================================================
!
!
       FUNCTION P3GQA (Y, NF, IMOD)
!
       IMPLICIT REAL*8 (A-Z)
       INTEGER IMOD, nf,nf2,nf3
!
       YM  = 1.D0/Y
       Y1  = 1.D0-Y
       DL  = DLOG(Y)
       DL1 = DLOG(1.D0-Y)
!
       nf2 = nf*nf
       nf3 = nf*nf2
!
! Known large-x coefficients
       x1L5cff = 1.3443073D+1 - 5.4869684D-1*nf
       x1L4cff = 3.7539831D+2 - 3.4494742D+1*nf + 8.7791495D-1*nf2
!    
! Small-x  Casimir scaled from P_gg (approx. for bfkl1)
       bfkl0 =   - 8.3086173D+3 / 2.25
       bfkl1 = ( - 1.0691199D+5 - nf* 9.9638304D+2 ) / 2.25
!
! The resulting part of the function
!
       P3gq01 = &
            + bfkl0* DL**3*YM&
            + bfkl1* DL**2*YM&
            + x1L4cff* DL1**4&
            + x1L5cff* DL1**5
!
! The selected approximations for nf = 3, 4, 5
       IF ( NF .EQ. 3 ) THEN
         P3gqApp1 = P3GQ01        &
            + 3.4D0 *bfkl1* DL*YM &
            - 161562D0 * Y1*YM    &
            + 36469D0             &
            + 72317D0 * DL        &
            - 3977.3D0* DL1**2    &
            +  484.4D0 * DL1**3
         P3gqApp2  = P3GQ01       &
            + 5.4D0 *bfkl1* DL*YM &
            - 546482D0 * Y1*YM    &
            - 39464D0             &
            - 401000D0 * DL       &
            + 13270D0 * DL1**2    &
            + 3289D0 * DL1**3
       ELSE IF ( NF .EQ. 4 ) THEN
         P3gqApp1 = P3GQ01        &
            + 3.4D0 *bfkl1* DL*YM &
            - 158805D0 * Y1*YM    &
            + 35098D0             &
            + 87258D0 * DL        &
            - 4834.1D0 * DL1**2   &
            +  176.6D0 * DL1**3
         P3gqApp2  = P3GQ01       &
            + 5.4D0 *bfkl1* DL*YM &
            - 547215D0 * Y1*YM    &
            - 41523D0             &
            - 390350D0 * DL       &
            + 12571D0 * DL1**2    &
            + 3007D0 * DL1**3
       ELSE IF ( NF .EQ. 5 ) THEN
         P3gqApp1 = P3GQ01       &
            + 3.4D0 *bfkl1* DL*YM&
            - 154336D0 * Y1*YM   &
            + 33889D0            &
            + 103440D0 * DL      &
            - 5745.8D0  * DL1**2 &
            -  128.6D0 * DL1**3
         P3gqApp2  = P3GQ01      &
            + 5.4D0 *bfkl1* DL*YM&
            - 546236D0 * Y1*YM   &
            - 43421D0            &
            - 378460D0 * DL      &
            + 11816D0 * DL1**2   &
            + 2727.3D0 * DL1**3
       ELSE IF ( NF .EQ. 5 ) THEN
         P3gqApp1 = P3GQ01
         P3gqApp2 = P3GQ01
       ELSE
         WRITE(6,*) '  Error in function P3GQA: choice of nf   '
         CALL ABORT
       END IF
!
! We return (for now) one of the two error-band representatives
! or the present best estimate, their average
       IF ( IMOD .EQ. 1 ) THEN
         P3GQA = P3gqApp1
       ELSE IF ( IMOD .EQ. 2 ) THEN
         P3GQA = P3gqApp2
       ELSE
         P3GQA = 0.5D0 * ( P3gqApp1 + P3gqApp2 )
       END IF
!
       RETURN
     END FUNCTION P3GQA
!
! =================================================================av==
   end module xpgq3a

      MODULE XCLNS2P
      CONTAINS
*
* ..File: xclns2p.f    FL_NS
*
*
* ..Calculation of the 2-loop x-space MS(bar) coefficient functions 
*    for FL via compact parametrizations involving only logarithms.
*    Non-singlet, mu_r = mu_f = Q. Expansion parameter: alpha_s/(4 pi).
*
*  ..The distributions (in the mathematical sense) are given as in eq.
*    (B.26) of Floratos, Kounnas, Lacaze: Nucl. Phys. B192 (1981) 417.
*    The name-endings A, B, and C of the functions below correspond to 
*    the kernel superscripts [2], [3], and [1] in that equation.
*
*  ..The relative accuracy of the coefficient functions, as well as of 
*    the convolution results, amounts to a few thousandth.
*
*  ..Reference: W.L. van Neerven and A. Vogt, 
*               hep-ph/9907472 = Nucl. Phys. B568 (2000) 263
*  ..The user should also cite the original calculation,
*      J. Sanchez Guillen et al, Nucl. Phys. B353 (1991) 337.
*    
* 
* =====================================================================
*
*
* ..This is the regular non-singlet piece for the electromagnetic F2, 
*    corresponding to CLNSP+C2NSM in W. van Neerven's program. The 
*    8 numerical coefficients are fitted to his results, using x values 
*    between 10^-6 and 1-10^-6. 
*
       FUNCTION CLNN2A (Y, NF)
       IMPLICIT REAL*8 (A-Z)
       DOUBLE PRECISION D16O27
       PARAMETER (D16O27 = 16.0D0/27.0D0)
       INTEGER NF
*
       DL  = LOG (Y)
       OMY = 1.0D0 - Y
       DL1 = LOG (OMY)
*
       CLNN2A = - 40.41D0 + 97.48D0 * Y + (26.56D0 * Y - 0.031D0) * DL
     $      **2 - 14.85D0 * DL + 13.62D0 * DL1**2 - 55.79D0 * DL1 -
     $      150.5D0 * DL * DL1 + NF * D16O27 * ( 6.D0* Y*DL1 - 12.D0* Y
     $      *DL - 25.D0* Y + 6.D0)
*
       RETURN
       END FUNCTION
*
* ---------------------------------------------------------------------
*
*
* ..This is the regular non-singlet piece for the odd-moment (CC) FL, 
*    corresponding to CLNSP-CLNSN in WvN's program. The 8 numerical 
*    coefficients the NF^0 piece are fitted to his results. The NF part
*    is the same as in CLNN2A.
*
       FUNCTION CLNC2A (Y, NF)
       IMPLICIT REAL*8 (A-Z)
       DOUBLE PRECISION D16O27
       PARAMETER (D16O27 = 16.0D0/27.0D0)
       INTEGER NF
*
       DL  = LOG (Y)
       OMY = 1.0D0 - Y
       DL1 = LOG (OMY)
*
       CLNC2A = - 52.27D0 + 100.8D0 * Y + (23.29D0 * Y - 0.043D0) * DL
     $      **2 - 22.21D0 * DL + 13.30D0 * DL1**2 - 59.12D0 * DL1 -
     $      141.7D0 * DL * DL1 + NF * D16O27 * ( 6.D0* Y*DL1 -
     $      12.D0* Y*DL - 25.D0* Y + 6.D0)
*
       RETURN
       END FUNCTION
*
* ---------------------------------------------------------------------
*
*
* ..This is the 'local' NS piece for the e.m. FL, with no counterpart 
*    in WvN's program, as it does not exist in the exact expressions.
*    The value is fixed from the lowest integer moments.
*
       FUNCTION CLNN2C (Y)
       IMPLICIT REAL*8 (A-Z)
*
       CLNN2C = -0.164D0
*
       RETURN
       END FUNCTION
*
* ---------------------------------------------------------------------
*
*
* ..This is the 'local' NS piece for the CC FL, with no counterpart 
*    in WvN's program, as it does not exist in the exact expressions.  
*    The value is fixed from the lowest integer moments.
*
       FUNCTION CLNC2C (Y)
       IMPLICIT REAL*8 (A-Z)
*
       CLNC2C = -0.150D0
*
       RETURN
       END FUNCTION
*
* =================================================================av==

      END MODULE XCLNS2P

!! strings for setting colors and other terminal capabilities
module hoppet_term
  implicit none

  character(len=*), parameter :: red    = char(27)//"[31m"
  character(len=*), parameter :: green  = char(27)//"[32m"
  character(len=*), parameter :: blue   = char(27)//"[34m"
  character(len=*), parameter :: yellow = char(27)//"[33m"
  character(len=*), parameter :: magenta = char(27)//"[35m"
  character(len=*), parameter :: cyan   = char(27)//"[36m"
  character(len=*), parameter :: white  = char(27)//"[37m"
  character(len=*), parameter :: black  = char(27)//"[30m"
  
  character(len=*), parameter :: bg_red    = char(27)//"[41m"
  character(len=*), parameter :: bg_green  = char(27)//"[42m"
  character(len=*), parameter :: bg_yellow = char(27)//"[43m"
  character(len=*), parameter :: bg_blue   = char(27)//"[44m"
  character(len=*), parameter :: bg_magenta= char(27)//"[45m"
  character(len=*), parameter :: bg_cyan   = char(27)//"[46m"
  character(len=*), parameter :: bg_white  = char(27)//"[47m"
  character(len=*), parameter :: bg_black  = char(27)//"[40m"

  character(len=*), parameter :: bold   = char(27)//"[1m"
  character(len=*), parameter :: underline = char(27)//"[4m"
  
  character(len=*), parameter :: reset  = char(27)//"[0m"

end module hoppet_term

program compare2file
  use io_utils
  use types; use consts_dp
  implicit none
  character(len=300) :: line1, line2
  integer :: idev1, idev2, iostat
  
  real(dp) :: max07_guds, max07_gudsc, err_guds, err_gudsc
  real(dp) :: max09_guds, max09_gudsc
  real(dp) :: res1(0:4), res2(0:4), err(0:4)
  real(dp) :: y,Q

  idev1 = idev_open_arg(1,status='old')
  idev2 = idev_open_arg(2,status='old')

  do
     read(idev1,'(a)',iostat=iostat) line1
     if (iostat /= 0) exit
     read(idev2,'(a)',iostat=iostat) line2
     read(line1,*,iostat=iostat) y,Q,res1
     if (iostat /= 0) cycle
     read(line2,*) y,Q,res2

     err(0:4) = abs(res1/res2-one)
     err_gudsc = maxval(err, mask=(res2 /= zero))
     err_guds  = maxval(err(0:3), mask=(res2(0:3)/=0))
     if (exp(-y) <= 0.9_dp) then
        max09_guds  = max(max09_guds,  err_guds)
        max09_gudsc = max(max09_gudsc, err_gudsc)
        !write(0,*) y,Q, max09_gudsc
     end if
     if (exp(-y) <= 0.7_dp) then
        max07_guds  = max(max07_guds,  err_guds)
        max07_gudsc = max(max07_gudsc, err_gudsc)
     end if
  end do

  write(6,"(4es20.10)") max07_guds, max07_gudsc, max09_guds, max09_gudsc
end program compare2file

!! An example program using a tabulation. It should yield an output identical
!! to the content of the file tabulation_example_qed.default_output
!!
!!
program tabulation_example_qed
  use hoppet
  
  !! if using LHAPDF, rename the hoppet functions EvolvePDF and InitPDF, which
  !! would otherwise conflict with LHAPDF, by replacing the use
  !! statement above with:
  !use hoppet, EvolvePDF_hoppet => EvolvePDF, InitPDF_hoppet => InitPDF

  implicit none
  real(dp) :: dy, ymax
  ! the interpolation order (not the perturbative order!)
  integer  :: order
  ! the number of loops in QCD and QED
  integer  :: nloop_qcd, nqcdloop_qed
  ! whether to include the alpha^2 Plq term
  logical  :: with_Plq_nnloqed
  !! holds information about the grid in y=log(1/x)
  type(grid_def) :: grid
  !! holds the splitting functions
  type(dglap_holder) :: dh
  !! holds the PDF tabulation
  type(pdf_table)       :: table
  !! holds the coupling
  real(dp)               :: effective_light_quark_masses, quark_masses(4:6)
  type(running_coupling) :: coupling
  !! holds the initial pdf
  real(dp), pointer :: pdf0(:,:)
  real(dp) :: Q0
  !! holds results at some x, Q
  real(dp) :: Q, pdf_at_xQ(ncompmin:ncompmaxLeptons)
  real(dp), parameter :: heralhc_xvals(9) = &
       & (/1e-5_dp,1e-4_dp,1e-3_dp,1e-2_dp,0.1_dp,0.3_dp,0.5_dp,0.7_dp,0.9_dp/)
  integer  :: ix
  !! Additional things for QED
  type(qed_coupling)  :: coupling_qed
  type(qed_split_mat) :: qed_split


  !! define the interfaces for LHA pdf (by default not used)
  !! (NB: unfortunately this conflicts with an internal hoppet name,
  !! so make sure that you "redefine" the internal hoppet name, 
  !! as illustrated in the commented "use" line above:
  !! use hoppet, EvolvePDF_hoppet => EvolvePDF, ...)
  ! interface
  !    subroutine EvolvePDF(x,Q,res)
  !      use types; implicit none
  !      real(dp), intent(in)  :: x,Q
  !      real(dp), intent(out) :: res(*)
  !    end subroutine EvolvePDF
  ! end interface

  ! set up parameters for grid
  order = -6
  ymax  = 12.0_dp
  dy    = 0.1_dp

  ! set up the grid itself (this call sets up a nested grid composed of 4 subgrids)
  call InitGridDefDefault(grid, dy, ymax, order=order)

  ! set variables to specify the perturbative accuracy
  nloop_qcd = 3
  nqcdloop_qed = 1
  with_Plq_nnloqed = .false.
  
  ! initialise the splitting-function holder
  call InitDglapHolder(grid,dh,factscheme=factscheme_MSbar,&
       &                      nloop=nloop_qcd,nflo=3,nfhi=6)

  ! and the QED splitting matrices
  call InitQEDSplitMat(grid, qed_split)

  write(6,'(a)') "Splitting functions initialised!"

  ! allocate a pdf0 array including leptons
  call AllocPDFWithLeptons(grid, pdf0)

  ! initialise a PDF from the function below (must be contained,
  ! in a "used" module, or with an explicitly defined interface)
  ! pdf0(:,-6:6) are the standard pdf for quarks and gluons,
  ! pdf0(:,8) is the photon density,
  ! pdf0(:,9:11) are the sum of lepton-antilepton densities
  ! for the electron, the muon and the tau.
  pdf0(:,:) = unpolarized_dummy_pdf(xValues(grid))  

  Q0 = sqrt(2.0_dp)  ! the initial scale

  ! allocate and initialise the running coupling with a given
  ! set of quark masses (NB: charm mass just above Q0).
  quark_masses(4:6) = (/1.414213563_dp, 4.5_dp, 175.0_dp/)
  call InitRunningCoupling(coupling,alfas=0.35_dp,Q=Q0,nloop=nloop_qcd,&
       &                   quark_masses = quark_masses)

  ! Initialises coupling_qed object, including thresholds. All light
  ! quarks turn on simultaneously at some specified effective scale; the
  ! choice of m_light_quarks_default (defined in qed_coupling_module, to
  ! be 0.1055 GeV, as of 2025-10-10) results in values of 
  ! alpha(mZ) and alpha(m_tau) and that are within 1 sigma of the PDG
  ! MSbar value
  effective_light_quark_masses = m_light_quarks_default
  call InitQEDCoupling(coupling_qed, effective_light_quark_masses, quark_masses(4:6))

  ! create the table object that will contain the values of the parton
  ! densities in a grid of x and Q interpolation points.
  call AllocPdfTableWithLeptons(grid, table, Qmin=1.0_dp, Qmax=28000.0_dp, & 
       & dlnlnQ = dy/4.0_dp, freeze_at_Qmin=.true.)
  ! add information about the nf transitions to the table (improves
  ! interpolation quality)
  call AddNfInfoToPdfTable(table,coupling)

  ! create the tabulation based on the evolution of pdf0 from scale Q0
  ! up to qmax and down to qmin
  call EvolvePdfTableQED(table, Q0, pdf0, dh, qed_split, &
                         coupling, coupling_qed, nloop_qcd, nqcdloop_qed, with_Plq_nnloqed)

  write(6,'(a)') "Evolution done!"

  ! get the value of the tabulation at some point
  Q = 91.1880_dp;
  write(6,'(a)')
  write(6,'(a,f8.3,a)') " Using effective light_quark_masses = ", effective_light_quark_masses," GeV"
  write(6,'(a,f9.4,a,f8.5)') " At Q = ",Q," GeV, QCD coupling is alpha_s     = ", value(coupling, Q)
  write(6,'(a,f9.4,a,f8.3)') " At Q = ",Q," GeV, QED coupling is 1/alpha_qed = ", one/value(coupling_qed, Q)
  write(6,'(a,f6.4,a,f8.3)') " At mtau = ",m_tau," GeV, QED coupling is 1/alpha_qed = ", one/value(coupling_qed, m_tau/1.0000001_dp)
  write(6,'(a)')

  ! Get values at some points and print them 
  Q = 100.0_dp
  write(6,'(a,f9.4,a)') "           Evaluating PDFs at Q = ",Q," GeV"
  write(6,'(a5,2a12,a14,a10,a11,4a13)') "x",&
       & "u-ubar","d-dbar","2(ubr+dbr)","c+cbar","gluon",&
       & "photon","e+ + e-","mu+ + mu-","tau+ + tau-"
  do ix = 1, size(heralhc_xvals)
     call EvalPdfTable_xQ(table,heralhc_xvals(ix),Q,pdf_at_xQ)
     write(6,'(es7.1,9es12.4)') heralhc_xvals(ix), &
          &  pdf_at_xQ(2)-pdf_at_xQ(-2), &
          &  pdf_at_xQ(1)-pdf_at_xQ(-1), &
          &  2*(pdf_at_xQ(-1)+pdf_at_xQ(-2)), &
          &  (pdf_at_xQ(-4)+pdf_at_xQ(4)), &
          &  pdf_at_xQ(0), &
          &  pdf_at_xQ(iflv_photon), &
          &  pdf_at_xQ(iflv_electron), &
          &  pdf_at_xQ(iflv_muon),&
          &  pdf_at_xQ(iflv_tau)          
  end do
  
  ! some cleaning up (not strictly speaking needed, but illustrates
  ! how it's done)
  call Delete(table)
  call Delete(pdf0)
  call Delete(dh)
  call Delete(coupling)
  call Delete(grid)
  call Delete(qed_split)
  call Delete(coupling_qed)

contains 
  !======================================================================
  !! The dummy PDF suggested by Vogt as the initial condition for the 
  !! unpolarized evolution (as used in hep-ph/0511119).
  function unpolarized_dummy_pdf(xvals) result(pdf)
    real(dp), intent(in) :: xvals(:)
    real(dp)             :: pdf(size(xvals),ncompmin:ncompmaxLeptons)
    real(dp) :: gluon(size(xvals)), uv(size(xvals)), dv(size(xvals))
    real(dp) :: ubar(size(xvals)), dbar(size(xvals))
    !---------------------
    real(dp), parameter :: N_g = 1.7_dp, N_ls = 0.387975_dp
    real(dp), parameter :: N_uv=5.107200_dp, N_dv = 3.064320_dp
    real(dp), parameter :: N_db = half*N_ls
  
    pdf = zero
    ! clean method for labelling as PDF as being in the human representation
    ! (not actually needed after setting pdf=0
    call LabelPdfAsHuman(pdf)

    !-- remember that these are all xvals*q(xvals)
    gluon = N_g * xvals**(-0.1_dp) * (1-xvals)**5
    uv = N_uv * xvals**0.8_dp * (1-xvals)**3
    dv = N_dv * xvals**0.8_dp * (1-xvals)**4
    dbar = N_db * xvals**(-0.1_dp) * (1-xvals)**6
    ubar = dbar * (1-xvals)

    ! labels iflv_g, etc., come from the hoppet module, inherited
    ! from the main program
    pdf(:, iflv_g) = 0.99_dp * gluon
    pdf(:,-iflv_s) = 0.2_dp*(dbar + ubar)
    pdf(:, iflv_s) = pdf(:,-iflv_s)
    pdf(:, iflv_u) = uv + 0.9_dp * ubar
    pdf(:,-iflv_u) = 0.9_dp * ubar
    pdf(:, iflv_d) = dv + 0.9_dp * dbar
    pdf(:,-iflv_d) = 0.9_dp * dbar
    pdf(:,iflv_photon) = gluon/100._dp + ubar/10._dp 
    pdf(:,iflv_electron) = dbar/10._dp
    pdf(:,iflv_muon) = ubar/10._dp
    pdf(:,iflv_tau) = dbar/10._dp         

  end function unpolarized_dummy_pdf

end program tabulation_example_qed

module split_helper
  use types;
  use consts_dp;
  use convolution
  use convolution_communicator
  use qcd
  implicit none
contains

  real(dp) function piecewise_fn(x) result(res)
    real(dp), intent(in) :: x
    if (x < 0) then
      res = -x
    else
      res = x**2
    end if
  end function piecewise_fn

  !----------------------------------------------------------------------
  function broken_Pqq(y) result(res)
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x
    x = exp(-y)
    res = zero

    select case(cc_piece)
    case(cc_REAL,cc_REALVIRT)
       res = cf*(one+x**2)/(one-x)
    end select
    select case(cc_piece)
    case(cc_VIRT,cc_REALVIRT)
       res = res - cf*two/(one-x)
    case(cc_DELTA)
       res = cf*three*half
    end select

    if (x < half) res = two * res 

    if (cc_piece /= cc_DELTA) res = res * x
  end function broken_Pqq

  !----------------------------------------------------------------------
  function zerohalf_Pqq(y) result(res)
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x
    real(dp) :: plus
    x = exp(-y)
    res = zero

    if (x > half .or. cc_piece == cc_DELTA) return

    plus = cf*(one+x**2)/(one-x)
    !plus = -two * log(x/(one-x)) * plus

    !! REALVIRT will be zero, because it adds REAL and VIRT
    !! which are equal and opposite
    select case(cc_piece)
    case(cc_REAL)
      res = plus
    case(cc_VIRT)
      res = -plus
    end select

    res = res * x
  end function zerohalf_Pqq

  !----------------------------------------------------------------------
  function halfone_Pqq(y) result(res)
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x
    real(dp) :: plus
    x = exp(-y)
    res = zero

    if (x < half .or. cc_piece == cc_DELTA) return

    plus = cf*(one+x**2)/(one-x)
    !plus = -two * log(x/(one-x)) * plus

    !! REALVIRT will be zero, because it adds REAL and VIRT
    !! which are equal and opposite
    select case(cc_piece)
    case(cc_REAL)
      res = plus
    case(cc_VIRT)
      res = -plus
    end select

    res = res * x
  end function halfone_Pqq


end module split_helper

program main
  use types
  use consts_dp
  use split_helper
  use integrator
  use io_utils
  use convolution
  use splitting_functions

  implicit none
  real(dp) :: eps = 1e-6_dp
  real(dp) :: yn, ys, yn1, yn2, ys1, ys2
  integer :: i, n
  logical :: all_good = .true.
  !print *, y

  yn = ig_LinWeight(piecewise_fn, -1.0_dp, 2.0_dp, one, one, eps)
  ys = ig_LinWeight(piecewise_fn, -1.0_dp, 2.0_dp, one, one, eps, (/0.0_dp/))
  call check("LinWeight(1.0,1.0)", yn, ys)

  yn = ig_LinWeight(piecewise_fn, -1.0_dp, 2.0_dp, half, one, eps)
  ys = ig_LinWeight(piecewise_fn, -1.0_dp, 2.0_dp, half, one, eps, (/0.0_dp/))
  call check("LinWeight(0.5,2.0)", yn, ys)

  yn1 = ig_PolyWeight(piecewise_fn, -one, two, (/-one,two/), 1, eps)
  yn2 = ig_PolyWeight(piecewise_fn, -one, two, (/-one,two/), 2, eps)
  ys1 = ig_PolyWeight(piecewise_fn, -one, two, (/-one,two/), 1, eps, split=(/0.0_dp/))
  ys2 = ig_PolyWeight(piecewise_fn, -one, two, (/-one,two/), 2, eps, split=(/0.0_dp/))
  call check("PolyWeight node 1", yn1, ys1)
  call check("PolyWeight node 2", yn2, ys2)
  call check("PolyWeight sum   ", half*yn1+yn2, half*ys1+ys2)

  ! yn1 = ig_PolyWeight_expand(piecewise_fn, -one, two, (/-one,two/), 1, eps)
  ! yn2 = ig_PolyWeight_expand(piecewise_fn, -one, two, (/-one,two/), 2, eps)
  ! ys1 = ig_PolyWeight_expand(piecewise_fn, -one, two, (/-one,two/), 1, eps, split=(/0.0_dp/))
  ! ys2 = ig_PolyWeight_expand(piecewise_fn, -one, two, (/-one,two/), 2, eps, split=(/0.0_dp/))
  ! call check("PolyWeight_expand node 1", yn1, ys1)
  ! call check("PolyWeight_expand node 2", yn2, ys2)
  ! call check("PolyWeight_expand sum   ", half*yn1+yn2, half*ys1+ys2)

  call convolution_checks()

  n = int(dble_val_opt("-n", 0.0_dp))
  print *, "Now trying to integrate ", n, " times."
  do i = 1, n
    ys = ys + ig_LinWeight(piecewise_fn, -1.0_dp, 2.0_dp, half, one, eps, (/0.0_dp/))
    !y = y + ig_LinWeight(piecewise_fn, -1.0_dp, 0.0_dp, half, one, eps)
  end do


  if (.not. all_good) stop 1
contains

  subroutine check(label, a,b, limit)
    use assertions
    character(len=*), intent(in) :: label
    real(dp), intent(in) :: a, b
    real(dp), intent(in), optional :: limit
    real(dp) :: limit_lcl
    print *, label, " NO   split:", a
    print *, label, " WITH split:", b

    limit_lcl = default_or_opt(eps * (one + abs(a) + abs(b)), limit)
    if (abs(a-b) > limit_lcl) then
      all_good = .false.
      print *, "Error: |a-b| =  |", a - b , "| > ", limit_lcl
    end if
  end subroutine check


  subroutine convolution_checks()
    real(dp) :: dy, ymax = 10.0_dp
    type(grid_def) :: grid
    type(grid_conv) :: gc_broken_pqq, gc_broken_pqq_split, gc_pqq
    type(grid_conv) :: gc_zerohalf_pqq, gc_halfone_pqq
    type(grid_conv) :: gc_zerohalf_pqq_split, gc_halfone_pqq_split
    real(dp), pointer :: pdf(:), conv_res1(:), conv_res2(:), xvals
    real(dp) :: dx=0.001_dp, x
    integer  :: ix
    real(dp) :: split(1) = (/log(two)/)


    dy = dble_val_opt("-dy", 0.1_dp)
    dx = dble_val_opt("-dx", 0.1_dp)
    call InitGridDefDefault(grid, dy, ymax)

    call InitGridConv(grid, gc_broken_pqq, broken_Pqq)
    call InitGridConv(grid, gc_broken_pqq_split, broken_Pqq, split=split)

    call InitGridConv(grid, gc_zerohalf_pqq, zerohalf_Pqq)
    call InitGridConv(grid, gc_halfone_pqq , halfone_Pqq )
    call InitGridConv(grid, gc_zerohalf_pqq_split, zerohalf_Pqq, split=split)
    call InitGridConv(grid, gc_halfone_pqq_split , halfone_Pqq , split=split)

    !call AddWithCoeff(gc_broken_pqq_split, broken_Pqq, split=split)
    call InitGridConv(grid, gc_pqq, sf_Pqq)
    !call InitGridConv(grid, gc_broken_pqq_split)
    !call AddWithCoeff(gc_broken_pqq_split, sf_Pqq, split=(/log(two)/))

    call AllocGridQuant(grid, pdf)
    call AllocGridQuant(grid, conv_res1)
    call AllocGridQuant(grid, conv_res2)

    pdf = (one - xValues(grid))**3 * xValues(grid)**(-0.2_dp)
    !conv_res1 = gc_halfone_pqq       * pdf
    !conv_res2 = gc_halfone_pqq_split * pdf
    !conv_res1 = gc_zerohalf_pqq       * pdf
    !conv_res2 = gc_zerohalf_pqq_split * pdf
    !conv_res1 = gc_zerohalf_pqq       * pdf + gc_halfone_pqq       * pdf - gc_pqq * pdf
    !conv_res2 = gc_zerohalf_pqq_split * pdf + gc_halfone_pqq_split * pdf - gc_pqq * pdf

    ! for the unit test: compare the evaluation with complete splitting function
    ! to the evaluation with the two halves of the splitting function
    conv_res1 = gc_pqq * pdf
    conv_res2 = gc_zerohalf_pqq_split * pdf + gc_halfone_pqq_split * pdf 
    !conv_res2 = gc_zerohalf_pqq * pdf + gc_halfone_pqq * pdf 

    if  (maxval(abs(conv_res1-conv_res2)) > eps) then
      print *, "Error: maxval(abs(conv_res1-conv_res2)) = ", maxval(abs(conv_res1-conv_res2))
      all_good = .false.
    end if
    

    do ix = max(1,int(0.02/dx)), int(0.9/dx)
      x = ix * dx
      ! XX makes it easy to grep out the result
      print *, "XX", x, conv_res1.atx.(x.with.grid), conv_res2.atx.(x.with.grid)
    end do

  end subroutine convolution_checks
end program main

!
! This include sets __HOPPET_tab_min_subgrid_ny__ and
! __HOPPET_tab_min_nQ__, which are the minimum values for the subgrid ny
! and nQ respectively for various interpolation assumptions to be
! correct, avoiding the need for runtime checks
#include "inc/pdf_tabulate.inc"

!-----------------------------------------------------------
!! Module to make tabulation easy
!!
!! Currently does not know anything about nf thresholds.
!!
!! But some form of support for these might be useful... Question is:
!! how can it be arranged in a fairly clean manner, without breaking
!! things that already use the system (e.g. caesar resum)?
!!
!! One possibility is to use an running_coupling as a source of information.
!! One can then either take a copy of the running_coupling and use its routines
!! or else just extract the relevant useful information
!!
!! Aim is to be able to write -- i.e. convolutions with full nf info
!!
!!   Ptab%tab = dh%P_LO(iloop,tab%nf_int(:)) .conv. tab%tab
!!
!! This probably requires some modifications also to the convolution 
!! routines (which do not currently have this overloading for .conv.).
!!
!! [NB at some point maybe include nf association in some simpler manner?]
module pdf_tabulate
  use types; use consts_dp
  use convolution; use dglap_objects
  use pdf_representation; use pdf_general
  use interpolation
  use warnings_and_errors
  !use pdf_tabulate_types
  !-- needed only for EvolvePdfTable [separate it out one day?]
  use qcd_coupling; use evolution; use dglap_holders
  implicit none
  private

  type pdfseginfo
  real(dp) :: lnlnQ_lo, lnlnQ_hi, dlnlnQ, inv_dlnlnQ
    integer :: ilnlnQ_lo, ilnlnQ_hi
  end type pdfseginfo
  public :: pdfseginfo

  type pdf_table
    ! basic elements of a pdf_table, common regardless of whether we
    ! additionally have the nf segments...
    logical :: allocated = .false.
    type(grid_def) :: grid
    real(dp) :: default_dlnlnQ
    real(dp) :: lnlnQ_min, lnlnQ_max, lambda_eff
    real(dp), pointer :: tab(:,:,:)
    real(dp), pointer :: lnlnQ_vals(:), Q_vals(:)
    integer :: nQ, lnlnQ_order
    logical :: freeze_at_Qmin
    ! this is useful only in absence of nf info.
    real(dp) :: dlnlnQ    

    ! a seginfo-like object when there is no nf info,
    ! makes it easier to have common code across nf and no-nf 
    ! cases
    type(pdfseginfo) :: seginfo_no_nf

    ! Stuff to do with variable nf and alpha_s; not always available.
    ! In cases with variable nf, the table will be broken into multiple
    ! segments, each one of which potentially different spacings.
    !
    logical :: nf_info_associated
    integer :: nflo, nfhi
    type(pdfseginfo), pointer :: seginfo(:)
    integer,          pointer :: nf_int(:)
    real(dp),         pointer :: as2pi(:)
    !
    ! Elements needed in case we want to do precalculation of
    ! of evolution. Not always available.
    type(evln_operator), pointer :: evops(:)
    integer                      :: StartScale_iQlo
    real(dp)                     :: StartScale

    ! for some purposes (e.g. structure function work), it is useful
    ! for the table to have a user-tuned maximum iflv value (this
    ! affects the range used for interpolation rather than for
    ! allocation of the table itself)
    integer :: tab_iflv_max = iflv_max

    ! pointers to evaluation routines; the abstract interfaces
    ! are defined below
    procedure(EvalPdfTable_yQ_interface ), pointer, nopass :: EvalPdfTable_yQ_ptr  => null()
    procedure(EvalPdfTable_yQf_interface), pointer, nopass :: EvalPdfTable_yQf_ptr => null()
    procedure(EvalPdfTable1D_yQ_interface), pointer, nopass :: EvalPdfTable1D_yQ_ptr => null()
  end type pdf_table
  public :: pdf_table


  integer :: override_npnt_y = -1
  integer :: override_order_y = -1
  integer :: override_order_Q = -1
  logical :: override_on = .false.
  

  !-- for calculating ln ln Q/lambda_eff
  real(dp), parameter :: default_lambda_eff = 0.1_dp
  real(dp), parameter :: default_dlnlnQ = 0.07_dp
  real(dp), parameter :: warn_tolerance = 1e-3_dp
  !! used in various contexts for deciding when an interval is
  !! sufficiently small that it can be ignored...
  real(dp), parameter :: min_dlnlnQ_singleQ = 1e-10_dp
  integer, public :: def_lnlnQ_order = 4
  !! the max_lnlnQ_order is used in certain hard-coded array sizes
  !! so that they can be created on the stack rather than the heap,
  !! which has a speed advantage
  integer, parameter :: max_lnlnQ_order = 6

  interface AllocPdfTable
    module procedure pdftab_AllocTab_, pdftab_AllocTab_fromorig,&
          & pdftab_AllocTab_1d, pdftab_AllocTab_fromorig_1d
  end interface

  interface AllocPdfTableWithPhoton
    module procedure pdftab_AllocTabWithPhoton_, pdftab_AllocTabWithPhoton_1d
  end interface
  public :: AllocPdfTableWithPhoton

  interface AllocPdfTableWithLeptons
    module procedure pdftab_AllocTabWithLeptons_, pdftab_AllocTabWithLeptons_1d
  end interface
  public :: AllocPdfTableWithLeptons  


  interface AddNfInfoToPdfTable
    module procedure AddNfInfoToPdfTable, pdftab_AssocNfInfo_1d
  end interface

  public :: PdfTableSetInterpPointers

  interface FillPdfTable_f90sub
    module procedure pdftab_InitTabSub_, pdftab_InitTabSub_iset
  end interface

  public :: FillPdfTable_LHAPDF

  interface EvolvePdfTable
    module procedure pdftab_InitTabEvolve_frompre, EvolvePdfTable
  end interface

  interface Delete
    module procedure pdftab_DelTab_0d, pdftab_DelTab_1d
  end interface

  public :: AllocPdfTable, FillPdfTable_f90sub
  public :: AddNfInfoToPdfTable
  public :: EvolvePdfTable, PreEvolvePdfTable, EvolvePdfTableQED
  public :: EvolvePdfTableGen

  interface EvalPdfTable_yQ
    module procedure EvalPdfTable0D_yQ, EvalPdfTable1D_yQ
  end interface
  interface EvalPdfTable_xQ
    module procedure EvalPdfTable0D_xQ, EvalPdfTable1D_xQ
  end interface
  public :: EvalPdfTable0D_yQ, EvalPdfTable0D_xQ, EvalPdfTable1D_yQ, EvalPdfTable1D_xQ
  public :: EvalPdfTable_yQ, EvalPdfTable_xQ

  
  public :: EvalPdfTable_Q
  public :: EvalPdfTable_yQf, EvalPdfTable_xQf
  public :: WriteLHAPDFFromPdfTable
  public :: Delete

  public :: PdfTableOverrideInterpOrders


  public :: EvalPdfTable_yQf_order22
  public :: EvalPdfTable_yQf_order33
  public :: EvalPdfTable_yQf_order44

  public :: EvalPdfTable_yQ_order22
  public :: EvalPdfTable_yQ_order33
  public :: EvalPdfTable_yQ_order44
  public :: EvalPdfTable_yQ_any_order

  abstract interface
    subroutine EvalPdfTable_yQ_interface(tab,y,Q,val)
      use types
      import :: pdf_table ! ensures pdf_table is visible
      implicit none
      type(pdf_table), intent(in), target  :: tab
      real(dp),        intent(in)          :: y, Q
      real(dp),        intent(out)         :: val(:)
    end subroutine EvalPdfTable_yQ_interface
  end interface

  abstract interface
    function EvalPdfTable_yQf_interface(tab,y,Q,iflv) result(res)
      use types
      import :: pdf_table ! ensures pdf_table is visible
      implicit none
      type(pdf_table), intent(in), target  :: tab
      real(dp),        intent(in)          :: y, Q
      integer,         intent(in)          :: iflv
      real(dp)                             :: res
    end function EvalPdfTable_yQf_interface
  end interface

  abstract interface
    subroutine EvalPdfTable1D_yQ_interface(tab,y,Q,val)
      use types
      import :: pdf_table ! ensures pdf_table is visible
      implicit none
      type(pdf_table), intent(in), target  :: tab(:)
      real(dp),        intent(in)          :: y, Q
      real(dp),        intent(out)         :: val(:,:)
    end subroutine EvalPdfTable1D_yQ_interface
  end interface

  procedure(EvalPdfTable_yQ_interface ), pointer :: EvalPdfTable_yQ_ptr  => null()
  procedure(EvalPdfTable_yQf_interface), pointer :: EvalPdfTable_yQf_ptr => null()
  procedure(EvalPdfTable1D_yQ_interface), pointer :: EvalPdfTable1D_yQ_ptr  => null()

  public :: EvalPdfTable_yQ_interface, EvalPdfTable_yQf_interface, EvalPdfTable1D_yQ_interface

contains

  !---------------------------------------------------------
  !! Allocate a pdf_table, which covers a range Qmin to Qmax, using
  !! tabulation uniform in (ln ln Q/Lambda), where Lambda is currently
  !! a module parameter.
  !!
  !! If freeze_at_Qmin is present and .true., distributions are frozen
  !! at their Qmin value for Q < Qmin. Otherwise they are set to zero
  !! there.
  !!
  !! More sensible extrapolation beyond Q range offers scope for future 
  !! improvement here!
  !!
  !! If the pdf_table had previously been allocated, then delete its
  !! contents before the new allocations
  !!
  subroutine pdftab_AllocTab_(grid, tab, Qmin, Qmax, dlnlnQ, lnlnQ_order, freeze_at_Qmin, iflv_max_table)
    type(grid_def),    intent(in)    :: grid
    type(pdf_table),   intent(inout) :: tab
    real(dp), intent(in)           :: Qmin, Qmax
    real(dp), intent(in), optional :: dlnlnQ
    integer,  intent(in), optional :: lnlnQ_order
    logical,  intent(in), optional :: freeze_at_Qmin
    integer,  intent(in), optional :: iflv_max_table
    !----------------------------------------------
    integer :: iQ, igd
    logical :: grids_bad

    ! clear memory if the table was already allocated
    if (tab%allocated) call Delete(tab)

    tab%grid = grid
    tab%lambda_eff = min(half*Qmin, default_lambda_eff)
    tab%lnlnQ_min = lnln(tab,Qmin)
    tab%lnlnQ_max = lnln(tab,Qmax)

    ! some of our interpolation needs a minimum number of ny points in
    ! the grid or each sub-grid, so check that
    if (associated(tab%grid%subgd)) then
      grids_bad = any(tab%grid%subgd(:)%ny < __HOPPET_tab_min_subgrid_ny__)
    else
      grids_bad = tab%grid%ny < __HOPPET_tab_min_subgrid_ny__
    end if
    if (grids_bad) call wae_error("pdftab_AllocTab_",&
                  "grid or subgrid has ny < __HOPPET_tab_min_subgrid_ny__=",intval=__HOPPET_tab_min_subgrid_ny__)

    tab%default_dlnlnQ = default_or_opt(default_dlnlnQ, dlnlnQ)
    tab%nQ = ceiling((tab%lnlnQ_max - tab%lnlnQ_min)/tab%default_dlnlnQ)
    tab%nQ = max(tab%nQ, __HOPPET_tab_min_nQ__)
    tab%dlnlnQ = (tab%lnlnQ_max - tab%lnlnQ_min)/tab%nQ

    tab%freeze_at_Qmin = default_or_opt(.false.,freeze_at_Qmin)
    tab%lnlnQ_order = default_or_opt(def_lnlnQ_order,lnlnQ_order)
    if (tab%lnlnQ_order > max_lnlnQ_order) call wae_error('pdftab_AllocTab_',&
         &'too large a value of lnlnQ_order =',intval=tab%lnlnQ_order)

    !-- by default, no extra info is given
    tab%nf_info_associated = .false.
    nullify(tab%as2pi)
    nullify(tab%nf_int)
    nullify(tab%evops)

    !write(0,*) 'pdf_table info: Number of Q bins is ',tab%nQ
    ! start off with this default
    tab%tab_iflv_max = iflv_max
    if (present(iflv_max_table)) then
      if (iflv_max_table < iflv_max) call wae_error('pdftab_AllocTab_','iflv_max_table too small (<iflv_max)',intval=iflv_max_table)
      call AllocGridQuant(grid, tab%tab, iflv_min, iflv_max_table, 0, tab%nQ)
      if (iflv_max_table /= ncompmax) tab%tab_iflv_max = iflv_max_table
    else
       call AllocPDF(grid,tab%tab,0,tab%nQ)
    end if
    allocate(tab%lnlnQ_vals(0:tab%nQ))
    allocate(tab%Q_vals(0:tab%nQ))
    do iQ = 0, tab%nQ
      tab%lnlnQ_vals(iQ) = tab%lnlnQ_min + iQ * tab%dlnlnQ
      tab%Q_vals(iQ) = invlnln(tab,tab%lnlnQ_vals(iQ))
    end do


    tab%seginfo_no_nf%lnlnQ_lo = tab%lnlnQ_min
    tab%seginfo_no_nf%lnlnQ_hi = tab%lnlnQ_max
    tab%seginfo_no_nf%dlnlnQ = tab%dlnlnQ
    tab%seginfo_no_nf%inv_dlnlnQ = 1.0_dp / tab%dlnlnQ
    tab%seginfo_no_nf%ilnlnQ_lo = 0
    tab%seginfo_no_nf%ilnlnQ_hi = tab%nQ

    call pdftab_SetupEvalPtrs(tab)

    ! label this tab as allocated
    tab%allocated = .true.
  end subroutine pdftab_AllocTab_


  
  !---------------------------------------------------------
  !! 1d overloaded version of AllocPdfTable
  subroutine pdftab_AllocTab_1d(grid, tab, Qmin, Qmax, dlnlnQ, lnlnQ_order, freeze_at_Qmin, iflv_max_table)
    type(grid_def),    intent(in)     :: grid
    type(pdf_table),   intent(inout)  :: tab(:)
    real(dp), intent(in)           :: Qmin, Qmax
    real(dp), intent(in), optional :: dlnlnQ
    integer,  intent(in), optional :: lnlnQ_order
    logical,  intent(in), optional :: freeze_at_Qmin
    integer,  intent(in), optional :: iflv_max_table
    integer :: i

    do i = 1, size(tab)
       call pdftab_AllocTab_(grid, tab(i), Qmin, Qmax, dlnlnQ, lnlnQ_order, freeze_at_Qmin, iflv_max_table)
    end do
  end subroutine pdftab_AllocTab_1d


  subroutine pdftab_AllocTabWithPhoton_(grid, tab, Qmin, Qmax, dlnlnQ, lnlnQ_order, freeze_at_Qmin)
    use qed_objects
    type(grid_def),    intent(in)    :: grid
    type(pdf_table),   intent(inout) :: tab
    real(dp), intent(in)           :: Qmin, Qmax
    real(dp), intent(in), optional :: dlnlnQ
    integer,  intent(in), optional :: lnlnQ_order
    logical,  intent(in), optional :: freeze_at_Qmin
    call AllocPdfTable(grid, tab, Qmin, Qmax, dlnlnQ, lnlnQ_order, freeze_at_Qmin, iflv_max_table=ncompmaxPhoton)
  end subroutine pdftab_AllocTabWithPhoton_
  
  subroutine pdftab_AllocTabWithPhoton_1d(grid, tab, Qmin, Qmax, dlnlnQ, lnlnQ_order, freeze_at_Qmin)
    use qed_objects
    type(grid_def),    intent(in)    :: grid
    type(pdf_table),   intent(inout) :: tab(:)
    real(dp), intent(in)           :: Qmin, Qmax
    real(dp), intent(in), optional :: dlnlnQ
    integer,  intent(in), optional :: lnlnQ_order
    logical,  intent(in), optional :: freeze_at_Qmin
    call AllocPdfTable(grid, tab, Qmin, Qmax, dlnlnQ, lnlnQ_order, freeze_at_Qmin, iflv_max_table=ncompmaxPhoton)
  end subroutine pdftab_AllocTabWithPhoton_1d
  

  subroutine pdftab_AllocTabWithLeptons_(grid, tab, Qmin, Qmax, dlnlnQ, lnlnQ_order, freeze_at_Qmin)
   use qed_objects
   type(grid_def),    intent(in)    :: grid
    type(pdf_table),   intent(inout) :: tab
    real(dp), intent(in)           :: Qmin, Qmax
    real(dp), intent(in), optional :: dlnlnQ
    integer,  intent(in), optional :: lnlnQ_order
    logical,  intent(in), optional :: freeze_at_Qmin
    call AllocPdfTable(grid, tab, Qmin, Qmax, dlnlnQ, lnlnQ_order, freeze_at_Qmin, iflv_max_table=ncompmaxLeptons)
  end subroutine pdftab_AllocTabWithLeptons_
  
  subroutine pdftab_AllocTabWithLeptons_1d(grid, tab, Qmin, Qmax, dlnlnQ, lnlnQ_order, freeze_at_Qmin)
    use qed_objects
    type(grid_def),    intent(in)    :: grid
    type(pdf_table),   intent(inout) :: tab(:)
    real(dp), intent(in)           :: Qmin, Qmax
    real(dp), intent(in), optional :: dlnlnQ
    integer,  intent(in), optional :: lnlnQ_order
    logical,  intent(in), optional :: freeze_at_Qmin
    call AllocPdfTable(grid, tab, Qmin, Qmax, dlnlnQ, lnlnQ_order, freeze_at_Qmin, iflv_max_table=ncompmaxLeptons)
  end subroutine pdftab_AllocTabWithLeptons_1d


  !---------------------------------------------------------------
  !! Associate a tab with the nf info from an alpha_s holder
  !! (i.e. read that info, and copy it into tab).
  !!
  !! This involves REALLOCATING the tab pointer so as to allow for
  !! extra information.
  !!
  !! The new tab separates stretches with different nf values. It also
  !! has extra info in the form of arrays nf_int and as2pi, which make
  !! it possible to write expressions such as
  !!
  !!   Dtab%tab = tab%as2pi(:) * (dh%P_LO(iloop,tab%nf_int(:)) .conv. tab%tab)
  !!
  !! This is one of the rare cases in which direct access to structure 
  !! components is still allowed... (Lack of finalisation makes it
  !! difficult to do otherwise).
  !!
  !! KNOWN LIMITATIONS: What happens with muM_mQ /= 1? All hell breaks
  !! loose?
  subroutine AddNfInfoToPdfTable(tab,coupling)
    type(pdf_table), intent(inout), target :: tab
    type(running_coupling), intent(in) :: coupling
    !-----------------------------------
    integer  :: nflcl, iQ_prev, iQ, iflv_max_table
    real(dp) :: Qlo, Qhi, Qhi_test
    type(pdfseginfo), pointer :: seginfo

    
    !if (tab%nf_info_associated) call wae_error('AddNfInfoToPdfTable',&
    !     &'nf info already associated: delete it first')

    ! We will be reallocating everything here, so first clean up
    iflv_max_table = ubound(tab%tab,dim=2)
    call Delete(tab)
    tab%dlnlnQ = zero ! will no longer be useful...

    tab%nflo = NfAtQ(coupling, invlnln(tab,tab%lnlnQ_min))
    tab%nfhi = NfAtQ(coupling, invlnln(tab,tab%lnlnQ_max))

    allocate(tab%seginfo(tab%nflo:tab%nfhi))

    ! figure out how we are going to bin things...
    iQ_prev = -1
    do nflcl = tab%nflo, tab%nfhi
      !write(0,*) 'nflcl',nflcl
      seginfo => tab%seginfo(nflcl)

      call QRangeAtNf(coupling, nflcl, Qlo, Qhi_test)
      call QRangeAtNf(coupling, nflcl, Qlo, Qhi, muM_mQ=one)
      ! if one weakens this restriction, then one should think about
      ! the consequences for the determination of alpha_s/2pi, here
      ! and elsewhere....
      if (Qhi_test /= Qhi) call wae_error('AddNfInfoToPdfTable',&
        &'it seems that coupling has muM_mQ /= one. Currently unsupported.',&
        &dbleval=Qhi_test/Qhi)

      ! Include min_dlnlnQ_singleQ to ensure we do not go EXACTLY to the
      ! mass threshold, where, in evolution one might run into problems.
      ! BUT, we will later have to worry about what to do when we
      ! are in between thresholds...
      seginfo%lnlnQ_lo = max(lnln(tab,Qlo)+min_dlnlnQ_singleQ, tab%lnlnQ_min)
      seginfo%lnlnQ_hi = min(lnln(tab,Qhi)-min_dlnlnQ_singleQ, tab%lnlnQ_max)

      seginfo%ilnlnQ_lo = iQ_prev + 1
      !write(0,*) 'ill_lo', seginfo%ilnlnQ_lo
      if ((seginfo%lnlnQ_hi - seginfo%lnlnQ_lo) < two*min_dlnlnQ_singleQ) then
         ! use just one point
         seginfo%ilnlnQ_hi = seginfo%ilnlnQ_lo
         seginfo%dlnlnQ = zero
         seginfo%lnlnQ_hi = seginfo%lnlnQ_lo
      else
         seginfo%ilnlnQ_hi = seginfo%ilnlnQ_lo + &
            & max(__HOPPET_tab_min_nQ__,&
                & tab%lnlnQ_order,&
                & ceiling((seginfo%lnlnQ_hi - seginfo%lnlnQ_lo)/tab%default_dlnlnQ))
         seginfo%dlnlnQ = (seginfo%lnlnQ_hi - seginfo%lnlnQ_lo)/&
              & (seginfo%ilnlnQ_hi - seginfo%ilnlnQ_lo)
      end if
      !write(0,*) 'ill_hi', seginfo%ilnlnQ_hi, seginfo%dlnlnQ, &
      !     &invlnln(tab,seginfo%lnlnQ_lo),invlnln(tab,seginfo%lnlnQ_hi), tab%default_dlnlnQ
      iQ_prev = seginfo%ilnlnQ_hi
      seginfo%inv_dlnlnQ = one / seginfo%dlnlnQ
    end do
    

    ! this should not happen too often! But check it just in
    ! case...
    if (tab%seginfo(tab%nflo)%lnlnQ_lo /= tab%lnlnQ_min .or.&
         &tab%seginfo(tab%nfhi)%lnlnQ_hi /= tab%lnlnQ_max) &
         &call wae_error('AddNfInfoToPdfTable',&
         & 'mismatch in segment and global lnlnQ limits.',&
         & 'Could be due to coupling having more restricted range?')


    ! now reallocate things. 
    tab%nQ = tab%seginfo(tab%nfhi)%ilnlnQ_hi
    ! copy across the iflv_max used in the original version of the table
    call AllocGridQuant(tab%grid, tab%tab, iflv_min, iflv_max_table, 0, tab%nQ)
    allocate(tab%lnlnQ_vals(0:tab%nQ))
    allocate(tab%Q_vals(0:tab%nQ))
    allocate(tab%nf_int(0:tab%nQ))
    allocate(tab%as2pi(0:tab%nQ))

    ! carry out a check that it's always safe to use up to __HOPPET_tab_min_nQ__+1 points
    ! in the Q interpolation, even for segments with a single Q (for those segments, the
    ! interpolation weights in some high-efficiency routines will be just 1 for that iQ
    ! and 0 at higher iQ, but table must actually contain valid higher iQ points to avoid
    ! accessing invalid memory)
    do nflcl = tab%nflo, tab%nfhi      
      seginfo => tab%seginfo(nflcl)
      if (seginfo%ilnlnQ_lo == seginfo%ilnlnQ_hi .and. tab%nQ - seginfo%ilnlnQ_hi < __HOPPET_tab_min_nQ__) then
        call wae_error("AddNfInfoToPdfTable",&
              "too few ilnlnQ points for safe interpolation, above a segment with a single ilnlnQ.",&
              "Try raising the table's Qmax.",&
              "The problem occurred for nf=",intval=nflcl)
      end if
    end do


    ! set up complementary info...
    do nflcl = tab%nflo, tab%nfhi
      !write(0,*) 'nflcl',nflcl
      seginfo => tab%seginfo(nflcl)
      do iQ = seginfo%ilnlnQ_lo, seginfo%ilnlnQ_hi
        tab%nf_int(iQ) = nflcl
        tab%lnlnQ_vals(iQ) = seginfo%lnlnQ_lo &
              & + (iQ-seginfo%ilnlnQ_lo)*seginfo%dlnlnQ
        tab%Q_vals(iQ)     = invlnln(tab,tab%lnlnQ_vals(iQ))
        tab%as2pi(iQ) = Value(coupling,invlnln(tab,tab%lnlnQ_vals(iQ)))/twopi
      end do
    end do

    call pdftab_SetupEvalPtrs(tab)

    ! REMEMBER TO COMPLETE FROM ORIG...
    tab%nf_info_associated = .true.
  end subroutine AddNfInfoToPdfTable

  !---------------------------------------------------------------
  subroutine pdftab_SetupEvalPtrs(tab)
    type(pdf_table), intent(inout) :: tab
    integer :: grid_order, npnt_y, order_y

    if (associated(tab%grid%subgd)) then
      grid_order = tab%grid%subgd(1)%order
      if (any(tab%grid%subgd(:)%order /= grid_order)) then
        ! different per-grid orders not yet supported, so set the
        ! orders to -1, which sets the pointers to null
        call PdfTableSetInterpPointers(-1,-1, &
                                   tab%EvalPdfTable_yQ_ptr, tab%EvalPdfTable_yQf_ptr, tab%EvalPdfTable1D_yQ_ptr)
      end if
    else
      grid_order = tab%grid%order
    end if

    ! convolution.f90's default is to set the interpolation order to abs(grid%order)-1
    ! with limits on the range; so table-specific interpolation, we adopt the 
    ! same defaults here
    npnt_y = min(grid_interp_npnt_max, max(grid_interp_npnt_min, abs(grid_order)))
    order_y = npnt_y - 1
    call PdfTableSetInterpPointers(order_y, tab%lnlnQ_order, &
                                   tab%EvalPdfTable_yQ_ptr, tab%EvalPdfTable_yQf_ptr, tab%EvalPdfTable1D_yQ_ptr)
  end subroutine pdftab_SetupEvalPtrs

  !---------------------------------------------------------------
  !! 1d-overloaded verseion of AddNfInfoToPdfTable
  subroutine pdftab_AssocNfInfo_1d(tab,coupling)
    type(pdf_table), intent(inout) :: tab(:)
    type(running_coupling), intent(in) :: coupling
    !-----------------------------------
    integer :: i
    do i = 1, size(tab)
       call AddNfInfoToPdfTable(tab(i),coupling)
    end do
    
  end subroutine pdftab_AssocNfInfo_1d


  !-----------------------------------------------------------------------
  !! Allocate the memory for a new tab, using as a template an
  !! preexistent tab (origtab).
  !!
  !! Additionally, information concerning any varnf and alphas
  !! structure copied from origtab to tab. Actual PDF contents of the
  !! tab are not however copied.
  !! 
  subroutine pdftab_AllocTab_fromorig(tab, origtab)
    type(pdf_table), intent(out) :: tab
    type(pdf_table), intent(in)  :: origtab
    integer                      :: iflv_max_table
    
    tab = origtab
    !-- the next things are those not taken care of automatically by the assignment;
    !   we allow for arbitrary numbers of flavours
    iflv_max_table = ubound(tab%tab,dim=2)
    call AllocGridQuant(tab%grid, tab%tab, iflv_min, iflv_max_table, 0, tab%nQ)
    allocate(tab%lnlnQ_vals(0:tab%nQ))
    tab%lnlnQ_vals = origtab%lnlnQ_vals
    allocate(tab%Q_vals(0:tab%nQ))
    tab%Q_vals = origtab%Q_vals

    if (origtab%nf_info_associated) then
       allocate(tab%seginfo(tab%nflo:tab%nfhi))
       allocate(tab%nf_int(0:tab%nQ))
       allocate(tab%as2pi(0:tab%nQ))
       tab%seginfo = origtab%seginfo
       tab%nf_int = origtab%nf_int
       tab%as2pi = origtab%as2pi
    end if
  end subroutine pdftab_AllocTab_fromorig

  !---------------------------------------------------------
  !! 1d-overloaded version of pdftab_AllocTab_fromorig
  subroutine pdftab_AllocTab_fromorig_1d(tab, origtab)
    type(pdf_table), intent(inout) :: tab(:)
    type(pdf_table), intent(in)    :: origtab
    integer :: i
    do i = 1, size(tab)
       call pdftab_AllocTab_fromorig(tab(i), origtab)
    end do
  end subroutine pdftab_AllocTab_fromorig_1d


  !------------------------------------------------------
  !! Initialise the tab with the results of a subroutine (see
  !! interface). Note that the subroutine takes y = ln1/x and Q as its
  !! arguments.
  subroutine pdftab_InitTabSub_(tab, sub)
    type(pdf_table), intent(inout) :: tab
    interface
       subroutine sub(y, Q, res)
         use types; implicit none
         real(dp), intent(in) :: y, Q
         real(dp), intent(out):: res(:)
       end subroutine sub
    end interface
    !-------------
    integer :: iQ
    real(dp) :: Q
    do iQ = 0, tab%nQ
       Q = invlnln(tab,tab%lnlnQ_min + iQ*tab%dlnlnQ)
       call InitPDFSub(tab%grid, tab%tab(:,:,iQ), sub, Q)
    end do
    
  end subroutine pdftab_InitTabSub_
  
  !------------------------------------------------------
  !! Initialise the tab with the results of a subroutine (see
  !! interface). In addition y = ln1/x and Q, the subroutine takes the
  !! argument iset, enabling one to initialise from a subroutine that
  !! provides several "PDF sets".
  !!
  subroutine pdftab_InitTabSub_iset(tab, sub, iset)
    type(pdf_table), intent(inout) :: tab
    integer,      intent(in)    :: iset
    interface
       subroutine sub(y, Q, iset, res)
         use types; implicit none
         real(dp), intent(in) :: y, Q
         integer, intent(in) :: iset
         real(dp), intent(out):: res(:)
       end subroutine sub
    end interface
    !-------------
    integer :: iQ
    real(dp) :: Q
    do iQ = 0, tab%nQ
       !Q = invlnln(tab,tab%lnlnQ_min + iQ*tab%dlnlnQ)
       Q = invlnln(tab,tab%lnlnQ_vals(iQ))
       call InitPDFSub(tab%grid, tab%tab(:,:,iQ), sub, Q, iset)
    end do
    
  end subroutine pdftab_InitTabSub_iset

  !------------------------------------------------------
  !! Initialise the tab with the results of a subroutine (see
  !! interface). Note that the subroutine takes y = ln1/x and Q as its
  !! arguments.
  subroutine FillPdfTable_LHAPDF(tab, LHAsub)
    type(pdf_table), intent(inout) :: tab
    interface
       subroutine LHAsub(x,Q,res)
         use types; implicit none
         real(dp), intent(in)  :: x,Q
         real(dp), intent(out) :: res(*)
       end subroutine LHAsub
    end interface
    !-------------
    integer :: iQ
    real(dp) :: Q
    do iQ = 0, tab%nQ
       Q = tab%Q_vals(iQ)
       call InitPDF_LHAPDF(tab%grid, tab%tab(:,:,iQ), LHAsub, Q)
    end do
  end subroutine FillPdfTable_LHAPDF

  !---------------------------------------------------------------------
  !! Given a starting distribution, StartDist, at StartScale and an
  !! "coupling" determining the behaviour of alphas, fill in the tab with
  !! the evolution of the starting distribution. Most of the arguments
  !! have meanings similar to those in the evolution routines
  !!
  subroutine EvolvePdfTable(tab, StartScale, StartDist, &
                                    & dh, coupling, muR_Q,nloop, untie_nf)
    type(pdf_table),    intent(inout) :: tab
    real(dp),           intent(in) :: StartScale
    real(dp),           intent(in) :: StartDist(0:,iflv_min:)
    type(dglap_holder), intent(in) :: dh
    type(running_coupling),  intent(in) :: coupling
    real(dp), intent(in), optional :: muR_Q
    integer,  intent(in), optional :: nloop
    logical,  intent(in), optional :: untie_nf
    !-----------------------------------------------------
    
    call EvolvePdfTableGen(tab, StartScale, dh, coupling, &
       &StartDist=StartDist, muR_Q=muR_Q, nloop=nloop, untie_nf=untie_nf)
  end subroutine EvolvePdfTable
  
  !---------------------------------------------------------------------
  !! Given a starting scale, precalculate the evolution operators that
  !! are needed to generate the full tab from a distribution at that 
  !! starting scale . Most of the arguments have meanings similar
  !! to those in the evolution routines
  !!
  subroutine PreEvolvePdfTable(tab,StartScale,dh,coupling,muR_Q,nloop,untie_nf)
    type(pdf_table),    intent(inout) :: tab
    real(dp),           intent(in) :: StartScale
    type(dglap_holder), intent(in) :: dh
    type(running_coupling),    intent(in) :: coupling
    real(dp), intent(in), optional :: muR_Q
    integer,  intent(in), optional :: nloop
    logical,  intent(in), optional :: untie_nf
    !-----------------------------------------------------
    
    call EvolvePdfTableGen(tab, StartScale, dh, coupling, &
       &precalc = .true., muR_Q=muR_Q, nloop = nloop, untie_nf=untie_nf)
  end subroutine PreEvolvePdfTable

  !---------------------------------------------------------------------
  !! Given a starting distribution, StartDist, and assuming that the
  !! pre-evolution has been carried out for the tab, then generate the
  !! contents of the table from the StartDist.
  !!
  !! NB: alphas will not be updated relative to last true evolution or
  !!     preevolution. So if at any point since doing the preevolution,
  !!     an evolution has been carried out with a different alphas, then 
  !!     as2pi will not be correct here. SHOULD THIS BE FIXED?
  !!
  subroutine pdftab_InitTabEvolve_frompre(tab, StartDist)
    type(pdf_table),    intent(inout) :: tab
    real(dp),           intent(in) :: StartDist(0:,iflv_min:)
    !-----------------------------------------------------
    real(dp) :: dist(0:ubound(StartDist,1),iflv_min:ubound(StartDist,2))
    integer :: iQ
    
    if (.not. associated(tab%evops)) call wae_error(&
         &'pdftab_InitTabEvolve_frompre',&
         &'No precalculated evolution is available')

    dist = StartDist
    do iQ = tab%StartScale_iQlo, 0, -1
       dist = tab%evops(iQ) .conv. dist
       tab%tab(:,:,iQ) = dist
    end do
    dist = StartDist
    do iQ = tab%StartScale_iQlo+1, tab%nQ
       dist = tab%evops(iQ) .conv. dist
       tab%tab(:,:,iQ) = dist
    end do
    
  end subroutine pdftab_InitTabEvolve_frompre

  !---------------------------------------------------------------------
  !! General internal routine, which serves both to carry out evolution
  !! of a parton distribution AND to determine the evops. That way
  !! everything to do with evolution is concentrated in a single location.
  !!
  !! For the user, this routine should probably be accessed via the more
  !! specific routines, EvolvePdfTable and pdftab_PreCalc.
  !!
  !! Given a starting distribution, StartDist, at StartScale and an
  !! "coupling" determining the behaviour of alphas, fill in the tab with
  !! the evolution of the starting distribution.
  !!
  subroutine EvolvePdfTableGen(tab, StartScale, dh, coupling, &
       &StartDist, precalc, muR_Q, nloop, untie_nf)
    type(pdf_table),           intent(inout) :: tab
    real(dp),               intent(in)    :: StartScale
    type(dglap_holder),     intent(in)    :: dh
    type(running_coupling), intent(in)    :: coupling
    !real(dp), optional, intent(in) :: StartDist(0:,iflv_min:)
    real(dp),     optional, intent(in)    :: StartDist(:,:)
    logical,      optional, intent(in)    :: precalc
    real(dp),     optional, intent(in)    :: muR_Q
    integer,      optional, intent(in)    :: nloop
    logical,      optional, intent(in)    :: untie_nf
    !-----------------------------------------------------
    real(dp), allocatable :: dist(:,:)
    real(dp) :: lnlnQ_norm, lnlnQ, Q_init, Q_end, last_Q
    integer :: i, iQ_lo, iQ_hi
    logical :: precalc_lcl

    precalc_lcl = default_or_opt(.false.,precalc)
    if (precalc_lcl) then
       if (associated(tab%evops)) call wae_error('EvolvePdfTableGen',&
            &'tab%evops has already been calculated. Delete the tab first,',&
            &'if you want to recalculated it.')
       allocate(tab%evops(0:tab%nQ))
    end if
    
    
    lnlnQ = lnln(tab,StartScale)
    call request_iQrange(tab, lnlnQ, 1, iQ_lo, iQ_hi, lnlnQ_norm)
    tab%StartScale = StartScale
    tab%StartScale_iQlo = iQ_lo
    ! force this...
    iQ_hi = iQ_lo + 1
    !write(0,*) iQ_lo, iQ_hi
    !lnlnQ_norm_start = lnln_norm(tab,StartScale)


    if (present(StartDist)) then
       allocate(dist(size(StartDist,1),size(StartDist,2)))
       dist = StartDist
    end if
    
    last_Q = StartScale
    !do i = floor(lnlnQ_norm_start), 0, -1
    do i = iQ_lo, 0, -1
       Q_init = last_Q
       Q_end = invlnln(tab,tab%lnlnQ_vals(i))
       !write(0,*) 'doing ev from ',Q_init,' to', Q_end

       if (present(StartDist)) then
          call EvolvePDF(dh, dist, &
               & coupling, Q_init, Q_end, muR_Q, nloop, untie_nf)
          tab%tab(:,:,i) = dist
       end if
       
       if (precalc_lcl) call EvolveGeneric(dh, &
            &coupling, Q_init, Q_end, evop=tab%evops(i), &
            &muR_Q = muR_Q, nloop = nloop, untie_nf = untie_nf)

       if (tab%nf_info_associated) tab%as2pi(i) = Value(coupling,Q_end)/twopi
       last_Q = Q_end
    end do
    

    if (present(StartDist)) dist = StartDist
    last_Q = StartScale
    !do i = ceiling(lnlnQ_norm_start), tab%nQ
    do i = iQ_hi, tab%nQ
       Q_init = last_Q
       Q_end = invlnln(tab,tab%lnlnQ_vals(i))
       !write(0,*) 'doing ev from ',Q_init,' to', Q_end

       !write(0,*) 'doing ev from ',Q_init,' to', Q_end
       if (present(StartDist)) then
          call EvolvePDF(dh, dist,&
               & coupling, Q_init, Q_end, muR_Q, nloop, untie_nf)
          tab%tab(:,:,i) = dist
       end if
       
       if (precalc_lcl) call EvolveGeneric(dh, &
            &coupling, Q_init, Q_end, evop=tab%evops(i), &
            &muR_Q = muR_Q, nloop = nloop, untie_nf = untie_nf)

       if (tab%nf_info_associated) tab%as2pi(i) = Value(coupling,Q_end)/twopi
       last_Q = Q_end
    end do
    
    if (present(StartDist)) deallocate(dist)
  end subroutine EvolvePdfTableGen


  !---------------------------------------------------------------------
  !! Routine for creating a QED evolution table. It assumes the tabulation
  !! has been set up with the correct size, etc.
  !!
  subroutine EvolvePdfTableQED(tab, StartScale, StartDist, dh, qed_sm, &
       & coupling_qcd, coupling_qed, &
       & nloop_qcd, nqcdloop_qed_arg, with_Plq_nnloqed)
    use qed_evolution; use qed_coupling_module; use qed_objects
    type(pdf_table),           intent(inout) :: tab
    real(dp),               intent(in)    :: StartScale
    type(dglap_holder),     intent(in)    :: dh
    type(qed_split_mat),    intent(in)    :: qed_sm
    type(running_coupling), intent(in)    :: coupling_qcd
    type(qed_coupling),     intent(in)    :: coupling_qed
    real(dp),               intent(in)    :: StartDist(:,:)
    integer,                intent(in)    :: nloop_qcd, nqcdloop_qed_arg
    logical,  optional,     intent(in)    :: with_Plq_nnloqed
    !logical,      optional, intent(in)    :: untie_nf
    !-----------------------------------------------------
    real(dp), allocatable :: dist(:,:)
    real(dp) :: lnlnQ_norm, lnlnQ, Q_init, Q_end, last_Q
    integer :: i, iQ_lo, iQ_hi

    lnlnQ = lnln(tab,StartScale)
    call request_iQrange(tab, lnlnQ, 1, iQ_lo, iQ_hi, lnlnQ_norm)
    tab%StartScale = StartScale
    tab%StartScale_iQlo = iQ_lo
    ! force this...
    iQ_hi = iQ_lo + 1

    allocate(dist(size(StartDist,1),size(StartDist,2)))
    dist = StartDist
    
    last_Q = StartScale
    !do i = floor(lnlnQ_norm_start), 0, -1
    do i = iQ_lo, 0, -1
       Q_init = last_Q
       Q_end = invlnln(tab,tab%lnlnQ_vals(i))

       call QEDQCDEvolvePDF(dh, qed_sm, dist, coupling_qcd, coupling_qed,&
                   &        Q_init, Q_end, nloop_qcd, nqcdloop_qed_arg, with_Plq_nnloqed)
       tab%tab(:,:,i) = dist
       
       last_Q = Q_end
    end do

    dist = StartDist
    last_Q = StartScale
    do i = iQ_hi, tab%nQ
       Q_init = last_Q
       Q_end = invlnln(tab,tab%lnlnQ_vals(i))
       call QEDQCDEvolvePDF(dh, qed_sm, dist, coupling_qcd, coupling_qed,&
                   &        Q_init, Q_end, nloop_qcd, nqcdloop_qed_arg, with_Plq_nnloqed)
       tab%tab(:,:,i) = dist
       
       last_Q = Q_end
    end do
    
    deallocate(dist)
  end subroutine EvolvePdfTableQED

  !--------------------------------------------------------------------
  !! Override all tables' default interpolation orders (which are
  !! normally set by the grid and the olnlnQ in the table constructor)
  !!
  !! Either both orders should be >0 or both negative (negative means
  !! use the table's defaults)
  !!
  !! Specific settings give significant speed improvements. Currently:
  !! (2,2), (3,3) and (4,4), because these correspond to cases where
  !! there are specific routines with hard-coded orders
  subroutine PdfTableOverrideInterpOrders(yorder, lnlnQorder)
    integer, intent(in) :: yorder, lnlnQorder

    if (yorder * lnlnQorder <= 0) call wae_error("PdfTableOverrideInterpOrders: both orders must be >0 or <0")

    if (yorder <= 0) then
      override_order_y = -1
      override_npnt_y  = -1
    else
      override_order_y = yorder
      override_npnt_y  = yorder + 1
    end if

    override_order_Q = lnlnQorder
    if (override_order_Q <= 0) override_order_Q = -1

    ! it's enough for one to be >0 for override to be turned on
    override_on = (override_order_y > 0 .or. override_order_Q > 0)

    ! this will only set pointers if there is a hard-coded routine for
    ! the override; if either of the overrides <=0, then no pointers
    ! are set, consistent with override_on being .false.
    call PdfTableSetInterpPointers(override_order_y, override_order_Q, &
                                   EvalPdfTable_yQ_ptr, EvalPdfTable_yQf_ptr, EvalPdfTable1D_yQ_ptr)
  end subroutine PdfTableOverrideInterpOrders

  !--------------------------------------------------------------------
  !! Set up the pointers if we have a hard-coded routine for this specific
  !! order_y and order_Q, otherwise set them to null.
  subroutine PdfTableSetInterpPointers(order_y, order_Q, yQ_ptr, yQf_ptr, t1D_yQ_ptr)
    integer, intent(in) :: order_y, order_Q
    procedure(EvalPdfTable_yQ_interface ), pointer, intent(out) :: yQ_ptr
    procedure(EvalPdfTable_yQf_interface), pointer, intent(out) :: yQf_ptr
    procedure(EvalPdfTable1D_yQ_interface), pointer, intent(out) :: t1D_yQ_ptr

    if      (order_y == 2 .and. order_Q == 2) then
      yQ_ptr  => EvalPdfTable_yQ_order22
      yQf_ptr => EvalPdfTable_yQf_order22
      t1D_yQ_ptr => EvalPdfTable1D_yQ_order22
    else if (order_y == 3 .and. order_Q == 3) then
      yQ_ptr  => EvalPdfTable_yQ_order33
      yQf_ptr => EvalPdfTable_yQf_order33
      t1D_yQ_ptr => EvalPdfTable1D_yQ_order33
    else if (order_y == 4 .and. order_Q == 4) then
      yQ_ptr  => EvalPdfTable_yQ_order44
      yQf_ptr => EvalPdfTable_yQf_order44
      t1D_yQ_ptr => EvalPdfTable1D_yQ_order44
    else if (order_y == 5 .and. order_Q == 4) then
      yQ_ptr  => EvalPdfTable_yQ_order54
      yQf_ptr => EvalPdfTable_yQf_order54
      t1D_yQ_ptr => EvalPdfTable1D_yQ_order54
    else if (order_y == 6 .and. order_Q == 4) then
      yQ_ptr  => EvalPdfTable_yQ_order64
      yQf_ptr => EvalPdfTable_yQf_order64
      t1D_yQ_ptr => EvalPdfTable1D_yQ_order64
    else
      yQ_ptr  => null()
      yQf_ptr => null()
      t1D_yQ_ptr => null()
    end if
  end subroutine PdfTableSetInterpPointers

  
  !--------------------------------------------------------------------
  !! Sets the vector val(iflv_min:) for the PDF at this
  !! y=ln1/x,Q.
  !!
  !! If this is a standard QCD table then entries val(iflv_min:iflv_max)
  !! get set.
  !!
  !! If this is a generalised table, then val(:) should be as big as
  !! the number of flavours in the table and all will get set
  !! (including the "representation" flavour).
  subroutine EvalPdfTable0D_yQ(tab,y,Q,val)
    type(pdf_table), intent(in), target :: tab
    real(dp),     intent(in) :: y, Q
    real(dp),    intent(out) :: val(iflv_min:)
    !----------------------------------------
    real(dp) :: lnlnQ_wgts(0:max_lnlnQ_order)
    real(dp) :: y_wgts(0:WeightGridQuand_npnt_max-1)
    real(dp) :: wgts(0:WeightGridQuand_npnt_max-1,0:max_lnlnQ_order)
    integer :: ilnlnQ_lo, ilnlnQ_hi, nQ,iylo, iQ, iflv, iflv_max_table, npnt_y
    integer, save :: warn_id = 4!warn_id_INIT    

    if (ubound(val,dim=1) < tab%tab_iflv_max) call wae_error('pdftab_ValTab',&
         &'upper bound of val is too low', intval=ubound(val,dim=1))

    if (associated(EvalPdfTable_yQ_ptr)) then
      call EvalPdfTable_yQ_ptr(tab,y,Q,val)
    else if (associated(tab%EvalPdfTable_yQ_ptr) .and. (.not. override_on)) then
      call tab%EvalPdfTable_yQ_ptr(tab,y,Q,val)
    else
      call wae_warn(warn_id, "EvalPdfTable_yQ: y & Q interpolation orders not available hard-coded, reverting to slower routine")
      call EvalPdfTable_yQ_any_order(tab,y,Q,val)      
    end if
    
  end subroutine EvalPdfTable0D_yQ

  subroutine EvalPdfTable1D_xQ(tab,x,Q,val)
    type(pdf_table), intent(in), target :: tab(:)
    real(dp),     intent(in) :: x, Q
    real(dp),    intent(out) :: val(iflv_min:,:)
    call EvalPdfTable1D_yQ(tab, -log(x), Q, val)
  end subroutine EvalPdfTable1D_xQ
    
  !! Sets the vector val(iflv_min:,:) at this
  !! y=ln1/x,Q, for a set of tables (e.g. error members of
  !! a PDF set)
  subroutine EvalPdfTable1D_yQ(tab,y,Q,val)
    type(pdf_table), intent(in), target :: tab(:)
    real(dp),     intent(in) :: y, Q
    real(dp),    intent(out) :: val(iflv_min:,:)
    !----------------------------------------
    !real(dp) :: lnlnQ_wgts(0:max_lnlnQ_order)
    !real(dp) :: y_wgts(0:WeightGridQuand_npnt_max-1)
    !real(dp) :: wgts(0:WeightGridQuand_npnt_max-1,0:max_lnlnQ_order)
    !integer :: ilnlnQ_lo, ilnlnQ_hi, nQ,iylo, iQ, iflv, iflv_max_table, npnt_y
    integer, save :: warn_id = 4!warn_id_INIT    
    integer :: itab

    if (ubound(val,dim=1) < tab(1)%tab_iflv_max) call wae_error('pdftab_ValTab',&
         &'upper bound of val is too low', intval=ubound(val,dim=1))
    if (size(val,2) < size(tab)) then
      call wae_error("EvalPdfTable1D_yQ","size of res second dim is smaller than tab array, size(res,2)=",intval=size(val,2))
    end if


    if (associated(EvalPdfTable1D_yQ_ptr)) then
      call EvalPdfTable1D_yQ_ptr(tab,y,Q,val)
    else if (associated(tab(1)%EvalPdfTable_yQ_ptr) .and. (.not. override_on)) then
      do itab = 2, size(tab)
         if (.not. associated(tab(itab)%EvalPdfTable_yQ_ptr, tab(1)%EvalPdfTable_yQ_ptr)) then
            call wae_error("EvalPdfTable1D_yQ","not all tables have EvalPdfTable_yQ_ptr associated")
         end if
      end do
      call tab(1)%EvalPdfTable1D_yQ_ptr(tab,y,Q,val)
    else
      call wae_warn(warn_id, "EvalPdfTable1D_yQ: y & Q interpolation orders not available hard-coded, reverting to slower routine")

      do itab = 1, size(tab)
         call EvalPdfTable_yQ_any_order(tab(itab),y,Q,val(:,itab))      
      end do
    end if
    
  end subroutine EvalPdfTable1D_yQ


  !! subsidiary routine that handles arbitrary interpolation orders.
  !! Note that this is quite a bit slower than the specialized versions
  !! (order2, etc.)
  subroutine EvalPdfTable_yQ_any_order(tab,y,Q,val)
    type(pdf_table), intent(in), target :: tab
    real(dp),     intent(in) :: y, Q
    real(dp),    intent(out) :: val(iflv_min:)
    !----------------------------------------
    real(dp) :: lnlnQ_wgts(0:max_lnlnQ_order)
    real(dp) :: y_wgts(0:WeightGridQuand_npnt_max-1)
    real(dp) :: wgts(0:WeightGridQuand_npnt_max-1,0:max_lnlnQ_order)
    integer :: ilnlnQ_lo, ilnlnQ_hi, nQ,iylo, iQ, iflv, iflv_max_table, npnt_y
    integer, save :: warn_id = warn_id_INIT    

    !-- y weights taken care of elsewhere....
    call WgtGridQuant_noalloc(tab%grid, y, iylo, y_wgts, npnt_y, npnt_in = override_npnt_y)

    !-- new routine for getting Q weights; ilnlnQ_lo > ilnlnQ_hi is the
    !   signal for Q being out of range
    call get_lnlnQ_wgts(tab, Q, lnlnQ_wgts(0:tab%lnlnQ_order), ilnlnQ_lo, ilnlnQ_hi)
    nQ = ilnlnQ_hi - ilnlnQ_lo

    ! diagnostics
    !print *, "any_order: Q weights:", lnlnQ_wgts(0:nQ), ilnlnQ_lo
    !print *, "any_order: y weights:", y_wgts(0:npnt_y-1), iylo

    !-- is this order more efficient, or should we not bother to
    !   calculate wgts? Not calculating it would imply significantly
    !   more operations, so probably good to stay as is
    !
    ! we specialise certain specific cases, because this appears to
    ! help the compiler with its optimisation.
    ! 
    ! timings below done 2024-11-29, on MacM2 gfortran-14.2 -O3 with 
    ! prec_and_timing -nrep 1 -nxQ 5000 -outputgrid -dy 0.05 -order -6 -nopreev -4grids -dlnlnQ 0.01 -du 0.01 -olnlnQ 2 -yinterp 2 -nrep-eval 10000000
    !
    ! (NB: nQ == olnlnQ ; npnt_y == y interpolation order + 1; so cubic -olnlnQ 3 -yinterp 3  gives npnt_y == 4, nQ==3, which means 4 actual points for each...)
    if (npnt_y == 4 .and. nQ == 3) then
      ! ! specialising this saves about 4ns (M2Pro -O3)
      ! do iQ = 0, 3
      !    wgts(:npnt_y-1,iQ) = y_wgts(0:npnt_y-1) * lnlnQ_wgts(iQ)
      ! end do
      ! !! 110ns/call with this specialisation (M2Pro)   -> 186ns/call with -O2 -g (RelWithDebInfo)
      ! !! 165ns/call without this specialisation
      ! do iflv = iflv_min, tab%tab_iflv_max
      !    val(iflv) = sum(wgts(0:3,0:3) &
      !                    * tab%tab(iylo:iylo+3, iflv,ilnlnQ_lo:ilnlnQ_lo+3))
      ! end do

      !! 2025-09-03 (GPS+AK): this variant seems to be the fastest, saving a further 10ns (M2Pro,O3)
      !!                      getting it to about 99ns
      !! Note that further unrolling the loop manually didn't seem to bring any advantages
      do iflv = iflv_min, tab%tab_iflv_max
        val(iflv) = sum(y_wgts(0:3) * tab%tab(iylo:iylo+3, iflv,ilnlnQ_lo  )) * lnlnQ_wgts(0) &
                +   sum(y_wgts(0:3) * tab%tab(iylo:iylo+3, iflv,ilnlnQ_lo+1)) * lnlnQ_wgts(1) &
                +   sum(y_wgts(0:3) * tab%tab(iylo:iylo+3, iflv,ilnlnQ_lo+2)) * lnlnQ_wgts(2) &
                +   sum(y_wgts(0:3) * tab%tab(iylo:iylo+3, iflv,ilnlnQ_lo+3)) * lnlnQ_wgts(3) 
      end do
    else if (npnt_y == 3 .and. nQ == 2) then
      !do iQ = 0, 2
      !   wgts(0:2,iQ) = y_wgts(0:2) * lnlnQ_wgts(iQ)
      !end do
      !  85ns/call with this specialisation    -> 150ns/call with -O2 -g (RelWithDebInfo)
      ! 123ns/call without this specialisation -> 160ns/call with -O2 -g (RelWithDebInfo)
      !do iflv = iflv_min, tab%tab_iflv_max
      !      val(iflv) = sum(wgts(0:2,0:2) &
      !                      * tab%tab(iylo:iylo+2, iflv,ilnlnQ_lo:ilnlnQ_lo+2))
      !end do
      !! 2025-09-03 (GPS+AK): the following variant shaves off a further couple of percent
      do iflv = iflv_min, tab%tab_iflv_max
        val(iflv) = sum(y_wgts(0:2) * tab%tab(iylo:iylo+2, iflv,ilnlnQ_lo  )) * lnlnQ_wgts(0) &
                +   sum(y_wgts(0:2) * tab%tab(iylo:iylo+2, iflv,ilnlnQ_lo+1)) * lnlnQ_wgts(1) &
                +   sum(y_wgts(0:2) * tab%tab(iylo:iylo+2, iflv,ilnlnQ_lo+2)) * lnlnQ_wgts(2) 
      end do
    else
      do iQ = 0, nQ
         wgts(:npnt_y-1,iQ) = y_wgts(0:npnt_y-1) * lnlnQ_wgts(iQ)
      end do
      ! 250ns/call with olnlnQ==4 and yinterp==6 -> 290ns/call with -O2 -g (RelWithDebInfo)
      do iflv = iflv_min, tab%tab_iflv_max
          val(iflv) = sum(wgts(0:npnt_y-1,0:nQ) &
                          * tab%tab(iylo:iylo+npnt_y-1, iflv,ilnlnQ_lo:ilnlnQ_hi))
      end do
       !write(0,*) ilnlnQ_lo, ilnlnQ_hi, real(lnlnQ_wgts), val(1)
   end if
    
  end subroutine EvalPdfTable_yQ_any_order

  !--------------------------------------------------------------------
  !! Sets the vector val(iflv_min:) for the PDF at this
  !! y=ln1/x,Q.
  !!
  !! If this is a standard QCD table then entries val(iflv_min:iflv_max)
  !! get set.
  !!
  !! If this is a generalised table, then val(:) should be as big as
  !! the number of flavours in the table and all will get set
  !! (including the "representation" flavour).
  function EvalPdfTable_yQf(tab,y,Q,iflv) result(val)
   type(pdf_table), intent(in), target :: tab
   real(dp),     intent(in) :: y, Q
   integer,      intent(in) :: iflv
   real(dp)                 :: val
   !----------------------------------------
   !real(dp), allocatable :: wgts(:,:)
   !real(dp) :: lnlnQ_wgts(0:tab%lnlnQ_order)
   real(dp) :: lnlnQ_wgts(0:max_lnlnQ_order)
   real(dp) :: y_wgts(0:WeightGridQuand_npnt_max-1)
   integer :: ilnlnQ_lo, ilnlnQ_hi, nQ,iylo, iQ, npnt_y
   integer, save :: warn_id = 5
   real(dp) :: wgts(0:WeightGridQuand_npnt_max-1,0:max_lnlnQ_order)    

   if (iflv > tab%tab_iflv_max) call wae_error('pdftab_ValTab',&
        &'iflv is too high', intval=iflv)
   if (iflv < iflv_min) call wae_error('pdftab_ValTab',&
        &'iflv is too low', intval=iflv)

   if (associated(EvalPdfTable_yQf_ptr)) then
     val = EvalPdfTable_yQf_ptr(tab,y,Q,iflv)
     return
   else if (associated(tab%EvalPdfTable_yQf_ptr) .and. (.not. override_on)) then
     val = tab%EvalPdfTable_yQf_ptr(tab,y,Q,iflv)
     return
   end if

   call wae_warn(warn_id, "EvalPdfTable_yQf: y & Q interpolation orders not available hard-coded, reverting to slower routine")

   !-- y weights taken care of elsewhere....
   call WgtGridQuant_noalloc(tab%grid, y, iylo, y_wgts, npnt_y, override_npnt_y)

   !-- new routine for getting Q weights; ilnlnQ_lo > ilnlnQ_hi is the
   !   signal for Q being out of range
   call get_lnlnQ_wgts(tab, Q, lnlnQ_wgts(0:tab%lnlnQ_order), ilnlnQ_lo, ilnlnQ_hi)
   nQ = ilnlnQ_hi - ilnlnQ_lo

   !write(6,*) "general: iylo = ", iylo, "y_wgts = ", y_wgts(0:npnt_y-1)
   !write(6,*) "general: ilnlnQ = ", ilnlnQ_lo, "lnlnQ_wgts = ", lnlnQ_wgts(0:nQ)
   !write(6,*) "general: Qvals = ", tab%Q_vals(ilnlnQ_lo:ilnlnQ_hi)


   ! 2024-11-29 (Mac M2, gfortran 14.2) explored various options here,
   ! including going via a 2D wgts vector, and having an if statement to
   ! choose between versions with hard-coded limits for specific npnt_y
   ! and nQ values (as in EvalPdfTable_yQ). The conclusion is that
   ! within measurement error, the simple code below remains about as
   ! efficient as anything else (if not more so, by O(5-10%)).
   val = zero
   do iQ = 0, nQ
         val = val + lnlnQ_wgts(iQ) * sum(y_wgts(0:npnt_y-1) * &
             & tab%tab(iylo:iylo+npnt_y-1, iflv,ilnlnQ_lo+iQ))
   end do
 
  end function EvalPdfTable_yQf

  !----------------------------------------------------------------
  !! sets the vector val(iflv_min:iflv_max) for the PDF at this x,Q.
  subroutine EvalPdfTable0D_xQ(tab,x,Q,val)
    type(pdf_table), intent(in), target :: tab
    real(dp),     intent(in) :: x, Q
    real(dp),    intent(out) :: val(iflv_min:)
    call EvalPdfTable_yQ(tab,-log(x),Q,val)
  end subroutine EvalPdfTable0D_xQ

  !----------------------------------------------------------------
  !! sets the vector val(iflv_min:iflv_max) for the PDF at this x,Q.
  function EvalPdfTable_xQf(tab,x,Q,iflv) result(val)
    type(pdf_table), intent(in), target :: tab
    real(dp),     intent(in) :: x, Q
    integer,      intent(in) :: iflv
    real(dp) :: val
    val = EvalPdfTable_yQf(tab,-log(x),Q,iflv)
  end function EvalPdfTable_xQf

  ! 2025-09-08 attempt to explore potential for speedup in PDF
  ! evaluation when we hard-code and inline as much as possible
  function EvalPdfTable_yQf_order2_hc(tab,y,Q,iflv) result(val)
    use interpolation_coeffs
    type(pdf_table), intent(in), target :: tab
    real(dp),        intent(in)         :: y, Q
    integer,         intent(in)         :: iflv
    real(dp)                            :: val
    !----------------------------------------
    integer, parameter :: NN = 2, halfNN=0
    real(dp) :: y_wgts(0:NN), lnlnQ_wgts(0:NN), lnlnQ
    integer  :: i_nf, iylo, ilnlnQ, igd
    real(dp) :: ynorm, lnlnQ_norm
    type(grid_def),   pointer :: subgd
    type(pdfseginfo), pointer :: seginfo

    !------ First deal with the y interpolation ------
    ! For now, to get a sense of the maximal possible speed, we 
    ! assume we have a standard 4-part locked grid -- we will revisit this later
    ! once we have a better picture of speed
    ! With that assumption, we know tab%grid%subgd(4) has largest ymax
    if (y > tab%grid%subgd(4)%ymax .or. y < 0) then
      call wae_error("EvalPdfTable_yQf_order2","y did not satisfy 0 <= y <= ymax, with y=",dbleval=y)
    endif
    do igd = 4, 2, -1
      if (y > tab%grid%subgd(igd-1)%ymax) exit
    end do

    subgd => tab%grid%subgd(igd)
    ynorm = y / subgd%dy
    iylo = int(ynorm) - halfNN
    if (iylo < 0) iylo = 0
    if (iylo + NN > subgd%ny) iylo = subgd%ny - NN
    call fill_interp_weights2(ynorm - iylo, y_wgts)
    iylo = iylo + tab%grid%subiy(igd)

    !----- next deal with the Q interpolation
    lnlnQ = lnln(tab,Q)
    if (lnlnQ < tab%lnlnQ_min) then
      lnlnQ = tab%lnlnQ_min
    else if (lnlnQ > tab%lnlnQ_max) then
      call wae_error("EvalPdfTable_yQf_order2","Q was too large",dbleval=Q)
    endif
    if (.not. tab%nf_info_associated) call wae_error("EvalPdfTable_yQf_order2",&
         &"tab%nf_info_associated was not set")
    do i_nf = tab%nflo, tab%nfhi-1
      if (lnlnQ < tab%seginfo(i_nf)%lnlnQ_lo) exit
    end do

    seginfo => tab%seginfo(i_nf)
    lnlnQ_norm = (lnlnQ - seginfo%lnlnQ_lo) / seginfo%dlnlnQ
    if (seginfo%ilnlnQ_hi - seginfo%ilnlnQ_lo < NN) then
      call wae_error("EvalPdfTable_yQf_order2","not enough points in Q segment")
    end if
    ilnlnQ = int(lnlnQ_norm) + seginfo%ilnlnQ_lo - halfNN
    if (ilnlnQ    < seginfo%ilnlnQ_lo) ilnlnQ = seginfo%ilnlnQ_lo
    if (ilnlnQ+NN > seginfo%ilnlnQ_hi) ilnlnQ = seginfo%ilnlnQ_hi - NN
    call fill_interp_weights2(lnlnQ_norm - (ilnlnQ-seginfo%ilnlnQ_lo), lnlnQ_wgts)

    val = sum(tab%tab(iylo:iylo+NN, iflv,ilnlnQ  ) * y_wgts) * lnlnQ_wgts(0) &
        + sum(tab%tab(iylo:iylo+NN, iflv,ilnlnQ+1) * y_wgts) * lnlnQ_wgts(1) &
        + sum(tab%tab(iylo:iylo+NN, iflv,ilnlnQ+2) * y_wgts) * lnlnQ_wgts(2)
  end function EvalPdfTable_yQf_order2_hc

  !! given a table and a y value, sets up a pointer (grid_ptr) to the relevant
  !! grid or sub-grid, as well as the iy_offset to the start of that grid
  !! in the y dimension of the table.
  !!
  !! Note that this function overlaps substantially with conv_BestISub,
  !! Because of its location it can be inlined in other pdf_tabulate.f90 
  !! routines, which gives a small but relevant speed advantage
  subroutine tab_get_grid_ptr(tab, y, grid_ptr, iy_offset)
    type(pdf_table), intent(in), target :: tab
    real(dp), intent(in) :: y
    type(grid_def), pointer :: grid_ptr
    integer, intent(out) :: iy_offset
    !----------------------------------------
    type(grid_def), pointer :: grid
    integer :: igd

    grid => tab%grid
    ! note that relative to conv_BestIsub, we bail out if we are
    ! beyond grid%ymax
    if (y > grid%ymax .or. y < 0) then
      call wae_error("tab_get_grid_ptr","y did not satisfy 0 <= y <= ymax, with y=",dbleval=y)
    endif

    if (associated(grid%subgd)) then
      if (grid%locked) then
        do igd = size(grid%subgd), 2, -1
          if (y > grid%subgd(igd-1)%ymax) exit
        end do
      else
        igd = minloc(grid%subgd%ymax,dim=1,mask=(grid%subgd%ymax>=y))
      end if
      grid_ptr => grid%subgd(igd)
      iy_offset = grid%subiy(igd)
    else
      grid_ptr => grid
      iy_offset = 0
    endif
  end subroutine tab_get_grid_ptr

  !subroutine tab_get_seginfo_ptr(tab, lnlnQ, seginfo_ptr)
  !  type(pdf_table), intent(in), target :: tab
  !  real(dp),        intent(inout)      :: lnlnQ
  !  type(pdfseginfo), pointer           :: seginfo_ptr
  !  !----------------------------------------
  !  integer :: i_nf
  !
  !  if (lnlnQ < tab%lnlnQ_min) then
  !    lnlnQ = tab%lnlnQ_min
  !  else if (lnlnQ > tab%lnlnQ_max) then
  !    call wae_error("EvalPdfTable_yQ_orderNNNN","Q was too large",dbleval=invlnln(tab,lnlnQ))
  !  endif
  !  if (.not. tab%nf_info_associated) then
  !    seginfo_ptr => tab%seginfo_no_nf
  !  else
  !    do i_nf = tab%nflo, tab%nfhi-1
  !      if (lnlnQ < tab%seginfo(i_nf)%lnlnQ_lo) exit
  !    end do
  !    seginfo_ptr => tab%seginfo(i_nf)
  !  end if
  !end subroutine tab_get_seginfo_ptr

  ! the following code loads the appropriate PDF evaluation subroutine
  ! with the order hard-coded to NNNN
#define __HOPPET_InterpOrder__ 2
#include "inc/pdf_tabulate_OrderNNN.F90"

#define __HOPPET_InterpOrder__ 3
#include "inc/pdf_tabulate_OrderNNN.F90"

#define __HOPPET_InterpOrder__ 4
#include "inc/pdf_tabulate_OrderNNN.F90"

#define __HOPPET_InterpOrderY__ 5
#define __HOPPET_InterpOrderQ__ 4
#include "inc/pdf_tabulate_OrderNNN.F90"

#define __HOPPET_InterpOrderY__ 6
#define __HOPPET_InterpOrderQ__ 4
#include "inc/pdf_tabulate_OrderNNN.F90"

  !--------------------------------------------------------------------
  !! Sets the pdf(0:iflv_min:) for the PDF at this value of Q.
  !!
  subroutine EvalPdfTable_Q(tab,Q,pdf)
    type(pdf_table), intent(in) :: tab
    real(dp),    intent(in)  :: Q
    real(dp),    intent(out) :: pdf(0:,iflv_min:)
    !-----------------------------------------------
    real(dp) :: lnlnQ_wgts(0:tab%lnlnQ_order)
    integer  :: ilnlnQ_lo, ilnlnQ_hi
    integer  :: iQ

    ! safety checks
    if (tab%grid%ny /= ubound(pdf,dim=1) .or.&
         & ubound(pdf,dim=2) /= ubound(tab%tab,dim=2)) call wae_error("EvalPdfTable_Q",&
         & "pdf argument was not of size consistent with the table")

    !-- new routine for getting Q weights; ilnlnQ_lo > ilnlnQ_hi is the
    !   signal for Q being out of range
    call get_lnlnQ_wgts(tab, Q, lnlnQ_wgts, ilnlnQ_lo, ilnlnQ_hi)
    if (ilnlnQ_lo > ilnlnQ_hi) then
      pdf = zero
      return
    end if

    ! by setting the pdf to zero we will then get whatever representation
    ! is implicity in the table once we do the additions
    pdf(:,:) = zero
    do iQ = ilnlnQ_lo, ilnlnQ_hi
       pdf(:,:) = pdf(:,:) + lnlnQ_wgts(iQ-ilnlnQ_lo) * tab%tab(:, : ,iQ)
    end do
    
  end subroutine EvalPdfTable_Q

  !----------------------------------------------------------------------
  !! Write a PDF table to an LHAPDF-format file, i.e. the .dat files
  !! used by LHAPDF
  !!
  !! - table: the pdf_table object that is to be written
  !!
  !! - coupling: the coupling object associated with this table
  !! 
  !! - basename: the basename of the LHAPDF file; the full name
  !!   will be basename_nnnn.dat, where nnnn is given by pdf_index.
  !!   
  !! - pdf_index is the index that will be used for the LHAPDF .dat file
  !!   If it is zero, the routing will also output the .info file and
  !!   and the .dat will be declared a central member; otherwise 
  !!   the .dat file will be declared an error member.
  !!
  !! - iy_increment (optional, default 1):
  !!   * anything positive: chooses the x-points based on table's own
  !!     grid; the value indicates the increment to use in going up in y.
  !!     The essence of the rule is that every time y goes up and iy has
  !!     gone up by at least iy_increment, it outputs an x point.
  !!   * -1: uses a fixed distribution of x points with a coarse ln x spacing
  !!     at small x, and a finer spacing at larger x. LHAPDF's resulting interpolation
  !!     accuracy should be about $10^{-4}$ for $x<0.5$, $10^{-3}$ for $x<0.9$
  !!
  !! - flav_indices (optional): indicates which indices to use from the PDF table
  !!
  !! - flav_pdg_ids (optional): indicates the corresponding PDG IDs
  !!
  !! - flav_rescale (optional): specifies by how much each flavour should be
  !!   rescaled (usually by one, unless you want to use an entry that
  !!   has a sum of flavour and anti-flavour and so rescale by 50% to get
  !!   just the flavour)
  !!
  !! If flav_indices and flav_pdg_ids are not supplied, these are chosen
  !! by establishing whether the table has photons and leptons based on the
  !! the upper bound of the table's flavour index dimension.
  !!
  subroutine WriteLHAPDFFromPdfTable(table, coupling, basename, pdf_index, &
                                 & iy_increment, &
                                 & flav_indices, flav_pdg_ids, flav_rescale)                                
    use qed_objects
    type(pdf_table), target, intent(in) :: table
    type(running_coupling), intent(in) :: coupling
    character(len=*),       intent(in) :: basename
    integer,                intent(in) :: pdf_index
    integer,  optional,     intent(in) :: iy_increment
    integer,  optional,     intent(in) :: flav_indices(:), flav_pdg_ids(:)
    real(dp), optional,     intent(in) :: flav_rescale(:)
    !------------------------------------
    integer          :: dat_unit, info_unit
    character(len=4) :: pdf_index_str
    character(len=:), allocatable :: dat_file, info_file
    real(dp) :: flavs(lbound(table%tab,2):ubound(table%tab,2))
    real(dp) :: xVals_orig(0:table%grid%ny), val, yVal
    real(dp) :: zeta, zetamax, dzeta
    ! these parameters appear to give OK accuracy, <=10^{-4} for x<0.5
    ! and <=10^{-3} for x<0.9, at least for Q=100
    real(dp), parameter :: dzeta_def = 0.30_dp, zeta_a = 10.0_dp, zeta_b = 5.0_dp
    integer  :: iyVals(0:table%grid%ny), nx, nx_max, iy, ix, iQ, iseg, iQlo, iQhi, ipdg, iflv
    type(pdfseginfo), pointer :: seginfos(:)
    integer  :: iy_inc, i

    integer,  allocatable :: lcl_flav_indices(:), lcl_flav_pdg_ids(:)
    real(dp), allocatable :: lcl_flav_rescale(:)
    ! for choosing the xvalues output
    real(dp), allocatable :: xVals_tmp(:), xVals(:)

    iy_inc = default_or_opt(1, iy_increment)

    if (present(flav_indices)) then
      if (.not. present(flav_pdg_ids)) call wae_error("WritePdfTableLHAPDF",&
                                    "flav_pdg_ids must be present if flav_indices is present")
      lcl_flav_indices = flav_indices
      lcl_flav_pdg_ids = flav_pdg_ids
    else
      if (present(flav_pdg_ids) .or. present(flav_rescale)) then
        call wae_error("WritePdfTableLHAPDF","flav_pdg_ids and flav_rescale must not be present if flav_indices is not present")
     end if
     !print*, "Entered here", ubound(table%tab,2), ncompmax, ncompmaxPhoton, ncompmaxLeptons
      if (ubound(table%tab,2) == ncompmax) then
        lcl_flav_indices = (/-6,-5,-4,-3,-2,-1, 0,1,2,3,4,5,6/)
        lcl_flav_pdg_ids = (/-6,-5,-4,-3,-2,-1,21,1,2,3,4,5,6/)
      else if (ubound(table%tab,2) == ncompmaxPhoton) then
        lcl_flav_indices = (/-6,-5,-4,-3,-2,-1, 0,1,2,3,4,5,6, 8/)
        lcl_flav_pdg_ids = (/-6,-5,-4,-3,-2,-1,21,1,2,3,4,5,6,22/)
      else if (ubound(table%tab,2) == ncompmaxLeptons) then
        ! recall that our internal representation has 
        lcl_flav_indices = (/-6,-5,-4,-3,-2,-1, 0,1,2,3,4,5,6, 8,&
             & iflv_tau, iflv_muon, iflv_electron, iflv_electron,&
             & iflv_muon, iflv_tau/)
        lcl_flav_pdg_ids = (/-6,-5,-4,-3,-2,-1,21,1,2,3,4,5,6,22,    &
             &  -15,       -13,           -11,            11,       &
             & 13,       15/)
        lcl_flav_rescale = (/ (one, i=1,14), half, half, half, half,&
             & half, half/)
      end if

    end if
    if (present(flav_rescale)) lcl_flav_rescale = flav_rescale

    write(pdf_index_str,'(i4.4)') pdf_index
    dat_unit = 0
    dat_file = trim(basename)//"_"//pdf_index_str//'.dat'
    open(newunit=dat_unit, file=dat_file, status='replace')
    if (dat_unit == 0) call wae_error("WritePdfTableLHAPDF","Could not open "//dat_file)
    write(6,'(a)') "# Writing LHAPDF dat file "//trim(dat_file)

    ! First work out what x values to use.
    ! In this simple version, we simply take the grid points (eliminating duplications)
    xVals_orig = xValues(table%grid)
    write(dat_unit,'(a)') "# data file generated by HOPPET"
    write(dat_unit,'(a,i4,a,f10.5)') '# iy_increment = ', iy_inc, ", dy(base) = ", table%grid%dy
    if (iy_inc > 0) then
      xVals_tmp = MonotonicUniqueXValues(table%grid)
      nx = size(xVals_tmp) / iy_inc
      nx_max = nx
      ! make sure we go all the way to the lowest point in x
      if (nx * iy_inc < size(xVals_tmp)) nx_max = nx + 1
      allocate(xVals(1:nx_max))
      xVals(1:nx) = xVals_tmp(::iy_inc)
      if (nx < nx_max) xVals(nx_max) = xVals_tmp(ubound(xVals_tmp,1))
    !else if (iy_inc == 0) then
    !  ! use the PDF4LHC15 points; note that we need to reverse their order
    !  do iy = size(pdf4lhc_yvalues), 1, -1
    !     yVal = pdf4lhc_yvalues(iy)
    !     if (yVal < table%grid%ymax) then
    !        nx_max = nx_max + 1
    !        xVals(nx_max) = exp(-yVal)
    !     end if
    !  end do
    !  ! finish off with the last grid point
    !  nx_max = nx_max + 1
    !  xVals(nx_max) = exp(-table%grid%ymax)
    else if (iy_inc == -1) then
      write(dat_unit,'(a,f10.5,a,f10.5,a,f10.5)') &
          & '# dzeta_def = ', dzeta_def,&
          & ', zeta_a = ', zeta_a,&
          & ', zeta_b = ', zeta_b

      ! use our own smoothly changing spacing
      zetamax = zetaext_of_y(table%grid%ymax, zeta_a, zeta_b)
      nx_max = ceiling(zetamax/dzeta_def)
      dzeta = zetamax / nx_max
      allocate(xVals(0:nx_max))
      do ix = 0, nx_max
        xVals(ix) = exp(-y_of_zetaext(dzeta*ix, zeta_a, zeta_b))
      end do
    else
      call wae_error('WritePdfTableLHAPDF','value of iy_increment could not be handled; it was',&
          &intval = iy_inc)
    end if
    
    !write(0,*) 'nx = ', nx_max+1, ', nQ = ', size(table%Q_vals)

    ! the official header
    write(dat_unit,'(a,a)') 'PdfType: ',trim(merge("central","error  ",pdf_index==0))!trim(pdf_type)
    write(dat_unit,'(a)'  ) 'Format: lhagrid1'
    write(dat_unit,'(a)'  ) '---'

    ! handle different seginfo scenarios
    if (table%nf_info_associated) then
       ! if the table has seginfo, then just point to it
       seginfos => table%seginfo
    else
       ! otherwise create a fictitious seginfo with the info we need...
       allocate(seginfos(1:1))
       seginfos(1)%ilnlnQ_lo = lbound(table%Q_vals,1)
       seginfos(1)%ilnlnQ_hi = ubound(table%Q_vals,1)
    end if

    ! now loop over the actual or "invented" seginfos
    do iseg = lbound(seginfos,1), ubound(seginfos,1)
       ! first we output info about x structure, Q structure and flavours
       write(dat_unit,'(4000es14.7)') xVals(ubound(xVals,1):lbound(xVals,1):-1)
       iQlo = seginfos(iseg)%ilnlnQ_lo
       iQhi = seginfos(iseg)%ilnlnQ_hi
       write(dat_unit,'(4000es14.7)') table%Q_vals(iQlo:iQhi)
       write(dat_unit,'(100i4)')      lcl_flav_pdg_ids

       ! then write out the PDF itself
       ! Note that LHAPDF wants _increasing_ x values
       do ix = ubound(xVals,1), lbound(xVals,1), -1
          do iQ = iQlo, iQhi
             flavs = table%tab(:,:,iQ) .atx. (xVals(ix).with.table%grid)
             do ipdg = 1, ubound(lcl_flav_pdg_ids,1)
                val = flavs(lcl_flav_indices(ipdg))
                !print*, val, lcl_flav_rescale(ipdg), lcl_flav_indices(ipdg), ipdg
                if (allocated(lcl_flav_rescale)) val = val * lcl_flav_rescale(lcl_flav_indices(ipdg))
                if (val == zero) then
                   write(dat_unit,'(a)',advance='no') '  0'
                else
                   write(dat_unit,'(es15.7)',advance='no') val
                end if
             end do
             !stop
             write(dat_unit,'(a)') ''
          end do
       end do

       ! and finish with a yaml subdocument separator
       write(dat_unit,'(a)') '---'
    end do
    close(dat_unit)

    if (pdf_index == 0) then
      info_file = trim(basename)//'.info'
      info_unit = 0
      open(newunit=info_unit, file=info_file, status='replace')
      if (info_unit == 0) call wae_error("WritePdfTableLHAPDF: could not open info file  "//info_file)
      write(6,'(a)') "# Writing LHAPDF info file "//trim(info_file)

      write(info_unit,'(a)') 'SetDesc: <SetDesc>'
      write(info_unit,'(a)') 'SetIndex: 00000'
      write(info_unit,'(a)') 'Authors: <Authors>'
      write(info_unit,'(a)') 'Reference: <Reference>'
      write(info_unit,'(a)') 'Format: lhagrid1'
      write(info_unit,'(a)') 'DataVersion: 1'
      write(info_unit,'(a)') 'NumMembers: 1'
      write(info_unit,'(a)') 'Particle: 2212'
      write(info_unit,'(a)',advance="no") 'Flavors: '
      call write_yaml_array(info_unit, '(i3)', lcl_flav_pdg_ids(:), 15)
      write(info_unit,'(a,i2)') 'OrderQCD: ', NumberOfLoops(coupling)-1
      if (size(seginfos) == 1) then
        write(info_unit,'(a)') 'FlavorScheme: fixed'
      else
        write(info_unit,'(a)') 'FlavorScheme: variable'
      endif 
      write(info_unit,'(a,i2)') 'NumFlavors: ', table%nfhi
      write(info_unit,'(a)') 'ErrorType: <ErrorType>'
      write(info_unit,'(a,es22.14)') 'XMin: ', minval(xVals)
      write(info_unit,'(a,es22.14)') 'XMax: ', maxval(xVals)
      write(info_unit,'(a,es22.14)') 'QMin: ', minval(table%Q_vals)
      write(info_unit,'(a,es22.14)') 'QMax: ', maxval(table%Q_vals)
      write(info_unit,'(a)') 'MZ: 0.911870E+02'
      write(info_unit,'(a)') 'MUp: 0'
      write(info_unit,'(a)') 'MDown: 0'
      write(info_unit,'(a)') 'MStrange: 0'
      write(info_unit,'(a,es22.14)') 'MCharm: ',  QuarkMass(coupling,4)
      write(info_unit,'(a,es22.14)') 'MBottom: ', QuarkMass(coupling,5)
      write(info_unit,'(a,es22.14)') 'MTop: ',    QuarkMass(coupling,6)
      write(info_unit,'(a,es22.14)') 'AlphaS_MZ:', value(coupling, 91.11870_dp)
      write(info_unit,'(a)') 'AlphaS_OrderQCD: 2'
      write(info_unit,'(a)') 'AlphaS_Type: ipol'
      ! allocate, fill and output Q_vals and alphas_vals, 
      block
        real(dp), allocatable :: Q_vals(:), alphas_vals(:)
        Q_vals = table%Q_vals
        allocate(alphas_vals(lbound(Q_vals,1):ubound(Q_vals,1)))
        if (table%nf_info_associated) then
          ! near thresholds, by default the pdf_table chooses Q_vals that are very slightly
          ! below/above the thresholds; but LHAPDF wants two identical Q values
          ! as a signal that it should do separate interpolation above/below
          do iseg = lbound(seginfos,1), ubound(seginfos,1)-1
            Q_vals(seginfos(iseg)%ilnlnQ_hi) = 0.5_dp*(&
              table%Q_vals(seginfos(iseg)%ilnlnQ_hi) + table%Q_vals(seginfos(iseg+1)%ilnlnQ_lo))
            Q_vals(seginfos(iseg+1)%ilnlnQ_lo) = Q_vals(seginfos(iseg)%ilnlnQ_hi)
          end do
        end if
        do iQ = lbound(Q_vals,1), ubound(Q_vals,1)
          if (table%nf_info_associated) then
            alphas_vals(iQ) = value(coupling, Q_vals(iQ), fixnf=table%nf_int(iQ))
          else
            alphas_vals(iQ) = value(coupling, table%Q_vals(iQ))
          end if
        end do
      write(info_unit,'(a)', advance="no") 'AlphaS_Qs: '
      call write_yaml_array(info_unit, '(es22.14)', Q_vals, 4)
        write(info_unit,'(a)', advance="no") 'AlphaS_Vals: '
        call write_yaml_array(info_unit, '(es22.14)', alphas_vals,4)
      end block
      close(info_unit)
    end if

    ! cleaning
    if (.not. table%nf_info_associated) deallocate(seginfos)
  end subroutine WriteLHAPDFFromPdfTable

  !! write a yaml array (integer or real(dp)), limiting the number
  !! of elements to max_per_line on each line
  subroutine write_yaml_array(iunit, format, array, max_per_line)
    integer,          intent(in) :: iunit
    character(len=*), intent(in) :: format
    class(*),         intent(in) :: array(:)
    integer,          intent(in) :: max_per_line
    !------------
    integer :: i
    write(iunit,'(a)',advance="no") "["
    do i = 1, size(array)
      if (i > 1) write(iunit,'(a)',advance="no") ","
      if (mod(i,max_per_line) == 0) write(iunit,'(a)') ""
      ! now write the value
      select type (array)
      type is (integer)
        write(iunit,format,advance="no") array(i)
      type is (real(dp))
        write(iunit,format,advance="no") array(i)
      class default
        call wae_error("write_yaml_array: unsupported array type")
      end select
    end do
    write(iunit,'(a)') "]"
  end subroutine write_yaml_array

  !-----------------------------------------------------------
  !! Deletes all allocated info associated with the tabulation
  subroutine pdftab_DelTab_0d(tab)
    type(pdf_table), intent(inout) :: tab
    integer :: i
    deallocate(tab%tab)
    deallocate(tab%lnlnQ_vals)
    deallocate(tab%Q_vals)
    if (tab%nf_info_associated) then
       deallocate(tab%seginfo)
       deallocate(tab%nf_int)
       deallocate(tab%as2pi)
    end if
    if (associated(tab%evops)) then
       do i = 0, tab%nQ
          call Delete(tab%evops(i))
       end do
       !write(0,*) "CURRENTLY UNABLE TO DELETE EVOP CONTENTS"
       deallocate(tab%evops)
    end if
    ! reset the information about allocation so that we don't
    ! try to delete something that has already been deleted
    tab%allocated = .false.
  end subroutine pdftab_DelTab_0d
  subroutine pdftab_DelTab_1d(tab)
    type(pdf_table), intent(inout) :: tab(:)
    integer :: i
    do i = 1, size(tab)
       call pdftab_DelTab_0d(tab(i))
    end do
  end subroutine pdftab_DelTab_1d
  

  !--------------------------------------------------------------
  !! Service routine used in evaluating the PDF table so as to obtain,
  !! given Q, the relevant range of ilnlnQ values and weights for
  !! interpolating the table
  !!
  subroutine get_lnlnQ_wgts(tab, Q, lnlnQ_wgts, ilnlnQ_lo, ilnlnQ_hi)
    use hoppet_to_string
    type(pdf_table), intent(in) :: tab
    real(dp), intent(in)    :: Q
    real(dp), intent(out)   :: lnlnQ_wgts(0:)
    integer,  intent(out)   :: ilnlnQ_lo, ilnlnQ_hi
    !------------------------------------------------
    real(dp) :: lnlnQ, lnlnQ_norm
    integer  :: nQ, nQ_request
    integer, save :: warn_id = warn_id_INIT

    !-- Q weights need some help in finding location etc.
    lnlnQ = lnln(tab,Q)

    if (tab%freeze_at_Qmin .and. lnlnQ < tab%lnlnQ_min) then
       lnlnQ = tab%lnlnQ_min
    else if (lnlnQ < (one-warn_tolerance)*tab%lnlnQ_min &
         &.or. lnlnQ > (one+warn_tolerance)*tab%lnlnQ_max) then
      call wae_warn(default_max_warn, warn_id, &
           &'get_lnlnQ_wgts: Q out of range; result will be set to zero; Q was:',&
           &dbleval=Q)
      ilnlnQ_lo  = 0
      ilnlnQ_hi  = 0
      lnlnQ_wgts = zero ! set this to avoid warning
      return
    end if

    
    nQ_request = tab%lnlnQ_order    
    if (override_order_Q > 0) then
      nQ_request = override_order_Q
    else
      nQ_request = tab%lnlnQ_order
    end if
    if (nQ_request > ubound(lnlnQ_wgts,1)) then
      call wae_error('get_lnlnQ_wgts',&
         & 'lnlnQ_wgts too small (ubound='//trim(to_string(ubound(lnlnQ_wgts,1)))&
         //') for requested Q interpolation (nQ_request='//trim(to_string(nQ_request))//')')
    end if
    call request_iQrange(tab,lnlnQ, nQ_request,&
         &               ilnlnQ_lo, ilnlnQ_hi, lnlnQ_norm)

    nQ = ilnlnQ_hi - ilnlnQ_lo
    if (nQ == 0) then
       if (abs(lnlnQ - tab%lnlnQ_vals(ilnlnQ_lo)) < two * min_dlnlnQ_singleQ) then
          lnlnQ_wgts(0) = 1
       else
         call wae_error('get_lnlnQ_wgts',&
            & 'nQ=0 but lnlnQ='//trim(to_string(lnlnQ))//&
            & ' not close enough to tab%lnlnQ_vals(ilnlnQ_lo)(='//trim(to_string(tab%lnlnQ_vals(ilnlnQ_lo)))//')')
       end if

    !else if (nQ < ubound(lnlnQ_wgts,1)) then
    !  ! nQ can be zero if the table had a very narrow range of Q values (< O(min_dlnlnQ_singleQ))
    !  if (nQ == 0 .and. abs(lnlnQ - tab%lnlnQ_vals(ilnlnQ_lo)) < two * min_dlnlnQ_singleQ) then
    !     lnlnQ_wgts(0) = 1
    !  else
    !     !write(6,*) "Q=", Q, 'nQ = ',nQ, 'lnlnQ_wgts = ',ubound(lnlnQ_wgts,1), tab%nf_int
    !     call wae_error('get_lnlnQ_wgts',&
    !        & 'lnlnQ_wgts too small (ubound='//trim(to_string(ubound(lnlnQ_wgts,1)))&
    !        //') for requested Q interpolation (nQ='//trim(to_string(nQ))//')')
    !  end if
    end if
    call uniform_interpolation_weights(lnlnQ_norm, lnlnQ_wgts(0:nQ))

  end subroutine get_lnlnQ_wgts


  !------------------------------------------------------------------
  !! Given a tab and lnlnQ value, determine the range of iQ entries,
  !! iQ_lo:iQ_hi to be used for interpolating the grid.
  !!
  !! Where possible (i.e. if there are sufficient Q values in the
  !! grid) ensure that iQ_hi-iQ_lo = nrequest; for grids with varnf,
  !! all iQ_lo:iQ_hi values should correspond to the same nf value.
  !! 
  !! return value of lnlnQ_norm = (lnlnQ - lnlnQ(iQ_lo))/dlnlnQ
  !!
  subroutine request_iQrange(tab, lnlnQ, nrequest, iQ_lo, iQ_hi, lnlnQ_norm)
    type(pdf_table), intent(in), target :: tab
    real(dp),     intent(in) :: lnlnQ
    integer,      intent(in) :: nrequest
    integer,     intent(out) :: iQ_lo, iQ_hi
    real(dp),    intent(out) :: lnlnQ_norm
    !-------------------------------------
    real(dp) :: dist, distclosest
    integer  :: nfclosest, nflcl
    type(pdfseginfo), pointer :: seginfo
    if (nrequest < 1) call wae_error('request_iQrange',&
         &'nrequest should be >= 1',intval=nrequest)

    if (.not. tab%nf_info_associated) then
       lnlnQ_norm = (lnlnQ-tab%lnlnQ_min)/tab%dlnlnQ
       iQ_lo = floor(lnlnQ_norm) - nrequest/2
       iQ_lo = max(0, min(tab%nQ-nrequest,iQ_lo))
       iQ_hi = min(tab%nQ,iQ_lo + nrequest)
       lnlnQ_norm = lnlnQ_norm - iQ_lo
    else
       ! need to find range to which we are closest. There is certainly
       ! a better way of doing it...
       distclosest = 1e10_dp
       do nflcl = tab%nflo, tab%nfhi
          dist = max(zero,(lnlnQ-tab%seginfo(nflcl)%lnlnQ_hi),&
               & (tab%seginfo(nflcl)%lnlnQ_lo-lnlnQ))
          if (dist < distclosest) then
             nfclosest = nflcl
             distclosest = dist
          end if
       end do
       seginfo => tab%seginfo(nfclosest)
       if (seginfo%ilnlnQ_lo == seginfo%ilnlnQ_hi) then
          iQ_lo = seginfo%ilnlnQ_lo
          iQ_hi = iQ_lo
          lnlnQ_norm = zero
       else
          lnlnQ_norm = (lnlnQ-seginfo%lnlnQ_lo)/seginfo%dlnlnQ &
               &+ seginfo%ilnlnQ_lo
          !write(0,*) lnlnQ_norm, seginfo%dlnlnQ
          iQ_lo = floor(lnlnQ_norm) - nrequest/2
          iQ_lo = max(seginfo%ilnlnQ_lo, min(seginfo%ilnlnQ_hi-nrequest,iQ_lo))
          iQ_hi = min(seginfo%ilnlnQ_hi,iQ_lo + nrequest)
          lnlnQ_norm = lnlnQ_norm - iQ_lo
          !write(0,*) iQ_lo, iQ_hi, invlnln(tab,lnlnQ), lnlnQ_norm
       end if
    end if
  end subroutine request_iQrange
  

  !-------------------------------------
  !! conversion from Q to lnlnQ
  function lnln(tab,Q)
    type(pdf_table), intent(in) :: tab
    real(dp),     intent(in) :: Q
    real(dp)                 :: lnln

    if (Q < tab%lambda_eff) then
       lnln = -1e300_dp
    else
       lnln = log(log(Q/tab%lambda_eff))
    end if
  end function lnln

  !! conversion from lnlnQ to Q
  function invlnln(tab,lnlnQ)
    type(pdf_table), intent(in) :: tab
    real(dp),     intent(in) :: lnlnQ
    real(dp)                 :: invlnln

    invlnln = exp(exp(lnlnQ))*tab%lambda_eff
  end function invlnln

  !-----------------------------------------------------------------
  !! return zeta = ln 1/x + a*(1-x) + b * (1-x)^4 (x = exp(-y))
  function zetaext_of_y(y, a, b) result(zeta)
    real(dp), intent(in) :: y, a, b
    real(dp)             :: zeta, x
    x = exp(-y)
    zeta = y + a*(one - x) + b * (one - x**4)
  end function zetaext_of_y

  
  !-----------------------------------------------------------------
  !! return inversion of zetaext = ln 1/x + a*(1-x) +b*(1-x^4) (x = exp(-y))
  function y_of_zetaext(zetaext, a, b) result(y)
    real(dp), intent(in) :: zetaext, a, b
    real(dp)             :: y, x, diff_from_zero, deriv
    integer              :: iter
    real(dp), parameter  :: eps = 1e-12_dp
    integer,  parameter  :: maxiter = 100

    ! starting condition (and soln if a = 0 and b=0)
    y = zetaext 
    if (a /= zero .or. b /= zero) then
      do iter = 0, maxiter
        x = exp(-y);
        diff_from_zero = zetaext - (y + a*(one-x) + b*(one-x**4));
        ! we have found good solution
        if (abs(diff_from_zero) < eps) exit
        deriv = -one  - a*x - four*b*x**4;
        y = y - diff_from_zero / deriv;
      end do
    end if
    
    if (iter > maxiter) write(0,*) "y_of_zeta reached maxiter"

  end function y_of_zetaext


!OLD! function lnln_norm(tab,Q)
!OLD! type(pdf_table), intent(in) :: tab
!OLD! real(dp), intent(in) :: Q
!OLD! real(dp) :: lnln_norm
!OLD!
!OLD! if (tab%nf_info_associated) call wae_error('lnln_norm')
!OLD! lnln_norm = (lnln(tab,Q) - tab%lnlnQ_min)/tab%dlnlnQ
!OLD! end function lnln_norm
!OLD!
!OLD! function invlnln_norm(tab,lnlnQ_norm)
!OLD! type(pdf_table), intent(in) :: tab
!OLD! real(dp), intent(in) :: lnlnQ_norm
!OLD! real(dp) :: invlnln_norm
!OLD!
!OLD! if (tab%nf_info_associated) call wae_error('invlnln_norm')
!OLD! invlnln_norm = invlnln(tab, lnlnQ_norm*tab%dlnlnQ + tab%lnlnQ_min)
!OLD! end function invlnln_norm
end module pdf_tabulate

! This file copyright the Hoppet authors, released under GPLv3

!======================================================================
! What follows is mainly interfaces for VFNS at order(as^3). The
! actual code is contained in VFNSmod.f, momnsmod.f, and AQg3mod.f90,
! which is based on code from Blumlein and collaborators.
module blumlein_interfaces
  use types; use consts_dp; use assertions; use vfnsmod; use aqg3mod;&
       & use momnsmod
  implicit none

  ! generic interface corresponding to functions of z in code from
  ! Johannes Blumlein, allowing us to easily have pointers to them
  abstract interface
    double precision function JBfunc(z,nf,a4pi,LL)
      double precision :: z,nf,a4pi,LL
    end function JBfunc
  end interface

  !abstract interface
  !  double precision function JBone(z)
  !    double precision, intent(in) :: z
  !  end function JBone
  !end interface

  ! generic interface corresponding to functions of N in code from
  ! Johannes Blumlein, allowing us to easily have pointers to them
  abstract interface
    double precision function JBmom(N,z,nf,a4pi,LL)
      integer :: N
      double precision :: z,nf,a4pi,LL
    end function JBmom
  end interface

  abstract interface
    double precision function JBMomInt(a1,a2,a3,a4,a5)
      integer :: a1,a2,a3,a4,a5
    end function JBMomInt
  end interface

contains
  !! a_Qq^(3,PS)
  double precision function APS(z,nf,as,LL)
    double precision :: z,nf,as,LL

    APS = APS1(z,nf,as,LL) + APS2(z,nf,as,LL)
  end function 

  double precision function AGGREG(z,nf,as,LL)
    double precision :: z,nf,as,LL

    IF(z.LT.0.5D0) AGGREG=AGGREG0(z,nf,as,LL)
    IF(z.GE.0.5D0) AGGREG=AGGREG1(z,nf,as,LL)
  end function 

  ! This is the plus part of the NS plus piece
  double precision function ANSPLU(z,nf,as,LL)
    double precision :: z,nf,as,LL

    ANSPLU = ANSPLU1(z,nf,as,LL) + ANSPLU2(z,nf,as,LL)
  end function

  ! This is the plus part of the light-flavour NS minus piece
  ! with arguments in our standard order
  double precision function OPLUS_znfasLL(z,nf,as,LL)  
    double precision :: z,nf,as,LL  
    OPLUS_znfasLL = OPLUS1(as, LL, NF, z) + OPLUS2(as, LL, NF, z)
  end function

  ! This is the regular part of the light-flavour NS minus piece
  ! with arguments in our standard order
  double precision function OREG_znfasLL(z,nf,as,LL)  
    double precision :: z,nf,as,LL  
    OREG_znfasLL = OREG(as, LL, NF, z)
  end function

  ! This is the delta-function part of the light-flavour NS minus piece
  ! with arguments in our standard order
  double precision function ODEL_znfasLL(z,nf,as,LL)  
    double precision :: z,nf,as,LL  
    ODEL_znfasLL = ODEL(as, LL, NF)
  end function

  !! 2024-03-22: an aproximation to AQG that gets the sum rule to within
  !! O(1) * (as/2pi)^3
  !!
  !! 2024-05-30: this is now the full AQG.
  double precision function AQGtotal(z,nf,as,LL)
    double precision :: z,nf,as,LL
    double precision :: RED

    IF(z.LT.0.5D0) RED=RED0(z)
    IF(z.GE.0.5D0) RED=RED1(z)
    
    AQGtotal = (aQg3(z)/2+RED+nf*AQG3NF(z))*as**3
    !AQGtotal = (RED+nf*AQG3NF(z))*as**3
  end function AQGtotal

end module blumlein_interfaces

module mass_thresholds_n3lo
  use types; use consts_dp; use assertions
  use qcd
  use convolution
  use convolution_communicator
  use blumlein_interfaces
  implicit none

  abstract interface
  real(dp) function HoppetPij(y)
    use types
    real(dp), intent(in) :: y
  end function HoppetPij
  end interface

  type comparator
    character(len=100) :: name = ""
    procedure(JBfunc),    nopass, pointer :: blum_fn   => null()
    procedure(HoppetPij), nopass, pointer :: hoppet_fn => null()
    integer            :: piece = -1
  contains
    procedure :: compare
  end type comparator



  type JB
    procedure(JBfunc), nopass, pointer :: reg    => null()
    procedure(JBfunc), nopass, pointer :: plus   => null()
    procedure(JBfunc), nopass, pointer :: delta  => null()
    !! - if order is 10n (n=2,3) then  JB_fn will return the coefficient
    !!   of (as/4pi)^n by evaluating the function at multiple alphas values
    !! - if order is 20n (n=2,3) then  JB_fn will return the coefficient
    !!   of (as/4pi)^n by evaluating the function at a single very small 
    !!   or large alphas value, such that the other order is relatively negligible
    !! - if order is n (n=2,3) then JB_fn will return the coefficient of
    !!   of (as/4pi)^n by evaluating the function at a single alphas value
    !! - care will be taken also with a 1*delta(1-x) component
    integer                    :: order = 3
  contains 
    !!
    !! a hoppet-style function that evalues the integrand needed for
    !! a grid_conv object (coefficient of as/2pi^n) taking y=ln(1/x)
    !! and returning xP(x). Call it as
    !!  
    !!    this%integrand(y)
    !!
    !! (it is normally accessed via the JB_ptr_integrand, which uses
    !! the module wide InitGridConv_JB_ptr)
    procedure :: integrand => JB_integrand
    !!
    !! underlying order separator function (deals with a4pi^n).
    !! To be called as 
    !! 
    !!       this%fn(this%reg, z)
    !!
    !! (or similarly with this%plus and this%delta) and it returns the
    !! coefficient of (as/4pi)^n, with n defined from order as above
    procedure :: fn => JB_fn
  end type JB

  interface InitGridConv
    module procedure InitGridConv_JB
  end interface
  interface AddWithCoeff
    module procedure AddWithCoeff_JB
  end interface
  class(JB), pointer :: InitGridConv_JB_ptr => null()

!  private
!  public init_MTM_N3LO
contains

  !! returns the integrand as needed by hoppet, assuming
  !! that InitGridConv_JB_ptr has been set up
  real(dp) function JB_ptr_integrand(y) result(res)
    real(dp), intent(in) :: y
    !-------------------------------
    res = InitGridConv_JB_ptr%integrand(y)
  end function JB_ptr_integrand

  !! performs InitGridConv with a JB object
  subroutine InitGridConv_JB(grid, gc, JB_obj) 
    type(grid_def),  intent(in)    :: grid
    type(grid_conv), intent(inout) :: gc
    class(JB), intent(in), target :: JB_obj
    !-------------------------------
    InitGridConv_JB_ptr => JB_obj
    call InitGridConv(grid, gc, JB_ptr_integrand)
  end subroutine InitGridConv_JB

  !! performs InitGridConv with a JB object
  subroutine AddWithCoeff_JB(gc, JB_obj) 
    type(grid_conv), intent(inout) :: gc
    class(JB), intent(in), target :: JB_obj
    !-------------------------------
    InitGridConv_JB_ptr => JB_obj
    call AddWithCoeff(gc, JB_ptr_integrand)
  end subroutine AddWithCoeff_JB

  !! returns the integrand as needed by hoppet
  !! Implements JB%integrand(...)
  real(dp) function JB_integrand(this, y) result(res)
    class(JB), intent(in) :: this
    real(dp),  intent(in) :: y
    !-------------------------------
    real(dp) :: z
    z = exp(-y)

    select case(cc_piece)
    case(cc_REAL)
      res = this%fn(this%reg,z)
      res = res + this%fn(this%plus,z)
    case(cc_REALVIRT)
      res = this%fn(this%reg,z)
    case(cc_VIRT)
      res = -this%fn(this%plus,z)
    case(cc_DELTA)
      res = this%fn(this%delta,z)
    end select
    if (cc_piece /= cc_DELTA) res = res * z
    ! convert from (as/4pi)**order normalisation to (as/2pi)**order
    res = res * half**mod(this%order,100)
  end function JB_integrand

  !! return the evaluation of the specific function at the point z
  !! working out the coefficient of as4pi**this%order
  !! Implements JB%fn(...)
  real(dp) function JB_fn(this, fn, z) result(res)
    use warnings_and_errors
    class(JB), intent(in) :: this
    procedure(JBfunc), pointer :: fn
    real(dp)                   :: z
    !-------------------------------
    integer  :: nf_light_int
    real(dp) :: orders(2:3), nf_light_dp
    real(dp) :: a4pi(0:2) =  (/ 0.0_dp, 0.10_dp, 1.0_dp /), this_a4pi
    real(dp) :: res_a4pi(0:2)
    logical  :: delta_one
    integer  :: i, imin, imax
    integer  :: mod_order

    ! diagnostics
    ! if (associated(fn,this%reg  )) write(6,*) 'JB_fn: reg'
    ! if (associated(fn,this%plus )) write(6,*) 'JB_fn: plus'
    ! if (associated(fn,this%delta)) write(6,*) 'JB_fn: delta'
    ! if (.not. associated(fn)     ) write(6,*) 'JB_fn: null'
    ! write(6,*) 'JB_fn: z = ', z

    res = zero

    ! if the function is a null ptr then return zero
    if (.not. associated(fn)) then
      return
    end if

    ! our convention is that nf_int = nf_light + 1
    nf_light_int = nf_int - 1
    nf_light_dp = real(nf_light_int, dp)

    ! otherwise, we need to extract the coefficient of 
    ! (as/4pi)**order from the function, with care for the
    ! the case where we are using the delta-function 
    ! component, which needs special treatment
    delta_one = associated(fn, this%delta)
    mod_order = mod(this%order, 100)

    ! if order > 200 and we're not dealing with the delta function piece
    ! then we make use of the fact that if we choose a very small or very 
    ! large value of alphas, we will be dominated by either a4pi^2 or a4pi^3
    ! term
    if (this%order > 200 .and. (.not. delta_one)) then
      if (mod_order == 2) then
        ! very small a4pi, so the relative contribution of a4pi^3 is
        ! negligible
        this_a4pi = 1e-80_dp
      else if (mod_order == 3) then
        ! very large a4pi, so the relative contribution of a4pi^2 is
        ! negligible
        this_a4pi = 1e80_dp
      else
        call wae_error('JB_fn', 'order > 200 and not mod_order 2 or 3; order = ', intval=this%order)
      end if
      res = fn(z, nf_light_dp, this_a4pi, zero)
      res = res / this_a4pi**mod_order
      return
    end if


    ! otherwise we will use up to two (or even three) finite a4pi values 
    ! solve the linear relation to extract the coefficients of a4pi^2 or a4pi^3

    ! fortran ternary, equivalent to C's delta_one ? 0 : 1
    imin = merge(0, 1, delta_one)
    ! special treatment that order > 100 means mixed orders
    imax = merge(2, 1, this%order > 100)

    ! for some reason the separate_orders function did not
    ! correctly receive the function pointer, so do things
    ! manually here    
    !print *, this%order, imin, imax, delta_one, mod_order
    do i = imin, imax
      ! last argument is LL = log(mQ^2/mu^2), taken to be zero
      res_a4pi(i) = fn(z, nf_light_dp, a4pi(i), zero)
    end do
    ! remove any constant piece
    if (delta_one) res_a4pi(1:imax) = res_a4pi(1:imax) - res_a4pi(0)

    if (imax == 2) then
      orders(3) = (res_a4pi(2)/a4pi(2)**2 - res_a4pi(1)/a4pi(1)**2)/(a4pi(2) - a4pi(1))
      orders(2) = (res_a4pi(1) - orders(3)*a4pi(1)**3)/a4pi(1)**2
      res = orders(mod_order)
    else
      res = res_a4pi(1) / a4pi(1)**mod_order
    end if
    !print*,res
  end function JB_fn
  
  ! Given a comparator object, compare the results of the Blumlein function
  ! and the Hoppet function at the point x
  subroutine compare(this, x)
    class(comparator), intent(in) :: this
    real(dp), intent(in) :: x
    real(dp) :: res_blum(2:3), res_hoppet
    !-------------------------------
    logical  :: delta_one
    real(dp) :: lcl_x, diff
    character(len=1) :: warning

    ! set the global cc_piece
    cc_piece = this%piece    
    ! nothing to compare
    if (cc_piece < 0) return

    if (associated(this%hoppet_fn)) then
      res_hoppet = this%hoppet_fn(log(one/x)) 
    else
      res_hoppet = zero
    end if
    ! for powers of x, take the convention from Blumlein
    if (this%piece /= cc_DELTA) res_hoppet = res_hoppet / x 
    if (this%piece == cc_VIRT)  res_hoppet = -res_hoppet

    ! establish if we will need to subtract 1 from the result 
    ! (because the terms with a delta function are of the form 1 + alpha^2...)
    delta_one = (this%piece == cc_DELTA)

    ! include a factor 0.5^n, so that the result multiplies 
    ! (as/2pi)^n
    res_blum = separate_orders(x, nf_int, this%blum_fn, delta_one) * (/ 0.25_dp, 0.125_dp /)

    lcl_x = x
    if (this%piece == cc_DELTA) lcl_x = one
    write(6,'(a8, f8.3)', advance='no') trim(this%name), lcl_x
    diff = res_blum(2) - res_hoppet
    if (abs(diff) > 1e-10) then
      warning = '*'
    else
      warning = ' '
    end if
    write(6,*) res_blum(2), res_hoppet, res_blum(2) - res_hoppet, warning
  end subroutine compare


  !! given a JB function fn that contains the sum of 2nd and 3rd order
  !! results, return the separate values of the 2nd and 3rd orders 
  !! (coefficients of (as/4pi)^n) by evaluating fn at two alphas values.
  !!
  !! if delta_one is .true., then we subtract one from the result
  function separate_orders(x, nf_light, fn, delta_one) result(res)
    real(dp), intent(in) :: x
    integer,  intent(in) :: nf_light
    procedure(JBfunc) :: fn
    !! if present, then we must subtract one from the result
    !! which has a delta(x-1)*(one)
    logical, intent(in), optional :: delta_one
    !interface 
    !  function fn(xx, nnf, aa4pi, LL) result(res)
    !    double precision, intent(in) :: xx
    !    integer,  intent(in) :: nnf
    !    double precision, intent(in) :: aa4pi, LL
    !    double precision :: res
    !  end function fn
    !end interface
    real(dp) :: res(2:3)
    !-------------------------------
    real(dp) :: a4pi(2) =  (/ 0.10_dp, 0.3_dp /)
    real(dp) :: res_a4pi(2), nf_light_dp
    integer  :: i

    !ffn => fn
    nf_light_dp = nf_light
    !write(0,*) fn(x, nf_light_dp, one, zero)
    do i = 1, size(a4pi)
      ! last argument is LL = log(mQ^2/mu^2), taken to be zero
      res_a4pi(i) = fn(x, nf_light_dp, a4pi(i), zero)
      if (default_or_opt(.false., delta_one)) res_a4pi(i) = res_a4pi(i) - one
    end do
    res(3) = (res_a4pi(2)/a4pi(2)**2 - res_a4pi(1)/a4pi(1)**2)/(a4pi(2) - a4pi(1))
    res(2) = (res_a4pi(1) - res(3)*a4pi(1)**3)/a4pi(1)**2
    !write(6,*) fn(x, nf, 0.0001_dp, zero), fn(x, nf, 0.00001_dp, zero)
  end function separate_orders

  !! Given a4pi(1:2) and res_a4pi(1:2) that contains a result at
  !! those two a4pi values, return the coefficients of the 2nd and 3rd
  !! powers of a4pi.
  function separate23(a4pi, res_a4pi, delta_one) result(res23)
    real(dp), intent(in) :: a4pi(2), res_a4pi(2)
    logical, intent(in), optional :: delta_one
    real(dp) :: res23(2:3), res_a4pi_lcl(2)
    !-------------------------------
    res_a4pi_lcl = res_a4pi
    if (default_or_opt(.false., delta_one)) res_a4pi_lcl = res_a4pi_lcl - one

    res23(3) = (res_a4pi_lcl(2)/a4pi(2)**2 - res_a4pi_lcl(1)/a4pi(1)**2)/(a4pi(2) - a4pi(1))
    res23(2) = (res_a4pi_lcl(1) - res23(3)*a4pi(1)**3)/a4pi(1)**2
  end function separate23

  ! a super inefficient (O N^2) way of getting the moment that also
  ! suffers from a truncation error...
  real(dp) function gc_moment(gc, momN) result(res)
    type(grid_conv), intent(in) :: gc
    real(dp), intent(in) :: momN
    !-------------------------------
    real(dp) :: powx(0:gc%grid%ny), conv_res(0:gc%grid%ny)
    powx = xValues(gc%grid)**(-(momN-1))
    conv_res = gc * powx
    res = conv_res(gc%grid%ny) / powx(gc%grid%ny)
  end function gc_moment

end module mass_thresholds_n3lo

! $Id: runge_kutta.f90,v 1.1 2001/06/27 13:40:17 gsalam Exp $
module runge_kutta
  use types; use consts_dp
  implicit none
  private


  real(dp),  parameter :: third = one/three

  interface rkstp
     module procedure rkstp_0d, rkstp_1d, rkstp_2d!
     !module procedure rkstp_0d_arg
  end interface
  public :: rkstp

  interface rkstp_arg
     module procedure rkstp_0d_arg
  end interface
  public :: rkstp_arg, rkstp_0d_arg


contains
  !----------------------------------------------------------------------
  ! write the Runge Kutta routine; try and be efficient with work-space
  ! This is a scalar version...
  subroutine rkstp_0d(h,x,y,conv)
    real(dp), intent(in)    :: h
    real(dp), intent(inout) :: x, y
    interface
       subroutine conv(x,y,dy)
         use types
         real(dp), intent(in)  :: x, y
         real(dp), intent(out) :: dy
       end subroutine conv
    end interface
    !------------------------------------------------------------
    real(dp) :: w1, w2, w3
    real(dp) :: hh
    hh = half * h
    call conv(x,y,w1); w1 = w1 * hh            ! w1 = k1/2
    call conv(x+hh, y + w1, w2); w2 = w2 * hh  ! w2 = k2/2
    call conv(x+hh, y + w2, w3); w3 = w3 * h   ! w3 = k3
    w2 = w1 + two*w2                           ! w2 = half*k1 + k2
    call conv(x+h , y + w3, w1); w1 = w1 * hh  ! w1 = k4/2
    
    x = x + h
    !                k1/2 + k2  + k3 + k4/2
    y = y + third * (w2         + w3 + w1)
  end subroutine rkstp_0d

  ! version that takes a generic extra argument
  ! Note that the actual conv must genuinely taks a class(*) arg
  ! and then use select type(arg) to specialise to the correct
  ! variant.
  subroutine rkstp_0d_arg(h,x,y,conv, arg)
    real(dp), intent(in)    :: h
    real(dp), intent(inout) :: x, y
    class(*), intent(in)    :: arg
    interface
       subroutine conv(x,y,dy,arg)
         use types
         real(dp), intent(in)  :: x, y
         real(dp), intent(out) :: dy
         class(*), intent(in)  :: arg
       end subroutine conv
    end interface
    !------------------------------------------------------------
    real(dp) :: w1, w2, w3
    real(dp) :: hh
    hh = half * h
    call conv(x,y,w1,arg); w1 = w1 * hh            ! w1 = k1/2
    call conv(x+hh, y + w1, w2,arg); w2 = w2 * hh  ! w2 = k2/2
    call conv(x+hh, y + w2, w3,arg); w3 = w3 * h   ! w3 = k3
    w2 = w1 + two*w2                               ! w2 = half*k1 + k2
    call conv(x+h , y + w3, w1,arg); w1 = w1 * hh  ! w1 = k4/2

    x = x + h
    !                k1/2 + k2  + k3 + k4/2
    y = y + third * (w2         + w3 + w1)
  end subroutine rkstp_0d_arg

  !----------------------------------------------------------------------
  subroutine rkstp_1d(h,x,y,conv)
    real(dp), intent(in)    :: h
    real(dp), intent(inout) :: x, y(:)
    interface
       subroutine conv(x,y,dy)
         use types
         real(dp), intent(in)  :: x, y(:)
         real(dp), intent(out) :: dy(:)
       end subroutine conv
    end interface
    !------------------------------------------------------------
    real(dp) :: w1(size(y)), w2(size(y)), w3(size(y))
    real(dp) :: hh
    hh = half * h
    call conv(x,y,w1); w1 = w1 * hh            ! w1 = k1/2
    call conv(x+hh, y + w1, w2); w2 = w2 * hh  ! w2 = k2/2
    call conv(x+hh, y + w2, w3); w3 = w3 * h   ! w3 = k3
    w2 = w1 + two*w2                           ! w2 = half*k1 + k2
    call conv(x+h , y + w3, w1); w1 = w1 * hh  ! w1 = k4/2
    
    x = x + h
    !                k1/2 + k2  + k3 + k4/2
    y = y + third * (w2         + w3 + w1)
  end subroutine rkstp_1d

  !----------------------------------------------------------------------
  subroutine rkstp_2d(h,x,y,conv)
    real(dp), intent(in)    :: h
    real(dp), intent(inout) :: x, y(:,:)
    interface
       subroutine conv(x,y,dy)
         use types
         real(dp), intent(in)  :: x, y(:,:)
         real(dp), intent(out) :: dy(:,:)
       end subroutine conv
    end interface
    !------------------------------------------------------------
    real(dp) :: w1(size(y,dim=1),size(y,dim=2)), &
         &      w2(size(y,dim=1),size(y,dim=2)), &
         &      w3(size(y,dim=1),size(y,dim=2))
    real(dp) :: hh
    hh = half * h
    call conv(x,y,w1); w1 = w1 * hh            ! w1 = k1/2
    call conv(x+hh, y + w1, w2); w2 = w2 * hh  ! w2 = k2/2
    call conv(x+hh, y + w2, w3); w3 = w3 * h   ! w3 = k3
    w2 = w1 + two*w2                           ! w2 = half*k1 + k2
    call conv(x+h , y + w3, w1); w1 = w1 * hh  ! w1 = k4/2
    
    x = x + h
    !                k1/2 + k2  + k3 + k4/2
    y = y + third * (w2         + w3 + w1)
  end subroutine rkstp_2d

end module runge_kutta

!!
!! Parameters describing the range of possible "options" in the
!! DGLAP evolution. Options refer both to physical choices (such 
!! as schemes, polarization) as well as technical choices (choice of 
!! approximation used for NNLO splitting function).
!!
!! GPS: adapted from qcd.f90 18/09/2004
!!
module dglap_choices
  implicit none
  private

  integer, parameter, public :: nnlo_splitting_exact = -2
  integer, parameter, public :: nnlo_splitting_param = -1
  ! these three should keep their numerical values because
  ! of a correspondence with vogt imod values
  integer, parameter, public :: nnlo_splitting_Nfitav   =  0
  integer, parameter, public :: nnlo_splitting_Nfiterr1 =  1
  integer, parameter, public :: nnlo_splitting_Nfiterr2 =  2
  integer, public :: nnlo_splitting_variant = nnlo_splitting_param

  integer, parameter, public :: n3lo_splitting_exact = -2
  integer, parameter, public :: n3lo_splitting_param = -1
  ! these three should keep their numerical values because
  ! of a correspondence with vogt imod values
  integer, parameter, public :: n3lo_splitting_Nfitav   =  0
  integer, parameter, public :: n3lo_splitting_Nfiterr1 =  1
  integer, parameter, public :: n3lo_splitting_Nfiterr2 =  2
  integer, public :: n3lo_splitting_variant = n3lo_splitting_Nfitav
  ! As of 2024-04-16 there are several approximations available of the
  ! n3lo splitting functions. To maintain some backwards compatibility
  ! we have a switch below that allows the user to pick which set of
  ! approximations to use. The have progressively more moments.
  integer, parameter, public :: n3lo_splitting_approximation_up_to_2310_05744 = 100 !< Uses non-singlet of 1610.07477+1707.08315,
                                                                                    !< pure-singlet (qq) of 2302.07593,
                                                                                    !< qg of 2307.04158 and gq and gg of 2310.05744
  integer, parameter, public :: n3lo_splitting_approximation_up_to_2404_09701 = 101 !< Replaces gq with that of 2404.09701
  integer, parameter, public :: n3lo_splitting_approximation_up_to_2410_08089 = 102 !< Additionally replaces gg with that of 2410.08089
  integer, public :: n3lo_splitting_approximation =  n3lo_splitting_approximation_up_to_2410_08089 

  integer, parameter, public :: nnlo_nfthreshold_exact = -12
  integer, parameter, public :: nnlo_nfthreshold_param = -11
  integer, public :: nnlo_nfthreshold_variant = nnlo_nfthreshold_param

  integer, parameter, public :: n3lo_nfthreshold_exact_fortran = 2 !< exact except AQg
  integer, parameter, public :: n3lo_nfthreshold_libOME = 1        !< C++ expansions, good to 2048*epsilon, https://gitlab.com/libome/libome 
  integer, parameter, public :: n3lo_nfthreshold_off = 0
  integer, public :: n3lo_nfthreshold = n3lo_nfthreshold_libOME

  ! define n3lo_nfthreshold_on for compatibility with v2.0.x, split across two
  ! lines to avoid being caught by NameSelect.pl
  integer, parameter,&
        & public :: n3lo_nfthreshold_on = n3lo_nfthreshold_libOME   


  integer, parameter, public :: factscheme_MSbar    = 1
  integer, parameter, public :: factscheme_DIS      = 2
  integer, parameter, public :: factscheme_PolMSbar = 3
  integer, parameter, public :: factscheme_FragMSbar = 4
  ! have these on split lines so that they are not caught
  ! by naming routines.
  integer, parameter,&
       & public :: factscheme_default = factscheme_MSbar
  integer, parameter, &
       &public :: factscheme_Poldefault = factscheme_PolMSbar

  public :: dglap_Set_nnlo_splitting
  public :: dglap_Set_n3lo_splitting
  public :: dglap_Set_n3lo_splitting_approximation
  public :: dglap_Set_nnlo_nfthreshold
  public :: dglap_Set_n3lo_nfthreshold
contains

  !-------- overkill ----------------------------------------
  subroutine dglap_Set_nnlo_splitting(variant)
    integer, intent(in) :: variant
    nnlo_splitting_variant = variant
  end subroutine dglap_Set_nnlo_splitting

  !-------- overkill ----------------------------------------
  subroutine dglap_Set_n3lo_splitting(variant)
    integer, intent(in) :: variant
    n3lo_splitting_variant = variant
  end subroutine dglap_Set_n3lo_splitting

  !-------- overkill ----------------------------------------
  subroutine dglap_Set_n3lo_splitting_approximation(variant)
    integer, intent(in) :: variant
    n3lo_splitting_approximation = variant
  end subroutine dglap_Set_n3lo_splitting_approximation

  !-------- overkill ----------------------------------------
  subroutine dglap_Set_nnlo_nfthreshold(variant)
    integer, intent(in) :: variant
    nnlo_nfthreshold_variant = variant
  end subroutine dglap_Set_nnlo_nfthreshold

  !-------- overkill ----------------------------------------
  subroutine dglap_Set_n3lo_nfthreshold(variant)
    integer, intent(in) :: variant
    n3lo_nfthreshold = variant
  end subroutine dglap_Set_n3lo_nfthreshold
end module dglap_choices

!! An example program using structure functions up to N3LO. !!
!!
program structure_functions_example
  use hoppet
  use pdfs_for_benchmarks
  use streamlined_interface
  use structure_functions
  implicit none
  real(dp) :: Qmax, xmur, xmuf, Qmin, ymax, Q, mc, mb, mt, asQ, Q0,&
       & muR_Q, dy, dlnlnQ, minQval, maxQval
  integer  :: nloop_coefs, sc_choice,nloop, order
  integer :: nargs
  character(len=5) :: arg_string
  logical :: param_coefs = .true.

  ! Get the number of command line arguments
  nargs = COMMAND_ARGUMENT_COUNT()

  ! Very simple commandline.
  if(nargs == 1) then
     call GET_COMMAND_ARGUMENT(1, arg_string)
     if(arg_string == "exact") param_coefs = .false.
  endif
     
  Qmax = 13000.0_dp 
  nloop_coefs = 4
  xmur = one
  xmuf = one
  sc_choice = scale_choice_Q ! Uses Q as the central scale choice
  Qmin = one

  ! Set heavy flavour scheme
  mc = 1.414213563_dp   ! sqrt(2.0_dp) + epsilon
  mb = 4.5_dp
  mt = 175.0_dp
  call hoppetSetPoleMassVFN(mc, mb, mt)

  ! Streamlined initialization
  ! including  parameters for x-grid
  order = -6 ! interpolation order, not perturbative order in alphas!
  ymax  = 16.0_dp
  dy    = 0.05_dp  ! dble_val_opt("-dy",0.1_dp)
  dlnlnQ = dy/4.0_dp
  nloop = 3 
  minQval = min(xmuF*Qmin, Qmin)
  maxQval = max(xmuF*Qmax, Qmax)
  
  ! initialise the grid and dglap holder, using the streamlined
  ! interface for simplicity
  call hoppetStartExtended(ymax,dy,minQval,maxQval,dlnlnQ,nloop,&
         &         order,factscheme_MSbar)

  ! Setup all constants and parameters needed by the structure functions
  call StartStrFct(nloop_coefs, nflav = 5, scale_choice = sc_choice, param_coefs&
       & = param_coefs)

  ! Evolve the PDF
  asQ = 0.35_dp
  Q0 = sqrt(2.0_dp)
  muR_Q = 1.0_dp

  call hoppetEvolve(asQ, Q0, nloop,muR_Q, benchmark_pdf_unpolarized_lha, Q0)

  ! Initialise the structure functions using separate orders
  ! NB: this uses the PDFs that were set up in the streamlined interface
  ! with the hoppetEvolve routine
  call InitStrFct(nloop_coefs, .true., xR = xmur, xF = xmuf)

  ! write out the structure functions
  ymax = log(1e5) !ymax=20
  Q = 100.0_dp
  call write_f1(6, Q, ymax, 10)
  call write_f2(6, Q, ymax, 10)
  call write_f3(6, Q, ymax, 10)

  !call hoppetWriteLHAPDFgrid('test',0)

end program structure_functions_example

!! An example program which prints out the DIS structure functions up
!! to N3LO. This program produces the checks that were carried out
!! with Valerio Bertone in (INSERT ARXIV IDENTIFIER HERE)
!!

program structure_functions_benchmark_checks
  use hoppet
  use pdfs_for_benchmarks
  use streamlined_interface
  use structure_functions
  use io_utils !< for command-line access
  implicit none
  real(dp) :: Qmax, xmur, xmuf, Qmin, ymax, Q, mc, mb, mt, asQ, Q0alphas, muR_Q, Q0pdf
  real(dp) :: xpdf_at_xQ(-6:6), dy, dlnlnQ, minQval, maxQval
  integer  :: order_max, sc_choice,nloop,ix,nf_lcl,order
  real(dp), parameter :: heralhc_xvals(9) = &
       & (/1e-5_dp,1e-4_dp,1e-3_dp,1e-2_dp,0.1_dp,0.3_dp,0.5_dp,0.7_dp,0.9_dp/)
  ! Couplings needed for the F3 structure functions
  real(dp), parameter :: mz = 91.1876_dp, mw = 80.398_dp, sin_thw_sq = 1.0_dp - (mw/mz)**2
  real(dp), parameter :: Ae = - 0.5_dp, Ve = - 0.5_dp + 2.0_dp * sin_thw_sq, Ae2 = Ae**2, &
       &  Ve2 = Ve**2, Ve2_Ae2 = Ve2 + Ae2, two_Ve_Ae = 2.0_dp * Ve * Ae, &
       &  sin_2thw_sq = 4.0_dp * (1.0_dp - sin_thw_sq) * sin_thw_sq
  logical :: param_coefs = .true.
  character(len=1024) :: outdir

  Qmax = 13000.0_dp 
  order_max = 4
  xmur = one
  xmuf = one
  sc_choice = 1 ! Uses Q as the central scale choice
  Qmin = one

  ! Set heavy flavour scheme
  mc = 1.414213563_dp   ! sqrt(2.0_dp) + epsilon
  mb = 4.5_dp
  mt = 175.0_dp
  call hoppetSetPoleMassVFN(mc, mb, mt)

  ! Streamlined initialization
  ! including  parameters for x-grid
  order = -6 
  ymax  = 16.0_dp
  dy    = dble_val_opt("-dy",0.05_dp)
  param_coefs = .not. log_val_opt("-exact-coefs")
  outdir = string_val_opt("-outdir","structure-functions-benchmarks")
  dlnlnQ = dy/4.0_dp
  nloop = 3 
  minQval = min(xmuF*Qmin, Qmin)
  maxQval = max(xmuF*Qmax, Qmax)
  
  ! initialise the grid and dglap holder
  write(6,'(a)') "Initialising splitting functions"
  call hoppetStartExtended(ymax,dy,minQval,maxQval,dlnlnQ,nloop,&
       &         order,factscheme_MSbar)

  ! Setup all constants and parameters needed by the structure functions
  write(6,'(a)') "Initialising coefficient functions for structure functions"
  if (.not. param_coefs) write(6,('(a)')) "NB: this is being done with exact coefficient functions and will take about a minute "
  call StartStrFct(order_max, scale_choice = sc_choice, param_coefs =&
       & param_coefs, wmass = mw, zmass = mz)

  ! Evolve the PDF
  nloop = 3 ! NNLO evolution
  asQ = 0.35_dp
  Q0alphas = sqrt(2.0_dp)
  muR_Q = 1.0_dp
  Q0pdf = sqrt(2.0_dp) ! The initial evolution scale
  call hoppetEvolve(asQ, Q0alphas, nloop,muR_Q, benchmark_pdf_unpolarized_lha, Q0pdf)

  write(6,'(a)') "Quick output of alphas and PDFs, e.g. to enable consistency checks with other codes"
  Q = 100.0_dp
  print*, 'Q = ', Q, ' GeV'
  !AV commented out because it is an error in non-GNU compilers
  !print*, 'αS(Q) = ', Value(coupling, Q)
  
  write(6,'(a)')
  write(6,'(a,f8.3,a)') "Evaluating PDFs at Q = ",Q," GeV"
  write(6,'(a5,2a12,a14,a10,a12)') "x",&
       & "u-ubar","d-dbar","2(ubr+dbr)","c+cbar","gluon"
  do ix = 1, size(heralhc_xvals)
     call EvalPdfTable_xQ(tables(0),heralhc_xvals(ix),Q,xpdf_at_xQ)
     write(6,'(es7.1,5es12.4)') heralhc_xvals(ix), &
          &  xpdf_at_xQ(2)-xpdf_at_xQ(-2), &
          &  xpdf_at_xQ(1)-xpdf_at_xQ(-1), &
          &  2*(xpdf_at_xQ(-1)+xpdf_at_xQ(-2)), &
          &  (xpdf_at_xQ(-4)+xpdf_at_xQ(4)), &
          &  xpdf_at_xQ(0)
  end do
  print*, ''
  
  ! Initialise the structure functions using separate order
  write(6,'(a)') "Initialising tabulated structure functions"
  call InitStrFct(order_max, .true., xR = xmur, xF = xmuf)

  write(6,'(a)') "Writing structure function benchmarks to ** " // trim(outdir) // "/ ** directory"
  open(unit = 99, file = trim(outdir) // '/structure-functions-Q-2.0-GeV.dat')
  Q = 2.0_dp
  write(6,'(a,f5.1,a)') "Printing structure functions at Q = ",Q," GeV"
  call write_f1_benchmark(99, Q, -3.0_dp, 10.0_dp, 200)
  call write_f2_benchmark(99, Q, -3.0_dp, 10.0_dp, 200)
  call write_f3_benchmark(99, Q, -3.0_dp, 10.0_dp, 200)
  close(99)
  
  open(unit = 99, file = trim(outdir) // '/structure-functions-Q-5.0-GeV.dat')
  Q = 5.0_dp
  write(6,'(a,f5.1,a)') "Printing structure functions at Q = ",Q," GeV"
  call write_f1_benchmark(99, Q, -3.0_dp, 10.0_dp, 200)
  call write_f2_benchmark(99, Q, -3.0_dp, 10.0_dp, 200)
  call write_f3_benchmark(99, Q, -3.0_dp, 10.0_dp, 200)
  close(99)
  
  open(unit = 99, file = trim(outdir) // '/structure-functions-Q-10.0-GeV.dat')
  Q = 10.0_dp
  write(6,'(a,f5.1,a)') "Printing structure functions at Q = ",Q," GeV"
  call write_f1_benchmark(99, Q, -3.0_dp, 10.0_dp, 200)
  call write_f2_benchmark(99, Q, -3.0_dp, 10.0_dp, 200)
  call write_f3_benchmark(99, Q, -3.0_dp, 10.0_dp, 200)
  close(99)
  
  open(unit = 99, file = trim(outdir) // '/structure-functions-Q-50.0-GeV.dat')
  Q = 50.0_dp
  write(6,'(a,f5.1,a)') "Printing structure functions at Q = ",Q," GeV"
  call write_f1_benchmark(99, Q, -3.0_dp, 10.0_dp, 200)
  call write_f2_benchmark(99, Q, -3.0_dp, 10.0_dp, 200)
  call write_f3_benchmark(99, Q, -3.0_dp, 10.0_dp, 200)
  close(99)
  
  open(unit = 99, file = trim(outdir) // '/structure-functions-Q-100.0-GeV.dat')
  Q = 100.0_dp
  write(6,'(a,f5.1,a)') "Printing structure functions at Q = ",Q," GeV"
  call write_f1_benchmark(99, Q, -3.0_dp, 10.0_dp, 200)
  call write_f2_benchmark(99, Q, -3.0_dp, 10.0_dp, 200)
  call write_f3_benchmark(99, Q, -3.0_dp, 10.0_dp, 200)
  close(99)
  
  open(unit = 99, file = trim(outdir) // '/structure-functions-Q-500.0-GeV.dat')
  Q = 500.0_dp
  write(6,'(a,f5.1,a)') "Printing structure functions at Q = ",Q," GeV"
  call write_f1_benchmark(99, Q, -3.0_dp, 10.0_dp, 200)
  call write_f2_benchmark(99, Q, -3.0_dp, 10.0_dp, 200)
  call write_f3_benchmark(99, Q, -3.0_dp, 10.0_dp, 200)
  close(99)
  
contains 
 !----------------------------------------------------------------------
  ! write the F1 structure function to idev
  subroutine write_f1_benchmark (idev, Qtest, logxomx_min, logxomx_max, nx)
  implicit none
    real(dp), intent(in) :: Qtest, logxomx_min, logxomx_max
    integer, intent(in)  :: idev, nx
    real(dp) :: ytest, xval, mR, mF, F1Z_LO, F1Z_NLO, F1Z_NNLO, F1Z_N3LO, res(-6:7)
    real(dp) :: F1g_LO, F1g_NLO, F1g_NNLO, F1g_N3LO
    integer  :: iy
    !F1 Wp Wm Z
    write(idev,'(a,f10.4,a,f10.4)') '# Q = ', Qtest
    write(idev,'(a,a)') '# x  F1Wp(LO) F1Wm(LO) F1Wp(NLO) F1Wm(NLO) F1Wp(NNLO) F1Wm(NNLO)', &
          & ' F1Wp(N3LO) F1Wm(N3LO) F1Z(LO) F1Z(NLO) F1Z(NNLO) F1Z(N3LO) F1γ(LO) F1γ(NLO) F1γ(NNLO) F1γ(N3LO)'
    mF = sf_muF(Qtest)
    mR = sf_muR(Qtest)
    do iy = nx, 0, -1
       ytest = logxomx_max + iy * (logxomx_min - logxomx_max) / nx
       xval = exp(-ytest)/(one+exp(-ytest))
       ytest = - log(xval)
       res = F_LO(xval, Qtest, mR, mF)
       write(idev,'(3es22.12)',advance='no') xval, res(iF1Wp),res(iF1Wm)
       F1Z_LO = res(iF1Z)
       F1g_LO = res(iF1EM)
       res = F_NLO(xval, Qtest, mR, mF)
       write(idev,'(2es22.12)',advance='no') res(iF1Wp), res(iF1Wm)
       F1Z_NLO = res(iF1Z)
       F1g_NLO = res(iF1EM)
       res = F_NNLO(xval, Qtest, mR, mF)
       write(idev,'(2es22.12)',advance='no') res(iF1Wp), res(iF1Wm)
       F1Z_NNLO = res(iF1Z)
       F1g_NNLO = res(iF1EM)
       res = F_N3LO(xval, Qtest, mR, mF)
       write(idev,'(2es22.12)',advance='no') res(iF1Wp), res(iF1Wm)
       F1Z_N3LO = res(iF1Z)
       F1g_N3LO = res(iF1EM)
       write(idev,'(4es22.12)',advance='no') F1Z_LO, F1Z_NLO, F1Z_NNLO, F1Z_N3LO
       write(idev,'(4es22.12)',advance='no') F1g_LO, F1g_NLO, F1g_NNLO, F1g_N3LO
       write(idev,*)
    end do
    write(idev,*)
    write(idev,*)
  end subroutine write_f1_benchmark

  !----------------------------------------------------------------------
  ! write the F2 structure function to idev
  subroutine write_f2_benchmark (idev, Qtest, logxomx_min, logxomx_max, nx)
  implicit none
    real(dp), intent(in) :: Qtest, logxomx_min, logxomx_max
    integer, intent(in)  :: idev, nx
    real(dp) :: ytest, xval, mR, mF, F2Z_LO, F2Z_NLO, F2Z_NNLO, F2Z_N3LO, res(-6:7)
    real(dp) :: F2g_LO, F2g_NLO, F2g_NNLO, F2g_N3LO
    integer  :: iy
    !F2 Wp Wm Z
    write(idev,'(a,f10.4,a,f10.4)') '# Q = ', Qtest
    write(idev,'(a,a)') '# x  F2Wp(LO) F2Wm(LO) F2Wp(NLO) F2Wm(NLO) F2Wp(NNLO) F2Wm(NNLO)', &
          & ' F2Wp(N3LO) F2Wm(N3LO) F2Z(LO) F2Z(NLO) F2Z(NNLO) F2Z(N3LO) F2γ(LO) F2γ(NLO) F2γ(NNLO) F2γ(N3LO)'
    mF = sf_muF(Qtest)
    mR = sf_muR(Qtest)
    do iy = nx, 0, -1
       ytest = logxomx_max + iy * (logxomx_min - logxomx_max) / nx
       xval = exp(-ytest)/(one+exp(-ytest))
       ytest = - log(xval)
       res = F_LO(xval, Qtest, mR, mF)
       write(idev,'(3es22.12)',advance='no') xval, res(iF2Wp),res(iF2Wm)
       F2Z_LO = res(iF2Z)
       F2g_LO = res(iF2EM)
       res = F_NLO(xval, Qtest, mR, mF)
       write(idev,'(2es22.12)',advance='no') res(iF2Wp), res(iF2Wm)
       F2Z_NLO = res(iF2Z)
       F2g_NLO = res(iF2EM)
       res = F_NNLO(xval, Qtest, mR, mF)
       write(idev,'(2es22.12)',advance='no') res(iF2Wp), res(iF2Wm)
       F2Z_NNLO = res(iF2Z)
       F2g_NNLO = res(iF2EM)
       res = F_N3LO(xval, Qtest, mR, mF)
       write(idev,'(2es22.12)',advance='no') res(iF2Wp), res(iF2Wm)
       F2Z_N3LO = res(iF2Z)
       F2g_N3LO = res(iF2EM)
       write(idev,'(4es22.12)',advance='no') F2Z_LO, F2Z_NLO, F2Z_NNLO, F2Z_N3LO
       write(idev,'(4es22.12)',advance='no') F2g_LO, F2g_NLO, F2g_NNLO, F2g_N3LO
       write(idev,*)
    end do
    write(idev,*)
    write(idev,*)
  end subroutine write_f2_benchmark

  !----------------------------------------------------------------------
  ! write the F3 structure function to idev
  subroutine write_f3_benchmark (idev, Qtest, logxomx_min, logxomx_max, nx)
  implicit none
    real(dp), intent(in) :: Qtest, logxomx_min, logxomx_max
    integer, intent(in)  :: idev, nx
    real(dp) :: ytest, xval, mR, mF, F3Z_LO, F3Z_NLO, F3Z_NNLO, F3Z_N3LO, res(-6:7)
    real(dp) :: F3gZ_LO, F3gZ_NLO, F3gZ_NNLO, F3gZ_N3LO, F3LO, F3NLO, F3NNLO, F3N3LO, &
            & prop
    integer  :: iy
    !F3 Wp Wm Z
    write(idev,'(a,f10.4,a,f10.4)') '# Q = ', Qtest
    write(idev,'(a,a)') '# x  F3Wp(LO) F3Wm(LO) F3Wp(NLO) F3Wm(NLO) F3Wp(NNLO) F3Wm(NNLO)', &
          & ' F3Wp(N3LO) F3Wm(N3LO) F3Z(LO) F3Z(NLO) F3Z(NNLO) F3Z(N3LO)'
    mF = sf_muF(Qtest)
    mR = sf_muR(Qtest)
    do iy = nx, 0, -1
       ytest = logxomx_max + iy * (logxomx_min - logxomx_max) / nx
       xval = exp(-ytest)/(one+exp(-ytest))
       ytest = - log(xval)
       res = F_LO(xval, Qtest, mR, mF)
       write(idev,'(3es22.12)',advance='no') xval, res(iF3Wp),res(iF3Wm)
       F3Z_LO = res(iF3Z)
       F3gZ_LO = res(iF3gZ)
       res = F_NLO(xval, Qtest, mR, mF)
       write(idev,'(2es22.12)',advance='no') res(iF3Wp), res(iF3Wm)
       F3Z_NLO = res(iF3Z)
       F3gZ_NLO = res(iF3gZ)
       res = F_NNLO(xval, Qtest, mR, mF)
       write(idev,'(2es22.12)',advance='no') res(iF3Wp), res(iF3Wm)
       F3Z_NNLO = res(iF3Z)
       F3gZ_NNLO = res(iF3gZ)
       res = F_N3LO(xval, Qtest, mR, mF)
       write(idev,'(2es22.12)',advance='no') res(iF3Wp), res(iF3Wm)
       F3Z_N3LO = res(iF3Z)
       F3gZ_N3LO = res(iF3gZ)
       ! Before printing we dress the F3 structure functions with the appropriate couplings 
       ! as defined in for instance the pink book (notice that there are typos in these 
       ! equations in the pink book) eqs. 4.20-4.21
       prop   = Qtest**2 / (Qtest**2 + MZ**2) / sin_2thw_sq
       F3LO   = - (Ae * prop * F3gZ_LO   - two_Ve_Ae * prop**2 * F3Z_LO)   * 0.5_dp
       F3NLO  = - (Ae * prop * F3gZ_NLO  - two_Ve_Ae * prop**2 * F3Z_NLO)  * 0.5_dp
       F3NNLO = - (Ae * prop * F3gZ_NNLO - two_Ve_Ae * prop**2 * F3Z_NNLO) * 0.5_dp
       F3N3LO = - (Ae * prop * F3gZ_N3LO - two_Ve_Ae * prop**2 * F3Z_N3LO) * 0.5_dp
       write(idev,'(4es22.12)',advance='no') F3LO, F3NLO, F3NNLO, F3N3LO
       write(idev,*)
    end do
    write(idev,*)
    write(idev,*)
  end subroutine write_f3_benchmark

end program structure_functions_benchmark_checks

!
! First results: in general, need to watch out for placing 
!                first Q bin too low, because it "cuts" the evolution
!                and one doesn't really get the full result
!
! Worst channel for Q case is b+bbar
!
! Actually "best" way of testing Q evolution might be to 
! rerun the evolution from scratch each time, maybe even in a
! fixed-flavour number scheme? Answers might change by a factor of
! two roughly.
!
! Where first Qval is 5.0 GeV, in a VFNS, we're basically seeing
! NB: this is all wrong....

! du       err (always channel 11 = b+bbar, Q=5,y=0.1)
! 0.150    2.658068E-04
! 0.100    6.027373E-05
! 0.070    1.308940E-05
! 0.050    4.379481E-06
! 0.035    8.875060E-07
! 0.025    2.433153E-07
!
! The best channels seem to be uv,dv,ubar+dbar,s+sbar, about 6-10
! times better.
! 
! The above results correspond roughly to expectation of eps^4
module accuracy_helper
   use hoppet; use sort !(not included with hoppet)
  implicit none

  private

  integer, parameter, public :: accflv_n = 13
  integer, parameter, public :: accflv_g   = 1  ! gluon
  integer, parameter, public :: accflv_sng = 2  ! singlet
  integer, parameter, public :: accflv_uv  = 3  ! u - ubar
  integer, parameter, public :: accflv_dv  = 4  ! d - dbar
  integer, parameter, public :: accflv_umd = 5  ! u - d
  integer, parameter, public :: accflv_Lp  = 6  ! ubar + dbar
  integer, parameter, public :: accflv_Lm  = 7  ! ubar - dbar
  integer, parameter, public :: accflv_ss  = 8  ! s + sbar
  integer, parameter, public :: accflv_cs  = 9  ! c + cbar
  integer, parameter, public :: accflv_bs  = 10 ! b + bbar
  integer, parameter, public :: accflv_sv  = 11 ! s - sbar
  integer, parameter, public :: accflv_cv  = 12 ! c - cbar
  integer, parameter, public :: accflv_bv  = 13 ! b - bbar

  character(len=10), parameter, public :: accflv_names(accflv_n) = (/&
       "gluon    ", & ! accflv_g   = 1  !
       "singlet  ", & ! accflv_sng = 2  !
       "u-ubar   ", & ! accflv_uv  = 3  !
       "d-dbar   ", & ! accflv_dv  = 4  !
       "u-d      ", & ! accflv_umd = 5  !
       "ubar+dbar", & ! accflv_Lp  = 6  !
       "ubar-dbar", & ! accflv_Lm  = 7  !
       "s+sbar   ", & ! accflv_ss  = 8  !
       "c+cbar   ", & ! accflv_cs  = 9  !
       "b+bbar   ", & ! accflv_bs  = 10 !
       "s-sbar   ", & ! accflv_sv  = 11 !
       "c-cbar   ", & ! accflv_cv  = 12 !
       "b-bbar   "/)  ! accflv_bv  = 13 !

  public :: FillRefTable

  real(dp), parameter :: delta_y = 0.03_dp

  interface percentiles
     module procedure percentiles_1d, percentiles_2d, percentiles_3d
  end interface
  public :: percentiles

  public :: add_du_info

contains

  !======================================================================
  !! given a grid return a table of distributions, and optionally
  !! return a table of reference normalizations -- these are identical
  !! to the distributions except when there is a nearby sign change, in
  !! which case they are deduced from the average of the function
  !! at y+-delta_y.
  !!
  !! Currently best suited to cases where all(Qvals > Qinit)
  subroutine FillRefTable(grid, dh, yvals, Qvals, table, table_norm)
    type(grid_def),     intent(in)  :: grid
    type(dglap_holder), intent(in)  :: dh
    real(dp),           intent(in)  :: yvals(:), Qvals(:)
    real(dp),           intent(out) :: table(:,:,:)
    real(dp), optional, intent(out) :: table_norm(:,:,:)
    !--------------------------
    type(running_coupling) :: coupling
    integer :: ny, nQ, nflv, iQ, iy
    real(dp)          :: lastQ, slice(-6:6)
    real(dp)          :: accref_yplus(accflv_n), accref_yminus(accflv_n)
    real(dp), pointer :: pdf(:,:)
    real(dp)          :: Qinit

    ny   = assert_eq(size(yvals),size(table,1),'FillRefTable')
    nQ   = assert_eq(size(Qvals),size(table,3),'FillRefTable')
    nflv = assert_eq(accflv_n,   size(table,2),'FillRefTable')

    call AllocPDF(grid, pdf)
    pdf = unpolarized_dummy_pdf(xValues(grid))
    Qinit = sqrt(two)  ! Vogt starting scale

    call InitRunningCoupling(coupling,alfas=0.35_dp,Q=Qinit,nloop=3)

    lastQ = Qinit
    do iQ = 1, nQ
       call evolvePDF(dh, pdf, coupling, lastQ, Qvals(iQ))
       lastQ = Qvals(iQ)
       
       do iy = 1, ny
          slice = pdf(:,-6:6) .aty. (yvals(iy).with.grid)
          table(iy,:,iQ) = human2acc(slice)
          if (present(table_norm)) then
             accref_yplus  = human2acc(pdf(:,-6:6) .aty. (&
                  &           (yvals(iQ)+delta_y).with.grid))
             accref_yminus = human2acc(pdf(:,-6:6) .aty. (&
                  &           max(zero,yvals(iQ)-delta_y).with.grid))
             ! look out for sign changes
             where(accref_yplus*accref_yminus < zero)
                ! essentially take derivative as normalisation
                ! ( == we will look at error on position of zero).
                table_norm(iy,:,iQ) = &
                     &              (abs(accref_yplus - accref_yminus))&
                     &               / (two*delta_y)
             else where
                table_norm(iy,:,iQ) = abs(table(iy,:,iQ))
             end where
          end if
       end do
       
    end do

    ! eliminate problems associated with sign changes in Q...
    ! (recall we have already taken abs value).
    do iQ = 2, nQ-1
       where (table_norm(:,:,iQ) < table_norm(:,:,iQ+1) .and. &
            & table_norm(:,:,iQ) < table_norm(:,:,iQ-1))
          table_norm(:,:,iQ) = half * &
               &    (table_norm(:,:,iQ-1)+table_norm(:,:,iQ+1))
       end where
    end do
    

    call Delete(coupling)
    call Delete(pdf)
  end subroutine FillRefTable
  

  !======================================================================
  !! Given a pdf slice in "human" format, return one in the format
  !! needed for our accuracy tests (marginally different from those
  !! used with Vogt).
  function human2acc(slice) result(accslice)
    real(dp), intent(in) :: slice(ncompmin:)
    real(dp)             :: accslice(accflv_n)

    accslice(accflv_g  ) = slice(iflv_g)
    accslice(accflv_sng) = sum(slice(1:6)) + sum(slice(-6:-1))
    accslice(accflv_uv ) = slice(iflv_u   ) - slice(iflv_ubar)
    accslice(accflv_dv ) = slice(iflv_d   ) - slice(iflv_dbar)
    accslice(accflv_umd) = slice(iflv_u   ) - slice(iflv_d   )
    accslice(accflv_Lp ) = slice(iflv_ubar) + slice(iflv_dbar)
    accslice(accflv_Lm ) = slice(iflv_ubar) - slice(iflv_dbar)
    accslice(accflv_ss ) = slice(iflv_s   ) + slice(iflv_sbar)
    accslice(accflv_cs ) = slice(iflv_c   ) + slice(iflv_cbar)
    accslice(accflv_bs ) = slice(iflv_b   ) + slice(iflv_bbar)
    accslice(accflv_sv ) = slice(iflv_s   ) - slice(iflv_sbar)
    accslice(accflv_cv ) = slice(iflv_c   ) - slice(iflv_cbar)
    accslice(accflv_bv ) = slice(iflv_b   ) - slice(iflv_bbar)

  end function human2acc
  

  !======================================================================
  !! The dummy PDF suggested by Vogt as the initial condition for the 
  !! unpolazrized evolution
  function unpolarized_dummy_pdf(xvals) result(dummy_pdf)
    real(dp), intent(in) :: xvals(:)
    real(dp)             :: dummy_pdf(size(xvals),ncompmin:ncompmax)
    real(dp) :: uv(size(xvals)), dv(size(xvals))
    real(dp) :: ubar(size(xvals)), dbar(size(xvals))
    !---------------------
    real(dp), parameter :: N_g = 1.7_dp, N_ls = 0.387975_dp
    real(dp), parameter :: N_uv=5.107200_dp, N_dv = 3.064320_dp
    real(dp), parameter :: N_db = half*N_ls
  
    dummy_pdf = zero ! automatically in human rep

    !-- remember that these are all xvals*q(xvals)
    uv = N_uv * xvals**0.8_dp * (1-xvals)**3
    dv = N_dv * xvals**0.8_dp * (1-xvals)**4
    dbar = N_db * xvals**(-0.1_dp) * (1-xvals)**6
    ubar = dbar * (1-xvals)
    dummy_pdf(:,iflv_g) = N_g * xvals**(-0.1_dp) * (1-xvals)**5
        
    dummy_pdf(:,-iflv_s) = 0.2_dp*(dbar + ubar)
    dummy_pdf(:, iflv_s) = dummy_pdf(:,-iflv_s)
    dummy_pdf(:, iflv_u) = uv + ubar
    dummy_pdf(:,-iflv_u) = ubar
    dummy_pdf(:, iflv_d) = dv + dbar
    dummy_pdf(:,-iflv_d) = dbar
  end function unpolarized_dummy_pdf


  !======================================================================
  !! Return the percentiles of array as requested in percentiles_wanted,
  !! optionally masked.
  !!
  !! Solution used (sort compacted version of masked array) is OK if
  !! mask is one-off or there are many small masks, but suboptimal if
  !! one repeatedly investigates masks which are nearly always 1 [in
  !! that case a better solution would be to sort the array once and 
  !! for all and then work out the percentiles of subsets of the
  !! sorted array].
  !!
  !! Percentiles should be as a fraction of 1.
  function percentiles_1d(array,percentiles_wanted, mask) result(res)
    real(dp), intent(in), target   :: array(:), percentiles_wanted(:)
    logical,  intent(in), optional :: mask(:)
    real(dp)                       :: res(size(percentiles_wanted))
    !------------------------------------------------------
    real(dp), target  :: masked_array(size(array))
    real(dp), pointer :: ref_array(:)
    integer           :: n, i, ell, index_array(size(array))

    if (present(mask)) then
       ! make a compact copy of the masked array
       ell = 0
       do i = 1, size(array)
          if (mask(i)) then
             ell = ell + 1
             masked_array(ell) = array(i)
          end if
       end do
       ref_array => masked_array(1:ell)
    else
       ref_array => array(:)
    end if
    
    n = size(ref_array)
    forall(i = 1:n) index_array(i) = i
    call indexx(ref_array, index_array(1:n))

    forall(i = 1:size(percentiles_wanted)) 
       res(i) = ref_array(index_array(max(1,nint(percentiles_wanted(i)*n))))
    end forall
  end function percentiles_1d


  !======================================================================
  !! 2d version of percentiles
  function percentiles_2d(array, percentiles_wanted, mask) result(res)
    real(dp), intent(in), target   :: array(:,:), percentiles_wanted(:)
    logical,  intent(in), optional :: mask(:,:)
    real(dp)                       :: res(size(percentiles_wanted))
    !-----------------------------------------------------
    real(dp), target  :: masked_array(size(array))
    integer           :: i, j, ell
    if (present(mask)) then
       ! make a compact copy of the masked array
       ell = 0
       do j = 1, size(array,2)
          do i = 1, size(array,1)
             if (mask(i,j)) then
                ell = ell + 1
                masked_array(ell) = array(i,j)
             end if
          end do
       end do
       res = percentiles(masked_array(1:ell), percentiles_wanted)
    else
       masked_array = reshape(array,(/ size(array) /))
       res = percentiles(masked_array, percentiles_wanted)
    end if
  end function percentiles_2d
  

  !======================================================================
  !! 3d version of percentiles
  function percentiles_3d(array, percentiles_wanted, mask) result(res)
    real(dp), intent(in), target   :: array(:,:,:), percentiles_wanted(:)
    logical,  intent(in), optional :: mask(:,:,:)
    real(dp)                       :: res(size(percentiles_wanted))
    !-----------------------------------------------------
    real(dp), target  :: masked_array(size(array))
    integer           :: i, j, k, ell
    if (present(mask)) then
       ! make a compact copy of the masked array
       ell = 0
       do k = 1, size(array,3)
          do j = 1, size(array,2)
             do i = 1, size(array,1)
                if (mask(i,j,k)) then
                   ell = ell + 1
                   masked_array(ell) = array(i,j,k)
                end if
             end do
          end do
       end do
       res = percentiles(masked_array(1:ell), percentiles_wanted)
    else
       masked_array = reshape(array,(/ size(array) /))
       res = percentiles(masked_array, percentiles_wanted)
    end if
  end function percentiles_3d


  !======================================================================
  !! takes a grid info string and adds info on current du
  subroutine add_du_info(string,du)
    character(len=*), intent(inout) :: string
    real(dp),         optional      :: du
    !-------------------
    character(len=80) duinfo

    write(duinfo,'("|du=",f6.4)') default_or_opt(DefaultEvolutionDu(),du)
    string = trim(string)//trim(duinfo)
  end subroutine add_du_info
  
end module accuracy_helper


!======================================================================
!! Program options
!! -du duval :   establish quality of specified duval
!! -dytable  :   run with a table of ty
!! -big -div2 n -div3 n : loop over ymax vals, orders, dy
program determine_accuracies
   use hoppet; use io_utils
  use accuracy_helper
  implicit none
  real(dp)           :: ymax = 12.0_dp, dy_ref, dy, du_ref
  type(grid_def)     :: grid_ref, grid, gridarray(5)
  type(dglap_holder) :: dh_ref, dh
  integer            :: iy, iQ, i
  integer, parameter :: ny = 443, nQ = 6, ref_order=5
  ! leave quite a large spacing otherwise with coarse Q grid we
  ! learn very little...
  real(dp), parameter :: Qvals(nQ) = &
       &       (/5.0_dp,10.0_dp,30.0_dp,100.0_dp,1000.0_dp,1e4_dp/)
  real(dp), target :: yvals(ny), table(ny,accflv_n,nQ), du
  real(dp), target :: reftable(ny,accflv_n,nQ), reftable_norm(ny,accflv_n,nQ)
  real             :: test_run_time = 0, test_init_time = 0, start_time

  character(len=80) :: grid_string_ref, grid_string_test
  integer           :: outdev

  if (log_val_opt('-out')) then
     outdev = idev_open_opt("-out")
  else
     outdev = 6
  end if

  write(outdev,'(a)') '# '//trim(command_line())

  !dy_ref = 0.0125_dp
  dy_ref = dble_val_opt('-dy_ref',0.10_dp)
  du_ref = dble_val_opt('-du_ref',0.01_dp)
  write(0,*) 'dy_ref = ', dy_ref
  write(0,*) 'du_ref = ', du_ref
  call InitGridDef(gridarray(3),dy_ref/9.0_dp, 0.5_dp, ref_order)
  call InitGridDef(gridarray(2),dy_ref/3.0_dp, 2.0_dp, ref_order)
  call InitGridDef(gridarray(1),dy_ref,        ymax,   ref_order)
  call InitGridDef(grid_ref, gridarray(1:3), locked=.true.)
  call Delete(gridarray(1:3))

  call InitDglapHolder(grid_ref,dh_ref,nloop=3,nflo=3,nfhi=6)
  write(0,*) 'Reference initialisation done'

  ! uniform spacing (maybe non-uniform would be better?)
  forall(iy=1:ny) yvals(iy) = 0.1_dp + (iy-1)*(ymax-0.1_dp)/(ny-1)

  call SetDefaultEvolutionDu(du_ref)
  call GetGridInfoString(grid_ref,grid_string_ref)
  call add_du_info(grid_string_ref)

  call FillRefTable(grid_ref,dh_ref,yvals,Qvals,reftable,reftable_norm)

  if (log_val_opt('-du')) then
     du = dble_val_opt('-du')
     call SetDefaultEvolutionDu(du)
     write(outdev,*) "Evolution du = ", du
     grid = grid_ref
     dh   = dh_ref
     test_init_time = 0.0
     !call FillRefTable(grid,dh_ref,yvals,Qvals,table)
     call FillRefTable_with_timings()
     call printout_accuracies
  end if


  if (log_val_opt('-dytable')) then
     dy = 0.4
     do 
        if (dy < 2*dy_ref) exit
        call InitGridDef(gridarray(3),dy/9.0_dp, 0.5_dp, ref_order)
        call InitGridDef(gridarray(2),dy/3.0_dp, 2.0_dp, ref_order)
        call InitGridDef(gridarray(1),dy,        ymax,   ref_order)
        call InitGridDef(grid, gridarray(1:3), locked=.true.)
        call Delete(gridarray(1:3))

        call cpu_time(start_time)
        call InitDglapHolder(grid,dh,nloop=3,nflo=3,nfhi=6)
        call cpu_time(test_init_time); 
        test_init_time = test_init_time - start_time

        !call FillRefTable(grid,dh,yvals,Qvals,table)
        call FillRefTable_with_timings()
        call printout_accuracies

        call Delete(grid)
        call Delete(dh)
        dy = dy * 0.8_dp
     end do
  end if

  if (log_val_opt('-big')) call big_table

contains

  !======================================================================
  subroutine big_table
    real(dp) :: inner_ymax(1:3), lcl_ymax(1:3), dyarr(3)
    integer  :: order1,order2,order3, divisors(1:3), orders(3)
    integer, parameter :: inner_ymax_lims(2:3) = (/ 3.5_dp, 1.0_dp/)
    integer  :: ndone
    logical  :: dummy

    dummy = log_val_opt('-dummy')
    ndone = 0

    divisors(1) = 1
    divisors(2) = int_val_opt('-div2')
    divisors(3) = int_val_opt('-div3') * divisors(2)

    inner_ymax(1) = ymax

    ! ymax(3) loop
    inner_ymax(3) = 0.3_dp
    do 
       if (inner_ymax(3) > inner_ymax_lims(3)) exit

       ! ymax(2) loop
       inner_ymax(2) = 1.5_dp * inner_ymax(3)
       do
          if (inner_ymax(2) > inner_ymax_lims(2)) exit

          ! order loops
          do order1 = -6, 6
          do order2 = -6, 6
          do order3 = -6, 6

             orders = (/order1,order2,order3/)
             if (any(abs(orders) < 4)) cycle

             dy = 0.5
             do 
                if (dy < 2*dy_ref) exit

                ! adjust things to be exactly on-grid
                dyarr(1)  = ymax / nint(ymax/dy)
                dyarr(2:) = dyarr(1) / divisors(2:)
                
                lcl_ymax(1)  = ymax
                lcl_ymax(2:) = nint(inner_ymax(2:)/dyarr(2:))*dyarr(2:)

                ! check to make sure we have room for the orders
                ! we're asking for...
                !write(0,*) '-----------------------------'
                !write(0,*) dy
                !write(0,*) dyarr
                !write(0,*) lcl_ymax
                !write(0,*) orders
                !write(0,*) nint(lcl_ymax/dyarr)
                
                if (.not.any(nint(lcl_ymax/dyarr) < abs(orders)+1)) then
                   call InitGridDef(gridarray(3),dyarr(3), lcl_ymax(3), order3)
                   call InitGridDef(gridarray(2),dyarr(2), lcl_ymax(2), order2)
                   call InitGridDef(gridarray(1),dyarr(1), lcl_ymax(1), order1)
                   call InitGridDef(grid, gridarray(1:3), locked=.true.)
                   call Delete(gridarray(1:3))
                   
                   call cpu_time(start_time)
                   if (.not.dummy) &
                        &call InitDglapHolder(grid,dh,nloop=3,nflo=3,nfhi=6)
                   
                   call cpu_time(test_init_time); 
                   test_init_time = test_init_time - start_time
                   
                   !call FillRefTable(grid,dh,yvals,Qvals,table)
                   if (.not.dummy) then
                      call FillRefTable_with_timings()
                   else
                      table = zero
                   end if
                   !call printout_accuracies
                   if (.not.dummy .or. mod(ndone,1000)==0) call printout_accuracies
                   
                   call Delete(grid)
                   if (.not.dummy) call Delete(dh)
                   ndone = ndone + 1
                   write(0,*) ndone
                end if
                dy = dy * 0.8_dp
             end do ! dy loop
          end do
          end do
          end do    ! order loops

          inner_ymax(2) = inner_ymax(2) + 0.3_dp
       end do       ! inner_ymax(2) loop

       inner_ymax(3) = inner_ymax(3) + 0.1_dp
    end do          ! inner_ymax(3) loop
    
  end subroutine big_table



  !======================================================================
  subroutine FillRefTable_with_timings()
    real    :: ref_time
    integer :: nrun
    call cpu_time(ref_time); nrun = 0
    do
       call FillRefTable(grid,dh,yvals,Qvals,table)
       call cpu_time(test_run_time); nrun = nrun + 1
       test_run_time = test_run_time - ref_time
       if (test_run_time > 1.0) exit
    end do
    test_run_time = test_run_time / nrun
  end subroutine FillRefTable_with_timings


  !======================================================================
  !! A quick and dirty routine to print out accuracies, etc...
  subroutine printout_accuracies
    real(dp), pointer :: normtable(:,:,:)
    logical           :: ymask(ny,accflv_n,nQ)
    logical           :: flvmask(ny,accflv_n,nQ), flvmask2(ny,accflv_n,nQ)
    integer ::  iflv, posn(3,6), j
    !real(dp) :: percentls(6) = (/0.0_dp,0.5_dp, 0.9_dp, 0.99_dp, 0.999_dp, 1.0_dp /)
    real(dp) :: percentls(1) = (/0.99_dp/)
    real(dp) :: perc_res(size(percentls),6)

    forall (iy   = 1:ny) ymask(iy,:,:) = exp(-yvals(iy)) < 0.7_dp
    forall (iflv = 1:accflv_n) flvmask(:,iflv,:)  = iflv <=8
    forall (iflv = 1:accflv_n) flvmask2(:,iflv,:) = iflv <=5

    ! decide whether to use our special special table designed to
    ! avoid "dangerous zeros"
    if (log_val_opt('-norm')) then
       normtable => reftable_norm
    else
       normtable => reftable
    end if

    where (reftable /= zero)
       table = abs((table-reftable) / normtable)
    elsewhere
       table = zero
    end where

    posn(:,1) = maxloc(table)
    posn(:,2) = maxloc(table,ymask)            
    posn(:,3) = maxloc(table,flvmask)          
    posn(:,4) = maxloc(table,flvmask.and.ymask)
    posn(:,5) = maxloc(table,flvmask2)          
    posn(:,6) = maxloc(table,flvmask2.and.ymask)
    ! now get some percentiles
    perc_res(:,1) = percentiles(table,percentls)
    perc_res(:,2) = percentiles(table,percentls,ymask)            
    perc_res(:,3) = percentiles(table,percentls,flvmask)          
    perc_res(:,4) = percentiles(table,percentls,flvmask.and.ymask)
    perc_res(:,5) = percentiles(table,percentls,flvmask2)          
    perc_res(:,6) = percentiles(table,percentls,flvmask2.and.ymask)

    write(outdev,'(78("="))')
    write(outdev,'(a)') "Ref.: "//trim(grid_string_ref)
    call GetGridInfoString(grid,grid_string_test)
    call add_du_info(grid_string_test)
    write(outdev,'(a)') "Test: "//trim(grid_string_test)

    write(outdev,'(a,2es9.1,2f10.5)') & 
         & "Summary(max(4,5);99%(3);run/s;init/s):", &
         & max(table(posn(1,4),posn(2,4),posn(3,4)), &
         &     table(posn(1,5),posn(2,5),posn(3,5))),&
         & perc_res(:,3), &
         & test_run_time, &
         & test_init_time
    write(outdev,'(78("-"))')

    write(outdev,'("Accuracy/99%: ",es7.1," (chnl ",i2,")/",es7.1,&
         &" ; x<=0.7: ",es7.1," (chnl ",i2,")/",es7.1)') &
         & table(posn(1,1),posn(2,1),posn(3,1)), posn(2,1), perc_res(1,1),&
         & table(posn(1,2),posn(2,2),posn(3,2)), posn(2,2), perc_res(1,2)
    write(outdev,'("Acc(1-8)/99%: ",es7.1," (chnl ",i2,")/",es7.1,&
         &" ; x<=0.7: ",es7.1," (chnl ",i2,")/",es7.1)') &
         & table(posn(1,3),posn(2,3),posn(3,3)), posn(2,3), perc_res(1,3),&
         & table(posn(1,4),posn(2,4),posn(3,4)), posn(2,4), perc_res(1,4)
    write(outdev,'("Acc(1-5)/99%: ",es7.1," (chnl ",i2,")/",es7.1,&
         &" ; x<=0.7: ",es7.1," (chnl ",i2,")/",es7.1)') &
         & table(posn(1,5),posn(2,5),posn(3,5)), posn(2,5), perc_res(1,5),&
         & table(posn(1,6),posn(2,6),posn(3,6)), posn(2,6), perc_res(1,6)

    !write(outdev,'(a,es8.1,a,i2,a,es8.1,a,i2,a)') &
    !     &   'Worst acc(1-8):',table(posn(1,3),posn(2,3),posn(3,3)),&
    !     &   ' (channel ', posn(2,3),'); for x<=0.7:',&
    !     &   table(posn(1,4),posn(2,4),posn(3,4)),&
    !     &   ' (channel ', posn(2,4),')'
    !write(outdev,'(a,es8.1,a,i2,a,es8.1,a,i2,a)') &
    !     &   'Worst acc(1-5):',table(posn(1,5),posn(2,5),posn(3,5)),&
    !     &   ' (channel ', posn(2,5),'); for x<=0.7:',&
    !     &   table(posn(1,6),posn(2,6),posn(3,6)),&
    !     &   ' (channel ', posn(2,6),')'
    !do j = 1, size(percentls)
    !   write(outdev,'("percentile ",f6.3,":",6es8.1)') percentls(j), perc_res(j,:)
    !end do


    write(outdev,'(78("-"))')
    write(outdev,'(a2,a12,a8,a7,a8,a8," |",a8,a7,a8,a8)') &
         & "","channel","worst","y","Q","99%","x<0.7","y","Q","99%"
    write(outdev,'(78("-"))')
    do iflv = 1, accflv_n
       posn((/1,3/),1) = maxloc(table(:,iflv,:))
       posn((/1,3/),2) = maxloc(table(:,iflv,:),ymask(:,iflv,:))
       perc_res(:,1) = percentiles(table(:,iflv,:),percentls(:))
       perc_res(:,2) = percentiles(table(:,iflv,:),percentls(:),ymask(:,iflv,:))
       write(outdev,&
            &'(i2,a12,es8.1,f7.3,f8.1,es8.1," |",es8.1,f7.3,f8.1,es8.1)') &
            &  iflv, accflv_names(iflv), &
            &   table(posn(1,1),iflv,posn(3,1)),&  
            &   yvals(posn(1,1)), Qvals(posn(3,1)),&
            &   perc_res(:,1), &
            &   table(posn(1,2),iflv,posn(3,2)),&  
            &   yvals(posn(1,2)), Qvals(posn(3,2)),&
            &   perc_res(:,2)
       if (iflv == 5 .or. iflv == accflv_n) write(outdev,'(78("-"))')
    end do
  end subroutine printout_accuracies

end program determine_accuracies

!
! run this with
!
! ./test_qed_evol_lhapdf -Qlo 3.0 -Qhi 100  -pdf CT14qed_proton -nqcdloop-qed 0  -x 1e-3 >! a
!
!
!! TESTS
!! * Test against plain qcd evolution, with QED alpha turned to zero
!!   -> works OK, but watch out for the fact that the tau introduces
!!      an extra threshold, so that numerically there are differences
!!      at the evolution precision; reducing du by a factor of 10
!!      significantly reduces these differences. See basic test output with
!!   ./test_qed_evol_lhapdf -no-qed -x 0.5 | grep moment
!!   ./test_qed_evol_lhapdf -alpha-qed 0 -x 0.5 | grep moment
!!
!! * test momentum sum rule, with both nqcdloop_qed values
!!   -> this seems to work fine, e.g. test with
!!      ./test_qed_evol_lhapdf -ymax 25 -nqcdloop-qed 0 |& grep moment
!!      ./test_qed_evol_lhapdf -ymax 25 -nqcdloop-qed 1 |& grep moment
!!
!! * compare to photon evolution from another source?
!!   -> done in with-lhapdf/test_qed_evol_lhapdf.f90
!!      generally, answers are to within O(1%) of the MRST2004qed and
!!      CT14qed_proton results for evolution from 3 to 100 GeV. E.g.
!!    ./test_qed_evol_lhapdf -Qlo 3.0 -Qhi 100  -pdf CT14qed_proton -nqcdloop-qed 0  -x 1e-3 >! a
!!
program test_qed_evol
   use hoppet
  use qed_evolution; use qed_objects; use qed_coupling_module
  use io_utils
  implicit none
  character(len=200) :: pdfname
  type(grid_def)      :: grid
  type(qed_split_mat) :: qed_split
  type(dglap_holder)  :: dh
  real(dp)               :: quark_masses(4:6)
  type(running_coupling) :: coupling
  type(qed_coupling)     :: coupling_qed
  real(dp)               :: ymax, dy, x, alphas_mz, lha_qmin
  real(dp), parameter    :: mz = 91.1876_dp
  real(dp), pointer :: pdf_in(:,:), pdf_out(:,:)
  real(dp)         :: Qlo, Qhi, moments(ncompmin:ncompmaxLeptons)
  integer :: compact_output_n = -1
  integer :: nloop_qcd = 3, nqcdloop_qed, imem, iflv, iunit
  logical :: no_qed

  if (log_val_opt("-out")) then
     iunit = idev_open_opt("-out")
  else
     iunit = 6
  end if
  compact_output_n = int_val_opt("-compact-output", compact_output_n)
  
  write(iunit,'(a)') "# "//trim(command_line())

  ymax  = dble_val_opt("-ymax",20.0_dp)
  dy    = dble_val_opt("-dy",0.1_dp)
  call InitGridDefDefault(grid, dy, ymax)
  write(iunit,'(a,2f10.6)') "# ymax, dy ", ymax, dy

  ! allow option to just write out the x values of the grid
  ! and exit
  if (log_val_opt("-xvalues")) then
     write(iunit,"(a)") "# next lines contain number of x values, and actual x values"
     write(iunit,*) grid%ny+1
     write(iunit,*) xValues(grid)
     stop
  end if

  Qlo = m_electron * 1.00001_dp ! the initial scale
  Qhi = 40.0_dp
  Qlo = sqrt(dble_val_opt("-Q2lo", Qlo**2))
  Qhi = sqrt(dble_val_opt("-Q2hi", Qhi**2))
  Qlo = dble_val_opt("-Qlo",Qlo)
  Qhi = dble_val_opt("-Qhi",Qhi)
  write(iunit,'(a,es14.6)') "# Qlo = ", Qlo
  write(iunit,'(a,es14.6)') "# Qhi = ", Qhi


  quark_masses(4:6) = (/1.414213563_dp, 4.5_dp, 175.0_dp/)
  alphas_mz = 0.118_dp
  write(iunit,*) '# quark masses (c,b,t) = ', quark_masses
  

  nloop_qcd = int_val_opt("-nloop-qcd",nloop_qcd)
  write(iunit,*) "# nloop_qcd = ", nloop_qcd

  nqcdloop_qed = int_val_opt('-nqcdloop-qed',0)
  write(iunit,*) "# nqcdloop_qed = ", nqcdloop_qed
  
  no_qed = log_val_opt("-no-qed",.false.)

  x = dble_val_opt("-x",1e-3_dp)

  
  call SetDefaultEvolutionDu(dy/3.0_dp)  ! generally a good choice
  call InitQEDSplitMat(grid, qed_split)
  call InitDglapHolder(grid,dh,factscheme=factscheme_MSbar,&
       &                      nloop=nloop_qcd,nflo=3,nfhi=6)


  call InitRunningCoupling(coupling,alfas=alphas_mz,Q=mz,nloop=nloop_qcd,&
       &                   quark_masses = quark_masses)
  if (log_val_opt("-alpha-qed")) then
     call InitQEDCoupling(coupling_qed, quark_masses(4), quark_masses(5), quark_masses(6), &
          &               dble_val_opt("-alpha-qed"))
  else
     call InitQEDCoupling(coupling_qed, quark_masses(4), quark_masses(5), quark_masses(6))
  end if

  
  write(iunit,*) "# 1/QED coupling at Me = ", one/Value(coupling_qed,m_electron)
  write(iunit,*) "# 1/QED coupling at MZ = ", one/Value(coupling_qed,MZ)
  write(iunit,*) "# QCD coupling at MZ = ", Value(coupling,MZ)
  write(iunit,*) "# Qlo, Qhi ", Qlo, Qhi
  
  call AllocPDFWithLeptons(grid, pdf_in)
  call AllocPDFWithLeptons(grid, pdf_out)
  
  pdf_in = zero
  ! then add in a lepton of some kind
  pdf_in(:,iflv_electron) = electron_dummy_pdf(xValues(grid))
  

  if (.not.CheckAllArgsUsed(0)) stop

  pdf_out = pdf_in
  if (no_qed) then
     call EvolvePDF(dh, pdf_out(:,ncompmin:ncompmax), coupling, Qlo, Qhi, nloop=nloop_qcd)
  else
     call QEDQCDEvolvePDF(dh, qed_split, pdf_out, coupling, coupling_qed,&
          &               Qlo, Qhi, nloop_qcd, nqcdloop_qed)
  end if
     

  call write_moments(pdf_in, ' in')
  call write_moments(pdf_out,'out')
  call write_pdf(pdf_in,'in')
  call write_pdf(pdf_out,'out')

  write(0,*) 'x = ', x, 'Q = ', Qhi
  write(0,'(a5,4a17)') 'iflv','hoppet'
  do iflv = -6, 11
     write(0,'(i5,4f17.7)') iflv, pdf_out(:,iflv).atx.(x.with.grid)
  end do
  
contains
  
  !----------------------------------------------------------------------
  subroutine write_moments(pdf,label)
    real(dp),         intent(in) :: pdf(0:,ncompmin:)
    character(len=*), intent(in) :: label
    !-----------------
    real(dp) :: moments(ncompmin:ubound(pdf,dim=2))
    
    write(iunit,"(a)", advance="no") "# total momentum "//trim(label)//" (& components)"
    moments = TruncatedMoment(grid, pdf, one)
    write(iunit,"(40f10.7)") sum(moments), moments

    write(iunit,"(a)", advance="no") "# total number "//trim(label)//" (& components)"
    moments(1:6) = TruncatedMoment(grid, pdf(:,1:6)-pdf(:,-1:-6:-1), zero)
    write(iunit,"(40f11.7)") sum(moments(1:6)), moments(1:6)


  end subroutine write_moments
  
  
  !----------------------------------------------------------------------
  subroutine write_pdf(pdf,label)
    real(dp), intent(in) :: pdf(0:,ncompmin:)
    character(len=*), intent(in) :: label
    !----------------------
    real(dp) :: y, yVals(0:grid%ny), last_y
    real(dp) :: zeta, zeta_max, a_stretch=7.0_dp, pdf_val
    integer  :: i,j

    write(iunit,"(a)") "# pdf "//trim(label)
    !do i = 0, 100
    !   y = 0.1_dp * i
    !   write(iunit,*) y, pdf.aty.(y.with.grid)
    !end do
    if (compact_output_n > 0) then
       ! value of compact_output_n sets number of points being written
       zeta_max = zeta_of_y(grid%ymax, a_stretch)
       do i = 0, compact_output_n
          zeta = (i*zeta_max)/compact_output_n
          y = y_of_zeta(zeta, a_stretch)
          write(iunit,'(f10.6)',advance="no") y
          do j = lbound(pdf,dim=2), ubound(pdf,dim=2)
             pdf_val = pdf(:,j).aty.(y.with.grid)
             if (abs(pdf_val) < 1e-100_dp) then
                write(iunit,'(a)',advance='no') ' 0 '
             else
                write(iunit,'(es14.6)',advance='no') pdf_val
             end if
          end do
          write(iunit,*)
       end do
    else
       last_y = -one
       yVals = yValues(grid)
       do i = 0, grid%ny
          y = yVals(i)
          if (y < 1.000000001_dp * last_y) cycle
          write(iunit,*) y, pdf(i,:)
          last_y = y
       end do
    end if
    
    write(iunit,*)
    write(iunit,*)
    
  end subroutine write_pdf
  

  function electron_dummy_pdf(xvals) result(pdf)
    implicit none
    real(dp), intent(in) :: xvals(0:)
    real(dp)             :: pdf(0:ubound(xvals,1))
    pdf = xvals**2 * (one-xvals)**4 * 100.0_dp
  end function electron_dummy_pdf
  
  
  !-----------------------------------------------------------------
  !! return zeta = ln 1/x + a*(1-x)  (x = exp(-y))
  function zeta_of_y(y, a) result(zeta)
    real(dp), intent(in) :: y, a
    real(dp)             :: zeta
    zeta = y + a*(one - exp(-y))
  end function zeta_of_y

  
  !-----------------------------------------------------------------
  !! return inversion of zeta = ln 1/x + a*(1-x)  (x = exp(-y))
  function y_of_zeta(zeta, a) result(y)
    real(dp), intent(in) :: zeta, a
    real(dp)             :: y, x, diff_from_zero, deriv
    integer             :: iter
    real(dp), parameter :: eps = 1e-12_dp
    integer,  parameter :: maxiter = 100

    ! starting condition (and soln if a = 0)
    y = zeta 
    if (a /= zero) then
       do iter = 0, maxiter
          x = exp(-y);
          diff_from_zero = zeta - y - a*(one-x);
          ! we have found good solution
          if (abs(diff_from_zero) < eps) exit
          deriv = -one  - a*x;
          y = y - diff_from_zero / deriv;
       end do
    end if
    
    if (iter > maxiter) write(0,*) "y_of_zeta reached maxiter"

  end function y_of_zeta

end program test_qed_evol

module qed_evolution
  use types; use consts_dp
  use dglap_objects; use qcd_coupling
  use assertions; use qcd
  use qed_coupling_module
  use qed_objects
  use warnings_and_errors
  use dglap_holders; use pdf_representation
  ! this is shared with the main QCD evolution
  use evolution_helper
  implicit none

  private

  public :: QEDQCDEvolvePDF
  
  type(qed_split_mat), save :: qed_sm_copy
  integer             :: ev_nqcdloop_qed
  type(qed_coupling), pointer :: ev_coupling_qed
  logical, public :: ev_with_Plq_nnloqed=.false.
  
contains

  subroutine QEDQCDEvolvePDF(dh, qed_sm, pdf, coupling_qcd, coupling_qed,&
       &                     Q_init, Q_end, nloop_qcd, nqcdloop_qed, with_Plq_nnloqed)
    type(dglap_holder),     intent(in), target :: dh
    type(qed_split_mat),    intent(in), target :: qed_sm
    type(running_coupling), intent(in), target :: coupling_qcd
    type(qed_coupling),     intent(in), target :: coupling_qed
    
    real(dp),               intent(inout)      :: pdf(0:,ncompmin:)
    real(dp),               intent(in)         :: Q_init, Q_end
    integer,                intent(in)         :: nloop_qcd
    integer,                intent(in)         :: nqcdloop_qed
    logical,  optional,     intent(in)         :: with_Plq_nnloqed
    !------------------------------------------------------
    ! iqed indicates which momentum region of the QED coupling
    ! we are working in
    integer  :: iqed, iqed_init, iqed_end, nflav(3), direction
    integer  :: nf_old, nf_new
    real(dp) :: lcl_Q_init, lcl_Q_end
    type(dglap_holder)  :: dhcopy
    type(running_coupling), target :: coupling_qcd_zero

    ! create a zero QCD coupling for use when scale is too low
    ! (it's really a dummy coupling, just to satisfy some constraints
    ! from the evolution.f90 module)
    call InitRunningCoupling(coupling_qcd_zero, alfas=0.0_dp, Q=1.0_dp, nloop = 0)
    
    ! these copies are cheap, because they just copy pointers
    dhcopy = dh
    qed_sm_copy = qed_sm
    ev_coupling_qed => coupling_qed
    
    ! set up "global" constants in evolution_helper module
    ev_ash => coupling_qcd
    call ev_SetModuleConsts(coupling=coupling_qcd, muR_Q=one, &
         &                  nloop=nloop_qcd, untie_nf=.false.)
    if (ev_nloop > dhcopy%nloop) &
         &call wae_error('QEDQCDEvolvePDF: dh%nloop must be >= nloop')
    
    ! establish evolution direction
    if (Q_end >= Q_init) then
       direction = 1
    else
       direction = -1
    end if

    ! establish which flavour regions we are working in
    ! (verify QCD and QED couplings have the same masses)
    if (QuarkMass(coupling_qcd,4) /= coupling_qed%thresholds(4)) call wae_Error("QED-QCD coupling mismatch of charm mass")
    if (QuarkMass(coupling_qcd,5) /= coupling_qed%thresholds(6)) call wae_Error("QED-QCD coupling mismatch of bottom mass")
    if (QuarkMass(coupling_qcd,6) /= coupling_qed%thresholds(7)) call wae_Error("QED-QCD coupling mismatch of top mass")
    iqed_init = iQEDThresholdAtQ(coupling_qed, Q_init)
    iqed_end  = iQEDThresholdAtQ(coupling_qed, Q_end )

    nf_old = coupling_qed%nflav(2,iqed_init) + coupling_qed%nflav(3,iqed_init)
    do iqed = iqed_init, iqed_end, direction
       ! there is no evolution to be done when iqed=0 (below electron mass)
       if (iqed == 0) cycle
       ! make sure we don't get into trouble here...
       if (iqed  > coupling_qed%n_thresholds) call wae_error("QEDQCDEvolvePDF", "iqed too high")
       if (direction == 1) then
          lcl_Q_init = max(Q_init, coupling_qed%thresholds(iqed  ))
          lcl_Q_end  = min(Q_end,  coupling_qed%thresholds(iqed+1))
       else
          lcl_Q_init = min(Q_init, coupling_qed%thresholds(iqed+1))
          lcl_Q_end  = max(Q_end,  coupling_qed%thresholds(iqed  ))
       end if

       
       ! set up the number of flavours
       ! (/ nleptons, ndown, nup /)
       nflav = coupling_qed%nflav(:,iqed)
       nf_new = nflav(2) + nflav(3)
       !write(0,*) lcl_Q_init, lcl_Q_end, nf_new
       call qcd_SetNf(nf_new)
       ! we can only handle QCD evolution when nf >= 3
       if (nf_new >= 3) then
          call SetNfDglapHolder(dhcopy, nf_new, QuarkMassesAreMSbar(coupling_qcd))
          ev_ash => coupling_qcd
          ev_force_old_dt = .false.
       else
          ev_ash => coupling_qcd_zero
          ! this ensures that we don't "intelligently" set the number of
          ! evolution steps to zero on the basis of a zero coupling...
          ev_force_old_dt = .true.
       end if
       call QEDSplitMatSetNf(qed_sm_copy, nflav(1), nflav(2), nflav(3))

       ! if we have changed nf, include threshold term; but only for transitions
       ! where one of the values is above three
       if (nf_new /= nf_old .and. nf_new >=3 .and. nf_old >= 3) then
          call ev_CrossMassThreshold(dhcopy,coupling_qcd,direction,pdf(:,:ncompmax))
       end if

       !!-- NOW PREPARE EVOLUTION
       ev_PLO  => dhcopy%P_LO
       if (ev_nloop >= 2) ev_PNLO => dhcopy%P_NLO
       if (ev_nloop >= 3) ev_PNNLO => dhcopy%P_NNLO
       if (ev_nloop >= 4) ev_PN3LO => dhcopy%P_N3LO
       if (ev_nloop >= 5) call wae_error('ev_evolve: nloop(QCD) > 4 not yet supported in QED evolution')

       ev_nqcdloop_qed = nqcdloop_qed
       ev_with_Plq_nnloqed = default_or_opt(.false., with_Plq_nnloqed)
       if (nqcdloop_qed > 1) call wae_error("QEDQCDEvolvePDF", "No support currently for nqcdloop_qed > 1")
       if (with_Plq_nnloqed .and. nqcdloop_qed == 0) then
         call wae_error("QEDQCDEvolvePDF", "with_Plq_nnloqed==.true. inconsistent with nqcdloop_qed == 0")
       end if

       call ev_evolveLocal(pdf, lcl_Q_init, lcl_Q_end, ev_conv_qed)
       
       nf_old = nf_new
    end do

    call Delete(coupling_qcd_zero)
  end subroutine QEDQCDEvolvePDF
  

  subroutine ev_conv_qed(u, pdf, dpdf)
    use convolution
    real(dp), intent(in)  :: u, pdf(0:,ncompmin:)
    real(dp), intent(out) :: dpdf(0:,ncompmin:)
    !--------------
    real(dp) :: alpha
    dpdf = zero

    ! get the QCD part of the evolution; NB: if alphas
    ! is zero, then this just returns a zero derivative,
    ! without trying to call any of the splitting functions
    ! (which may not be sensibly set up), but
    ! while still setting up things we need such as the
    ! jacobian.
    call ev_conv(u, pdf(:,:ncompmax), dpdf(:,:ncompmax))
    
    ! then get the QED and mixed QED-QCD parts, making use of the
    ! jacobian, as2pi and last_Q values made available in ev_conv
    alpha = Value(ev_coupling_qed, ev_conv_last_Q)

    dpdf = dpdf + (alpha/twopi * ev_conv_last_jacobian) * (qed_sm_copy%lo * pdf)

    if (ev_nqcdloop_qed >= 1) then
       dpdf = dpdf + (ev_conv_last_as2pi * alpha/twopi * ev_conv_last_jacobian) &
            &        * (qed_sm_copy%nlo * pdf)
    end if

    ! add Plq splitting at NNLO QED 
    if ( ev_with_Plq_nnloqed ) then
       dpdf = dpdf + ( (alpha/twopi)**2 * ev_conv_last_jacobian) &
            &        * (qed_sm_copy%nnlo * pdf)
    end if

  end subroutine ev_conv_qed
  
end module qed_evolution

!======================================================================
!! Program for checking that operations on splitting matrices behave
!! as expected. 
program split_mat_ops
  use hoppet
  implicit none
  type(grid_def)     :: grid
  type(split_mat)    :: PA, PB, PC
  type(dglap_holder) :: dh
  real(dp), pointer  :: pdf(:,:), pdfres(:,:)
  integer i

  ! choose grid in which multiplications of grid_conv are exactly
  ! commutative, and in which PA*PB*pdf is exactly associative (both
  ! to within machine precision) -- negative order ensures the former,
  ! the fact that we have a single grid (rather than subgrids) ensures
  ! the latter
  call InitGridDef(grid, dy=0.1_dp, ymax = 10.0_dp, order=-5)

  ! get some convenient ready-made splitting matrices
  do i = 1, 3
     call InitDglapHolder(grid, dh, nloop=2)
     call delete(dh)
  end do
  
  call InitDglapHolder(grid, dh, nloop=2)
  call AllocPDF(grid, pdf)
  pdf = unpolarized_dummy_pdf(xValues(grid))

  ! allocate space for result
  call AllocPDF(grid, pdfres)

  write(6,*) "The following tests are passed if the results are all"
  write(6,*) "zero to within machine precision"
  
  ! multiplication test
  call InitSplitMat(PA, dh%P_LO); call Multiply(PA,two)
  call InitSplitMat(PB, dh%P_LO, two)
  pdfres = PA*pdf - PB*pdf
  write(6,*) 'Multiplication test: ', maxval(pdfres(:,-6:6))

  ! convolution test
  call SetToConvolution(PC, dh%P_LO, dh%P_NLO)
  pdfres = PC*pdf - dh%P_LO*(dh%P_NLO*pdf)
  write(6,*) '(PA*PB)*pdf - PA*(PB*pdf): ', maxval(pdfres(:,-6:6))
  
  !! commutation test
  call SetToCommutator(PC, dh%P_LO, dh%P_NLO)
  pdfres = PC*pdf - (dh%P_LO*(dh%P_NLO*pdf)  - dh%P_NLO*(dh%P_LO*pdf))
  write(6,*) '[PA,PB]*pdf - (PA*(PB*pdf)-PB*(PA*pdf)): ', maxval(pdfres(:,-6:6))

  ! cleaning up
  call delete(PA)
  call delete(PB)
  call delete(PC)
  call delete(dh)
  call delete(grid)
  deallocate(pdf, pdfres)

contains

  !======================================================================
  !! The dummy PDF suggested by Vogt as the initial condition for the 
  !! unpolazrized evolution
  function unpolarized_dummy_pdf(xvals) result(dummy_pdf)
    real(dp), intent(in) :: xvals(:)
    real(dp)             :: dummy_pdf(size(xvals),-6:7)
    real(dp) :: uv(size(xvals)), dv(size(xvals))
    real(dp) :: ubar(size(xvals)), dbar(size(xvals))
    !---------------------
    real(dp), parameter :: N_g = 1.7_dp, N_ls = 0.387975_dp
    real(dp), parameter :: N_uv=5.107200_dp, N_dv = 3.064320_dp
    real(dp), parameter :: N_db = half*N_ls
  
    dummy_pdf = zero ! automatically in human rep

    !-- remember that these are all xvals*q(xvals)
    uv = N_uv * xvals**0.8_dp * (1-xvals)**3
    dv = N_dv * xvals**0.8_dp * (1-xvals)**4
    dbar = N_db * xvals**(-0.1_dp) * (1-xvals)**6
    ubar = dbar * (1-xvals)
    dummy_pdf(:,iflv_g) = N_g * xvals**(-0.1_dp) * (1-xvals)**5
        
    dummy_pdf(:,-iflv_s) = 0.2_dp*(dbar + ubar)
    dummy_pdf(:, iflv_s) = dummy_pdf(:,-iflv_s)
    dummy_pdf(:, iflv_u) = uv + ubar
    dummy_pdf(:,-iflv_u) = ubar
    dummy_pdf(:, iflv_d) = dv + dbar
    dummy_pdf(:,-iflv_d) = dbar
  end function unpolarized_dummy_pdf

end program split_mat_ops

!! A module that provides access to a quicksort form of sorting
!! routine. 
!!
!! Not clear that it is very efficient (e.g. compared to C++ stdlib
!! sort). It is based on the ideas behind NR indexx, but has been
!! rewritten (without looking at the NR f90 code) to avoid copyright
!! issues. Considerable tests have been performed [but no guarantees
!! are provided...!]
!!
module sort
  use types
  use warnings_and_errors
  use assertions
  implicit none
  private

  

  interface indexx
     module procedure indexx_dp, indexx_int
  end interface
  public :: indexx

  interface swap
     module procedure swap_int, swap_dp
  end interface
  public :: swap
  
  interface sort_array
     module procedure sort_array_dp
  end interface sort_array
  public :: sort_array
  
contains

  subroutine sort_array_dp(array)
    real(dp), intent(inout) :: array(:)
    !--------------------------------
    integer :: idx(size(array))
    real(dp) :: tmp(size(array))
    integer :: i
    call indexx(array, idx)
    tmp = array
    array = tmp(idx)
  end subroutine sort_array_dp
  
  
  !-------------------------------------------------------------------------
  !! A non-recursive version of the quick sort algorithm. It returns
  !! an array idx such that array(idx) is sorted.
  !!
  !! Following NR outline, it uses insertion for for sorting small
  !! sub-segments, sentinels to reduce the number of checks when
  !! pivoting and median of first, middle and last elements in order
  !! to select the pivot, to reduce the chances of the worst case
  !! (N^2) occurring.
  !!
  !! Note it uses a fixed-size stack, which is not so great an idea...
  !! (recursion would have had the advantage that this would not have
  !! been a problem).
  subroutine indexx_dp(array,idx)
    real(dp), intent(in)  :: array(:)
    integer,  intent(out) :: idx(size(array))
    !----------------------------------
    integer, parameter :: insertion_threshold = 7, stack_size = 50
    type lrpair
       integer :: l, r
    end type lrpair
    type(lrpair) :: stack(stack_size)
    integer  :: nmid, i, j, l, r, ixstack, medidx, n
    real(dp) :: medval
    
    !n = size(array)
    !if (n/=size(idx)) stop 'array and idx are different sizes'
    n = assert_eq(size(idx),size(array),'indexx_dp')

    forall(i=1:n) idx(i) = i
    
    ! push the whole array section onto the stack
    ixstack = 1
    stack(1) = lrpair(1,n); ixstack = 1
    do 
       ! pull an array section off the stack
       l = stack(ixstack)%l
       r = stack(ixstack)%r
       ixstack = ixstack - 1
       ! get to work on it
       if (r-l < insertion_threshold) then
          ! run an inlined insertion sort.
          do i = l+1, r
             medidx = idx(i)
             medval = array(medidx)
             ! look for the place where we should insert the element "medval", 
             ! and as we go about it, shift the other elements up by one
             do j = i-1, l, -1
                if (medval < array(idx(j))) then
                   idx(j+1) = idx(j)
                else
                   exit
                end if
             end do
             ! insert medval in its correct location
             idx(j+1) = medidx
          end do
       else
          ! NR idea is to take the median value of first, middle and
          ! last elements, so do a little insertion sort to get these
          ! three elements into order
          nmid = (l+r)/2
          ! first place the middle element in position l+1
          call swap(idx(l+1),idx(nmid))
          if (array(idx(l+1)) < array(idx(l))  ) call swap(idx(l+1),idx(l))
          if (array(idx(r))   < array(idx(l+1))) then
             call swap(idx(r),idx(l+1))
             if (array(idx(l+1)) < array(idx(l))) call swap(idx(l+1),idx(l))
          end if
          medidx = idx(l+1)
          medval = array(medidx)

          ! Then run up from first (non-trivial) element, and down from last
          ! element, swapping things as need be until i and j cross
          i = l+1; j = r
          do
             do 
                i = i + 1
                if (array(idx(i)) >= medval) exit
             end do
             do 
                j = j - 1
                if (array(idx(j)) <= medval) exit
             end do
             if (i > j) exit
             call swap(idx(i), idx(j))
          end do
          ! now insert medval (the partitioning element) into the
          ! correct position
          idx(l+1) = idx(j)
          idx(j)   = medidx

          ! now put things onto the stack
          if (ixstack+2 > stack_size) error stop 'stack too small'
          stack(ixstack+1) = lrpair(l,j-1)
          stack(ixstack+2) = lrpair(j,r)
          ixstack = ixstack + 2
       end if
       
       if (ixstack == 0) exit
    end do
    
  end subroutine indexx_dp



  !-------------------------------------------------------------------------
  !! A non-recursive version of the quick sort algorithm. It returns
  !! an array idx such that array(idx) is sorted.
  !!
  !! Following NR outline, it uses insertion for for sorting small
  !! sub-segments, sentinels to reduce the number of checks when
  !! pivoting and median of first, middle and last elements in order
  !! to select the pivot, to reduce the chances of the worst case
  !! (N^2) occurring.
  !!
  !! Note it uses a fixed-size stack, which is not so great an idea...
  !! (recursion would have had the advantage that this would not have
  !! been a problem).
  subroutine indexx_int(array,idx)
    integer,  intent(in)  :: array(:)
    integer,  intent(out) :: idx(size(array))
    !----------------------------------
    integer, parameter :: insertion_threshold = 7, stack_size = 50
    type lrpair
       integer :: l, r
    end type lrpair
    type(lrpair) :: stack(stack_size)
    integer :: nmid, i, j, l, r, ixstack, medidx, n
    real    :: medval
    
    !n = size(array)
    !if (n/=size(idx)) stop 'array and idx are different sizes'
    n = assert_eq(size(idx),size(array),'indexx_dp')

    forall(i=1:n) idx(i) = i
    
    ! push the whole array section onto the stack
    ixstack = 1
    stack(1) = lrpair(1,n); ixstack = 1
    do 
       ! pull an array section off the stack
       l = stack(ixstack)%l
       r = stack(ixstack)%r
       ixstack = ixstack - 1
       ! get to work on it
       if (r-l < insertion_threshold) then
          ! run an inlined insertion sort.
          do i = l+1, r
             medidx = idx(i)
             medval = array(medidx)
             ! look for the place where we should insert the element "medval", 
             ! and as we go about it, shift the other elements up by one
             do j = i-1, l, -1
                if (medval < array(idx(j))) then
                   idx(j+1) = idx(j)
                else
                   exit
                end if
             end do
             ! insert medval in its correct location
             idx(j+1) = medidx
          end do
       else
          ! NR idea is to take the median value of first, middle and
          ! last elements, so do a little insertion sort to get these
          ! three elements into order
          nmid = (l+r)/2
          ! first place the middle element in position l+1
          call swap(idx(l+1),idx(nmid))
          if (array(idx(l+1)) < array(idx(l))  ) call swap(idx(l+1),idx(l))
          if (array(idx(r))   < array(idx(l+1))) then
             call swap(idx(r),idx(l+1))
             if (array(idx(l+1)) < array(idx(l))) call swap(idx(l+1),idx(l))
          end if
          medidx = idx(l+1)
          medval = array(medidx)

          ! Then run up from first (non-trivial) element, and down from last
          ! element, swapping things as need be until i and j cross
          i = l+1; j = r
          do
             do 
                i = i + 1
                if (array(idx(i)) >= medval) exit
             end do
             do 
                j = j - 1
                if (array(idx(j)) <= medval) exit
             end do
             if (i > j) exit
             call swap(idx(i), idx(j))
          end do
          ! now insert medval (the partitioning element) into the
          ! correct position
          idx(l+1) = idx(j)
          idx(j)   = medidx

          ! now put things onto the stack
          if (ixstack+2 > stack_size) error stop 'stack too small'
          stack(ixstack+1) = lrpair(l,j-1)
          stack(ixstack+2) = lrpair(j,r)
          ixstack = ixstack + 2
       end if
       
       if (ixstack == 0) exit
    end do
    
  end subroutine indexx_int


  subroutine swap_dp(a,b)
    real(dp), intent(inout) :: a,b
    real(dp)                :: dummy
    dummy=a
    a=b
    b=dummy
  end subroutine swap_dp

  subroutine swap_int(a,b)
    integer, intent(inout) :: a,b
    integer                :: dummy
    dummy=a
    a=b
    b=dummy
  end subroutine swap_int

end module sort

!======================================================================
! 
!! This module provide a type for matrices of splitting functions as
!! well as for coefficient functions and mass-threshold matrices. The
!! two latter ones are liable to evolve.
!!
!! The module also provides:
!!
!! - subroutines for manipulating the splitting matrices (similarly 
!!   to the subroutine for grid_conv objects)
!!
!! - subroutines for initialising the splitting matrices with the LO
!!   NLO and NNLO splitting functions
!!
!! - subroutines for initialising Polarised LO and NLO splitting matrices. 
!!
!! - mass thresholds, coefficient functions, 
!!
!! - tools for getting "derived" splitting matrices.
!!
!======================================================================
module dglap_objects
  use types; use consts_dp; use splitting_functions; use mass_thresholds_n3lo
  !use qcd
  use dglap_choices
  use warnings_and_errors
  use pdf_representation
  use convolution
  use assertions
  implicit none
  private

  !-----------------------------------------------------------------
  ! holds all the components of the splitting functions
  type split_mat
     !private
     !-- These are the singlet evolution pieces
     !   qg is defined including a 2nf factor
     type(grid_conv)           :: singlet(iflv_g:iflv_sigma,iflv_g:iflv_sigma)
     type(grid_conv), pointer  :: gg, qq, gq, qg
     !-- These are the non-singlet pieces     ! 
     type(grid_conv) :: NS_plus   ! multiplies [(q_i + qbar_i) - (q_j + qbar_j)]
     type(grid_conv) :: NS_minus  ! multiplies [(q_i - qbar_i) - (q_j - qbar_j)]
     type(grid_conv) :: NS_V      ! multiplies [\sum_i (q_i - qbar_i)]
     ! the nf value for which this splitting matrix is defined
     integer            :: nf_int
  end type split_mat
  public             :: split_mat


  ! !-----------------------------------------------------------------
  ! type, extends(split_mat) :: new_mass_threshold_mat
  !   type(grid_conv) :: PShq !!< (h+hbar) from singlet(nflight)
  !   type(grid_conv) :: PShg !!< (h+hbar) from gluon  (nflight)
  !   type(grid_conv) :: NShV !!< (h-hbar) from valence(nflight) i.e. sum_i (q_i-qbar_i)
  ! end type new_mass_threshold_mat

  !---------------------------------------------------------------
  ! for going from nf to nf+1. Currently contains pieces
  ! required for O(as^2), but not the full general structure.
  !
  ! The full (flavor-symmetric) structure is given in Eqs.(32-35) of
  ! 1403.6356, and 1406.4654 eq. 7.1 for the non-singlet part (note
  ! different NF convention between the two papers. We use the
  ! latter)..
  type mass_threshold_mat
     ! pieces that start at NNLO
     type(grid_conv) :: PShq   !!< A^PS_Qq    Q+Qbar from singlet(nflight)
     type(grid_conv) :: PShg   !!< A^PS_Qg    Q+Qbar from gluon  (nflight)
     type(grid_conv) :: NSqq_H !!< A^NS_qq,Q  ΔNS(nfheavy) from NS(nflight)
     type(grid_conv) :: Sgg_H  !!< A^S_gg,Q   Δg(nfheavy) from g(nflight)
     type(grid_conv) :: Sgq_H  !!< A^S_gq,Q   Δg(nfheavy) from singlet(nflight)
     ! pieces that start at N3LO
     type(grid_conv) :: PSqq_H  !!< A^PS_qq,Q  Δsinglet(nfheavy) from singlet(nflight)
     type(grid_conv) :: Sqg_H   !!< A^S_qg,Q   Δsinglet(nfheavy) from gluon(nflight)
     type(grid_conv) :: NSmqq_H !!< A^{NSm}_qq,Q ΔNSminus(1:nflight) from NSminus(1:nflight)
     ! pieces related to the case of thresholds at MSbar masses
     ! NB: not supported yet at N3LO
     type(grid_conv) :: PShg_MSbar !!< replaces PShg when masses are MSbar
     real(dp)        :: Sgg_H_extra_MSbar_delta
     !! LOOPS == 1+POWER OF AS2PI,
     !! NB: if adding two pieces with different numbers of loops
     !!     this contains the maximum among the two pieces
     integer         :: loops
     !! nf_int = nf including heavy quark.
     integer         :: nf_int
     !! a flag to indicate that this MTM is to be used for a transition
     !! at an MSbar mass
     logical         :: masses_are_MSbar
  end type mass_threshold_mat
  public :: mass_threshold_mat

  !-----------------------------------------------------------------
  ! holds the components of a coefficient function
  type coeff_mat
     !private
     !-- need a grid def. Sometimes no g or q will be defined
     !   but still want the coefficient function associated with a grid
     !   def
     !   delta is the magnitude of a delta function piece
     !   quark charge contributions are included by the routines here.
     !   for gluons the implicitness is \sum_{q,qbar} e_q^2
     type(grid_def)     :: grid
     type(grid_conv)    :: g, q
     real(dp)           :: delta
     logical            :: HO
  end type coeff_mat
  public             :: coeff_mat


  !---------- avoid need for main program to access convolution
  !  give it both possible names. Maybe not necessary?
  public :: grid_def
  interface cobj_InitGridDef
     ! perhaps illegal, so do it explicitly?
     !module procedure InitGridDef
     module procedure conv_InitGridDef_single, conv_InitGridDef_multi
  end interface
  public :: cobj_InitGridDef
  public :: InitGridDef

  public :: cobj_InitSplitLinks
  public :: InitSplitMatLO, InitSplitMatNLO
  public :: InitSplitMatNNLO, InitSplitMatN3LO
  public :: InitSplitMatTimeNLO
  public :: InitSplitMatPolLO, InitSplitMatPolNLO

  public :: InitSplitMat!, Delete_sm
  !public :: AddWithCoeff_sm, Multiply_sm
  !public :: cobj_PConv, cobj_PConv_1d

  interface InitMTM
    module procedure InitMTM_from_MTM
  end interface
  public :: InitMTM, InitMTMNNLO, InitMTMN3LO, SetNfMTM !, cobj_ConvMTM  , cobj_DelMTM
  public :: InitMTMLibOME, InitMTMN3LOExactFortran
  public :: SetMassSchemeMTM
  
  !-------- things for splitting functions --------------------
  interface cobj_InitCoeff
     module procedure cobj_InitCoeffLO, cobj_InitCoeffHO, cobj_InitCoeff_cf
  end interface
  public :: cobj_InitCoeff, cobj_InitCoeffLO, cobj_InitCoeffHO
  !public :: cobj_CConv
  !public :: cobj_AddCoeff, cobj_DelCoeff
  public :: GetDerivedSplitMatProbes, AllocSplitMat, SetDerivedSplitMat


  interface operator(*)
     module procedure cobj_PConv, cobj_PConv_1d, cobj_CConv, cobj_ConvMTM
  end interface
  public :: operator(*)
  interface operator(.conv.)
     module procedure cobj_PConv, cobj_PConv_1d, cobj_CConv, cobj_ConvMTM
  end interface
  public  :: operator(.conv.)
  public  :: cobj_Eval2LConv
  !-- avoid access through here
  private :: cobj_PConv, cobj_PConv_1d, cobj_CConv

  interface SetToZero
     module procedure SetToZero_sm
  end interface
  public :: SetToZero

  interface Multiply
     module procedure Multiply_sm, Multiply_MTM
  end interface
  public :: Multiply

  interface AddWithCoeff
     module procedure AddWithCoeff_sm, AddWithCoeff_MTM
  end interface
  public :: AddWithCoeff

  interface SetToConvolution
     module procedure SetToConvolution_sm
  end interface
  public :: SetToConvolution

  interface SetToCommutator
     module procedure SetToCommutator_sm
  end interface
  public :: SetToCommutator

  interface Delete
     module procedure Delete_sm, cobj_DelMTM,  cobj_DelCoeff
  end interface
  public :: Delete


contains

  !======================================================================
  !! make sure all required internal links are set up for the splitting 
  !! matrix 
  subroutine cobj_InitSplitLinks(P)
    type(split_mat), target,  intent(inout) :: P
    
    if ((iflv_sigma - iflv_g) /= 1) call wae_error(&
         &'cobj_InitSplitLinks:', 'local gluon and sigma ids not consistent')
    
    !-- NB singlet matrix is not written with usual convention of 
    !   (sigma g), but rather (g sigma)
    P%gg => P%singlet(iflv_g,iflv_g)
    P%gq => P%singlet(iflv_g,iflv_sigma)
    P%qg => P%singlet(iflv_sigma,iflv_g)
    P%qq => P%singlet(iflv_sigma,iflv_sigma)
  end subroutine cobj_InitSplitLinks
  

  !======================================================================
  !! Initialise a LO unpolarised splitting matrix, with the nf value that
  !! is current from the qcd module. 
  subroutine InitSplitMatLO(grid, P)
    use qcd
    type(grid_def),  intent(in)    :: grid
    type(split_mat), intent(inout) :: P

    !-- info to describe the splitting function
    !P%loops  = 1
    P%nf_int = nf_int

    call cobj_InitSplitLinks(P)

    call InitGridConv(grid, P%gg, sf_Pgg)
    call InitGridConv(grid, P%qq, sf_Pqq)
    call InitGridConv(grid, P%gq, sf_Pgq)
    call InitGridConv(grid, P%qg, sf_Pqg)

    !-- now fix up pieces so that they can be directly used as a matrix
    call Multiply(P%qg, 2*nf)

    !-- PqqV +- PqqbarV
    call InitGridConv(P%NS_plus,  P%qq)
    call InitGridConv(P%NS_minus, P%qq)

    !-- PNSminus + nf * (PqqS - PqqbarS)
    call InitGridConv(P%NS_V, P%NS_minus)
  end subroutine InitSplitMatLO


  !======================================================================
  !! Initialise a NLO unpolarised splitting matrix, with the nf value that
  !! is current from the qcd module. (MSbar scheme)
  subroutine InitSplitMatNLO(grid, P, factscheme)
    use qcd
    type(grid_def),    intent(in)    :: grid
    type(split_mat),   intent(inout) :: P
    integer, optional, intent(in)    :: factscheme
    integer :: factscheme_local
    !-----------------------------------------
    type(grid_conv) :: P1qqV, P1qqbarV, P1qqS
    !-- needed for DIS schemes
    type(grid_conv) :: Cq,Cg
    type(grid_conv) :: CqPqq, CqPqg, CqPgq, CqPgg
    type(grid_conv) :: CgPgg, CgPqg, CgPgq, CgPqq


    factscheme_local = default_or_opt(factscheme_default, factscheme)
    if (factscheme_local /= factscheme_MSbar) then
       ! NB: do not support DIS scheme here since it involves 
       !     determination of Pqq etc at LO (already done once, so do 
       !     not want to repeat) -- rather do this stuff in
       !     dglap_holders, where Pqq(LO) will in any case be available.
       !     (Is this "chickening out"?)
       write(0,*) 'InitSplitMatNLO: unsupported fact scheme', factscheme
       call wae_error('InitSplitMatNLO: stopping')
    end if
    
    !-- info to describe the splitting function
    !P%loops = 2
    P%nf_int = nf_int
    
    call cobj_InitSplitLinks(P)

    !-- these are the building blocks
    call InitGridConv(grid, P1qqV, sf_P1qqV)
    call InitGridConv(grid, P1qqbarV, sf_P1qqbarV)
    call InitGridConv(grid, P1qqS, sf_P1qqS)

    !-- PqqV + PqqbarV
    call InitGridConv(P%NS_plus, P1qqV)
    call AddWithCoeff(P%NS_plus, P1qqbarV, one)
    !-- PqqV - PqqbarV
    call InitGridConv(P%NS_minus, P1qqV)
    call AddWithCoeff(P%NS_minus, P1qqbarV, -one)

    !-- PNSminus + nf * (PqqS - PqqbarS) 
    !   [NB at NLO, PqqS = PqqbarS] 
    call InitGridConv(P%NS_V, P%NS_minus)
    
    !-- Pqq in matrix:  PNS_plus + nf*(PqqS + PqqbarS)
    !   [NB at NLO, PqqS = PqqbarS] 
    call InitGridConv(P%qq, P%NS_plus)
    call AddWithCoeff(P%qq, P1qqS, two*nf)

    !-- rest of singlet matrix
    call InitGridConv(grid, P%gq, sf_P1gq)
    call InitGridConv(grid, P%gg, sf_P1gg)
    call InitGridConv(grid, P%qg, sf_P1qg)
    !-- recall that the way it is defined it needs a factor 2nf
    call Multiply(P%qg, two*nf)

    !-- tidy up 
    call Delete(P1qqV)
    call Delete(P1qqbarV)
    call Delete(P1qqS)

  end subroutine InitSplitMatNLO



  !======================================================================
  !! Initialise a NNLO unpolarised splitting matrix, with the nf value that
  !! is current from the qcd module. (MSbar scheme)
  subroutine InitSplitMatNNLO(grid, P, factscheme)
    use qcd; use convolution_communicator
    type(grid_def),    intent(in)    :: grid
    type(split_mat),   intent(inout) :: P
    integer, optional, intent(in) :: factscheme
    integer :: factscheme_local
    !-----------------------------------------
    type(grid_conv) :: P2NSS
    real(dp) :: dummy

    !call wae_error('InitSplitMatNNLO: NNLO not yet implemented')
    factscheme_local = default_or_opt(factscheme_default, factscheme)
    if (factscheme_local /= factscheme_MSbar) then
       write(0,*) 'InitSplitMatNNLO: unsupported fact scheme', factscheme
       call wae_error('InitSplitMatNNLO: stopping')
    end if
    
    !-- info to describe the splitting function
    !P%loops = 3
    P%nf_int = nf_int

    ! NO LONGER NECESSARY
!!$    !-- dummy to initialize Vogt routines (needed in exact cases 
!!$    !   for the A3 piece to be set up). Do it better later on if it works?
!!$    cc_piece = cc_real
!!$    dummy = sf_P2NSMinus(0.5_dp)
!!$    dummy = sf_P2gg(0.5_dp)

    call cobj_InitSplitLinks(P)

    call InitGridConv(grid, P%NS_plus, sf_P2NSPlus)
    call InitGridConv(grid, P%NS_minus, sf_P2NSMinus)
    
    !-- if understanding of convention is right then P_V = P_- + P_S
    call InitGridConv(P%NS_V, P%NS_minus)
    call InitGridConv(grid, P2NSS, sf_P2NSS)
    call AddWithCoeff(P%NS_V, P2NSS)    
    call Delete(P2NSS)

    !-- now the singlet functions
    call InitGridConv(grid, P%qg, sf_P2qg2nf)
    call InitGridConv(grid, P%gg, sf_P2gg)
    call InitGridConv(grid, P%gq, sf_P2gq)
    !-- qq = "pure-singlet" + P+
    call InitGridConv(grid, P%qq, sf_P2PS)
    call AddWithCoeff(P%qq, P%NS_plus)
  end subroutine InitSplitMatNNLO


  !======================================================================
  !! Initialise a N3LO unpolarised splitting matrix, with the nf value that
  !! is current from the qcd module. (MSbar scheme)
  subroutine InitSplitMatN3LO(grid, P, factscheme)
    use qcd; use convolution_communicator
    type(grid_def),    intent(in)    :: grid
    type(split_mat),   intent(inout) :: P
    integer, optional, intent(in) :: factscheme
    integer :: factscheme_local, nf_store
    !-----------------------------------------
    type(grid_conv) :: P3NSS
    real(dp) :: dummy
    integer, save :: nwarn_nf_lo = 5, nwarn_nf_hi = 5

    !call wae_error('InitSplitMatN3LO: N3LO not yet implemented')
    factscheme_local = default_or_opt(factscheme_default, factscheme)
    if (factscheme_local /= factscheme_MSbar) then
       write(0,*) 'InitSplitMatN3LO: unsupported fact scheme', factscheme
       call wae_error('InitSplitMatN3LO: stopping')
    end if
    
    !-- info to describe the splitting function
    !P%loops = 3
    ! The splitting matrices are currently hard coded for nf=3,4,5
    nf_store = nf_int
    if (nf_int < 3) then
      nf_int = 3
      call wae_warn(nwarn_nf_lo, "InitSplitMatN3LO: nf_int < 3, setting to 3; nf_int was", intval = nf_store)
    else if (nf_int > 5) then
      nf_int = 5
      call wae_warn(nwarn_nf_hi, "InitSplitMatN3LO: nf_int > 5, setting to 5; nf_int was", intval = nf_store)
    end if
    !nf_int = min(max(nf_int,3),5)
    P%nf_int = nf_store

    ! NO LONGER NECESSARY
!!$    !-- dummy to initialize Vogt routines (needed in exact cases 
!!$    !   for the A3 piece to be set up). Do it better later on if it works?
!!$    cc_piece = cc_real
!!$    dummy = sf_P3NSMinus(0.5_dp)
!!$    dummy = sf_P3gg(0.5_dp)

    call cobj_InitSplitLinks(P)

    call InitGridConv(grid, P%NS_plus, sf_P3NSPlus)
    call InitGridConv(grid, P%NS_minus, sf_P3NSMinus)
    
    !-- if understanding of convention is right then P_V = P_- + P_S
    call InitGridConv(P%NS_V, P%NS_minus)
    call InitGridConv(grid, P3NSS, sf_P3NSS)
    call AddWithCoeff(P%NS_V, P3NSS)    
    call Delete(P3NSS)

    !-- now the singlet functions
    call InitGridConv(grid, P%qg, sf_P3qg2nf)
    call InitGridConv(grid, P%gg, sf_P3gg)
    call InitGridConv(grid, P%gq, sf_P3gq)
    !-- qq = "pure-singlet" + P+
    call InitGridConv(grid, P%qq, sf_P3PS)
    call AddWithCoeff(P%qq, P%NS_plus)

    ! Restore nf_int
    nf_int = nf_store
  end subroutine InitSplitMatN3LO

    !======================================================================
  !! Initialise a NLO unpolarised splitting matrix, with the nf value that
  !! is current from the qcd module. (MSbar scheme)
  subroutine InitSplitMatTimeNLO(grid, P)
    use qcd
    type(grid_def),    intent(in)    :: grid
    type(split_mat),   intent(inout) :: P
    !-----------------------------------------
    type(grid_conv) :: P1qqV, P1qqbarV

    !-- info to describe the splitting function
    !P%loops = 2
    P%nf_int = nf_int
    
    call cobj_InitSplitLinks(P)

    !-- these are the building blocks
    call InitGridConv(grid, P1qqV, sf_P1qqV)
    ! add in the timelike correction
    call AddWithCoeff(P1qqV, sf_TmSP1qqNS)
    call InitGridConv(grid, P1qqbarV, sf_P1qqbarV)

    !-- PqqV + PqqbarV
    call InitGridConv(P%NS_plus, P1qqV)
    call AddWithCoeff(P%NS_plus, P1qqbarV, one)
    !-- PqqV - PqqbarV
    call InitGridConv(P%NS_minus, P1qqV)
    call AddWithCoeff(P%NS_minus, P1qqbarV, -one)

    !-- PNSminus + nf * (PqqS - PqqbarS) 
    !   [NB at NLO, PqqS = PqqbarS] 
    call InitGridConv(P%NS_V, P%NS_minus)
    
    !--  singlet matrix
    ! Note that for the singlet matrix here, we are using the ESW notation
    ! which swaps qg/gq names in the matrix, i.e.
    !
    ! - the matrix qg entry will multiply a gluon fragementation function
    !   so it corresponds to q->g splitting which is similar to the initial-state
    !   Pgq; the q entry is the sum over all quark fragmentation functions; since
    !   each quark can branch to a gluon we need a 2nf factor
    !
    ! - the matrix gq entry will multiply a quark fragmentation function, so
    !   it corresponds to a g->q splitting, which is similar to the initial-state
    !   Pqg; the ESW definition includes a factor 2nf which should not be there
    !   because the singlet already includes the sum over all flavours.
    !
    call InitGridConv(grid, P%qq, sf_TP1qq)
    call InitGridConv(grid, P%gg, sf_TP1gg)
    call InitGridConv(grid, P%gq, sf_TP1qg) ! note swap of qg/gq for time-like case
    call InitGridConv(grid, P%qg, sf_TP1gq) ! note swap of qg/gq for time-like case
    !-- recall that the way it is defined it needs a factor 2nf
    call Multiply(P%qg, two*nf)
    call Multiply(P%gq, one/(two*nf))

    !-- tidy up 
    call Delete(P1qqV)
    call Delete(P1qqbarV)

  end subroutine InitSplitMatTimeNLO



  !======================================================================
  !! Initialise a LO Polarised splitting matrix, with the nf value that
  !! is current from the qcd module.
  subroutine InitSplitMatPolLO(grid, P)
    use qcd
    type(grid_def),    intent(in)    :: grid
    type(split_mat),   intent(inout) :: P

    !-- info to describe the splitting function
    !P%loops  = 1
    P%nf_int = nf_int

    call cobj_InitSplitLinks(P)

    call InitGridConv(grid, P%gg, sf_DPgg)
    call InitGridConv(grid, P%qq, sf_DPqq)
    call InitGridConv(grid, P%gq, sf_DPgq)
    call InitGridConv(grid, P%qg, sf_DPqg)

    !-- now fix up pieces so that they can be directly used as a matrix
    call Multiply(P%qg, 2*nf)

    !-- PqqV +- PqqbarV
    call InitGridConv(P%NS_plus,  P%qq)
    call InitGridConv(P%NS_minus, P%qq)

    !-- PNSminus + nf * (PqqS - PqqbarS)
    call InitGridConv(P%NS_V, P%NS_minus)
  end subroutine InitSplitMatPolLO

  !======================================================================
  !! Initialise a NLO Polarised splitting matrix, with the nf value that
  !! is current from the qcd module.
  subroutine InitSplitMatPolNLO(grid, P, factscheme)
    use qcd
    type(grid_def),    intent(in)    :: grid
    type(split_mat),   intent(inout) :: P
    integer, optional, intent(in)    :: factscheme
    integer :: factscheme_local
    !-----------------------------------------
    type(grid_conv) :: DP1qqV, DP1qqbarV, DP1qqS

    factscheme_local = default_or_opt(factscheme_Poldefault, factscheme)
    if (factscheme_local /= factscheme_PolMSbar) then
       ! NB: do not support DIS scheme here since it involves 
       !     determination of Pqq etc at LO (already done once, so do 
       !     not want to repeat) -- rather do this stuff in
       !     dglap_holders, where Pqq(LO) will in any case be available.
       !     (Is this "chickening out"?)
       write(0,*) 'InitSplitMatPolNLO: unsupported fact scheme', factscheme
       call wae_error('InitSplitMatPolNLO: stopping')
    end if
    
    !-- info to describe the splitting function
    !P%loops = 2
    P%nf_int = nf_int
    
    call cobj_InitSplitLinks(P)

    !-- these are the building blocks
    call InitGridConv(grid, DP1qqV, sf_DP1qqV)
    call InitGridConv(grid, DP1qqbarV, sf_DP1qqbarV)
    call InitGridConv(grid, DP1qqS, sf_DP1qqS)

    !-- PqqV + PqqbarV
    call InitGridConv(P%NS_plus, DP1qqV)
    call AddWithCoeff(P%NS_plus, DP1qqbarV, one)
    !-- PqqV - PqqbarV
    call InitGridConv(P%NS_minus, DP1qqV)
    call AddWithCoeff(P%NS_minus, DP1qqbarV, -one)

    !-- PNSminus + nf * (PqqS - PqqbarS) 
    !   [NB at NLO, PqqS = PqqbarS] 
    call InitGridConv(P%NS_V, P%NS_minus)
    
    !-- Pqq in matrix:  PNS_plus + nf*(PqqS + PqqbarS)
    !   [NB at NLO, PqqS = PqqbarS] 
    call InitGridConv(P%qq, P%NS_plus)
    call AddWithCoeff(P%qq, DP1qqS, two*nf)

    !-- rest of singlet matrix
    call InitGridConv(grid, P%gq, sf_DP1gq)
    call InitGridConv(grid, P%gg, sf_DP1gg)
    call InitGridConv(grid, P%qg, sf_DP1qg)
    !-- recall that the way it is defined it needs a factor 2nf
    call Multiply(P%qg, two*nf)

    !-- tidy up 
    call Delete(DP1qqV)
    call Delete(DP1qqbarV)
    call Delete(DP1qqS)

  end subroutine InitSplitMatPolNLO


  !----------------------------------------------------------------------
  !! initialize a splitting function matrix with another one (potentially 
  !! multiplied by some factor). Memory allocation should be automatically
  !! handled by the subsiduary routines.
  subroutine InitSplitMat(P, Pin, factor)
    type(split_mat),  intent(inout)        :: P
    type(split_mat),  intent(in)           :: Pin
    real(dp),         intent(in), optional :: factor
    !if (nf_d /= (nf_int+1)/2) write(0,*) 'WARNING: non-standard nf_d'

    !P%loops  = Pin%loops
    P%nf_int = Pin%nf_int
    call cobj_InitSplitLinks(P)

    call InitGridConv(P%gg,    Pin%gg,     factor)
    call InitGridConv(P%qq,    Pin%qq,     factor)
    call InitGridConv(P%gq,    Pin%gq,     factor)
    call InitGridConv(P%qg,    Pin%qg,     factor)

    !-- from here on, one could exploit info in loops so as to 
    !   reduce number of multiplications... But I am too lazy in this first
    !   go
    call InitGridConv(P%NS_plus,  Pin%NS_plus,  factor)
    call InitGridConv(P%NS_minus, Pin%NS_minus, factor)
    call InitGridConv(P%NS_V,     Pin%NS_V,     factor)
    
  end subroutine InitSplitMat


  !----------------------------------------------------------------------
  !! init a splitting function set with another one (potentially 
  !! multiplied by some factor)
  subroutine AddWithCoeff_sm(P, Padd, factor)
    type(split_mat),     intent(inout) :: P
    type(split_mat),     intent(in)    :: Padd
    real(dp),       intent(in), optional :: factor
    !if (nf_d /= (nf_int+1)/2) write(0,*) 'WARNING: non-standard nf_d'

    !P%loops = max(P%loops, Padd%loops)
    P%nf_int = assert_eq(P%nf_int, Padd%nf_int, &
         &'AddWithCoeff_sm: nf must be the same')
    call AddWithCoeff(P%gg,       Padd%gg,       factor)
    call AddWithCoeff(P%qq,       Padd%qq,       factor)
    call AddWithCoeff(P%gq,       Padd%gq,       factor)
    call AddWithCoeff(P%qg,       Padd%qg,       factor)
    call AddWithCoeff(P%NS_plus,  Padd%NS_plus,  factor)
    call AddWithCoeff(P%NS_minus, Padd%NS_minus, factor)
    call AddWithCoeff(P%NS_V,     Padd%NS_V,     factor)

  end subroutine AddWithCoeff_sm


  !----------------------------------------------------------------------
  !! Multiply the splitting matrix P by factor.
  subroutine Multiply_sm(P, factor)
    type(split_mat),  intent(inout) :: P
    real(dp),         intent(in)    :: factor
    !if (nf_d /= (nf_int+1)/2) write(0,*) 'WARNING: non-standard nf_d'

    call Multiply(P%gg,       factor)
    call Multiply(P%qq,       factor)
    call Multiply(P%gq,       factor)
    call Multiply(P%qg,       factor)
    call Multiply(P%NS_plus,  factor)
    call Multiply(P%NS_minus, factor)
    call Multiply(P%NS_V,     factor)

  end subroutine Multiply_sm


  !======================================================================
  !! Set the splitting matrix P to zero
  subroutine SetToZero_sm(P)
    type(split_mat),  intent(inout) :: P

    call SetToZero(P%gg)
    call SetToZero(P%qq)
    call SetToZero(P%gq)
    call SetToZero(P%qg)
    call SetToZero(P%NS_plus)
    call SetToZero(P%NS_minus)
    call SetToZero(P%NS_V)

  end subroutine SetToZero_sm


  !======================================================================
  !! Set the splitting matrix PA to be equal to PB .conv. PC
  subroutine SetToConvolution_sm(PA, PB, PC)
    type(split_mat),  intent(inout) :: PA
    type(split_mat),  intent(in)    :: PB, PC

    PA%nf_int = assert_eq(PB%nf_int, PC%nf_int, 'SetToConvolution_sm')
    call cobj_InitSplitLinks(PA)

    call SetToConvolution(PA%singlet , PB%singlet , PC%singlet )
    call SetToConvolution(PA%NS_plus , PB%NS_plus , PC%NS_plus )
    call SetToConvolution(PA%NS_minus, PB%NS_minus, PC%NS_minus)
    call SetToConvolution(PA%NS_V    , PB%NS_V    , PC%NS_V    )

  end subroutine SetToConvolution_sm


  !----------------------------------------------------------------------
  !! Set the splitting matrix PA to be equal to [PB, PC]
  subroutine SetToCommutator_sm(PA, PB, PC)
    type(split_mat),  intent(inout) :: PA
    type(split_mat),  intent(in)    :: PB, PC

    PA%nf_int = assert_eq(PB%nf_int, PC%nf_int, 'SetToCommutator_sm')
    call cobj_InitSplitLinks(PA)

    call SetToCommutator(PA%singlet, PB%singlet, PC%singlet)
    ! Recall that following calls also set things to zero
    call InitGridConv(PB%NS_plus%grid, PA%NS_plus )
    call InitGridConv(PB%NS_plus%grid, PA%NS_minus)
    call InitGridConv(PB%NS_plus%grid, PA%NS_V    )

  end subroutine SetToCommutator_sm


  !----------------------------------------------------------------------
  !! Clear a splitting function (dealloc memory)
  subroutine Delete_sm(P)
    type(split_mat),     intent(inout) :: P

    call Delete(P%gg); nullify(P%gg)
    call Delete(P%qq); nullify(P%qq)
    call Delete(P%gq); nullify(P%gq)
    call Delete(P%qg); nullify(P%qg)
    call Delete(P%NS_plus)
    call Delete(P%NS_minus)
    call Delete(P%NS_V)
  end subroutine Delete_sm

  !----------------------------------------------------------------------
  !! Return the convolution of the splitting matrix P with q_in.
  !!
  !! If q_in is in the human representation is is returned in the
  !! human representation (though internal conversions are carried
  !! out). If it is in an evolution representation then it is
  !! _assumed_ to be in the representation that corresponds to the nf
  !! value of P (and no consistency checking is performed) and no
  !! change of representation is carried out.
  !!
  !! This function also has a 1d overloaded version
  function cobj_PConv(P,q_in) result(Pxq)
    type(split_mat), intent(in)         :: P
    real(dp),        intent(in), target :: q_in(0:,ncompmin:)
    real(dp)                     :: Pxq(0:ubound(q_in,dim=1),ncompmin:ncompmax)
    !-- for when we have to change rep
    integer                       :: pdfr
    !type(pdf_rep)                :: prep
    real(dp), allocatable, target :: q_ev(:,:)
    real(dp), pointer             :: q(:,:)
    integer :: i

    if (ncomponents < P%nf_int) then
       call wae_error('cobj_Pconv:',&
            &'ncomponents in representation is < nf in P.')
    end if

    pdfr = GetPdfRep(q_in)
    if (pdfr /= pdfr_Human) then
       ! check we have the right number of flavours
       if (GetPdfRep(q_in) /= p%nf_int) then
          call wae_error('cobj_Pconv:',&
               &'n-flavours of q_in representation /= n-flavours for splitting function = ', &
               &intval=GetPdfRep(q_in), dbleval=one*p%nf_int)
       end if
       q => q_in
    else
       allocate(q_ev(0:ubound(q_in,dim=1),ncompmin:ncompmax))
       !prep = DefaultEvlnRep(p%nf_int)
       call CopyHumanPdfToEvln(p%nf_int, q_in, q_ev)
       q => q_ev
    end if
    
    PxQ(:, iflv_V)     = P%NS_V * q(:,iflv_V)
    !PxQ(:, iflv_g)     = P%gg * q(:,iflv_g) + P%gq * q(:,iflv_sigma)
    !PxQ(:, iflv_sigma) = P%qg * q(:,iflv_g) + P%qq * q(:,iflv_sigma)
    PxQ(:,iflv_g:iflv_sigma) = P%singlet .conv. q(:,iflv_g:iflv_sigma)

    !-- we need nf-1 NS (+ and -) pieces
    do i = 2, P%nf_int
       PxQ(:,+i) = P%NS_plus  * q(:,+i)
       PxQ(:,-i) = P%NS_minus * q(:,-i)
    end do

    !-- everything else should be set to zero
    do i = P%nf_int + 1, ncomponents
       PxQ(:,+i) = zero
       PxQ(:,-i) = zero
    end do

    !call LabelPdfAsRep(Pxq,pdfr_Evln)
    call LabelPdfAsRep(Pxq,P%nf_int)
    if (pdfr == pdfr_Human) then
       q_ev = Pxq ! avoid an extra temporary... (real cleverness might
                  ! have been to avoid this copy...?)
       !call CopyEvlnPdfToHuman(prep, q_ev, Pxq) ! does labelling as well
       call CopyEvlnPdfToHuman(p%nf_int, q_ev, Pxq) ! does labelling as well
       deallocate(q_ev)
    end if
    
  end function cobj_PConv

  !-----------------------------------------------------------------
  !! In some situations the 1d overloaded version is useful.
  !! Do just for PConv, but think also about doing it for others
  !! later on...
  function cobj_PConv_1d(P,q_in) result(Pxq)
    type(split_mat), intent(in)         :: P
    real(dp),        intent(in), target :: q_in(0:,ncompmin:,:)
    real(dp)                            :: &
         &Pxq(0:ubound(q_in,dim=1),ncompmin:ncompmax,size(q_in,dim=3))
    integer :: i
    do i = 1, size(q_in,dim=3)
       Pxq(:,:,i) = cobj_PConv(P,q_in(:,:,i))
    end do
  end function cobj_PConv_1d
  


  !------------------------------------------------------------
  !! Allocate space for a set of splitting functions, labelling
  !! also with the appropriate nf and nloops...
  subroutine AllocSplitMat(grid,P,nf_in)!, nloops)
    type(grid_def),    intent(in)   :: grid
    type(split_mat),   intent(out)  :: P
    integer,           intent(in)   :: nf_in
    !integer, optional, intent(in)   :: nloops
    
    P%nf_int = nf_in
    !P%loops  = default_or_opt(0,nloops)
    call cobj_InitSplitLinks(P)
    call AllocGridConv(grid,P%gg      )
    call AllocGridConv(grid,P%qq      )
    call AllocGridConv(grid,P%gq      )
    call AllocGridConv(grid,P%qg      )
    call AllocGridConv(grid,P%NS_plus )
    call AllocGridConv(grid,P%NS_minus)
    call AllocGridConv(grid,P%NS_V    )
  end subroutine AllocSplitMat

  
  !-----------------------------------------------------------------
  !! Returns the set of probes needed to establish a matrix of
  !! "derived" effective splitting functions.
  subroutine GetDerivedSplitMatProbes(grid, nf_in, probes)
    type(grid_def), intent(in) :: grid
    integer,        intent(in) :: nf_in
    real(dp),       pointer    :: probes(:,:,:)
    !-----------
    real(dp), pointer :: probes_1d(:,:)
    integer :: nprobes, nprobes_1d, iprobe

    call GetDerivedProbes(grid,probes_1d)

    nprobes_1d = ubound(probes_1d,2)

    ! need to double the number of probes because we need to deduce
    ! the 2x2 matrix for singlet evolution (so once we'll do it with
    ! the singlet quark set to zero; the other time we'll do it with the
    ! singlet gluon set to zero).
    nprobes    = 2*nprobes_1d

    allocate(probes(0:ubound(probes_1d,1),ncompmin:ncompmax, 1:nprobes))

    probes = zero
    do iprobe = 1, nprobes
       ! make sure representation is correct...
       !call LabelPdfAsRep(probes(:,:,iprobe),pdfr_Evln)
       call LabelPdfAsRep(probes(:,:,iprobe),nf_in)
    end do

    probes(:,iflv_V, 1:nprobes_1d) = probes_1d       ! NS_V
    probes(:,   2, 1:nprobes_1d) = probes_1d       ! NS+
    probes(:,  -2, 1:nprobes_1d) = probes_1d       ! NS-
    probes(:,iflv_sigma, 1:nprobes_1d) = probes_1d   ! Quark column of singlet

    ! gluon column of singlet
    probes(:,iflv_g, nprobes_1d+1:nprobes) = probes_1d       

    ! normally this would be part of housekeeping job of convolution
    ! module (SetDerivedConv), but since probes_1d is lost from 
    ! view at this point, we have to do it ourselves...
    deallocate(probes_1d)
  end subroutine GetDerivedSplitMatProbes

  
  !---------------------------------------------------------------------
  !! Given an allocated split_mat and the results of operating on the probes
  !! determine the resulting "derived" splitting function.
  subroutine SetDerivedSplitMat(P,probes)
    type(split_mat),  intent(inout) :: P
    real(dp),         pointer       :: probes(:,:,:)
    !-----------------------------------------
    integer :: nprobes_1d,nprobes, il, ih

    nprobes   = size(probes,dim=3)
    nprobes_1d = nprobes/2

    il = 1; ih = nprobes_1d
    call SetDerivedConv_nodealloc(P%NS_V,     probes(:,iflv_V,il:ih))
    call SetDerivedConv_nodealloc(P%NS_plus,  probes(:,2,il:ih))
    call SetDerivedConv_nodealloc(P%NS_minus, probes(:,-2,il:ih))
    call SetDerivedConv_nodealloc(P%gq,       probes(:,iflv_g,il:ih))
    call SetDerivedConv_nodealloc(P%qq,       probes(:,iflv_sigma,il:ih))
    
    il = nprobes_1d+1; ih = nprobes
    call SetDerivedConv_nodealloc(P%gg,       probes(:,iflv_g,il:ih))
    call SetDerivedConv_nodealloc(P%qg,       probes(:,iflv_sigma,il:ih))

    deallocate(probes)
  end subroutine SetDerivedSplitMat
  
  !======================================================================
  !         MASS THRESHOLDS
  !======================================================================
  ! Here we keep all things to do with mass thresholds

  subroutine InitMTMNNLO(grid,MTM)
    use qcd
    type(grid_def),           intent(in)  :: grid
    type(mass_threshold_mat), intent(out) :: MTM
    !logical, parameter :: vogt_A2PShg = .false.
    !logical, parameter :: vogt_A2PShg = .true.
    integer, save :: warn_param = 3

    call InitGridConv(grid, MTM%PSHq, sf_A2PShq)
    select case (nnlo_nfthreshold_variant)
    case(nnlo_nfthreshold_param)
       call InitGridConv(grid, MTM%PSHg, sf_A2PShg_vogt)
       call wae_warn(warn_param,'InitMTMNNLO:&
            & using parametrisation  (less accurate) for A2PShg')
    case(nnlo_nfthreshold_exact)
       call InitGridConv(grid, MTM%PSHg, sf_A2PShg)
    case default
       call wae_error('InitMTMNNLO', 'Unknown nnlo_threshold_variant',&
            &intval=nnlo_nfthreshold_variant)
    end select
   
    call InitGridConv(grid, MTM%NSqq_H, sf_A2NSqq_H)
    call InitGridConv(MTM%NSmqq_H, MTM%NSqq_H) ! the plus and minus non-singlet pieces are the same
    call InitGridConv(grid, MTM%Sgg_H, sf_A2Sgg_H)
    call InitGridConv(grid, MTM%Sgq_H, sf_A2Sgq_H)

    ! things specific to MSbar (CCN32-57)
    MTM%Sgg_H_extra_MSbar_delta = 8.0_dp/three * CF * TR
    ! here we need an extra -4CF * P_{q+qbar,g} = -8CF*P_{qg}
    call InitGridConv(grid, MTM%PShg_MSbar, sf_Pqg)
    call Multiply(MTM%PShg_MSbar, -8.0_dp*CF)
    call AddWithCoeff(MTM%PShg_MSbar, MTM%PSHg)

    ! pieces that are zero at NNLO
    call InitGridConv(grid, MTM%PSqq_H)
    call InitGridConv(grid, MTM%Sqg_H)

    ! just store info that it is NNLO. For now it is obvious, but
    ! one day when we have NNNLO it may be useful, to indicate
    ! which structures exist and which do not. 
    ! (Mind you inexistent structures have yet to be implemented here...)
    MTM%loops = 3
    !-- no default value
    MTM%nf_int = nf_int
    !-- by default 
    MTM%masses_are_MSbar = .false.
  end subroutine InitMTMNNLO

  !! Initialise an N3LO MTM object based on the choice in 
  !! the global variable n3lo_nfthreshold
  subroutine InitMTMN3LO(grid,MTM_N3LO)
    type(grid_def),           intent(in)  :: grid
    type(mass_threshold_mat), intent(out) :: MTM_N3LO
    integer, save :: nwarn_n3lo_nfthreshold = 1

    if(n3lo_nfthreshold .eq. n3lo_nfthreshold_libOME) then
      call InitMTMLibOME(grid,MTM_N3LO,nloop=4)

    else if(n3lo_nfthreshold .eq. n3lo_nfthreshold_exact_fortran) then
      call InitMTMN3LOExactFortran(grid,MTM_N3LO)

    else if (n3lo_nfthreshold .eq. n3lo_nfthreshold_off) then
      call InitMTMNNLO(grid,MTM_N3LO) !! dummy initialisation to NNLO, just to get started
      MTM_N3LO%loops = 4
      call Multiply(MTM_N3LO, zero)

      call wae_warn(nwarn_n3lo_nfthreshold, 'InitMTMN3LO: n3lo_nfthreshold = off not recommended for nloop=4')

    else
      call wae_error('InitMTMN3LO', 'Unknown n3lo_threshold_variant',&
           &intval=n3lo_nfthreshold)
    end if

  end subroutine InitMTMN3LO


  !! Initialise an MTM object using the libome routines of arXiv:2510.02175
  !!
  !! \param grid    The grid to use
  !! \param MTM     The MTM object to initialise
  !! \param nloop   The perturbative (hoppet) nloops; libOME order = nloop-1 = # of powers of alpha_s
  !! \param LM      log(m^2/mu^2) where m is the heavy quark mass and mu the factorisation scale
  !!
  !! The number of light flavours is the global nf_int-1
  !!
  !! The expected relative accuracy on the underlying libOME is at least
  !! as good as (2048 * epsilon(1.0_dp))~4.5e-13,  which will usually be
  !! significantly better than the standard global integration precision
  !! (convolution's DefaultConvolutionEps(), which defaults to 1e-7)
  subroutine InitMTMLibOME(grid, MTM, nloop, LM)
    use iso_c_binding, only: c_double, c_int
    use hoppet_libome_fortran
    type(grid_def),           intent(in)  :: grid
    type(mass_threshold_mat), intent(out) :: MTM
    integer,                  intent(in)  :: nloop
    real(dp),  optional,      intent(in)  :: LM
    !-----------
    real(c_double) :: LM_c, nf_light_d
    integer(c_int) :: order_c
    logical, save :: first_time = .true.

    if (first_time) then
      first_time = .false.
      write(6,'(a)') 'Initialisation of Mass Threshold Matrices with code from libOME'
      write(6,'(a)') '*     J. Ablinger, A. Behring, J. Blümlein, A. De Freitas,'
      write(6,'(a)') '*     A. von Manteuffel, C. Schneider, and K. Schönwald,'
      write(6,'(a)') '*     "The Single-Mass Variable Flavor Number Scheme at Three-Loop Order",'
      write(6,'(a)') '*     arXiv:2510.02175 (DESY 24-037), https://gitlab.com/libome/libome'
    end if

    nf_light_d = real(nf_int-1,c_double)
    if (present(LM)) then
      LM_c = real(LM,c_double)
    else
      LM_c = zero
    end if
    order_c = nloop - 1

    call InitGridConv(grid, MTM%PShq   , conv_OME(AQqPS_ptr     , order=order_c, nf_light=nf_light_d, LM=LM_c))
    call InitGridConv(grid, MTM%PShg   , conv_OME(AQg_ptr       , order=order_c, nf_light=nf_light_d, LM=LM_c))
    call InitGridConv(grid, MTM%PSqq_H , conv_OME(AqqQPS_ptr    , order=order_c, nf_light=nf_light_d, LM=LM_c))
    call InitGridConv(grid, MTM%NSqq_H , conv_OME(AqqQNSEven_ptr, order=order_c, nf_light=nf_light_d, LM=LM_c))
    call InitGridConv(grid, MTM%NSmqq_H, conv_OME(AqqQNSOdd_ptr , order=order_c, nf_light=nf_light_d, LM=LM_c))
    call InitGridConv(grid, MTM%Sgg_H  , conv_OME(AggQ_ptr      , order=order_c, nf_light=nf_light_d, LM=LM_c))
    call InitGridConv(grid, MTM%Sgq_H  , conv_OME(AgqQ_ptr      , order=order_c, nf_light=nf_light_d, LM=LM_c))
    call InitGridConv(grid, MTM%Sqg_H  , conv_OME(AqgQ_ptr      , order=order_c, nf_light=nf_light_d, LM=LM_c))

    ! set the MSbar piece to zero -- MSbar thresholds not yet supported, but still needs
    ! to be there to avoid errors in the code.
    call InitGridConv(grid, MTM%PShg_MSbar)
    MTM%masses_are_MSbar = .false.
    MTM%Sgg_H_extra_MSbar_delta = zero

    MTM%loops  = nloop
    MTM%nf_int = nf_int

  end subroutine InitMTMLibOME


  subroutine InitMTMN3LOExactFortran(grid,MTM_N3LO)
    type(grid_def),           intent(in)  :: grid
    type(mass_threshold_mat), intent(out) :: MTM_N3LO
    logical, save :: first_time = .true.
    !! 103 uses two alphas points to separate out aalphas**3 from alphas**2, 
    !! 203 uses just one extreme one and is faster while giving consistent results
    integer, parameter :: ord3 = 203 
    
    if (first_time) then
        write(6,'(a)') 'Initialisation of Mass Threshold Matrices at N3LO. The paper'
        write(6,'(a)') '*     J. Ablinger, A. Behring, J. Blümlein, A. De Freitas,'
        write(6,'(a)') '*     A. von Manteuffel, C. Schneider, and K. Schönwald,'
        write(6,'(a)') '*     "The Single-Mass Variable Flavor Number Scheme at Three-Loop Order",'
        write(6,'(a)') '*     arXiv:2510.02175 (DESY 24-037)'
        write(6,'(a)') '* shall be cited at any use. Corresponding code from J. Bluemlein, March 19 2024 and '
        write(6,'(a)') '* K. Schönwald, March 15 2024, including results from arXiv:2207.00027, arXiv:2403.00513'
        write(6,'(a)') '*'
        write(6,'(a)') "The initialisation could take up to a minute, depending on the machine."
        first_time = .false.
    end if
    
    write(6,'(a,i1,a,i1)') 'Initialising N3LO mass (exact Fortran) threshold matrices for nf = ', nf_int-1,' -> ', nf_int
    call InitGridConv(grid, MTM_N3LO%PShq  , JB( PS, null(), null(), order=ord3))
    call AddWithCoeff(      MTM_N3LO%PShq  , JB(APS, null(), null(), order=  3))
    
    call InitGridConv(grid, MTM_N3LO%PShg  , JB( QG, null(), null(), order=ord3))
    call AddWithCoeff(      MTM_N3LO%PShg  , JB(AQGtotal, null(), null(), order=  3)) ! The full thing
    !
    call InitGridConv(grid, MTM_N3LO%PSqq_H, JB(PSL, null(), null(), order=ord3))
    !! there is no APSL, all is included in PSL

    !
    call InitGridConv(grid, MTM_N3LO%NSqq_H, JB( NSREG,  NSPLU,  NSDEL, order=ord3))
    call AddWithCoeff(      MTM_N3LO%NSqq_H, JB(ANSREG, ANSPLU, ANSDEL, order=  3))

    
    call InitGridConv(grid, MTM_N3LO%NSmqq_H, JB(OREG_znfasLL, OPLUS_znfasLL, ODEL_znfasLL, ord3))

    !
    call InitGridConv(grid, MTM_N3LO%Sgg_H, JB( GGREG,  GGPLU,  GGDEL, order=ord3))
    call AddWithCoeff(      MTM_N3LO%Sgg_H, JB(AGGREG, AGGPLU, AGGDEL, order=  3))
    !
    call InitGridConv(grid, MTM_N3LO%Sgq_H  , JB( GQ, null(), null(), order=ord3))
    call AddWithCoeff(      MTM_N3LO%Sgq_H  , JB(AGQ, null(), null(), order=  3))
    !
    call InitGridConv(grid, MTM_N3LO%Sqg_H  , JB(QGL, null(), null(), order=ord3))
    ! there is no AQGL, all is included in QGL
    
    ! set the MSbar piece to zero -- MSbar thresholds not yet supported, but still needs
    ! to be there to avoid errors in the code.
    call InitGridConv(grid, MTM_N3LO%PShg_MSbar)
    MTM_N3LO%masses_are_MSbar = .false.
    MTM_N3LO%Sgg_H_extra_MSbar_delta = zero

    MTM_N3LO%loops = 4
    MTM_N3LO%nf_int = nf_int

  end subroutine InitMTMN3LOExactFortran

  subroutine InitMTM_from_MTM(MTM, MTM_in)
    type(mass_threshold_mat), intent(inout) :: MTM
    type(mass_threshold_mat), intent(in)    :: MTM_in

    call InitGridConv(MTM%PSHq, MTM_in%PSHq)
    call InitGridConv(MTM%PSHg, MTM_in%PSHg)
    call InitGridConv(MTM%NSqq_H, MTM_in%NSqq_H)
    call InitGridConv(MTM%NSmqq_H, MTM_in%NSmqq_H)
    call InitGridConv(MTM%Sgg_H, MTM_in%Sgg_H)
    call InitGridConv(MTM%Sgq_H, MTM_in%Sgq_H)
    call InitGridConv(MTM%PSqq_H, MTM_in%PSqq_H)
    call InitGridConv(MTM%Sqg_H, MTM_in%Sqg_H)

    call InitGridConv(MTM%PShg_MSbar, MTM_in%PShg_MSbar)
    MTM%Sgg_H_extra_MSbar_delta = MTM_in%Sgg_H_extra_MSbar_delta
    MTM%loops = MTM_in%loops
    MTM%nf_int = MTM_in%nf_int
    MTM%masses_are_MSbar = MTM_in%masses_are_MSbar
  end subroutine InitMTM_from_MTM


  subroutine Multiply_MTM(MTM, factor)
   use assertions
   type(mass_threshold_mat), intent(inout) :: MTM
   real(dp),                 intent(in)    :: factor

   call Multiply(MTM%PSHq,  factor)
   call Multiply(MTM%PSHg,  factor)
   call Multiply(MTM%NSqq_H, factor)
   call Multiply(MTM%NSmqq_H, factor)
   call Multiply(MTM%Sgg_H,  factor)
   call Multiply(MTM%Sgq_H,  factor)
   call Multiply(MTM%PSqq_H, factor)
   call Multiply(MTM%Sqg_H,  factor)
   call Multiply(MTM%PShg_MSbar, factor)
   MTM%Sgg_H_extra_MSbar_delta = MTM%Sgg_H_extra_MSbar_delta * factor 
 end subroutine Multiply_MTM

 subroutine AddWithCoeff_MTM(MTM, MTM_to_add, factor)
    use assertions
    type(mass_threshold_mat), intent(inout) :: MTM
    type(mass_threshold_mat), intent(in)    :: MTM_to_add
    real(dp),                 intent(in), optional :: factor

    if (MTM%nf_int /= MTM_to_add%nf_int) call wae_error('AddWithCoeff_MTM, nf values are inconsistent')
    if (MTM%masses_are_MSbar .neqv. MTM_to_add%masses_are_MSbar) &
                           call wae_error('AddWithCoeff_MTM, masses_are_MSbar values are inconsistent')
    MTM%loops = max(MTM%loops, MTM_to_add%loops)

    call AddWithCoeff(MTM%PSHq, MTM_to_add%PSHq, factor)
    call AddWithCoeff(MTM%PSHg, MTM_to_add%PSHg, factor)
    call AddWithCoeff(MTM%NSqq_H, MTM_to_add%NSqq_H, factor)
    call AddWithCoeff(MTM%NSmqq_H, MTM_to_add%NSmqq_H, factor)
    call AddWithCoeff(MTM%Sgg_H, MTM_to_add%Sgg_H, factor)
    call AddWithCoeff(MTM%Sgq_H, MTM_to_add%Sgq_H, factor)
    call AddWithCoeff(MTM%PSqq_H, MTM_to_add%PSqq_H, factor)
    call AddWithCoeff(MTM%Sqg_H, MTM_to_add%Sqg_H, factor)
    call AddWithCoeff(MTM%PShg_MSbar, MTM_to_add%PShg_MSbar, factor)
    MTM%Sgg_H_extra_MSbar_delta = MTM%Sgg_H_extra_MSbar_delta + &
         & default_or_opt(one, factor)*MTM_to_add%Sgg_H_extra_MSbar_delta

  end subroutine AddWithCoeff_MTM


  !---------------------------------------------------------------------
  ! want to be able to set nf, defined as number of flavours
  ! after heavy matching
  subroutine SetNfMTM(MTM,nf_lcl)
    type(mass_threshold_mat), intent(inout) :: MTM
    integer,                intent(in)    :: nf_lcl
    if (MTM%loops > 3) then
       call wae_Error('SetNfMTM: MTM had loops > 3; nf is probably fixed')
    end if
    MTM%nf_int = nf_lcl
  end subroutine SetNfMTM
  
  !---------------------------------------------------------------------
  ! set the quark mass scheme for the MTM matching
  subroutine SetMassSchemeMTM(MTM, masses_are_MSbar)
    type(mass_threshold_mat), intent(inout) :: MTM
    logical,                  intent(in)    :: masses_are_MSbar
    MTM%masses_are_MSbar = masses_are_MSbar
  end subroutine SetMassSchemeMTM
  

  !----------------------------------------------------------------------
  ! Returns the amount to be added to go from nf-1 to nf flavours.
  ! Will try some tests to make sure that nf is consistent?
  !
  ! PDFs are assumed to be in "HUMAN" REPRESENTATION.
  function cobj_ConvMTM(MTM,q) result(Pxq)
    use qcd
    type(mass_threshold_mat), intent(in) :: MTM
    real(dp),   intent(in) :: q(0:,ncompmin:)
    real(dp)               :: Pxq(0:ubound(q,dim=1),ncompmin:ncompmax)
    real(dp) :: singlet(0:ubound(q,dim=1))    
    real(dp) :: dq_from_singlet(0:ubound(q,dim=1)) !!< addition to each flavour from singlet
    real(dp) :: plus(0:ubound(q,dim=1)), minus(0:ubound(q,dim=1))
    integer :: i, nf_light, nf_heavy

    !-- general sanity checks
    if (MTM%loops <=0 .or. MTM%nf_int <=0) call wae_error('cobj_ConvMTM:',&
         &'Mass threshold matrix is undefined')

    if (GetPdfRep(q) /= pdfr_Human) call wae_error('cobj_ConvMTM',&
         &'q is not in Human representation')

    nf_heavy = MTM%nf_int
    nf_light = nf_heavy - 1
    !write(0,*) 'Doing a MT convolution with nf_heavy =',nf_heavy

    if (ncomponents < nf_heavy) call wae_error('cobj_ConvMTM:',&
            &'ncomponents in representation is < nf in MTM.')
    if (iflv_g /= 0) call wae_Error('cobj_ConvMTM:','iflv_g/=0')
    
    !-- sanity check on nf
    !if (any(q(:,-nf_heavy)/=zero) .or. any(q(:,nf_heavy)/=zero)) &
    !     & call wae_error('cobj_ConvMTM:',&
    !     &'Distribution already has non-zero components at nf_heavy')
    
    singlet = sum(q(:,-nf_light:-1),dim=2) + sum(q(:,1:nf_light),dim=2)

    if (MTM%masses_are_MSbar) then
      if (MTM%loops /= 3) call wae_error('cobj_ConvMTM:',&
            &'masses_are_MSbar but MTM is not NNLO')
      Pxq(:,nf_heavy) = half*(&
           &(MTM%PShq .conv. singlet) + (MTM%PShg_MSbar .conv. q(:,iflv_g)) )
    else 
      Pxq(:,nf_heavy) = half*(&
           &(MTM%PShq .conv. singlet) + (MTM%PShg .conv. q(:,iflv_g)) )
    end if
    
    Pxq(:,-nf_heavy) = Pxq(:,nf_heavy)
    Pxq(:,iflv_g)     = (MTM%Sgq_H.conv. singlet) + (MTM%Sgg_H.conv. q(:,iflv_g))

    ! the extra delta-function piece in the MSbar scheme
    if (MTM%masses_are_MSbar) then
      Pxq(:,iflv_g) = Pxq(:,iflv_g) + MTM%Sgg_H_extra_MSbar_delta*q(:,iflv_g)
    end if
    
    ! the singlet contributions to the individual light-quark flavours,
    ! which we compute once and for all here, per flavour. 
    !  
    ! The convention that we use is that PSqq_H and Sqg_H provide with the 
    ! contribution to the total light singlet quark flavour; so to get
    ! the contribution to the singlet quark flavour we need to divide by
    ! by (2*nf_light)
    dq_from_singlet = (half/nf_light) * ((MTM%PSqq_H * singlet) + (MTM%Sqg_H * q(:,iflv_g)))

    ! finally do all individual light-quark flavours
    do i = 1, ncomponents
       if (i > nf_heavy) then
          Pxq(:, i) = zero
          Pxq(:,-i) = zero
       else if (i == iflv_g .or. abs(i) == nf_heavy) then
          cycle
       else
          plus  = MTM%NSqq_H  * (q(:,i)+q(:,-i))
          minus = MTM%NSmqq_H * (q(:,i)-q(:,-i))
          Pxq(:, i) = half*(plus+minus) + dq_from_singlet
          Pxq(:,-i) = half*(plus-minus) + dq_from_singlet
       end if
    end do

    call LabelPdfAsRep(Pxq,pdfr_Human)
  end function cobj_ConvMTM
  

  !---- usual cleaning up --------------------------------------------
  subroutine cobj_DelMTM(MTM)
    type(mass_threshold_mat), intent(inout) :: MTM
    call Delete(MTM%PSHq)
    call Delete(MTM%PSHg)
    call Delete(MTM%PShg_MSbar)
    call Delete(MTM%NSqq_H)
    call Delete(MTM%NSmqq_H)
    call Delete(MTM%Sgg_H)
    call Delete(MTM%Sgq_H)
    call Delete(MTM%PSqq_H)
    call Delete(MTM%Sqg_H)
    MTM%loops = -1
    MTM%nf_int = -1
  end subroutine cobj_DelMTM


  !======================================================================
  ! From here onwards we have things to do with coefficient functions
  subroutine cobj_InitCoeffLO(grid,C, factor)
    type(grid_def), intent(in)    :: grid
    type(coeff_mat),     intent(inout) :: C
    real(dp),       intent(in), optional :: factor

    C%grid = grid
    C%HO = .false.
    if (present(factor)) then
       C%delta = factor
    else
       C%delta = one
    end if
  end subroutine cobj_InitCoeffLO
  
  !-- HO. coeff function is not quite so simple. Note that we do simply 
  !   call it NLO, because it could also be relevant at O(as^2).
  !   NOTE UNUSUAL ORDER...
  subroutine cobj_InitCoeffHO(grid, C, coeff_g, coeff_q)
    use convolution_communicator
    type(grid_def), intent(in)    :: grid
    type(coeff_mat),     intent(inout) :: C
    interface
       function coeff_g(x)
         use types; implicit none
         real(dp), intent(in) :: x
         real(dp)             :: coeff_g
       end function coeff_g
    end interface
    interface
       function coeff_q(x)
         use types; implicit none
         real(dp), intent(in) :: x
         real(dp)             :: coeff_q
       end function coeff_q
    end interface
    real(dp) :: sanity1, sanity2

    C%grid = grid
    C%HO = .true.
    C%delta = zero
    call InitGridConv(grid,C%g, coeff_g)
    call InitGridConv(grid,C%q, coeff_q)
    !-- a sanity check: quite often the arguments for the
    !   quark and gluon pieces get exchanged.
    !   Cannot always ensure correctness (e.g. FL), but can 
    !   detect some cases of misuse
    cc_piece = cc_VIRT
    sanity1 = coeff_g(one)
    cc_piece = cc_DELTA
    sanity2 = coeff_g(zero)
    if (sanity1 /= zero .or. sanity2 /= zero) then
       write(0,*) 'WARNING in cobj_InitCoeffHO **********************'
       write(0,*) 'gluon coefficient function has virtual corrections'
       write(0,*) 'this could be a sign that quark and gluon cf fns have&
            & been exchanged'
       write(0,*) '**************************************************'
    end if
  end subroutine cobj_InitCoeffHO

  !-- initialise C as being factor*Cin ----------------------
  subroutine cobj_InitCoeff_cf(C, Cin, factor)
    type(coeff_mat),     intent(inout) :: C
    type(coeff_mat),     intent(in)    :: Cin
    real(dp),       intent(in), optional :: factor

    C%grid = Cin%grid
    C%HO = Cin%HO
    C%delta = Cin%delta
    if (present(factor)) C%delta = C%delta * factor
    if (C%HO) then
       call InitGridConv(C%q, Cin%q, factor)
       call InitGridConv(C%g, Cin%g, factor)
    end if
  end subroutine cobj_InitCoeff_cf

  
  !-- initialise C as being factor*Cin ----------------------
  subroutine cobj_AddCoeff(C, Cin, factor)
    type(coeff_mat),     intent(inout) :: C
    type(coeff_mat),     intent(in)    :: Cin
    real(dp),       intent(in), optional :: factor

    call ValidateGD(C%grid,Cin%grid,'cobj_AddCoeff')
    if (present(factor)) then 
       C%delta = C%delta  + Cin%delta * factor
    else
       C%delta = C%delta  + Cin%delta
    end if
    
    if (Cin%HO) then
       if (C%HO) then
          call AddWithCoeff(C%q, Cin%q, factor)
          call AddWithCoeff(C%g, Cin%g, factor)
       else
          call InitGridConv(C%q, Cin%q, factor)
          call InitGridConv(C%g, Cin%g, factor)
       end if
    end if
    C%HO = C%HO .or. Cin%HO
  end subroutine cobj_AddCoeff

  !----------------------------------------------------------------------
  ! Clear a coefficient function (dealloc memory)
  subroutine cobj_DelCoeff(C)
    type(coeff_mat),     intent(inout) :: C

    if (C%HO) then
       call Delete(C%g)
       call Delete(C%q)
    end if
  end subroutine cobj_DelCoeff



  !-------------------------------------------------------------------
  function cobj_CConv(C,q) result(Cxq)
    type(coeff_mat), intent(in) :: C
    real(dp),   intent(in) :: q(0:,0:)
    real(dp)               :: Cxq(0:ubound(q,dim=1))
    !--------------------------------------------------
    real(dp) :: ud(0:ubound(q,dim=1))
    real(dp), parameter :: uq2 = (4.0_dp/9.0_dp)
    real(dp), parameter :: dq2 = (1.0_dp/9.0_dp)

    call wae_error('cobj_CConv:', &
         &'coefficient functions not yet suppoprted with new representation')
    Cxq = zero
    !REPLACE ud = q(:,iflv_u)*uq2 + q(:,iflv_d)*dq2
    !REPLACE if (C%HO) then
    !REPLACE    !-- CHECK: factor of two in front of nf_u and nf_d is there both 
    !REPLACE    !   in ESW and the ADS paper.
    !REPLACE    Cxq = (two*(nf_u*uq2 + nf_d*dq2)) * (C%g .conv. q(:,iflv_g))&
    !REPLACE         & + (C%q .conv. ud)
    !REPLACE    if (C%delta /= zero) Cxq = Cxq + C%delta * ud
    !REPLACE else
    !REPLACE    Cxq = C%delta * ud
    !REPLACE end if
  end function cobj_CConv

  !-------------------------------------------------------------------
  ! Calculates [(C2 - y^2/(1+(1-y)^2) CL) .conv. pdf] .atx. xbj
  ! put it here to have access to .conv. for coefficient functions
  function cobj_Eval2LConv(C2, CL, pdf, xbj, ybj) result(res)
    use types; use consts_dp; use convolution
    type(coeff_mat), intent(in)  :: C2, CL
    real(dp),   intent(in)  :: pdf(0:,0:), xbj, ybj
    real(dp)                :: res
    !----------------------------------------------
    type(gdval) :: gdx
    type(coeff_mat)  :: C2L

    call cobj_InitCoeff(C2L, C2)
    call cobj_AddCoeff (C2L, CL, - ybj**2/(1+(1-ybj)**2) )
    gdx = xbj .with. C2%grid
    res = EvalGridQuant(gdx%grid, (C2L .conv. pdf), -log(gdx%val))
    !res = ((C2L.conv.pdf) .atx. gdx ) 
    call cobj_DelCoeff (C2L)
  end function cobj_Eval2LConv
    
end module dglap_objects
!end module dglap_objects_hidden

!---------------------------------------------------------------
!! provides facilities related to alphas calculations
!!
!! there are two ways of accessing it: either with a handle which 
!! contains the details of the particular alfas which is being dealt
!! with (e.g. one loop etc...), or without a handle, in which case the
!! global handle is used.
!!
!! Original core based on BRW (analytical NLO running coupling)
!! Tested 25/04/00
!!
!! NB: Subsequently updated to makes use of the new_as module which
!! implements running coupling via the solution of the QCD
!! differential equation. Therefore the code present in this module is
!! mostly redundant and the real work is being done in new_as.f90
!!  
!-------------------------------------------------------------------
module qcd_coupling
  use new_as; use types; use consts_dp
  use warnings_and_errors
  implicit none
  private


type running_coupling 
    !private
    type(na_handle) :: nah      ! simply "redirect" to new coupling
    logical         :: use_nah
    !-- following components are related to old analytical approximations
    real(dp) :: QCDL5
    real(dp) :: BN(3:6), CN(3:6), CN5(3:6)
    integer  :: nloop, nf
 contains
    procedure :: Value => as_Value_ash
  end type running_coupling
  public :: running_coupling

  interface InitRunningCoupling
     module procedure  as_Init_ash, as_Init_noash
  end interface
  public :: InitRunningCoupling
  interface Value
     module procedure  as_Value_ash, as_Value_noash
  end interface
  public :: Value
  interface RunningCoupling
     module procedure  as_Value_ash, as_Value_noash
  end interface
  public :: RunningCoupling
  interface Delete
     !-- for digital f90 the second one causes problems
     module procedure  as_Del_ash!, as_Del_noash
  end interface
  public :: Delete
  public :: NfRange, NfAtQ, QRangeAtNf, QuarkMass, QuarkMassesAreMSbar
  interface NumberOfLoops
     module procedure NumLoops_in_coupling
  end interface
  public :: NumberOfLoops
  public :: SetDefaultCouplingDt, DefaultCouplingDt

  ! A public instance of the coupling (as far as an outside user is
  ! concerned). This is set if the user calls the initialisation
  ! routine without providing a "running_coupling" object as an 
  ! argument. HIGHLY discouraged and may break in the future...
  type(running_coupling), target, save :: ash_global
  public :: ash_global


  !--- all constants below relate to the now somewhat obsolete
  !    NLO analytical approximation for the running coupling
  !-----------------------------------------------------------------
  !-- inclusion of CN is a rather tricky way of introducing 
  !   support for 1 and 2-loops in a fairly similary way
  !   and B(3:6) is a way of introducing support for fixed or variable
  !   flavour numbers
  real(dp), parameter :: rmass(6) = (/0D0,0D0,.15D0,1.7D0,5.3D0,175D0/)
  !real(dp), parameter :: rmass(6) = (/0D0,0D0,1D0,1.1D0,1.2D0,2005D0/)
  real(dp), parameter :: CAFAC = 3.0_dp, CFFAC = 4.0_dp/3.0_dp
  real(dp), parameter :: PIFAC = 3.141592653589793238462643383279502884197_dp
  real(dp), parameter :: B3=((11.0_dp*CAFAC)- 6.0_dp)/(12.0_dp*PIFAC) 
  real(dp), parameter :: B4=((11.0_dp*CAFAC)- 8.0_dp)/(12.0_dp*PIFAC) 
  real(dp), parameter :: B5=((11.0_dp*CAFAC)-10.0_dp)/(12.0_dp*PIFAC) 
  real(dp), parameter :: B6=((11.0_dp*CAFAC)-12.0_dp)/(12.0_dp*PIFAC) 
  !-- with absoft there are some difficulties in accessing this quant
  !   from outside 
  real(dp), parameter, public :: as_BN(3:6) = (/ B3, B4, B5, B6/)
  real(dp), parameter :: trueC3=((17.0_dp*CAFAC**2)-(5.0_dp*CAFAC+3.0_dp&
       &*CFFAC)*3.0_dp) /(24.0_dp*PIFAC**2)/B3**2 
  real(dp), parameter :: trueC4=((17.0_dp*CAFAC**2)-(5.0_dp*CAFAC+3.0_dp&
       &*CFFAC)*4.0_dp) /(24.0_dp*PIFAC**2)/B4**2 
  real(dp), parameter :: trueC5=((17.0_dp*CAFAC**2)-(5.0_dp*CAFAC+3.0_dp&
       &*CFFAC)*5.0_dp) /(24.0_dp*PIFAC**2)/B5**2 
  real(dp), parameter :: trueC6=((17.0_dp*CAFAC**2)-(5.0_dp*CAFAC+3.0_dp&
       &*CFFAC)*6.0_dp) /(24.0_dp*PIFAC**2)/B6**2 
  real(dp), parameter :: as_CN(3:6) = (/ trueC3, trueC4, trueC5, trueC6 /)


contains

  !-- alternative versions to allow access to a global alpha
  subroutine as_Init_noash(alfas, Q, qcdl5, nloop, fixnf,  &
       & quark_masses, masses_are_MSbar, muMatch_mQuark, use_nah)
    real(dp), intent(in), optional :: alfas, Q, qcdl5
    integer,  intent(in), optional :: nloop, fixnf
    real(dp), intent(in), optional :: quark_masses(4:6)
    logical,  intent(in), optional :: masses_are_MSbar
    real(dp), intent(in), optional :: muMatch_mQuark
    logical,  intent(in), optional :: use_nah
    type(running_coupling), pointer :: coupling
    coupling => ash_global
    call as_Init_ash(coupling, alfas, Q, nloop, fixnf,  &
       & quark_masses, masses_are_MSbar, muMatch_mQuark, use_nah, qcdl5)
  end subroutine as_Init_noash
  
  function as_Value_noash(Q,fixnf) result(Value)
    real(dp), intent(in) :: Q
    real(dp)             :: Value
    type(running_coupling), pointer  :: coupling
    integer, intent(in), optional :: fixnf
    coupling => ash_global
    Value = as_Value_ash(coupling, Q, fixnf)
  end function as_Value_noash

  subroutine as_Del_noash()
    type(running_coupling), pointer :: coupling
    coupling => ash_global
    call as_Del_ash(coupling)
  end subroutine as_Del_noash
  

  !======================================================================
  ! The following are essentially interface routines to bryan's 
  ! code for alfas
  ! if present alfas then set coupling such alfas at M_Z or Q is equal to alpha_s
  ! Alternatively set qcdl5
  ! Can also optionally modify the number of loops and fix the number
  ! of flavours
  !
  ! As of 30/06/2001, by sepcifying use_nah=.true. it should give
  ! fairly transparent access to the differential equation solution
  ! for alfas, using new_as. The only proviso is that initialisation 
  ! may well be quite a bit slower. Also if we want to reinitialise
  ! then it is necessary to call Delete
  !
  ! As of 16/01/2001 use_nah=.true. will become the default
  !
  ! Feature added 21/02/2011: masses_are_MSbar, default is false; if
  ! true then masses are assumed to be MSbar masses, evaluated at the
  ! mass itself, m_MSbar(m_MSbar).
  !
  ! As of 2018-12-27: it should now accept nloop = 0, to provide a
  ! fixed-coupling class
  subroutine as_Init_ash(coupling, alfas, Q, nloop, fixnf, &
       & quark_masses, masses_are_MSbar, muMatch_mQuark, use_nah, qcdl5)
    use assertions
    type(running_coupling) :: coupling
    real(dp), intent(in), optional :: alfas, Q, qcdl5
    integer,  intent(in), optional :: nloop, fixnf
    real(dp), intent(in), optional :: quark_masses(4:6)
    logical,  intent(in), optional :: masses_are_MSbar
    real(dp), intent(in), optional :: muMatch_mQuark
    logical,  intent(in), optional :: use_nah
    real(dp) :: dummy, lower, upper, middle
    real(dp) :: Qloc
    real(dp), parameter :: mz = 91.1880_dp
    real(dp) :: eps = 1e-8_dp

    coupling%use_nah = default_or_opt(.true., use_nah)
    if (coupling%use_nah) then
       call na_Init(coupling%nah, alfas, Q, nloop, fixnf, &
            &           quark_masses, masses_are_MSbar, muMatch_mQuark)
       return
    else
       call wae_error('as_Init_ash','old alphas (analytic approx to solution) is obsolete and will not run...')
    end if

    if (present(nloop)) then
       coupling%nloop = nloop
    else
       coupling%nloop = 2
    end if

    !-- a fudge to fix the number of flavours
    if (present(fixnf)) then
       coupling%BN = as_BN(fixnf)
       coupling%CN = as_CN(fixnf)
    else
       coupling%BN = as_BN
       coupling%CN = as_CN
    end if
    
    !-- a fudge to set the number of loops
    select case (coupling%nloop)
    case(1)
       coupling%CN   = zero
    case(2)
       ! keep coupling%CN = as_CN as it was set before
    case default
       stop 'InitRunningCoupling: nloop must be either 1 or 2'
    end select

    if (present(alfas)) then
       if (present(Q)) then
          Qloc = Q
       else
          Qloc = mz
       end if
       !-- set up search limits ----------------------------
       lower = 0.01_dp
       upper = 1.0_dp
       !-- we may need to revise lower and upper...
       do
          call priv_as_init_2l(coupling,lower); dummy = Value(coupling,Qloc)
          if (dummy > alfas) then
             !call hwwarn(100)
             upper = lower
             lower = lower**2
             cycle
          end if
          call priv_as_init_2l(coupling,upper); dummy = Value(coupling,Qloc)
          if (dummy < alfas) call hwwarn(101)
          exit
       end do
       do 
          !-- could be more efficient -- but too lazy for now
          !write(0,'(4f20.15)') upper, lower, dummy, alfas
          middle = sqrt(lower*upper)
          call priv_as_init_2l(coupling,middle)
          dummy = Value(coupling,Qloc)
          if (dummy >= alfas) upper = middle
          if (dummy < alfas) lower = middle
          if (upper/lower-1.0_dp < eps ) exit
       end do
    elseif (present(qcdl5)) then
       call priv_as_init_2l(coupling,qcdl5)
    else
       !call priv_as_init_2l(coupling,0.280_dp)  ! alfas(91) = 0.124
       call priv_as_init_2l(coupling,0.214_dp)  ! alfas(91) = 0.117
       !call priv_as_init_2l(coupling,0.158_dp)  ! alfas(91) = 0.112
    end if
  end subroutine as_Init_ash


  !======================================================================
  function as_Value_ash(coupling, Q, fixnf) result(Value)
    class(running_coupling)      :: coupling
    real(dp), intent(in) :: Q
    real(dp)             :: Value
    integer, intent(in), optional :: fixnf
    if (coupling%use_nah) then
       Value = na_Value(coupling%nah, Q, fixnf)
    else
       if (present(fixnf)) call wae_error('as_Value_ash: &
            &fixnf not support for old alpha_s')
       Value = hwualf(coupling, 1, Q)
    end if
  end function as_Value_ash


  !======================================================================
  !! Returns the number of loops used for the evolution of this coupling.
  integer function NumLoops_in_coupling(coupling)
    type(running_coupling) :: coupling
    if (coupling%use_nah) then
       NumLoops_in_coupling = na_NumberOfLoops(coupling%nah)
    else
       NumLoops_in_coupling = coupling%nloop
    end if
    
  end function NumLoops_in_coupling
  

  !-----------------------------------------------------------------
  ! do any required cleaning up 
  subroutine as_Del_ash(coupling)
    type(running_coupling)      :: coupling
    if (coupling%use_nah) call na_Del(coupling%nah)
  end subroutine as_Del_ash

  !-----------------------------------------------------------------
  ! Indicate the range of nf values supported by this handle.
  subroutine NfRange(coupling, nflo, nfhi)
    type(running_coupling), intent(in)  :: coupling
    integer,         intent(out) :: nflo, nfhi
    if (coupling%use_nah) then
       call na_nfRange(coupling%nah,nflo,nfhi)
    else
       call wae_Error('NfRange: this routine&
            & is only supported with new alpha_s')
    end if
  end subroutine NfRange
  
  !-------------------------------------------------------------
  ! Returns the number of flavours relevant for scale Q
  ! Also returns the range of Qvalues (Qlo, Qhi) for which 
  ! this value of nf remains the same.
  function NfAtQ(coupling, Q, Qlo, Qhi, muM_mQ)
    integer                             :: nfAtQ
    type(running_coupling), intent(in)  :: coupling
    real(dp),        intent(in)  :: Q
    real(dp),        intent(out), optional :: Qlo, Qhi
    real(dp),        intent(in),  optional :: muM_mQ
    !-----------------------------
    if (coupling%use_nah) then
       call na_nfAtQ(coupling%nah, Q, nfAtQ, Qlo, Qhi, muM_mQ)
    else
       call wae_Error('NfAtQ: this routine&
            & is only supported with new alpha_s')
    end if
  end function NfAtQ
  
  
  !======================================================================
  real(dp) function QuarkMass(coupling, iflv) result(mass)
    type(running_coupling), intent(in) :: coupling
    integer,                intent(in) :: iflv
    if (coupling%use_nah) then
       mass = na_QuarkMass(coupling%nah, iflv)
    else
       call wae_Error('QuarkMass: this routine&
            & is only supported with new alpha_s')
    end if
  end function QuarkMass


  !======================================================================
  logical function QuarkMassesAreMSbar(coupling) result(res)
    type(running_coupling), intent(in) :: coupling
    if (coupling%use_nah) then
       res = na_QuarkMassesAreMSbar(coupling%nah)
    else
       call wae_Error('QuarkMassesAreMSbar: this routine&
            & is only supported with new alpha_s')
    end if
  end function QuarkMassesAreMSbar
  
  !-------------------------------------------------------------
  ! returns the Q range for a given value of nf. If supported.
  subroutine QRangeAtNf(coupling, nflcl, Qlo, Qhi, muM_mQ)
    type(running_coupling), intent(in)  :: coupling
    integer,         intent(in)  :: nflcl
    real(dp),        intent(out) :: Qlo, Qhi
    real(dp),        intent(in),  optional :: muM_mQ
    if (coupling%use_nah) then
       call na_QrangeAtNf(coupling%nah, nflcl, Qlo, Qhi, muM_mQ)
    else
       call wae_Error('QRangeAtNf: this routine&
            & is only supported with new alpha_s')
    end if
  end subroutine QRangeAtNf
  
  !----------------------------------------------------------------------
  ! the routine that does the real initialisation of alfas
  subroutine priv_as_init_2l(coupling, qcdl5)
    type(running_coupling)      :: coupling
    real(dp), intent(in) :: qcdl5
    real(dp) :: dummy
    coupling%qcdl5 = qcdl5
    dummy = HWUALF(coupling, 0, 1e2_dp)
  end subroutine priv_as_init_2l
  !-----------------------------------------------------------------------
  !     STRONG COUPLING CONSTANT
  !     IOPT == 0  INITIALIZES
  !          == 1  TWO-LOOP, FLAVOUR THRESHOLDS
  !
  ! BRW routine, with various bits and pieces shuffled around or
  ! removed by GPS on 24/04/00
  !---------------------------------------------------------------------
  FUNCTION HWUALF(coupling, IOPT, SCALE) 
    REAL(DP) :: HWUALF 
    type(running_coupling), target :: coupling
    real(dp), intent(in) :: scale
    integer,  intent(in) :: iopt
    !--------------------------------------------------------------------
    REAL(DP)          :: RHO,RAT,RLF
    real(dp), pointer :: CN5(:), CN(:), QCDL5, BN(:)
    integer           :: nf

    CN5   => coupling%CN5
    QCDL5 => coupling%QCDL5
    CN    => coupling%CN
    BN    => coupling%BN

    !-- the rest is init related to this value of lambda5
    IF (IOPT == 0) THEN 
       !---QCDL5 IS 5-FLAVOUR LAMBDA-MS-BAR                                    
       !---COMPUTE THRESHOLD MATCHING                                          
       RHO=2.0_dp*LOG(RMASS(6)/QCDL5) 
       RAT=LOG(RHO)/RHO 
       CN5(6)=(coupling%BN(5)/(1.0_dp-CN(5)*RAT)-coupling%BN(6)/(1.0_dp-CN(6)*RAT))*RHO 
       RHO=2.0_dp*LOG(RMASS(5)/QCDL5) 
       RAT=LOG(RHO)/RHO 
       CN5(4)=(coupling%BN(5)/(1.0_dp-CN(5)*RAT)-coupling%BN(4)/(1.0_dp-CN(4)*RAT))*RHO 
       RHO=2.0_dp*LOG(RMASS(4)/QCDL5) 
       RAT=LOG(RHO)/RHO 
       CN5(3)=(coupling%BN(4)/(1.0_dp-CN(4)*RAT)-&
            & coupling%BN(3)/(1.0_dp-CN(3)*RAT))*RHO+CN5(4) 
       CN5(5) = zero
    ENDIF
    IF (SCALE <= QCDL5) then; CALL HWWARN(51); hwualf=0.0_dp; return
    end IF
    RHO=2.0_dp*LOG(SCALE/QCDL5) 
    RAT=LOG(RHO)/RHO 
    !-- this will allow us to fiddle nf later on, according to some
    !   flag in coupling
    nf = priv_nf(coupling, scale)
    RLF = coupling%BN(nf)*RHO/(one - CN(nf)*RAT) + CN5(nf)
!!$    select case(nf)
!!$    case(6)
!!$       RLF=B6*RHO/(1.0_dp-CN(6)*RAT)+CN5(6) 
!!$    case(5)
!!$       RLF=B5*RHO/(1.0_dp-CN(5)*RAT) 
!!$    case(4)
!!$       RLF=B4*RHO/(1.0_dp-CN(4)*RAT)+CN5(4) 
!!$    case default
!!$       RLF=B3*RHO/(1.0_dp-CN(3)*RAT)+CN5(3) 
!!$    end select
    IF (RLF <= ZERO) then; CALL HWWARN(53); hwualf=0.0_dp; return
    end IF

    IF (IOPT == 1) THEN 
       HWUALF=1.0_dp/RLF 
    ENDIF
  end function hwualf

  !---------------------------------------------------------------
  ! returns the appropriate for the given scale
  function priv_nf(coupling, scale) result(nf)
    type(running_coupling), intent(in) :: coupling
    real(dp),        intent(in) :: scale
    integer                     :: nf
    IF (SCALE > RMASS(6)) THEN 
       nf = 6
    ELSEIF (SCALE > RMASS(5)) THEN 
       nf = 5
    ELSEIF (SCALE > RMASS(4)) THEN 
       nf = 4
    ELSE 
       nf = 3
    ENDIF
  end function priv_nf
  

  !-- a little primitive? --------------------------------------------
  SUBROUTINE HWWARN(ICODE) 
    integer, intent(in) :: icode
    real(dp) :: a, b
    write(0,*) ' ALFAS WARNING CODE',ICODE
    a = sqrt(0.0_dp)
    b = a**2
    !write(0,*) 1.0_dp/(a-b)
    stop
  END SUBROUTINE HWWARN


end module qcd_coupling

!!$program astest
!!$  use types; use consts_dp
!!$  use qcd_coupling
!!$  implicit none
!!$  integer  :: i
!!$  real(dp) :: Q
!!$
!!$  call InitRunningCoupling(alfas=0.118_dp,nloop=2)
!!$  do i = 0,100
!!$     Q = 91.2_dp**(i/100.0_dp)
!!$     write(6,*) Q, Value(Q)
!!$  end do
!!$  
!!$end program astest

!! An example program using HOPPET's streamlined interface. 
!! It outputs a subset of
!! table 15 of hep-ph/0511119 and this output should be identical
!! to the contents of the file tabulation_example_streamlined.default_output
!!
!! NB: for the full functionality used in generating the HeraLHC and
!!     Les Houches comparison tables, see ../benchmarks/benchmarks.f90
!!     and carefully read the comments at the beginning. Subtleties
!!     exist in particular wrt the treatment of scales muF/=muR.
!!
!! NB: commented code shows usage with LHAPDF (e.g. for cross-checking 
!!     some public PDF set's evolution) -- to use this part of the code
!!     you will also need to link with LHAPDF
!!
!! This program uses the streamlined HOPPET interface rather
!! than the more general ones, used in the example programs
!! tabulation_example.f90 and tabulation_example_2.f90
!!
!!



module lhasub4streamlined
  implicit none

contains
  !======================================================================
  !! The dummy PDF suggested by Vogt as the initial condition for the 
  !! unpolarized evolution (as used in hep-ph/0511119).
  subroutine LHAsub(x,Q,xpdf)
  use types; use consts_dp; use hoppet; implicit none
    real(dp), intent(in)  :: x,Q
    real(dp), intent(out) :: xpdf(-6:6)
    real(dp) :: uv, dv
    real(dp) :: ubar, dbar
    !---------------------
    real(dp), parameter :: N_g = 1.7_dp, N_ls = 0.387975_dp
    real(dp), parameter :: N_uv=5.107200_dp, N_dv = 3.064320_dp
    real(dp), parameter :: N_db = half*N_ls
  
    ! Set to zero the xpdf array
    xpdf = zero
    
  
    !-- remember that these are all x*q(x)
    uv = N_uv * x**0.8_dp * (1-x)**3
    dv = N_dv * x**0.8_dp * (1-x)**4
    dbar = N_db * x**(-0.1_dp) * (1-x)**6
    ubar = dbar * (1-x)
  
    ! labels iflv_g, etc., come from the hoppet module, inherited
    ! from the main program
    xpdf(iflv_g) = N_g * x**(-0.1_dp) * (1-x)**5
    xpdf(-iflv_s) = 0.2_dp*(dbar + ubar)
    xpdf(iflv_s) = xpdf(-iflv_s)
    xpdf(iflv_u) = uv + ubar
    xpdf(-iflv_u) = ubar
    xpdf(iflv_d) = dv + dbar
    xpdf(-iflv_d) = dbar
  end subroutine LHAsub
end module lhasub4streamlined




program tabulation_example_streamlined
  use hoppet; use lhasub4streamlined
  !! if using LHAPDF, rename a couple of hoppet functions which
  !! would otherwise conflict with LHAPDF 
  !use hoppet, EvolvePDF_hoppet => EvolvePDF, InitPDF_hoppet => InitPDF
  implicit none
  real(dp) :: dy, ymax, dlnlnQ, Qmin, Qmax, muR_Q
  real(dp) :: asQ, Q0alphas, Q0pdf
  real(dp) :: mc,mb,mt
  integer  :: order, nloop
  !! hold results at some x, Q
  real(dp) :: Q, xpdf_at_xQ(-6:6)
  real(dp), parameter :: heralhc_xvals(9) = &
       & (/1e-5_dp,1e-4_dp,1e-3_dp,1e-2_dp,0.1_dp,0.3_dp,0.5_dp,0.7_dp,0.9_dp/)
  integer  :: ix
  !! define the interfaces for LHA pdf (by default not used)
  !! (NB: unfortunately this conflicts with an internal hoppet name,
  !! so make sure that you "redefine" the internal hoppet name,
  !! as illustrated in the commented "use" line above:
  !! use hoppet, EvolvePDF_hoppet => EvolvePDF, ...)
  ! interface
  !    subroutine EvolvePDF(x,Q,res)
  !      use types; implicit none
  !      real(dp), intent(in)  :: x,Q
  !      real(dp), intent(out) :: res(*)
  !    end subroutine EvolvePDF
  ! end interface

  ! Streamlined initialization
  ! including  parameters for x-grid
  order = -6
  ymax  = 12.0_dp
  dy    = 0.1_dp
  ! and parameters for Q tabulation
  Qmin=1.0_dp
  Qmax=28000.0_dp
  dlnlnQ = dy/4.0_dp
  ! and number of loops to initialise!
  nloop = 3
  call hoppetStartExtended(ymax,dy,Qmin,Qmax,dlnlnQ,nloop,&
       &         order,factscheme_MSbar)
  write(6,'(a)') "Streamlined initialization completed!"
  
  ! Set heavy flavour scheme
  mc = 1.414213563_dp   ! sqrt(2.0_dp) + epsilon
  mb = 4.5_dp
  mt = 175.0_dp
  call hoppetSetVFN(mc, mb, mt)

  ! Streamlined evolution
 
  ! Set parameters of running coupling
  asQ = 0.35_dp
  Q0alphas = sqrt(2.0_dp)
  muR_Q = 1.0_dp
  Q0pdf = sqrt(2.0_dp) ! The initial evolution scale
  call hoppetEvolve(asQ, Q0alphas, nloop,muR_Q, LHAsub, Q0pdf)
  write(6,'(a)') "Evolution done!"
  
  
  ! get the value of the tabulation at some point
  Q = 100.0_dp
  write(6,'(a)')
  write(6,'(a,f8.3,a)') "           Evaluating PDFs at Q = ",Q," GeV"
  write(6,'(a5,2a12,a14,a10,a12)') "x",&
       & "u-ubar","d-dbar","2(ubr+dbr)","c+cbar","gluon"
  do ix = 1, size(heralhc_xvals)
     call hoppetEval(heralhc_xvals(ix),Q,xpdf_at_xQ)
     write(6,'(es7.1,5es12.4)') heralhc_xvals(ix), &
          &  xpdf_at_xQ(2)-xpdf_at_xQ(-2), &
          &  xpdf_at_xQ(1)-xpdf_at_xQ(-1), &
          &  2*(xpdf_at_xQ(-1)+xpdf_at_xQ(-2)), &
          &  (xpdf_at_xQ(-4)+xpdf_at_xQ(4)), &
          &  xpdf_at_xQ(0)
  end do
  
 
! ! Now perform cached evolution
!  call hoppetPreEvolve(asQ, Q0alphas, nloop,muR_Q,Q0pdf)
!  write(6,'(a)') "Pre-evolution prepared!"
!
!  call hoppetCachedEvolve(LHAsub)
!  write(6,'(a)') "Cached evolution performed!"
!
!  ! Same output as before
!  Q = 100.0_dp
!  write(6,'(a)')
!  write(6,'(a,f8.3,a)') "           Evaluating PDFs at Q = ",Q," GeV"
!  write(6,'(a5,2a12,a14,a10,a12)') "x",&
!       & "u-ubar","d-dbar","2(ubr+dbr)","c+cbar","gluon"
!  do ix = 1, size(heralhc_xvals)
!     call hoppetEval(heralhc_xvals(ix),Q,xpdf_at_xQ)
!     write(6,'(es7.1,5es12.4)') heralhc_xvals(ix), &
!          &  xpdf_at_xQ(2)-xpdf_at_xQ(-2), &
!          &  xpdf_at_xQ(1)-xpdf_at_xQ(-1), &
!          &  2*(xpdf_at_xQ(-1)+xpdf_at_xQ(-2)), &
!          &  (xpdf_at_xQ(-4)+xpdf_at_xQ(4)), &
!          &  xpdf_at_xQ(0)
!  end do

  ! perform cleanup (not strictly required)
  call hoppetDeleteAll()
  
end program tabulation_example_streamlined

!! Program to test correct implementation of bidirectional mass thresholds.
!!
!! Run it as follows
!!
!! ./bidirectional_mass_thresholds -as 0.005 [-evop] >! bi-c0.005
!! ./bidirectional_mass_thresholds -as 0.01  [-evop] >! bi-c0.01
!!
!! It evolves from 1.4GeV to 1.5GeV (crossing charm threshold) and
!! back. Col  1 = y; 
!!       cols 2-4 = initial (/g,s,c/);
!!       cols 5-7 = final   (/g,s,c/);
!!
!! Given that upwards threshold were working before, test that 
!! downwards ones also work is that the following combinations should
!! all be O(as^4) [since threshold = O(as^2), so non-cancelling piece
!! between up and down directions should be the square of that]
!!
!!       ($5-$2) [initial glue    - final glue]
!!       ($6-$3) [initial strange - final strange]
!!       ($7-$4) [initial charm   - final charm]
!!
!! Note that in the evop formulation, because the result of a
!! convolution has frozen flavours to zero, one loses the left-over
!! "intrinsic charm" component with the -evop option.
!!
!! Tests carried out 7 May 2006 (will be revision 44)
program bidirectional_mass_thresholds
  use hoppet; use io_utils
  implicit none
  type(grid_def) :: grid
  type(dglap_holder) :: dh
  real(dp), pointer  :: pdf_init(:,:), pdf_final(:,:)
  real(dp)           :: Q_init, Q_mid, asQ
  type(running_coupling) :: coupling
  type(evln_operator)    :: evop_up, evop_down
  integer, parameter     :: nloop = 3
  integer  :: iy
  logical  :: use_evop
  real(dp) :: y

  Q_init = 1.4_dp
  Q_mid  = 1.5_dp
  asQ    = dble_val_opt('-as')
  use_evop = log_val_opt('-evop')

  call InitGridDef(grid,ymax=10.0_dp, dy=0.1_dp,order=-5)
  call InitDglapHolder(grid,dh,nloop=nloop,nflo=3,nfhi=4)
  
  call AllocPDF(grid, pdf_init)
  call AllocPDF(grid, pdf_final)
  pdf_init = unpolarized_dummy_pdf(xValues(grid))

  call InitRunningCoupling(coupling, asQ, Q_init, nloop)

  ! go up and down
  if (use_evop) then
     call InitEvlnOperator(dh,evop_up,   coupling, Q_init, Q_mid)
     call InitEvlnOperator(dh,evop_down, coupling, Q_mid, Q_init)
     pdf_final = evop_down * (evop_up * pdf_init)
     call Delete(evop_up)
     call Delete(evop_down)
  else
     pdf_final = pdf_init
     call EvolvePDF(dh, pdf_final, coupling, Q_init, Q_mid)
     call EvolvePDF(dh, pdf_final, coupling, Q_mid, Q_init)
  end if
  
  ! and see what's left
  do iy = 1, 100
     y = iy*0.1_dp
     write(6,'(f10.5,6es25.15)') y, &
          &        pdf_init (:,(/0,3,4/)).aty.(y.with.grid),&
          &        pdf_final(:,(/0,3,4/)).aty.(y.with.grid)
  end do
     
  ! cleanup
  !call Delete(grid)
  call Delete(dh)
  call Delete(coupling)
  call Delete(pdf_init)
  call Delete(pdf_final)

contains
  !======================================================================
  !! The dummy PDF suggested by Vogt as the initial condition for the 
  !! unpolazrized evolution
  function unpolarized_dummy_pdf(xvals) result(pdf)
    real(dp), intent(in) :: xvals(:)
    real(dp)             :: pdf(size(xvals),ncompmin:ncompmax)
    real(dp) :: uv(size(xvals)), dv(size(xvals))
    real(dp) :: ubar(size(xvals)), dbar(size(xvals))
    !---------------------
    real(dp), parameter :: N_g = 1.7_dp, N_ls = 0.387975_dp
    real(dp), parameter :: N_uv=5.107200_dp, N_dv = 3.064320_dp
    real(dp), parameter :: N_db = half*N_ls
  
    pdf = zero
    ! clean method for labelling as PDF as being in the human representation
    call LabelPdfAsHuman(pdf)

    !-- remember that these are all xvals*q(xvals)
    uv = N_uv * xvals**0.8_dp * (1-xvals)**3
    dv = N_dv * xvals**0.8_dp * (1-xvals)**4
    dbar = N_db * xvals**(-0.1_dp) * (1-xvals)**6
    ubar = dbar * (1-xvals)
    pdf(:,iflv_g) = N_g * xvals**(-0.1_dp) * (1-xvals)**5
        
    pdf(:,-iflv_s) = 0.2_dp*(dbar + ubar)
    pdf(:, iflv_s) = pdf(:,-iflv_s)
    pdf(:, iflv_u) = uv + ubar
    pdf(:,-iflv_u) = ubar
    pdf(:, iflv_d) = dv + dbar
    pdf(:,-iflv_d) = dbar
  end function unpolarized_dummy_pdf

end program bidirectional_mass_thresholds

      MODULE XCDIFF3PNEW
      USE XC2NS3P
      CONTAINS

*
* ..File: xcdiff3p.f    F_{i,NS},  i = 2,3,L  (even-N - odd-N)
*
*
* ..Parametrizations of the differences between the even-N and odd-N 
*    based three-loop coefficient functions for the structure functions
*    F_L, F_2 and F_3 in charged-current deep-inelastic scattering.
*    MS(bar) scheme, the expansion parameter is  a_s = alpha_s/(4 pi).
*
* ..Except where the values are very small, the relative accuracy of 
*     these parametrizations, as well as of the convolution results, 
*     is one part in thousand or better.
*
* ..These functions should be used together with the results for the 
*    even-N based F_L, F_2 and the odd-N F_3 respectively presented in 
*              S. Moch, J. Vermaseren and A. Vogt,
*              hep-ph/0411112, hep-ph/0504242 and arXiv:0812.4168
*    For F_2 and F_L the (NC) flavour class fl11 has to be deactivated 
*    there, and for F_3 the fl02 contributions have to be left out.
*
* ..Reference: J. Davies, S. Moch, J. Vermaseren and A. Vogt, 
*              arXiv:1606.08907
*
* ===================================================================== 
*
*
* ..F_2: third-order c_2^{nu+nubar} - c_2^{nu-nubar}
*
       FUNCTION c2q3dfP (Y, DL, NF)
*
       IMPLICIT REAL*8 (A-Z)
       INTEGER IMOD, NF
*
       Y1  = Y1VAL(Y, DL)
       DL1 = DL1VAL(Y, DL)
*
       C2Q30 =   273.59D0 - 44.95D0* Y - 73.56D0* Y**2 + 40.68D0* Y**3 +
     $      0.1356D0* DL**5 + 8.483D0* DL**4 + 55.90D0* DL**3 + 120.67D0
     $      * DL**2 + 388.0D0* DL - 329.8D0* DL*DL1 - Y*DL* (316.2D0 +
     $      71.63D0* DL) + 46.30D0*DL1 + 5.447D0* DL1**2
*
       C2Q31 = - 19.093D0 + 12.97D0* Y + 36.44D0* Y**2 - 29.256D0* Y**3
     $      - 0.76D0* DL**4 - 5.317D0* DL**3 - 19.82D0* DL**2 - 38.958D0
     $      * DL - 13.395D0* DL*DL1 + Y*DL* (14.44D0 + 17.74D0*DL) +
     $      1.395D0* DL1
*
       c2q3dfP = (C2Q30 + NF * C2Q31)* Y1
*
       RETURN
       END
*
* ..The `local' piece for F2, artificial but useful for maximal accuracy 
*    of moments and convolutions
*
       FUNCTION c2q3dfPC (Y, NF)
*
       IMPLICIT REAL*8 (A-Z)
       INTEGER NF
*
       c2q3dfPC = - 0.0008D0 + 0.0001D0* NF  
*
       RETURN
       END
*
* ---------------------------------------------------------------------
*
* ..F_L: third-order c_L^{nu+nubar} - c_L^{nu-nubar}
*
       FUNCTION cLq3dfP (Y, DL, NF)
*
       IMPLICIT REAL*8 (A-Z)
       INTEGER NF
*
       Y1  = Y1VAL(Y, DL)
       DL1 = DL1VAL(Y, DL)
*
       CLQ30 = - 620.53D0 - 394.5D0* Y + 1609.D0* Y**2 - 596.2D0* Y**3 +
     $      0.217D0* DL**3 + 62.18D0* DL**2 + 208.47D0* DL - 482.5D0* DL
     $      *DL1 - Y*DL* (1751.D0 - 197.5D0* DL) + 105.5D0* DL1 +
     $      0.442D0* DL1**2
*
       CLQ31 = - 6.500D0 - 12.435D0* Y + 23.66D0* Y**2 + 0.914D0* Y**3 +
     $      0.015D0* DL**3 - 6.627D0* DL**2 - 31.91D0* DL - Y*DL*
     $      (5.711D0 + 28.635D0* DL)
*
       cLq3dfP = (CLQ30 + NF * CLQ31) * Y1**2
*
       RETURN
       END
*
* ---------------------------------------------------------------------
*
* ..F_3: third-order c_3^{nu-nubar} - c_3^{nu+nubar}    Note the sign!
*
       FUNCTION c3q3dfP (Y, DL, NF)
*
       IMPLICIT REAL*8 (A-Z)
       INTEGER NF
*
       Y1  = Y1VAL(Y, DL)
       DL1 = DL1VAL(Y, DL)
*
       C3Q30 = - 553.5D0 + 1412.5D0* Y - 990.3D0* Y**2 + 361.1D0* Y**3 +
     $      0.1458D0* DL**5 + 9.688D0* DL**4 + 90.62D0* DL**3 + 83.684D0
     $      * DL**2 - 602.32D0* DL - 382.5D0* DL*DL1 - Y*DL* (2.805D0 +
     $      325.92D0* DL) + 133.5D0* DL1 + 10.135D0* DL1**2 
*
       C3Q31 = - 16.777D0 + 77.78D0* Y - 24.81D0* Y**2 - 28.89D0* Y**3 -
     $      0.7714D0* DL**4 - 7.701D0* DL**3 - 21.522D0* DL**2 - 7.897D0
     $      * DL - 16.17D0* DL*DL1 + Y*DL* (43.21D0 + 67.04D0*DL) +
     $      1.519D0* DL1
*
       c3q3dfP = (C3Q30 + NF * C3Q31)* Y1
*
       RETURN
       END
*
* ..The `local' piece for F3 - present for the same reason as for F2
*
       FUNCTION c3q3dfPC (Y, NF)
*
       IMPLICIT REAL*8 (A-Z)
       INTEGER NF
*
       c3q3dfPC = - 0.0029D0 + 0.00006D0* NF
*
       RETURN
       END
*
* =================================================================av==
       END MODULE XCDIFF3PNEW

!======================================================================
!! Module containing the definition of the dglap_holder type, together
!! with various related subroutines.
!!
!! The dglap_holder type is intended to contain all splitting
!! functions and coefficient functions related to PDF evolution and
!! F2/FL convolutions. As of (5/5/2006 -- actually for a long time
!! now), the coefficient function part is not fully implemented,
!! whereas all the splitting functions are.
!!
module dglap_holders
  use types; use consts_dp
  use dglap_objects
  use pdf_representation
  use assertions; use warnings_and_errors
  implicit none
  private

  !-- 
  !! Everything needed to calculate a cross section, given structure
  !! functions and alpha_s.
  !!
  ! nomenclature is: objects are leading order, unless there is a suffix n, 
  ! in which case they are NLO.
  type dglap_holder
     type(grid_def) :: grid
     !*********** for interpolated splitting functions ****************
     !* type(split_mat), pointer :: interpP(:, :)  ![alphas,nf]
     !* real(dp),        pointer :: alphas_values(:,:) ![alphas,nf]
     !* type(split_max), pointer :: currentP => null()
     !* logical                  :: using_interp
     !*********** for interpolated splitting functions ****************

     !-----------------------  nloop, nf  --------------
     type(split_mat), pointer :: allP(:,   :)  
     
     type(split_mat), pointer :: P_LO, P_NLO, P_NNLO, P_N3LO ! pointers to allP(:,nf)
     type(coeff_mat), pointer :: allC(:,:)
     type(coeff_mat), pointer :: C2, C2_1, CL_1

     !----------------------------------  nloop,nf
     type(mass_threshold_mat), pointer :: allMTM(:,:) => null()
     type(mass_threshold_mat), pointer :: MTM2 ! legacy, deprecated, pointer to MTM(3,nf)
     type(mass_threshold_mat), pointer :: MTM_NNLO, MTM_N3LO ! will be pointers to MTM(3,nf) and MTM(4,nf)
     logical    :: MTM2_exists=.false.
     integer    :: factscheme, nloop
     !--------------------------------  nf  ------------
     !type(pdf_rep), pointer :: all_prep(:)
     !type(pdf_rep), pointer :: prep
     integer                :: nf
  !contains
  !   procedure :: SetNf => SetNfDglapHolder
  end type dglap_holder
  
  !-- this is potentially makeshift?
  integer, parameter :: nC = 3

  public :: dglap_holder, InitDglapHolder, SetNfDglapHolder

  interface Delete
     module procedure holder_Delete
  end interface
  public :: Delete

contains

  !*********** for interpolated splitting functions ****************
  !!!! MEMBER FUNCTIONS !!!!!
  !!! InitDglapHolder_from_table(...)
  !!!
  !!! SetCurrentP(alphas [,nf])  -> sets currentP
  !!!
  !*********** for interpolated splitting functions ****************
  
  !-------------------------------------------------------
  ! Sets up eveything needed to calculate cross sections
  ! i.e. splitting functions and coefficient functions
  subroutine InitDglapHolder(grid, dh, factscheme, nloop, nflo, nfhi)
    use coefficient_functions; use convolution
    use qcd; use dglap_choices
    type(grid_def),     intent(in)    :: grid
    type(dglap_holder), intent(inout), target :: dh
    integer, optional,  intent(in)    :: factscheme
    integer, optional,  intent(in)    :: nloop
    integer, optional,  intent(in)    :: nflo, nfhi
    !-- holds temporary results
    type(grid_conv) :: dconv
    !-- holds all possible combinations of coefficient and splitting functions
    !   needed for DIS schemes
    type(grid_conv) :: Cq,Cg
    type(grid_conv) :: CqPqq, CqPqg, CqPgq, CqPgg
    type(grid_conv) :: CgPqq, CgPqg, CgPgq, CgPgg
    !-- more compactly written version of DIS scheme
    type(grid_conv) :: CC(iflv_g:iflv_sigma,iflv_g:iflv_sigma)
    type(grid_conv) :: tmp2d(iflv_g:iflv_sigma,iflv_g:iflv_sigma)
    logical :: newDIS = .true.
    !logical :: newDIS = .false.
    integer :: nfstore, nflcl
    integer, save :: nfragwarn = 5
    logical :: need_MTM

    dh%factscheme = default_or_opt(factscheme_default, factscheme)
    dh%nloop     = default_or_opt(2, nloop)
    if (dh%nloop > 4 .or. dh%nloop < 1) then
       call wae_error('InitDglapHolder: nloop must be between 1 and 4')
    end if
    dh%grid = grid


    if (present(nflo) .and. present(nfhi)) then
       allocate(dh%allP(dh%nloop,nflo:nfhi))
       !allocate(dh%all_prep(nflo:nfhi))
       allocate(dh%allC(nC,nflo:nfhi))
    else
       !-- otherwise, use whatever nf is currently set
       allocate(dh%allP(dh%nloop,nf_int:nf_int))
       !allocate(dh%all_prep(nf_int:nf_int))
       allocate(dh%allC(nC,nf_int:nf_int))
    end if

    ! mass steps not always supported. Work out if they are
    need_MTM = dh%nloop >= 3 .and. dh%factscheme == factscheme_MSbar .and. mass_steps_on &
            &.and. lbound(dh%allP,dim=2) /= ubound(dh%allP,dim=2)
    if (need_MTM) allocate(dh%allMTM(3:nloop,nflo:nfhi))

    !-- want to reset it at end
    nfstore = nf_int
    
    do nflcl = lbound(dh%allP,dim=2), ubound(dh%allP,dim=2)
       !-- this sets up all the pointers to make it look like a fixed-nf
       !   dh!
       call SetNfDglapHolder(dh, nflcl)

       !----- this is the remainder, essentially unchanged ----
       select case (dh%factscheme)
       case (factscheme_MSbar)
          call InitSplitMatLO (grid, dh%P_LO)
          if (dh%nloop >= 2) call InitSplitMatNLO(grid, dh%P_NLO, dh%factscheme)
          if (dh%nloop >= 3) then
             call InitSplitMatNNLO(grid, dh%P_NNLO, dh%factscheme)
             if (need_MTM) then
               if (nflcl == lbound(dh%allP,dim=2)+1) then
                  call InitMTMNNLO(grid,dh%MTM_NNLO)
               else if (nflcl > lbound(dh%allP,dim=2) + 1) then
                  ! try to be efficient by recycling MTMs from lower nf
                  ! since all that changes is nf_int variable inside MTM_NNLO
                  call InitMTM(dh%MTM_NNLO, dh%allMTM(3, lbound(dh%allP,dim=2) + 1))
                  call SetNfMTM(dh%MTM_NNLO, nflcl)
               end if
             end if
          end if
          if (dh%nloop >= 4) then
             call InitSplitMatN3LO(grid, dh%P_N3LO, dh%factscheme)
             ! we do not need this for the lower nf, because it takes
             ! us from nf-1->nf
             if (nflcl /= lbound(dh%allP,dim=2)) call InitMTMN3LO(grid,dh%MTM_N3LO)
             !-- do this once, and only if really needed
!             if (lbound(dh%allP,dim=2) /= ubound(dh%allP,dim=2) &
!                  &.and. mass_steps_on &
!                  &.and. nflcl == lbound(dh%allP,dim=2)) then
!                dh%MTM2_exists = .true.
!             end if
          end if

          call cobj_InitCoeff(grid, dh%C2)
          call cobj_InitCoeff(grid, dh%C2_1, cf_CgF2MSbar, cf_CqF2MSbar)
          call cobj_InitCoeff(grid, dh%CL_1,  cf_CgFL, cf_CqFL)
       case (factscheme_DIS)
          call InitSplitMatLO (grid, dh%P_LO)
          if (dh%nloop >= 2) &
               &call InitSplitMatNLO(grid, dh%P_NLO, factscheme_MSbar)
          if (dh%nloop >= 3) write(0,*) &
               &'DIS factorisation scheme not supported for 3 loops or more'
          call cobj_InitCoeff(grid, dh%C2)
          call cobj_InitCoeff(dh%C2_1, dh%C2, zero)
          call cobj_InitCoeff(grid, dh%CL_1,  cf_CgFL, cf_CqFL)
          
          !-- now convert MSbar splitting functions into DIS scheme -------
          ! See CCN21-6 (and also CCN17-61)
          
          if (newDIS) then
             !
             ! NB THIS VERSION OF THE DIS SCHEME IS NOT YET IN AGREEMENT
             !    WITH THE OLDER VERSION...
             !    ACTUALLY: THIS IS PROBABLY NO LONGER TRUE?
             !-- create the matrix C for use in 
             !   P_matrix -> P_matrix + [C,P]
             !           /  Cq   Cg \
             !     C ==  |          |   where Cg includes 2nf factor
             !           \ -Cq  -Cg /
             call InitGridConv(grid,CC(iflv_sigma,iflv_sigma),cf_CqF2MSbar)
             call InitGridConv(grid,CC(iflv_sigma,iflv_g),    cf_CgF2MSbar)
             call Multiply(CC(iflv_sigma,iflv_g), two*nf)
             call InitGridConv(CC(iflv_g,:),CC(iflv_sigma,:),-one)
             !-- now get a temporary to hold the commutator
             call AllocGridConv(grid,tmp2d)
             !-- work out the commutator: tmp2d=[C,P]
             !write(0,*) 'lb',lbound(dh%P_LO%singlet), ubound(dh%P_LO%singlet)
             !write(0,*) 'dh%P_LO%singlet(0,0)%nsub',dh%P_LO%singlet(0,0)%grid%nsub
             !write(0,*) 'dh%P_LO%singlet(0,1)%nsub',dh%P_LO%singlet(0,1)%grid%nsub
             !-----------------------------------------------
             ! putting the explicit singlet bounds somehow eliminates
             ! an ifc memory error, which was associated with 
             ! gcb in SetToCommutator obtaining ubound=(/220,1/)
             ! No understanding of origin of error and locally
             ! singlet has right bounds
             !
             ! result however seems to be wrong.
             !
             ! Message: be wary of intel here
             !call SetToCommutator(tmp2d,CC,dh%P_LO%singlet(iflv_g:iflv_sigma,iflv_g:iflv_sigma))
             call SetToCommutator(tmp2d,CC,dh%P_LO%singlet)
             !-- add it to P1
             call AddWithCoeff(dh%P_NLO%singlet,tmp2d)
             !-- add the beta function pieces as well
             call AddWithCoeff(dh%P_NLO%singlet,CC, -twopi_beta0)
             call AddWithCoeff(dh%P_NLO%NS_plus, CC(iflv_sigma,iflv_sigma),&
                  & -twopi_beta0)
             !-- quark number conservation remains OK because
             !   Cq has the om=0 moment equal to zero.
             call AddWithCoeff(dh%P_NLO%NS_minus, CC(iflv_sigma,iflv_sigma), &
                  &-twopi_beta0)
             call AddWithCoeff(dh%P_NLO%NS_V, CC(iflv_sigma,iflv_sigma), &
                  &-twopi_beta0)
             
             !-- clean up
             call Delete(CC)
             call Delete(tmp2d)
          else
             call InitGridConv(grid, Cq, cf_CqF2MSbar)
             call InitGridConv(grid, Cg, cf_CgF2MSbar)
             call Multiply(Cg, two*nf)
             !   where possible put the smoother distribution to the right
             !   (only makes a difference when pdfs are non zero at x=1?)
             call conv_ConvConv(CqPqq, Cq, dh%P_LO%qq)
             call conv_ConvConv(CqPqg, Cq, dh%P_LO%qg)
             call conv_ConvConv(CqPgq, Cq, dh%P_LO%gq)
             call conv_ConvConv(CqPgg, Cq, dh%P_LO%gg)
             call conv_ConvConv(CgPqq, dh%P_LO%qq, Cg)
             call conv_ConvConv(CgPqg, dh%P_LO%qg, Cg)
             call conv_ConvConv(CgPgq, dh%P_LO%gq, Cg)
             call conv_ConvConv(CgPgg, dh%P_LO%gg, Cg)
             
             !
             !   First deal with P_matrix -> P_matrix + [C,P]
             !           /  Cq   Cg \
             !     C ==  |          |   where Cg includes 2nf factor
             !           \ -Cq  -Cg /
             !
             !   Pqq -> Pqq + (Cg Pgq + Cq Pqg)
             call AddWithCoeff(dh%P_NLO%qq, CgPgq, one)
             call AddWithCoeff(dh%P_NLO%qq, CqPqg, one)
             !   Pqg -> Pqg + (Cq Pqg + Cg Pgg - Cg Pqq + Cg Pqg)
             call AddWithCoeff(dh%P_NLO%qg, CqPqg, one)
             call AddWithCoeff(dh%P_NLO%qg, CgPgg, one)
             call AddWithCoeff(dh%P_NLO%qg, CgPqq,-one)
             call AddWithCoeff(dh%P_NLO%qg, CgPqg, one)
             !   Pgq -> Pqg + (-Cq Pqq - Cg Pgq - Cq Pgq + Cq Pgg)
             call AddWithCoeff(dh%P_NLO%gq, CqPqq,-one)
             call AddWithCoeff(dh%P_NLO%gq, CgPgq,-one)
             call AddWithCoeff(dh%P_NLO%gq, CqPgq,-one)
             call AddWithCoeff(dh%P_NLO%gq, CqPgg, one)
             !   Pgg -> Pgg + (-Cq Pqg - Cg Pgq)
             call AddWithCoeff(dh%P_NLO%gg, CqPqg,-one)
             call AddWithCoeff(dh%P_NLO%gg, CgPgq,-one)
             !
             !   Now deal with P_matrix -> P_matrix - beta0 * C
             !                 P_+      -> P_+      - beta0 * C_q
             call AddWithCoeff(dh%P_NLO%qq, Cq, -twopi_beta0)
             call AddWithCoeff(dh%P_NLO%qg, Cg, -twopi_beta0)
             call AddWithCoeff(dh%P_NLO%gq, Cq, +twopi_beta0)
             call AddWithCoeff(dh%P_NLO%gg, Cg, +twopi_beta0)
             call AddWithCoeff(dh%P_NLO%NS_plus, Cq, -twopi_beta0)
             !-- quark number conservation remains OK because
             !   Cq has the om=0 moment equal to zero.
             call AddWithCoeff(dh%P_NLO%NS_minus, Cq, -twopi_beta0)
             call AddWithCoeff(dh%P_NLO%NS_V, Cq, -twopi_beta0)
             !
             !   tidy up
             !write(0,*) 'Hey:',dh%P_LO%singlet(0,0)%subgc(1)%conv(0:3,1)
             !write(0,*) 'Hey:',dh%P_LO%singlet(0,1)%subgc(1)%conv(0:3,1)
             !write(0,*) 'Hey:',dh%P_LO%singlet(1,0)%subgc(1)%conv(0:3,1)
             !write(0,*) 'Hey:',dh%P_LO%singlet(1,1)%subgc(1)%conv(0:3,1)
             !write(0,*) 'Hey:',               Cq%subgc(1)%conv(0:3,1)
             !write(0,*) 'Hey:',               Cg%subgc(1)%conv(0:3,1)
             
             call Delete(Cq)
             call Delete(Cg)
             call Delete(CqPqq)
             call Delete(CqPqg)
             call Delete(CqPgq)
             call Delete(CqPgg)
             call Delete(CgPqq)
             call Delete(CgPqg)
             call Delete(CgPgq)
             call Delete(CgPgg)
             write(0,*) 'result:',dh%P_NLO%singlet(iflv_sigma,iflv_sigma)%conv(10,1)
          end if
          
       case (factscheme_PolMSbar)
          write(0,*) "SETTING UP POLARIZED EVOLUTION"
          call InitSplitMatPolLO (grid, dh%P_LO)
          if (dh%nloop >= 2) call InitSplitMatPolNLO(grid, &
               &dh%P_NLO, dh%factscheme)
          if (dh%nloop >= 3) call wae_error('InitDglapHolder',&
               &'nloop >= 3 not supported for polarized case')

       case (factscheme_FragMSbar)
          if (dh%nloop >= 3) call wae_error('InitDglapHolder',&
               &'nloop >= 3 not supported for fragmentation case')

          ! recall that equations for timelike evolution (fragmentation
          ! functions) are different from those for the spacelike case,
          ! as given for example in Owens, Phys.Lett 76B (1978) 80 and
          ! so read
          !
          ! d/dlnQ^2 Dq = as/2pi * (      Pqq Dq + Pgq Dg)
          ! d/dlnQ^2 Dg = as/2pi * (sum_q Pqg Dq + Pgg Dg)
          !
          ! those the actual Pij are identical to before; so we've transposed
          ! the matrix and for the singlet formulation also reshuffled
          ! some 2nf factors
          !
          ! start off with default space-like matrix
          call InitSplitMatLO (grid, dh%P_LO)
          ! get 2nf factors correct
          call Multiply(dh%P_LO%qg, one / (2*nflcl))
          call Multiply(dh%P_LO%gq, one * 2*nflcl)
          ! exchange qg and gq entries
          dconv = dh%P_LO%qg       ! tmp
          dh%P_LO%qg = dh%P_LO%gq
          dh%P_LO%gq = dconv

          if (dh%nloop >= 2) then
             call InitSplitMatTimeNLO (grid, dh%P_NLO)
             call wae_warn(nfragwarn, &
                  & 'DANGER: nloop=2 fragmentation flavour thresholds not implemented')
          end if
          
       case default
          write(0,*) 'factorisation scheme ',dh%factscheme,&
               &' is not currently supported' 
          stop
       end select
       
       !-- used for converting to and from the evolution representation
       !dh%prep = DefaultEvlnRep(nf_int)
!!$       dh%prep%nf    = nf_int
!!$       !dh%prep%ibase = nf_int
!!$       dh%prep%ibase = 1
    end do

    

    !-- be "clean", put nf back to where it was ----------
    if (nfstore <= ubound(dh%allP,2) .and. nfstore >= lbound(dh%allP,2)) then
       ! set it in the dglap holder as well if valid
       call SetNfDglapHolder(dh,nfstore)
    else
       ! set it just in the global qcd module, because it is not
       ! valid here...
       call qcd_SetNf(nfstore)
    end if
    
  end subroutine InitDglapHolder


  !--------------------------------------------------------------
  ! set up all pointers so that it looks like an old holder in the
  ! good-old fixed-nf days; it also sets the global nf.
  ! (NB: perhaps that is not too good?)
  !
  ! If quark_masses_are_MSbar is present, the the quark mass 
  ! scheme is also set for the mass-threshold-matrix
  subroutine SetNfDglapHolder(dh, nflcl, quark_masses_are_MSbar)
    use qcd
    !class(dglap_holder), intent(inout) :: dh
    type(dglap_holder), intent(inout) :: dh
    integer, intent(in) :: nflcl
    logical, optional, intent(in) :: quark_masses_are_MSbar

    if (nflcl < lbound(dh%allP,dim=2) .or. nflcl > ubound(dh%allP,dim=2)) then
      call wae_Error('SetNfDglapHolder: tried to set unsupported nf; requested nf was',intval=nflcl)
    end if 
    
    !-- want general nf to be consistent. Not really all that nice a 
    !   way of doing things, but cannot think of a better solution 
    !   given the current structure...
    call qcd_SetNf(nflcl)

    !-- set up links so that the remainder of the routine
    !   can stay unchanged
    dh%P_LO  => dh%allP(1,nflcl)
    if (dh%nloop >= 2) then
       dh%P_NLO => dh%allP(2,nflcl)
    else
       nullify(dh%P_NLO)
    end if
    
    if (dh%nloop >= 3) then
       dh%P_NNLO => dh%allP(3,nflcl)
       if (associated(dh%allMTM) .and. nflcl >= lbound(dh%allMTM,2)) then
         dh%MTM_NNLO => dh%allMTM(3,nflcl)
         dh%MTM2     => dh%allMTM(3,nflcl)
         if (present(quark_masses_are_MSbar)) call SetMassSchemeMTM(dh%MTM_NNLO, quark_masses_are_MSbar)
         dh%MTM2_exists = .true.
       else
         nullify(dh%MTM_NNLO)
         nullify(dh%MTM2    )
         dh%MTM2_exists = .false.
       end if
    else
      nullify(dh%P_NNLO)
      nullify(dh%MTM_NNLO)
      nullify(dh%MTM2)
      dh%MTM2_exists = .false.
   end if
    
    if (dh%nloop >= 4) then
       dh%P_N3LO => dh%allP(4,nflcl)
       if (associated(dh%allMTM) .and. nflcl >= lbound(dh%allMTM,2)) then
         dh%MTM_N3LO => dh%allMTM(4,nflcl)
         if (present(quark_masses_are_MSbar)) call SetMassSchemeMTM(dh%MTM_N3LO, quark_masses_are_MSbar)
       else
         nullify(dh%MTM_N3LO)
       end if
    else
       nullify(dh%P_N3LO)
       nullify(dh%MTM_N3LO)
    end if
    
    dh%C2 => dh%allC(1,nflcl)
    dh%C2_1 => dh%allC(2,nflcl)
    dh%CL_1 => dh%allC(3,nflcl)
    !dh%prep => dh%all_prep(nflcl)
    dh%nf = nflcl
  end subroutine SetNfDglapHolder

  !======================================================================
  !! Attempt to free up all memory associated with this holder
  subroutine holder_Delete(dh)
    type(dglap_holder), intent(inout) :: dh
    !--------------------------------------
    integer :: nflcl, iloop, i

    do nflcl = lbound(dh%allP,2), ubound(dh%allP,2)
       do i = 1, size(dh%allC(:,nflcl))
          call Delete(dh%allC(i,nflcl))
       end do
       do iloop = 1, dh%nloop
          call Delete(dh%allP(iloop,nflcl))
       end do
    end do
    
    if (associated(dh%allMTM)) then
      do nflcl = lbound(dh%allMTM,2), ubound(dh%allMTM,2)
         do iloop = lbound(dh%allMTM,1), ubound(dh%allMTM,1)
            call Delete(dh%allMTM(iloop,nflcl))
         end do
      end do
      deallocate(dh%allMTM)
    end if 

    deallocate(dh%allP)
    deallocate(dh%allC)
    !deallocate(dh%all_prep)
  end subroutine holder_Delete
  
  
end module dglap_holders

!  $Id: xa2hgp.f90,v 1.1 2002/03/06 17:12:12 gsalam Exp $ 
!  Automatically generated from f77 file, with addition of "d0"
!  From avogt@nikhef.nl Thu Feb  7 15:34:35 2002                        
!  Date: Wed, 6 Feb 2002 18:23:05 +0100 (MET)                           
!  From: Andreas Vogt <avogt@nikhef.nl>                                 
!  To: G. Salam <Gavin.Salam@cern.ch>                                   
!  Cc: A. Vogt <avogt@nikhef.nl>                                        
!  Subject: the subroutine                                              
!                                                                       
!                                                                       
! ..File: xa2hgp.f                                                      
!                                                                       
!                                                                       
! ..Calculation of the alpha_s^2 heavy-quark singlet operator matrix    
!    element (OME) a^2_Hg(x) in the MS(bar) scheme for mu_f = m_H via   
!    a compact parametrization involving only logarithms.               
!    The coupling constant is normalized as  a_s = alpha_s/(4*pi).      
!                                                                       
! ..This quantity, presented in Appendix B of M. Buza, Y. Matiounine,   
!    J. Smith and W.L. van Neerven, Eur. Phys. J. C1 (1998) 301 (BSMN), 
!    is required for the N_f matching of the NNLO parton densities.     
!                                                                       
!  ..The distributions (in the mathematical sense) are given as in eq.  
!    (B.26) of Floratos, Kounnas, Lacaze: Nucl. Phys. B192 (1981) 417.  
!    The name-endings A, B, and C of the functions below correspond to  
!    the kernel superscripts [2], [3], and [1] in that equation.        
!                                                                       
!  ..The relative accuracy of the OME, as well as of its convolutions   
!    with gluon distributions, amounts to a few thousandth.             
!                                                                       
!  ..Reference: not yet known                                           
!               hep-ph/yymmnnn                                          
!  ..The user should also cite the original calculation by BSMN.        
!                                                                       
!                                                                       
! ===================================================================== 
!                                                                       
!                                                                       
! ..This is the regular piece.                                          
!                                                                       
       FUNCTION A2HGA (Y) 
       IMPLICIT REAL*8 (A-Z) 
!                                                                       
       DL  = LOG (Y) 
       DL1 = LOG (1.-Y) 
!                                                                       
       A2HGA = - 24.89d0 / Y - 187.8d0 + 249.6d0 * Y - 146.8d0 * DL**2 * DL1    &
     &         - 1.556d0 * DL**3  - 3.292d0 * DL**2  - 93.68d0 * DL           &
     &         - 1.111d0 * DL1**3 - 0.400d0 * DL1**2 - 2.770d0 * DL1          
!                                                                       
       RETURN 
      END                                           
!                                                                       
! --------------------------------------------------------------------- 
!                                                                       
!                                                                       
! ..This is the 'local' piece, which has no counterpart in W. van       
!    Neerven's program, as it does not exist in the exact expressions.  
!                                                                       
       FUNCTION A2HGC (Y) 
       IMPLICIT REAL*8 (A-Z) 
!                                                                       
       A2HGC = - 0.006d0 
!                                                                       
       RETURN 
      END                                           

program coupling
  use types; use consts_dp
  use qcd_coupling
  implicit none

  real(dp), parameter :: mc_pole = 1.67_dp
  real(dp), parameter :: mb_pole = 4.78_dp
  real(dp), parameter :: mt_pole = 173.21_dp

  real(dp), parameter :: mc_msbar = 1.275_dp
  real(dp), parameter :: mb_msbar = 4.18_dp

  type(running_coupling) :: this_coupling

  real(dp), parameter :: mz = 91.1876_dp
  real(dp) :: alphas_mz = 0.118_dp
  real(dp) :: mu_vals(6) = (/ 0.1_dp, 1.1_dp, 2.0_dp, 6.0_dp, mz, 1000.0_dp /)
  real(dp) :: mu
 
  integer  :: i_mu

  call InitRunningCoupling(this_coupling, alphas_mz, Q=mz, nloop = 0, &
       &                   quark_masses = (/mc_pole, mb_pole, mt_pole /),&
       &                   masses_are_MSbar = .false.)

  do i_mu = 1, size(mu_vals)
     mu = mu_vals(i_mu)
     write(6,*) mu, Value(this_coupling, mu)
  end do

  write(6,*)
  call delete(this_coupling)
  call InitRunningCoupling(this_coupling, alphas_mz, Q=mz, nloop = 0, &
       &                   quark_masses = (/mc_msbar, mb_msbar, 161.0_dp /),&
       &                   masses_are_MSbar = .true.)
  do i_mu = 1, size(mu_vals)
     mu = mu_vals(i_mu)
     write(6,*) mu, Value(this_coupling, mu)
  end do
  
  
end program coupling

!
! run this with
!
! ./test_qed_evol_lhapdf -Qlo 3.0 -Qhi 100  -pdf CT14qed_proton -nqcdloop-qed 0  -x 1e-3 >! a
!
!
!! TESTS
!! * Test against plain qcd evolution, with QED alpha turned to zero
!!   -> works OK, but watch out for the fact that the tau introduces
!!      an extra threshold, so that numerically there are differences
!!      at the evolution precision; reducing du by a factor of 10
!!      significantly reduces these differences. See basic test output with
!!   ./test_qed_evol_lhapdf -no-qed -x 0.5 | grep moment
!!   ./test_qed_evol_lhapdf -alpha-qed 0 -x 0.5 | grep moment
!!
!! * test momentum sum rule, with both nqcdloop_qed values
!!   -> this seems to work fine, e.g. test with
!!      ./test_qed_evol_lhapdf -ymax 25 -nqcdloop-qed 0 |& grep moment
!!      ./test_qed_evol_lhapdf -ymax 25 -nqcdloop-qed 1 |& grep moment
!!
!! * compare to photon evolution from another source?
!!   -> done in with-lhapdf/test_qed_evol_lhapdf.f90
!!      generally, answers are to within O(1%) of the MRST2004qed and
!!      CT14qed_proton results for evolution from 3 to 100 GeV. E.g.
!!    ./test_qed_evol_lhapdf -Qlo 3.0 -Qhi 100  -pdf CT14qed_proton -nqcdloop-qed 0  -x 1e-3 >! a
!!
program test_qed_evol
   use hoppet
  use qed_evolution; use qed_objects; use qed_coupling_module
  use io_utils
  implicit none
  character(len=200) :: pdfname
  type(grid_def)      :: grid
  type(qed_split_mat) :: qed_split
  type(dglap_holder)  :: dh
  real(dp)               :: quark_masses(4:6)
  type(running_coupling) :: coupling
  type(qed_coupling)     :: coupling_qed
  real(dp)               :: ymax, dy, x, alphas_mz, lha_qmin, scale_qg
  real(dp), parameter    :: mz = 91.1876_dp
  real(dp), pointer :: pdf_in(:,:), pdf_out(:,:), pdf_lhapdf_out(:,:)
  real(dp), pointer :: photon_lumi(:,:)
  real(dp)         :: Qlo, Qhi, moments(ncompmin:ncompmaxLeptons)
  real(dp) :: alphaspdf ! from LHAPDF
  integer :: compact_output_n = -1
  integer :: nloop_qcd = 3, nqcdloop_qed, imem, iflv, iunit
  logical :: no_qed, use_lhapdf

  if (log_val_opt("-out")) then
     iunit = idev_open_opt("-out")
  else
     iunit = 6
  end if
  compact_output_n = int_val_opt("-compact-output", compact_output_n)
  
  write(iunit,'(a)') "# "//trim(command_line())

  ymax  = dble_val_opt("-ymax",20.0_dp)
  dy    = dble_val_opt("-dy",0.1_dp)
  call InitGridDefDefault(grid, dy, ymax)
  write(iunit,'(a,2f10.6)') "# ymax, dy ", ymax, dy

  ! allow option to just write out the x values of the grid
  ! and exit
  if (log_val_opt("-xvalues")) then
     write(iunit,"(a)") "# next lines contain number of x values, and actual x values"
     write(iunit,*) grid%ny+1
     write(iunit,*) xValues(grid)
     stop
  end if

  Qlo = sqrt(two) ! the initial scale
  Qhi = 40.0_dp
  Qlo = sqrt(dble_val_opt("-Q2lo", Qlo**2))
  Qhi = sqrt(dble_val_opt("-Q2hi", Qhi**2))
  Qlo = dble_val_opt("-Qlo",Qlo)
  Qhi = dble_val_opt("-Qhi",Qhi)
  write(iunit,'(a,es14.6)') "# Qlo = ", Qlo
  write(iunit,'(a,es14.6)') "# Qhi = ", Qhi


  scale_qg = dble_val_opt("-scale-qg",one)
  
  use_lhapdf = log_val_opt("-pdf")
  if (use_lhapdf) then
     pdfname = string_val_opt("-pdf")
     imem    = int_val_opt("-imem",0)
     call InitPDFsetByName(trim(pdfname))
     call InitPDFm(1,imem)
     write(iunit,*) "# using LHAPDF ", trim(pdfname), ' imem = ', imem
     quark_masses(4:6) = (/lhapdf_qmass(4), lhapdf_qmass(5), lhapdf_qmass(6)/)
     alphas_mz = alphaspdf(mz)
     call getorderas(nloop_qcd); nloop_qcd = nloop_qcd + 1 ! LHAPDF convention is that LO=0
     ! the following lines are problematic for some reason
     ! if (Qlo < lhapdf_qmin()) &
    !      &write(0,*) "WARNING: Qlo = ", Qlo, " < lhapdf Qmin = ", lhapdf_qmin() 
  else
     write(iunit,*) "# using toy pdf"
     quark_masses(4:6) = (/1.414213563_dp, 4.5_dp, 175.0_dp/)
     alphas_mz = 0.118_dp
  end if
  write(iunit,*) '# quark masses (c,b,t) = ', quark_masses
  

  nloop_qcd = int_val_opt("-nloop-qcd",nloop_qcd)
  write(iunit,*) "# nloop_qcd = ", nloop_qcd

  nqcdloop_qed = int_val_opt('-nqcdloop-qed',0)
  write(iunit,*) "# nqcdloop_qed = ", nqcdloop_qed
  
  no_qed = log_val_opt("-no-qed",.false.)

  x = dble_val_opt("-x",1e-3_dp)

  
  call SetDefaultEvolutionDu(dy/3.0_dp)  ! generally a good choice
  call InitQEDSplitMat(grid, qed_split)
  call InitDglapHolder(grid,dh,factscheme=factscheme_MSbar,&
       &                      nloop=nloop_qcd,nflo=3,nfhi=6)


  call InitRunningCoupling(coupling,alfas=alphas_mz,Q=mz,nloop=nloop_qcd,&
       &                   quark_masses = quark_masses)
  if (log_val_opt("-alpha-qed")) then
     call InitQEDCoupling(coupling_qed, quark_masses(4), quark_masses(5), quark_masses(6), &
          &               dble_val_opt("-alpha-qed"))
  else
     call InitQEDCoupling(coupling_qed, quark_masses(4), quark_masses(5), quark_masses(6))
  end if

  
  write(iunit,*) "# 1/QED coupling at MZ = ", one/Value(coupling_qed,MZ)
  write(iunit,*) "# QCD coupling at MZ = ", Value(coupling,MZ)
  write(iunit,*) "# Qlo, Qhi ", Qlo, Qhi
  
  call AllocPDFWithLeptons(grid, pdf_in)
  call AllocPDFWithLeptons(grid, pdf_out)
  call AllocPDFWithLeptons(grid, pdf_lhapdf_out)
  call AllocGridQuant(grid, photon_lumi, 1, 1)
  
  if (use_lhapdf) then
     call fill_from_lhapdf(pdf_in, Qlo)
     call fill_from_lhapdf(pdf_lhapdf_out, Qhi)
  else
     pdf_in = zero
     ! fill in the QCD part
     pdf_in(:,:ncompmax) = unpolarized_dummy_pdf(xValues(grid))
     ! then add in a photon of some kind
     pdf_in(:,iflv_photon) = alpha_qed_scale_0 * (one - xValues(grid))**4
  end if
  if (scale_qg /= one) then
     pdf_in(:,:6) = pdf_in(:,:6) * scale_qg
  end if
  
  ! allow user to override the photon from a suitably formatted file
  if (log_val_opt("-read-photon")) pdf_in(:,iflv_photon) = read_photon(grid)

  if (.not.CheckAllArgsUsed(0)) stop
  
  pdf_out = pdf_in
  if (no_qed) then
     call EvolvePDF(dh, pdf_out(:,ncompmin:ncompmax), coupling, Qlo, Qhi, nloop=nloop_qcd)
  else
     call QEDQCDEvolvePDF(dh, qed_split, pdf_out, coupling, coupling_qed,&
          &               Qlo, Qhi, nloop_qcd, nqcdloop_qed)
  end if
     

  call write_moments(pdf_in, ' in')
  call write_moments(pdf_out,'out')
  if (use_lhapdf) call write_moments(pdf_lhapdf_out,'lha')
  call write_pdf(pdf_in,'in')
  call write_pdf(pdf_out,'out')
  if (use_lhapdf) call write_pdf(pdf_lhapdf_out,'lhapdf out')

  photon_lumi(:,1) = PartonLuminosity(grid, pdf_in(:,8),pdf_in(:,8))
  call write_pdf(photon_lumi,'photon-lumi-in')
  photon_lumi(:,1) = PartonLuminosity(grid, pdf_out(:,8),pdf_out(:,8))
  call write_pdf(photon_lumi,'photon-lumi-out')
  if (use_lhapdf)  then
     photon_lumi(:,1) = PartonLuminosity(grid, pdf_lhapdf_out(:,8),pdf_lhapdf_out(:,8))
     call write_pdf(photon_lumi,'photon-lumi-lhapdf-out')
  end if
  
  write(0,*) 'x = ', x, 'Q = ', Qhi
  write(0,'(a5,4a17)') 'iflv','lhapdf','hoppet'
  do iflv = -6, 8
     write(0,'(i5,4f17.7)') iflv, pdf_lhapdf_out(:,iflv).atx.(x.with.grid),&
          &                       pdf_out       (:,iflv).atx.(x.with.grid)
  end do
  
contains

  function lhapdf_qmin() result(qmin)
    real(dp) :: qmin, q2min
    call getq2min(q2min)
    write(0,*) q2min
    qmin = sqrt(q2min)
  end function lhapdf_qmin
  
  
  function lhapdf_qmass(iflv) result(res)
    integer, intent(in) :: iflv
    real(dp)            :: res
    call getqmass(iflv,res)
  end function lhapdf_qmass
  
  
  !----------------------------------------------------------------------
  subroutine fill_from_lhapdf(this_pdf, Q)
    real(dp), intent(out) :: this_pdf(0:,-6:)
    real(dp), intent(in)  :: Q
    !---------
    real(dp) :: xv(0:grid%ny)
    integer  :: i

    xv = xValues(grid)
    this_pdf = zero
    do i = 0, grid%ny
       call EvolvePDFPhoton(xv(i), Q, this_pdf(i,-6:6), this_pdf(i,8))
       !write(iunit,*) xv(i), this_pdf(i,8)
    end do
  end subroutine fill_from_lhapdf

  !----------------------------------------------------------------------
  ! this assumes a 6-column format where column 1 is x and column 6 is
  ! xf_{gamma/p}(x)
  function read_photon(grid) result(photon)
    type(grid_def), intent(in) :: grid
    !---------------------------------
    integer             :: iy, iread
    character(len=1000) :: line
    real(dp)            :: photon(0:grid%ny), xVals(0:grid%ny), numbers(6)
    real(dp), parameter :: tolerance = 1e-7_dp
    
    iread = idev_open_opt("-read-photon",status='OLD')
    xVals = xValues(grid)
    write(0,*) 'reading photon from file',trim(string_val_opt("-read-photon"))
    do iy = 0, grid%ny
       ! skip comment lines
       do while (.true.)
          read(iread,'(a)') line
          if (line(1:1) /= '#') exit
       end do
       ! then get & check the numbers
       read(line,*) numbers
       if (abs(log(numbers(1)/xVals(iy))) > tolerance) then
          write(0,*) 'grid  x value = ', xVals(iy)
          write(0,*) 'input x value = ', numbers(1)
          call wae_error('read_photon', 'x value is inconsistent with grid')
       end if
       photon(iy) = numbers(6)
    end do
    
  end function read_photon
  
  
  !----------------------------------------------------------------------
  subroutine write_moments(pdf,label)
    real(dp),         intent(in) :: pdf(0:,ncompmin:)
    character(len=*), intent(in) :: label
    !-----------------
    real(dp) :: moments(ncompmin:ubound(pdf,dim=2))
    
    write(iunit,"(a)", advance="no"), "# total momentum "//trim(label)//" (& components)"
    moments = TruncatedMoment(grid, pdf, one)
    write(iunit,"(40f10.7)") sum(moments), moments

    write(iunit,"(a)", advance="no"), "# total number "//trim(label)//" (& components)"
    moments(1:6) = TruncatedMoment(grid, pdf(:,1:6)-pdf(:,-1:-6:-1), zero)
    write(iunit,"(40f11.7)") sum(moments(1:6)), moments(1:6)


  end subroutine write_moments
  
  
  !----------------------------------------------------------------------
  subroutine write_pdf(pdf,label)
    real(dp), intent(in) :: pdf(0:,ncompmin:)
    character(len=*), intent(in) :: label
    !----------------------
    real(dp) :: y, yVals(0:grid%ny), last_y
    real(dp) :: zeta, zeta_max, a_stretch=7.0_dp, pdf_val
    integer  :: i,j

    write(iunit,"(a)"), "# pdf "//trim(label)
    !do i = 0, 100
    !   y = 0.1_dp * i
    !   write(iunit,*) y, pdf.aty.(y.with.grid)
    !end do
    if (compact_output_n > 0) then
       ! value of compact_output_n sets number of points being written
       zeta_max = zeta_of_y(grid%ymax, a_stretch)
       do i = 0, compact_output_n
          zeta = (i*zeta_max)/compact_output_n
          y = y_of_zeta(zeta, a_stretch)
          write(iunit,'(f10.6)',advance="no") y
          do j = lbound(pdf,dim=2), ubound(pdf,dim=2)
             pdf_val = pdf(:,j).aty.(y.with.grid)
             if (abs(pdf_val) < 1e-100_dp) then
                write(iunit,'(a)',advance='no') ' 0 '
             else
                write(iunit,'(es14.6)',advance='no') pdf_val
             end if
          end do
          write(iunit,*)
       end do
    else
       last_y = -one
       yVals = yValues(grid)
       do i = 0, grid%ny
          y = yVals(i)
          if (y < 1.000000001_dp * last_y) cycle
          write(iunit,*) y, pdf(i,:)
          last_y = y
       end do
    end if
    
    write(iunit,*)
    write(iunit,*)
    
  end subroutine write_pdf
  
  !======================================================================
  !! The dummy PDF suggested by Vogt as the initial condition for the 
  !! unpolarized evolution (as used in hep-ph/0511119).
  function unpolarized_dummy_pdf(xvals) result(pdf)
    real(dp), intent(in) :: xvals(:)
    real(dp)             :: pdf(size(xvals),ncompmin:ncompmax)
    real(dp) :: uv(size(xvals)), dv(size(xvals))
    real(dp) :: ubar(size(xvals)), dbar(size(xvals))
    !---------------------
    real(dp), parameter :: N_g = 1.7_dp, N_ls = 0.387975_dp
    real(dp), parameter :: N_uv=5.107200_dp, N_dv = 3.064320_dp
    real(dp), parameter :: N_db = half*N_ls
  
    pdf = zero
    ! clean method for labelling as PDF as being in the human representation
    ! (not actually needed after setting pdf=0
    call LabelPdfAsHuman(pdf)

    !-- remember that these are all xvals*q(xvals)
    uv = N_uv * xvals**0.8_dp * (1-xvals)**3
    dv = N_dv * xvals**0.8_dp * (1-xvals)**4
    dbar = N_db * xvals**(-0.1_dp) * (1-xvals)**6
    ubar = dbar * (1-xvals)

    ! labels iflv_g, etc., come from the hoppet module, inherited
    ! from the main program
    pdf(:, iflv_g) = N_g * xvals**(-0.1_dp) * (1-xvals)**5
    pdf(:,-iflv_s) = 0.2_dp*(dbar + ubar)
    pdf(:, iflv_s) = pdf(:,-iflv_s)
    pdf(:, iflv_u) = uv + ubar
    pdf(:,-iflv_u) = ubar
    pdf(:, iflv_d) = dv + dbar
    pdf(:,-iflv_d) = dbar
  end function unpolarized_dummy_pdf

  !-----------------------------------------------------------------
  !! return zeta = ln 1/x + a*(1-x)  (x = exp(-y))
  function zeta_of_y(y, a) result(zeta)
    real(dp), intent(in) :: y, a
    real(dp)             :: zeta
    zeta = y + a*(one - exp(-y))
  end function zeta_of_y

  
  !-----------------------------------------------------------------
  !! return inversion of zeta = ln 1/x + a*(1-x)  (x = exp(-y))
  function y_of_zeta(zeta, a) result(y)
    real(dp), intent(in) :: zeta, a
    real(dp)             :: y, x, diff_from_zero, deriv
    integer             :: iter
    real(dp), parameter :: eps = 1e-12_dp
    integer,  parameter :: maxiter = 100

    ! starting condition (and soln if a = 0)
    y = zeta 
    if (a /= zero) then
       do iter = 0, maxiter
          x = exp(-y);
          diff_from_zero = zeta - y - a*(one-x);
          ! we have found good solution
          if (abs(diff_from_zero) < eps) exit
          deriv = -one  - a*x;
          y = y - diff_from_zero / deriv;
       end do
    end if
    
    if (iter > maxiter) write(0,*) "y_of_zeta reached maxiter"

  end function y_of_zeta

end program test_qed_evol

      MODULE XC2NS2P
      CONTAINS
*     
* ..File: xc2ns2p.f    F2_NS
*
*
* ..Calculation of the 2-loop x-space MS(bar) coefficient functions 
*    for F2 via compact parametrizations involving only logarithms.
*    Non-singlet, mu_r = mu_f = Q. Expansion parameter: alpha_s/(4 pi).
*
*  ..The distributions (in the mathematical sense) are given as in eq.
*    (B.26) of Floratos, Kounnas, Lacaze: Nucl. Phys. B192 (1981) 417.
*    The name-endings A, B, and C of the functions below correspond to 
*    the kernel superscripts [2], [3], and [1] in that equation.
*
*  ..The relative accuracy of the coefficient functions, as well as of 
*    the convolution results, amounts to a few thousandth.
*    
*  ..Reference: W.L. van Neerven and A. Vogt, 
*               hep-ph/9907472 = Nucl. Phys. B568 (2000) 263
*  ..The user should also cite the original calculation, 
*     E.B. Zijlstra and W.L. van Neerven, Phys. Lett. B272 (1991) 127.
*
* 
* =====================================================================
*
*
* ..This is the regular non-singlet piece for the electromagnetic F2, 
*    corresponding to C2NSP+C2NSN in W. van Neerven's program. The 
*    (10+8) numerical coefficients are fitted to his results, using x 
*    values between 10^-6 and 1-10^-6. 
*
       FUNCTION C2NN2A (Y, NF)
       IMPLICIT REAL*8 (A-Z)
       INTEGER NF
*
       DL  = LOG (Y)
       OMY = 1.0D0 - Y
       DL1 = LOG (OMY)
*
       C2NN2A = 
     1          - 69.59D0 - 1008.D0* Y
     2          - 2.835D0 * DL**3 - 17.08D0 * DL**2 + 5.986D0 * DL 
     3          - 17.19D0 * DL1**3 + 71.08D0 * DL1**2 - 660.7D0 * DL1
     4          - 174.8D0 * DL * DL1**2 + 95.09D0 * DL**2 * DL1
     5        + NF * ( - 5.691D0 - 37.91D0 * Y 
     6          + 2.244D0 * DL**2 + 5.770D0 * DL 
     7          - 1.707D0 * DL1**2  + 22.95D0 * DL1
     8          + 3.036D0 * DL**2 * DL1 + 17.97D0 * DL * DL1 )     
*
       RETURN
       END FUNCTION C2NN2A
*
* ---------------------------------------------------------------------
*
*
* ..This is the regular non-singlet piece for the odd-moment (CC) F2, 
*    corresponding to C2NSP-C2NSN in WvN's program. For the NF^0 piece
*    8 numerical coefficients are fitted to his results, the ones of
*    ln^3(1-y) and ln^2(1-y) are taken over from C3NN2A. The NF piece
*    is also the same as in C3NN2A.
*
       FUNCTION C2NC2A (Y, NF)
       IMPLICIT REAL*8 (A-Z)
       INTEGER NF
*
       DL  = LOG (Y)
       OMY = 1.0D0 - Y
       DL1 = LOG (OMY)
*
       C2NC2A = 
     1          - 84.18D0 - 1010.D0* Y
     2          - 3.748D0 * DL**3 - 19.56D0 * DL**2 - 1.235D0 * DL 
     3          - 17.19D0 * DL1**3 + 71.08D0 * DL1**2 - 663.0D0 * DL1
     4          - 192.4D0 * DL * DL1**2 + 80.41D0 * DL**2 * DL1
     5        + NF * ( - 5.691D0 - 37.91D0 * Y 
     6          + 2.244D0 * DL**2 + 5.770D0 * DL 
     7          - 1.707D0 * DL1**2  + 22.95D0 * DL1
     8          + 3.036D0 * DL**2 * DL1 + 17.97D0 * DL * DL1 )     
*
       RETURN
       END FUNCTION C2NC2A
*
* ---------------------------------------------------------------------
*
*
* ..This is the singular NS piece, denoted by SOFT2 in WvN's program. 
*    It is the same for all F2 and F3 cases. The numerical coefficients 
*    are exact, but truncated.
*
       FUNCTION C2NS2B (Y, NF)
       IMPLICIT REAL*8 (A-Z)
       INTEGER NF
*
       OMY = 1.0D0 - Y
       DL1 = LOG (OMY)
       DM  = 1.D0/(OMY)
*
       C2NS2B = + 14.2222D0 * DL1**3 - 61.3333D0 * DL1**2 - 31.105D0 *
     $      DL1 + 188.64D0 + NF * ( 1.77778D0 * DL1**2 - 8.5926D0 * DL1
     $      + 6.3489D0 ) 
       C2NS2B = DM * C2NS2B
*
       RETURN
       END FUNCTION C2NS2B
*
* ---------------------------------------------------------------------
*
*
* ..This is the 'local' NS piece for the e.m. F2, denoted by COR2 in 
*    WvN's program. The numerical coefficients of the logs are exact,
*    but truncated, the constant one (from the delta-function) is 
*    slightly adjusted (+ 0.485 - 0.0035 NF) using the lowest moments.
*
       FUNCTION C2NN2C (Y, NF)
       IMPLICIT REAL*8 (A-Z)
       INTEGER NF
*
       OMY = 1.0D0 - Y
       DL1 = LOG (OMY)
*
       C2NN2C = + 3.55555D0 * DL1**4 - 20.4444D0 * DL1**3 - 15.5525D0 *
     $      DL1**2 + 188.64D0 * DL1 - 338.531D0 + 0.485D0 + NF *
     $      (0.592593D0 * DL1**3 - 4.2963D0 * DL1**2 + 6.3489D0 * DL1 +
     $      46.844D0 - 0.0035D0)
*
       RETURN
       END FUNCTION C2NN2C
*
* ---------------------------------------------------------------------
*
*
* ..This is the 'local' NS piece for the CC F2, also given by COR2 in 
*    WvN's program. The numerical coefficients of the logs are exact,
*    but truncated, the constant one is adjusted (- 0.2652 - 0.0035 NF) 
*    using the lowest moments.
*
       FUNCTION C2NC2C (Y, NF)
       IMPLICIT REAL*8 (A-Z)
       INTEGER NF
*
       OMY = 1.0D0 - Y 
       DL1 = LOG (OMY)
*
       C2NC2C = + 3.55555D0 * DL1**4 - 20.4444D0 * DL1**3 - 15.5525D0 *
     $      DL1**2 + 188.64D0 * DL1 - 338.531D0 + 0.537D0 + NF *
     $      (0.592593D0 * DL1**3 - 4.2963D0 * DL1**2 + 6.3489D0 * DL1 +
     $      46.844D0 - 0.0035D0)
*
       RETURN
       END FUNCTION C2NC2C

      end module xc2ns2p

*     
* =================================================================av==

!======================================================================
! This contains a few useful bits and pieces, some of which are from NR.
! The parts from NR (assertions) are in the public domain (see section
! C1.2 of "Numerical Recipes in Fortran 90" by Press et al.)
!
! $Id: assertions.f90,v 1.1 2001/06/27 13:40:16 gsalam Exp $
!
!======================================================================
module assertions
  use types
  implicit none
  private
  
  INTERFACE assert_eq
     MODULE PROCEDURE assert_eq2,assert_eq3,assert_eq4,assert_eq5,assert_eqn
  END INTERFACE
  public :: assert_eq

  interface default_or_opt
     MODULE PROCEDURE default_or_opt_dp, default_or_opt_sp,&
          & default_or_opt_int, default_or_opt_log
  end interface
  public :: default_or_opt

contains

  function default_or_opt_dp(xdef,xopt) result(x)
    real(dp), intent(in)           :: xdef
    real(dp), intent(in), optional :: xopt
    real(dp)                       :: x
    if (present(xopt)) then
       x = xopt
    else
       x = xdef
    end if
  end function default_or_opt_dp
  function default_or_opt_sp(xdef,xopt) result(x)
    real(sp), intent(in)           :: xdef
    real(sp), intent(in), optional :: xopt
    real(sp)                       :: x
    if (present(xopt)) then
       x = xopt
    else
       x = xdef
    end if
  end function default_or_opt_sp
  function default_or_opt_int(xdef,xopt) result(x)
    integer, intent(in)           :: xdef
    integer, intent(in), optional :: xopt
    integer                       :: x
    if (present(xopt)) then
       x = xopt
    else
       x = xdef
    end if
  end function default_or_opt_int
  function default_or_opt_log(xdef,xopt) result(x)
    logical, intent(in)           :: xdef
    logical, intent(in), optional :: xopt
    logical                       :: x
    if (present(xopt)) then
       x = xopt
    else
       x = xdef
    end if
  end function default_or_opt_log
  



  FUNCTION assert_eq2(n1,n2,string)
    CHARACTER(LEN=*), INTENT(IN) :: string
    INTEGER, INTENT(IN) :: n1,n2
    INTEGER :: assert_eq2
    if (n1 == n2) then
       assert_eq2=n1
    else
       write (0,*) 'nrerror: an assert_eq failed with this tag:', &
            string
       write(0,*) 'n1=',n1,' n2=',n2
       ERROR STOP 'program terminated by assert_eq2'
    end if
  END FUNCTION assert_eq2
  !BL
  FUNCTION assert_eq3(n1,n2,n3,string)
    CHARACTER(LEN=*), INTENT(IN) :: string
    INTEGER, INTENT(IN) :: n1,n2,n3
    INTEGER :: assert_eq3
    if (n1 == n2 .and. n2 == n3) then
       assert_eq3=n1
    else
       write (0,*) 'nrerror: an assert_eq failed with this tag:', &
            string
       ERROR STOP 'program terminated by assert_eq3'
    end if
  END FUNCTION assert_eq3
  !BL
  FUNCTION assert_eq4(n1,n2,n3,n4,string)
    CHARACTER(LEN=*), INTENT(IN) :: string
    INTEGER, INTENT(IN) :: n1,n2,n3,n4
    INTEGER :: assert_eq4
    if (n1 == n2 .and. n2 == n3 .and. n3 == n4) then
       assert_eq4=n1
    else
       write (0,*) 'nrerror: an assert_eq failed with this tag:', &
            string
       ERROR STOP 'program terminated by assert_eq4'
    end if
  END FUNCTION assert_eq4
  FUNCTION assert_eq5(n1,n2,n3,n4,n5,string)
    CHARACTER(LEN=*), INTENT(IN) :: string
    INTEGER, INTENT(IN) :: n1,n2,n3,n4,n5
    INTEGER :: assert_eq5
    if (n1 == n2 .and. n2 == n3 .and. n3 == n4 .and. n4 == n5) then
       assert_eq5=n1
    else
       write (0,*) 'nrerror: an assert_eq failed with this tag:', &
            string
       ERROR STOP 'program terminated by assert_eq4'
    end if
  END FUNCTION assert_eq5
  !BL
  FUNCTION assert_eqn(nn,string)
    CHARACTER(LEN=*), INTENT(IN) :: string
    INTEGER, DIMENSION(:), INTENT(IN) :: nn
    INTEGER :: assert_eqn
    if (all(nn(2:) == nn(1))) then
       assert_eqn=nn(1)
    else
       write (0,*) 'nrerror: an assert_eq failed with this tag:', &
            string
       ERROR STOP 'program terminated by assert_eqn'
    end if
  END FUNCTION assert_eqn
  !BL

end module assertions

module qcd_qed_coupling
  use types
  use qcd
  use couplings
  use qed_coupling_module ! gives us lepton masses
  implicit none
  private

  integer, parameter, public :: qcd_mass_scheme_pole  = 1
  integer, parameter, public :: qcd_mass_scheme_MSbar = 2
  
  type QCDQEDThreshold
     real(dp) :: mu
     integer  :: pdg_id
     integer  :: nflav(3) = 0 ! (nleptons, ndown, nup)
     real(dp) :: qcd_mult = one
  end type QCDQEDThreshold
  public :: QCDQEDThreshold

  integer, parameter    :: n_thresholds = 8
  type QCDQEDCoupling
     type(Coupling)        :: Coupling
     type(QCDQEDThreshold) :: thresholds(0:n_thresholds)
     integer               :: quark_schemes(4:6)
  end type QCDQEDCoupling
  public :: QCDQEDCoupling

  public :: new_QCDQEDCoupling
  public :: coupling_value, coupling_array ! from couplings
  public :: coupling
contains

  ! what thresholds will we have?
  ! - 3 lepton masses
  ! - 3 heavy-quark masses (c,b,t)
  ! - effective uds mass for QED part
  ! - freezing scale for QCD coupling
  !
  ! loops is a string variable of the form "01 02 03 10"
  ! to indicate QCD running up to three loops and QED running up to one loop
  ! add "11" to get the mixed QCD-QED running terms
  function new_QCDQEDCoupling(alphas, alpha, mu, loops, quark_masses, quark_schemes) result(cpl)
    use sort; use assertions; use warnings_and_errors
    real(dp), intent(in) :: alphas, alpha, mu
    character(len=*), intent(in) :: loops
    real(dp), intent(in) :: quark_masses(4:6)
    integer,  intent(in) :: quark_schemes(4:6)
    type(QCDQEDCoupling), target :: cpl
    !----------------------------------------------------------------------
    type(QCDQEDThreshold), target  :: thresholds(0:n_thresholds)
    type(QCDQEDThreshold), pointer :: threshold, last
    integer  :: i, indices(0:n_thresholds)
    integer  :: nloops, nloops_tot, loops_int(20)=-1
    logical :: qcd_target, qed_target
    type(CouplingTerm), allocatable :: beta_terms(:,:), thr_terms(:,:), rthr_terms(:,:)
    type(CouplingDefinition) :: coupling_def
    integer :: ithr, iloop, nf_lcl, nf_old, nf_diff, nlept
    
    ! first we collect the thresholds
    thresholds(0) = QCDQEDThreshold(m_electron/10   , -1 ) ! lower edge
    thresholds(1) = QCDQEDThreshold(m_electron      , 11 )
    thresholds(2) = QCDQEDThreshold(m_muon          , 13 )
    thresholds(3) = QCDQEDThreshold(m_tau           , 15 )
    thresholds(4) = QCDQEDThreshold(0.5_dp          , 123) ! turn off quarks in QED coupling
    thresholds(5) = QCDQEDThreshold(1.0_dp          , 21 ) ! unfreeze QCD coupling
    thresholds(6) = QCDQEDThreshold(quark_masses(4) , 4  )
    thresholds(7) = QCDQEDThreshold(quark_masses(5) , 5  )
    thresholds(8) = QCDQEDThreshold(quark_masses(6) , 6  )

    ! then we sort them (and adjust output, which is based on numbers from 1 upwards)
    call indexx(thresholds%mu, indices); indices = indices - 1

    ! just check that lower bound is genuinely zero
    i = assert_eq(indices(0),0, 'new_QCDQEDCoupling internal inconsistent lower bound')  

    ! now we establish the number of each kind of flavour
    do i = 1, n_thresholds
       last      => thresholds(indices(i-1))
       threshold => thresholds(indices(i))
       if (123 == threshold%pdg_id) then
          ! handle light quarks
          threshold%nflav(:) = last%nflav(:) + (/ 0, 2, 1 /)
       else  if (1 <= threshold%pdg_id .and. threshold%pdg_id <= 6) then
          ! handle heavy quarks
          if (mod(threshold%pdg_id,2) == 1) then
             threshold%nflav(:) = last%nflav(:) + (/ 0, 1, 0 /)
          else
             threshold%nflav(:) = last%nflav(:) + (/ 0, 0, 1 /)
          end if
       else if (11 <= threshold%pdg_id .and. threshold%pdg_id <= 15) then
          ! handle leptons
          threshold%nflav(:) = last%nflav(:) + (/1, 0, 0/)
       else if (21 == threshold%pdg_id) then
          ! no changes in flavour, but everything below this
          ! has frozen QCD coupling, obtained by setting qcd_mult -> 0
          threshold%nflav(:) = last%nflav(:)
          thresholds(indices(:i-1))%qcd_mult = zero
       else
          call wae_error('new_QCDQEDCoupling','inconsistent pdg_id', intval=threshold%pdg_id)
       end if
    end do
    cpl%thresholds = thresholds(indices(:))

    ! next we figure out which loop terms we will need
    nloops = Count_Items(loops)
    read(loops,*) loops_int(1:nloops)
    nloops_tot = nloops
    do i = 1, nloops
       qcd_target = (digit(1,loops_int(i)) /= 0)
       qed_target = (digit(2,loops_int(i)) /= 0)
       if (qcd_target) then
          ! this multiplies QCD coupling (index 1)
          loops_int(i) = loops_int(i) + 100             ! target is QCD
          if (qed_target) then
             ! and also QED coupling, so we add an extra entry
             nloops_tot = nloops_tot + 1
             loops_int(nloops_tot) = loops_int(i) + 100 ! target for this entry is QED
          end if
       else if (qed_target) then
          loops_int(i) = loops_int(i) + 200             ! target is QED
       else
          call wae_error('new_QCDQEDCoupling','inconsistent loops entry', intval=loops_int(i))
       end if
       
    end do
    nloops = nloops_tot

    ! allocate the terms we need
    allocate(beta_terms(1:nloops, 0:n_thresholds))
    allocate(thr_terms (1:nloops, 0:n_thresholds))
    allocate(rthr_terms(1:nloops, 0:n_thresholds))
    ! set defaults
    beta_terms = new_CouplingTerm(1, (/0,0/), zero)
    thr_terms  = new_CouplingTerm(1, (/0,0/), zero)
    rthr_terms = new_CouplingTerm(1, (/0,0/), zero)
    
    write(6,*) loops_int(1:nloops)

    ! now fill up 
    do ithr = 0, n_thresholds
       threshold => cpl%thresholds(ithr)
       nf_old = sum(cpl%thresholds(max(0,ithr-1))%nflav(2:3))
       nf_lcl = sum(threshold%nflav(2:3))
       nf_diff = nf_lcl - nf_old
       call qcd_SetNf(nf_lcl)
       nlept  = threshold%nflav(1)
       do iloop = 1, nloops
          select case(loops_int(iloop))
          case(101)
             beta_terms(iloop,ithr) = new_CouplingTerm(1, (/1,0/), -beta0)
          case(102)
             beta_terms(iloop,ithr) = new_CouplingTerm(1, (/2,0/), -beta1)
          case(103)
             beta_terms(iloop,ithr) = new_CouplingTerm(1, (/3,0/), -beta2)
             if (nf_diff == 1) thr_terms (iloop,ithr) = new_CouplingTerm(1, (/2,0/),  alphastep20_pole)
             if (nf_diff == 1) rthr_terms(iloop,ithr) = new_CouplingTerm(1, (/2,0/), -alphastep20_pole)
          case(104)
             beta_terms(iloop,ithr) = new_CouplingTerm(1, (/4,0/), -beta3)
             ! note unconventional sign here, as used in new_as.f90
             if (nf_diff == 1) thr_terms (iloop,ithr) = new_CouplingTerm(1, (/3,0/), &
                  &                       -alphastep30_pole-(nf_lcl-1)*alphastep30_pole_nl)
             if (nf_diff == 1) rthr_terms(iloop,ithr) = new_CouplingTerm(1, (/3,0/),  &
                  &                        alphastep30_pole+(nf_lcl-1)*alphastep30_pole_nl)
          case(210)
             beta_terms(iloop,ithr) = new_CouplingTerm(2, (/0,1/), &
                  &two/(6*pi)*qed_squared_charge(threshold%nflav(1),&
            &                                    threshold%nflav(2),&
            &                                    threshold%nflav(3)))
          case(211)
             ! got this from MNSZ backup notes, Eq. 96
             beta_terms(iloop,ithr) = new_CouplingTerm(2, (/1,1/), &
                  & three*CF/(4*pi)*one/(three*pi)*&
                  &           qed_squared_charge(                 0,&
            &                                    threshold%nflav(2),&
            &                                    threshold%nflav(3)))
          case(111)
             ! deduced this from Eq.(30) in 1512.00612
             beta_terms(iloop,ithr) = new_CouplingTerm(1, (/1,1/), &
                  & one/(four*pisq) * TR/CA*&
                  &           qed_squared_charge(                 0,&
            &                                    threshold%nflav(2),&
            &                                    threshold%nflav(3)))
             write(0,*) 'CHECK 111 case'
          case default
             call wae_error('new_QCDQEDCoupling','loops entry cannot be handled',&
                  &intval=loops_int(iloop))
          end select

          ! now post-process to make sure it makes sense
          call check_and_amend(beta_terms(iloop,ithr), loops_int(iloop), .false., cpl%thresholds(ithr         )%qcd_mult, 'beta')
          call check_and_amend(thr_terms (iloop,ithr), loops_int(iloop), .true. , cpl%thresholds(max(0,ithr-1))%qcd_mult, 'thr ')
          call check_and_amend(rthr_terms(iloop,ithr), loops_int(iloop), .true. , cpl%thresholds(max(0,ithr-1))%qcd_mult, 'rthr')

          ! write(6,*) ithr, iloop, loops_int(iloop)
          ! write(6,*) 'beta = ', beta_terms(iloop,ithr)%itarget, beta_terms(iloop,ithr)%alpha_powers, beta_terms(iloop,ithr)%coeff
          ! write(6,*) 'thr  = ', thr_terms (iloop,ithr)%itarget, thr_terms (iloop,ithr)%alpha_powers, thr_terms (iloop,ithr)%coeff
          ! write(6,*) 'rthr = ', rthr_terms(iloop,ithr)%itarget, rthr_terms(iloop,ithr)%alpha_powers, rthr_terms(iloop,ithr)%coeff
       end do
    end do
    
    coupling_def = new_CouplingDefinition(&
         & n_couplings = 2,&
         & nf_lo       = 0,&
         & nf_hi       = n_thresholds,&
         & beta_terms  = beta_terms,&
         & threshold_terms         = thr_terms (:,1:),&
         & reverse_threshold_terms = rthr_terms(:,1:),&
         & muMatch_M   = one)

    write(0,*) one/alpha
    cpl%Coupling = new_Coupling(coupling_def, (/alphas, alpha /), mu, cpl%thresholds(1:)%mu,&
         &                      Q_lo = m_electron/10.0_dp, Q_hi = 1e20_dp, eps=1e-10_dp)
  end function new_QCDQEDCoupling

  !----------------------------------------------------------------------
  ! check that the coupling term corresponds to the loops_int
  ! expectation (unless the coeff is zero) and adjust the power of the
  ! coupling for the target coupling
  subroutine check_and_amend(coupling_term, loops_int, is_threshold, qcd_mult, term)
    use warnings_and_errors
    type(CouplingTerm), intent(inout) :: coupling_term
    integer,            intent(in)    :: loops_int
    logical,            intent(in)    :: is_threshold
    real(dp),           intent(in)    :: qcd_mult
    character(len=*),   intent(in)    :: term
    !-------------------------------
    logical :: issue
    integer :: itarget
    integer :: adj_powers(lbound(coupling_term%alpha_powers,1):ubound(coupling_term%alpha_powers,1))

    itarget = coupling_term%itarget
    adj_powers = coupling_term%alpha_powers
    if (is_threshold) adj_powers(itarget) = adj_powers(itarget) + 1
    
    issue = .false.
    issue = issue .or. .not.( adj_powers(1)         == digit(1,loops_int) .or. coupling_term%coeff == zero)
    issue = issue .or. .not.( adj_powers(2)         == digit(2,loops_int) .or. coupling_term%coeff == zero)
    issue = issue .or. .not.( coupling_term%itarget == digit(3,loops_int) .or. coupling_term%coeff == zero)
    if (issue) call wae_error('new_QCDQEDCoupling->check_and_amend','issue with loop term '//term,intval=loops_int)

    ! add 1 to alpha_power corresponding to target, because above we've assumed that
    !
    !   dalpha(itarget) = alpha(itarget) * (...)
    !
    ! whereas the couplings module doesn't include the leading power
    coupling_term%alpha_powers(itarget) = coupling_term%alpha_powers(itarget) + 1

    ! then apply qcd_mult (typically either one or zero) to anything that involves
    ! a QCD coupling
    if (coupling_term%alpha_powers(1) /= 0 .or. coupling_term%itarget == 1)&
         &coupling_term%coeff = coupling_term%coeff * qcd_mult
  end subroutine check_and_amend
  
  
  ! --------------------
  ! from http://fortranwiki.org/fortran/show/String_Functions
  INTEGER FUNCTION Count_Items(s1)  ! in string or C string that are blank or comma separated
    CHARACTER(*) :: s1
    CHARACTER(len(s1)) :: s
    INTEGER :: i, k
    
    s = s1                            ! remove possible last char null
    k = 0  ; IF (s /= ' ') k = 1      ! string has at least 1 item
    DO i = 1,LEN_TRIM(s)-1
       IF (s(i:i) /= ' '.AND.s(i:i) /= ',' &
            .AND.s(i+1:i+1) == ' '.OR.s(i+1:i+1) == ',') k = k+1
    END DO
    Count_Items = k
  END FUNCTION Count_Items

  ! returns the i^th digit of number n
  integer function digit(i,n)
    integer, intent(in) :: i, n
    digit = mod(n/10**(i-1),10)
  end function digit
  
  
end module qcd_qed_coupling

!======================================================================
!! Program to run benchmark checks for comparison with Andreas Vogt's
!! numbers
!!
!! Usage: 
!! ./benchmark outname [options]
!!
!! Sends output to files outname.6|7|8|9
!!
!! Options include:
!!
!! Internal choices (accuracy etc.)
!! --------------------------------
!! -dy    dy        spacing in y
!! -dt    dt        old form of spacing in t=lnQ; default is dy
!! -order order     interpolation order
!! -ceps  eps       precision for integrations to get splitting fn.s
!! -lock            whether to lock subgrids together (recommended)
!!
!! -repeat nrep     number of times to repeat calcn (for timing)
!! -precalc         precalculate the evolution
!!
!! -high            write results with high output precision
!! -gnuplot         write output suitable for gnuplot
!!
!! Physics choices
!! ---------------
!! -nloop nloop     # of loops
!! -muR_Q muR_Q     ratio of renorm. to fact. scale
!! -nomasssteps     turn off corrections when going through thresholds
!! -nnlo {exact|param|Nfitav|Nfiterr1|Nfiterr2} 
!!                  which of the NNLO split fns. to use (default param)
!! -nnlo_nfthreshold {exact|param}
!!
!! -varnf           use variable nf
!! -pol             do polarized evln
!!
! $Id: main-tablevogt.f90,v 1.25 2004/09/21 18:50:20 salam Exp $ 
!======================================================================

! the initial conditions
module parton_distributions
   use hoppet
  implicit none
  private
  public :: unpolarized_benchmark_pdf, polarized_benchmark_pdf
contains
  !======================================================================
  !! The dummy PDF suggested by Vogt as the initial condition for the 
  !! unpolazrized evolution
  function unpolarized_benchmark_pdf(xvals) result(pdf)
    real(dp), intent(in) :: xvals(:)
    real(dp)             :: pdf(size(xvals),ncompmin:ncompmax)
    real(dp) :: uv(size(xvals)), dv(size(xvals))
    real(dp) :: ubar(size(xvals)), dbar(size(xvals))
    !---------------------
    real(dp), parameter :: N_g = 1.7_dp, N_ls = 0.387975_dp
    real(dp), parameter :: N_uv=5.107200_dp, N_dv = 3.064320_dp
    real(dp), parameter :: N_db = half*N_ls
  
    pdf = zero
    ! clean method for labelling as PDF as being in the human representation
    call LabelPdfAsHuman(pdf)

    !-- remember that these are all xvals*q(xvals)
    uv = N_uv * xvals**0.8_dp * (1-xvals)**3
    dv = N_dv * xvals**0.8_dp * (1-xvals)**4
    dbar = N_db * xvals**(-0.1_dp) * (1-xvals)**6
    ubar = dbar * (1-xvals)
    pdf(:,iflv_g) = N_g * xvals**(-0.1_dp) * (1-xvals)**5
        
    pdf(:,-iflv_s) = 0.2_dp*(dbar + ubar)
    pdf(:, iflv_s) = pdf(:,-iflv_s)
    pdf(:, iflv_u) = uv + ubar
    pdf(:,-iflv_u) = ubar
    pdf(:, iflv_d) = dv + dbar
    pdf(:,-iflv_d) = dbar
  end function unpolarized_benchmark_pdf


  function polarized_benchmark_pdf(x) result(pdf)
    real(dp), intent(in) :: x(:)
    real(dp)             :: pdf(size(x),-6:7)
    real(dp) :: uv(size(x)), dv(size(x)), ubar(size(x)), dbar(size(x))

    pdf = zero
    ! clean method for labelling as PDF as being in the human representation
    call LabelPdfAsHuman(pdf)
    !-- remember that my definitions that these are all x*q(x)
    uv =  1.3_dp * x**0.7_dp * (1-x)**3 * (1+3*x)
    dv = -0.5_dp * x**0.7_dp * (1-x)**4 * (1+4*x)
    dbar = -0.05_dp * x**0.3_dp * (1-x)**7
    ubar = dbar
    ubar = 0.9_dp * ubar
    dbar = 1.1_dp * dbar
    pdf(:,iflv_g) = 1.5_dp * x**0.5_dp * (1-x)**5

    pdf(:,-iflv_s) = 0.25_dp * (dbar+ubar)
    pdf(:, iflv_s) = pdf(:,-iflv_s)
    pdf(:, iflv_u) = uv + ubar
    pdf(:,-iflv_u) = ubar
    pdf(:, iflv_d) = dv + dbar
    pdf(:,-iflv_d) = dbar

  end function polarized_benchmark_pdf

end module parton_distributions


program main_tablevogt
  ! local things
  use parton_distributions
  use NameSelect; use io_utils, int_value => value
  ! hoppet
   use hoppet
  implicit none
  type(running_coupling)  :: coupling, ash3to4
  integer, parameter :: ngrid = 3
  type(grid_def)     :: grid, gdarray(ngrid)
  real(dp), pointer  :: qdist(:,:)
  type(dglap_holder) :: dh
  real(dp) :: dy, dt, ceps
  integer  :: order, nloop
  logical  :: varnf
  real(dp) :: Qlo
  !------------------------
  !real(dp), parameter :: ymax = 11.6_dp
  real(dp), parameter :: ymax = 18.6_dp
  integer,  parameter :: nms = 20
  real(dp), parameter :: ms(nms) = (/ &
       2.D0,  2.7D0,  3.6D0,   5.D0,   7.D0,   1.D1,&
       1.4D1,  2.D1,   3.D1,   5.D1,   7.D1,   1.D2,&
       2.D2,   5.D2,   1.D3,   3.D3,   1.D4,   4.D4,&
       2.D5,   1.D6 /)
!!$  real(dp), parameter :: ms(20) = (/ &
!!$       2.D0,  2.7D0,  3.6D0,   5.D0,   7.D0,   1.D1,&
!!$       1.4D1,  20.249999999D0,   20.250000001D0,   5.D1,   7.D1,   1.D2,&
!!$       2.D2,   5.D2,   1.D3,   3.D3,   1.D4,   4.D4,&
!!$       2.D5,   1.D6 /)
  real(dp), parameter :: xb(25) = (/ &
       1.D-8,  1.D-7,  1.D-6,&
       1.D-5,  2.D-5,  5.D-5,  1.D-4,  2.D-4,  5.D-4,&
       1.D-3,  2.D-3,  5.D-3,  1.D-2,  2.D-2,  5.D-2,&
       1.D-1, 1.5D-1,  2.D-1,  3.D-1,  4.D-1,  5.0D-1,&
       6.D-1, 7.D-1, 8.D-1, 9.D-1 /)
  type(evln_operator) :: evop(2:nms)

  character(len=*), parameter :: pdfformat_vogt = &
       &'(1X,2(1PE9.1),1X,5(1PE15.7))'
  character(len=*), parameter :: pdfformat_gnu = &
       &'(1X,2(1PE9.1),1X,5(1PE14.6))'
  character(len=*), parameter :: pdfformat_highprec = &
       &'(1X,2(1PE9.1),1X,5(1PE22.14))'
  character(len=len(pdfformat_highprec)) :: pdfformat
  character(len=*), parameter :: asformat = &
       &'(1X,1(1PE9.1),1X,0PF10.7)'
  real(dp) :: qdx(-iflv_max:iflv_max)
  real(dp) :: uv, dv, sv, del, uds, ss, cs, bs, gl, cv
  real(dp) :: x, m2, muR_Q
  integer  :: im, ix, id, nrepeat, irepeat, nfdefault
  integer  :: idev6, idev7, idev8, idev9, idev10
  integer  :: lcl_vogt_imod, factscheme, pdfid
  logical  :: gnuplot, highprec_out, polarized
  logical  :: precalc_evln


  write(0,*) '=============== HOPPET benchmark starting ==================='


  dy    = dble_val_opt('-dy',0.1_dp)
  order = int_val_opt('-order',7)
  nloop = int_val_opt('-nloop',2)
  dt    = dble_val_opt('-dt',dy)
  ceps  = dble_val_opt('-eps',1e-7_dp)
  muR_Q = dble_val_opt('-muR_Q', one)               !
  muR_Q = sqrt(dble_val_opt('-mu2R_Q', muR_Q**2))   ! allow both specifications
  varnf = log_val_opt('-varnf')
  nfdefault = int_val_opt('-nf',4)
  mass_steps_on = log_val_opt('-masssteps',.true.)
  gnuplot = log_val_opt('-gnuplot')
  highprec_out = log_val_opt('-high')
  !lock    = log_val_opt('-lock',.false.)
  nrepeat = int_val_opt('-repeat',1)
  precalc_evln = log_val_opt('-precalc')

  ! take care of consistent use of param and exact variants
  call dglap_Set_nnlo_splitting(&
       &code_val_opt('-nnlo',nnlo_splitting_variant,prefix='nnlo_splitting_'))
  select case(nnlo_splitting_variant)
  case(nnlo_splitting_exact)
     call dglap_Set_nnlo_nfthreshold(nnlo_nfthreshold_exact)
  case default
     call dglap_Set_nnlo_nfthreshold(nnlo_nfthreshold_param)
  end select
  call dglap_Set_nnlo_nfthreshold(&
       &code_val_opt('-nnlo_nfthreshold',nnlo_nfthreshold_variant,&
       &              prefix='nnlo_nfthreshold_'))
       

  polarized = log_val_opt('-pol')
  if (polarized) then
     factscheme = factscheme_PolMSbar
  else
     factscheme = factscheme_MSbar
  end if


  call print_comments(prefix='',idev=0)
  idev9 = idev_open_arg(1,'.9')
  !-- security ----------------------
  if (.not. CheckAllArgsUsed(0)) stop
  !----------------------------------
  call print_comments(prefix='# ',idev=idev9)

  if (gnuplot) then
     pdfformat = pdfformat_gnu
  else if (highprec_out) then
     pdfformat = pdfformat_highprec
  else
     pdfformat = pdfformat_vogt
  end if

  call SetDefaultEvolutionDt(dt)
  call SetDefaultConvolutionEps(ceps)

  idev6 = idev_open_arg(1,'.6')
  idev7 = idev_open_arg(1,'.7')
  idev8 = idev_open_arg(1,'.8')
  idev10 = idev_open_arg(1,'.10')


  ! call InitGridDef(gdarray(3),dy*0.1_dp,0.5_dp, order=order)
  ! call InitGridDef(gdarray(2),dy/3.0_dp,2.0_dp, order=order)
  ! call InitGridDef(gdarray(1),dy,       ymax  ,order=order)
  call InitGridDefDefault(grid, dy, ymax, order)
  
  call qcd_SetNf(nfdefault) ! <-- CHECK THIS
  if (varnf) then
     ! given that we do not actually need to evolve in nf=3, but just
     ! go past the threshold, we could not bother with this nf=3,
     ! but it makes things a bit simpler.
     call InitDglapHolder(grid, dh, factscheme, nloop=nloop,&
          & nflo=3, nfhi=6)
     if (muR_Q < one) then
        !-- this is a hack to make sure that alfas=0.35 corresponds
        !   to the 3-flavour alphas.
        !   initialise with 3 flavours (default for this scale)
        call InitRunningCoupling(ash3to4, alfas=0.35_dp, Q=sqrt(ms(1)), nloop=nloop,&
             & muMatch_mQuark=one, use_nah=.true.)
        !   reinitialise with new alpha_s with muMatch_mQuark=muR_Q
        !   and 4 flavours
        !call InitRunningCoupling(coupling, alfas=Value(ash3to4,Q=sqrt(ms(1)),fixnf=4),&
        !     & Q=sqrt(ms(1)), nloop=nloop,&
        !     & muMatch_mQuark=muR_Q, use_nah=.true.)
        !------------------
        ! "second scenario:" evolve down to muR_Q*mc and set the
        ! new coupling there.
        call InitRunningCoupling(coupling, alfas=Value(ash3to4,Q=sqrt(ms(1))*muR_Q),&
             & Q=sqrt(ms(1))*muR_Q, nloop=nloop,&
             & muMatch_mQuark=muR_Q, use_nah=.true.)
     else
        call InitRunningCoupling(coupling, alfas=0.35_dp, Q=sqrt(ms(1)), nloop=nloop,&
             & muMatch_mQuark=muR_Q, use_nah=.true.)
     end if
     
!!$     call InitRunningCoupling(coupling, alfas=0.115161, Q=100.0_dp, nloop=nloop,&
!!$          & use_nah=.true.)
  else
     call InitDglapHolder(grid, dh, factscheme, nloop=nloop)
     call InitRunningCoupling(coupling, alfas=0.35_dp, Q=sqrt(ms(1)), nloop=nloop,&
          & fixnf=nf_int, use_nah=.true.)
  end if
  

  write(0,*) 'Init done'

  Qlo = sqrt(ms(1))

  !--- allow testing of precalculated and stored evolution
  if (precalc_evln) then
     do im = 2, size(ms)
        call EvolveGeneric(dh, nloop=nloop, coupling=coupling, &
             &Q_init=sqrt(ms(im-1)), Q_end=sqrt(ms(im)), &
             &evop = evop(im), muR_Q = muR_Q)
     end do
  end if

  do irepeat = 1, nrepeat
     
  call allocPDF(grid, qdist)
  if (polarized) then
     qdist = polarized_benchmark_pdf(xValues(grid))
  else 
     qdist = unpolarized_benchmark_pdf(xValues(grid))
  end if

  do im = 1, size(ms)
     m2 = ms(im)
     if (im > 1) then
        if (precalc_evln) then
           qdist = evop(im) .conv. qdist
        else
           call EvolvePDF(dh, qdist, nloop=nloop, coupling=coupling, &
                &Q_init=sqrt(ms(im-1)), Q_end=sqrt(ms(im)), muR_Q = muR_Q)
        end if
     end if
     
     !if (irepeat /= 1) cycle
     if (irepeat == 1) write(idev6,asformat) m2, Value(coupling, sqrt(m2))
     if (irepeat > 1) cycle ! get JUST the time for evolution...
                            ! later on worry about optimizing the rest...
     do ix = 1, size(xb)
        x = xb(ix)
        !-- decant...
        qdx(iflv_min:iflv_max) = &
             &EvalGridQuant(grid,qdist(:,iflv_min:iflv_max),-log(x))
        uv  = qdx(iflv_u) - qdx(iflv_ubar)
        dv  = qdx(iflv_d) - qdx(iflv_dbar)
        sv  = qdx(iflv_s) - qdx(iflv_sbar); 
        del = qdx(iflv_dbar) - qdx(iflv_ubar)
        uds = two*(qdx(iflv_dbar) + qdx(iflv_ubar)) ! presume this is meant
        ss  = qdx(iflv_s) + qdx(iflv_sbar)
        cs  = qdx(iflv_c) + qdx(iflv_cbar)
        bs  = qdx(iflv_b) + qdx(iflv_bbar)
        gl  = qdx(iflv_g)
        cv  = qdx(iflv_c) - qdx(iflv_cbar); !TEMPORARY FOR DEBUGGING
        !-- fix up rounding errors to avoid embarassment!
        if (nloop <= 2) sv = zero
        if (irepeat == 1) then
           write(idev7,pdfformat) M2, X, UV, DV, DEL, UDS, GL
           write(idev8,pdfformat) M2, X, SV, SS, CS, BS
           if (abs(m2-1e4_dp) < 1e-3_dp) call vogt_latex
        end if
     end do
     if (gnuplot .and. irepeat == 1) then
        write(idev7,*) 
        write(idev8,*) 
        write(idev7,*) 
        write(idev8,*) 
     end if
  end do
  deallocate(qdist)
  end do


contains

  subroutine print_comments(prefix,idev)
    character(len=*), intent(in) :: prefix
    integer,          intent(in) :: idev

    character(len=*), parameter :: fa='(a,a)'
    character(len=*), parameter :: fd='(a,f12.8)'
    character(len=*), parameter :: fe='(a,es15.5)'
    character(len=*), parameter :: fi='(a,i6)'
    character(len=*), parameter :: fl='(a,l2)'
    character(len=200) :: arg1

    arg1 = trim(string_val_arg(1))
    write(idev,fa) prefix//'Output will be sent to '//arg1//'.[678]'
    write(idev,fd) prefix//'dy = ', dy
    write(idev,fd) prefix//'dt = ', dt
    write(idev,fi) prefix//'num order = ', order
    !write(idev,fl) prefix//'locking is ', lock
    write(idev,fi) prefix//'nloop = ', nloop
    write(idev,fe) prefix//'conv_eps = ', ceps
    write(idev,fd) prefix//'muR_Q = ', muR_Q
    write(idev,fd) prefix//'muR_Q^2 = ', muR_Q**2
    write(idev,fl) prefix//'varnf is ',varnf
    if (.not. varnf) &
         & write(idev,fi) prefix//'nf = ',nfdefault
    write(idev,fl) prefix//'polarization = ', polarized
    write(idev,fl) prefix//'mass_steps_on is',mass_steps_on
    write(idev,fa) prefix//'factscheme = ', &
         &trim(NameOfCode(factscheme,prefix='factscheme'))
    if (nloop > 2) then
       write(idev,fa) prefix//'nnlo_splitting_variant = ', &
         &trim(NameOfCode(nnlo_splitting_variant,prefix='nnlo_splitting'))
       write(idev,fa) prefix//'nnlo_nfthreshold_variant = ', &
         &trim(NameOfCode(nnlo_nfthreshold_variant,prefix='nnlo_nfthreshold'))
    end if
    write(idev,fl) prefix//'Precalc evolution   ', precalc_evln
    write(idev,fi) prefix//'Number of repeats ', nrepeat
    write(idev,fa,advance="no") prefix
    call time_stamp(idev)
    write(idev,fa) '# '//trim(command_line())
  end subroutine print_comments
  

  subroutine vogt_latex
    !DATA XB / 1.D-8,  1.D-7,  1.D-6,  1.D-5,  1.D-4,  1.D-3,         &
    !     &           1.D-2,  1.D-1,  3.D-1,  5.D-1,  7.D-1,  9.D-1 /        
    !                                                                       
    ! ..Output                                                              
    !                                                                       
    !        WRITE (7,18) M2, X, UV, DV, DEL, UDS, GL                       
    !        WRITE (8,18) M2, X, SV, SS, CS, BS                             
    !WRITE (7,18) X, UV, DV, DEL, UDS, GL 
    !WRITE (8,18) X, SV, SS, CS, BS 
    !                                                                       
    logical :: writeit

    writeit = .false.
    IF ( (X .GT. 0.9E-7) .and. (X .LT. 1.1E-7) ) THEN
       writeit = .true. ; WRITE (idev10,20)
    ELSE IF ( (X .GT. 0.9E-6) .and. (X .LT. 1.1E-6) ) THEN
       writeit = .true. ; WRITE (idev10,21)
    ELSE IF ( (X .GT. 0.9E-5) .and. (X .LT. 1.1E-5) ) THEN
       writeit = .true. ; WRITE (idev10,22)
    ELSE IF ( (X .GT. 0.9E-4) .and. (X .LT. 1.1E-4) ) THEN
       writeit = .true. ; WRITE (idev10,23)
    ELSE IF ( (X .GT. 0.9E-3) .and. (X .LT. 1.1E-3) ) THEN
       writeit = .true. ; WRITE (idev10,24)
    ELSE IF ( (X .GT. 0.9E-2) .and. (X .LT. 1.1E-2) ) THEN
       writeit = .true. ; WRITE (idev10,25)
    ELSE IF ( (X .GT. 0.9E-1) .and. (X .LT. 1.1E-1) ) THEN
       writeit = .true. ; WRITE (idev10,26)
    ELSE IF ( (X .GT. 2.9E-1) .and. (X .LT. 3.1E-1) ) THEN
       writeit = .true. ; WRITE (idev10,27)
    ELSE IF ( (X .GT. 4.9E-1) .and. (X .LT. 5.1E-1) ) THEN
       writeit = .true. ; WRITE (idev10,28)
    ELSE IF ( (X .GT. 6.9E-1) .and. (X .LT. 7.1E-1) ) THEN
       writeit = .true. ; WRITE (idev10,29)
    ELSE IF ( (X .GT. 8.9E-1) .and. (X .LT. 9.1E-1) ) THEN
       writeit = .true. ; WRITE (idev10,30)
    END IF
    if (writeit) then
       WRITE (idev10,31) UV, DV, DEL, UDS
       ! WRITE (idev10,32) SV, SS, CS, GL
       WRITE (idev10,32) SS, CS, BS, GL
    end if
    
20  FORMAT ('$q! 10^{-7}q!$ &')
21  FORMAT ('$q! 10^{-6}q!$ &')
22  FORMAT ('$q! 10^{-5}q!$ &')
23  FORMAT ('$q! 10^{-4}q!$ &')
24  FORMAT ('$q! 10^{-3}q!$ &')
25  FORMAT ('$q! 10^{-2}q!$ &')
26  FORMAT ('$q! 0.1    q!$ &')
27  FORMAT ('$q! 0.3    q!$ &')
28  FORMAT ('$q! 0.5    q!$ &')
29  FORMAT ('$q! 0.7    q!$ &')
30  FORMAT ('$q! 0.9    q!$ &')
31  FORMAT (3('$q!',1PE11.4,'}q!$ &'),'$q!',1PE11.4,'}q!$ &')
32  FORMAT (3('$q!',1PE11.4,'}q!$ &'),'$q!',1PE11.4,'}q!$qq')

!!$    IF ( (X .GT. 0.9E-7) .and. (X .LT. 1.1E-7) ) THEN 
!!$       WRITE (idev10,20) UV, DV, DEL, UDS 
!!$       WRITE (idev10,40) SS, CS, GL 
!!$    ELSE IF ( (X .GT. 0.9E-6) .and. (X .LT. 1.1E-6) ) THEN 
!!$       WRITE (idev10,21) UV, DV, DEL, UDS 
!!$       WRITE (idev10,41) SS, CS, GL 
!!$    ELSE IF ( (X .GT. 0.9E-5) .and. (X .LT. 1.1E-5) ) THEN 
!!$       WRITE (idev10,22) UV, DV, DEL, UDS 
!!$       WRITE (idev10,42) SS, CS, GL 
!!$    ELSE IF ( (X .GT. 0.9E-4) .and. (X .LT. 1.1E-4) ) THEN 
!!$       WRITE (idev10,23) UV, DV, DEL, UDS 
!!$       WRITE (idev10,43) SS, CS, GL 
!!$    ELSE IF ( (X .GT. 0.9E-3) .and. (X .LT. 1.1E-3) ) THEN 
!!$       WRITE (idev10,24) UV, DV, DEL, UDS 
!!$       WRITE (idev10,44) SS, CS, GL 
!!$    ELSE IF ( (X .GT. 0.9E-2) .and. (X .LT. 1.1E-2) ) THEN 
!!$       WRITE (idev10,25) UV, DV, DEL, UDS 
!!$       WRITE (idev10,45) SS, CS, GL 
!!$    ELSE IF ( (X .GT. 0.9E-1) .and. (X .LT. 1.1E-1) ) THEN 
!!$       WRITE (idev10,26) UV, DV, DEL, UDS 
!!$       WRITE (idev10,46) SS, CS, GL 
!!$    ELSE IF ( (X .GT. 2.9E-1) .and. (X .LT. 3.1E-1) ) THEN 
!!$       WRITE (idev10,27) UV, DV, DEL, UDS 
!!$       WRITE (idev10,47) SS, CS, GL 
!!$    ELSE IF ( (X .GT. 4.9E-1) .and. (X .LT. 5.1E-1) ) THEN 
!!$       WRITE (idev10,28) UV, DV, DEL, UDS 
!!$       WRITE (idev10,48) SS, CS, GL 
!!$    ELSE IF ( (X .GT. 6.9E-1) .and. (X .LT. 7.1E-1) ) THEN 
!!$       WRITE (idev10,29) UV, DV, DEL, UDS 
!!$       WRITE (idev10,49) SS, CS, GL 
!!$    ELSE IF ( (X .GT. 8.9E-1) .and. (X .LT. 9.1E-1) ) THEN 
!!$       WRITE (idev10,30) UV, DV, DEL, UDS 
!!$       WRITE (idev10,50) SS, CS, GL 
!!$    END IF
!!$    !                                                                       
!!$10  FORMAT (1PE8.1,1X,7(1PE10.3)) 
!!$12  FORMAT (1X,1PE9.1,1X,6(1PE11.4)) 
!!$18  FORMAT (1X,1(1PE9.1),1X,5(1PE13.6)) 
!!$    !                                                                       
!!$20  FORMAT (1X,'$10^{-7}$ &',3(1PE11.4,'}$ &'),1PE11.4,'}$ ') 
!!$40  FORMAT (1X,'          &',2(1PE11.4,'}$ &'),1PE11.4,'}$ qq') 
!!$21  FORMAT (1X,'$10^{-6}$ &',3(1PE11.4,'}$ &'),1PE11.4,'}$ ') 
!!$41  FORMAT (1X,'          &',2(1PE11.4,'}$ &'),1PE11.4,'}$ qq') 
!!$22  FORMAT (1X,'$10^{-5}$ &',3(1PE11.4,'}$ &'),1PE11.4,'}$ ') 
!!$42  FORMAT (1X,'          &',2(1PE11.4,'}$ &'),1PE11.4,'}$ qq') 
!!$23  FORMAT (1X,'$10^{-4}$ &',3(1PE11.4,'}$ &'),1PE11.4,'}$ ') 
!!$43  FORMAT (1X,'          &',2(1PE11.4,'}$ &'),1PE11.4,'}$ qq') 
!!$24  FORMAT (1X,'$10^{-3}$ &',3(1PE11.4,'}$ &'),1PE11.4,'}$ ') 
!!$44  FORMAT (1X,'          &',2(1PE11.4,'}$ &'),1PE11.4,'}$ qq') 
!!$25  FORMAT (1X,'$10^{-2}$ &',3(1PE11.4,'}$ &'),1PE11.4,'}$ ') 
!!$45  FORMAT (1X,'          &',2(1PE11.4,'}$ &'),1PE11.4,'}$ qq') 
!!$26  FORMAT (1X,'0.1       &',3(1PE11.4,'}$ &'),1PE11.4,'}$ ') 
!!$46  FORMAT (1X,'          &',2(1PE11.4,'}$ &'),1PE11.4,'}$ qq') 
!!$27  FORMAT (1X,'0.3       &',3(1PE11.4,'}$ &'),1PE11.4,'}$ ') 
!!$47  FORMAT (1X,'          &',2(1PE11.4,'}$ &'),1PE11.4,'}$ qq') 
!!$28  FORMAT (1X,'0.5       &',3(1PE11.4,'}$ &'),1PE11.4,'}$ ') 
!!$48  FORMAT (1X,'          &',2(1PE11.4,'}$ &'),1PE11.4,'}$ qq') 
!!$29  FORMAT (1X,'0.7       &',3(1PE11.4,'}$ &'),1PE11.4,'}$ ') 
!!$49  FORMAT (1X,'          &',2(1PE11.4,'}$ &'),1PE11.4,'}$ qq') 
!!$30  FORMAT (1X,'0.9       &',3(1PE11.4,'}$ &'),1PE11.4,'}$ ') 
!!$50  FORMAT (1X,'          &',2(1PE11.4,'}$ &'),1PE11.4,'}$ qq')
  end subroutine vogt_latex
  
end program main_tablevogt

module xpgg3a
  character(len=*), parameter :: name_xpgg3 = "xpgg3a"
contains
! ..File: xPgg3a.f   
!
! ..The 4-loop MSbar gluon-gluon splitting function P_{gg}^(3) 
!    for the  evolution of the flavour-singlet parton distributions.
!    The expansion parameter is alpha_s/(4 pi), the scale mu_r = mu_f.
!
! ..These are approximations for fixed nf = 3, 4 and 5 based on the 
!    first five even moments together with small-x/large-x constraints.
!    The two sets providing the error estimate are called via IMOD = 1 
!    and IMOD = 2.  Any other value of IMOD invokes their average.
!
! ..The distributions (in the mathematical sense) are given as in eq.
!    (B.26) of Floratos, Kounnas, Lacaze: Nucl. Phys. B192 (1981) 417.
!    The name-endings A, B, and C of the functions below correspond to 
!    the kernel superscripts [2], [3], and [1] in that equation.
!   
!    Reference: Additional moments and x-space approximations
!                 of four-loop splitting functions in QCD
!               S. Moch, B. Ruijl, T. Ueda, J. Vermaseren and A. Vogt
!               DESY 23-150, Nikhef 2023-016, LTH 1354
!
! =====================================================================
!
! ..The regular part
!
       FUNCTION P3GGA (Y, NF, IMOD)
!
       IMPLICIT REAL*8 (A-Z)
       INTEGER IMOD, nf
       COMMON / P3GSOFT / A4gluon
!
       YM  = 1.D0/Y
       Y1  = 1.D0-Y
       DL  = DLOG(Y)
       DL1 = DLOG(1.D0-Y)
!
       nf2 = nf*nf
       nf3 = nf*nf2
!
!  The known large-x coefficients [except delta(1-x)]
!
       A4gluon =  40880.330D0     - 11714.246D0*nf &
                + 440.04876D0*nf2 + 7.3627750D0*nf3
       Ccoeff = 8.5814120D+4 - 1.3880515D+4*nf + 1.3511111D+2*nf2
       Dcoeff = 5.4482808D+4 - 4.3411337D+3*nf - 2.1333333D+1*nf2 
!    
!  The known coefficients of 1/x*ln^a x terms, a = 3,2
!
       bfkl0  = - 8.308617314D+3
       bfkl1  = - 1.069119905D+5 - 9.963830436D+2*nf
!
!  The resulting part of the function
!
       P3gg01 =               &
            + bfkl0* DL**3*YM &
            + bfkl1* DL**2*YM &
            + Ccoeff* DL1     &
            + Dcoeff - A4gluon
!
!  The selected approximations for nf = 3, 4, 5
!
       IF ( NF .EQ. 3 ) THEN
         P3ggApp1 = P3gg01        &
            + 3.4D0 *bfkl1* DL*YM    &
            - 345063.D0 * Y1*YM      &
            + 86650.D0 * (1.D0 +Y*Y)*Y1 &
            + 158160.D0 * DL         &
            - 15741.D0 * Y1*DL1**2   &
            - 9417.D0 * Y1*DL1**3  
         P3ggApp2 = P3gg01        &
            + 5.4D0 *bfkl1* DL*YM    &
            - 1265632.D0 * Y1*YM     &
            - 656644.D0 * (1.D0 +Y*Y)*Y1&
            - 1352233.D0 * DL        &
            + 203298.D0 * Y1*DL1**2  &
            + 39112.D0 * Y1*DL1**3  
       ELSE IF ( NF .EQ. 4 ) THEN
         P3ggApp1 = P3gg01        &
            + 3.4D0 *bfkl1* DL*YM    &
            - 342625.D0 * Y1*YM      &
            + 100372.D0 * (1.D0 +Y*Y)*Y1&
            + 189167.D0 * DL         &
            - 29762.D0 * Y1*DL1**2   &
            - 12102.D0 * Y1*DL1**3  
         P3ggApp2 = P3gg01        &
            + 5.4D0 *bfkl1* DL*YM    &
            - 1271540.D0 * Y1*YM     &
            - 649661.D0 * (1.D0 +Y*Y)*Y1&
            - 1334919.D0 * DL        &
            + 191263.D0 * Y1*DL1**2  &
            + 36867.D0 * Y1*DL1**3  
       ELSE IF ( NF .EQ. 5 ) THEN
         P3ggApp1 = P3gg01        &
            + 3.4D0 *bfkl1* DL*YM    &
            - 337540.D0 * Y1*YM      &
            + 119366.D0 * (1.D0 +Y*Y)*Y1&
            + 223769.D0 * DL         &
            - 45129.D0 * Y1*DL1**2   &
            - 15046.D0 * Y1*DL1**3
         P3ggApp2 = P3gg01        &
            + 5.4D0 *bfkl1* DL*YM    &
            - 1274800.D0 * Y1*YM     &
            - 637406.D0 * (1.D0 +Y*Y)*Y1&
            - 1314010.D0 * DL        &
            + 177882.D0 * Y1*DL1**2  &
            + 34362.D0 * Y1*DL1**3  
       ELSE
         WRITE(6,*) '  Error in function P3GGA: choice of nf   '
         CALL ABORT
       END IF
!
!  We return (for now) one of the two error-band representatives
!  or the present best estimate, their average
       IF ( IMOD .EQ. 1 ) THEN
         P3GGA = P3ggApp1
       ELSE IF ( IMOD .EQ. 2 ) THEN
         P3GGA = P3ggApp2
       ELSE
         P3GGA = 0.5D0 * ( P3ggApp1 + P3ggApp2 )
       END IF
!
       RETURN
     END FUNCTION P3GGA
!
! ---------------------------------------------------------------------
!
! ..The singular (soft) piece of P_gg^(3).
!   Note: A4gluon is provided by a common block set in P3GGA
!
       FUNCTION P3GGB (Y, NF)
       IMPLICIT REAL*8 (A - Z)
       INTEGER nf
       COMMON / P3GSOFT / A4gluon
       !
       nf2 = nf*nf
       nf3 = nf*nf2
       !
       ! AK Added A4gluon here in case the A piece is not beign
       ! called. Should check later if this is ever the case.
       A4gluon =  40880.330D0     - 11714.246D0*nf &
            + 440.04876D0*nf2 + 7.3627750D0*nf3
       P3GGB  = A4gluon/(1.D0-Y)
       !
       RETURN
     END FUNCTION P3GGB
!
! ---------------------------------------------------------------------
!
!
! ..The 'local' piece of P_gg^(3).
!   Note: A4gluon is provided by a common block set in P3GGA
!
       FUNCTION P3GGC (Y, NF)
!
       IMPLICIT REAL*8 (A - Z)
       INTEGER nf
       COMMON / P3GSOFT / A4gluon
!
       nf2 = nf*nf
       nf3 = nf*nf2
!
!  The coefficient of delta(1-x), also called the virtual anomalous
!  dimension. nf^0 and nf^1 are still approximate, but the errors 
!  (+- 0.3 in nf^0) are too small to be relevant in this context.
!
       B4gluon =  68587.64D0        - 18143.983D0*nf &
                + 423.81135D0*nf2 + 9.0672154D-1*nf3
!
       P3GGC = LOG (1.D0-Y)* A4gluon + B4gluon
!
       RETURN
     END FUNCTION P3GGC
!
! =================================================================av==
   end module xpgg3a

#include "timing.inc"

!!!!!!!!!!!!!!!!!!!!!!!
program hoppet_unit_tests
  use types
  use unit_tests
  use test_interpolation
  use test_alphas
  use test_convolution
  use test_libome
  use io_utils
  implicit none

  if (log_val_opt("-h", .false.) .or. log_val_opt("--help", .false.)) then
    print *, "Usage: hoppet-unit-tests [-h|--help] [-time TIMING_NAME] [-list-timing]"
    print *, "  -h, --help          Print this help message"
    print *, "  -time TIMING_NAME   Run timing for the specified test (default: none)"
    print *, "                      (anything whose initial characters match TIMING_NAME will be timed)"
    print *, "  -list-timing        List all available timing names"
    print *, "  -only TEST_GROUP    Run only the specified test group(s) (substring match)"
    print *, "  -verbose            Print a message for each passed test"
    print *, "  -nloop N            Set the number of loops for hoppet startup (default: 3)"
    stop 0
  end if
  print '(a)', "Running HOPPET unit tests"
  call hoppet_setup()  
  timing_name = string_val_opt("-time","none") ! get timing name from command line
  list_timing = log_val_opt("-list-timing",.false.)
  test_only = trim(string_val_opt("-only",""))
  verbose   = log_val_opt("-verbose",.false.)

  if (.not. CheckAllArgsUsed(0)) stop 1

  call test_interpolation_coeffs()
  call test_tab_eval()
  call unit_tests_alphas()
  call test_InitGridConv()
  call test_libome_interface()

  if (unit_test_failures > 0) then
    ! print a message in red
    print '(a)', bold//red//trim(to_string(unit_test_failures))//' unit tests failed.'//reset
    stop 1
  else
    ! print a message in green
    print '(a)', bold//green//'All '//trim(to_string(unit_test_successes))//' unit tests passed.'//reset
  end if

contains

  subroutine hoppet_setup()
    use streamlined_interface
    use dglap_choices
    use pdfs_for_benchmarks

    real(dp) :: dy, ymax, dlnlnQ, Qmin, Qmax, muR_Q
    real(dp) :: asQ, Q0alphas, Q0pdf
    real(dp) :: mc,mb,mt
    integer  :: order, nloop

    order = -6
    ymax  = 12.0_dp
    dy    = 0.1_dp
    ! and parameters for Q tabulation
    Qmin=1.0_dp
    Qmax=28000.0_dp
    dlnlnQ = dy/4.0_dp
    ! and number of loops to initialise!
    nloop = int_val_opt("-nloop", 3)
    nnlo_nfthreshold_variant = nnlo_nfthreshold_exact
    call hoppetStartExtended(ymax,dy,Qmin,Qmax,dlnlnQ,nloop,&
       &         order,factscheme_MSbar)

    ! Set heavy flavour scheme
    mc = 1.414213563_dp   ! sqrt(2.0_dp) + epsilon
    mb = 4.5_dp
    mt = 175.0_dp
    call hoppetSetVFN(mc, mb, mt)

    ! Streamlined evolution
    
    ! Set parameters of running coupling
    asQ = 0.35_dp
    Q0alphas = sqrt(2.0_dp)
    muR_Q = 1.0_dp
    Q0pdf = sqrt(2.0_dp) ! The initial evolution scale
    call hoppetEvolve(asQ, Q0alphas, nloop,muR_Q, benchmark_pdf_unpolarized_lha, Q0pdf)
  end subroutine hoppet_setup


  !! a number of tests of the evaluation of the PDF tables
  !! NB: when trying to include this in test_interpolation.F90, it gave 
  !! an internal compiler error with gfortran 15.1.0
  subroutine test_tab_eval()
    use interpolation
    use interpolation_coeffs
    use pdf_tabulate
    use pdf_representation
    use streamlined_interface
    real(dp), parameter :: xvals(*) = [1e-5_dp, 0.12_dp, 0.9_dp]
    real(dp), parameter :: Qvals(*) = [1.0_dp, sqrt(2.0_dp), 3.0_dp, 7.0_dp, 100.0_dp, 700.0_dp]
    !real(dp), parameter :: xvals(*) = [1e-5_dp]
    !real(dp), parameter :: Qvals(*) = [3.0_dp]
    real(dp) :: x, Q, xpdf(iflv_min:tables(0)%tab_iflv_max), xpdff
    integer  :: iflv, ix, iQ

    if (.not. do_test("test_tab_eval")) return

    ! first check that single-flavour evaluation gives the same answer
    ! as all-flavour evaluation
    do ix = 1, size(xvals)
      x = xvals(ix)
      do iQ = 1, size(Qvals)
        Q = Qvals(iQ)
        call EvalPdfTable_xQ(tables(0), x, Q, xpdf)
        do iflv = iflv_min, iflv_max
          xpdff = EvalPdfTable_xQf(tables(0), x, Q, iflv)
          call check_approx_eq_0d("EvalPdfTable_xQf, x="//trim(to_string(x))//&
                               ", Q="//trim(to_string(Q))//", iflv="//trim(to_string(iflv)), &
                               xpdff, xpdf(iflv), tol_abs = 1e-10_dp)
        end do
      end do
    end do 

    ! Add tests that the general table-evaluation routine and the 
    ! order-specific ones agree
    block
      real(dp) :: xpdf_ord(iflv_min:tables(0)%tab_iflv_max), xpdf1D_ord(iflv_min:tables(0)%tab_iflv_max,1)
      procedure(EvalPdfTable_yQ_interface ), pointer :: EvalPdfTable_yQ_order
      procedure(EvalPdfTable_yQf_interface), pointer :: EvalPdfTable_yQf_order
      procedure(EvalPdfTable1D_yQ_interface), pointer :: EvalPdfTable1D_yQ_order
      integer, parameter :: orders(*) = [22,33,44,54,64]
      integer            :: iord, order_y, order_Q

      do iord = 1, size(orders)
        order_y = orders(iord)/10
        order_Q = mod(orders(iord),10)
        call PdfTableSetInterpPointers(order_y, order_Q, &
                  EvalPdfTable_yQ_order, EvalPdfTable_yQf_order, EvalPdfTable1D_yQ_order)
        if (     .not. associated(EvalPdfTable_yQ_order) &
            .or. .not.associated(EvalPdfTable_yQf_order)&
            .or. .not.associated(EvalPdfTable1D_yQ_order)) then
          call fail("Unsupported order "//trim(to_string(orders(iord)))//" in test_tab_eval")
          cycle
        end if

        ! this makes sure that the call below to the any_order routine takes into account
        ! the override
        call PdfTableOverrideInterpOrders(order_y, order_Q)

        do ix = 1, size(xvals)
          x = xvals(ix)
          do iQ = 1, size(Qvals)
            Q = Qvals(iQ)
            ! call the "any_order" routine to make sure we don't have the automatic
            ! bypass to one of the hard-coded routines
            call EvalPdfTable_yQ_any_order(tables(0), -log(x), Q, xpdf)
            ! then call our own pointer to a hard-coded routine
            call EvalPdfTable_yQ_order(tables(0), -log(x), Q, xpdf_ord)
            call check_approx_eq("EvalPdfTable_yQ, order="//trim(to_string(orders(iord)))//&
                                 ", x="//trim(to_string(x))//", Q="//trim(to_string(Q)), &
                                 xpdf_ord, xpdf, tol_abs = 1e-10_dp)

            call EvalPdfTable1D_yQ_order(tables(0:0), -log(x), Q, xpdf1D_ord)
            call check_approx_eq("EvalPdfTable1D_yQ, order="//trim(to_string(orders(iord)))//&
                                 ", x="//trim(to_string(x))//", Q="//trim(to_string(Q)), &
                                 xpdf1D_ord(:,1), xpdf, tol_abs = 1e-10_dp)

            ! then flavour-by-flavour
            do iflv = iflv_min, iflv_max
              xpdff = EvalPdfTable_yQf_order(tables(0), -log(x), Q, iflv)
              call check_approx_eq_0d("EvalPdfTable_yQf, order="//trim(to_string(orders(iord)))//&
                                   ", x="//trim(to_string(x))//", Q="//trim(to_string(Q))//", iflv="//trim(to_string(iflv)), &
                                   xpdf_ord(iflv), xpdff, tol_abs = 1e-10_dp)
            end do
          end do
        end do
      end do
    end block
  end subroutine test_tab_eval

end program hoppet_unit_tests

!! io_utils.f90
!!
!======================================================================
!! All the various bits and pieces which could be useful regarding i/o,
!! such as opening the right files, getting numerical values for
!! command line arguments, etc...
!======================================================================


!! some of the constants used in the io_utils module
module io_utils_consts
  integer, parameter :: max_arg_len  = 180
  integer, parameter :: max_line_len = 600
end module io_utils_consts

! for backwards compatibility
module sub_defs_io_consts
   use io_utils_consts
end module sub_defs_io_consts

!----------------------------------------------------------------------
! Interfaces to the dec f90 iargc and getarg routines
!----------------------------------------------------------------------
integer function lcl_iargc()
   implicit none
   lcl_iargc = COMMAND_ARGUMENT_COUNT()
end function lcl_iargc

subroutine lcl_getarg(k, argk)
   implicit none
   integer,      intent(in)  :: k
   character(*), intent(out) :: argk

   call GET_COMMAND_ARGUMENT(k, argk)
end subroutine lcl_getarg


subroutine lcl_flush(idev)
   implicit none
   integer, intent(in) :: idev

   flush(idev)
end subroutine lcl_flush

subroutine lcl_system(string)
   implicit none
   character(*), intent(in) :: string
   !------------------------------------------------------------
   !integer return_val, system

   call  EXECUTE_COMMAND_LINE(string)
end subroutine lcl_system



!----------------------------------------------------------------------
!! All the interfaces needed here and in the lcl_???.f90 routines
!----------------------------------------------------------------------
module io_utils
  use io_utils_consts


  interface
     subroutine open_arg(iarg, idev, ext, status, form, default_val)
       implicit none
       integer, intent(in) :: iarg, idev
       character(*), optional, intent(in) :: ext, status, form, default_val
     end subroutine open_arg
  end interface

  interface
     function idev_open_opt(opt, default_val, ext, status, form) result(idev)
       implicit none
       character(*), intent(in) :: opt
       character(*), optional, intent(in) :: default_val, ext, status, form
       integer  :: idev
     end function idev_open_opt
  end interface
  
  interface
     function idev_open_arg(iarg, ext, status, form) result(idev)
       implicit none
       integer             :: idev
       integer, intent(in) :: iarg
       character(*), optional, intent(in) :: ext, status, form
     end function idev_open_arg
  end interface

  interface
     function iargc_opt(opt)
       implicit none
       integer                      :: iargc_opt
       character(len=*), intent(in) :: opt
     end function iargc_opt
  end interface

  interface
     function command_line()
       use io_utils_consts
       implicit none
       character(len=max_line_len) ::  command_line
     end function command_line
  end interface

  interface
     function string_val_opt(opt,default_val)
       use io_utils_consts
       implicit none
       character(len=max_arg_len)             :: string_val_opt
       character(len=*), intent(in)           :: opt
       character(len=*), intent(in), optional :: default_val
     end function string_val_opt
  end interface
  
  interface
     function int_val_opt(opt,default_val)
       implicit none
       integer                      :: int_val_opt
       character(len=*), intent(in) :: opt
       integer, intent(in), optional :: default_val
     end function int_val_opt
  end interface

  interface
     function log_val_opt(opt,default_val)
       implicit none
       logical                       :: log_val_opt
       character(len=*), intent(in)  :: opt
       logical, intent(in), optional :: default_val
     end function log_val_opt
  end interface

  interface
     function dble_val_opt(opt,default_val)
       implicit none
       real(kind(1d0))                      :: dble_val_opt
       character(len=*), intent(in) :: opt
       real(kind(1d0)), intent(in), optional :: default_val
     end function dble_val_opt
  end interface

  interface
     integer function value(string)
        implicit none
        character(*),  intent(in)  ::   string
     end function value
  end interface

  interface
     integer function int_val_arg(argk, default_val)
       implicit none
       integer, intent(in)           :: argk
       integer, intent(in), optional :: default_val
     end function int_val_arg
  end interface

  interface
     real(kind(1d0)) function dble_val_arg(argk, default_val)
       implicit none
       integer,         intent(in)           :: argk
       real(kind(1d0)), intent(in), optional :: default_val
     end function dble_val_arg
  end interface

  interface
     function string_val_arg(argk, default_val)
       use io_utils_consts
       implicit none
       character(len=max_arg_len)             :: string_val_arg
       integer,          intent(in)           :: argk
       character(len=*), intent(in), optional :: default_val
     end function string_val_arg
  end interface

  interface
     real(kind(1d0)) function dble_value(string)
       implicit none
       character(*),  intent(in)  ::   string
     end function dble_value
  end interface


  interface num2char
     function int2char(num,frmt)
       implicit none
       character(len=30) :: int2char
       integer, intent(in) :: num
       character(*), intent(in), optional :: frmt
     end function int2char
     function sp2char(num,frmt)
       implicit none
       character(len=30) :: sp2char
       real(kind(1.0)), intent(in) :: num
       character(*), intent(in), optional :: frmt
     end function sp2char
     function dp2char(num,frmt)
       implicit none
       character(len=30) :: dp2char
       real(kind(1d0)), intent(in) :: num
       character(*), intent(in), optional :: frmt
     end function dp2char
  end interface
  

  interface
     function get_new_device() result(dev)
       implicit none
       integer :: dev
     end function get_new_device
  end interface
  
  interface
     subroutine time_stamp(idev, string)
       implicit none
       integer,          intent(in),  optional :: idev
       character(len=*), intent(out), optional :: string
     end subroutine time_stamp
  end interface
  
  interface
     subroutine error_report(subname,line1,line2,line3,line4,action)
       implicit none
       character(*), intent(in) :: subname
       character(*), intent(in), optional :: line1, line2, line3, line4
       character(*), intent(in), optional :: action
     end subroutine error_report
  end interface
       
       
   !==================================================================
   ! ====
   ! Interfaces to the standard routines which provide the links to
   ! platform dependent calls
   !======================================================================

  interface
     subroutine lcl_write_2d(idev, array)
       implicit none
       integer,         intent(in) :: idev
       real(kind(1d0)), intent(in) :: array(1:, 1:)
     end subroutine lcl_write_2d
  end interface

  interface
     subroutine lcl_read_2d(idev, array, ifail)
       implicit none
       integer,           intent(in)  :: idev
       real(kind(1d0)),   intent(out) :: array(1:, 1:)
       integer, optional, intent(out) :: ifail
     end subroutine lcl_read_2d
  end interface

  interface
     integer function lcl_iargc()
     end function lcl_iargc
  end interface

  interface
     subroutine lcl_getarg(k, argk)
       implicit none
       integer,      intent(in)  :: k
       character(*), intent(out) :: argk
     end subroutine lcl_getarg
  end interface

  interface
     subroutine lcl_flush(idev)
       implicit none
       integer, intent(in) :: idev
     end subroutine lcl_flush
  end interface

  
  interface  
     function CheckAllArgsUsed(ErrDev) result(check)
       logical :: check
       integer, optional :: ErrDev
     end function CheckAllArgsUsed
  end interface
  interface  
     function CheckAllOptsUsed(ErrDev) result(check)
       logical :: check
       integer, optional :: ErrDev
     end function CheckAllOptsUsed
  end interface
  
contains
   
  !! sets hostname to the name of the machine (up to a max of 255 or the length
  !! of the string, whichever is smaller)
  !!
  !! Based in part on code at https://rosettacode.org/wiki/Hostname#Fortran
  subroutine get_hostname(hostname)
    use, intrinsic  :: iso_c_binding
    implicit none
    character(len=*), intent(out) :: hostname
    !------------
    interface !to function: int gethostname(char *name, size_t namelen);
    integer(c_int) function gethostname(name, namelen) bind(c)
       use, intrinsic  :: iso_c_binding, only: c_char, c_int, c_size_t
       integer(c_size_t), value, intent(in) :: namelen
       character(len=1,kind=c_char), dimension(namelen),  intent(inout) ::  name
    end function gethostname
    end interface    
    integer(c_int) :: status
    integer,parameter :: HOST_NAME_MAX=255
    character(kind=c_char,len=1),dimension(HOST_NAME_MAX) :: cstr_hostname
    integer(c_size_t) :: lenstr
    integer :: i

    lenstr = HOST_NAME_MAX
    status = gethostname(cstr_hostname, lenstr)
    
    if (status /= 0) then
       write(0,*) 'Error in get_hostname: gethostname returned ',status
       hostname = "hostname_error"
       return
    end if

    do i = 1, len(hostname)
       hostname(i:i) = " "
    end do
    do i = 1, HOST_NAME_MAX
       if (i > lenstr .or. cstr_hostname(i) == c_null_char) exit
       hostname(i:i) = cstr_hostname(i)
    end do

  end subroutine get_hostname
end module io_utils


!--------------------------------------------------------------
!! When an argument is used register the fact here. Then at the
!! end of program initialisation one can check to see whether all
!! arguments have been used
module track_args
  ! putting the "only" here ensures that this compiles under intel 7.1
  ! (not immediately clear why, though it could be related to fact
  ! that interface CheckAllArgsUsed is being used, but that the 
  ! corresponding subroutine uses track_args?)
  use io_utils, only: lcl_iargc, lcl_getarg
  use io_utils_consts
  implicit none
  private
  logical, allocatable, save :: argsused(:)
  logical, save :: started = .false.
  integer, save :: narg
  character(len=*), parameter :: sep = &
       &'=============================================================='

  public :: ta_RegisterUsed, ta_CheckAllArgsUsed, ta_CheckAllOptsUsed

contains

  !----------------------------------------------------------------------
  ! registers the fact that argument number iarg has been used
  subroutine ta_RegisterUsed(iarg)
    integer, intent(in)  :: iarg
    
    call ta_TrackingOn() 

    if (iarg > narg .or. iarg < 1) then
       write(0,*) 'In ta_RegisterUsed tried to set illegal arg', iarg
       stop
    end if
    argsused(iarg) = .true.
  end subroutine ta_RegisterUsed

  !----------------------------------------------------------------------
  ! makes sure that tracking of argument usage is turned on
  subroutine ta_TrackingOn()
    if (.not. started) then
       narg = lcl_iargc()
       allocate(argsused(narg))
       argsused = .false.
       started = .true.
    end if
  end subroutine ta_TrackingOn
  
  
  !--------------------------------------------------------
  !! ErrDev = device to which one should send the list of 
  !! unused args
  function ta_CheckAllOptsUsed(ErrDev) result(check)
    logical :: check
    integer, optional :: ErrDev
    integer :: i
    character(len=max_arg_len) :: argi
    logical :: writeit

    call ta_TrackingOn() 

    check = .true.
    writeit = present(ErrDev)
    do i = 1, narg
       if (argsused(i)) cycle
       call lcl_getarg(i, argi)
       if (argi(1:1) == "-") then
          if (check .and. writeit) then
             write(ErrDev,*) sep
             write(ErrDev,*) &
                  &'WARNING / ERROR: the following options were not recognized'
          end if
          check = .false.
          if(writeit) write(ErrDev,*) trim(argi)
       end if
    end do
    if ((.not. check) .and. writeit ) write(ErrDev,*) sep
  end function ta_CheckAllOptsUsed


  !--------------------------------------------------------
  !! ErrDev = device to which one should send the list of 
  !! unused args
  function ta_CheckAllArgsUsed(ErrDev) result(check)
    logical :: check
    integer, optional :: ErrDev
    integer :: i
    character(len=max_arg_len) :: argi

    call ta_TrackingOn() 

    if (narg > 0 ) then 
       check = all(argsused)
    else
       check = .true. 
       return
    end if
    if ((.not. check) .and. present(ErrDev)) then
       write(ErrDev,*) sep
       write(ErrDev,*) &
            &'WARNING / ERROR: the following args were not recognized'
       do i = 1, narg 
          if (.not. argsused(i)) then
             call lcl_getarg(i, argi)
             write(ErrDev,*) trim(argi)
          end if
       end do
       write(ErrDev,*) sep
    end if
  end function ta_CheckAllArgsUsed
  
  
end module track_args




!--------------------------------------------------------
!! ErrDev = device to which one should send the list of 
!! unused args
function CheckAllArgsUsed(ErrDev) result(check)
  use track_args
  logical :: check
  integer, optional :: ErrDev
  check = ta_CheckAllArgsUsed(ErrDev)
end function CheckAllArgsUsed
function CheckAllOptsUsed(ErrDev) result(check)
  use track_args
  logical :: check
  integer, optional :: ErrDev
  check = ta_CheckAllOptsUsed(ErrDev)
end function CheckAllOptsUsed


!----------------------------------------------------------------------
!! As open_arg -- except that it automatically allocates and returns a
!! device number
!----------------------------------------------------------------------
function idev_open_arg(iarg, ext, status, form) result(idev)
  use io_utils, except => idev_open_arg
  implicit none
  integer             :: idev
  integer, intent(in) :: iarg
  character(*), optional, intent(in) :: ext, status, form
  !--------------------------------------------------------------------
  idev = get_new_device()
  call open_arg(iarg, idev, ext, status, form)
end function idev_open_arg


!---------------------------------------------------------------------
!! Open file indicated by command line option and return the 
!! device number.
!!
!! GPS 05/01/01
!---------------------------------------------------------------------
function idev_open_opt(opt, default_val, ext, status, form) result(idev)
  use io_utils, except => idev_open_opt
  implicit none
  character(*), intent(in) :: opt
  character(*), optional, intent(in) :: default_val, ext, status, form
  integer  :: idev, iarg
  !--------------------------------------------------------------------
  idev = get_new_device()
  iarg = iargc_opt(opt) + 1 ! will return -100 if opt is not present
  if (iarg < 0) then
     write(0,*) 'ERROR in idev_open_opt:'
     write(0,*) 'command-line option "'//opt//'" missing'
     stop
  end if
  call open_arg(iarg, idev, ext, status, form, default_val)
end function idev_open_opt


!----------------------------------------------------------------------
!! Open file corresponding the name in command line argument 'iarg'
!! 
!! GPS 20/03/97
!----------------------------------------------------------------------
subroutine open_arg(iarg, idev, ext, status, form, default_val)
  use io_utils, only : lcl_getarg, lcl_iargc, max_arg_len, time_stamp
  use track_args
  implicit none
  integer, intent(in) :: iarg, idev
  character(*), optional, intent(in) :: ext, status, form, default_val
  !----------------------------------------------------------------------
  character(len=max_arg_len) :: arg
  integer       :: l, le
  
  l = lcl_iargc()
  if (iarg > l .or. iarg < 0) then
     if (present(default_val)) then
        arg = trim(default_val)
     else
        write(0,*) 'Number of args is',l
        write(0,*) 'Could not open file corresponding to arg',iarg
        write(0,*) 'because that arg does not exist'
        call time_stamp(0)
        write(0,*) 'stop'
        stop
     end if
  else
     call lcl_getarg(iarg, arg)
     call ta_RegisterUsed(iarg)
  end if
  
  l = index(arg,' ') - 1
  if (present(ext)) then
     le = index(ext,' ') - 1
     if (le <= 0) le = len(ext)
     arg(l+1:l+le) = ext(1:le)
     l = l + le
  end if
  !-- the following stupid sequence should not be necessary, but the
  ! standard doesn't specify open as having `optional args'
  if (present(status)) then
     if (present(form)) then
        open(unit=idev,file=arg(1:l),status=status,form=form)
     else
        open(unit=idev,file=arg(1:l),status=status)
     end if
  else
     if (present(form)) then
        open(unit=idev,file=arg(1:l),form=form)
     else
        open(unit=idev,file=arg(1:l))
     end if
  end if

end subroutine open_arg


!----------------------------------------------------------------------
!! It can often be useful to have a record of the command line -- this 
!! returns a string which conatins the command name and all the arguments
!----------------------------------------------------------------------
function command_line()
  use io_utils, except => command_line
  implicit none
  character(len=max_line_len) ::  command_line
  !----------------------------------------------------------------------
  character(len=max_arg_len) :: string
  integer :: i, n

  n = lcl_iargc()
  call lcl_getarg(0,command_line)
  do i = 1, n
     call lcl_getarg(i,string)
     command_line = trim(command_line)//' '//trim(string)
  end do
end function command_line

!----------------------------------------------------------------------
!! Return the index of the argument which matches the string opt -- 
!! Intended to be used to get hold of the presence of an option, and/or
!! to locate an option so that one can extract values that follow it
!!
!! Trailing spaces are ignored.
!!
!! Returns a negative number if the option is not found.
!!
!! GPS 24/01/98 
!----------------------------------------------------------------------
function iargc_opt(opt)
  use io_utils, except => iargc_opt
  use track_args
  implicit none
  integer                      :: iargc_opt
  character(len=*), intent(in) :: opt
  !------------------------------------------------------------
  integer :: i, n
  character(len=max_arg_len) :: string

  n = lcl_iargc()
  do i = 1, n
     call lcl_getarg(i,string)
     if (trim(string) == trim(opt)) exit
  end do
  ! Check to see if argument found
  if (i > n) then
     !-- make sure that iargc_opt + reasonable number remains negative
     iargc_opt = -100
  else
     iargc_opt = i
     call ta_RegisterUsed(iargc_opt)
  end if
end function iargc_opt



!----------------------------------------------------------------------
!! Return the string value corresponding to the argument which follows
!! the command line option opt
!!
!! GPS 8/11/95 (CCN8 23)
!----------------------------------------------------------------------
function string_val_opt(opt,default_val)
  use io_utils, except => string_val_opt
  use track_args
  implicit none
  character(len=max_arg_len)             :: string_val_opt
  character(len=*), intent(in)           :: opt
  character(len=*), intent(in), optional :: default_val
  integer :: i,n
  i = iargc_opt(opt)
  n = lcl_iargc()
  if (i >= n .or. i < 0) then
     if (present(default_val)) then
        string_val_opt = default_val
     else
        write(0,*) 'String value for option ',trim(opt),' has been&
             & requested'
        write(0,*) 'but that option is not present, and no default value&
             & was provided'
        stop
     end if
  else
     call lcl_getarg(i+1,string_val_opt)
     call ta_RegisterUsed(i+1)
  end if
end function string_val_opt

!----------------------------------------------------------------------
!! Return the integer value corresponding to the argument which follows
!! the command line option opt
!!
!! GPS 8/11/95 (CCN8 23)
!----------------------------------------------------------------------
function int_val_opt(opt,default_val)
  use io_utils, except => int_val_opt
  implicit none
  integer                      :: int_val_opt
  character(len=*), intent(in) :: opt
  integer, intent(in), optional :: default_val
  !----------------------------------------------------------------------
  integer :: i, n

  i = iargc_opt(opt)
  n = lcl_iargc()
  if (i >= n .or. i < 0) then
     if (present(default_val)) then
        int_val_opt = default_val
     else
        write(0,*) 'Numerical value for option ',trim(opt),' has been&
             & requested'
        write(0,*) 'but that option is not present, and no default value&
             & was provided'
        stop
     end if
  else
     int_val_opt = int_val_arg(i+1,default_val)
  end if
end function int_val_opt
!----------------------------------------------------------------------
!! Similar to int_val_opt, but for dble value
!----------------------------------------------------------------------
function dble_val_opt(opt,default_val)
  use io_utils, except => dble_val_opt
  implicit none
  real(kind(1d0))                      :: dble_val_opt
  character(len=*), intent(in) :: opt
  real(kind(1d0)), intent(in), optional :: default_val
  !----------------------------------------------------------------------
  integer :: i, n

  i = iargc_opt(opt)
  n = lcl_iargc()
  if (i >= n .or. i < 0) then
     if (present(default_val)) then
        dble_val_opt = default_val
     else
        write(0,*) 'Numerical value for option ',trim(opt),' has been&
             & requested'
        write(0,*) 'but that option is not present, and no default value&
             & was provided'
        stop
     end if
  else
     dble_val_opt = dble_val_arg(i+1,default_val)
  end if
end function dble_val_opt
!----------------------------------------------------------------------
!! Say opt is -xxx: if -xxx is present on the command line, then
!! return true; if -noxxx is present on the command line, then return false.
!! If neither is present on the command line, then return default_val,
!! which therefore is not optional. If both arguments are present, then
!! return default val.
!!
!! GPS 8/11/95 (CCN8 23)
!----------------------------------------------------------------------
function log_val_opt(opt,default_val)
  use io_utils, except => log_val_opt
  implicit none
  logical                       :: log_val_opt
  character(len=*), intent(in)  :: opt
  logical, intent(in), optional :: default_val
  !----------------------------------------------------------------------
  character(len=30) :: noopt
  integer :: i, j

  i = len_trim(opt)
  noopt = opt(1:1)//'no'//opt(2:i)

  i = iargc_opt(trim(opt))
  j = iargc_opt(trim(noopt))
  
  if (i > 0 .neqv. j > 0) then
     log_val_opt = (i>0)
  else
     if (present(default_val)) then
        log_val_opt = default_val
     else
        log_val_opt = .false.
     end if
  end if
end function log_val_opt

  
!----------------------------------------------------------------------
!! Return the integer value corresponding to the argk^th command line
!! argument. If # args < argk then use default if it is present, otherwise
!! output an error message and stop
!!
!! GPS 8/11/95 (CCN8 23)
!----------------------------------------------------------------------
integer function int_val_arg(argk, default_val)
  use track_args
  use io_utils, except => int_val_arg
  implicit none
  integer, intent(in)           :: argk
  integer, intent(in), optional :: default_val
  !------------------------------------------------------------
  integer             :: i
  character(len=max_arg_len) string

  i = lcl_iargc()
  if (i < argk .or. argk < 0) then
     if (present(default_val)) then
        int_val_arg = default_val
        return
     else
        write(0,*) 'Numerical value of arg',argk,' has been requested'
        write(0,*) 'but only',i,' args present, and no default value&
             & was provided'
        stop
     end if
  end if

  call lcl_getarg(argk, string)
  call ta_RegisterUsed(argk)
  if (trim(string) == '-' .and. present(default_val)) then
     int_val_arg = default_val
  else
     int_val_arg = value(string)
  end if

end function int_val_arg

      
!======================================================================
!! Routine to convert string into an integer
!! Added ability to cope with negative numbers
!! GPS 30/11/94+13/11/96
!======================================================================

integer function value(string)
      implicit none
      character(*),  intent(in)  ::   string
      !----------------------------------------------------------------
      character(11), parameter   ::  template = '0123456789-'
      character  ::  current
      integer    ::  i, j, sgn
      logical    ::  number_started

      value          = 0
      sgn = 1
      number_started = .false.

loop: do i = 1, len(string)
         current = string(i:i)
         j = index(template, current)
         if (j == 11) then
            if (number_started) then
               write(0,*) string(1:len(string)), ' is an invalid number'
               write(0,*) 'Stop.'
               stop
            end if
            sgn = -1
            number_started = .true.
            cycle
         end if
         if (j /= 0) number_started = .true.
         if (number_started) then
            if (j == 0) exit
            value = value * 10 + (j-1)
         endif
      end do loop
      value = value * sgn
end function value

!----------------------------------------------------------------------
!! Return the dble value corresponding to the argk^th command line
!! argument. If # args < argk then use default if it is present, otherwise
!! output an error message and stop
!!
!! GPS 8/11/95 (CCN8 23)
!----------------------------------------------------------------------
real(kind(1d0)) function dble_val_arg(argk, default_val)
  use track_args
  use io_utils, except => dble_val_arg
  implicit none
  integer,         intent(in)           :: argk
  real(kind(1d0)), intent(in), optional :: default_val
  !------------------------------------------------------------
  integer             :: i
  character(80) string

  i = lcl_iargc()
  if (i < argk .or. argk < 0) then
     if (present(default_val)) then
        dble_val_arg = default_val
        return
     else
        write(0,*) 'Numerical value of arg',argk,' has been requested'
        write(0,*) 'but only',i,' args present, and no default value&
             & was provided'
        stop
     end if
  end if

  call lcl_getarg(argk, string)
  call ta_RegisterUsed(argk)
  if (trim(string) == '-' .and. present(default_val)) then
     dble_val_arg = default_val
  else
     dble_val_arg = dble_value(string)
  end if
end function dble_val_arg


!---------------------------------------------------------------
!! returns the string corresponding to argument argk.
!! If that argument is absent, return the default_val (if provided)
function string_val_arg(argk, default_val)
  use track_args
  use io_utils, except => string_val_arg
  implicit none
  character(len=max_arg_len)             :: string_val_arg
  integer,          intent(in)           :: argk
  character(len=*), intent(in), optional :: default_val
  integer             :: i

  i = lcl_iargc()
  if (i < argk .or. argk < 0) then
     if (present(default_val)) then
        string_val_arg = trim(default_val)
        return
     else
        write(0,*) 'String value of arg',argk,' has been requested'
        write(0,*) 'but only',i,' args present, and no default value&
             & was provided'
        stop
     end if
  end if
  
  call lcl_getarg(argk, string_val_arg)
  call ta_RegisterUsed(argk)
end function string_val_arg
     

!======================================================================
!! Routine to convert string into an float
!! Added ability to cope with negative numbers. Cannot cope with
!! scientific notation or other such fancy things.
!!
!! Actually: current version just does a read on the string...
!!
!! GPS 30/11/94+13/11/96+18/11/96
!======================================================================
real(kind(1d0)) function dble_value(string)
      implicit none
      character(*),  intent(in)  ::   string
      !----------------------------------------------------------------
      character(12), parameter   ::  template = '0123456789-.'
      character  ::  current
      integer    ::  i, j, sgn
      logical    ::  number_started, dpoint
      real(kind(1d0)) :: jfact, pfact

      read(string,*) dble_value
      return
      !-- default sign is positive
      sgn = 1

      number_started = .false.
      dpoint = .false.
      dble_value          = 0
      jfact = 1d0
      pfact = 10d0

loop: do i = 1, len(string)
         current = string(i:i)
         j = index(template, current)
         if (j == 11) then
            if (number_started) call invalid_number
             sgn = -1
            number_started = .true.
            cycle
         end if
         if (j /= 0) number_started = .true.
         if (number_started) then
            if (j == 0) exit
            if (j == 12) then 
               if (dpoint) call invalid_number
               dpoint = .true.
               pfact = 1d0
               cycle
            end if
            if (dpoint) jfact = jfact * 0.1d0
            dble_value = dble_value * pfact + (j-1) * jfact
         endif
      end do loop
      dble_value = dble_value * sgn
contains

  subroutine invalid_number
    write(0,*) string(1:len(string)), ' is an invalid number'
    write(0,*) 'Stop.'
    stop
  end subroutine invalid_number
  
end function dble_value

!----------------------------------------------------------------------
!! A set of routines for converting a number to a string, with optional
!! format specifier. 
function int2char(num,frmt)
  implicit none
  character(len=30) :: int2char
  integer, intent(in) :: num
  character(*), intent(in), optional :: frmt
  if (present(frmt)) then
     write(int2char,frmt) num
  else
     write(int2char,*) num
  end if
  int2char = adjustl(int2char)
end function int2char
function sp2char(num,frmt)
  implicit none
  character(len=30) :: sp2char
  real(kind(1.0)), intent(in) :: num
  character(*), intent(in), optional :: frmt
  if (present(frmt)) then
     write(sp2char,frmt) num
  else
     write(sp2char,*) num
  end if
  sp2char = adjustl(sp2char)
end function sp2char
function dp2char(num,frmt)
  implicit none
  character(len=30) :: dp2char
  real(kind(1d0)), intent(in) :: num
  character(*), intent(in), optional :: frmt
  if (present(frmt)) then
     write(dp2char,frmt) num
  else
     write(dp2char,*) num
  end if
  dp2char = adjustl(dp2char)
end function dp2char


!======================================================================
!! Returns a new device if any are available, or else causes an error
!! dump
!!
!! GPS 13/04/98
!======================================================================
function get_new_device() result(dev)
  use io_utils, except => get_new_device
  implicit none
  integer :: dev
  !--------------------------------------------------------------
  integer, parameter :: dev_low = 30
  logical :: exist, opened
  integer :: iostat
  character(len=*), parameter :: subname='get_new_device'

  dev = dev_low
  do
     inquire(unit=dev,iostat=iostat, exist=exist, opened=opened)
     if (iostat /= 0) call error_report(subname, 'iostat non zero')
     if (.not. exist) call error_report(subname, 'available devices exhausted')
     if (.not. opened) exit
     dev = dev + 1 
  end do

end function get_new_device


!==========================================================================
!! Routine to write `time stamp' to a given output device (idev). The stamp
!! also contains the name of the program that generates it (taken from arg0)
!!
!! GPS 4/12/96
!==========================================================================
subroutine time_stamp(idev,string)
  use io_utils, excepts => time_stamp
  implicit none
  integer,          intent(in),  optional :: idev
  character(len=*), intent(out), optional :: string
  !----------------------------------------------------------------------
  character(79) :: prog_name
  integer       :: time(8)
  
  call lcl_getarg(0,prog_name)
  call date_and_time(values=time)
  if (present(idev)) then
     !write(idev,15) prog_name(1:index(prog_name,' ')-1),&
     !     & time(3),time(2),time(1),time(5),time(6),time(7)
     write(idev,15) trim(prog_name),&
          & time(3),time(2),time(1),time(5),time(6),time(7)
  end if
  if (present(string)) then
     !write(string,15) prog_name(1:index(prog_name,' ')-1),&
     !     & time(3),time(2),time(1),time(5),time(6),time(7)
     write(string,15) trim(prog_name),&
          & time(3),time(2),time(1),time(5),time(6),time(7)
  end if
  
15 format('Stamped by ',a,' on ',i2,'/',i2.2,'/',i4.4,' at ',i2.2,':'&
        & ,i2.2 ,':',i2.2) 
  call lcl_flush(idev)
end subroutine time_stamp

!======================================================================
!! Standard error reporting routine. Writes error to
!! stderr and then does one of the following (specified by contents of
!! "action")
!!
!!  core
!!  stop
!!  cont
!!
!! Default action is currently defined below, but maybe its definition
!! should be moved to a globally accessible location.
!!
!! GPS 19/08/97
!======================================================================
subroutine error_report(subname,line1,line2,line3,line4,action)
  use io_utils, excepts => error_report; implicit none
  character(*), intent(in) :: subname
  character(*), intent(in), optional :: line1, line2, line3, line4
  character(*), intent(in), optional :: action
  !--------------------------------------------------------------------
  character(*), parameter :: default_action = 'core'
  character(10) :: laction
  real :: a, b
  
  if (present(action)) then
     laction = trim(action)
  else
     laction = default_action
  end if

  write(0,*)
  write(0,'(2a)') 'Error report from routine: ',subname
  write(0,*)
  if (present(line1)) then
     write(0,'(a)') 'Reason is:'
     write(0,'(a)') line1
  end if
  if (present(line2)) write(0,'(a)') line2
  if (present(line3)) write(0,'(a)') line3
  if (present(line4)) write(0,'(a)') line4
  write(0,*)
  call time_stamp(0)
  !------ allow for more information on exit.
  if (trim(laction) == 'core') then
     a = 1d0; b = 1d0
     write(0,'(a)') 'Error report routine is about to dump core'
     write(0,*)
     write(0,*) 1d0/sqrt(a-b)
     !-- just in case that did not work, do an explicit stop
     stop
  else if (trim(laction) /= 'cont') then
     write(0,'(a)') 'Program stopped'
     stop
  else
     write(0,'(a)') 'Execution continuing'
  end if
end subroutine error_report

!! alternative name to access to the sub_defs_io module,
!! so as to match this filename
module sub_defs_io
  use io_utils
  implicit none
end module sub_defs_io

!! A program that can be used to produce the results presented for
!! n3lo evolution in the v130 manual.
program tabulation_n3lo
  use io_utils, int_value => value
  !! if using LHAPDF, rename a couple of hoppet functions which
  !! would otherwise conflict with LHAPDF 
     use hoppet, EvolvePDF_hoppet => EvolvePDF, InitPDF_hoppet => InitPDF
  use streamlined_interface, HoppetInitPDF => initPDF
  use hoppet_git_state
  implicit none
  real(dp) :: dy, ymax, dlnlnQ
  integer  :: order, nloop
  real(dp) :: quark_masses(4:6)
  !! hold the initial pdf
  real(dp), pointer :: pdf0(:,:)
  real(dp) :: Q0
  !! hold results at some x, Q
  real(dp) :: Q, pdf_at_xQ(-6:6)
  real(dp), parameter :: heralhc_xvals(11) = &
       & (/1e-7_dp, 1e-6_dp, 1e-5_dp,1e-4_dp,1e-3_dp,1e-2_dp,0.1_dp,0.3_dp,0.5_dp,0.7_dp,0.9_dp/)
  integer  :: i, ix
  real(dp) :: x
  integer :: idev, n3lo_split_approx, n3lo_vfns_on, scheme
  character(200)   pdfname
  real(dp) :: mc, mb, mt, asQ0, QMin, Qmax, xmu, lhapdf_qmin, Qevolve
  double precision alphasPDF, hoppetAlphas
  external         evolvePDF, alphasPDF
  
  ! Get output and pdf name here
  idev = idev_open_opt("-o","")
  pdfname = string_val_opt("-pdf","toyHERA")
  write(idev,'(a,a)') "# ", trim(command_line())
  call hoppet_print_git_state(idev,prefix="# ")
    
  ! set up parameters for grid
  Qmin  = dble_val_opt("-Qmin",1.0_dp)  ! smallest Q value in tabulation
  Qmax  = 1d4       ! largest Q value in tabulation
  order  = int_val_opt("-order",-6) ! numerical interpolation order (-6 is a good choice) 
  ymax   = dble_val_opt("-ymax",17.0_dp) ! max value of ln 1/x
  dy     = dble_val_opt("-dy",0.05_dp) ! the internal grid spacing (smaller->higher accuarcy)
  dlnlnQ = dble_val_opt("-dlnlnQ",dy/8.0_dp) ! tabulation spacing in dlnlnQ (dy/4 recommended) 
  scheme = 1 ! 1=unpol-MSbar, 2=unpol-DIS, 3=Pol-MSbar
  Qevolve = dble_val_opt("-Qevolve",100.0_dp)
  ! Determine evolution order
  nloop = int_val_opt("-nloop",4) ! 1; LO, 2; NLO, 3; NNLO; 4; N3LO
  n3lo_split_approx = int_val_opt("-n3lo-split-approx",2) ! 0: n3lo_splitting_approximation_up_to_2310_05744
                                                          ! 1: n3lo_splitting_approximation_up_to_2404_09701
                                                          ! 2: n3lo_splitting_approximation_up_to_2410_08089
                                                          ! see dglap_choices.f90 for details
  n3lo_vfns_on = int_val_opt("-n3lo-vfns-on",1) ! 1: on, 0: off
  call dglap_Set_n3lo_splitting_approximation(n3lo_split_approx)
  call dglap_Set_nnlo_nfthreshold(nnlo_nfthreshold_exact) ! Exact nnlo thresholds
  call dglap_Set_n3lo_nfthreshold(n3lo_vfns_on) ! To turn on/off the n3lo mass thresholds
  xmu = 1.0_dp ! Renormlization scale
  call hoppetStartExtended(ymax,dy,Qmin,Qmax,dlnlnQ,nloop,order,scheme)
  write(6,'(a)') "Hoppet grid setup done!"

  call AllocPDF(grid, pdf0)
  if(trim(pdfname).eq."toyHERA") then
     mc = 1.414213563_dp
     mb = 4.5_dp
     mt = 175.0_dp
     ! initialise a PDF from the function below (must be contained,
     ! in a "used" module, or with an explicitly defined interface)
     pdf0 = unpolarized_dummy_pdf(xValues(grid))
     Q0 = dble_val_opt("-Q0",sqrt(2.0_dp))  ! the initial scale
     asQ0 = dble_val_opt("-asQ0",0.35_dp) ! alphas at Q0
  else
     call InitPDFsetByName(pdfname)
     call InitPDF(0)

     ! Retrieve starting scale and coupling from LHAPDF, and also the
     ! quark masses
     call getQ2min(0,lhapdf_qmin)
     lhapdf_qmin = sqrt(lhapdf_qmin)
     Q0 = dble_val_opt("-Q0",lhapdf_qmin)
     asQ0 = alphasPDF(Q0)
     call getthreshold(4,mc)
     call getthreshold(5,mb)
     call getthreshold(6,mt)
     call InitPDF_LHAPDF(grid, pdf0, evolvePDF, Q0)
  endif

  if (.not.CheckAllArgsUsed(0)) then
     call exit()
  endif

    
  call hoppetSetPoleMassVFN(mc,mb,mt)
  quark_masses(4:6) = (/mc,mb,mt/)
  call InitRunningCoupling(coupling,alfas=asQ0,Q=Q0,nloop=nloop,&
       &                   quark_masses = quark_masses)
  call AddNfInfoToPdfTable(tables,coupling)
  coupling_initialised = .true.
  write(6,'(a)') "Coupling initialised!"
  write(6,'(a,f7.4,a,f7.4,a,f7.3,f7.3,f9.3)') "Q0 = ", Q0, ", αS(Q0) = ", asQ0, ", (mc,mb,mt) = ", quark_masses
  write(idev,'(a,f8.4,a,f7.4,a,f7.3,f7.3,f9.3)') "# Q0 = ", Q0, ", αS(Q0) = ", asQ0, ", (mc,mb,mt) = ", quark_masses
  write(6,'(a,f7.4)') "Hoppet αS(Q0) = ", hoppetAlphas(Q0)
! create the tabulation based on the evolution of pdf0 from scale Q0
  call EvolvePdfTable(tables(0), Q0, pdf0, dh, coupling, nloop=nloop)
  
    
  write(6,'(a)') "Evolution done!"

  ! get the value of the tabulation at some point
  Q = Q0
  write(6,'(a)')
  write(6,'(a,f10.5,a)') "                                   Evaluating PDFs at Q = ",Q," GeV"
  write(6,'(a5,3a12,a14,3a11,a12)') "x",&
       & "u-ubar","d-dbar","dbr-ubr","2(ubr+dbr)","s+sbar","c+cbar","b+bbar","gluon"
  do ix = 1, size(heralhc_xvals)
     call EvalPdfTable_xQ(tables(0),heralhc_xvals(ix),Q,pdf_at_xQ)
     write(6,'(es7.1,8es12.4)') heralhc_xvals(ix), &
          &  pdf_at_xQ(2)-pdf_at_xQ(-2), &
          &  pdf_at_xQ(1)-pdf_at_xQ(-1), &
          &  (pdf_at_xQ(-1)-pdf_at_xQ(-2)), &
          &  2*(pdf_at_xQ(-1)+pdf_at_xQ(-2)), &
          &  (pdf_at_xQ(-3)+pdf_at_xQ(3)), &
          &  (pdf_at_xQ(-4)+pdf_at_xQ(4)), &
          &  (pdf_at_xQ(-5)+pdf_at_xQ(5)), &
          &  pdf_at_xQ(0)
  end do

  if(trim(pdfname).ne."toyHERA") then
     ! get the value of the tabulation at some point
     Q = Q0
     write(6,'(a)')
     write(6,'(a,f10.5,a)') "                                   LHAPDF interpolation at Q = ",Q," GeV"
     write(6,'(a5,3a12,a14,3a11,a12)') "x",&
          & "u-ubar","d-dbar","dbr-ubr","2(ubr+dbr)","s+sbar","c+cbar","b+bbar","gluon"
     do ix = 1, size(heralhc_xvals)
        call evolvePDF(heralhc_xvals(ix),Q,pdf_at_xQ)
        write(6,'(es7.1,8es12.4)') heralhc_xvals(ix), &
             &  pdf_at_xQ(2)-pdf_at_xQ(-2), &
             &  pdf_at_xQ(1)-pdf_at_xQ(-1), &
             &  (pdf_at_xQ(-1)-pdf_at_xQ(-2)), &
             &  2*(pdf_at_xQ(-1)+pdf_at_xQ(-2)), &
             &  (pdf_at_xQ(-3)+pdf_at_xQ(3)), &
             &  (pdf_at_xQ(-4)+pdf_at_xQ(4)), &
             &  (pdf_at_xQ(-5)+pdf_at_xQ(5)), &
             &  pdf_at_xQ(0)
     end do
  end if

  ! get the value of the tabulation at some point
  Q = Qevolve
  write(6,'(a)')
  write(6,'(a,f10.5,a)') "                                   Evaluating PDFs at Q = ",Q," GeV"
  write(6,'(a5,3a12,a14,3a11,a12)') "x",&
       & "u-ubar","d-dbar","dbr-ubr","2(ubr+dbr)","s+sbar","c+cbar","b+bbar","gluon"
  do ix = 1, size(heralhc_xvals)
     call EvalPdfTable_xQ(tables(0),heralhc_xvals(ix),Q,pdf_at_xQ)
     write(6,'(es7.1,8es12.4)') heralhc_xvals(ix), &
          &  pdf_at_xQ(2)-pdf_at_xQ(-2), &
          &  pdf_at_xQ(1)-pdf_at_xQ(-1), &
          &  (pdf_at_xQ(-1)-pdf_at_xQ(-2)), &
          &  2*(pdf_at_xQ(-1)+pdf_at_xQ(-2)), &
          &  (pdf_at_xQ(-3)+pdf_at_xQ(3)), &
          &  (pdf_at_xQ(-4)+pdf_at_xQ(4)), &
          &  (pdf_at_xQ(-5)+pdf_at_xQ(5)), &
          &  pdf_at_xQ(0)
  end do

  if(trim(pdfname).ne."toyHERA") then
     ! get the value of the tabulation at some point
     Q = Qevolve
     write(6,'(a)')
     write(6,'(a,f10.5,a)') "                                   LHAPDF interpolation at Q = ",Q," GeV"
     write(6,'(a5,3a12,a14,3a11,a12)') "x",&
          & "u-ubar","d-dbar","dbr-ubr","2(ubr+dbr)","s+sbar","c+cbar","b+bbar","gluon"
     do ix = 1, size(heralhc_xvals)
        call evolvePDF(heralhc_xvals(ix),Q,pdf_at_xQ)
        write(6,'(es7.1,8es12.4)') heralhc_xvals(ix), &
             &  pdf_at_xQ(2)-pdf_at_xQ(-2), &
             &  pdf_at_xQ(1)-pdf_at_xQ(-1), &
             &  (pdf_at_xQ(-1)-pdf_at_xQ(-2)), &
             &  2*(pdf_at_xQ(-1)+pdf_at_xQ(-2)), &
             &  (pdf_at_xQ(-3)+pdf_at_xQ(3)), &
             &  (pdf_at_xQ(-4)+pdf_at_xQ(4)), &
             &  (pdf_at_xQ(-5)+pdf_at_xQ(5)), &
             &  pdf_at_xQ(0)
     end do
  endif

  ! Write to a file
  Q = Qevolve
  write(idev,'(a, f10.5)') "# hoppet at Q  = ", Q
  write(idev,'(a8,3a15,a17,5a14,a15)') "x",&
       & "u-ubar","d-dbar","dbr-ubr","2(ubr+dbr)","s+sbar","s-sbar","c+cbar","c-cbar","b+bbar","gluon"
  do i = 1, 200
     x     = 0.00001_dp ** (i/200.0_dp)
     call EvalPdfTable_xQ(tables(0),x,Q,pdf_at_xQ)
     write(idev,'(es10.4,10es15.7)') x, &
          &  pdf_at_xQ(2)-pdf_at_xQ(-2), &
          &  pdf_at_xQ(1)-pdf_at_xQ(-1), &
          &  (pdf_at_xQ(-1)-pdf_at_xQ(-2)), &
          &  2*(pdf_at_xQ(-1)+pdf_at_xQ(-2)), &
          &  (pdf_at_xQ(-3)+pdf_at_xQ(3)), &
          &  (pdf_at_xQ(-3)-pdf_at_xQ(3)), &
          &  (pdf_at_xQ(-4)+pdf_at_xQ(4)), &
          &  (pdf_at_xQ(-4)-pdf_at_xQ(4)), &
          &  (pdf_at_xQ(-5)+pdf_at_xQ(5)), &
          &  pdf_at_xQ(0)
   end do
   write(idev,*) ''
   write(idev,*) ''

  write(idev,'(a, f10.5)') "# LHAPDF at Q  = ", Q
  write(idev,'(a8,3a15,a17,5a14,a15)') "x",&
       & "u-ubar","d-dbar","dbr-ubr","2(ubr+dbr)","s+sbar","s-sbar","c+cbar","c-cbar","b+bbar","gluon"
  do i = 1, 200
     x     = 0.00001_dp ** (i/200.0_dp)
     call evolvePDF(x,Q,pdf_at_xQ)
     write(idev,'(es10.4,10es15.7)') x, &
          &  pdf_at_xQ(2)-pdf_at_xQ(-2), &
          &  pdf_at_xQ(1)-pdf_at_xQ(-1), &
          &  (pdf_at_xQ(-1)-pdf_at_xQ(-2)), &
          &  2*(pdf_at_xQ(-1)+pdf_at_xQ(-2)), &
          &  (pdf_at_xQ(-3)+pdf_at_xQ(3)), &
          &  (pdf_at_xQ(-3)-pdf_at_xQ(3)), &
          &  (pdf_at_xQ(-4)+pdf_at_xQ(4)), &
          &  (pdf_at_xQ(-4)-pdf_at_xQ(4)), &
          &  (pdf_at_xQ(-5)+pdf_at_xQ(5)), &
          &  pdf_at_xQ(0)
   end do
   write(idev,*) ''
   write(idev,*) ''
   

contains 


  !======================================================================
  !! The dummy PDF suggested by Vogt as the initial condition for the 
  !! unpolarized evolution (as used in hep-ph/0511119).
  function unpolarized_dummy_pdf(xvals) result(pdf)
    use types; use consts_dp; use pdf_representation
    real(dp), intent(in) :: xvals(:)
    real(dp)             :: pdf(size(xvals),ncompmin:ncompmax)
    real(dp) :: uv(size(xvals)), dv(size(xvals))
    real(dp) :: ubar(size(xvals)), dbar(size(xvals))
    !---------------------
    real(dp), parameter :: N_g = 1.7_dp, N_ls = 0.387975_dp
    real(dp), parameter :: N_uv=5.107200_dp, N_dv = 3.064320_dp
    real(dp), parameter :: N_db = half*N_ls
  
    pdf = zero
    ! clean method for labelling as PDF as being in the human representation
    ! (not actually needed after setting pdf=0
    call LabelPdfAsHuman(pdf)

    !-- remember that these are all xvals*q(xvals)
    uv = N_uv * xvals**0.8_dp * (1-xvals)**3
    dv = N_dv * xvals**0.8_dp * (1-xvals)**4
    dbar = N_db * xvals**(-0.1_dp) * (1-xvals)**6
    ubar = dbar * (1-xvals)

    ! labels iflv_g, etc., come from the hoppet module, inherited
    ! from the main program
    pdf(:, iflv_g) = N_g * xvals**(-0.1_dp) * (1-xvals)**5
    pdf(:,-iflv_s) = 0.2_dp*(dbar + ubar)
    pdf(:, iflv_s) = pdf(:,-iflv_s)
    pdf(:, iflv_u) = uv + ubar
    pdf(:,-iflv_u) = ubar
    pdf(:, iflv_d) = dv + dbar
    pdf(:,-iflv_d) = dbar
  end function unpolarized_dummy_pdf

end program tabulation_n3lo

!=============================================================================
! dummy module that gets included if exact DIS coefficient functions are not
! compiled in
module coefficient_functions_holder_exact
  implicit none
end module coefficient_functions_holder_exact

!=============================================================================
! This just exits the program with an error message
subroutine InitCoefHolderExact(grid, ch)
  use types; use coefficient_functions_holder, dummy => InitCoefHolderExact
  use warnings_and_errors
  implicit none
  type(grid_def), intent(in) :: grid
  type(coef_holder), intent(inout), target :: ch

  call wae_error('InitCoefHolderExact: exact DIS coefficient functions not compiled in.')
end subroutine InitCoefHolderExact

!! An example program using a tabulation. It outputs a subset of
!! table 15 of hep-ph/0511119 and this output should be identical
!! to the contents of the file tabulation_example.default_output
!!
!! NB: for the full functionality used in generating the HeraLHC and
!!     Les Houches comparison tables, see ../benchmarks/benchmarks.f90
!!     and carefully read the comments at the beginning. Subtleties
!!     exist in particular wrt the treatment of scales muF/=muR.
!!
!! NB: commented code shows usage with LHAPDF (e.g. for cross-checking 
!!     some public PDF set's evolution) -- to use this part of the code
!!     you will also need to link with LHAPDF
!!
!! Pipe the output through
!!
!!   pcresed 's/E(.).(.)/\$^\{$1$2\}\$/g' | pcresed 's/  ([0-9])/ &  $1/g' | pcresed 's/ -/ & -/g'
!!
!! to get the number in LaTeX table format
program tabulation_example_n3lo
  use hoppet
  !! if using LHAPDF, rename a couple of hoppet functions which
  !! would otherwise conflict with LHAPDF 
  !use hoppet, EvolvePDF_hoppet => EvolvePDF, InitPDF_hoppet => InitPDF
  implicit none
  real(dp) :: dy, ymax, dlnlnQ
  integer  :: order, nloop
  !! holds information about the grid
  type(grid_def) :: grid
  !! holds the splitting functions
  type(dglap_holder) :: dh
  !! hold the PDF tabulation
  type(pdf_table)       :: table
  !! hold the coupling
  real(dp)               :: quark_masses(4:6)
  type(running_coupling) :: coupling
  !! hold the initial pdf
  real(dp), pointer :: pdf0(:,:)
  real(dp) :: Q0
  !! hold results at some x, Q
  real(dp) :: Q, pdf_at_xQ(-6:6)
  real(dp), parameter :: heralhc_xvals(11) = &
       & (/1e-7_dp, 1e-6_dp, 1e-5_dp,1e-4_dp,1e-3_dp,1e-2_dp,0.1_dp,0.3_dp,0.5_dp,0.7_dp,0.9_dp/)
  integer  :: i, ix
  real(dp) :: x
  logical :: vfn = .true. ! Change to false to run nf = 4 FFN for comparison with 2406.16188

  !! define the interfaces for LHA pdf (by default not used)
  !! (NB: unfortunately this conflicts with an internal hoppet name,
  !! so make sure that you "redefine" the internal hoppet name, 
  !! as illustrated in the commented "use" line above:
  !! use hoppet, EvolvePDF_hoppet => EvolvePDF, ...)
  ! interface
  !    subroutine EvolvePDF(x,Q,res)
  !      use types; implicit none
  !      real(dp), intent(in)  :: x,Q
  !      real(dp), intent(out) :: res(*)
  !    end subroutine EvolvePDF
  ! end interface

  ! set up parameters for grid
  order = -6
  ymax  = 17.0_dp
  dy    = 0.05_dp      ! a large value of 0.20 gives results that are good to within relative 10^{-4}, 0.1 agrees with 0.05 to within relative 10^{-5}
  dlnlnQ = dy / 4.0_dp ! a good default as long as ymax is not too large

  ! set up the grid itself (this call sets up a nested grid composed of 4 subgrids)
  call InitGridDefDefault(grid, dy, ymax, order=order)

  ! initialise the splitting-function holder
  nloop = 4 ! 1; LO, 2; NLO, 3; NNLO; 4; N3LO
  if(vfn) then 
     !n3lo_splitting_approximation = n3lo_splitting_approximation_up_to_2310_05744 ! Controls the approximation that we use the in n3lo splitting functions
     call dglap_Set_nnlo_nfthreshold(nnlo_nfthreshold_exact)
     call dglap_Set_n3lo_nfthreshold(n3lo_nfthreshold_on) ! To turn on/off the n3lo mass thresholds
     call InitDglapHolder(grid,dh,factscheme=factscheme_MSbar,&
          &                      nloop=nloop,nflo=3,nfhi=5)
     write(6,'(a)') "Splitting functions initialised!"
     write(6,'(a,i1)') "Using nloop = ",nloop
     write(6,'(a,f6.4,a,f8.6)') "Using dy = ",dy," dlnlnQ = ",dlnlnQ

     !! set up LHAPDF with cteq
     !call InitPDFsetByName("cteq61.LHgrid")
     !call InitPDF(0)
     ! allocate and set up the initial pdf from LHAPDF ...
     !Q0 = 5.0_dp 
     !call AllocPDF(grid, pdf0)
     !call InitPDF_LHAPDF(grid, pdf0, EvolvePDF, Q0)

     ! initialise a PDF from the function below (must be contained,
     ! in a "used" module, or with an explicitly defined interface)
     call AllocPDF(grid, pdf0)
     pdf0 = unpolarized_dummy_pdf(xValues(grid))
     Q0 = sqrt(2.0_dp)  ! the initial scale
     
     ! allocate and initialise the running coupling with a given
     ! set of quark masses (NB: charm mass just above Q0).
     quark_masses(4:6) = (/1.414213563_dp, 4.5_dp, 1e100_dp/)
     call InitRunningCoupling(coupling,alfas=0.35_dp,Q=Q0,nloop=nloop,&
          &                   quark_masses = quark_masses)
     
  else
     ! To perform the nf = 4 FFN run that compares against 2406.16188
     ! tables 1 & 2 uncomment the below and comment the above
     n3lo_splitting_approximation = n3lo_splitting_approximation_up_to_2310_05744
     call dglap_Set_n3lo_nfthreshold(n3lo_nfthreshold_off) ! To turn on/off the n3lo mass thresholds
     call InitDglapHolder(grid,dh,factscheme=factscheme_MSbar,&
          &                      nloop=nloop,nflo=4,nfhi=4)
     write(6,'(a)') "Doing FFN nf = 4 tabulation for comparison with 2406.16188"
     write(6,'(a)') "Splitting functions initialised, using 2310_05744 approximation!"
     write(6,'(a,i1)') "Using nloop = ",nloop
     write(6,'(a,f6.4,a,f8.6)') "Using dy = ",dy," dlnlnQ = ",dlnlnQ
     
     ! initialise a PDF from the function below (must be contained,
     ! in a "used" module, or with an explicitly defined interface)
     call AllocPDF(grid, pdf0)
     pdf0 = unpolarized_dummy_pdf(xValues(grid))
     Q0 = sqrt(2.0_dp)  ! the initial scale
     
     ! allocate and initialise the running coupling with a given
     ! set of quark masses (NB: charm mass just above Q0).
     quark_masses(4:6) = (/1.414213563_dp, 4.5_dp, 1e100_dp/)
     call InitRunningCoupling(coupling,alfas=0.35_dp,Q=Q0,nloop=nloop,&
          &                   quark_masses = quark_masses, fixnf = 4)
  endif
  ! create the tables that will contain our copy of the user's pdf
  ! as well as the convolutions with the pdf.
  call AllocPdfTable(grid, table, Qmin=1.0_dp, Qmax=10000.0_dp, & 
       & dlnlnQ = dlnlnQ, freeze_at_Qmin=.true.)
  ! add information about the nf transitions to the table (improves
  ! interpolation quality)
  call AddNfInfoToPdfTable(table,coupling)

  ! create the tabulation based on the evolution of pdf0 from scale Q0
  call EvolvePdfTable(table, Q0, pdf0, dh, coupling, nloop=nloop)
  ! alternatively "pre-evolve" so that subsequent evolutions are faster
  !call PreEvolvePdfTable(table, Q0, dh, coupling)
  !call EvolvePdfTable(table,pdf0)
  write(6,'(a)') "Evolution done!"

  ! get the value of the tabulation at some point
  Q = 100.0_dp
  write(6,'(a)')
  write(6,'(a,f8.3,a)') "                                   Evaluating PDFs at Q = ",Q," GeV"
  write(6,'(a5,3a12,a14,4a11,a12)') "x",&
       & "u-ubar","d-dbar","dbr-ubr","2(ubr+dbr)","s-sbar","s+sbar","c+cbar","b+bbar","gluon"
  do ix = 1, size(heralhc_xvals)
     call EvalPdfTable_xQ(table,heralhc_xvals(ix),Q,pdf_at_xQ)
     write(6,'(es7.1,9es12.4)') heralhc_xvals(ix), &
          &  pdf_at_xQ(2)-pdf_at_xQ(-2), &
          &  pdf_at_xQ(1)-pdf_at_xQ(-1), &
          &  (pdf_at_xQ(-1)-pdf_at_xQ(-2)), &
          &  2*(pdf_at_xQ(-1)+pdf_at_xQ(-2)), &
          &  (pdf_at_xQ(3)-pdf_at_xQ(-3)), &
          &  (pdf_at_xQ(-3)+pdf_at_xQ(3)), &
          &  (pdf_at_xQ(-4)+pdf_at_xQ(4)), &
          &  (pdf_at_xQ(-5)+pdf_at_xQ(5)), &
          &  pdf_at_xQ(0)
  end do
  ! Write to a file
  
  write(12,'(a5,3a12,a14,4a11,a12)') "x",&
       & "u-ubar","d-dbar","dbr-ubr","2(ubr+dbr)","s-sbar","s+sbar","c+cbar","b+bbar","gluon"
  do i = 1, 200
     x     = 0.0001_dp ** (i/200.0_dp)
     call EvalPdfTable_xQ(table,x,Q,pdf_at_xQ)
     write(12,'(es10.4,9es14.7)') x, &
          &  pdf_at_xQ(2)-pdf_at_xQ(-2), &
          &  pdf_at_xQ(1)-pdf_at_xQ(-1), &
          &  (pdf_at_xQ(-1)-pdf_at_xQ(-2)), &
          &  2*(pdf_at_xQ(-1)+pdf_at_xQ(-2)), &
          &  (pdf_at_xQ(3)-pdf_at_xQ(-3)), &
          &  (pdf_at_xQ(-3)+pdf_at_xQ(3)), &
          &  (pdf_at_xQ(-4)+pdf_at_xQ(4)), &
          &  (pdf_at_xQ(-5)+pdf_at_xQ(5)), &
          &  pdf_at_xQ(0)
   end do
   write(12,*) ''
   write(12,*) ''
  
  ! some cleaning up (not strictly speaking needed, but illustrates
  ! how it's done)
  call Delete(table)
  call Delete(pdf0)
  call Delete(dh)
  call Delete(coupling)
  call Delete(grid)

contains 
  !======================================================================
  !! The dummy PDF suggested by Vogt as the initial condition for the 
  !! unpolarized evolution (as used in hep-ph/0511119).
  function unpolarized_dummy_pdf(xvals) result(pdf)
    real(dp), intent(in) :: xvals(:)
    real(dp)             :: pdf(size(xvals),ncompmin:ncompmax)
    real(dp) :: uv(size(xvals)), dv(size(xvals))
    real(dp) :: ubar(size(xvals)), dbar(size(xvals))
    !---------------------
    real(dp), parameter :: N_g = 1.7_dp, N_ls = 0.387975_dp
    real(dp), parameter :: N_uv=5.107200_dp, N_dv = 3.064320_dp
    real(dp), parameter :: N_db = half*N_ls
  
    pdf = zero
    ! clean method for labelling as PDF as being in the human representation
    ! (not actually needed after setting pdf=0
    call LabelPdfAsHuman(pdf)

    !-- remember that these are all xvals*q(xvals)
    uv = N_uv * xvals**0.8_dp * (1-xvals)**3
    dv = N_dv * xvals**0.8_dp * (1-xvals)**4
    dbar = N_db * xvals**(-0.1_dp) * (1-xvals)**6
    ubar = dbar * (1-xvals)

    ! labels iflv_g, etc., come from the hoppet module, inherited
    ! from the main program
    pdf(:, iflv_g) = N_g * xvals**(-0.1_dp) * (1-xvals)**5
    pdf(:,-iflv_s) = 0.2_dp*(dbar + ubar)
    pdf(:, iflv_s) = pdf(:,-iflv_s)
    pdf(:, iflv_u) = uv + ubar
    pdf(:,-iflv_u) = ubar
    pdf(:, iflv_d) = dv + dbar
    pdf(:,-iflv_d) = dbar
  end function unpolarized_dummy_pdf

end program tabulation_example_n3lo

!--------------------------------------------------------------------
!! contains the random number generator; use l'Ecuyer's method which
!! is sufficient for simple uses (want something that above all is
!! quick) . Original code comes via herwig.
!!
module hoppetrandom
  use types
  implicit none
  private

  public :: ran_one,rangen, SetSeed, GetSeed

  integer, save :: iseed(2) = (/123450,678900/)
contains
  !! returns one random number (in double precision) between 0 and 1
  function ran_one()
    real(dp) :: ran_one
    real(dp) :: rann(1)
    !call random_number(ran)
    call rangen(rann)
    ran_one = rann(1)
  end function ran_one
 
  subroutine rangen(r)
    implicit none
    !---random number generator
    !   uses method of l'Ecuyer, (via F.James, Comp Phys Comm 60(1990)329)
    !   returns the vector r(:) of random values
    real(dp), intent(out) :: r(:)
    integer i,k,iz
    do i=1,size(r)
       k=iseed(1)/53668
       iseed(1)=40014*(iseed(1)-k*53668)-k*12211
       if (iseed(1).lt.0) iseed(1)=iseed(1)+2147483563
       k=iseed(2)/52774
       iseed(2)=40692*(iseed(2)-k*52774)-k*3791
       if (iseed(2).lt.0) iseed(2)=iseed(2)+2147483399
       iz=iseed(1)-iseed(2)
       if (iz.lt.1) iz=iz+2147483562
       r(i)=real(iz,kind=dp)*4.656613d-10
    enddo
  end subroutine rangen

  
  subroutine SetSeed(iseed_in)
    integer, intent(in) :: iseed_in(2)
    iseed = iseed_in
  end subroutine SetSeed

  subroutine GetSeed(iseed_out)
    integer, intent(out) :: iseed_out(2)
    iseed_out = iseed
  end subroutine GetSeed

end module hoppetrandom

module xpns3s
  character(len=*), parameter :: name_xpns3s = "xpns3s"
contains
!
! ..File: xpns3s.f
!   
! ..The 4-loop MSbar splitting functions P_ns^(3)s, which contributes
!    to the N^3LO evolution of the total valence quark distribution. 
!    The expansion parameter is alpha_s/(4 pi), the scale mu_r = mu_f.
!
! ..The nf^2 part is a high-accuracy (0.1% or better) parametrization
!    of the exact expression obtained in arXiv:1610.07477, see xpns3m.f
!
! ..The nf^0 part is an approximation based on the first 9 odd moments.
!    The two sets spanning the error estimate are called via  IMOD = 1
!    and  IMOD = 2.  Any other value of IMOD invokes their average.
!
! ..The distributions (in the mathematical sense) are given as in eq.
!    (B.27) of Floratos, Kounnas, Lacaze: Nucl. Phys. B192 (1981) 417.
!    The name-endings A, B, and C of the functions below correspond to 
!    the kernel superscripts [2], [3], and [1] in that equation.
!
!  ..Reference: 
!        S. Moch, B. Ruijl, T. Ueda, J.Vermaseren and A. Vogt,
!         DESY 17-106, Nikhef 2017-034, LTH 1139
!
!  ..Additional reference for the nf^2 part
!        J. Davies, B. Ruijl, T. Ueda, J.Vermaseren and A. Vogt
!         arXiv:1610.07477, Nucl. Phys. B915 (2017) 335
!
! =====================================================================
!
!
! ..The regular piece of P_ns^(3)s. 
!
  FUNCTION P3NSSA (Y, NF, IMOD)
!
       IMPLICIT REAL*8 (A-Z)
       INTEGER IMOD, nf
!
       Y1  = 1.D0-Y
       DM  = 1.D0/Y1
       DL  = LOG (Y)
       DL1 = LOG (1.D0-Y)
!
! nf^1: two approximations
!
       P3NSA11 = Y1*Y* ( 4989.2D0 - 1607.73D0* Y)&
               + 3687.6D0* DL + 3296.6D0* DL**2 + 1271.11D0* DL**3&
               + 533.44D0 * DL**4 + 97.27D0*  DL**5 + 4.D0* DL**6&
               + 60.40D0* Y1*DL1**2 + 4.685D0* Y1*DL1**3
       P3NSA12 = 1030.79D0* Y1*Y + 1266.77D0* Y1*(2.D0-Y*Y) &
               + 2987.83D0 * DL + 273.05D0* DL**2 - 923.48D0* DL**3& 
               - 236.76D0* DL**4 - 33.886D0*  DL**5 - 4.D0* DL**6 &
               - 254.63D0* Y1*DL1 - 0.28953D0* Y1*DL1**3
!
! nf^2 (parametrized) 
!
       P3NSSA2 = 2.5D+2*  ( Y1* ( -4.7656D0 + 1.6908D0* Y + 0.1703D0* Y**2 )& 
               - 0.41652D0* Y*DL + 0.90777D0* Y*DL**2 + 0.12478D0* Y*DL**3  &
               + 0.17155D0* Y1*DL1 + 0.17191D0 * DL*DL1 )                   &
               - 6.473971D+2*DL - 6.641219D+1*DL**2 - 5.353347D+0*DL**3     &
               - 5.925926D+0*DL**4 - 3.950617D-1*DL**5                      &
               + 1.970002D+1*Y1*DL1 - 3.435474D+0*Y1*DL1**2  
!
       IF (IMOD .EQ. 1) THEN
         P3NSSA = nf*P3NSA11 + nf**2* P3NSSA2
       ELSE IF (IMOD .EQ. 2) THEN
         P3NSSA = nf*P3NSA12 + nf**2* P3NSSA2
       ELSE
         P3NSSA = 0.5D0*nf* (P3NSA11 + P3NSA12) + nf**2* P3NSSA2 
       END IF
!
       RETURN
     END FUNCTION P3NSSA
!
! =================================================================av==
   end module xpns3s

!! Module defining interfaces to LHAPDF Fortran routines. 
!!
!! Only a subset of routines is included here.
module hoppet_lhapdf_interfaces
  implicit none

  ! interface to the LHAPDF routine for accessing the PDF
  interface
    subroutine EvolvePDF(x,Q,res)
      use types; implicit none
      real(dp), intent(in)  :: x,Q
      real(dp), intent(out) :: res(*)
    end subroutine EvolvePDF
  end interface

  interface
    function alphasPDF(Q) result(as)
      use types; implicit none
      real(dp), intent(in) :: Q
      real(dp) :: as
    end function alphasPDF
  end interface

  !! Get the number of error members in the set (non-multiset version)
  interface 
    subroutine numberpdf(n)
      integer, intent(out) :: n
    end subroutine numberpdf
  end interface

  interface 
    subroutine initPDFSetByName(name)
      character(len=*), intent(in) :: name
    end subroutine initPDFSetByName
  end interface

  interface 
    subroutine initPDF(imem)
      integer, intent(in) :: imem
    end subroutine initPDF
  end interface

  interface 
    subroutine getQ2min(imem,Q2min)
      use types; implicit none
      integer, intent(in) :: imem
      real(dp), intent(out) :: Q2min
    end subroutine getQ2min
  end interface
  interface 
    subroutine getQ2max(imem,Q2max)
      use types; implicit none
      integer, intent(in) :: imem
      real(dp), intent(out) :: Q2max
    end subroutine getQ2max
  end interface

  interface 
    subroutine getxmin(imem,xmin)
      use types; implicit none
      integer, intent(in) :: imem
      real(dp), intent(out) :: xmin
    end subroutine getxmin
  end interface
  
  interface 
    subroutine getxmax(imem,xmax)
      use types; implicit none
      integer, intent(in) :: imem
      real(dp), intent(out) :: xmax
    end subroutine getxmax
  end interface

  interface 
    subroutine getorderas(order)
      integer, intent(out) :: order
    end subroutine getorderas
  end interface

  interface 
    subroutine getthreshold(nf, mquark)
      use types; implicit none
      integer, intent(in) :: nf
      real(dp), intent(out) :: mquark
    end subroutine getthreshold
  end interface

  interface 
    subroutine getnf(nf)
      integer, intent(out) :: nf
    end subroutine getnf
  end interface

  interface 
    subroutine GetPDFUncertainty(pdfset, central, err_up, err_down, err_symm)
      use types; implicit none
      real(dp), intent(in)  :: pdfset(*)
      real(dp), intent(out) :: central, err_up, err_down, err_symm
    end subroutine GetPDFUncertainty
  end interface

end module hoppet_lhapdf_interfaces

      module xc3ns2p
      contains
*     
* ..File: xc3ns2p.f    F3_NS
*
*
* ..Calculation of the 2-loop x-space MS(bar) coefficient functions 
*    for xF3 via compact parametrizations involving only logarithms.
*    mu_r = mu_f = Q. Expansion parameter: alpha_s/(4 pi).
*
*  ..The distributions (in the mathematical sense) are given as in eq.
*    (B.26) of Floratos, Kounnas, Lacaze: Nucl. Phys. B192 (1981) 417.
*    The name-endings A, B, and C of the functions below correspond to 
*    the kernel superscripts [2], [3], and [1] in that equation.
*
*  ..The relative accuracy of the coefficient functions, as well as of 
*    the convolution results, amounts to a few thousandth.
*    
*  ..Reference: W.L. van Neerven and A. Vogt,
*               hep-ph/9907472 = Nucl. Phys. B568 (2000) 263
*  ..The user should also cite the original calculation,
*     E.B. Zijlstra and W.L. van Neerven, Phys. Lett. B297 (1992) 377.
*
* 
* =====================================================================
*
*                                                               __
* ..This is the regular non-singlet piece for the sum F3(nu)+F3(nu), 
*    corresponding to C3NSP-C3NSN in W. van Neerven's program. The 
*    (9+8) numerical coefficients are fitted to his results, using x 
*    values between 10^-6 and 1-10^-6. 
*     
      FUNCTION C3NM2A (Y, NF)
      IMPLICIT REAL*8 (A-Z)
      INTEGER NF
*     
      DL  = LOG (Y)
      OMY = 1.0D0 - Y
      DL1 = LOG (OMY)
*     
      C3NM2A = - 206.1D0 - 576.8D0 * Y - 3.922D0 * DL**3 - 33.31D0 * DL
     $     **2 - 67.60D0 * DL - 15.20D0 * DL1**3 + 94.61D0 * DL1**2 -
     $     409.6D0 * DL1 - 147.9D0 * DL * DL1**2 + NF * ( - 6.337D0 -
     $     14.97D0 * Y + 2.207D0 * DL**2 + 8.683D0 * DL + 0.042D0 * DL1
     $     **3 - 0.808D0 * DL1**2 + 25.00D0 * DL1 + 9.684D0 * DL * DL1 )
     $     
*     
      RETURN
      END function 
*
* ---------------------------------------------------------------------
*
*                                                                 __
* ..This is the regular non-singlet piece for the diff. F3(nu)-F3(nu), 
*    corresponding to C3NSP+C3NSN in WvN's program. For the NF^0 piece
*    7 numerical coefficients are fitted to his results, the ones of
*    ln^3(1-y) and ln^2(1-y) are taken over from C3NM2A. The NF piece
*    is also the same as in C3NM2A.
*
       FUNCTION C3NP2A (Y, NF)
       IMPLICIT REAL*8 (A-Z)
       INTEGER NF
*
       DL  = LOG (Y)
       OMY = 1.0D0 - Y
       DL1 = LOG (OMY)
*
       C3NP2A = - 242.9D0 - 467.2D0 * Y - 3.049D0 * DL**3 - 30.14D0 * DL
     $      **2 - 79.14D0 * DL - 15.20D0 * DL1**3 + 94.61D0 * DL1**2 -
     $      396.1D0 * DL1 - 92.43D0 * DL * DL1**2 + NF * ( - 6.337D0 -
     $      14.97D0 * Y + 2.207D0 * DL**2 + 8.683D0 * DL + 0.042D0 * DL1
     $      **3 - 0.808D0 * DL1**2  + 25.00D0 * DL1 + 9.684D0 * DL * DL1
     $      )     
*
       RETURN
       END function 
*
* ---------------------------------------------------------------------
*
*
* ..This is the singular NS piece, denoted by SOFT2 in WvN's program. 
*    It is the same for all F2 and F3 cases. The numerical coefficients 
*    are exact, but truncated.
*
       FUNCTION C3NS2B (Y, NF)
       IMPLICIT REAL*8 (A-Z)
       INTEGER NF
*
       OMY = 1.0D0 - Y
       DL1 = LOG (OMY)
       DM  = 1.D0/OMY
*
       C3NS2B = + 14.2222D0 * DL1**3 - 61.3333D0 * DL1**2 - 31.105D0 *
     $      DL1 + 188.64D0 + NF * ( 1.77778D0 * DL1**2 - 8.5926D0 * DL1
     $      + 6.3489D0 ) 
       C3NS2B = DM * C3NS2B
*
       RETURN
       END function 
*
* ---------------------------------------------------------------------
*
*                                        __
* ..This is the 'local' NS piece for the nu+nu F3, denoted by COR2 in 
*    WvN's program. The numerical coefficients of the logs are exact,
*    but truncated, the constant one (from the delta-function) is 
*    slightly adjusted (- 0.104 + 0.013 NF) using the lowest moments.
*
       FUNCTION C3NM2C (Y, NF)
       IMPLICIT REAL*8 (A-Z)
       INTEGER NF
*
       OMY = 1.0D0 - Y
       DL1 = LOG (OMY)
*
       C3NM2C = + 3.55555D0 * DL1**4 - 20.4444D0 * DL1**3 - 15.5525D0 *
     $      DL1**2 + 188.64D0 * DL1 - 338.531D0 - 0.104D0 + NF *
     $      (0.592593D0 * DL1**3 - 4.2963D0 * DL1**2 + 6.3489D0 * DL1 +
     $      46.844D0 + 0.013D0)
*
       RETURN
       END function 
*
* ---------------------------------------------------------------------
*
*                                        __
* ..This is the 'local' NS piece for the nu-nu F3, also given by COR2 in
*    WvN's program. The numerical coefficients of the logs are exact,
*    but truncated, the constant one (from the delta-function) is 
*    slightly adjusted (- 0.152 + 0.013 NF) using the lowest moments.
*
       FUNCTION C3NP2C (Y, NF)
       IMPLICIT REAL*8 (A-Z)
       INTEGER NF
*
       OMY = 1.0D0 - Y
       DL1 = LOG (OMY)
*
       C3NP2C = + 3.55555D0 * DL1**4 - 20.4444D0 * DL1**3 - 15.5525D0 *
     $      DL1**2 + 188.64D0 * DL1 - 338.531D0 - 0.152D0 + NF *
     $      (0.592593D0 * DL1**3 - 4.2963D0 * DL1**2 + 6.3489D0 * DL1 +
     $      46.844D0 + 0.013D0)
*
       RETURN
       END function 
*
* =================================================================av==
      end module xc3ns2p

!======================================================================
! QED splitting function. NB y == gamma
!
! Beyond leading order, these are taken from arXiv:1512.00612
!
! Their notation (Eqs.6-7) is that
!
! - P_{q_i q_k} = \delta_{ik} P_{qq}^V + P_{qq}^S
!
! - P_{q_i \bar q_k} = \delta_{ik} P_{q \barq}^V + P_{q\bar q}^S
!
! - P^{\pm}_q = P_{qq}^V \pm P_{q\bar q}^V
!
! In our notation, "gamma" is written "y".
!
! Note that the Piy_11 functions have not been coded, because they
! appear to be given simply by
!
!    Piy_11 = (CF CA / TR) Pig_11 
!
! GPS 2016-05-20
module qed_splitting_functions
  use types; use consts_dp; use convolution_communicator
  use qcd; use warnings_and_errors
  use splitting_functions
  implicit none
  private

  public :: sf_Pqq_01, sf_Pqy_01, sf_Pyq_01, sf_Pyy_01
  public :: sf_Pqg_11, sf_Pyg_11, sf_Pgg_11
  public :: sf_PqqV_11, sf_PqqbarV_11, sf_Pgq_11

  ! just one of the NNLO QED splitting functions, as
  ! needed for the QED lepton PDFs (cf. arXiv:2109.10924 and refs therein)
  public :: sf_Plq_02
contains

  !----------------------------------------------------------------------
  ! this is to be multplied by the eq^2
  function sf_Pqq_01(y) result(res)
    real(dp), intent(in) :: y
    real(dp)             :: res
    res = sf_Pqq(y) / CF
  end function sf_Pqq_01

  !----------------------------------------------------------------------
  ! this is to be multplied by the eq^2 -- The extra factor of N_C
  ! is not included here, see line
  ! chg2_toflv(-6:6) = CA * chg2_fromflv(-6:6)
  ! in qed_objects.f90
  function sf_Pqy_01(y) result(res)
    real(dp), intent(in) :: y
    real(dp)             :: res
    res = sf_Pqg(y) / TR
  end function sf_Pqy_01

  !----------------------------------------------------------------------
  ! this is to be multplied by the eq^2
  function sf_Pyq_01(y) result(res)
    real(dp), intent(in) :: y
    real(dp)             :: res
    res = sf_Pgq(y) / CF
  end function sf_Pyq_01

  !----------------------------------------------------------------------
  ! this is to be multiplied by ef^2 = NC \sum_q eq^2 + \sum_l el^2
  function sf_Pyy_01(y) result(res)
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x
    x = exp(-y)
    res = zero
    select case(cc_piece)
    case(cc_DELTA)
       res = - two/three
    end select
    if (cc_piece /= cc_DELTA) res = res * x
  end function sf_Pyy_01

  !======================================================================
  ! now the NLO ones

  !----------------------------------------------------------------------
  ! this is to be multiplied by eq^2
  function sf_Pqg_11(y) result(res)
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x, lnx, ln1mx, pqg
    x = exp(-y)
    res = zero

    select case(cc_piece)
    case(cc_REAL,cc_REALVIRT)
       lnx = -y
       ln1mx = log(one - x)
       pqg   = x**2 + (one-x)**2
       res = TR * half*(4 - 9*x - (1-4*x)*lnx - (1-2*x)*lnx**2 + 4*ln1mx&
             + pqg*(2*(ln1mx-lnx)**2 - 4*(ln1mx-lnx) - two*pisq/three + 10))
    end select
    select case(cc_piece)
    case(cc_VIRT,cc_REALVIRT)
    case(cc_DELTA)
    end select

    if (cc_piece /= cc_DELTA) res = res * x
  end function sf_Pqg_11
  

  !----------------------------------------------------------------------
  ! this is to be multiplied by \sum_j=1^nf eqj^2
  function sf_Pyg_11(y) result(res)
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x, lnx
    x = exp(-y)
    lnx = -y
    res = zero

    select case(cc_piece)
    case(cc_REAL,cc_REALVIRT)
       res = TR * (-16 + 8*x + 20*x**2/three + four/(3*x) &
            &      -(6+10*x)*lnx - 2*(1+x)*lnx**2)
    end select
    select case(cc_piece)
    case(cc_VIRT,cc_REALVIRT)
    case(cc_DELTA)
    end select

    if (cc_piece /= cc_DELTA) res = res * x
  end function sf_Pyg_11

  
  !----------------------------------------------------------------------
  ! this is to be multiplied by \sum_j=1^nf eqj^2
  function sf_Pgg_11(y) result(res)
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x
    x = exp(-y)
    res = zero
    select case(cc_piece)
    case(cc_DELTA)
       res = - TR
    end select
    if (cc_piece /= cc_DELTA) res = res * x
  end function sf_Pgg_11


  !----------------------------------------------------------------------
  ! to be multiplied by eq^2
  function sf_PqqV_11(y) result(res)
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x, lnx, ln1mx, pqq
    x = exp(-y)
    res = zero

    select case(cc_piece)
    case(cc_REAL,cc_REALVIRT)
      lnx = -y
      ln1mx = log(one - x)
      pqq = two/(one-x) - one - x
       res = -two*CF*(&
            &  (2*lnx*ln1mx + 1.5_dp*lnx)*pqq&
            &   + (three+7.0_dp*x)/two * lnx&
            &   + (one+x)/two * lnx**2&
            &   + 5*(one-x))
    end select
    select case(cc_piece)
    case(cc_VIRT,cc_REALVIRT)
    case(cc_DELTA)
       res = -two*CF*(pisq/two - three/8.0_dp - 6 * zeta3)
    end select

    if (cc_piece /= cc_DELTA) res = res * x
  end function sf_PqqV_11

  !----------------------------------------------------------------------
  ! to be multiplied by eq^2
  function sf_PqqbarV_11(y) result(res)
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x, lnx, ln1mx, pqqmx
    x = exp(-y)
    res = zero

    select case(cc_piece)
    case(cc_REAL,cc_REALVIRT)
      lnx = -y
      ln1mx = log(one - x)
      pqqmx = two/(one+x) - one + x
       res = two*CF*(&
            &   4*(1-x)&
            &  + 2*(1+x)*lnx&
            &  + 2*pqqmx * sf_S2(x))
    end select
    select case(cc_piece)
    case(cc_VIRT,cc_REALVIRT)
    case(cc_DELTA)
    end select

    if (cc_piece /= cc_DELTA) res = res * x
  end function sf_PqqbarV_11

  !----------------------------------------------------------------------
  ! to be multiplied by eq^2
  ! Pyq_11 is identical
  function sf_Pgq_11(y) result(res)
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x, lnx, ln1mx, pgq
    x = exp(-y)
    res = zero

    select case(cc_piece)
    case(cc_REAL,cc_REALVIRT)
      lnx = -y
      ln1mx = log(one - x)
      pgq = (one + (one-x)**2)/x
       res = CF*(&
            &  -(three*ln1mx + ln1mx**2)*pgq&
            &  + (two + 7.0_dp/two * x)*lnx&
            &  - (1-half*x)*lnx**2&
            &  - two*x*ln1mx&
            &  - 7.0_dp*x/two - 5.0_dp/two)
    end select
    select case(cc_piece)
    case(cc_VIRT,cc_REALVIRT)
    case(cc_DELTA)
    end select
    if (cc_piece /= cc_DELTA) res = res * x
  end function sf_Pgq_11
  
  !======================================================================
  ! now the NNLO ones

  !----------------------------------------------------------------------
  ! this is to be multiplied by eq^2*el^2
  function sf_Plq_02(y) result(res)
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x, lnx, ln1mx, pqg
    x = exp(-y)
    res = zero

    select case(cc_piece)
    case(cc_REAL,cc_REALVIRT)
      lnx = -y
      ln1mx = log(one - x)
         res = 20.0_dp/9.0_dp/x - 2.0_dp + 6.0_dp*x - 56.0_dp/9.0_dp*x**2 &
            & + (1.0_dp + 5.0_dp*x + 8.0_dp/3.0_dp*x**2)*lnx &
            & - (1.0_dp + x)*lnx**2
    end select
    select case(cc_piece)
    case(cc_VIRT,cc_REALVIRT)
    case(cc_DELTA)
    end select

    if (cc_piece /= cc_DELTA) res = res * x
  end function sf_Plq_02

end module qed_splitting_functions

!----------------------------------------------------------------------
! program for testing the streamlined interface for convolution
! with multiple splitting functions
program streamlined_multisplit
  use streamlined_interface
  use pdfs_for_benchmarks
  implicit none
  real(dp) :: dy
  integer  :: nloop
  real(dp) :: asQ, Q0alphas, muR_Q = 1.0_dp, Q0pdf
  real(dp) :: mc, mb, mt
  !----------------------------------------------------------------------
  real(dp) :: x = 0.3_dp, Q = 100.0_dp
  real(dp), pointer :: pdf(:,:), pdfconv(:,:)
  real(dp) :: res(-6:6)
  integer  :: nf_lcl
  
  nloop = 3

  call startup()


  ! very basic test ------------
  call hoppetEval(x, Q, res)
  if (nloop == 3) call compare('pdf v. known ref', res(0), 7.8898E-02_dp)

  Q = 100.0_dp
  nf_lcl = -1 ! dynamic nf
  !call hoppetEvalSplit(x, Q, 7, nf_lcl, res) ! for testing errors
  call SetNfDglapHolder(dh, 5)
  call do_full_set

  Q = 3.3_dp
  call SetNfDglapHolder(dh, 4)
  call do_full_set

  nf_lcl = 5 ! fixed nf
  call SetNfDglapHolder(dh, nf_lcl)
  call do_full_set

contains

  ! run a full suite of checks for a given x, Q value
  subroutine do_full_set()

    write(6,*)
    write(6,*) 'Running full set with Q = ',Q, ', x = ', x, 'nf = ', nf_lcl

    call hoppetEval(x, Q, res)
    call EvalPdfTable_Q(tables(0), Q, pdf)
    call compare('internal v. table', res(0), pdf(:,0).atx.(x.with.grid))
    
    call hoppetEvalSplit(x, Q, 1, nf_lcl, res)
    pdfconv = dh%P_LO * pdf
    call compare('PLO * pdf', res(0), pdfconv(:,0).atx.(x.with.grid))
    
    call hoppetEvalSplit(x, Q, 2, nf_lcl, res)
    pdfconv = dh%P_NLO * pdf
    call compare('PNLO * pdf', res(0), pdfconv(:,0).atx.(x.with.grid))
    
    call hoppetEvalSplit(x, Q, 3, nf_lcl, res)
    pdfconv = dh%P_NNLO * pdf
    call compare('PNNLO * pdf', res(0), pdfconv(:,0).atx.(x.with.grid))
    
    call hoppetEvalSplit(x, Q, 11, nf_lcl, res)
    pdfconv = dh%P_LO * (dh%P_LO * pdf)
    call compare('PLO * PLO * pdf', res(0), pdfconv(:,0).atx.(x.with.grid))
    
    call hoppetEvalSplit(x, Q, 12, nf_lcl, res)
    pdfconv = dh%P_LO * (dh%P_NLO * pdf)
    call compare('PLO * PNLO * pdf', res(0), pdfconv(:,0).atx.(x.with.grid))
    
    call hoppetEvalSplit(x, Q, 21, nf_lcl, res)
    pdfconv = dh%P_NLO * (dh%P_LO * pdf)
    call compare('PNLO * PLO * pdf', res(0), pdfconv(:,0).atx.(x.with.grid))
    
    call hoppetEvalSplit(x, Q, 111, nf_lcl, res)
    pdfconv = dh%P_LO * (dh%P_LO * (dh%P_LO * pdf))
    call compare('PLO^3 * pdf', res(0), pdfconv(:,0).atx.(x.with.grid))

  end subroutine do_full_set
  
  
  !----------------------------------------------------------------------
  ! check two numbers are equal
  subroutine compare(testname, v1, v2)
    character(len=*), intent(in) :: testname
    real(dp), intent(in) :: v1, v2
    character(len=4)     :: status
    real(dp), parameter  :: tolerance = 3e-5

    if (abs(v1-v2) > tolerance*max(abs(v1),abs(v2))) then
       status = 'FAIL'
    else
       status = 'OK'
    end if

    write(6,'(a20,2es15.5,a6)') trim(testname), v1, v2, status
  end subroutine compare
  
  
  subroutine startup()
    dy = 0.1_dp
    call hoppetStart(dy, nloop)
    
    ! Set heavy flavour scheme
    mc = 1.414213563_dp   ! sqrt(2.0_dp) + epsilon
    mb = 4.5_dp
    mt = 175.0_dp
    call hoppetSetVFN(mc, mb, mt)
    
    ! Set parameters of running coupling
    asQ = 0.35_dp
    Q0alphas = sqrt(2.0_dp)
    muR_Q = 1.0_dp
    Q0pdf = Q0alphas
    call hoppetEvolve(asQ, Q0alphas, nloop, muR_Q, benchmark_pdf_unpolarized_lha, Q0pdf)

    call AllocPDF(grid, pdf)
    call AllocPDF(grid, pdfconv)
  end subroutine startup
  


end program streamlined_multisplit

module new_as
  use types; use consts_dp
  use assertions; use warnings_and_errors
  implicit none
  private

  type na_segment
     real(dp) :: tlo, thi, dt, invdt
     real(dp) :: beta0, beta1, beta2, beta3
     real(dp), pointer :: ra(:)
     !-- above iflip we evolve upwards, below iflip we evolve downwards
     integer  :: iflip, dummy
  end type na_segment
  
  type na_handle
     private
     type(na_segment), pointer :: seg(:)
     integer                   :: nlo, nhi
     integer                   :: nloop, fixnf
     !--- these are startoff parameters
     real(dp)                  :: alfas, Q
     real(dp)                  :: quark_masses(1:6)
     real(dp)                  :: muMatch_mQuark
     logical                   :: masses_are_MSbar
  end type na_handle
  
  !-- this seems to give reasonable results (c. 10^-9 precision
  !   almost everywhere if we start at Z peak)
  real(dp) :: dt_base = 0.2_dp
  !real(dp), parameter :: dt_base = 0.1_dp
  !--------- go from 0.5 GeV to over 10^20 GeV
  real(dp), parameter :: tlo = -1.3862944 !-3.2188758_dp
  real(dp), parameter :: thi = 93.0_dp 
  integer,  parameter :: nofixnf = -1000000045

  public :: na_handle
  public :: na_Init, na_Value, na_Value_full, na_Del, na_NumberOfLoops
  public :: na_nfRange, na_nfAtQ, na_QrangeAtNf, na_QuarkMass
  public :: na_QuarkMassesAreMSbar
  public :: na_Set_dt_base

  !type(na_segment), pointer :: seg

  interface SetDefaultCouplingDt
     module procedure na_Set_dt_base
  end interface
  public :: SetDefaultCouplingDt, DefaultCouplingDt
     

contains
  
  !======================================================================
  !! Set the value of dt_base (used to decide spacings for new coupling
  !! instances).
  subroutine na_Set_dt_base(new_dt_base)
    real(dp) :: new_dt_base
    dt_base = new_dt_base
  end subroutine na_Set_dt_base
  


  !---------------------------------------------------
  !! Set the value of dt_base (used to decide spacings for new coupling
  !! instances).
  function DefaultCouplingDt() 
    real(dp) :: DefaultCouplingDt
    DefaultCouplingDt = dt_base
  end function DefaultCouplingDt
  

  !---------------------------------------------------
  
  subroutine na_Init(nah, alfas, Q, nloop, fixnf, quark_masses, masses_are_MSbar, muMatch_mQuark)
    use qcd; 
    type(na_handle),  intent(out), target :: nah
    real(dp), intent(in), optional :: alfas, Q
    integer,  intent(in), optional :: nloop, fixnf
    real(dp), intent(in), optional :: quark_masses(4:6)
    real(dp), intent(in), optional :: muMatch_mQuark
    logical,  intent(in), optional :: masses_are_MSbar
    !---------------------------------------------
    !real(dp) :: alfas_lcl, Q_lcl
    !integer  :: nloop_lcl, fixnf_lcl
    !-------------------------------
    real(dp) :: alfas_here, lnmatch, alphastep20_lclscheme
    real(dp) :: alphastep30_lclscheme, alphastep31_lclscheme 
    real(dp) :: alphastep31_inv_lclscheme 
    real(dp) :: alphastep30_nl_lclscheme, alphastep31_nl_lclscheme 
    real(dp) :: tstart, t, ra
    integer  :: nf_store
    integer  :: nbin, i, j, nseg, istart
    integer  :: nbin_total
    type(na_segment), pointer :: seg

    !-- we may well play with nf, so need to be able to reset it
    nf_store = nf_int

    nah%alfas = default_or_opt(0.118_dp, alfas)
    nah%Q     = default_or_opt(91.2_dp, Q)
    nah%nloop = default_or_opt(2, nloop)

    nah%fixnf = default_or_opt(nofixnf, fixnf)

    nah%muMatch_mQuark = default_or_opt(one, muMatch_mQuark)
    nah%masses_are_MSbar = default_or_opt(.false., masses_are_MSbar)

    nah%quark_masses(1:3) = quark_masses_def(1:3)
    if (present(quark_masses)) then
       nah%quark_masses(4:6) = quark_masses(4:6)
    else
       nah%quark_masses(4:6) = quark_masses_def(4:6)
    end if
    

    !-- work out which ranges are needed
    !   even in the fixnf case these are used as guides
    !   for when to switch dt?
    do i = lbound(nah%quark_masses, dim=1), ubound(nah%quark_masses, dim=1)
       if (tlo > tOfQ(nah%muMatch_mQuark*nah%quark_masses(i))) nah%nlo = i
       if (thi > tOfQ(nah%muMatch_mQuark*nah%quark_masses(i))) nah%nhi = i
    end do

    ! check we have CA=3 and CF=4/3 for the nloop >=4 case
    if (nah%nloop >= 4) then
       if (ca /= ca_def) then
          call wae_error('na_Init','CA/=CA_def not supported for nloop >=4. CA is',dbleval=ca)
       else if (abs(cf - cf_def) > 1e-10_dp) then
          call wae_error('na_Init','CF/=CF_def not supported for nloop >=4. CF is',dbleval=cf)
       else if (abs(tr - tr_def) > 1e-10_dp) then
          call wae_error('na_Init','TR/=TR_def not supported for nloop >=4. TR is',dbleval=tr)
       end if
    end if
    
    
    !-- now set up the parameters of the segments
    allocate(nah%seg(nah%nlo:nah%nhi))
    nbin_total = 0
    do i = nah%nlo, nah%nhi
       seg => nah%seg(i)
       nah%seg(i)%tlo = max(tlo, tOfQ(nah%muMatch_mQuark*nah%quark_masses(i)))
       if (i < nah%nhi) then
          seg%thi = tOfQ(nah%muMatch_mQuark*nah%quark_masses(i+1))
       else
          seg%thi = thi
       end if

       !-- now fix running coupling
       if (nah%fixnf == nofixnf) then
          call qcd_SetNf(i)
       else
          call qcd_SetNf(nah%fixnf)
       end if
       
       !-- lazy person's option for getting number of loops automatically
       !   in derivative calculation
       seg%beta0 = beta0
       select case(nah%nloop)
       case(0)
         seg%beta0 = zero
         seg%beta1 = zero
         seg%beta2 = zero
         seg%beta3 = zero
       case(1)
          seg%beta1 = zero
          seg%beta2 = zero
          seg%beta3 = zero
       case(2)
          seg%beta1 = beta1
          seg%beta2 = zero
          seg%beta3 = zero
       case(3)
          seg%beta1 = beta1
          seg%beta2 = beta2
          seg%beta3 = zero
       case(4)
          seg%beta1 = beta1
          seg%beta2 = beta2
          seg%beta3 = beta3
       case default
          call wae_Error('na_init: unsupported number of loops requested')
       end select

       !-- first guess, which then needs to be "adapted" to the range
       seg%dt    = dt_base * half**(6-i)
       nbin = ceiling((seg%thi - seg%tlo)/seg%dt)
       nbin_total = nbin_total + nbin
       seg%dt    = (seg%thi - seg%tlo) / nbin
       seg%invdt = one / seg%dt
       allocate(seg%ra(0:nbin))
    end do
    !write(0,*) 'new_as: used total bins ', nbin_total


    ! nloop = 0 will be fixed coupling, in which case there is nothing
    ! else to do (we put this after the last of the "allocate"
    ! statements, to help ensure that deallocation works smoothly)
    if (nah%nloop == 0) return

    !-- find out in which segment we start
    tstart = tOfQ(nah%Q)
    do i = nah%nlo, nah%nhi
       if (tstart <= nah%seg(i)%thi .and. tstart >= nah%seg(i)%tlo) exit
    end do
    if (i > nah%nhi) &
         &call wae_Error('na_init: Specified Q not in supported range')
    nseg = i

    !-- fill up the starting segment
    ra = one/nah%alfas
    seg => nah%seg(nseg)
    istart = nint((tstart-seg%tlo)/seg%dt)
    t = tstart
    seg%ra(istart) = na_evolve(ra, seg%tlo+istart*seg%dt - tstart,seg)
    do i = istart+1, ubound(seg%ra,dim=1)
       seg%ra(i) = na_evolve(seg%ra(i-1), seg%dt, seg)
    end do
    do i = istart-1, lbound(seg%ra,dim=1), -1
       seg%ra(i) = na_evolve(seg%ra(i+1), -seg%dt, seg)
    end do
    seg%iflip = istart

    ! handle pole v. MSbar mass treatment
    if (nah%masses_are_MSbar) then
      alphastep20_lclscheme = alphastep20_msbar
      alphastep30_lclscheme = alphastep30_msbar
      alphastep31_lclscheme = alphastep31_msbar
      alphastep31_inv_lclscheme = alphastep31_msbar_inv
      alphastep30_nl_lclscheme = alphastep30_msbar_nl
      alphastep31_nl_lclscheme = alphastep31_msbar_nl
    else
      alphastep20_lclscheme = alphastep20_pole
      alphastep30_lclscheme = alphastep30_pole
      alphastep31_lclscheme = alphastep31_pole
      alphastep31_inv_lclscheme = alphastep31_pole_inv
      alphastep30_nl_lclscheme = alphastep30_pole_nl
      alphastep31_nl_lclscheme = alphastep31_pole_nl
    end if

    !-- fill up the segments above
    do j = nseg+1, nah%nhi
       seg => nah%seg(j)
       alfas_here = one/nah%seg(j-1)%ra(ubound(nah%seg(j-1)%ra,dim=1))
       if (mass_steps_on .and. nah%fixnf == nofixnf) then
          !write(0,*) '------ changing as from ',j-1,' to ',j
          !write(0,*) j-1, alfas_here
          lnmatch = two*log(nah%muMatch_mQuark)
          select case (nah%nloop)
          case(2)
             alfas_here = alfas_here*(1 + alphastep11 * lnmatch * alfas_here)
          case(3)
             alfas_here = alfas_here*(1 + alphastep11 * lnmatch * alfas_here&
                  & + (alphastep22 * lnmatch**2 + alphastep21 * lnmatch&
                  &    + alphastep20_lclscheme)*alfas_here**2)
          case(4)
             alfas_here = alfas_here*(1 + alphastep11 * lnmatch * alfas_here&
                  & + (alphastep22 * lnmatch**2 + alphastep21 * lnmatch&
                  & + alphastep20_lclscheme)*alfas_here**2&
                  & + (alphastep33 * lnmatch**3 + alphastep32_inv * lnmatch**2&
                  & + (alphastep31_inv_lclscheme - (j-1) * alphastep31_nl_lclscheme) * lnmatch & 
                  & + (-alphastep30_lclscheme - (j-1) * alphastep30_nl_lclscheme))*alfas_here**3)
          end select
       end if
       seg%ra(0) = one/alfas_here
       ! recall that this is the reciprocal of alpha!
       do i = 1, ubound(seg%ra,dim=1)
          seg%ra(i) = na_evolve(seg%ra(i-1), seg%dt, seg)
       end do
       seg%iflip = -1
    end do
    
    !-- fill up the segments below
    do j = nseg-1, nah%nlo, -1
       seg => nah%seg(j)
       alfas_here = one/nah%seg(j+1)%ra(0)
       if (mass_steps_on .and. nah%fixnf == nofixnf) then
!          write(0,*) '------ changing as from ',j+1,' to ',j
!          write(0,*) j+1, alfas_here
          lnmatch = two*log(nah%muMatch_mQuark)
          select case (nah%nloop)
          case(2)
             alfas_here = alfas_here*(1 - alphastep11 * lnmatch * alfas_here)
          case(3)
             alfas_here = alfas_here*(1 - alphastep11 * lnmatch * alfas_here&
                  & + (alphastep22 * lnmatch**2 - alphastep21 * lnmatch&
                  &    - alphastep20_lclscheme)*alfas_here**2)
          case(4)
             alfas_here = alfas_here*(1 - alphastep11 * lnmatch * alfas_here&
                  & + (alphastep22 * lnmatch**2 - alphastep21 * lnmatch&
                  & - alphastep20_lclscheme)*alfas_here**2&
                  & + (-alphastep33 * lnmatch**3 - alphastep32 * lnmatch**2&
                  & + (-alphastep31_lclscheme + j * alphastep31_nl_lclscheme) * lnmatch & 
                  & + (alphastep30_lclscheme + j * alphastep30_nl_lclscheme))*alfas_here**3)
          end select
!          write(0,*) j, alfas_here
!          write(0,*) 'Coefficients', alphastep20_lclscheme * pisq
       end if
       seg%ra(ubound(seg%ra,dim=1)) = one/alfas_here
       do i = ubound(seg%ra,dim=1)-1, 0, -1
          seg%ra(i) = na_evolve(seg%ra(i+1), -seg%dt, seg)
       end do
       seg%iflip = ubound(seg%ra,dim=1)+1
    end do

    !--- set things back to their origins
    call qcd_SetNf(nf_store)
  end subroutine na_init
  

  !-------------------------------------------------------------------------
  ! If fixnf is present, then the program will force (within limits of +-dt)
  ! the alpha that is returned to be that corresponding to fixnf flavours.
  ! 
  ! With smooth matching conditions, this is not a big deal, but with
  ! steps at alpha_s thresholds, it is important so that certain D.E.
  ! routines (e.g. for PDF evolution) do not give alpha values at end 
  ! points that give non-smoothness.
  function na_Value_full(nah, Q, fixnf) result(res)
    type(na_handle), intent(in), target :: nah
    real(dp),        intent(in)         :: Q
    integer,         intent(in), optional :: fixnf
    real(dp)                            :: res
    !-------------------------------------
    real(dp) :: t, trescaled, ra, delta_t
    integer  :: nseg, i, n
    integer, save :: warn_id = warn_id_INIT
    integer, parameter :: max_warn = 1
    type(na_segment), pointer :: seg

    if (nah%nloop == 0) then
      res = nah%alfas
      return
    end if

    t = tOfQ(Q)

    if (present(fixnf) .and. nah%fixnf == nofixnf) then
       if (fixnf < nah%nlo .or. fixnf > nah%nhi) then
          call wae_error('na_Value_full:', 'the fixnf requested is&
               & outside the range supported this na_handle')
       end if
       if (t < tlo .or. t > thi) then
          call wae_error('na_Value_full:', 'the Q value is&
               & outside the range supported this na_handle')
       end if
       nseg = fixnf
       !if (t > nah%seg(nseg)%thi+ nah%seg(nseg)%dt .or.&
       !     & t < nah%seg(nseg)%tlo-nah%seg(nseg)%dt) then
       !   call wae_error('na_Value_full:', &
       !        &  'With fixnf, Q is too far outside supported range.')
       !end if
    else
       if (present(fixnf) .and. nah%fixnf /= nofixnf) then
          if (fixnf /= nah%fixnf) then
             call wae_error('na_Value_full:', 'the fixnf requested is &
                  &different from that supported by na_handle')
          end if
       end if
       do nseg = nah%nlo, nah%nhi
          if (t <= nah%seg(nseg)%thi .and. t >= nah%seg(nseg)%tlo) exit
       end do
       if (nseg > nah%nhi) &
            &call wae_Error('na_Value_full: Specified Q is not in supported range'&
            &,dbleval=Q)
    end if
    
    seg => nah%seg(nseg)
    trescaled = (t - seg%tlo)/seg%dt
    if (trescaled > seg%iflip) then
       i = floor(trescaled)
    else
       i = ceiling(trescaled)
    end if
    i = max(0,min(ubound(seg%ra,dim=1),i))

    !-- support going well beyond supported limits of this nf, even
    !   if the procedure is not particularly recommended.
    delta_t = t - (seg%tlo+i*seg%dt)
    if (abs(delta_t) <= 1.3_dp*seg%dt) then
       res = one/na_evolve(seg%ra(i), delta_t, seg)
    else
       call wae_warn(max_warn,warn_id,'na_Value_full: will evolve &
            &fixed-nf alpha_s beyond precalculated range.',&
            &'This procedure may be very slow, Q=', dbleval=Q)
       !write(0,*) Qoft(seg%tlo),Qoft(seg%thi),Q
       n = ceiling(abs(delta_t/seg%dt))
       delta_t = delta_t/n
       ra = seg%ra(i)
       do i = 1, n
          ra = na_evolve(ra,delta_t, seg)
       end do
       res = one/ra
    end if
    !write(0,'(f15.10,i,f15.12)') t, nseg, res ! HOPPER TESTING
  end function na_Value_full

  !! Faster evaluation of alpha_s, with fewer options; reverts
  !! to _full for some edge cases and also doesn't have the 
  !! fixnf option
  function na_Value(nah, Q, fixnf) result(res)
    use interpolation_coeffs; use interpolation
    type(na_handle), intent(in), target :: nah
    real(dp),        intent(in)         :: Q
    integer,         intent(in), optional :: fixnf
    real(dp) :: res
    !---------------
    real(dp) :: t, tnorm, tdarr(0:4), itd, prod
    ! on M2Pro-gfortran15-O3 there's a small (~2%, 0.2ns out of 10ns) speed advantage
    ! in having the interpolation coefficients hard-coded here
    real(dp), parameter :: coeffs(0:4) = [one/24.0_dp, -one/6.0_dp, one/4.0_dp, -one/6.0_dp, one/24.0_dp]
    integer  :: iseg, it, i
    type(na_segment), pointer :: this_seg
    
    if (present(fixnf)) then
      res = na_Value_full(nah, Q, fixnf)
      return
    end if

    t = tofQ(Q)
    if (t < nah%seg(nah%nlo)%tlo .or. t > nah%seg(nah%nhi)%thi) then
      res = na_Value_full(nah,Q)
      return
    end if

    ! choose the segment
    do iseg = nah%nlo, nah%nhi
      if (t <= nah%seg(iseg)%thi) exit
    end do

    this_seg => nah%seg(iseg)
    if (ubound(this_seg%ra,1) < 4) then
      ! not enough points to do the interpolation, so just use na_value_full
      res = na_Value_full(nah,Q)
      return
    end if

    ! 2025-09-06: on M2Pro -O3 gfortran, save about 1ns by using multiplication rather than division
    tnorm = (t - this_seg%tlo) * this_seg%invdt
    it = int(tnorm)
    if (it == tnorm) then
      res = one/this_seg%ra(it)
      return
    end if

    ! M2Pro gfortran 15 -O3, save about 0.5 ns with explicit if rather than min,max
    ! So do not use `it = min(max(it - 2,0),ubound(this_seg%ra,1)-4)`
    if (it < 0) then
      it = it + 2
    else if (it + 4 > ubound(this_seg%ra,1)) then
      it = ubound(this_seg%ra,1) - 4
    end if

    itd = it
    ! This route gives a total timing of 10.0-10.2 ns on M2Pro-gfortran15-O3
    tdarr = (tnorm - itd) - [0.0_dp, 1.0_dp, 2.0_dp, 3.0_dp, 4.0_dp]
    !!! this route involves a division, but on M2Pro-gfortran15-O3 save 0.2-0.3ns
    prod = product(tdarr)
    res = prod * sum((coeffs * this_seg%ra(it:it+4)) / tdarr)

    ! this route skips divisions but on M2Pro-gfortran15-O3 costs an extra 0.2-0.3ns
    !block
    !  real(dp) :: prodsl(0:4), prodsr(0:4)
    !  prodsl(0) = one
    !  prodsr(4) = one
    !  do i = 1,4
    !    prodsl(i) = prodsl(i-1) * tdarr(i-1)
    !    prodsr(4-i) = prodsr(5-i) * tdarr(5-i)
    !  end do
    !  res = sum(prodsl * prodsr * this_seg%ra(it:it+4) * coeffs)
    !end block 

    !! alt1: 12.2-12.4 ns
    !call fill_interp_weights4(tnorm-itd, tdarr)
    !! alt2: 14.7-15.0 ns
    !call uniform_interpolation_weights(tnorm-itd, tdarr)
    !res = sum(tdarr * this_seg%ra(it:it+4))

    res = one / res
  end function na_Value


  !======================================================================
  !! Returns the number of loops in this coupling
  integer function na_NumberOfLoops(nah)
    type(na_handle), intent(in) :: nah
    na_NumberOfLoops = nah%nloop
  end function na_NumberOfLoops
  
  !-------------------------------------------------------------
  !! Do all the necessary cleaning up
  subroutine na_Del(nah)
    type(na_handle), intent(inout) :: nah
    integer :: i, status
    do i = nah%nlo, nah%nhi
       deallocate(nah%seg(i)%ra, stat=status)
    end do
    deallocate(nah%seg, stat=status)
  end subroutine na_Del

  
  !======================================================================
  !! Return the mass of the quark specified by iflv
  real(dp) function na_QuarkMass(nah,iflv) result(mass)
    type(na_handle), intent(in) :: nah
    integer,         intent(in) :: iflv
    if (iflv > 6 .or. iflv < 1) call wae_error('na_QuarkMass', &
         &'illegal value for iflv', intval=iflv)
    mass = nah%quark_masses(iflv)
  end function na_QuarkMass

  !-------------------------------------------------------------
  ! return true if the quark masses are in the MSbar scheme
  logical function na_QuarkMassesAreMSbar(nah) result(res)
    type(na_handle), intent(in) :: nah
    res = nah%masses_are_MSbar
  end function na_QuarkMassesAreMSbar
  

  !-------------------------------------------------------------
  !! Indicate the range of nf values supported by this handle.
  subroutine na_nfRange(nah,nflo,nfhi)
    type(na_handle), intent(in)  :: nah
    integer,         intent(out) :: nflo, nfhi
    if (nah%fixnf == nofixnf) then
       nflo = nah%nlo
       nfhi = nah%nhi
    else
       nflo = nah%fixnf
       nfhi = nah%fixnf
    end if
  end subroutine na_nfRange

  
  !-------------------------------------------------------------
  !! Returns the number of flavours relevant for scale Q
  !! Also returns the range of Qvalues (Qlo, Qhi) for which 
  !! this value of nf remains the same.
  subroutine na_nfAtQ(nah, Q, nfAtQ, Qlo, Qhi, muM_mQ)
    type(na_handle), intent(in)  :: nah
    real(dp),        intent(in)  :: Q
    integer,         intent(out) :: nfAtQ
    real(dp),        intent(out), optional :: Qlo, Qhi
    real(dp),        intent(in),  optional :: muM_mQ
    !-----------------------------
    real(dp) :: deltat_match
    real(dp) :: t
    integer  :: nseg
    real(dp) :: mtlo(nah%nlo:nah%nhi), mthi(nah%nlo:nah%nhi)


    deltat_match = tofQ(default_or_opt(&
         &nah%muMatch_mQuark, muM_mQ)/nah%muMatch_mQuark)

    !-- redefine limits so as to account for requested matching
    !   thresholds muM_mQ. Outer limits should not be modified
    !   since they are rigidly fixed?
    !
    !   What happens if one of these intervals becomes negative?
    mtlo(nah%nlo+1:nah%nhi) = nah%seg(nah%nlo+1:nah%nhi)%tlo + deltat_match
    mthi(nah%nlo:nah%nhi-1) = nah%seg(nah%nlo:nah%nhi-1)%thi + deltat_match
    mtlo(nah%nlo) = nah%seg(nah%nlo)%tlo
    mthi(nah%nhi) = nah%seg(nah%nhi)%thi

    t = tOfQ(Q)
    if (nah%fixnf == nofixnf) then
       do nseg = nah%nlo, nah%nhi
          if (t <= mthi(nseg) .and. t >= mtlo(nseg)) exit
       end do
       if (nseg > nah%nhi) &
            &call wae_Error('na_nfAtQ: Specified Q is not in supported range:'&
            &,dbleval=Q)
       nfAtQ = nseg
       if (present(Qlo) .and. present(Qhi)) then
          Qlo = QOft(mtlo(nseg))
          Qhi = QOft(mthi(nseg))
       end if
    else
       if (t > thi .or. t < tlo) then
          call wae_Error('na_nfAtQ: Specified Q is not in supported range'&
            &,dbleval=Q)
       end if
       nfAtQ = nah%fixnf
       if (present(Qlo) .and. present(Qhi)) then
          Qlo = QOft(tlo)
          Qhi = QOft(thi)
       end if
    end if
  end subroutine na_nfAtQ

  
  !-------------------------------------------------------------
  ! returns the Q range for a given value of nf. If supported.
  subroutine na_QRangeAtNf(nah, nflcl, Qlo, Qhi, muM_mQ)
    type(na_handle), intent(in)  :: nah
    integer,         intent(in)  :: nflcl
    real(dp),        intent(out) :: Qlo, Qhi
    real(dp), optional, intent(in) :: muM_mQ
    !---------------------------------------
    real(dp) :: deltat_match
    character(len=60) :: string

    deltat_match = tofQ(default_or_opt(&
         &nah%muMatch_mQuark, muM_mQ)/nah%muMatch_mQuark)

    if (nah%fixnf == nofixnf) then
       if (nflcl < nah%nlo .or. nflcl > nah%nhi) then
          write(string,'(a,i2,a)') 'nf value ',nflcl,' not supported'
          call wae_Error('QrangeAtNf', trim(string))
       end if
       if (nflcl == nah%nlo) then
          Qlo = QOft(nah%seg(nflcl)%tlo)
       else
          Qlo = QOft(nah%seg(nflcl)%tlo + deltat_match)
       end if
       if (nflcl == nah%nhi) then
          Qhi = QOft(nah%seg(nflcl)%thi)
       else
          Qhi = QOft(nah%seg(nflcl)%thi + deltat_match)
       end if
    else
       if (nflcl /= nah%fixnf) then
          write(string,'(a,i2,a)') 'nf value ',nflcl,' not supported'
          call wae_Error('QrangeAtNf', trim(string))
       end if
       Qlo = QOft(tlo)
       Qhi = QOft(thi)
    end if
  end subroutine na_QRangeAtNf
  
  
  !------------------------------------------------------------
  ! given ra return the value evolve by dt
  function na_evolve(ra,dt, seg) result(res)
    use runge_kutta
    real(dp), intent(in) :: ra, dt
    class(*), intent(in) :: seg
    !----------------------------------
    real(dp) :: res,t
    t = zero
    res = ra
    !call rkstp_arg(dt,t,res,na_deriv,seg)
    call rkstp_arg(dt,t,res,na_deriv,seg)
  end function na_evolve
  
  !---------------------------------------------------------
  !! derivative of 1/alpha
  subroutine na_deriv(t, ra, dra, seg)
    real(dp), intent(in)  :: t, ra
    real(dp), intent(out) :: dra
    class(*), intent(in)  :: seg

    select type(seg)
    type is (na_segment)
      dra = seg%beta0 + seg%beta1/ra + seg%beta2/ra**2 + seg%beta3/ra**3
    class default
      call wae_error('na_deriv: unknown polymorphic type for seg')
    end select
  end subroutine na_deriv

  !! Function that returns t = 2*log(Q).
  !! It is coded as a separate function to avoid the risk of forgetting
  !! the factor of 2 in the log and to allow for checks that Q is not zero.
  function tOfQ(Q)
    real(dp), intent(in) :: Q
    real(dp)             :: tOfQ
    if (Q <= zero) then
      ! anything that is too small is set to a very negative value for tofQ;
      ! Recall: huge(Q) is the largest representable number of the same type as Q.
      tOfQ = -huge(Q)
    else
      tOfQ = two * log(Q)
    end if
  end function tOfQ

  !! Function that returns Q = exp(half*t).
  function QOft(t)
    real(dp), intent(in) :: t
    real(dp)             :: QOft
    QOft = exp(half*t)
  end function QOft
  
end module new_as

!! program for comparing format produced by "prec_and_timing [...] -outputgrid" 
!!
!! Usage:
!!   progname file1 file2 {-summary | -channel ic [-minerr val] [-maxerr val]} [-protect]
!!
!! Arguments:
!!
!! -summary: print a single-line summary of the relative differences between files
!!
!! -channel ic: the flavour channel to consider (ic = 11 for all flavours)
!!
!! -protect: apply a protection mask to eliminate points close to a sign change
!!           (hard-coded to be within 0.4 in y and within one grid point in Q)
!!
!! -minerr val: only print errors greater than val
!! -maxerr val: only print errors less than val
!!
program compare2file_v2
  use io_utils
  use types; use consts_dp
  implicit none
  character(len=300) :: line1, line2
  integer :: idev1, idev2, iostat
  integer, parameter :: maxn = 200

  real(dp) :: max07_guds, max07_all, err_guds, err_all
  real(dp) :: max09_guds, max09_all
  real(dp) :: res1(maxn,maxn,-5:5) = zero
  real(dp) :: res2(maxn,maxn,-5:5) = zero
  real(dp) :: err (maxn,maxn,-5:5)
  real(dp) :: yval(maxn), Qval(maxn,maxn), xval(maxn)
  logical  :: mask  (maxn,maxn,-5:5)=.true.
  logical  :: mask07(maxn,maxn,-5:5)=.false.
  logical  :: mask09(maxn,maxn,-5:5)=.false.
  real(dp) :: y,Q, minerr, maxerr, this_err, true_err, Qmin
  integer  :: iy, iQ, ny, nQ, ic, icmax, idy, ml(3)
  real(dp) :: yval2, Qval2
  logical  :: do_help

  if (COMMAND_ARGUMENT_COUNT() < 2) then
     do_help = .true.
  else
     do_help = trim(string_val_arg(1)) == "-h"
  end if
  if (do_help) then
       write(6,"(a)") "Usage: " // trim(command_line()) // &
                      " file1 file2 {-summary | -channel ic [-minerr val] [-maxerr val]} [-protect]"
       write(6,"(a)") ""
       write(6,"(a)") "Arguments:"
       write(6,"(a)") ""
       write(6,"(a)") "-summary: print a single-line summary of the relative differences between files"
       write(6,"(a)") ""
       write(6,"(a)") "-channel ic: print out an x,Q grid for the given flavour channel (ic = 11 for all flavours)"
       write(6,"(a)") ""
       write(6,"(a)") "-protect: apply a protection mask to eliminate points close to a sign change"
       write(6,"(a)") "          (hard-coded to be within 0.4 in y and within one grid point in Q)"
       write(6,"(a)") ""
       write(6,"(a)") "-minerr val: only print errors greater than val"
       write(6,"(a)") "-maxerr val: only print errors less than val"
       write(6,"(a)") "-Qmin val: only consider points with Q >= val (default 0.0)"
       stop
   end if

  idev1 = idev_open_arg(1,status='old')
  idev2 = idev_open_arg(2,status='old')
  Qmin = dble_val_opt("-Qmin",0.0_dp)

  write(6,"(a)") "# " // trim(command_line())
  write(6,"(a)") "# Comparing files " // trim(string_val_arg(1)) // " and " // trim(string_val_arg(2))

  iy = 1; iQ = 1
  outer: do
     read(idev1,'(a)',iostat=iostat) line1
     if (iostat /= 0) exit outer
     !do while(.true.)
     !   if (len_trim(line1) > 0 .and. line1(1:1) /= "") exit
     !end do
     read(idev2,'(a)',iostat=iostat) line2
     if (iostat /= 0) exit outer
     !do while(.true.)
     !   read(line2,*,iostat=iostat) yval2,Qval2,res2(iy,iQ,:)
     !   if (iostat == 0) exit
     !end do
     !read(idev2,'(a)',iostat=iostat) line2
     !if (iostat /= 0) exit

     ! keep track of indicies
     if (trim(line1) == "") then
        ny = iy - 1
        iy = 1
        iQ = iQ + 1
     end if

     read(line1,*,iostat=iostat) yval(iy),Qval(iy,iQ),res1(iy,iQ,:)
     if (iostat /= 0) cycle
     read(line2,*,iostat=iostat) yval2,Qval2,res2(iy,iQ,:)
     if (iostat /= 0) ERROR STOP "Second file has a different format than the first one"
     if (yval(iy) /= yval2 .or. Qval(iy,iQ) /= Qval2) then
        write(6,"(a)") "Mismatch in y or Q values in input files"
        write(6,"(a)") line1
        write(6,"(a)") line2
        stop
     end if
     iy = iy + 1
  end do outer
  nQ = iQ - 1

  write(6,"(a,f10.4,a,f20.4)") "# yrange ", minval(yval(1:ny)), "-", maxval(yval(1:ny))
  write(6,"(a,f10.4,a,f20.4)") "# Qrange ", minval(Qval(1:ny,1:nQ)), "-", maxval(Qval(1:ny,1:nQ))

  ! establish a general protection mask -- if there is a sign change
  ! in the neighbourhood of the point then it should be eliminated.
  ! Work out dy neighbourhood
  idy = nint(0.4_dp / (yval(ny)-yval(ny-1)))
  if (log_val_opt('-protect')) then
     forall(iQ=1:nQ)
        forall(iy=1:ny)
           ! check for sign change in x direction
           mask(iy,iQ,:) = mask(iy,iQ,:) .and. &
                &   minval(res2(max(iy-idy,1):min(iy+idy,ny), iQ,:),dim=1) *&
                &   maxval(res2(max(iy-idy,1):min(iy+idy,ny), iQ,:),dim=1) > 0
           ! check for sign change in Q direction
           mask(iy,iQ,:) = mask(iy,iQ,:) .and. &
                &   minval(res2(iy,max(iQ-1,1):min(iQ+1,nQ),:),dim=1) *&
                &   maxval(res2(iy,max(iQ-1,1):min(iQ+1,nQ),:),dim=1) > 0
        end forall
     end forall
  end if

  ! now get masks for the x range
  xval(:ny) = exp(-yval(:ny))
  mask  (:ny,:nQ,:) = mask(:ny,:nQ,:) .and. spread(Qval(:ny,:nQ)>=Qmin,3,11)
  mask07(:ny,:nQ,:) = mask(:ny,:nQ,:) .and. spread(spread(xval<0.7_dp,2,nQ),3,11)
  mask09(:ny,:nQ,:) = mask(:ny,:nQ,:) .and. spread(spread(xval<0.9_dp,2,nQ),3,11)


  ! now establish errors
  where (res2 /= zero)
     err = abs(res1/res2 - one)
  elsewhere
     err = zero
  end where
  
  
  max07_guds = maxval(err(:ny,:nQ,0:3),mask07(:ny,:nQ,0:3))
  max09_guds = maxval(err(:ny,:nQ,0:3),mask09(:ny,:nQ,0:3))
  max07_all  = maxval(err(:ny,:nQ,-5:5),mask07(:ny,:nQ,-5:5))
  max09_all  = maxval(err(:ny,:nQ,-5:5),mask09(:ny,:nQ,-5:5))

  ml = maxloc(err(:ny,:nQ,0:3),mask09(:ny,:nQ,0:3));
  !write(0,*) yval(ml(1)), Qval(ml(1),ml(2)), ml(3)-1

  if (log_val_opt("-summary")) then
   write(6,"(a)") "# Summary of relative errors"
   
   write(6,"(a)") "# max rel error across: guds(x< 0.7), all(x< 0.7), guds(x< 0.9), all(x< 0.9)"
   write(6,"(4es20.10)") max07_guds, max07_all, max09_guds, max09_all
  end if
  
  if (log_val_opt("-channel")) then
     ic = int_val_opt("-channel")
     minerr = dble_val_opt("-minerr",zero)
     maxerr = dble_val_opt("-maxerr",1e100_dp)
     write(6,'(a,i3,a)') "# Flavour channel ", ic, &
        " (-5:5 means difference for that flavour; 11 means max difference across all flavours)"
     write(6,'(a)') "# Columns: y(=ln1/x) Q max_masked_difference max_difference maxflav_masked"
     do iQ = 1, nQ
        do iy = 1, ny
           if (ic == 11) then
              ! do all flavours
              true_err = maxval(err(iy,iQ,-5:5))
              if (any(mask(iy,iQ,:))) then
                 this_err = maxval(err(iy,iQ,-5:5),mask(iy,iQ,-5:5))
                 icmax = maxloc(err(iy,iQ,-5:5),mask=mask(iy,iQ,-5:5),dim=1) - 6 ! 1: -> -5:
              else
                 icmax = 11
                 this_err = -one
              end if
           else 
              icmax = ic
              true_err = err(iy,iQ,ic)
              if (.not.mask(iy,iQ,ic)) then
                 this_err = -one
              else
                 this_err = true_err
              end if
           end if
           if (this_err >= minerr .and. this_err <= maxerr) then
              write(6,'(4es20.12,i3,es20.12)') yval(iy), Qval(iy,iQ), this_err, true_err, icmax, merge(res1(iy,iQ,ic),zero,ic/=11)
           end if
        end do
        write(6,*)
     end do
  end if

  !-- security ----------------------
  if (.not. CheckAllArgsUsed(0)) stop
  !----------------------------------

end program compare2file_v2

module qed_objects
  use types; use consts_dp
  use convolution; use qcd
  use pdf_representation
  use qed_coupling_module
  use warnings_and_errors
  implicit none
  private

  ! a leading-order splitting matrix (multiplies alpha/2pi)
  type qed_split_mat_lo
     type(grid_conv) :: Pqq_01, Pqy_01, Pyq_01, Pyy_01
     integer         :: nu, nd, nl, nf
  end type qed_split_mat_lo

  ! a NLO splitting matrix (multiplies (alpha alpha_s)/(2pi)^2)
  type qed_split_mat_nlo
     type(grid_conv) :: Pqy_11, Pyy_11, Pgy_11
     type(grid_conv) :: Pqg_11, Pyg_11, Pgg_11
     type(grid_conv) :: PqqV_11, PqqbarV_11, Pgq_11, Pyq_11
     integer         :: nu, nd, nl, nf
  end type qed_split_mat_nlo

  ! a NNLO splitting matrix (multiplies ( alpha/(2pi) )^2) 
  ! contains only Plq splitting!
  type qed_split_mat_nnlo 
     type(grid_conv) :: Plq_02
     integer         :: nu, nd, nl, nf
  end type qed_split_mat_nnlo

  ! a container for both LO and NLO splitting matrices
  type qed_split_mat
     type(qed_split_mat_lo)  :: lo
     type(qed_split_mat_nlo) :: nlo
     type(qed_split_mat_nnlo) :: nnlo
   ! only with F2003
   !contains
   !  procedure :: SetNf => QEDSplitMatSetNf
  end type qed_split_mat
  public :: qed_split_mat
  public :: InitQEDSplitMat
  public :: QEDSplitMatSetNf

  
  interface operator(*)
     module procedure conv_qed_lo, conv_qed_nlo, conv_qed_nnlo
  end interface operator(*)
  public :: operator(*)
  interface operator(.conv.)
     module procedure conv_qed_lo, conv_qed_nlo, conv_qed_nnlo
  end interface operator(.conv.)
  public :: operator(.conv.)

  interface Copy
     module procedure Copy_qed_split_mat_lo, Copy_qed_split_mat_nlo, Copy_qed_split_mat_nnlo, Copy_qed_split_mat
  end interface Copy
  public :: Copy
  
  interface Delete
     module procedure Delete_qed_split_mat_lo, Delete_qed_split_mat_nlo, Delete_qed_split_mat_nnlo, Delete_qed_split_mat
  end interface
  public :: Delete


  ! 8 is photon, 9,10,11 are leptons (each is lepton + anti-lepton)
  integer, parameter, public :: ncompmaxLeptons = 11
  integer, parameter, public :: ncompmaxPhoton  = 8

  public :: AllocPDFWithPhoton, AllocPDFWithLeptons

  integer, parameter, public :: iflv_photon   =  8
  ! NB: convention here is that electron, muon and tau contain the sum
  !     of the particle and anti-particle distributions
  integer, parameter, public :: iflv_electron =  9
  integer, parameter, public :: iflv_muon     = 10
  integer, parameter, public :: iflv_tau      = 11

  logical, public :: OffLeptonChargesFrom=.false.
  logical, public :: OffLeptonChargesTo=.false.
  logical, public :: OffNlGammaGamma=.false.
  
contains

  !------------------------------------------
  subroutine AllocPDFWithPhoton(grid, pdf)
    type(grid_def), intent(in) :: grid
    real(dp),       pointer    :: pdf(:,:)
    
    call AllocGridQuant(grid,  pdf, ncompmin, ncompmaxPhoton)
  end subroutine AllocPDFWithPhoton

  !------------------------------------------
  subroutine AllocPDFWithLeptons(grid, pdf)
    type(grid_def), intent(in) :: grid
    real(dp),       pointer    :: pdf(:,:)
    
    call AllocGridQuant(grid,  pdf, ncompmin, ncompmaxLeptons)
  end subroutine AllocPDFWithLeptons
  
    
  
  !------------------------------------------
  subroutine InitQEDSplitMat(grid, qed_split)
    use qed_splitting_functions
    type(grid_def),      intent(in)    :: grid
    type(qed_split_mat), intent(inout) :: qed_split
    integer :: nl, nd, nu
    real(dp) :: fy_over_fg

    call InitGridConv(grid, qed_split%lo%Pqq_01, sf_Pqq_01)
    call InitGridConv(grid, qed_split%lo%Pyq_01, sf_Pyq_01)
    call InitGridConv(grid, qed_split%lo%Pqy_01, sf_Pqy_01)
    call InitGridConv(grid, qed_split%lo%Pyy_01, sf_Pyy_01)

    call InitGridConv(grid, qed_split%nlo%Pqg_11, sf_Pqg_11)
    call InitGridConv(grid, qed_split%nlo%Pyg_11, sf_Pyg_11)
    call InitGridConv(grid, qed_split%nlo%Pgg_11, sf_Pgg_11)

    ! get the fy splitting functions from the fg ones 
    fy_over_fg = CF * CA / TR 
    call InitGridConv(qed_split%nlo%Pqy_11, qed_split%nlo%Pqg_11, fy_over_fg)
    call InitGridConv(qed_split%nlo%Pgy_11, qed_split%nlo%Pyg_11, fy_over_fg)
    call InitGridConv(qed_split%nlo%Pyy_11, qed_split%nlo%Pgg_11, fy_over_fg)

    call InitGridConv(grid, qed_split%nlo%PqqV_11, sf_PqqV_11)
    call InitGridConv(grid, qed_split%nlo%PqqbarV_11, sf_PqqbarV_11)
    call InitGridConv(grid, qed_split%nlo%Pgq_11, sf_Pgq_11)
    call InitGridConv(qed_split%nlo%Pyq_11, qed_split%nlo%Pgq_11) ! identical...

    call InitGridConv(grid, qed_split%nnlo%Plq_02, sf_Plq_02)

    ! set some vaguely sensible values (the splitting functions
    ! themselves don't depend on nf at the order we are dealing with)
    nl = 3
    nd = (nf_int+1) / 2
    nu = (nf_int  ) / 2
    call QEDSplitMatSetNf(qed_split, nl, nd, nu)
  end subroutine InitQEDSplitMat

  !----------------------------------------------------------------------
  subroutine QEDSplitMatSetNf(qed_sm, nl, nd, nu)
    type(qed_split_mat) :: qed_sm
    integer, intent(in) :: nl, nu, nd

    qed_sm%lo%nl = nl
    qed_sm%lo%nd = nd
    qed_sm%lo%nu = nu
    qed_sm%lo%nf = nd+nu
    
    qed_sm%nlo%nl = nl
    qed_sm%nlo%nd = nd
    qed_sm%nlo%nu = nu
    qed_sm%nlo%nf = nd+nu

    qed_sm%nnlo%nl = nl
    qed_sm%nnlo%nd = nd
    qed_sm%nnlo%nu = nu
    qed_sm%nnlo%nf = nd+nu    
  end subroutine QEDSplitMatSetNf
  

  !----------------------------------------------------------------------
  function conv_qed_lo(qed_lo, gq) result(gout)
    type(qed_split_mat_lo), intent(in) :: qed_lo
    real(dp),               intent(in) :: gq(0:, ncompmin:)
    real(dp)                           :: gout(0:ubound(gq,dim=1), ncompmin:ubound(gq,dim=2))
    !---------------------------------------
    real(dp) :: flvsum(0:ubound(gq,dim=1)), flvout(0:ubound(gq,dim=1))
    integer  :: i
    ! the charge, colour, etc. factor when branching from a flavour;
    ! we allow for the leptons here, even if not using them, to
    ! allow for photon branching to them...
    real(dp) :: chg2_fromflv(ncompmin:ncompmaxLeptons)
    ! the charge, colour, etc. factor when branching to a flavour
    real(dp) :: chg2_toflv   (ncompmin:ncompmaxLeptons), sum_chg2_tofl
    

    ! for now we force this...
    if (GetPdfRep(gq(:,:ncompmax)) /= pdfr_Human) call wae_error('conv_qed_lo',&
         &'gq is not in "Human" format')
    if (ubound(gq,dim=2) < ncompmaxPhoton) call wae_error('conv_qed_lo',&
         &'gq appears not to have photon component')
    
    ! set up the squared electric charges of each of the components
    chg2_fromflv = zero
    chg2_fromflv(-1:(-2*qed_lo%nd+1):-2) = e_dn2
    chg2_fromflv( 1:( 2*qed_lo%nd-1):+2) = e_dn2
    chg2_fromflv(-2:(-2*qed_lo%nu ):-2) = e_up2
    chg2_fromflv( 2:( 2*qed_lo%nu ):+2) = e_up2
    if(OffLeptonChargesFrom) then
       chg2_fromflv(9:9+qed_lo%nl-1) = 0
    else
       chg2_fromflv(9:9+qed_lo%nl-1) = one       
    endif

    ! then set up a charge * multiplicity for branching to a given component
    chg2_toflv = zero
    ! include a factor of CA=NC for the quarks
    chg2_toflv(-6:6) = CA * chg2_fromflv(-6:6)

    ! include a factor of 2 for the leptons, because we sum leptons and
    ! anti-leptons
    chg2_toflv(9:9+qed_lo%nl-1) = two

    if(OffNlGammaGamma) then
       sum_chg2_tofl=sum(chg2_toflv(-6:6))
    else
       sum_chg2_tofl=sum(chg2_toflv)
    endif

    if(OffLeptonChargesTo) then
       chg2_toflv(9:9+qed_lo%nl-1) = 0
    endif

    !write(6,*) nf_int
    !write(6,*) chg2_fromflv
    !write(6,*) chg2_toflv
    
    ! now get the full "photon"-emission power; if the PDF doesn't
    ! include leptons, then the branching from them is not included
    ! (even if nl /= 0 in the splitting matrix)
    flvsum = zero
    do i = ncompmin, min(ubound(gq,dim=2), ncompmaxLeptons)
       if (chg2_fromflv(i) /= zero) flvsum = flvsum + chg2_fromflv(i) * gq(:,i)
    end do
    
    ! now set the result
    gout = zero
    ! first the evolution of the photon from quarks and leptons
    gout(:,8) = qed_lo%Pyq_01 * flvsum
    ! Then the derivative of the photons associated with their "decay" to fermions.
    ! Include a factor of 1/2 because we sum explicitly over quarks and anti-quarks
    ! whereas the original normalisation from eqs.(21&22) of 1512.00612 involves
    ! only a sum over flavours, not anti-flavours
    gout(:,8) = gout(:,8) + (half * sum_chg2_tofl) * (qed_lo%Pyy_01 * gq(:,8))

    ! now the evolution of the quarks and leptons:
    ! first calculate the generic splitting from a photon to a fermion
    ! without any charge or colour factors
    flvout    = qed_lo%Pqy_01 * gq(:,8)
    ! then add it in with appropriate charges
    do i = ncompmin, min(ubound(gq,dim=2), ncompmaxLeptons)
       if (chg2_toflv(i) /= zero) then
          gout(:,i) = chg2_toflv(i) * flvout
          gout(:,i) = gout(:,i) + chg2_fromflv(i) * (qed_lo%Pqq_01 * gq(:,i))
       end if
    end do
    
  end function conv_qed_lo
         
  
  !----------------------------------------------------------------------
  function conv_qed_nlo(qed_nlo, gq) result(gout)
    type(qed_split_mat_nlo), intent(in) :: qed_nlo
    real(dp),                intent(in) :: gq(0:, ncompmin:)
    real(dp)                            :: gout(0:ubound(gq,dim=1), ncompmin:ubound(gq,dim=2))
    !---------------------------------------
    real(dp) :: flvsum(0:ubound(gq,dim=1)), flvout(0:ubound(gq,dim=1))
    integer  :: i
    ! the charge, colour, etc. factor when branching from a flavour;
    ! we allow for the leptons here, even if not using them, to
    ! allow for photon branching to them...
    real(dp) :: chg2_fromflv(ncompmin:ncompmaxPhoton)
    ! the sum over charges (just flavours)
    real(dp) :: chg2sum

    ! for now we force this...
    if (GetPdfRep(gq(:,:ncompmax)) /= pdfr_Human) call wae_error('conv_qed_nlo',&
         &'gq is not in "Human" format')
    if (ubound(gq,dim=2) < ncompmaxPhoton) call wae_error('conv_qed_nlo',&
         &'gq appears not to have photon component')

    ! set up the squared electric charges of each of the components
    ! only use quarks here, because leptons don't contribute at O(alpha alpha_s)
    chg2_fromflv = zero
    chg2_fromflv(-1:(-2*qed_nlo%nd+1):-2) = e_dn2
    chg2_fromflv( 1:( 2*qed_nlo%nd-1):+2) = e_dn2
    chg2_fromflv(-2:(-2*qed_nlo%nu ):-2) = e_up2
    chg2_fromflv( 2:( 2*qed_nlo%nu ):+2) = e_up2
    chg2sum = half * sum(chg2_fromflv) 


    !write(6,*) nf_int
    !write(6,*) chg2_fromflv
    !write(6,*) chg2_toflv
    
    ! now get the full "photon"-emission power; if the PDF doesn't
    ! include leptons, then the branching from them is not included
    ! (even if nl /= 0 in the splitting matrix)
    flvsum = zero
    do i = ncompmin, min(ubound(gq,dim=2), ncompmaxPhoton)
       if (chg2_fromflv(i) /= zero) flvsum = flvsum + chg2_fromflv(i) * gq(:,i)
    end do
    
    ! now set the result
    gout = zero
    ! first the evolution of the gluon and photon from quarks
    gout(:,0) = qed_nlo%Pgq_11 * flvsum
    gout(:,8) = qed_nlo%Pyq_11 * flvsum
    ! Then the derivative of the photons associated with their "decay" to fermions.
    ! Include a factor of 1/2 because we sum explicitly over quarks and anti-quarks
    ! whereas the original normalisation from eqs.(21&22) of 1512.00612 involves
    ! only a sum over flavours, not anti-flavours
    gout(:,8) = gout(:,8) + chg2sum * (qed_nlo%Pyy_11 * gq(:,8) + qed_nlo%Pyg_11 * gq(:,0))
    gout(:,0) = gout(:,0) + chg2sum * (qed_nlo%Pgg_11 * gq(:,0) + qed_nlo%Pgy_11 * gq(:,8))

    ! now the evolution of the quarks:
    ! first calculate the generic splitting from a photon to a fermion
    ! without any charge or colour factors
    flvout    = (qed_nlo%Pqy_11 * gq(:,8) + qed_nlo%Pqg_11 * gq(:,0))
    ! then add it in with appropriate charges
    do i = ncompmin, min(ubound(gq,dim=2), ncompmaxPhoton)
       if (chg2_fromflv(i) /= zero) then
          gout(:,i) = chg2_fromflv(i) * flvout
          gout(:,i) = gout(:,i) + chg2_fromflv(i) * (&
               &qed_nlo%PqqV_11 * gq(:,i) + qed_nlo%PqqbarV_11 * gq(:,-i))
       end if
    end do
    
  end function conv_qed_nlo

  !----------------------------------------------------------------------
  function conv_qed_nnlo(qed_nnlo, gq) result(gout)
    type(qed_split_mat_nnlo), intent(in) :: qed_nnlo
    real(dp),                intent(in) :: gq(0:, ncompmin:)
    real(dp)                            :: gout(0:ubound(gq,dim=1), ncompmin:ubound(gq,dim=2))
    !---------------------------------------
    real(dp) :: flvsum(0:ubound(gq,dim=1)), flvout(0:ubound(gq,dim=1))
    integer  :: i
    ! the charge, colour, etc. factor when branching from a flavour;
    ! we allow for the leptons here, even if not using them, to
    ! allow for photon branching to them...
    real(dp) :: chg2_fromflv(ncompmin:ncompmaxPhoton)
    ! the sum over charges (just flavours)
    real(dp) :: chg2sum
    ! the charge, colour, etc. factor when branching to a flavour
    real(dp) :: chg2_toflv   (ncompmin:ncompmaxLeptons), sum_chg2_tofl

    ! for now we force this...
    if (GetPdfRep(gq(:,:ncompmax)) /= pdfr_Human) call wae_error('conv_qed_nnlo',&
         &'gq is not in "Human" format')
    if (ubound(gq,dim=2) < ncompmaxPhoton) call wae_error('conv_qed_nnlo',&
         &'gq appears not to have photon component')

    ! set up the squared electric charges of each of the components
    ! only use quarks here, because leptons don't contribute at O(alpha alpha_s)
    chg2_fromflv = zero
    chg2_fromflv(-1:(-2*qed_nnlo%nd+1):-2) = e_dn2
    chg2_fromflv( 1:( 2*qed_nnlo%nd-1):+2) = e_dn2
    chg2_fromflv(-2:(-2*qed_nnlo%nu ):-2) = e_up2
    chg2_fromflv( 2:( 2*qed_nnlo%nu ):+2) = e_up2

    ! then set up a charge * multiplicity for branching to a given component
    chg2_toflv = zero
    ! turn on only leptons
    ! include a factor of 2 for the leptons, because we sum leptons and
    ! anti-leptons
    chg2_toflv(9:9+qed_nnlo%nl-1) = two

    ! now get the full "photon"-emission power
    flvsum = zero
    do i = ncompmin, min(ubound(gq,dim=2), ncompmaxPhoton)
       if (chg2_fromflv(i) /= zero) flvsum = flvsum + chg2_fromflv(i) * gq(:,i)
    end do
    
    ! now set the result
    gout = zero
    ! we add only the splitting from a quark to a lepton        
    do i = ncompmin, min(ubound(gq,dim=2), ncompmaxLeptons)
       if (chg2_toflv(i) /= zero) then
          gout(:,i) = qed_nnlo%Plq_02 * flvsum * chg2_toflv(i)
       end if
    end do
        
  end function conv_qed_nnlo

  !----------------------------------------------------------------------
  subroutine Copy_qed_split_mat_lo(in,out)
    type(qed_split_mat_lo), intent(inout) :: in
    type(qed_split_mat_lo), intent(out)   :: out
    out%nu = in%nu
    out%nd = in%nd
    out%nl = in%nl
    out%nf = in%nf
    call InitGridConv(out%Pqq_01, in%Pqq_01)
    call InitGridConv(out%Pqy_01, in%Pqy_01)
    call InitGridConv(out%Pyq_01, in%Pyq_01)
    call InitGridConv(out%Pyy_01, in%Pyy_01)    
  end subroutine Copy_qed_split_mat_lo
  
  !----------------------------------------------------------------------
  subroutine Copy_qed_split_mat_nlo(in,out)
    type(qed_split_mat_nlo), intent(inout) :: in
    type(qed_split_mat_nlo), intent(out)   :: out
    out%nu = in%nu
    out%nd = in%nd
    out%nl = in%nl
    out%nf = in%nf

    call InitGridConv(out%Pqy_11    , in%Pqy_11    )
    call InitGridConv(out%Pyy_11    , in%Pyy_11    )
    call InitGridConv(out%Pgy_11    , in%Pgy_11    )
    call InitGridConv(out%Pqg_11    , in%Pqg_11    )
    call InitGridConv(out%Pyg_11    , in%Pyg_11    )
    call InitGridConv(out%Pgg_11    , in%Pgg_11    )
    call InitGridConv(out%PqqV_11   , in%PqqV_11   )
    call InitGridConv(out%PqqbarV_11, in%PqqbarV_11)
    call InitGridConv(out%Pgq_11    , in%Pgq_11    )
    call InitGridConv(out%Pyq_11    , in%Pyq_11    )
  end subroutine Copy_qed_split_mat_nlo

  !----------------------------------------------------------------------
  subroutine Copy_qed_split_mat_nnlo(in,out)
    type(qed_split_mat_nnlo), intent(inout) :: in
    type(qed_split_mat_nnlo), intent(out)   :: out
    out%nu = in%nu
    out%nd = in%nd
    out%nl = in%nl
    out%nf = in%nf
    call InitGridConv(out%Plq_02, in%Plq_02)
  end subroutine Copy_qed_split_mat_nnlo
  
  !----------------------------------------------------------------------
  subroutine Copy_qed_split_mat(in,out)
    type(qed_split_mat), intent(inout) :: in
    type(qed_split_mat), intent(out)   :: out
    call Copy(in%lo , out%lo )
    call Copy(in%nlo, out%nlo)
    call Copy(in%nnlo, out%nnlo)
  end subroutine Copy_qed_split_mat

  
  !----------------------------------------------------------------------
  subroutine Delete_qed_split_mat_lo(in)
   type(qed_split_mat_lo), intent(inout) :: in
   call Delete(in%Pqq_01)
   call Delete(in%Pqy_01)
   call Delete(in%Pyq_01)
   call Delete(in%Pyy_01)    
 end subroutine Delete_qed_split_mat_lo
 
 !----------------------------------------------------------------------
 subroutine Delete_qed_split_mat_nlo(in)
   type(qed_split_mat_nlo), intent(inout) :: in

   call Delete(in%Pqy_11    )
   call Delete(in%Pyy_11    )
   call Delete(in%Pgy_11    )
   call Delete(in%Pqg_11    )
   call Delete(in%Pyg_11    )
   call Delete(in%Pgg_11    )
   call Delete(in%PqqV_11   )
   call Delete(in%PqqbarV_11)
   call Delete(in%Pgq_11    )
   call Delete(in%Pyq_11    )
 end subroutine Delete_qed_split_mat_nlo

 !----------------------------------------------------------------------
 subroutine Delete_qed_split_mat_nnlo(in)
   type(qed_split_mat_nnlo), intent(inout) :: in
   call Delete(in%Plq_02)
 end subroutine Delete_qed_split_mat_nnlo
 
 !----------------------------------------------------------------------
 subroutine Delete_qed_split_mat(in)
   type(qed_split_mat), intent(inout) :: in
   call Delete(in%lo)
   call Delete(in%nlo)
   call Delete(in%nnlo)
 end subroutine Delete_qed_split_mat

end module qed_objects

!! Module that provides a simple interface for converting various numerical
!! types to strings
module hoppet_to_string
  use types
  implicit none

  interface to_string
     module procedure to_string_dp, to_string_int
  end interface

contains

  function to_string_dp(x,fmt) result(str)
    implicit none
    real(dp), intent(in) :: x
    character(len=*), intent(in), optional :: fmt
    character(len=:), allocatable :: str 
    character(len=100) :: tmp

    if (present(fmt)) then
       write(tmp, fmt) x
    else
       write(tmp, *) x
    end if
    tmp = adjustl(tmp)
    str = tmp(1:len_trim(tmp))
  end function to_string_dp

  function to_string_int(x) result(str)
    implicit none
    integer, intent(in) :: x
    character(len=:), allocatable :: str 
    character(len=100) :: tmp

    write(tmp, *) x
    tmp = adjustl(tmp)
    str = tmp(1:len_trim(tmp))
  end function to_string_int

end module hoppet_to_string

!======================================================================
! interface to exact 3-loop splitting functions, as programmed by Vogt
! (see xpij2e.f and xpns2e.f for details).
!
! There are several things to remember: 
!    . Vogt y == my x
!    . Vogt is normalised to powers of (as/4pi)^3 
!    . colour-factor dependence IS available (taken from qcd module)
!      but only for CF, CA -- TR is fixed to be 1/2
!    . systematic separation in A,B,C functions needs to be
!      taken into account; C function needs to be called with x=0?x
!    . check inclusion of 2nf in qg piece
! 
!----------------------------------------------------------------------
module splitting_functions_nnlo_e
  use types; use consts_dp; use convolution_communicator
  use qcd; use warnings_and_errors
  use xpij2e; use xpns2e
  implicit none
  private

  public :: sf_P2gg, sf_P2qg2nf, sf_P2PS, sf_P2gq
  public :: sf_P2NSPlus, sf_P2NSMinus, sf_P2NSS
  ! these are of help elsewhere in identifying (run-time) the sets of 
  ! splitting functions that have been used?
  public :: name_xpij2, name_xpns2

contains
  function sf_P2gg(y) result(res)
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x

    call sf_VogtValidate
    x = exp(-y)
    res = zero

    select case(cc_piece)
    case(cc_REAL,cc_REALVIRT)
       res = X2GGA(x, nf_int) + X2GGB(x, nf_int)
    end select
    select case(cc_piece)
    case(cc_VIRT,cc_REALVIRT)
       res = res - X2GGB(x, nf_int)
    case(cc_DELTA)
       res = X2GGC(zero, nf_int)
    end select

    res = res / 8.0_dp   ! compensate (as/4pi)^3 -> (as/2pi)^3
    if (cc_piece /= cc_DELTA) res = res * x
  end function sf_P2gg

  ! ..This is the (regular) pure-singlet splitting functions P_ps^(2).    
  !    P_qq^(2) is obtained by adding the non-singlet quantity P_NS^(2)+. 
  function sf_P2PS(y) result(res)
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x

    call sf_VogtValidate
    x = exp(-y)
    res = zero

    select case(cc_piece)
    case(cc_REAL,cc_REALVIRT)
       res = X2PSA(x, nf_int) + zero
    end select
    select case(cc_piece)
    case(cc_VIRT,cc_REALVIRT)
       res = res - zero
    case(cc_DELTA)
       res = zero
    end select

    res = res / 8.0_dp   ! compensate (as/4pi)^3 -> (as/2pi)^3
    if (cc_piece /= cc_DELTA) res = res * x
  end function sf_P2PS

  !--------------------------------------------------------------------
  ! this already includes the factor of 2nf
  function sf_P2qg2nf(y) result(res)
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x

    call sf_VogtValidate
    x = exp(-y)
    res = zero

    select case(cc_piece)
    case(cc_REAL,cc_REALVIRT)
       res = X2QGA(x, nf_int)
    end select
    select case(cc_piece)
    case(cc_VIRT,cc_REALVIRT)
       res = res - zero
    case(cc_DELTA)
       res = zero
    end select

    res = res / 8.0_dp   ! compensate (as/4pi)^3 -> (as/2pi)^3
    if (cc_piece /= cc_DELTA) res = res * x
  end function sf_P2qg2nf


  function sf_P2gq(y) result(res)
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x

    call sf_VogtValidate
    x = exp(-y)
    res = zero

    select case(cc_piece)
    case(cc_REAL,cc_REALVIRT)
       res = X2GQA(x, nf_int)
    end select
    select case(cc_piece)
    case(cc_VIRT,cc_REALVIRT)
       res = res - zero
    case(cc_DELTA)
       res = zero
    end select

    res = res / 8.0_dp   ! compensate (as/4pi)^3 -> (as/2pi)^3
    if (cc_piece /= cc_DELTA) res = res * x
  end function sf_P2gq

  !------------------------- non-singlet pieces ------------------------
  function sf_P2NSPlus(y) result(res)
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x

    call sf_VogtValidate
    x = exp(-y)
    res = zero

    select case(cc_piece)
    case(cc_REAL,cc_REALVIRT)
       res = X2NSPA(x, nf_int) + X2NSB(x, nf_int)
    end select
    select case(cc_piece)
    case(cc_VIRT,cc_REALVIRT)
       res = res - X2NSB(x, nf_int)
    case(cc_DELTA)
       res = X2NSC(zero, nf_int)
    end select

    res = res / 8.0_dp   ! compensate (as/4pi)^3 -> (as/2pi)^3
    if (cc_piece /= cc_DELTA) res = res * x
  end function sf_P2NSPlus


  function sf_P2NSMinus(y) result(res)
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x

    call sf_VogtValidate
    x = exp(-y)
    res = zero

    select case(cc_piece)
    case(cc_REAL,cc_REALVIRT)
       res = X2NSMA(x, nf_int) + X2NSB(x, nf_int)
    end select
    select case(cc_piece)
    case(cc_VIRT,cc_REALVIRT)
       res = res - X2NSB(x, nf_int)
    case(cc_DELTA)
       res = X2NSC(zero, nf_int)
    end select

    res = res / 8.0_dp   ! compensate (as/4pi)^3 -> (as/2pi)^3
    if (cc_piece /= cc_DELTA) res = res * x
  end function sf_P2NSMinus

  !-- according to comments in Vogt code P_S = P_V - P_-
  function sf_P2NSS(y) result(res)
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x

    call sf_VogtValidate
    x = exp(-y)
    res = zero

    select case(cc_piece)
    case(cc_REAL,cc_REALVIRT)
       res = X2NSSA(x, nf_int)
    end select
    select case(cc_piece)
    case(cc_VIRT,cc_REALVIRT)
       res = res - zero
    case(cc_DELTA)
       res = zero
    end select

    res = res / 8.0_dp   ! compensate (as/4pi)^3 -> (as/2pi)^3
    if (cc_piece /= cc_DELTA) res = res * x
  end function sf_P2NSS

  !----------------------------------------------------------------
  ! The Vogt expressions are valid only for standard colour factors
  ! This routine makes sure that the appropriate conditions hold
  subroutine sf_VogtValidate
    if (tr == half) return
    call wae_Error('sf_VogtValidate: &
         &colour factors must be set to default values', &
         &'in order to use the Vogt splitting function parameterisations')
  end subroutine sf_VogtValidate

end module splitting_functions_nnlo_e


!======================================================================
! interface to approx 3-loop splitting functions, as parameterised by Vogt
! (see xpij2p.f and xpns2p.f for details).
!
! There are several things to remember: 
!    . Vogt y == my x
!    . Vogt is normalised to powers of (as/4pi)^3 
!    . colour-factor dependence is not available
!    . systematic separation in A,B,C functions needs to be
!      taken into account; C function needs to be called with x=0?x
!    . check inclusion of 2nf in qg piece
! 
!----------------------------------------------------------------------
module splitting_functions_nnlo_p
  use types; use consts_dp; use convolution_communicator
  use qcd; use warnings_and_errors
  use xpij2p; use xpns2p
  implicit none
  private

  public :: sf_P2gg, sf_P2qg2nf, sf_P2PS, sf_P2gq
  public :: sf_P2NSPlus, sf_P2NSMinus, sf_P2NSS
  ! these are of help elsewhere in identifying (run-time) the sets of 
  ! splitting functions that have been used?
  public :: name_xpij2, name_xpns2

contains
  function sf_P2gg(y) result(res)
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x

    call sf_VogtValidate
    x = exp(-y)
    res = zero

    select case(cc_piece)
    case(cc_REAL,cc_REALVIRT)
       res = P2GGA(x, nf_int) + P2GGB(x, nf_int)
    end select
    select case(cc_piece)
    case(cc_VIRT,cc_REALVIRT)
       res = res - P2GGB(x, nf_int)
    case(cc_DELTA)
       res = P2GGC(zero, nf_int)
    end select

    res = res / 8.0_dp   ! compensate (as/4pi)^3 -> (as/2pi)^3
    if (cc_piece /= cc_DELTA) res = res * x
   end function sf_P2gg

  ! ..This is the (regular) pure-singlet splitting functions P_ps^(2).    
  !    P_qq^(2) is obtained by adding the non-singlet quantity P_NS^(2)+. 
  function sf_P2PS(y) result(res)
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x

    call sf_VogtValidate
    x = exp(-y)
    res = zero

    select case(cc_piece)
    case(cc_REAL,cc_REALVIRT)
       res = P2PSA(x, nf_int) + zero
    end select
    select case(cc_piece)
    case(cc_VIRT,cc_REALVIRT)
       res = res - zero
    case(cc_DELTA)
       res = zero
    end select

    res = res / 8.0_dp   ! compensate (as/4pi)^3 -> (as/2pi)^3
    if (cc_piece /= cc_DELTA) res = res * x
  end function sf_P2PS

  !--------------------------------------------------------------------
  ! this already includes the factor of 2nf
  function sf_P2qg2nf(y) result(res)
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x

    call sf_VogtValidate
    x = exp(-y)
    res = zero

    select case(cc_piece)
    case(cc_REAL,cc_REALVIRT)
       res = P2QGA(x, nf_int)
    end select
    select case(cc_piece)
    case(cc_VIRT,cc_REALVIRT)
       res = res - zero
    case(cc_DELTA)
       res = zero
    end select

    res = res / 8.0_dp   ! compensate (as/4pi)^3 -> (as/2pi)^3
    if (cc_piece /= cc_DELTA) res = res * x
  end function sf_P2qg2nf


  function sf_P2gq(y) result(res)
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x

    call sf_VogtValidate
    x = exp(-y)
    res = zero

    select case(cc_piece)
    case(cc_REAL,cc_REALVIRT)
       res = P2GQA(x, nf_int)
    end select
    select case(cc_piece)
    case(cc_VIRT,cc_REALVIRT)
       res = res - zero
    case(cc_DELTA)
       res = zero
    end select

    res = res / 8.0_dp   ! compensate (as/4pi)^3 -> (as/2pi)^3
    if (cc_piece /= cc_DELTA) res = res * x
  end function sf_P2gq

  !------------------------- non-singlet pieces ------------------------
  function sf_P2NSPlus(y) result(res)
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x

    call sf_VogtValidate
    x = exp(-y)
    res = zero

    select case(cc_piece)
    case(cc_REAL,cc_REALVIRT)
       res = P2NSPA(x, nf_int) + P2NSB(x, nf_int)
    end select
    select case(cc_piece)
    case(cc_VIRT,cc_REALVIRT)
       res = res - P2NSB(x, nf_int)
    case(cc_DELTA)
       res = P2NSPC(zero, nf_int)
    end select

    res = res / 8.0_dp   ! compensate (as/4pi)^3 -> (as/2pi)^3
    if (cc_piece /= cc_DELTA) res = res * x
  end function sf_P2NSPlus


  function sf_P2NSMinus(y) result(res)
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x

    call sf_VogtValidate
    x = exp(-y)
    res = zero

    select case(cc_piece)
    case(cc_REAL,cc_REALVIRT)
       res = P2NSMA(x, nf_int) + P2NSB(x, nf_int)
    end select
    select case(cc_piece)
    case(cc_VIRT,cc_REALVIRT)
       res = res - P2NSB(x, nf_int)
    case(cc_DELTA)
       res = P2NSMC(zero, nf_int)
    end select

    res = res / 8.0_dp   ! compensate (as/4pi)^3 -> (as/2pi)^3
    if (cc_piece /= cc_DELTA) res = res * x
  end function sf_P2NSMinus

  !-- according to comments in Vogt code P_S = P_V - P_-
  function sf_P2NSS(y) result(res)
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x

    call sf_VogtValidate
    x = exp(-y)
    res = zero

    select case(cc_piece)
    case(cc_REAL,cc_REALVIRT)
       res = P2NSSA(x, nf_int)
    end select
    select case(cc_piece)
    case(cc_VIRT,cc_REALVIRT)
       res = res - zero
    case(cc_DELTA)
       res = zero
    end select

    res = res / 8.0_dp   ! compensate (as/4pi)^3 -> (as/2pi)^3
    if (cc_piece /= cc_DELTA) res = res * x
  end function sf_P2NSS

  !----------------------------------------------------------------
  ! The Vogt expressions are valid only for standard colour factors
  ! This routine makes sure that the appropriate conditions hold
  subroutine sf_VogtValidate
    if (ca == three .and. tr == half .and. cf == four/three) return
    call wae_Error('sf_VogtValidate: &
         &colour factors must be set to default values', &
         &'in order to use the Vogt splitting function parameterisations')
  end subroutine sf_VogtValidate

end module splitting_functions_nnlo_p



!======================================================================
! interface to guessed 3-loop splitting functions, as parameterised by Vogt
! (see xpij2n.f and xpns2n.f for details).
!
! There are several things to remember: 
!    . Vogt y == my x
!    . Vogt is normalised to powers of (as/4pi)^3 
!    . colour-factor dependence is not available
!    . systematic separation in A,B,C functions needs to be
!      taken into account; C function needs to be called with x=0?x
!    . check inclusion of 2nf in qg piece
! 
!----------------------------------------------------------------------
module splitting_functions_nnlo_n
  use types; use consts_dp; use convolution_communicator
  use qcd; use dglap_choices; use warnings_and_errors
  use xpij2n; use xpns2n
  implicit none
  private

  public :: sf_P2gg, sf_P2qg2nf, sf_P2PS, sf_P2gq
  public :: sf_P2NSPlus, sf_P2NSMinus, sf_P2NSS
  ! these are of help elsewhere in identifying (run-time) the sets of 
  ! splitting functions that have been used?
  public :: name_xpij2, name_xpns2

contains
  function sf_P2gg(y) result(res)
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x

    call sf_VogtValidate
    x = exp(-y)
    res = zero

    select case(cc_piece)
    case(cc_REAL,cc_REALVIRT)
       res = P2GGA(x, nf_int, nnlo_splitting_variant) + P2GGB(x, nf_int, nnlo_splitting_variant)
    end select
    select case(cc_piece)
    case(cc_VIRT,cc_REALVIRT)
       res = res - P2GGB(x, nf_int, nnlo_splitting_variant)
    case(cc_DELTA)
       res = P2GGC(zero, nf_int, nnlo_splitting_variant)
    end select

    res = res / 8.0_dp   ! compensate (as/4pi)^3 -> (as/2pi)^3
    if (cc_piece /= cc_DELTA) res = res * x
  end function sf_P2gg

  ! ..This is the (regular) pure-singlet splitting functions P_ps^(2).    
  !    P_qq^(2) is obtained by adding the non-singlet quantity P_NS^(2)+. 
  function sf_P2PS(y) result(res)
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x

    call sf_VogtValidate
    x = exp(-y)
    res = zero

    select case(cc_piece)
    case(cc_REAL,cc_REALVIRT)
       res = P2PSA(x, nf_int, nnlo_splitting_variant) + zero
    end select
    select case(cc_piece)
    case(cc_VIRT,cc_REALVIRT)
       res = res - zero
    case(cc_DELTA)
       res = zero
    end select

    res = res / 8.0_dp   ! compensate (as/4pi)^3 -> (as/2pi)^3
    if (cc_piece /= cc_DELTA) res = res * x
  end function sf_P2PS

  !--------------------------------------------------------------------
  ! this already includes the factor of 2nf
  function sf_P2qg2nf(y) result(res)
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x

    call sf_VogtValidate
    x = exp(-y)
    res = zero

    select case(cc_piece)
    case(cc_REAL,cc_REALVIRT)
       res = P2QGA(x, nf_int, nnlo_splitting_variant)
    end select
    select case(cc_piece)
    case(cc_VIRT,cc_REALVIRT)
       res = res - zero
    case(cc_DELTA)
       res = zero
    end select

    res = res / 8.0_dp   ! compensate (as/4pi)^3 -> (as/2pi)^3
    if (cc_piece /= cc_DELTA) res = res * x
  end function sf_P2qg2nf


  function sf_P2gq(y) result(res)
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x

    call sf_VogtValidate
    x = exp(-y)
    res = zero

    select case(cc_piece)
    case(cc_REAL,cc_REALVIRT)
       res = P2GQA(x, nf_int, nnlo_splitting_variant)
    end select
    select case(cc_piece)
    case(cc_VIRT,cc_REALVIRT)
       res = res - zero
    case(cc_DELTA)
       res = zero
    end select

    res = res / 8.0_dp   ! compensate (as/4pi)^3 -> (as/2pi)^3
    if (cc_piece /= cc_DELTA) res = res * x
  end function sf_P2gq

  !------------------------- non-singlet pieces ------------------------
  function sf_P2NSPlus(y) result(res)
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x

    call sf_VogtValidate
    x = exp(-y)
    res = zero

    select case(cc_piece)
    case(cc_REAL,cc_REALVIRT)
       res = P2NSPA(x, nf_int, nnlo_splitting_variant) + P2NSPB(x, nf_int, nnlo_splitting_variant)
    end select
    select case(cc_piece)
    case(cc_VIRT,cc_REALVIRT)
       res = res - P2NSPB(x, nf_int, nnlo_splitting_variant)
    case(cc_DELTA)
       res = P2NSPC(zero, nf_int, nnlo_splitting_variant)
    end select

    res = res / 8.0_dp   ! compensate (as/4pi)^3 -> (as/2pi)^3
    if (cc_piece /= cc_DELTA) res = res * x
  end function sf_P2NSPlus


  function sf_P2NSMinus(y) result(res)
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x

    call sf_VogtValidate
    x = exp(-y)
    res = zero

    select case(cc_piece)
    case(cc_REAL,cc_REALVIRT)
       res = P2NSMA(x, nf_int, nnlo_splitting_variant) + P2NSMB(x, nf_int, nnlo_splitting_variant)
    end select
    select case(cc_piece)
    case(cc_VIRT,cc_REALVIRT)
       res = res - P2NSMB(x, nf_int, nnlo_splitting_variant)
    case(cc_DELTA)
       res = P2NSMC(zero, nf_int, nnlo_splitting_variant)
    end select

    res = res / 8.0_dp   ! compensate (as/4pi)^3 -> (as/2pi)^3
    if (cc_piece /= cc_DELTA) res = res * x
  end function sf_P2NSMinus

  !-- according to comments in Vogt code P_S = P_V - P_-
  function sf_P2NSS(y) result(res)
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x

    call sf_VogtValidate
    x = exp(-y)
    res = zero

    select case(cc_piece)
    case(cc_REAL,cc_REALVIRT)
       res = P2NSSA(x, nf_int, nnlo_splitting_variant)
    end select
    select case(cc_piece)
    case(cc_VIRT,cc_REALVIRT)
       res = res - zero
    case(cc_DELTA)
       res = zero
    end select

    res = res / 8.0_dp   ! compensate (as/4pi)^3 -> (as/2pi)^3
    if (cc_piece /= cc_DELTA) res = res * x
  end function sf_P2NSS

  !----------------------------------------------------------------
  ! The Vogt expressions are valid only for standard colour factors
  ! This routine makes sure that the appropriate conditions hold
  subroutine sf_VogtValidate
    if (ca == three .and. tr == half .and. cf == four/three) return
    call wae_Error('sf_VogtValidate: &
         &colour factors must be set to default values', &
         &'in order to use the Vogt splitting function parameterisations')
  end subroutine sf_VogtValidate

end module splitting_functions_nnlo_n


!======================================================================
! Modules for extracting selecting the relevant splitting functions, 
! either "n" version, "p" versions. May be extended to
! exact versions at some later stage...
!======================================================================
module sf_nnlo_n_rename
  use splitting_functions_nnlo_n,&
       &sf_n_P2gg      => sf_P2gg     ,&
       &sf_n_P2PS      => sf_P2PS     ,&
       &sf_n_P2qg2nf   => sf_P2qg2nf  ,&
       &sf_n_P2gq      => sf_P2gq     ,&
       &sf_n_P2NSPlus  => sf_P2NSPlus ,&
       &sf_n_P2NSMinus => sf_P2NSMinus,&
       &sf_n_P2NSS     => sf_P2NSS
  implicit none
  private
  public :: sf_n_P2gg, sf_n_P2qg2nf, sf_n_P2PS, sf_n_P2gq
  public :: sf_n_P2NSPlus, sf_n_P2NSMinus, sf_n_P2NSS
end module sf_nnlo_n_rename


module sf_nnlo_p_rename
  use splitting_functions_nnlo_p,&
       &sf_p_P2gg      => sf_P2gg     ,&
       &sf_p_P2PS      => sf_P2PS     ,&
       &sf_p_P2qg2nf   => sf_P2qg2nf  ,&
       &sf_p_P2gq      => sf_P2gq     ,&
       &sf_p_P2NSPlus  => sf_P2NSPlus ,&
       &sf_p_P2NSMinus => sf_P2NSMinus,&
       &sf_p_P2NSS     => sf_P2NSS
  implicit none
  private
  public :: sf_p_P2gg, sf_p_P2qg2nf, sf_p_P2PS, sf_p_P2gq
  public :: sf_p_P2NSPlus, sf_p_P2NSMinus, sf_p_P2NSS
end module sf_nnlo_p_rename


module sf_nnlo_e_rename
  use splitting_functions_nnlo_e,&
       &sf_e_P2gg      => sf_P2gg     ,&
       &sf_e_P2PS      => sf_P2PS     ,&
       &sf_e_P2qg2nf   => sf_P2qg2nf  ,&
       &sf_e_P2gq      => sf_P2gq     ,&
       &sf_e_P2NSPlus  => sf_P2NSPlus ,&
       &sf_e_P2NSMinus => sf_P2NSMinus,&
       &sf_e_P2NSS     => sf_P2NSS
  implicit none
  private
  public :: sf_e_P2gg, sf_e_P2qg2nf, sf_e_P2PS, sf_e_P2gq
  public :: sf_e_P2NSPlus, sf_e_P2NSMinus, sf_e_P2NSS
end module sf_nnlo_e_rename


module splitting_functions_nnlo
  use types; use qcd; use dglap_choices
  use warnings_and_errors
  use sf_nnlo_e_rename
  use sf_nnlo_p_rename
  use sf_nnlo_n_rename
  public :: sf_P2gg, sf_P2qg2nf, sf_P2PS, sf_P2gq
  public :: sf_P2NSPlus, sf_P2NSMinus, sf_P2NSS
contains
  
  
  real(dp) function sf_P2gg     (y) result(res)
    real(dp), intent(in) :: y
    select case(nnlo_splitting_variant)
    case(nnlo_splitting_exact)
       res = sf_e_P2gg(y)
    case(nnlo_splitting_param)
       res = sf_p_P2gg(y)
    case(nnlo_splitting_nfitav, nnlo_splitting_nfiterr1, nnlo_splitting_nfiterr2)
       res = sf_n_P2gg(y)
    case default
       call wae_error('splitting_functions_nnlo','unrecognized imod',&
            &intval=nnlo_splitting_variant)
    end select
  end function sf_P2gg
  
  real(dp) function sf_P2PS     (y) result(res)
    real(dp), intent(in) :: y
    select case(nnlo_splitting_variant)
    case(nnlo_splitting_exact)
       res = sf_e_P2PS(y)
    case(nnlo_splitting_param)
       res = sf_p_P2PS(y)
    case(nnlo_splitting_nfitav, nnlo_splitting_nfiterr1, nnlo_splitting_nfiterr2)
       res = sf_n_P2PS(y)
    case default
       call wae_error('splitting_functions_nnlo','unrecognized imod',&
            &intval=nnlo_splitting_variant)
    end select
  end function sf_P2PS
  
  real(dp) function sf_P2qg2nf  (y) result(res)
    real(dp), intent(in) :: y
    select case(nnlo_splitting_variant)
    case(nnlo_splitting_exact)
       res = sf_e_P2qg2nf(y)
    case(nnlo_splitting_param)
       res = sf_p_P2qg2nf(y)
    case(nnlo_splitting_nfitav, nnlo_splitting_nfiterr1, nnlo_splitting_nfiterr2)
       res = sf_n_P2qg2nf(y)
    case default
       call wae_error('splitting_functions_nnlo','unrecognized imod',&
            &intval=nnlo_splitting_variant)
    end select
  end function sf_P2qg2nf
  
  real(dp) function sf_P2gq     (y) result(res)
    real(dp), intent(in) :: y
    select case(nnlo_splitting_variant)
    case(nnlo_splitting_exact)
       res = sf_e_P2gq(y)
    case(nnlo_splitting_param)
       res = sf_p_P2gq(y)
    case(nnlo_splitting_nfitav, nnlo_splitting_nfiterr1, nnlo_splitting_nfiterr2)
       res = sf_n_P2gq(y)
    case default
       call wae_error('splitting_functions_nnlo','unrecognized imod',&
            &intval=nnlo_splitting_variant)
    end select
  end function sf_P2gq
  
  real(dp) function sf_P2NSPlus (y) result(res)
    real(dp), intent(in) :: y
    select case(nnlo_splitting_variant)
    case(nnlo_splitting_exact)
       res = sf_e_P2NSPlus(y)
    case(nnlo_splitting_param)
       res = sf_p_P2NSPlus(y)
    case(nnlo_splitting_nfitav, nnlo_splitting_nfiterr1, nnlo_splitting_nfiterr2)
       res = sf_n_P2NSPlus(y)
    case default
       call wae_error('splitting_functions_nnlo','unrecognized imod',&
            &intval=nnlo_splitting_variant)
    end select
  end function sf_P2NSPlus
  
  real(dp) function sf_P2NSMinus(y) result(res)
    real(dp), intent(in) :: y
    select case(nnlo_splitting_variant)
    case(nnlo_splitting_exact)
       res = sf_e_P2NSMinus(y)
    case(nnlo_splitting_param)
       res = sf_p_P2NSMinus(y)
    case(nnlo_splitting_nfitav, nnlo_splitting_nfiterr1, nnlo_splitting_nfiterr2)
       res = sf_n_P2NSMinus(y)
    case default
       call wae_error('splitting_functions_nnlo','unrecognized imod',&
            &intval=nnlo_splitting_variant)
    end select
  end function sf_P2NSMinus

  real(dp) function sf_P2NSS(y) result(res)
    real(dp), intent(in) :: y
    select case(nnlo_splitting_variant)
    case(nnlo_splitting_exact)
       res = sf_e_P2NSS(y)
    case(nnlo_splitting_param)
       res = sf_p_P2NSS(y)
    case(nnlo_splitting_nfitav, nnlo_splitting_nfiterr1, nnlo_splitting_nfiterr2)
       res = sf_n_P2NSS(y)
    case default
       call wae_error('splitting_functions_nnlo','unrecognized imod',&
            &intval=nnlo_splitting_variant)
    end select
  end function sf_P2NSS
end module splitting_functions_nnlo

!======================================================================
!!
!! Routine for dealing with warnings that may crop up many times and 
!! which should be output only a limited number of times
!!
!! In f95 could have used a special type which was preinitialised...
!!
!! $Id: warnings_and_errors.f90,v 1.6 2004/02/26 19:02:19 salam Exp $
!======================================================================
module warnings_and_errors
  use types
  implicit none
  private

  integer, parameter :: base = 10000
  integer            :: n_warn_sources   = 0
  integer, parameter, public :: warn_id_INIT=0
  integer, parameter, public :: default_max_warn = 5

  interface wae_warn
     module procedure wae_warn_new, wae_warn_old
  end interface
  
  public :: wae_warn, wae_error, wae_setunit

  integer, parameter :: stddev_in = 0
  integer            :: stddev = stddev_in


contains
  !---------------------------------------------------------------------
  !! Routine to allow the output of a warning up to some maximum number of 
  !! times after which no such warning will be issues.
  !!
  !! On the first call for a given kind of warning, the warn_n should
  !! (must have save attribute in calling routine) should be the 
  !! maximum number of warnings that will be output
  !!
  subroutine wae_warn_new(warn_n, text, text2, text3, text4, intval, dbleval)
    integer, intent(inout)       :: warn_n
    character(len=*), intent(in) :: text
    character(len=*), intent(in), optional :: text2
    character(len=*), intent(in), optional :: text3
    character(len=*), intent(in), optional :: text4
    integer,          intent(in), optional :: intval
    real(kind(1d0)),  intent(in), optional :: dbleval
    !--------------------------------------

    if (warn_n > 0) then
       warn_n = warn_n - 1
       write(stddev,'(a)', advance='no') 'WARNING in '
       write(stddev,'(a)')  text
       if (present(text2)) write(stddev,'(a)') text2
       if (present(text3)) write(stddev,'(a)') text3
       if (present(text4)) write(stddev,'(a)') text4
       if (present(intval))  write(stddev,*) intval
       if (present(dbleval)) write(stddev,*) dbleval
       if (warn_n == 0) write(stddev,'(a)') &
            &'----- No more such warnings will be issued ------'
    end if
  end subroutine wae_warn_new


  !---------------------------------------------------------------------
  !! Routine to allow the output of a warning up to some maximum number of 
  !! times after which no such warning will be issues.
  !!
  !! On the first call for a given kind of warning, the warn_id should be 
  !! equal to warn_id_INIT; warn_id should have the SAVE attribute to
  !! allow wae_warn to keep track of the number of warnings of this type
  !!
  subroutine wae_warn_old(max_warn, warn_id, &
       &text, text2, text3, intval, dbleval)
    integer, intent(in)          :: max_warn
    integer, intent(inout)       :: warn_id
    character(len=*), intent(in) :: text
    character(len=*), intent(in), optional :: text2
    character(len=*), intent(in), optional :: text3
    integer,          intent(in), optional :: intval
    real(kind(1d0)),  intent(in), optional :: dbleval
    !--------------------------------------
    integer :: warn_index, nwarn

    !-- generate a new warn_id
    if (warn_id <= 0) then
       n_warn_sources = n_warn_sources + 1
       warn_id = n_warn_sources * base
    end if
    
    warn_index = warn_id / base
    nwarn      = warn_id - warn_index*base

    if (nwarn < max_warn) then
       if (max_warn > base-2) call wae_error('wae_warn',&
            & 'max_warn exceeded maximum allowed value; message was', text)
       !-- does this make any sense at all (GPS 8/1/03)?
       if (warn_id > huge(warn_id)) call wae_error('wae_warn',&
            & 'exceeded max capicity for distinct warnings; message was', text)
    
       warn_id = warn_id + 1
       write(stddev,'(a)', advance='no') 'WARNING in '
       write(stddev,'(a)')  text
       if (present(text2)) write(stddev,'(a)') text2
       if (present(text3)) write(stddev,'(a)') text3
       if (present(intval))  write(stddev,*) intval
       if (present(dbleval)) write(stddev,*) dbleval
       !-- if there is only an 1 warning to be written then
       !   avoid cluttering screen with too many messages
       if (nwarn == max_warn - 1 .and. max_warn > 1) write(stddev,'(a)') &
            &'----- No more such warnings will be issued ------'
    end if
  end subroutine wae_warn_old

  !======================================================================
  !! Report an error and then crash (by attempting floating point exception)
  !======================================================================
  subroutine wae_error(text1, text2, text3, text4, intval, dbleval)
    character(len=*), intent(in) :: text1
    character(len=*), intent(in), optional :: text2
    character(len=*), intent(in), optional :: text3
    character(len=*), intent(in), optional :: text4
    integer,          intent(in), optional :: intval
    real(kind(1d0)),  intent(in), optional :: dbleval
    !real :: a,b

    write(stddev,*)
    write(stddev,'(a)') '============================================================='
    write(stddev,'(a)', advance='no') 'FATAL ERROR in '
    write(stddev,'(a)') text1
    if (present(text2))   write(stddev,'(a)') text2
    if (present(text3))   write(stddev,'(a)') text3
    if (present(text4))   write(stddev,'(a)') text4
    if (present(intval))  write(stddev,*) intval
    if (present(dbleval)) write(stddev,*) dbleval

    write(stddev,*)
    error stop 1
  end subroutine wae_error
  
  !!
  !! Set the unit for all output by the warning and error routines
  !!
  subroutine wae_setunit(unit)
    integer, intent(in) :: unit
    stddev = unit
  end subroutine wae_setunit
  
end module warnings_and_errors

module hoppet
  use types; use consts_dp
  use convolution; use dglap_objects
  use pdf_representation; use pdf_general
  use dglap_choices
  use warnings_and_errors
  use dglap_holders 
  use evolution
  use qcd_coupling
  use qcd
  use pdf_tabulate

  ! extra QED things
  use qed_evolution
  use qed_objects
  use qed_coupling_module

  use structure_functions
  use coefficient_functions_holder_exact
  implicit none
end module hoppet

module hoppet_version
  implicit none
  private
  ! DO NOT EDIT the next line -- it is modified automatically by scripts/set-version.sh
  character(len=*), parameter :: private_version_string = "2.1.0"

public :: HoppetVersion

contains  

  !! return a string with the current version of HOPPET
  function HoppetVersion() result(vs)
    character(len=len(private_version_string)) :: vs
    vs = private_version_string
  end function HoppetVersion

  !! Takes a pointer to an array of C characters and if the version
  !! string length is < maxlen-1, then fills the C-array with a null
  !! terminated string with the version, and returns 0. If the version
  !! string length is >= maxlen-1, then does not fill the C-array,
  !! and returns the required length (including the null terminator).
  !!
  !! C-signature is 
  !!  int HoppetVersionC(char *cchar, int maxlen)
  function hoppetVersionC(cchar, maxlen) result (errcode_or_maxlen) bind(C, name="hoppetVersionC")
    use, intrinsic :: iso_c_binding
    implicit none
    ! Arguments
    type(c_ptr),    value        :: cchar          !< pointer to char buffer from C/C++
    integer(c_int), value        :: maxlen         !< max buffer length provided by caller
    integer(c_int)               :: errcode_or_maxlen
    ! Local variables
    integer :: verlen
    character(kind=c_char), pointer :: fbuf(:)

    ! Actual length of version string
    verlen = len_trim(private_version_string)

    if (verlen < maxlen) then
      ! Associate the C pointer with a Fortran char buffer of length maxlen
      call c_f_pointer(cchar, fbuf, [maxlen])

      fbuf(1:verlen) = transfer(private_version_string(1:verlen), fbuf(1:verlen))

      ! Null terminate
      fbuf(verlen+1) = c_null_char

      ! Return success (0)
      errcode_or_maxlen = 0
    else
       ! Not enough room: return required length including null terminator
       errcode_or_maxlen = verlen + 1
    end if
  end function HoppetVersionC

end module hoppet_version


subroutine HoppetWelcomeMessage
  use hoppet_version
  use hoppet_term
  implicit none
  character(len=:), allocatable :: welcome_str

  welcome_str = 'Welcome to HOPPET v. '//HoppetVersion()

  write(0,'(a)') '-----------------------------------------------------------'//bold
  !write(0,'(a)') '              Welcome to HOPPET v. '//trim(HoppetVersionString())
  write(0,'(a)') repeat(' ', (59-len(welcome_str))/2)//welcome_str
  write(0,'(a)') '    Higher Order Perturbative Parton Evolution Toolkit     '//reset
  write(0,'(a)') '-----------------------------------------------------------'
  !write(0,'(a)') ''
  write(0,'(a)') '                  Written (2001-2025) by                   '
  write(0,'(a)') '     Frederic Dreyer, Alexander Karlberg, Paolo Nason,     '
  write(0,'(a)') '      Juan Rojo, Gavin P. Salam and Giulia Zanderighi      '
  write(0,'(a)') ''
  write(0,'(a)') ' It is made available under the GNU public license.        '
  write(0,'(a)') ' If using it for scientific work, please cite              '
  write(0,'(a)') ' G.P. Salam & J. Rojo, CPC 180(2009)120 (arXiv:0804.3755). '
  write(0,'(a)') ' and A. Karlberg, P. Nason, G.P. Salam, G. Zanderighi      '
  write(0,'(a)') ' & F. Dreyer (arXiv:2510.09310).                           '
  write(0,'(a)') ' '
  write(0,'(a)') ' You are also encouraged to cite the original references,  '
  write(0,'(a)') ' for LO, NLO, NNLO, and N3LO splitting functions, the QCD  '
  write(0,'(a)') ' 1, 2, 3, and 4 loop beta functions and the PDF and        '
  write(0,'(a)') ' coupling mass threshold matching functions. Additionally  '
  write(0,'(a)') ' the DIS coefficient functions should be cited when used.  '
  write(0,'(a)') '-----------------------------------------------------------'
end subroutine HoppetWelcomeMessage
  

#include "timing.inc"
module test_alphas
  use types
  use unit_tests
  use qcd_coupling
  implicit none

contains

  subroutine unit_tests_alphas()
    use new_as
    implicit none
    integer  :: nloop
    !-- reference results generated by unit-tests/gen-alphas-ref.py
    real(dp), parameter :: mc=1.670000_dp, mb=4.780000_dp, mt=172.570000_dp, mz=91.188000_dp
    real(dp), parameter :: alphas_mz=0.118000_dp
    real(dp), parameter :: Qvals(*) = [1.000000_dp, 3.000000_dp, 9.000000_dp, 10000.000000_dp]
    real(dp), parameter :: Qmin = Qvals(1), Qmax = Qvals(size(Qvals))
    integer , parameter :: nQ_fine = 200
    integer  :: iQ
    real(dp), parameter :: Qvals_fine(0:nQ_fine) = [(Qmin*(Qmax/Qmin)**(real(iQ,dp)/(nQ_fine)), iQ=0,nQ_fine)]
    !-- reference results for alphas_vfn
    real(dp), parameter :: ref_4loop_vfn(*) = [4.830605117006e-01_dp, 2.536789691195e-01_dp, 1.827498038423e-01_dp, 7.181752397345e-02_dp]
    !-- end of reference results    

    type(running_coupling) :: alphas_vfn, alphas_nf4
    real(dp) :: default_dt, Q, abs_tol = 1e-9_dp

    if (.not. do_test("unit_tests_alphas")) return


    default_dt = DefaultCouplingDt()
    !call SetDefaultCouplingDt(0.1_dp*default_dt)

    call InitRunningCoupling(alphas_vfn, alphas_mz, Q=mz, quark_masses=(/ mc, mb, mt /), nloop=4)
    call InitRunningCoupling(alphas_nf4, alphas_vfn%Value(2.0_dp), Q=2.0_dp, fixnf=4, nloop=4)

    do iQ = 1, size(Qvals)
      Q = Qvals(iQ)
      call check_approx_eq_0d("alphas_vfn at Q="//trim(to_string(Q)), alphas_vfn%Value(Q), ref_4loop_vfn(iQ), abs_tol)
    end do

    ! make sure that extraction outside of the range with fixnf works too
    call check_approx_eq("alphas_nf4_1GeV", alphas_nf4%Value(1.0_dp), alphas_vfn%Value(1.0_dp, fixnf=4), abs_tol)
    call check_approx_eq("alphas_nf4_9GeV", alphas_nf4%Value(9.0_dp), alphas_vfn%Value(9.0_dp, fixnf=4), abs_tol)

    ! test that evolution and interpolation variants are giving the same result
    ! to within the tolerance
    do iQ = 0, ubound(Qvals_fine,1)
      Q = Qvals_fine(iQ)
      call check_approx_eq("alphas: interp v. evol at Q="//trim(to_string(Q)), &
                           alphas_vfn%Value(Q), &
                           na_Value_full(alphas_vfn%nah,Q), abs_tol)
    end do

    TIME_START("alphas_vfn",10**7)
    real(dp) :: sum_alphas = 0.0_dp
    TIME_LOOP
      sum_alphas = sum_alphas + alphas_vfn%Value(Qvals(mod(irep,size(Qvals))+1))
      ! for testing impact of using a single Q value: saves about 1ns
      ! on M2Pro-gfortran15.1-O3
      !sum_alphas = sum_alphas + alphas_vfn%Value(6.0_dp)
    TIME_END(sum_alphas)

    TIME_START("alphas_vfn_full",10**7)
    real(dp) :: sum_alphas = 0.0_dp
    TIME_LOOP
      sum_alphas = sum_alphas + na_Value_full(alphas_vfn%nah,Qvals(mod(irep,size(Qvals))+1) ) !alphas_vfn%Value(Qvals(mod(irep,size(Qvals))+1))
    TIME_END(sum_alphas)


  end subroutine unit_tests_alphas

end module test_alphas

!! Test of array bounds bug that is present in a family of compilers that, as of 2024-12
!! includes AOCC (5.0) nvfortran (24.11). See the bug report at:
!! https://forums.developer.nvidia.com/t/bugreport-for-nvfortran-treatment-of-array-bounds-in-the-specification-part/278324
program array_bound_test
  implicit none
  real :: arr_in1(0:10, 2:5), arr1(0:10,2:5)
  integer  i, j
  do i=0,10 
  do j=2,5
    arr_in1(i,j) = 1000*i+j
  end do
  end do

  call evaluate(arr_in1,arr1)
contains

  function justcopy(arr_in)
   implicit none
   real, intent(in) :: arr_in(0:,:)
   real :: justcopy(0:ubound(arr_in,dim=1), 2:5)  !This works for "A" GNU,Intel/InteLLVM,lfortran,NAG,IBM. Does not work for "B" AOCC, NVidia, ARM.
   !real :: justcopy(0:size(arr_in,dim=1)-1, 2:5) !This works for all compilers
   write(*,*) "arr_in, dim 1 (lb,ub,sz):", lbound(arr_in,dim=1),ubound(arr_in,dim=1),size(arr_in,1)
   write(*,*) "arr_in, dim 2 (lb,ub,sz):", lbound(arr_in,dim=2),ubound(arr_in,dim=2),size(arr_in,2)
   write(*,*) "justcp, dim 1 (lb,ub,sz):", lbound(justcopy,dim=1),ubound(justcopy,dim=1),size(justcopy,1)
   write(*,*) "justcp, dim 2 (lb,ub,sz):", lbound(justcopy,dim=2),ubound(justcopy,dim=2),size(justcopy,2)
   justcopy=arr_in
  end function justcopy
  
  subroutine evaluate(arr_in1,arr_out1)
    implicit none
    real,    intent(in)  :: arr_in1(:,:)
    real,    intent(out) :: arr_out1(:,:)
    real, allocatable  :: X(:,:)

    !arr_out1 = justcopy(arr_in1)
    X = justcopy(arr_in1)       
    write(*,*) "X     , dim 1 (lb,ub,sz):", lbound(X,dim=1),ubound(X,dim=1),size(X,1)
    write(*,*) "X     , dim 2 (lb,ub,sz):", lbound(X,dim=2),ubound(X,dim=2),size(X,2)

    if (size(X,1) /= size(arr_in1,1)) then
       print "(A,I2,A,I2)","Error: size of X(dim1)=",size(X,1),&
                           " was not equal to size of arr_in1(dim1)=",size(arr_in1,1)
      error stop 1
    end if
    
    arr_out1 = X
  end subroutine evaluate  
end program array_bound_test

      program convolution_example
      implicit none
      !---------------
      external         evolvePDF
      double precision x, Q, lhapdf(-6:6), ourpdf(-6:6)
      double precision PLO_conv_ourpdf(-6:6), PNLO_conv_ourpdf(-6:6)
      double precision dy
      integer          iloop, nloop, nf, iflv

      ! initialise an LHAPDF set
      call InitPDFsetByName("cteq61.LHgrid")
      call InitPDF(0)

      ! start the hoppet evolution/convolution package 
      dy    = 0.1d0     ! the internal grid spacing (smaller->higher accuarcy)
                        ! 0.1 should provide at least 10^{-3} accuracy 
      nloop = 2         ! the number of loops to initialise (max=3!)
      call hoppetStart(dy, nloop)

      ! initialise our PDF using the LHAPDF subroutine for PDF-access
      ! (any other subroutine with same interface can be used in its place)
      call hoppetAssign(evolvePDF)

      x = 0.1d0
      Q = 30.0d0

      ! extract the pdf at this x,Q directly from LHAPDF
      call evolvePDF(x,Q,lhapdf)

      ! extract the pdf at this x,Q via our copy of the pdf
      call hoppetEval(x,Q,ourpdf)

      ! extract the convolution of the 1-loop (LO) splitting function
      ! with the currently stored pdf. The normalisation is such that to
      ! get the evolution with respect to ln(Q^2) one must multiply
      ! PLO_conv_ourpdf by alphas/(2*pi). This is the same thing that
      ! in hep-ph/0510324 is referred to as (P_0\otimes q)
      iloop = 1
      nf = 5
      call hoppetEvalSplit(x,Q,iloop,nf,PLO_conv_ourpdf)
      ! extract the convolution with the 2-loop (NLO) splitting function
      iloop = 2
      call hoppetEvalSplit(x,Q,iloop,nf,PNLO_conv_ourpdf)

      ! print it all
      write(6,*) 'x = ', x, ',   Q = ', Q
      write(6,'(a5,4a17)') 'iflv','lhapdf','ourpdf',
     $     'PLO_conv_ourpdf','PNLO_conv_ourpdf'
      do iflv = -6, 6
         write(6,'(i5,4f17.7)') iflv,
     $        lhapdf(iflv),ourpdf(iflv),
     $        PLO_conv_ourpdf(iflv),PNLO_conv_ourpdf(iflv)
      end do
      end

!! program to test behaviour with intrinsic charm
!!
!!
program msbar_tests
  use hoppet; use io_utils
  implicit none
  !-- for alpha_s
  type(running_coupling) :: coupling_pole, coupling_ms
  real(dp) :: asMZ, MZ, Q0, Q, dt
  real(dp) :: pole_masses(3)
  real(dp) :: test_scales(6) = (/1.0_dp, 1.3_dp, 1.5_dp, 3.0_dp, 10.0_dp, 200.0_dp /)
  integer  :: i
  !-- for PDFs
  type(grid_def) :: grid
  type(dglap_holder) :: dh
  type(pdf_table)    :: table_pole, table_ms
  real(dp), pointer  :: pdf_init(:,:), pdf_final(:,:)
  real(dp) :: x, pdf_pole(-6:6), pdf_ms(-6:6)
  integer  :: iflv


  dt = dble_val_opt("-dt", 0.2_dp)
  call SetDefaultCouplingDt(dt)

  Q0 = 1.3_dp
  
  asMZ=0.118_dp
  MZ=91.2_dp
  pole_masses(1:3) = (/1.414213563_dp, 4.5_dp, 175.0_dp /)
  
  ! get a coupling with pole masses
  call InitRunningCoupling(coupling_pole, asMZ, MZ, nloop=3, quark_masses = pole_masses)

  

  !======================================================================
  ! now set up 
  call SetDefaultEvolutionDu(0.05_dp)
  call InitGridDef(grid,ymax=10.0_dp, dy=0.1_dp,order=-5)
  call InitDglapHolder(grid,dh,nloop=3,nflo=3,nfhi=6)
  call AllocPDF(grid, pdf_init)
  call AllocPDF(grid, pdf_final)
  pdf_init = unpolarized_dummy_pdf(xValues(grid))

  call AllocPDFTable(grid, table_pole, 1.0_dp, 1e4_dp)
  call AddNfInfoToPDFTable(table_pole, coupling_pole)

  !call PreEvolvePDFTable(table_pole, Q0, dh, coupling_pole)
  !call EvolvePDFTable(table_pole, pdf_init)

  call EvolvePDFTable(table_pole, Q0, pdf_init, dh, coupling_pole)

  pdf_final = pdf_init
  call EvolvePDF(dh, pdf_final, coupling_pole, Q0, 1.5_dp)

  ! side test
  x = 1e-1_dp
  iflv = int_val_opt("-iflv",4)
  
  do i = 1, size(test_scales)
    Q = test_scales(i)
    call EvalPDFTable_xQ(table_pole, x, Q, pdf_pole)
    write(6,*) 'Q, pdf_pole(iflv), pdf_ms(iflv):', &
         & Q, pdf_pole(iflv), pdf_final(:,iflv).atx.(x.with.grid)
  end do



contains
  !======================================================================
  !! The dummy PDF suggested by Vogt as the initial condition for the 
  !! unpolazrized evolution
  function unpolarized_dummy_pdf(xvals) result(pdf)
    real(dp), intent(in) :: xvals(:)
    real(dp)             :: pdf(size(xvals),ncompmin:ncompmax)
    real(dp) :: uv(size(xvals)), dv(size(xvals))
    real(dp) :: ubar(size(xvals)), dbar(size(xvals))
    !---------------------
    real(dp), parameter :: N_g = 1.7_dp, N_ls = 0.387975_dp
    real(dp), parameter :: N_uv=5.107200_dp, N_dv = 3.064320_dp
    real(dp), parameter :: N_db = half*N_ls
  
    pdf = zero
    ! clean method for labelling as PDF as being in the human representation
    call LabelPdfAsHuman(pdf)

    !-- remember that these are all xvals*q(xvals)
    uv = N_uv * xvals**0.8_dp * (1-xvals)**3
    dv = N_dv * xvals**0.8_dp * (1-xvals)**4
    dbar = N_db * xvals**(-0.1_dp) * (1-xvals)**6
    ubar = dbar * (1-xvals)
    pdf(:,iflv_g) = N_g * xvals**(-0.1_dp) * (1-xvals)**5
        
    pdf(:,-iflv_s) = 0.2_dp*(dbar + ubar)
    pdf(:, iflv_s) = pdf(:,-iflv_s)
    pdf(:, iflv_u) = uv + ubar
    pdf(:,-iflv_u) = ubar
    pdf(:, iflv_d) = dv + dbar
    pdf(:,-iflv_d) = dbar

    pdf(:, iflv_c) = dbar

  end function unpolarized_dummy_pdf

end program msbar_tests

!======================================================================
! Need a (set of?) special integrator(s) for going from 
! splitting/coefficient functions to splitting/coefficient arrays
! $Id: integrator.f90,v 1.2 2001/07/17 13:51:01 gsalam Exp $
module integrator
  use types; use consts_dp
  use warnings_and_errors
  implicit none
  private

  public :: ig_LinWeight, ig_LinWeightSing, ig_PolyWeight, ig_PolyWeight_expand

  interface ig_LinWeight
     ! here and in what follows, we could use either the ffunc or the func
     ! version. For now we use the ffunc, with the idea that we might at
     ! some point remove the func version so as to have only one copy 
     ! of each procedure
     module procedure ig_LinWeight_ffunc, ig_LinWeight_class
  end interface
  
  interface ig_LinWeightSing
    module procedure ig_LinWeightSing_ffunc, ig_LinWeightSing_class
  end interface

  interface ig_PolyWeight
    module procedure ig_PolyWeight_ffunc, ig_PolyWeight_class
  end interface

  interface ig_PolyWeight_expand
    module procedure ig_PolyWeight_expand_ffunc, ig_PolyWeight_expand_class
  end interface


  !! The abstract interface for a function to be integrated
  abstract interface
    function ignd_func(x) result(func)
      import dp
      implicit none
      real(dp), intent(in) :: x
      real(dp)             :: func
    end function ignd_func
  end interface
  public :: ignd_func


  !! Base class for integrands. 
  !!
  !! The only thing a derived class needs to do is implement f(this,x),
  !! which should have the signature of ig_cfunc below, where "cfunc"
  !! means "class function"
  type, abstract :: ignd_class
  contains
    procedure(ignd_class__f), deferred :: f
  end type ignd_class
  public :: ignd_class

  !! The abstract interface for the ignd_class%f function
  abstract interface
    function ignd_class__f(this, x) result(func)
      import dp, ignd_class
      implicit none
      class(ignd_class), intent(in) :: this
      real(dp), intent(in) :: x
      real(dp)             :: func
    end function ignd_class__f
  end interface

  !! A concrete example of a class derived from ignd_class, 
  !! which simply wraps a procedure pointer to a function
  !! of type ignd_func. 
  !!
  !! This is a little bit of a roundabout way of doing things, but the
  !! use of the abstract base class means that we can also write classes
  !! that take integrands with additional parameters
  type, extends(ignd_class) :: ignd_class_from_func
    procedure(ignd_func), pointer, nopass :: f_ptr => null()
  contains
    procedure :: f => ignd_class_from_func__f
  end type ignd_class_from_func


contains

  !! Implements ignd_class_from_func%f, evaluating the procedure pointer
  !! returning this%f_ptr(x) 
  !!
  !! \param x the x value at which to evaluate the function
  real(dp) function ignd_class_from_func__f(this, x)
    class(ignd_class_from_func), intent(in) :: this
    real(dp), intent(in) :: x
    ignd_class_from_func__f = this%f_ptr(x)
  end function ignd_class_from_func__f

  !! Wrapper to call ig_LinWeight_class that sets up an ignd_class_from_func
  !! with a procedure pointer to the ignd_func F
  Recursive FUNCTION ig_LinWeight_ffunc(F,A,B,AMult,BMult,EPS, split) result(cgauss64)
    procedure(ignd_func)   :: F
    real(dp), intent(in) :: A,B,AMult,BMult,EPS
    real(dp), intent(in), optional :: split(:)
    real(dp) :: cgauss64
    !-----------
    type(ignd_class_from_func) :: F_class
    F_class%f_ptr => F
    cgauss64 = ig_LinWeight_class(F_class,A,B,AMult,BMult,EPS, split)
  end function ig_LinWeight_ffunc

   Recursive FUNCTION ig_LinWeightSing_ffunc(F,A_in,B_in,AMult,BMult,EPS) &
          &result(cgauss64)
      procedure(ignd_func)   :: F
      real(dp), intent(in) :: A_in,B_in,AMult,BMult,EPS
      real(dp) :: cgauss64
      type(ignd_class_from_func) :: F_class
      F_class%f_ptr => F
      cgauss64 = ig_LinWeightSing_class(F_class,A_in,B_in,AMult,BMult,EPS)
   end function ig_LinWeightSing_ffunc

   Recursive FUNCTION ig_PolyWeight_ffunc(F,A,B,nodes,inode_one,EPS,wgtadd, split) result(cgauss64)
      procedure(ignd_func)   :: F
      real(dp), intent(in) :: A,B,nodes(:),EPS
      integer,  intent(in) :: inode_one
      real(dp), intent(in), optional :: wgtadd
      real(dp), intent(in), optional :: split(:)
      real(dp) :: cgauss64
      type(ignd_class_from_func) :: F_class
      F_class%f_ptr => F
      cgauss64 = ig_PolyWeight_class(F_class,A,B,nodes,inode_one,EPS,wgtadd, split)
   end function ig_PolyWeight_ffunc

   Recursive FUNCTION ig_PolyWeight_expand_ffunc(F,A,B,nodes,inode_one,EPS,wgtadd) result(cgauss64)
      procedure(ignd_func)   :: F
      real(dp), intent(in) :: A,B,nodes(:),EPS
      integer,  intent(in) :: inode_one
      real(dp), intent(in), optional :: wgtadd
      real(dp) :: cgauss64
      type(ignd_class_from_func) :: F_class
      F_class%f_ptr => F
      cgauss64 = ig_PolyWeight_expand_class(F_class,A,B,nodes,inode_one,EPS,wgtadd)
   end function ig_PolyWeight_expand_ffunc
   
  !======================================================================
  !! Function that integrates F weighted with the linear function which has
  !! values AMult and BMult at A & B respectively.
  !!
  !! Result evaluated roughly with precision EPS (rel or abs 
  !! whichever is largest).
  !!
  !! Perhaps in general one is better off writing a version of this routine
  !! which has two function, which get multiplied. Then this routine
  !! would just set parameters for one of those functions. This would
  !! allow the easy generalisation to the case with more complex weight
  !! functions.
  !! 
  Recursive FUNCTION ig_LinWeight_func(F,A,B,AMult,BMult,EPS, split) result(cgauss64)
    procedure(ignd_func)   :: F
    real(dp), intent(in) :: A,B,AMult,BMult,EPS
    real(dp), intent(in), optional :: split(:)
    real(dp), allocatable :: edges(:)
    integer               :: i, n
    real(dp) :: lmult, rmult
    REAL(dp) :: AA,BB,U,C1,C2,S8,S16,H, CGAUSS64, pmult,mmult,Const
    real(dp), parameter :: z1 = 1, hf = half*z1, cst = 5*Z1/1000
    real(dp) :: X(12), W(12)
    CHARACTER(len=*), parameter ::  NAME = 'cgauss64'
    
    DATA X( 1) /9.6028985649753623D-1/, W( 1) /1.0122853629037626D-1/ 
    DATA X( 2) /7.9666647741362674D-1/, W( 2) /2.2238103445337447D-1/ 
    DATA X( 3) /5.2553240991632899D-1/, W( 3) /3.1370664587788729D-1/ 
    DATA X( 4) /1.8343464249564980D-1/, W( 4) /3.6268378337836198D-1/ 
    DATA X( 5) /9.8940093499164993D-1/, W( 5) /2.7152459411754095D-2/ 
    DATA X( 6) /9.4457502307323258D-1/, W( 6) /6.2253523938647893D-2/ 
    DATA X( 7) /8.6563120238783174D-1/, W( 7) /9.5158511682492785D-2/ 
    DATA X( 8) /7.5540440835500303D-1/, W( 8) /1.2462897125553387D-1/ 
    DATA X( 9) /6.1787624440264375D-1/, W( 9) /1.4959598881657673D-1/ 
    DATA X(10) /4.5801677765722739D-1/, W(10) /1.6915651939500254D-1/ 
    DATA X(11) /2.8160355077925891D-1/, W(11) /1.8260341504492359D-1/ 
    DATA X(12) /9.5012509837637440D-2/, W(12) /1.8945061045506850D-1/ 

    if (present(split)) then
      ! allocation cost is about 10ns, to be compared to integration
      ! time for a single simple function of c. 31ns. But without 
      ! splitting, integration time would be much higher (900ns versus
      ! a total of 73 ns with splitting), as well as less reliable.
      allocate(edges(size(split)+2))
      call split_limits(A,B,split,edges, n)
      cgauss64 = zero
      do i = 1, n
         lmult = ((edges(i  ) - A)/(B-A) * (BMult -AMult) + AMult)
         rmult = ((edges(i+1) - A)/(B-A) * (BMult -AMult) + AMult)
         cgauss64 = cgauss64 + ig_LinWeight_func(F,edges(i),edges(i+1),lmult,rmult,EPS)
      end do
      return
    end if

    H=0 
    IF(B .EQ. A) GO TO 99 
    CONST=CST/ABS(B-A) 
    BB=A 
1   AA=BB 
    BB=B 
2   C1=HF*(BB+AA) 
    C2=HF*(BB-AA) 
    S8=0 
    DO I = 1,4 
       U=C2*X(I) 
       pmult = ((c1+u) - A)/(B-A) * (BMult -AMult) + AMult
       mmult = ((c1-u) - A)/(B-A) * (BMult -AMult) + AMult
       S8=S8+W(I)*(F(C1+U)*pmult+F(C1-U)*mmult) 
    END DO
    S16=0 
    DO I = 5,12 
       U=C2*X(I) 
       pmult = ((c1+u) - A)/(B-A) * (BMult -AMult) + AMult
       mmult = ((c1-u) - A)/(B-A) * (BMult -AMult) + AMult
       S16=S16+W(I)*(F(C1+U)*pmult+F(C1-U)*mmult) 
    END DO
    S16=C2*S16 
    IF(ABS(S16-C2*S8) .LE. EPS*(1+ABS(S16))) THEN 
       H=H+S16 
       IF(BB .NE. B) GO TO 1 
    ELSE 
       BB=C1 
       IF(1+CONST*ABS(C2) .NE. 1) GO TO 2 
       H=0 
       !CALL MTLPRT(NAME,'D113.1','TOO HIGH ACCURACY REQUIRED') 
       write(0,*) NAME,'D113.1','TOO HIGH ACCURACY REQUIRED'
       GO TO 99 
    END IF
99  cgauss64=H 
  end function ig_LinWeight_func


  !! Function that integrates F weighted with the linear function which has
  !! values AMult and BMult at A & B respectively.
  !!
  !! Result evaluated roughly with precision EPS (rel or abs 
  !! whichever is largest).
  !!
  !! Perhaps in general one is better off writing a version of this routine
  !! which has two function, which get multiplied. Then this routine
  !! would just set parameters for one of those functions. This would
  !! allow the easy generalisation to the case with more complex weight
  !! functions.
  !! 
  Recursive FUNCTION ig_LinWeight_class(F,A,B,AMult,BMult,EPS, split) result(cgauss64)
    class(ignd_class), intent(in) :: F
    real(dp), intent(in) :: A,B,AMult,BMult,EPS
    real(dp), intent(in), optional :: split(:)
    real(dp), allocatable :: edges(:)
    integer               :: i, n
    real(dp) :: lmult, rmult
    REAL(dp) :: AA,BB,U,C1,C2,S8,S16,H, CGAUSS64, pmult,mmult,Const
    real(dp), parameter :: z1 = 1, hf = half*z1, cst = 5*Z1/1000
    real(dp) :: X(12), W(12)
    CHARACTER(len=*), parameter ::  NAME = 'cgauss64'
    
    DATA X( 1) /9.6028985649753623D-1/, W( 1) /1.0122853629037626D-1/ 
    DATA X( 2) /7.9666647741362674D-1/, W( 2) /2.2238103445337447D-1/ 
    DATA X( 3) /5.2553240991632899D-1/, W( 3) /3.1370664587788729D-1/ 
    DATA X( 4) /1.8343464249564980D-1/, W( 4) /3.6268378337836198D-1/ 
    DATA X( 5) /9.8940093499164993D-1/, W( 5) /2.7152459411754095D-2/ 
    DATA X( 6) /9.4457502307323258D-1/, W( 6) /6.2253523938647893D-2/ 
    DATA X( 7) /8.6563120238783174D-1/, W( 7) /9.5158511682492785D-2/ 
    DATA X( 8) /7.5540440835500303D-1/, W( 8) /1.2462897125553387D-1/ 
    DATA X( 9) /6.1787624440264375D-1/, W( 9) /1.4959598881657673D-1/ 
    DATA X(10) /4.5801677765722739D-1/, W(10) /1.6915651939500254D-1/ 
    DATA X(11) /2.8160355077925891D-1/, W(11) /1.8260341504492359D-1/ 
    DATA X(12) /9.5012509837637440D-2/, W(12) /1.8945061045506850D-1/ 

    if (present(split)) then
      ! allocation cost is about 10ns, to be compared to integration
      ! time for a single simple function of c. 31ns. But without 
      ! splitting, integration time would be much higher (900ns versus
      ! a total of 73 ns with splitting), as well as less reliable.
      allocate(edges(size(split)+2))
      call split_limits(A,B,split,edges, n)
      cgauss64 = zero
      do i = 1, n
         lmult = ((edges(i  ) - A)/(B-A) * (BMult -AMult) + AMult)
         rmult = ((edges(i+1) - A)/(B-A) * (BMult -AMult) + AMult)
         cgauss64 = cgauss64 + ig_LinWeight_class(F,edges(i),edges(i+1),lmult,rmult,EPS)
      end do
      return
    end if

    H=0 
    IF(B .EQ. A) GO TO 99 
    CONST=CST/ABS(B-A) 
    BB=A 
1   AA=BB 
    BB=B 
2   C1=HF*(BB+AA) 
    C2=HF*(BB-AA) 
    S8=0 
    DO I = 1,4 
       U=C2*X(I) 
       pmult = ((c1+u) - A)/(B-A) * (BMult -AMult) + AMult
       mmult = ((c1-u) - A)/(B-A) * (BMult -AMult) + AMult
       S8=S8+W(I)*(F%f(C1+U)*pmult+F%f(C1-U)*mmult) 
    END DO
    S16=0 
    DO I = 5,12 
       U=C2*X(I) 
       pmult = ((c1+u) - A)/(B-A) * (BMult -AMult) + AMult
       mmult = ((c1-u) - A)/(B-A) * (BMult -AMult) + AMult
       S16=S16+W(I)*(F%f(C1+U)*pmult+F%f(C1-U)*mmult) 
    END DO
    S16=C2*S16 
    IF(ABS(S16-C2*S8) .LE. EPS*(1+ABS(S16))) THEN 
       H=H+S16 
       IF(BB .NE. B) GO TO 1 
    ELSE 
       BB=C1 
       IF(1+CONST*ABS(C2) .NE. 1) GO TO 2 
       H=0 
       !CALL MTLPRT(NAME,'D113.1','TOO HIGH ACCURACY REQUIRED') 
       write(0,*) NAME,'D113.1','TOO HIGH ACCURACY REQUIRED'
       GO TO 99 
    END IF
99  cgauss64=H 
  end function ig_LinWeight_class


  !-------------------------------------------------------
  ! Try to improve convergence on nasty integrals
   Recursive FUNCTION ig_LinWeightSing_func(F,A_in,B_in,AMult,BMult,EPS) &
          &result(cgauss64)
      procedure(ignd_func)   :: F
      real(dp), intent(in) :: A_in,B_in,AMult,BMult,EPS
      REAL(dp) :: AA,BB,U,C1,C2,S8,S16,H, CGAUSS64, pmult,mmult,Const
      real(dp), parameter :: z1 = 1, hf = half*z1, cst = 5*Z1/1000
      real(dp) :: X(12), W(12), A, B, xp, xm, wp, wm
      integer :: i
      CHARACTER(len=*), parameter ::  NAME = 'cgauss64'
    
    DATA X( 1) /9.6028985649753623D-1/, W( 1) /1.0122853629037626D-1/ 
    DATA X( 2) /7.9666647741362674D-1/, W( 2) /2.2238103445337447D-1/ 
    DATA X( 3) /5.2553240991632899D-1/, W( 3) /3.1370664587788729D-1/ 
    DATA X( 4) /1.8343464249564980D-1/, W( 4) /3.6268378337836198D-1/ 
    DATA X( 5) /9.8940093499164993D-1/, W( 5) /2.7152459411754095D-2/ 
    DATA X( 6) /9.4457502307323258D-1/, W( 6) /6.2253523938647893D-2/ 
    DATA X( 7) /8.6563120238783174D-1/, W( 7) /9.5158511682492785D-2/ 
    DATA X( 8) /7.5540440835500303D-1/, W( 8) /1.2462897125553387D-1/ 
    DATA X( 9) /6.1787624440264375D-1/, W( 9) /1.4959598881657673D-1/ 
    DATA X(10) /4.5801677765722739D-1/, W(10) /1.6915651939500254D-1/ 
    DATA X(11) /2.8160355077925891D-1/, W(11) /1.8260341504492359D-1/ 
    DATA X(12) /9.5012509837637440D-2/, W(12) /1.8945061045506850D-1/ 


    ! change variables specifically for case of singularity close to zero
    A = sqrt(A_in); B = sqrt(B_in)
    
    
    H=0 
    IF(B .EQ. A) GO TO 99 
    CONST=CST/ABS(B-A) 
    BB=A 
1   AA=BB 
    BB=B 
2   C1=HF*(BB+AA) 
    C2=HF*(BB-AA) 
    S8=0 
    DO I = 1,4 
       U=C2*X(I)
       !-- get original variables...
       xp = (c1+u)**2; xm = (c1-u)**2
       pmult = (xp - A_in)/(B_in-A_in) * (BMult -AMult) + AMult
       mmult = (xm - A)/(B-A) * (BMult -AMult) + AMult
       !-- account for change of weight due two change of var
       pmult = pmult * two*(c1+u)
       mmult = mmult * two*(c1-u)
       S8=S8+W(I)*(F(xp)*pmult+F(xm)*mmult) 
    END DO
    S16=0 
    DO I = 5,12 
       U=C2*X(I) 
       !-- get original variables...
       xp = (c1+u)**2; xm = (c1-u)**2
       pmult = (xp - A_in)/(B_in-A_in) * (BMult -AMult) + AMult
       mmult = (xm - A)/(B-A) * (BMult -AMult) + AMult
       !-- account for change of weight due two change of var
       pmult = pmult * two*(c1+u)
       mmult = mmult * two*(c1-u)
       S16=S16+W(I)*(F(xp)*pmult+F(xm)*mmult) 
    END DO
    S16=C2*S16 
    IF(ABS(S16-C2*S8) .LE. EPS*(1+ABS(S16))) THEN 
       H=H+S16 
       IF(BB .NE. B) GO TO 1 
    ELSE 
       BB=C1 
       IF(1+CONST*ABS(C2) .NE. 1) GO TO 2 
       H=0 
       !CALL MTLPRT(NAME,'D113.1','TOO HIGH ACCURACY REQUIRED') 
       write(0,*) NAME,'D113.1','TOO HIGH ACCURACY REQUIRED'
       GO TO 99 
    END IF
99  cgauss64=H 
  end function ig_LinWeightSing_func

  Recursive FUNCTION ig_LinWeightSing_class(F,A_in,B_in,AMult,BMult,EPS) &
       &result(cgauss64)
    class(ignd_class), intent(in) :: F
    real(dp), intent(in) :: A_in,B_in,AMult,BMult,EPS
    REAL(dp) :: AA,BB,U,C1,C2,S8,S16,H, CGAUSS64, pmult,mmult,Const
    real(dp), parameter :: z1 = 1, hf = half*z1, cst = 5*Z1/1000
    real(dp) :: X(12), W(12), A, B, xp, xm, wp, wm
    integer :: i
    CHARACTER(len=*), parameter ::  NAME = 'cgauss64'

    DATA X( 1) /9.6028985649753623D-1/, W( 1) /1.0122853629037626D-1/ 
    DATA X( 2) /7.9666647741362674D-1/, W( 2) /2.2238103445337447D-1/ 
    DATA X( 3) /5.2553240991632899D-1/, W( 3) /3.1370664587788729D-1/ 
    DATA X( 4) /1.8343464249564980D-1/, W( 4) /3.6268378337836198D-1/ 
    DATA X( 5) /9.8940093499164993D-1/, W( 5) /2.7152459411754095D-2/ 
    DATA X( 6) /9.4457502307323258D-1/, W( 6) /6.2253523938647893D-2/ 
    DATA X( 7) /8.6563120238783174D-1/, W( 7) /9.5158511682492785D-2/ 
    DATA X( 8) /7.5540440835500303D-1/, W( 8) /1.2462897125553387D-1/ 
    DATA X( 9) /6.1787624440264375D-1/, W( 9) /1.4959598881657673D-1/ 
    DATA X(10) /4.5801677765722739D-1/, W(10) /1.6915651939500254D-1/ 
    DATA X(11) /2.8160355077925891D-1/, W(11) /1.8260341504492359D-1/ 
    DATA X(12) /9.5012509837637440D-2/, W(12) /1.8945061045506850D-1/ 

    ! change variables specifically for case of singularity close to zero
    A = sqrt(A_in); B = sqrt(B_in)
    
    
    H=0 
    IF(B .EQ. A) GO TO 99 
    CONST=CST/ABS(B-A) 
    BB=A 
1   AA=BB 
    BB=B 
2   C1=HF*(BB+AA) 
    C2=HF*(BB-AA) 
    S8=0 
    DO I = 1,4 
       U=C2*X(I)
       !-- get original variables...
       xp = (c1+u)**2; xm = (c1-u)**2
       pmult = (xp - A_in)/(B_in-A_in) * (BMult -AMult) + AMult
       mmult = (xm - A)/(B-A) * (BMult -AMult) + AMult
       !-- account for change of weight due two change of var
       pmult = pmult * two*(c1+u)
       mmult = mmult * two*(c1-u)
       S8=S8+W(I)*(F%f(xp)*pmult+F%f(xm)*mmult) 
    END DO
    S16=0 
    DO I = 5,12 
       U=C2*X(I) 
       !-- get original variables...
       xp = (c1+u)**2; xm = (c1-u)**2
       pmult = (xp - A_in)/(B_in-A_in) * (BMult -AMult) + AMult
       mmult = (xm - A)/(B-A) * (BMult -AMult) + AMult
       !-- account for change of weight due two change of var
       pmult = pmult * two*(c1+u)
       mmult = mmult * two*(c1-u)
       S16=S16+W(I)*(F%f(xp)*pmult+F%f(xm)*mmult) 
    END DO
    S16=C2*S16 
    IF(ABS(S16-C2*S8) .LE. EPS*(1+ABS(S16))) THEN 
       H=H+S16 
       IF(BB .NE. B) GO TO 1 
    ELSE 
       BB=C1 
       IF(1+CONST*ABS(C2) .NE. 1) GO TO 2 
       H=0 
       !CALL MTLPRT(NAME,'D113.1','TOO HIGH ACCURACY REQUIRED') 
       write(0,*) NAME,'D113.1','TOO HIGH ACCURACY REQUIRED'
       GO TO 99 
    END IF
99  cgauss64=H 
  end function ig_LinWeightSing_class
  

  !----------------------------------------------------------------------
  ! 
  !! Integrate F with a polynomial weight function which is zero at all
  !! nodes except that indicated by the index inode_one
  !! 
  !! If wgtadd is present then it is added to the weight function
  Recursive FUNCTION ig_PolyWeight_func(F,A,B,nodes,inode_one,EPS,wgtadd, split) result(cgauss64)
      procedure(ignd_func)   :: F
    real(dp), intent(in) :: A,B,nodes(:),EPS
    integer,  intent(in) :: inode_one
    real(dp), intent(in), optional :: wgtadd
    real(dp), intent(in), optional :: split(:)
    real(dp), allocatable :: edges(:)
    real(dp) :: zero_nodes(size(nodes)-1), norm_nodes, lcl_wgtadd
    integer  :: i, j, n
    REAL(dp) :: AA,BB,U,C1,C2,S8,S16,H, CGAUSS64, pmult,mmult,Const
    real(dp), parameter :: z1 = 1, hf = half*z1, cst = 5*Z1/1000
    real(dp) :: X(12), W(12)
    CHARACTER(len=*), parameter ::  NAME = 'cgauss64'
    
    DATA X( 1) /9.6028985649753623D-1/, W( 1) /1.0122853629037626D-1/ 
    DATA X( 2) /7.9666647741362674D-1/, W( 2) /2.2238103445337447D-1/ 
    DATA X( 3) /5.2553240991632899D-1/, W( 3) /3.1370664587788729D-1/ 
    DATA X( 4) /1.8343464249564980D-1/, W( 4) /3.6268378337836198D-1/ 
    DATA X( 5) /9.8940093499164993D-1/, W( 5) /2.7152459411754095D-2/ 
    DATA X( 6) /9.4457502307323258D-1/, W( 6) /6.2253523938647893D-2/ 
    DATA X( 7) /8.6563120238783174D-1/, W( 7) /9.5158511682492785D-2/ 
    DATA X( 8) /7.5540440835500303D-1/, W( 8) /1.2462897125553387D-1/ 
    DATA X( 9) /6.1787624440264375D-1/, W( 9) /1.4959598881657673D-1/ 
    DATA X(10) /4.5801677765722739D-1/, W(10) /1.6915651939500254D-1/ 
    DATA X(11) /2.8160355077925891D-1/, W(11) /1.8260341504492359D-1/ 
    DATA X(12) /9.5012509837637440D-2/, W(12) /1.8945061045506850D-1/ 


    !-- first set up the structure for the polynomial interpolation--
    j = 0
    do i = 1, size(nodes)
       if (i /= inode_one) then
          j = j + 1
          zero_nodes(j) = nodes(i)
       end if
    end do
    norm_nodes = 1.0_dp / product(nodes(inode_one) - zero_nodes)
    if (present(wgtadd)) then
       lcl_wgtadd = wgtadd
    else
       lcl_wgtadd = zero
    end if

    H=0 
    IF(B .EQ. A) GO TO 99 
    CONST=CST/ABS(B-A) 
    BB=A 
1   AA=BB 
    BB=B 
2   C1=HF*(BB+AA) 
    C2=HF*(BB-AA) 
    S8=0 
    DO I = 1,4 
       U=C2*X(I) 
       pmult = product(c1+u - zero_nodes) * norm_nodes + lcl_wgtadd
       mmult = product(c1-u - zero_nodes) * norm_nodes + lcl_wgtadd
       S8=S8+W(I)*(F(C1+U)*pmult+F(C1-U)*mmult) 
    END DO
    S16=0 
    DO I = 5,12 
       U=C2*X(I) 
       pmult = product(c1+u - zero_nodes) * norm_nodes + lcl_wgtadd
       mmult = product(c1-u - zero_nodes) * norm_nodes + lcl_wgtadd
       S16=S16+W(I)*(F(C1+U)*pmult+F(C1-U)*mmult) 
    END DO
    S16=C2*S16 
    IF(ABS(S16-C2*S8) .LE. EPS*(1+ABS(S16))) THEN 
       H=H+S16 
       IF(BB .NE. B) GO TO 1 
    ELSE 
       BB=C1 
       IF(1+CONST*ABS(C2) .NE. 1) GO TO 2 
       H=0 
       !CALL MTLPRT(NAME,'D113.1','TOO HIGH ACCURACY REQUIRED') 
       write(0,*) NAME,'D113.1','TOO HIGH ACCURACY REQUIRED'
       GO TO 99 
    END IF
99  cgauss64=H 
  end function ig_PolyWeight_func

  !! Integrate F with a polynomial weight function which is zero at all
  !! nodes except that indicated by the index inode_one
  !! 
  !! If wgtadd is present then it is added to the weight function
  Recursive FUNCTION ig_PolyWeight_class(F,A,B,nodes,inode_one,EPS,wgtadd, split) result(cgauss64)
    class(ignd_class), intent(in) :: F
    real(dp), intent(in) :: A,B,nodes(:),EPS
    integer,  intent(in) :: inode_one
    real(dp), intent(in), optional :: wgtadd
    real(dp), intent(in), optional :: split(:)
    real(dp), allocatable :: edges(:)
    real(dp) :: zero_nodes(size(nodes)-1), norm_nodes, lcl_wgtadd
    integer  :: i, j, n
    REAL(dp) :: AA,BB,U,C1,C2,S8,S16,H, CGAUSS64, pmult,mmult,Const
    real(dp), parameter :: z1 = 1, hf = half*z1, cst = 5*Z1/1000
    real(dp) :: X(12), W(12)
    CHARACTER(len=*), parameter ::  NAME = 'cgauss64'
    
    DATA X( 1) /9.6028985649753623D-1/, W( 1) /1.0122853629037626D-1/ 
    DATA X( 2) /7.9666647741362674D-1/, W( 2) /2.2238103445337447D-1/ 
    DATA X( 3) /5.2553240991632899D-1/, W( 3) /3.1370664587788729D-1/ 
    DATA X( 4) /1.8343464249564980D-1/, W( 4) /3.6268378337836198D-1/ 
    DATA X( 5) /9.8940093499164993D-1/, W( 5) /2.7152459411754095D-2/ 
    DATA X( 6) /9.4457502307323258D-1/, W( 6) /6.2253523938647893D-2/ 
    DATA X( 7) /8.6563120238783174D-1/, W( 7) /9.5158511682492785D-2/ 
    DATA X( 8) /7.5540440835500303D-1/, W( 8) /1.2462897125553387D-1/ 
    DATA X( 9) /6.1787624440264375D-1/, W( 9) /1.4959598881657673D-1/ 
    DATA X(10) /4.5801677765722739D-1/, W(10) /1.6915651939500254D-1/ 
    DATA X(11) /2.8160355077925891D-1/, W(11) /1.8260341504492359D-1/ 
    DATA X(12) /9.5012509837637440D-2/, W(12) /1.8945061045506850D-1/ 

    !-- first set up the structure for the polynomial interpolation--
    j = 0
    do i = 1, size(nodes)
       if (i /= inode_one) then
          j = j + 1
          zero_nodes(j) = nodes(i)
       end if
    end do
    norm_nodes = 1.0_dp / product(nodes(inode_one) - zero_nodes)
    if (present(wgtadd)) then
       lcl_wgtadd = wgtadd
    else
       lcl_wgtadd = zero
    end if

    H=0 
    IF(B .EQ. A) GO TO 99 
    CONST=CST/ABS(B-A) 
    BB=A 
1   AA=BB 
    BB=B 
2   C1=HF*(BB+AA) 
    C2=HF*(BB-AA) 
    S8=0 
    DO I = 1,4 
       U=C2*X(I) 
       pmult = product(c1+u - zero_nodes) * norm_nodes + lcl_wgtadd
       mmult = product(c1-u - zero_nodes) * norm_nodes + lcl_wgtadd
       S8=S8+W(I)*(F%f(C1+U)*pmult+F%f(C1-U)*mmult) 
    END DO
    S16=0 
    DO I = 5,12 
       U=C2*X(I) 
       pmult = product(c1+u - zero_nodes) * norm_nodes + lcl_wgtadd
       mmult = product(c1-u - zero_nodes) * norm_nodes + lcl_wgtadd
       S16=S16+W(I)*(F%f(C1+U)*pmult+F%f(C1-U)*mmult) 
    END DO
    S16=C2*S16 
    IF(ABS(S16-C2*S8) .LE. EPS*(1+ABS(S16))) THEN 
       H=H+S16 
       IF(BB .NE. B) GO TO 1 
    ELSE 
       BB=C1 
       IF(1+CONST*ABS(C2) .NE. 1) GO TO 2 
       H=0 
       !CALL MTLPRT(NAME,'D113.1','TOO HIGH ACCURACY REQUIRED') 
       write(0,*) NAME,'D113.1','TOO HIGH ACCURACY REQUIRED'
       GO TO 99 
    END IF
99  cgauss64=H 
  end function ig_PolyWeight_class

  
  !----------------------------------------------------------------------
  !! 
  !! Integrate F with a polynomial weight function which is zero at all
  !! nodes except that indicated by the index inode_one
  !! 
  !! If wgtadd is present then it is added to the weight function
  !!
  !! This version expands around the series in powers of
  !! v=(x-nodes(inode_one))~0 when v is small, to avoid numerical issues
  !! with convolution of real pieces
  Recursive FUNCTION ig_PolyWeight_expand_func(F,A,B,nodes,inode_one,EPS,wgtadd) result(cgauss64)
    use warnings_and_errors
    procedure(ignd_func)   :: F
    real(dp), intent(in) :: A,B,nodes(:),EPS
    integer,  intent(in) :: inode_one
    real(dp), intent(in), optional :: wgtadd
    real(dp) :: zero_nodes(size(nodes)-1), norm_nodes, lcl_wgtadd, expand1, expand2
    integer  :: i, j, k, l
    REAL(dp) :: AA,BB,U,C1,C2,S8,S16,H, CGAUSS64, pmult,mmult,Const
    real(dp), parameter :: z1 = 1, hf = half*z1, cst = 5*Z1/1000
    real(dp) :: X(12), W(12)
    ! the expansion threshold determines how close to inode we get
    ! before we switch to the expansion around inode. The
    ! switch location is about epsilon**(1/3)*dy, corresponding
    ! to the fact that we include terms up to (x-inode)**2
    ! (we assume nodes have relatively uniform spacing). 
    real(dp), parameter :: expansion_threshold_fraction = 3e-6_dp
    real(dp) :: expansion_threshold
    CHARACTER(len=*), parameter ::  NAME = 'cgauss64'
    
    DATA X( 1) /9.6028985649753623D-1/, W( 1) /1.0122853629037626D-1/ 
    DATA X( 2) /7.9666647741362674D-1/, W( 2) /2.2238103445337447D-1/ 
    DATA X( 3) /5.2553240991632899D-1/, W( 3) /3.1370664587788729D-1/ 
    DATA X( 4) /1.8343464249564980D-1/, W( 4) /3.6268378337836198D-1/ 
    DATA X( 5) /9.8940093499164993D-1/, W( 5) /2.7152459411754095D-2/ 
    DATA X( 6) /9.4457502307323258D-1/, W( 6) /6.2253523938647893D-2/ 
    DATA X( 7) /8.6563120238783174D-1/, W( 7) /9.5158511682492785D-2/ 
    DATA X( 8) /7.5540440835500303D-1/, W( 8) /1.2462897125553387D-1/ 
    DATA X( 9) /6.1787624440264375D-1/, W( 9) /1.4959598881657673D-1/ 
    DATA X(10) /4.5801677765722739D-1/, W(10) /1.6915651939500254D-1/ 
    DATA X(11) /2.8160355077925891D-1/, W(11) /1.8260341504492359D-1/ 
    DATA X(12) /9.5012509837637440D-2/, W(12) /1.8945061045506850D-1/ 

    !-- first set up the structure for the polynomial interpolation--
    j = 0
    do i = 1, size(nodes)
       if (i /= inode_one) then
          j = j + 1
          zero_nodes(j) = nodes(i)
       end if
    end do
    norm_nodes = 1.0_dp / product(nodes(inode_one) - zero_nodes)
    
    ! use the spacing between the first two nodes to decide the actual
    ! expansion threshold
    expansion_threshold = expansion_threshold_fraction * abs(nodes(2) - nodes(1))
    expand1 = zero
    expand2 = zero
    ! GPS 2024-02-06: I think that the code is only correct when nodes(inode_one) is zero
    ! -- otherwise one should replace -1/zero_nodes(i) with 1/(nodes(inode_one) - zero_nodes(i))
    if (nodes(inode_one) /= zero) call wae_error("ig_PolyWeight_expand: nodes(inode_one) /= zero but is instead", &
                               &   dbleval = nodes(inode_one))
    do i = 1, size(zero_nodes)
       expand1 = expand1 - 1.0_dp / zero_nodes(i)
       do k=i+1, size(zero_nodes)
         expand2 = expand2 + one/(zero_nodes(i)*zero_nodes(k))
       end do
    end do

    if (present(wgtadd)) then
       lcl_wgtadd = wgtadd
    else
       lcl_wgtadd = zero
    end if

    H=0 
    IF(B .EQ. A) GO TO 99 
    CONST=CST/ABS(B-A) 
    BB=A 
1   AA=BB 
    BB=B 
2   C1=HF*(BB+AA) 
    C2=HF*(BB-AA) 
    S8=0 
    DO I = 1,4 
       U=C2*X(I)
       if (abs(c1+u) < expansion_threshold) then
          ! NB: in situations where lcl_wgtadd is exactly -one, (one +
          ! lcl_wgtadd) should be evaluated before anything else, giving
          ! exactly zero, and ensuring that we have high accuracy for
          ! the remaining terms.
          pmult = (one + lcl_wgtadd) + (c1+u)*expand1 + ((c1+u)**2)*expand2
       else
          pmult = product(c1+u - zero_nodes) * norm_nodes + lcl_wgtadd
       endif
       if (abs(c1-u) < expansion_threshold) then
          mmult = (one + lcl_wgtadd) + (c1-u)*expand1 + ((c1-u)**2)*expand2
       else
          mmult = product(c1-u - zero_nodes) * norm_nodes + lcl_wgtadd
       endif
       ! pmult = product(c1+u - zero_nodes) * norm_nodes + lcl_wgtadd
       ! mmult = product(c1-u - zero_nodes) * norm_nodes + lcl_wgtadd
       S8=S8+W(I)*(F(C1+U)*pmult+F(C1-U)*mmult) 
    END DO
    S16=0 
    DO I = 5,12 
       U=C2*X(I) 
       if (abs(c1+u) < expansion_threshold) then
          pmult = (one + lcl_wgtadd) + (c1+u)*expand1 + ((c1+u)**2)*expand2
       else
          pmult = product(c1+u - zero_nodes) * norm_nodes + lcl_wgtadd
       endif
       if (abs(c1-u) < expansion_threshold) then
          mmult = (one + lcl_wgtadd) + (c1-u)*expand1 + ((c1-u)**2)*expand2
       else
          mmult = product(c1-u - zero_nodes) * norm_nodes + lcl_wgtadd
       endif
       ! pmult = product(c1+u - zero_nodes) * norm_nodes + lcl_wgtadd
       ! mmult = product(c1-u - zero_nodes) * norm_nodes + lcl_wgtadd
       S16=S16+W(I)*(F(C1+U)*pmult+F(C1-U)*mmult)
    END DO
    S16=C2*S16 
    IF(ABS(S16-C2*S8) .LE. EPS*(1+ABS(S16))) THEN 
       H=H+S16 
       IF(BB .NE. B) GO TO 1 
    ELSE 
       BB=C1 
       IF(1+CONST*ABS(C2) .NE. 1) GO TO 2 
       H=0 
       !CALL MTLPRT(NAME,'D113.1','TOO HIGH ACCURACY REQUIRED') 
       write(0,*) NAME,'D113.1','TOO HIGH ACCURACY REQUIRED'
       GO TO 99 
    END IF
99  cgauss64=H 
  end function ig_PolyWeight_expand_func

  !! Integrate F with a polynomial weight function which is zero at all
  !! nodes except that indicated by the index inode_one
  !! 
  !! If wgtadd is present then it is added to the weight function
  !!
  !! This version expands around the series in powers of
  !! v=(x-nodes(inode_one))~0 when v is small, to avoid numerical issues
  !! with convolution of real pieces
  Recursive FUNCTION ig_PolyWeight_expand_class(F,A,B,nodes,inode_one,EPS,wgtadd) result(cgauss64)
    use warnings_and_errors
    class(ignd_class), intent(in) :: F
    real(dp), intent(in) :: A,B,nodes(:),EPS
    integer,  intent(in) :: inode_one
    real(dp), intent(in), optional :: wgtadd
    real(dp) :: zero_nodes(size(nodes)-1), norm_nodes, lcl_wgtadd, expand1, expand2
    integer  :: i, j, k, l
    REAL(dp) :: AA,BB,U,C1,C2,S8,S16,H, CGAUSS64, pmult,mmult,Const
    real(dp), parameter :: z1 = 1, hf = half*z1, cst = 5*Z1/1000
    real(dp) :: X(12), W(12)
    ! the expansion threshold determines how close to inode we get
    ! before we switch to the expansion around inode. The
    ! switch location is about epsilon**(1/3)*dy, corresponding
    ! to the fact that we include terms up to (x-inode)**2
    ! (we assume nodes have relatively uniform spacing). 
    real(dp), parameter :: expansion_threshold_fraction = 3e-6_dp
    real(dp) :: expansion_threshold
    CHARACTER(len=*), parameter ::  NAME = 'cgauss64'
    
    DATA X( 1) /9.6028985649753623D-1/, W( 1) /1.0122853629037626D-1/ 
    DATA X( 2) /7.9666647741362674D-1/, W( 2) /2.2238103445337447D-1/ 
    DATA X( 3) /5.2553240991632899D-1/, W( 3) /3.1370664587788729D-1/ 
    DATA X( 4) /1.8343464249564980D-1/, W( 4) /3.6268378336198D-1/ 
    DATA X( 5) /9.8940093499164993D-1/, W( 5) /2.7152459411754095D-2/ 
    DATA X( 6) /9.4457502307323258D-1/, W( 6) /6.2253523938647893D-2/ 
    DATA X( 7) /8.6563120238783174D-1/, W( 7) /9.5158511682492785D-2/ 
    DATA X( 8) /7.5540440835500303D-1/, W( 8) /1.2462897125553387D-1/ 
    DATA X( 9) /6.1787624440264375D-1/, W( 9) /1.4959598881657673D-1/ 
    DATA X(10) /4.5801677765722739D-1/, W(10) /1.6915651939500254D-1/ 
    DATA X(11) /2.8160355077925891D-1/, W(11) /1.8260341504492359D-1/ 
    DATA X(12) /9.5012509837637440D-2/, W(12) /1.8945061045506850D-1/ 

    !-- first set up the structure for the polynomial interpolation--
    j = 0
    do i = 1, size(nodes)
       if (i /= inode_one) then
          j = j + 1
          zero_nodes(j) = nodes(i)
       end if
    end do
    norm_nodes = 1.0_dp / product(nodes(inode_one) - zero_nodes)
    
    ! use the spacing between the first two nodes to decide the actual
    ! expansion threshold
    expansion_threshold = expansion_threshold_fraction * abs(nodes(2) - nodes(1))
    expand1 = zero
    expand2 = zero
    ! GPS 2024-02-06: I think that the code is only correct when nodes(inode_one) is zero
    ! -- otherwise one should replace -1/zero_nodes(i) with 1/(nodes(inode_one) - zero_nodes(i))
    if (nodes(inode_one) /= zero) call wae_error("ig_PolyWeight_expand: nodes(inode_one) /= zero but is instead", &
                               &   dbleval = nodes(inode_one))
    do i = 1, size(zero_nodes)
       expand1 = expand1 - 1.0_dp / zero_nodes(i)
       do k=i+1, size(zero_nodes)
         expand2 = expand2 + one/(zero_nodes(i)*zero_nodes(k))
       end do
    end do

    if (present(wgtadd)) then
       lcl_wgtadd = wgtadd
    else
       lcl_wgtadd = zero
    end if

    H=0 
    IF(B .EQ. A) GO TO 99 
    CONST=CST/ABS(B-A) 
    BB=A 
1   AA=BB 
    BB=B 
2   C1=HF*(BB+AA) 
    C2=HF*(BB-AA) 
    S8=0 
    DO I = 1,4 
       U=C2*X(I)
       if (abs(c1+u) < expansion_threshold) then
          ! NB: in situations where lcl_wgtadd is exactly -one, (one +
          ! lcl_wgtadd) should be evaluated before anything else, giving
          ! exactly zero, and ensuring that we have high accuracy for
          ! the remaining terms.
          pmult = (one + lcl_wgtadd) + (c1+u)*expand1 + ((c1+u)**2)*expand2
       else
          pmult = product(c1+u - zero_nodes) * norm_nodes + lcl_wgtadd
       endif
       if (abs(c1-u) < expansion_threshold) then
          mmult = (one + lcl_wgtadd) + (c1-u)*expand1 + ((c1-u)**2)*expand2
       else
          mmult = product(c1-u - zero_nodes) * norm_nodes + lcl_wgtadd
       endif
       ! pmult = product(c1+u - zero_nodes) * norm_nodes + lcl_wgtadd
       ! mmult = product(c1-u - zero_nodes) * norm_nodes + lcl_wgtadd
       S8=S8+W(I)*(F%f(C1+U)*pmult+F%f(C1-U)*mmult) 
    END DO
    S16=0 
    DO I = 5,12 
       U=C2*X(I) 
       if (abs(c1+u) < expansion_threshold) then
          pmult = (one + lcl_wgtadd) + (c1+u)*expand1 + ((c1+u)**2)*expand2
       else
          pmult = product(c1+u - zero_nodes) * norm_nodes + lcl_wgtadd
       endif
       if (abs(c1-u) < expansion_threshold) then
          mmult = (one + lcl_wgtadd) + (c1-u)*expand1 + ((c1-u)**2)*expand2
       else
          mmult = product(c1-u - zero_nodes) * norm_nodes + lcl_wgtadd
       endif
       ! pmult = product(c1+u - zero_nodes) * norm_nodes + lcl_wgtadd
       ! mmult = product(c1-u - zero_nodes) * norm_nodes + lcl_wgtadd
       S16=S16+W(I)*(F%f(C1+U)*pmult+F%f(C1-U)*mmult)
    END DO
    S16=C2*S16 
    IF(ABS(S16-C2*S8) .LE. EPS*(1+ABS(S16))) THEN 
       H=H+S16 
       IF(BB .NE. B) GO TO 1 
    ELSE 
       BB=C1 
       IF(1+CONST*ABS(C2) .NE. 1) GO TO 2 
       H=0 
       !CALL MTLPRT(NAME,'D113.1','TOO HIGH ACCURACY REQUIRED') 
       write(0,*) NAME,'D113.1','TOO HIGH ACCURACY REQUIRED'
       GO TO 99 
    END IF
99  cgauss64=H 
  end function ig_PolyWeight_expand_class
  

  !! given limits a,b and points at which to split the integration
  !! (split), set edges to the limits of the subintervals over which to integrate 
  !! and n to the number of non-zero sub-intervals. 
  !!
  !! Requirements are that a <= b and split(:) points should be ordered.
  !!
  !! The edges array should be at least of size size(split)+2
  subroutine split_limits(a, b, split, edges, n)
     real(dp), intent(in) :: a, b, split(:)
     real(dp), intent(out) :: edges(:)
     integer,  intent(out) :: n
     integer :: i
     if (a > b) call wae_error("integrator::split_limits, a > b, which is not allowed")
     if (size(edges) < size(split)+2) call wae_error("integrator::split_limits, edges array too small")
     edges(1) = a
     n = 0
     do i = 1, size(split)
        if (split(i) > a .and. split(i) < b) then
           n = n + 1
           edges(n+1) = split(i)
        end if
     end do
     n = n + 1
     edges(n+1) = b
  end subroutine split_limits 
end module integrator

!======================================================================
! Module that holds a whole bunch of helper routines and variables
! some of which will come in useful also for the QED evolution code
module evolution_helper
  use types; use consts_dp
  use dglap_objects; use qcd_coupling
  use assertions; use qcd
  use warnings_and_errors
  implicit none

  !!
  !! fact that alpha_s/2pi is small means that we can quite comfortably
  !! take large steps. Have tested with 0.4 down to 1.5 GeV
  !!   
  !! Originally steps were uniform in dlnQ^2 (dt). As of September 2004,
  !! steps are now uniform in d(alpha_s * lnQ^2) = du. They are taken
  !! "matched" for alpha_s = 0.25
  !!
  real(dp), parameter :: du_dt = 0.25_dp, dt_ballpark_def = 0.4_dp
  real(dp) :: dt_ballpark = dt_ballpark_def
  real(dp) :: du_ballpark = du_dt * dt_ballpark_def
  real(dp) :: ev_tmp_du_ballpark
  !real(dp), parameter :: dt_ballpark = 0.2

  type(split_mat),      pointer :: ev_PLO, ev_PNLO, ev_PNNLO, ev_PN3LO
  type(running_coupling), pointer :: ev_ash
  integer                  :: ev_nloop
  real(dp) :: ev_muR_Q, fourpibeta0_lnmuR_Q
  logical  :: ev_untie_nf = .false.

  ! this was introduced for testing --- should now never be necessary
  ! to set it to .true., except in the QED override
  logical             :: ev_force_old_dt = .false.
  real(dp), parameter :: ev_minalphadiff     = 0.02_dp
  integer,  parameter :: ev_du_is_dt         = 1
  integer,  parameter :: ev_du_is_dtas_fixed = 2
  integer,  parameter :: ev_du_is_dtas_run   = 3
  integer             :: ev_du_type
  real(dp)            :: ev_u_asref, ev_u_tref, ev_u_bval, ev_du_dt
  integer,  parameter :: ev_nloop_interp = -1

  real(dp) :: ev_conv_last_jacobian
  real(dp) :: ev_conv_last_Q
  real(dp) :: ev_conv_last_as2pi

    !!
  !! A type that allows one to store the result of the evolution as an
  !! operator that can be "applied" to any parton distribution, eliminating 
  !! the need to repeat the whole Runge-Kutta evolution for each new PDF
  !!
  type evln_operator
     type(split_mat)              :: P
     type(mass_threshold_mat)  :: MTM ! assume we have just one of these...
     real(dp)                :: MTM_coeff, Q_init, Q_end
     logical                 :: cross_mass_threshold ! better name: apply_mass_threshold
     logical                 :: owns_MTM = .false.
     type(evln_operator), pointer :: next
  end type evln_operator

contains
  

  !======================================================================
  !! this bit here does the actual evolution of a PDF. Could make it
  !! more sophisticated later, if necessary (e.g. variable step size).
  subroutine ev_evolveLocal(pdf, Q_init, Q_end, ev_conv_sub)
    use runge_kutta
    real(dp),        intent(inout)         :: pdf(:,:)
    real(dp),        intent(in)            :: Q_init, Q_end
    interface
       subroutine ev_conv_sub(x,y,dy)
         use types
         real(dp), intent(in)  :: x, y(:,:)
         real(dp), intent(out) :: dy(:,:)
       end subroutine ev_conv_sub
    end interface
       
    !------------------------------------------------------------
    real(dp) :: t1, t2, dt, t, u1, u2, du, u, as1, as2
    integer  :: n, i
    integer :: ntot=0

    fourpibeta0_lnmuR_Q = four*pi*beta0*log(ev_muR_Q)
    !write(0,*) fourpibeta0_lnmuR_Q
    t1 = two*log(Q_init)
    t2 = two*log(Q_end)

    if (t2 == t1) return

    !-- now work out jacobians...
    as1 = ev_asval(Q_init)
    as2 = ev_asval(Q_end)
    
    ! allow for both signs of coupling (and sign changes)
    ! See CCN25-95 for formulae (NB: 0->1 and 1->2)
    if (ev_force_old_dt) then
       ! if the couplings are zero, then we expect that
       ! another type of evolution may be taking place
       ! and allow a normal evolution.
       ev_du_type = ev_du_is_dt
       u1 = t1; u2 = t2
       n  = ceiling(abs(t2-t1)/(ev_tmp_du_ballpark/du_dt))
    else if (abs(as1 - as2)/max(as1,as2) < ev_minalphadiff &
         &.or. as1*as2 <= zero) then
    !else if (.true.) then
       ev_du_type = ev_du_is_dtas_fixed
       ev_du_dt = max(abs(as1),abs(as2))
       u1 = t1 * ev_du_dt; u2 = t2 * ev_du_dt
       n  = ceiling(abs(u2-u1)/ev_tmp_du_ballpark)
    else
       ev_du_type = ev_du_is_dtas_run
       ev_u_asref = as1
       ev_u_tref  = t1
       ev_u_bval  = (as1/as2-1)/(as1*(t2-t1))
       u1 = zero
       u2 = log(1+ev_u_bval*ev_u_asref*(t2-t1)) / ev_u_bval
       n  = ceiling(abs(u2-u1)/ev_tmp_du_ballpark)
       !write(0,*) ev_u_asref, ev_u_bval
    end if
    
    du = (u2 - u1)/n

    ntot = ntot + n
    !write(0,*) 'Qinit,end, nsteps', Q_init, Q_end, n, ntot
    u = u1
    do i = 1, n
       call rkstp(du, u, pdf, ev_conv_sub)
    end do
  end subroutine ev_evolveLocal


  !======================================================================
  !! Assuming the relevant module-wide variables have been set, this
  !! returns the derivative dpdf (wrt "u" -- defined precisely
  !! elsewhere) of pdf, as specified by the DGLAP equations.
  !! 
  subroutine ev_conv(u, pdf, dpdf)
    use pdf_representation
    ! The following failed with the absoft compiler in 2003: see ABSOFT_BUG.txt
    ! For possibly related issues in compilers as of 2024, see
    ! https://fortran-lang.discourse.group/t/an-interesting-difference-between-compilers/7131
    ! and
    ! https://forums.developer.nvidia.com/t/bugreport-for-nvfortran-treatment-of-array-bounds-in-the-specification-part/278324")
    !
    real(dp), intent(in)  :: u, pdf(:,:)
    real(dp), intent(out) :: dpdf(:,:)
    ! The following failed with the intel compiler in 2003! See INTEL_BUG.txt
    ! (As of 2024 is now fixed)
    ! real(dp), intent(in)  :: u, pdf(0:,-ncomponents:)
    ! real(dp), intent(out) :: dpdf(0:,-ncomponents:)
    !--------------------------------------
    real(dp) :: as2pi, Q, t, jacobian
    type(split_mat) :: Pfull

    ! for analysing Intel bug
    !write(0,*) 'X',lbound(pdf),lbound(pdf,dim=1),size(pdf,dim=1)

    select case(ev_du_type)
    case(ev_du_is_dt)
       t = u
       jacobian = one
    case(ev_du_is_dtas_fixed)
       t = u / ev_du_dt
       jacobian = one / ev_du_dt
    case(ev_du_is_dtas_run)
       t = ev_u_tref + (exp(ev_u_bval*u)-one)/(ev_u_bval*ev_u_asref)
       jacobian = (1+ev_u_bval*ev_u_asref*(t-ev_u_tref))/ev_u_asref
    case default
       call wae_error('evconv: unknown ev_du_type',intval=ev_du_type)
    end select
    
    Q     = exp(half*t)
    as2pi = ev_asval(Q)/twopi

    ! store things, so that e.g. the QED evolution routine can make use of it
    ev_conv_last_jacobian = jacobian
    ev_conv_last_Q        = Q
    ev_conv_last_as2pi    = as2pi

    ! if the coupling is zero, then we can simply bail out with a
    ! zero derivative; NB: this is useful in cases where we want
    ! some intermediate info for more complex evolution (e.g. QED),
    ! but we know we won't actually be doing any evolution within
    ! the QCD part.
    if (as2pi == zero) then
       dpdf = zero
       return
    end if
    
    select case (ev_nloop)
    case(1)
       dpdf = (jacobian * as2pi) * (ev_PLO .conv. pdf)
    case(2)
       if (fourpibeta0_lnmuR_Q /= zero) then
          call InitSplitMat(Pfull, ev_PLO, one + as2pi*fourpibeta0_lnmuR_Q)
       else
          call InitSplitMat(Pfull, ev_PLO)
       end if
       call AddWithCoeff(Pfull, ev_PNLO, as2pi)
       dpdf = (jacobian * as2pi) * (Pfull .conv. pdf)
       call Delete(Pfull)
    case(3)
       if (fourpibeta0_lnmuR_Q /= zero) then
          call InitSplitMat(Pfull, ev_PLO, one + as2pi*fourpibeta0_lnmuR_Q&
               & + (as2pi*fourpibeta0_lnmuR_Q)**2&
               & + as2pi**2*(twopi**2*beta1)*two*log(ev_muR_Q))
          call AddWithCoeff(Pfull, ev_PNLO, &
               &as2pi*(one + two*as2pi*fourpibeta0_lnmuR_Q))
          call AddWithCoeff(Pfull, ev_PNNLO, as2pi**2)
          !call wae_error('ev_conv: NNL evolution not supported with muR_Q/=1')
       else
          call InitSplitMat(Pfull, ev_PLO)
          call AddWithCoeff(Pfull, ev_PNLO, as2pi)
          call AddWithCoeff(Pfull, ev_PNNLO, as2pi**2)
       end if
       dpdf = (jacobian * as2pi) * (Pfull .conv. pdf)
       call Delete(Pfull)
    case(4)
       if (fourpibeta0_lnmuR_Q /= zero) then
          ! From Mathematica:
          !as2pi**3*P3NLO + (1 + 4*as2pi*beta0*L*Pi + 
          !-     8*as2pi**2*L*(beta1 + 2*beta0**2*L)*Pi**2 + 
          !-     as2pi**3*(16*beta2*L*Pi**3 + 
          !-        80*beta0*beta1*L**2*Pi**3 + 64*beta0**3*L**3*Pi**3)
          !-     )*PLO + (as2pi + 8*as2pi**2*beta0*L*Pi + 
          !-     as2pi**3*(16*beta1*L*Pi**2 + 48*beta0**2*L**2*Pi**2))*
          !-   PNLO + (as2pi**2 + 12*as2pi**3*beta0*L*Pi)*PNNLO
          call InitSplitMat(Pfull, ev_PLO, one &
               &   + as2pi * fourpibeta0_lnmuR_Q&
               &   + as2pi**2 * (fourpibeta0_lnmuR_Q**2&
               &                 + (twopi**2*beta1) * two * log(ev_muR_Q))&
               &   + as2pi**3 * (fourpibeta0_lnmuR_Q**3&
               &                  + fourpibeta0_lnmuR_Q * 5.0_dp * twopi**2 * beta1 * log(ev_muR_Q) &
               &                  + (twopi**3*beta2) * two * log(ev_muR_Q)))
          call AddWithCoeff(Pfull, ev_PNLO, as2pi &
               & * (one + two*as2pi*fourpibeta0_lnmuR_Q&
               & + 3.0_dp*(as2pi*fourpibeta0_lnmuR_Q)**2&
               & + as2pi**2*(twopi**2*beta1)*4.0_dp*log(ev_muR_Q)))
          call AddWithCoeff(Pfull, ev_PNNLO, as2pi**2 &
               & * (one + 3.0_dp*as2pi*fourpibeta0_lnmuR_Q))
          call AddWithCoeff(Pfull, ev_PN3LO, as2pi**3)
          !call wae_error('ev_conv: NNL evolution not supported with muR_Q/=1')
       else
          call InitSplitMat(Pfull, ev_PLO)
          call AddWithCoeff(Pfull, ev_PNLO,  as2pi)
          call AddWithCoeff(Pfull, ev_PNNLO, as2pi**2)
          call AddWithCoeff(Pfull, ev_PN3LO, as2pi**3)
       end if
       dpdf = (jacobian * as2pi) * (Pfull .conv. pdf)
       call Delete(Pfull)
    case(ev_nloop_interp)
       ! *** SetCurrentP
       !
       ! dpdf = jacobian * (dhcopy%currentP .conv. pdf)
       error stop ! not yet programmed !!!
    case default
       call wae_error('ev_conv','unrecognised value for ev_nloop',&
            &         intval=ev_nloop)
    end select
  end subroutine ev_conv
  
  
  !======================================================================
  !! Given module-wide variables (including a pointer to the running
  !! coupling object), this returns alphas for the appropriate number 
  !! of flavours and at a scale Q*muR_Q.
  !!
  !! (put there because nf handling and xmuR handling involve various
  !! options, and it is convenient to have a common call that handles
  !! all options correctly).
  function ev_asval(Q) result(res)
    real(dp), intent(in) :: Q
    real(dp)             :: res
    if (.not. ev_untie_nf) then
       !-- fixnf option here will be quite restrictive. It means that
       !   if we have ev_muR_Q/=1 and variable numbers of flavours,
       !   then either ev_ash supports "extrapolation" with the same nf
       !   beyond the strictly legal region, or else it has been defined 
       !   so as to have flavour thresholds at ev_muR_Q*masses
       res   = Value(ev_ash, Q*ev_muR_Q, fixnf=nf_int)
    else
       ! sometimes (e.g. comparisons with others) it is useful to
       ! allow nf in alpha_s to have a value different from the nf
       ! being used in the splitting functions...
       res   = Value(ev_ash, Q*ev_muR_Q)
    end if

  end function ev_asval
  

  !---------------------------------------------------------
  !! A shortcut for setting up copies of information
  !! which may be useful module-wide
  !!
  !! Is it really needed?
  subroutine ev_SetModuleConsts(coupling, muR_Q, nloop, untie_nf, du)
    type(running_coupling),    intent(in)  :: coupling
    real(dp),        intent(in), optional  :: muR_Q
    integer,         intent(in), optional  :: nloop
    logical,         intent(in), optional  :: untie_nf
    real(dp),        intent(in), optional  :: du

    ev_nloop = default_or_opt(NumberOfLoops(coupling),nloop)
    ev_muR_Q = default_or_opt(one,muR_Q)
    ev_untie_nf = default_or_opt(.false., untie_nf)
    ev_tmp_du_ballpark = default_or_opt(du_ballpark, du)

    !* !**** Additional for interpolated splitting-function sets
    !* if (dhcopy%using_interp) then
    !*    nloop = ev_nloop_interp
    !*    if (ev_muR_Q /= one) call wae_error('ev_SetModuleConsts',&
    !*         & "muR_Q must be 1 for interpolated evln; it was ",&
    !*         & dble_val=ev_muR_Q)
  end subroutine ev_SetModuleConsts

  !======================================================================
  !! Cross the mass threshold in the specified direction (+-1). It is
  !! assumed that the current (module qcd) nf_int value corrresponds
  !! to the number of flavours _after_ crossing the threshold.
  !!
  !! Currently only supports mass thresholds at muF = m_H.
  !!
  !! In the case of positive direction, it assumes that the correct
  !! quark mass scheme setting has been applied to dh. 
  !!
  !! In the case of negative direction, at the end the quark mass setting
  !! of dh is that dictated by the coupling
  !!
  subroutine ev_CrossMassThreshold(dh,coupling,direction,pdf,evop)
    use dglap_holders; use pdf_representation; use dglap_choices
    type(dglap_holder),       intent(inout) :: dh
    type(running_coupling),   intent(in)    :: coupling
    integer,                  intent(in)    :: direction
    real(dp),                 intent(inout), optional :: pdf(:,:)
    type(evln_operator),      intent(inout), optional :: evop
    !----------------------------------------------
    integer, save      :: warn_DIS = 2, warn_Direction = 2
    real(dp) :: as2pi, muR
    real(dp) :: fourpibeta0_lnmuR_Q 
    integer  :: nfstore
    
    !-- CHANGE THIS IF HAVE MATCHING AT MUF/=MH
    if (ev_nloop < 3 .or. (.not. mass_steps_on)) then
       ! the name cross_mass_threshold isn't great -- maybe better to rename
       ! it apply_mass_threshold
       if (present(evop)) evop%cross_mass_threshold = .false.
       return
    end if    
    if (dh%factscheme /= factscheme_MSBar) then
       call wae_Warn(warn_DIS,&
            &'ev_CrossMassThreshold',&
            &'Factscheme is not MSBar;&
            & mass thresholds requested but not implemented')
       if (present(evop)) evop%cross_mass_threshold = .false.
       return
    end if
    
    nfstore = nf_int ! keep record in case we change it
    select case(direction)
    case(1)
    case(-1)
       ! nf value is that after crossing threshold; but for MTM
       ! (and other things) we need nf value above threshold, i.e. before
       ! crossing the threshold; so put in the correct value temporarily
       call SetNfDglapHolder(dh, nfstore + 1, QuarkMassesAreMSbar(coupling))
    case default
       call wae_error('ev_CrossMassThreshold',&
            &  'direction had unsupported value of',intval=direction)
    end select
    
    !-- now actually do something!
    !muR   = quark_masses(nf_int) * ev_MuR_Q
    muR   = QuarkMass(coupling,nf_int) * ev_MuR_Q
    !write(0,*) 'evolution crossing threshold ', nf_int, muR

    !-- fix nf so as to be sure of getting alpha value corresponding
    !   to the desired nf value, despite proximity to threshold.
    as2pi = Value(coupling, muR, fixnf=nf_int) / twopi
    if (ev_nloop == 3) then
       if (present(pdf)) pdf = pdf + &
            &                   (direction*as2pi**2) * (dh%MTM_NNLO .conv. pdf)
       if (present(evop)) then
          evop%cross_mass_threshold = .true.
          ! in this case, evop%MTM just copies pointers to the contents of
          ! the underlying grid_conv objects, so we do not have ownership
          evop%MTM = dh%MTM_NNLO  ! stores current nf value and quark-mass treatment
          evop%MTM_coeff = (direction*as2pi**2)
       end if
    else if (ev_nloop == 4) then
      fourpibeta0_lnmuR_Q = four*pi*beta0*log(ev_muR_Q)
      ! if (present(pdf)) pdf = pdf + &
      ! &           (direction*as2pi**2) * (dh%MTM_NNLO * pdf + as2pi*(dh%MTM_N3LO * pdf))
      !write(6,*) "fourpibeta0_lnmuR_Q =", fourpibeta0_lnmuR_Q
      if (present(pdf)) pdf = pdf + &
      &           (direction*(as2pi**2 * (one + two*fourpibeta0_lnmuR_Q * as2pi))) * (dh%MTM_NNLO * pdf) &
                  + (direction * as2pi**3) * (dh%MTM_N3LO * pdf)
      if (present(evop)) then
        evop%cross_mass_threshold = .true.
        ! we will be creating a new MTM object, so the evop will have ownership
        ! and so we set a flag so as to know to delete it when the evop is deleted
        evop%owns_MTM             = .true.
        call InitMTM(evop%MTM, dh%MTM_NNLO)
        call AddWithCoeff(evop%MTM, dh%MTM_N3LO, as2pi)
        evop%MTM_coeff = (direction*as2pi**2)
      end if

    else
       call wae_error('ev_CrossMassThreshold',&
            &  'ev_nloop had unsupported value of',intval=ev_nloop)
    end if
       
    if (nf_int /= nfstore) call SetNfDglapHolder(dh, nfstore, QuarkMassesAreMSbar(coupling))

  end subroutine ev_CrossMassThreshold
  
end module evolution_helper


!======================================================================
!!
!! Module for providing access to variable-flavour number DGLAP
!! evolution, both directly of a pdf and via evolution operators (with
!! facilities both for setting them and using them).
!!
module evolution
  use types; use consts_dp
  use dglap_objects; use qcd_coupling
  use assertions; use qcd
  use warnings_and_errors
  use evolution_helper
  implicit none
  private

  public :: EvolvePDF, EvolveGeneric
  public :: SetDefaultEvolutionDt, SetDefaultEvolutionDu
  public :: DefaultEvolutionDu

  public :: ev_MSBar2DIS, ev_evolve  ! should these be public

  ! the evln_operator type is defined in evolution_helper
  public :: evln_operator
  public :: InitEvlnOperator

  interface Delete
     module procedure Delete_evln_operator
  end interface
  public :: Delete

  
  !!
  !! related operation and operator
  !!
  public :: ev_conv_evop
  interface operator(*)
     module procedure ev_conv_evop
  end interface
  public :: operator(*)
  interface operator(.conv.)
     module procedure ev_conv_evop
  end interface
  public  :: operator(.conv.)


contains


  !======================================================================
  !! Set the spacing in t = ln Q^2 for the evolution. Actually this is
  !! now out of date, since t is no longer the evolution variable; instead
  !! it is a variable u, where du \simeq d(alphas*t). 
  !!
  !! By default du is set to be dt * du_dt, where an effective value
  !! of du_dt = 0.25 is used.
  subroutine SetDefaultEvolutionDt(dt)
    real(dp), intent(in) :: dt
    dt_ballpark = dt
    du_ballpark = dt * du_dt
  end subroutine SetDefaultEvolutionDt

  
  !======================================================================
  !! Set the spacing in u \simeq \int dlnQ^2 alphas(Q^2) for evolution
  !! steps.
  !!
  subroutine SetDefaultEvolutionDu(du)
    real(dp), intent(in) :: du
    dt_ballpark = du / du_dt
    du_ballpark = du
  end subroutine SetDefaultEvolutionDu

  !======================================================================
  !! Returns du_ballpark
  real(dp) function DefaultEvolutionDu() result(res)
    res = du_ballpark
  end function DefaultEvolutionDu
  

  !======================================================================
  !! This serves as a simplified entry point to the EvolveGeneric
  !! routine when you just want to evolve a PDF (but don't care about
  !! evln_operators). See the EvolveGeneric routine for an explanation
  !! of the various options.
  !! 
  subroutine EvolvePDF(dh, pdf, coupling, &
       &                    Q_init, Q_end, muR_Q, nloop, untie_nf, du)
    use dglap_holders; use pdf_representation
    type(dglap_holder),     intent(in), target   :: dh
    real(dp),               intent(inout)        :: pdf(:,:)
    type(running_coupling), intent(in), target   :: coupling
    real(dp),               intent(in)           :: Q_init, Q_end
    real(dp),               intent(in), optional :: muR_Q
    integer,                intent(in), optional :: nloop
    logical,                intent(in), optional :: untie_nf
    real(dp),               intent(in), optional :: du

    call EvolveGeneric(dh, coupling, Q_init, Q_end, &
         & pdf=pdf, muR_Q = muR_Q, nloop = nloop, untie_nf = untie_nf, du=du)
  end subroutine EvolvePDF


  !======================================================================
  !! This serves as a simplified entry point to the EvolveGeneric
  !! routine when you just want to evolve a PDF (but don't care about
  !! evln_operators). See the EvolveGeneric routine for an explanation
  !! of the various options.
  !! 
  subroutine InitEvlnOperator(dh, evop, coupling, &
       &                       Q_init, Q_end, muR_Q, nloop, untie_nf, du)
    use dglap_holders; use pdf_representation
    type(dglap_holder),     intent(in), target   :: dh
    type(evln_operator),    intent(out)          :: evop
    type(running_coupling), intent(in), target   :: coupling
    real(dp),               intent(in)           :: Q_init, Q_end
    real(dp),               intent(in), optional :: muR_Q
    integer,                intent(in), optional :: nloop
    logical,                intent(in), optional :: untie_nf
    real(dp),               intent(in), optional :: du

    call EvolveGeneric(dh, coupling, Q_init, Q_end, &
         & evop=evop, muR_Q = muR_Q, nloop = nloop, untie_nf = untie_nf, du=du)
  end subroutine InitEvlnOperator
  

  !======================================================================
  !! A routine that either evolves a PDF from scale Q_init to scale
  !! Q_end, or that returns an evln_operator that corresponds to the
  !! equivalent evolution.
  !!
  !! The decision on whether to evolve in a fixed flavour-number
  !! scheme (FFNS) are a variable flavour-number scheme (VFNS) is
  !! determined from the running coupling object (i.e. the DGLAP
  !! evolution does the same thing that was done for the running
  !! coupling).
  !!
  !! If the dglap_holder has been initialised with a smaller nf range
  !! than would be needed according to the coupling flavour
  !! information, then it is that smaller nf range that is used both
  !! for the DGLAP evolution and the coupling; e.g. if dglap_holder is
  !! initialised to have 3..5 flavours, then we will have a VFNS with
  !! flavours ranging from 3..5, but in the region above the top mass
  !! we will resort to a 5-flavour FFNS.
  !!
  !! Note that this is a potentially inefficient way of getting a
  !! mixed VFNS-FFNS (because one has to override the flavour number
  !! info in the coupling, involving significant recomputations) --
  !! instead you're better off setting the coupling to have a
  !! ficititious large top mass, so that the coupling is naturally in
  !! a mixed VFNS-FFNS.
  !!
  !! dh         a holder for dglap, initialised at least up to nloop
  !!
  !! coupling   a running_coupling object
  !!
  !! Q_init, Q_end: the initial and final scales for the evolution
  !!
  !! pdf     the pdf we evolve
  !!
  !! evop       or the evolution operator we set
  !!
  !! muR_Q      the ratio of the renormalisation scale to the PDF scale
  !!
  !! nloop      specifies the number of loops to be used; by default it
  !!            is taken equal to the number of loops used in the coupling.
  !!
  !! untie_nf   if (untie_nf) [default false] then alphas is allowed to 
  !!            have its natural value for nf, even if the dglap_holder
  !!            cannot reach this nf value.
  !!
  subroutine EvolveGeneric(dh, coupling, Q_init, Q_end, &
       &                     pdf, evop, muR_Q, nloop, untie_nf, du)
    use dglap_holders; use pdf_representation
    type(dglap_holder),     intent(in), target      :: dh
    type(running_coupling), intent(in),    target   :: coupling
    real(dp),               intent(in)              :: Q_init, Q_end
    real(dp),               intent(inout), optional :: pdf(:,:)
    type(evln_operator),    intent(inout), optional, target :: evop
    real(dp),               intent(in),    optional :: muR_Q
    integer,                intent(in),    optional :: nloop
    logical,                intent(in),    optional :: untie_nf
    real(dp),               intent(in),    optional :: du
    !-----------------------------------------------------
    !real(dp)           :: pdf_ev(size(pdf,dim=1), size(pdf,dim=2))
    type(dglap_holder) :: dhcopy
    integer            :: nf_init, nf_end, nflcl, nfuse
    integer            :: shnf_init, shnf_end, direction, i
    integer            :: nfstore_dhcopy, nfstore_qcd
    type(evln_operator), pointer :: this_evop
    real(dp),          pointer :: probes(:,:,:)
    !-- ranges
    real(dp) :: QRlo, QRhi, lcl_Q_init, lcl_Q_end
    
    !-- this will just copy pointers, so that we don't
    !   alter info held in original
    dhcopy = dh
    !   We want to be able to restore things at the end... (not that
    !   it is not so much for the dhcopy [which will be deleted] as for
    !   the global qcd nf. [maybe we could drop the dhcopy call?]
    nfstore_dhcopy = dh%nf
    nfstore_qcd    = nf_int


    call ev_SetModuleConsts(coupling, muR_Q, nloop, untie_nf)

    nf_init = NfAtQ(coupling, Q_init, muM_mQ=one)
    nf_end  = NfAtQ(coupling, Q_end,  muM_mQ=one)

    !write(0,*) real(Q_init), real(Q_end), nf_init, nf_end
    
    !-- could use sign, but cannot remember subtleties of signed
    !   zeroes in f95, and do not have manual at hand...
    if (Q_end >= Q_init) then
       direction = 1
    else
       direction = -1
    end if

    call ev_limit_nf(dhcopy, nf_init, shnf_init,'initial nf')
    call ev_limit_nf(dhcopy, nf_end , shnf_end ,'final nf')


    ! in loop we may want to refer to subsequent elements in chain, 
    ! so make use of a pointer which is kept updated
    if (present(evop)) then
       this_evop => evop
    else
       nullify(this_evop)
    end if

    do nflcl = shnf_init, shnf_end, direction
       call QRangeAtNf(coupling,nflcl,QRlo,QRhi, muM_mQ=one)
       if (direction == 1) then
          lcl_Q_init = max(Q_init, QRlo)
          lcl_Q_end  = min(Q_end,  QRhi)
       else
          lcl_Q_init = min(Q_init, QRhi)
          lcl_Q_end  = max(Q_end,  QRlo)
       end if
       ! make sure that end points are correct...
       if (nflcl == shnf_init) lcl_Q_init = Q_init
       if (nflcl == shnf_end)  lcl_Q_end  = Q_end
       !-- this will also set the global (qcd) nf_int which will
       !   be used elsewhere in this module
       call SetNfDglapHolder(dhcopy, nflcl, QuarkMassesAreMSbar(coupling))

       ! convention: cross mass thresholds before a step in the evolution
       if (nflcl /= shnf_init) then
          ! act directly
          if (present(pdf))&
               & call ev_CrossMassThreshold(dhcopy,coupling,direction,pdf)
          ! or store the information that will be needed to act subsequently.
          if (present(evop)) call ev_CrossMassThreshold(dhcopy,&
               &                  coupling,direction,evop=this_evop)
       else if (present(evop)) then
          this_evop%cross_mass_threshold = .false.
       end if
       
       ! do evolution
       if (present(pdf)) call ev_evolve(dhcopy, &
            &pdf, coupling, lcl_Q_init, lcl_Q_end, muR_Q, nloop, untie_nf, du)

       ! do the fake evolutions that allow us to do an accelerated 
       ! evolution later on.
       if (present(evop)) then
          ! recall: memory management of probes is done automatically
          !call GetDerivedSplitMatProbes(dh%grid,probes)
          call GetDerivedSplitMatProbes(dh%grid,nflcl,probes)
          do i = 1, size(probes,3)
             call ev_evolve(dhcopy, probes(:,:,i), &
                  & coupling, lcl_Q_init,lcl_Q_end, muR_Q, nloop, untie_nf, du)
          end do
          call AllocSplitMat(dh%grid, this_evop%P, nflcl)
          call SetDerivedSplitMat(this_evop%P,probes)
          if (nflcl == shnf_end) then
             nullify(this_evop%next)
          else
             allocate(this_evop%next)
             this_evop => this_evop%next
          end if
       end if
    end do

    !-- clean up
    call SetNfDglapHolder(dhcopy, nfstore_dhcopy)
    if (nfstore_qcd /= nfstore_dhcopy) call qcd_SetNf(nfstore_qcd)
  end subroutine EvolveGeneric



  !======================================================================
  !! Return the action of the evln_operator on the pdfdist 
  function ev_conv_evop(evop,pdfdist) result(res)
    type(evln_operator), intent(in), target :: evop
    real(dp),          intent(in)         :: pdfdist(:,:)
    real(dp) :: res(size(pdfdist,dim=1),size(pdfdist,dim=2))
    !------------
    type(evln_operator), pointer :: this_evop
    
    this_evop => evop
    res = pdfdist

    do
       ! "cross" here really means "apply"
       if (this_evop%cross_mass_threshold) then
          ! NB: this never occurs on first pass
          res = res + this_evop%MTM_coeff * (this_evop%MTM .conv. res)
       end if
       
       res = this_evop%P .conv. res

       if (associated(this_evop%next)) then
          this_evop => this_evop%next
       else
          return
       end if
    end do
  end function ev_conv_evop
  


  !======================================================================
  !! Return dhnflcl, which is nflcl modified to as to be
  !! within the supported limits of dh.
  !!
  !! Thus we can evolve with 5 flavours even into the 
  !! 6 flavour region, without the whole house crashing down
  !!
  !! Beware that this sort of thing is dangerous, because
  !! alphas might have one value for nf, beta0 a different value, 
  !! and overall ca sera la pagaille (if the untie_nf option is .true.)
  subroutine ev_limit_nf(dh, nflcl, dhnflcl, nfname)
    use dglap_holders
    type(dglap_holder), intent(in)  :: dh
    integer,            intent(in)  :: nflcl
    integer,            intent(out) :: dhnflcl
    character(len=*),   intent(in)  :: nfname
    !----------------------------------------
    integer, parameter :: max_warn = 4
    integer            :: warn_id = warn_id_INIT
    integer            :: nflo, nfhi
    character(len=80)  :: nfstring
    
    nflo = lbound(dh%allP,dim=2)
    nfhi = ubound(dh%allP,dim=2)

    dhnflcl = max(min(nflcl,nfhi),nflo)
    
    if (nflcl /= dhnflcl) then
       write(nfstring,'(a,i1,a,i1,a)') " changed from ",nflcl," to ",&
            &dhnflcl,"."
       call wae_warn(max_warn, warn_id, 'ev_limit_nf: '//&
            &nfname//trim(nfstring))
    end if
  end subroutine ev_limit_nf
  


  !======================================================================
  !! Internal entry routine for evolution with a fixed number of
  !! flavours. Takes a human distribution and deals with the necessary
  !! conversion to and from "evolution" format. The evolution order
  !! is set by nloop.
  subroutine ev_evolve(dh, pdf, coupling, Q_init, Q_end, muR_Q,&
       & nloop, untie_nf, du)
    use dglap_holders; use pdf_representation
    type(dglap_holder), intent(in), target :: dh
    real(dp),        intent(inout)         :: pdf(iflv_min:,0:)
    type(running_coupling), intent(in), target    :: coupling
    real(dp),        intent(in)            :: Q_init, Q_end
    real(dp),        intent(in), optional  :: muR_Q
    integer,         intent(in), optional  :: nloop
    logical,         intent(in), optional  :: untie_nf
    real(dp),        intent(in), optional  :: du
    !-----------------------------------------------------
    real(dp) :: pdf_ev(size(pdf,dim=1), size(pdf,dim=2))
    integer  :: pdfrep

    !-- make sure that number of flavours is correct?
    !if (nf_int /= dh%prep%nf) call wae_error('ev_evolve: &
    if (nf_int /= dh%nf) call wae_error('ev_evolve: &
         &global nf and representation nf are not equal.')

    !-- put things into the right format just once (it would
    !   be done automatically by the conv_object routines, but
    !   that would be wasteful)
    pdfrep = GetPdfRep(pdf)
    if (pdfrep == pdfr_Human) then
       !call CopyHumanPdfToEvln(dh%prep, pdf, pdf_ev)
       call CopyHumanPdfToEvln(dh%nf, pdf, pdf_ev)
    else
       pdf_ev = pdf
    end if
    
    ev_ash => coupling
    call ev_SetModuleConsts(coupling, muR_Q, nloop, untie_nf)

    if (ev_nloop > dh%nloop) &
         &call wae_error('ev_evolve: dh%nloop must be >= nloop')

    ev_PLO  => dh%P_LO
    if (ev_nloop >= 2) ev_PNLO => dh%P_NLO
    if (ev_nloop >= 3) ev_PNNLO => dh%P_NNLO
    if (ev_nloop >= 4) ev_PN3LO => dh%P_N3LO
    if (ev_nloop >= 5) call wae_error('ev_evolve: nloop > 4 not yet supported')

    call ev_evolveLocal(pdf_ev, Q_init, Q_end, ev_conv)

    !-- put things back into a "human" format
    if (pdfrep == pdfr_Human) then
       !call CopyEvlnPdfToHuman(dh%prep, pdf_ev, pdf)
       call CopyEvlnPdfToHuman(dh%nf, pdf_ev, pdf)
    else
       pdf = pdf_ev
    end if
  end subroutine ev_evolve

  


  !======================================================================
  !! Takes pdf in the MSBar scheme and converts it into the DIS scheme,
  !! hopefully correctly!
  subroutine ev_MSBar2DIS(dh,pdf,coupling,Q,nloop)
    use dglap_holders; use pdf_representation; use convolution
    type(dglap_holder),     intent(in)            :: dh
    real(dp),               intent(inout)         :: pdf(:,:)
    type(running_coupling), intent(in), target    :: coupling
    real(dp),               intent(in)            :: Q
    integer,                intent(in), optional  :: nloop
    !-----------------------------------------------------
    real(dp) :: pdf_ev(size(pdf,dim=1), -ncomponents:ncomponents )
    real(dp) :: Cq_x_q(size(pdf,dim=1)), Cg_x_g(size(pdf,dim=1))
    real(dp) :: as2pi
    integer  :: id

    !-- put things into the right format
    !call CopyHumanPdfToEvln(dh%prep, pdf, pdf_ev)
    call CopyHumanPdfToEvln(dh%nf, pdf, pdf_ev)

    as2pi = Value(coupling,Q) / twopi
    ev_nloop = default_or_opt(NumberOfLoops(coupling),nloop)
    
    if (ev_nloop /= 2) call wae_error('ev_MSBar2DIS',&
         &  'number of loops was not=2 [currently only case supported]')
    
    Cq_x_q = as2pi * (dh%C2_1%q .conv. pdf_ev(:,iflv_sigma))
    !Cg_x_g = (2*dh%prep%nf * as2pi) * (dh%C2_1%g .conv. pdf_ev(:,iflv_g))
    Cg_x_g = (2*dh%nf * as2pi) * (dh%C2_1%g .conv. pdf_ev(:,iflv_g))

    pdf_ev(:,iflv_sigma) = pdf_ev(:,iflv_sigma) + Cq_x_q + Cg_x_g
    pdf_ev(:,iflv_g)     = pdf_ev(:,iflv_g)     - Cq_x_q - Cg_x_g

    !do id = -dh%prep%nf, dh%prep%nf
    do id = -dh%nf, dh%nf
       if (id == iflv_sigma .or. id == iflv_g) cycle
       pdf_ev(:,id) = pdf_ev(:,id) + as2pi * (dh%C2_1%q .conv. pdf_ev(:,id))
    end do

    !-- put things back into a "human" format
    !call CopyEvlnPdfToHuman(dh%prep, pdf_ev, pdf)
    call CopyEvlnPdfToHuman(dh%nf, pdf_ev, pdf)
    !write(0,*) 'hello', lbound(pdf), lbound

  end subroutine ev_MSBar2DIS
  

  

  !======================================================================
  !! Delete the objects allocated in evop, including any
  !! subsiduary objects.
  recursive subroutine Delete_evln_operator(evop)
    type(evln_operator), intent(inout) :: evop

    if (associated(evop%next)) then
       call Delete_evln_operator(evop%next)
       deallocate(evop%next)
    end if
    
    ! do nothing here since MTM has not actually been allocated
    ! but rather just set "equal" to dh%MTM2 -- i.e. it just points
    ! to the contents of dh%MTM2 (except for the nf info, which is
    ! local, but does not need dealocating)
    !if (evop%cross_mass_threshold) then ! do nothing

    call Delete(evop%P)
    if (evop%owns_MTM) call Delete(evop%MTM)
    return
  end subroutine Delete_evln_operator
  

end module evolution

      MODULE XCLSG2P
      CONTAINS
*
* ..File: xclsg2p.f    FL_S
*
*
* ..Calculation of the 2-loop x-space MS(bar) coefficient functions 
*    for F2 via compact parametrizations involving only logarithms.
*    Singlet, mu_r = mu_f = Q. Expansion parameter: alpha_s/(4 pi).
*
*  ..The relative accuracy of the coefficient functions, as well as of 
*    the convolution results, amounts to a few thousandth.
*
*  ..Reference: W.L. van Neerven and A. Vogt, 
*               hep-ph/0006154 = Nucl. Phys. B588 (2000) 345
*  ..The user should also cite the original calculations,
*      J. Sanchez Guillen et al, Nucl. Phys. B353 (1991) 337  and 
*      E.B. Zijlstra and W.L. van Neerven, Phys. Lett. B273 (1991) 476 
*     
* 
* =====================================================================
*
*
* ..This is the pure singlet piece, denoted by C2S in WvN's program. 
*    Six numerical coefficients (all but the one of 1/y, which is 
*    exact up to truncation) are fitted to his results, using x values 
*    between 10^-6 and 1-10^-6.
*
       FUNCTION CLS2A (Y, NF)
       IMPLICIT REAL*8 (A-Z)
       INTEGER NF
*
       DL  = LOG (Y)
       OMY = 1.0D0 - Y
       DL1 = LOG (OMY)
*
       CLS2A = NF * ( (15.94D0 - 5.212D0 * Y) * OMY**2 * DL1 + (0.421D0
     $      + 1.520D0 * Y) * DL**2 + 28.09D0 * OMY * DL - (2.370D0/Y -
     $      19.27D0) * OMY**3 )
*
       RETURN
       END FUNCTION
*
* ---------------------------------------------------------------------
*
*
* ..This is the gluon contribution, denoted by C2G2 in WvN's program. 
*    Six numerical coefficients are fitted as above, the one of 1/y is
*    exact up to truncation.
*
       FUNCTION CLG2A (Y, NF)
       IMPLICIT REAL*8 (A-Z)
       INTEGER NF
*
       DL  = LOG (Y)
       OMY = 1.0D0 - Y
       DL1 = LOG (OMY)
*
       CLG2A = NF * ( (94.74D0 - 49.20D0 * Y) * OMY * DL1**2 + 864.8D0 *
     $      OMY * DL1 + 1161.D0* Y * DL * DL1 + 60.06D0 * Y * DL**2 +
     $      39.66D0 * OMY * DL - 5.333D0 * (1.D0/Y - 1.D0) )
*
       RETURN
       END FUNCTION
* 
* =================================================================av==

      END MODULE XCLSG2P

! An example in Fortran90 showing how to replace LHAPDF interpolation with
! (faster) hoppet interpolation using the streamlined interface
!
program fast_pdf_evaluation
  use hoppet, EvolvePDF_hoppet => EvolvePDF, InitPDF_hoppet => InitPDF ! Avoid namespace clashes with LHAPDF
  use streamlined_interface
  use hoppet_term
  use hoppet_lhapdf
  use hoppet_to_string
  use new_as
  use pdf_tabulate
  implicit none
  character(len=200) :: pdfname
  integer :: imem
  real(dp) :: x, Q, lhapdf(-6:6), hoppetpdf(-6:6)
  integer, parameter :: npoints = 3000
  real(dp), parameter :: xmin = 1d-5, xmax = 0.9_dp, Qmin = 1.5_dp, Qmax = 100000.0_dp
  real(dp), allocatable :: xvals(:), qvals(:)
  real(dp), external :: hoppetAlphaS, alphasPDF, hoppetEvalIFlv
  real(dp) :: aslhapdf, ashoppet
  integer :: i, j
  real(dp) :: t1, t2
  character(len=*), parameter :: tfmt = '("'//blue//'",a,f8.2,a,"'//reset//'")'
  character(len=*), parameter :: dfmt = '(f10.6)'

  ! Interface to LHAPDF as needed by hoppetAssign

  pdfname = "PDF4LHC21_40"
  imem = 0
  call LoadLHAPDF(pdfname,imem)
  !call load_lhapdf_assign_hoppet(trim(pdfname), imem)
  x = 0.01_dp
  Q = 13.0_dp
 
  ! Standard LHAPDF call
  call EvolvePDF(x, Q, lhapdf) ! Get the PDF from LHAPDF

  ! Equivalent hoppet call
  call hoppetEval(x, Q, hoppetpdf)

  ! Print the two PDFs
  write(*,'(a)') bold // "PDFs at x = " // to_string(x,dfmt) // ", Q = " // to_string(Q,dfmt) // reset
  write(*,'(a,11f12.8)') "LHAPDF(-5:5): ", lhapdf(-5:5)
  write(*,'(a,11f12.8)') "Hoppet(-5:5): ", hoppetpdf(-5:5)
  write(*,'(a,11f12.8)') "Difference  : ", hoppetpdf(-5:5)-lhapdf(-5:5)
  write(*,'(a)') 'LHAPDF AlphaS(Q) = ' // to_string(alphasPDF(Q),dfmt)
  write(*,'(a)') 'Hoppet AlphaS(Q) = ' // to_string(hoppetAlphaS(Q),dfmt)
  write(*,*) ! a blank line for clarity

  write(6,'(a)') bold // "Timing tests for PDF and alphaS evaluations" // reset
  allocate(xvals(npoints), qvals(npoints))
  do i = 1, npoints
    xvals(i) = exp(log(xmin) + (i-1) * (log(xmax) - log(xmin)) / real(npoints-1, dp))
    qvals(i) = exp(log(Qmin) + (i-1) * (log(Qmax) - log(Qmin)) / real(npoints-1, dp))
  end do

  ! Benchmark hoppetEval
  ! All flavours at once
  call cpu_time(t1)
  do i = 1, npoints
    do j = 1, npoints
      call hoppetEval(xvals(i), qvals(j), hoppetpdf)
    end do
  end do
  call cpu_time(t2)
  write(*,tfmt) blue//"hoppetEval    time (all flav): ", (t2-t1)/npoints/npoints*1d9, " ns"//reset
  ! One flavour at a time
  call cpu_time(t1)
  do i = 1, npoints
    do j = 1, npoints
      hoppetpdf(0) = hoppetEvalIFlv(xvals(i), qvals(j), mod(j,6))
      ! if pdf_tabulate is "use"d, this is slightly faster
      !hoppetpdf(0) = EvalPdfTable_xQf(tables(0),xvals(i),qvals(j),mod(j,6))
    end do
  end do
  call cpu_time(t2)
  write(*,tfmt) "hoppetEvalIFlv time (one flav): ", (t2-t1)/npoints/npoints*1d9, " ns"

  ! Benchmark EvolvePDF (LHAPDF)
  call cpu_time(t1)
  do i = 1, npoints
    do j = 1, npoints
      call EvolvePDF(xvals(i), qvals(j), lhapdf)
    end do
  end do
  call cpu_time(t2)
  write(*,tfmt) "LHAPDF EvolvePDF time (all flav): ", (t2-t1)/npoints/npoints*1d9, " ns"

  ! Now let's check the timing of hoppetAlphaS vs LHAPDF alphaS
  call cpu_time(t1)
  do i = 1, npoints
    do j = 1, npoints
      ashoppet = hoppetAlphaS(qvals(j))
      !! GPS M2Pro 2025-09-06: this variant saves only 0.4ns per call
      !! out of about 31.7
      !ashoppet = na_Value(coupling%nah, qvals(j))
      !ashoppet = na_Value_faster(coupling%nah, qvals(j))
      !if (i == 1) write(6,*) qvals(j), hoppetAlphaS(qvals(j)), na_Value_faster(coupling%nah, qvals(j))
    end do
  end do
  call cpu_time(t2)
  write(*,tfmt) "hoppet alphaS time: ", (t2-t1)/npoints/npoints*1d9, " ns"
  
  call cpu_time(t1)
  do i = 1, npoints
    do j = 1, npoints
      aslhapdf = alphasPDF(qvals(j))
      !alphasPDF(qvals(j))
    end do
  end do
  call cpu_time(t2)
  write(*,tfmt) "LHAPDF alphaS time: ", (t2-t1)/npoints/npoints*1d9, " ns" 
  write(*,*) ! a blank line for clarity

  call hoppetDeleteAll()

end program fast_pdf_evaluation

!! An example program using a tabulation. It outputs a subset of
!! table 15 of hep-ph/0511119 and this output should be identical
!! to the contents of the file tabulation_example.default_output
!!
!! NB: for the full functionality used in generating the HeraLHC and
!!     Les Houches comparison tables, see ../benchmarks/benchmarks.f90
!!     and carefully read the comments at the beginning. Subtleties
!!     exist in particular wrt the treatment of scales muF/=muR.
!!
!! NB: commented code shows usage with LHAPDF (e.g. for cross-checking 
!!     some public PDF set's evolution) -- to use this part of the code
!!     you will also need to link with LHAPDF
!!
program tabulation_example
     use hoppet
  !! if using LHAPDF, rename a couple of hoppet functions which
  !! would otherwise conflict with LHAPDF 
     !use hoppet, EvolvePDF_hoppet => EvolvePDF, InitPDF_hoppet => InitPDF
  implicit none
  real(dp) :: dy, ymax
  integer  :: order, nloop
  !! holds information about the grid
  type(grid_def) :: grid
  !! holds the splitting functions
  type(dglap_holder) :: dh
  !! hold the PDF tabulation
  type(pdf_table)       :: table
  !! hold the coupling
  real(dp)               :: quark_masses(4:6)
  type(running_coupling) :: coupling
  !! hold the initial pdf
  real(dp), pointer :: pdf0(:,:)
  real(dp) :: Q0
  !! hold results at some x, Q
  real(dp) :: Q, pdf_at_xQ(-6:6)
  real(dp), parameter :: heralhc_xvals(9) = &
       & (/1e-5_dp,1e-4_dp,1e-3_dp,1e-2_dp,0.1_dp,0.3_dp,0.5_dp,0.7_dp,0.9_dp/)
  integer  :: ix

  !! define the interfaces for LHA pdf (by default not used)
  !! (NB: unfortunately this conflicts with an internal hoppet name,
  !! so make sure that you "redefine" the internal hoppet name, 
  !! as illustrated in the commented "use" line above:
     !! use hoppet, EvolvePDF_hoppet => EvolvePDF, ...)
  ! interface
  !    subroutine EvolvePDF(x,Q,res)
  !      use types; implicit none
  !      real(dp), intent(in)  :: x,Q
  !      real(dp), intent(out) :: res(*)
  !    end subroutine EvolvePDF
  ! end interface

  ! set up parameters for grid
  order = -6
  ymax  = 12.0_dp
  dy    = 0.1_dp

  ! set up the grid itself (this call sets up a nested grid composed of 4 subgrids)
  call InitGridDefDefault(grid, dy, ymax, order=order)

  ! initialise the splitting-function holder
  nloop = 3
  call InitDglapHolder(grid,dh,factscheme=factscheme_MSbar,&
       &                      nloop=nloop,nflo=3,nfhi=6)
  write(6,'(a)') "Splitting functions initialised!"

  !! set up LHAPDF with cteq
  !call InitPDFsetByName("cteq61.LHgrid")
  !call InitPDF(0)
  ! allocate and set up the initial pdf from LHAPDF ...
  !Q0 = 5.0_dp 
  !call AllocPDF(grid, pdf0)
  !call InitPDF_LHAPDF(grid, pdf0, EvolvePDF, Q0)

  ! initialise a PDF from the function below (must be contained,
  ! in a "used" module, or with an explicitly defined interface)
  call AllocPDF(grid, pdf0)
  pdf0 = unpolarized_dummy_pdf(xValues(grid))
  Q0 = sqrt(2.0_dp)  ! the initial scale

  ! allocate and initialise the running coupling with a given
  ! set of quark masses (NB: charm mass just above Q0).
  quark_masses(4:6) = (/1.414213563_dp, 4.5_dp, 175.0_dp/)
  call InitRunningCoupling(coupling,alfas=0.35_dp,Q=Q0,nloop=nloop,&
       &                   quark_masses = quark_masses)

  ! create the tables that will contain our copy of the user's pdf
  ! as well as the convolutions with the pdf.
  call AllocPdfTable(grid, table, Qmin=1.0_dp, Qmax=10000.0_dp, & 
       & dlnlnQ = dy/4.0_dp, freeze_at_Qmin=.true.)
  ! add information about the nf transitions to the table (improves
  ! interpolation quality)
  call AddNfInfoToPdfTable(table,coupling)

  ! create the tabulation based on the evolution of pdf0 from scale Q0
  call EvolvePdfTable(table, Q0, pdf0, dh, coupling, nloop=nloop)
  ! alternatively "pre-evolve" so that subsequent evolutions are faster
  !call PreEvolvePdfTable(table, Q0, dh, coupling)
  !call EvolvePdfTable(table,pdf0)
  write(6,'(a)') "Evolution done!"

  ! get the value of the tabulation at some point
  Q = 100.0_dp
  write(6,'(a)')
  write(6,'(a,f8.3,a)') "           Evaluating PDFs at Q = ",Q," GeV"
  write(6,'(a5,2a12,a14,a10,a12)') "x",&
       & "u-ubar","d-dbar","2(ubr+dbr)","c+cbar","gluon"
  do ix = 1, size(heralhc_xvals)
     call EvalPdfTable_xQ(table,heralhc_xvals(ix),Q,pdf_at_xQ)
     write(6,'(es7.1,5es12.4)') heralhc_xvals(ix), &
          &  pdf_at_xQ(2)-pdf_at_xQ(-2), &
          &  pdf_at_xQ(1)-pdf_at_xQ(-1), &
          &  2*(pdf_at_xQ(-1)+pdf_at_xQ(-2)), &
          &  (pdf_at_xQ(-4)+pdf_at_xQ(4)), &
          &  pdf_at_xQ(0)
  end do
  
  ! some cleaning up (not strictly speaking needed, but illustrates
  ! how it's done)
  call Delete(table)
  call Delete(pdf0)
  call Delete(dh)
  call Delete(coupling)
  call Delete(grid)

contains 
  !======================================================================
  !! The dummy PDF suggested by Vogt as the initial condition for the 
  !! unpolarized evolution (as used in hep-ph/0511119).
  function unpolarized_dummy_pdf(xvals) result(pdf)
    real(dp), intent(in) :: xvals(:)
    real(dp)             :: pdf(size(xvals),ncompmin:ncompmax)
    real(dp) :: uv(size(xvals)), dv(size(xvals))
    real(dp) :: ubar(size(xvals)), dbar(size(xvals))
    !---------------------
    real(dp), parameter :: N_g = 1.7_dp, N_ls = 0.387975_dp
    real(dp), parameter :: N_uv=5.107200_dp, N_dv = 3.064320_dp
    real(dp), parameter :: N_db = half*N_ls
  
    pdf = zero
    ! clean method for labelling as PDF as being in the human representation
    ! (not actually needed after setting pdf=0
    call LabelPdfAsHuman(pdf)

    !-- remember that these are all xvals*q(xvals)
    uv = N_uv * xvals**0.8_dp * (1-xvals)**3
    dv = N_dv * xvals**0.8_dp * (1-xvals)**4
    dbar = N_db * xvals**(-0.1_dp) * (1-xvals)**6
    ubar = dbar * (1-xvals)

    ! labels iflv_g, etc., come from the hoppet module, inherited
    ! from the main program
    pdf(:, iflv_g) = N_g * xvals**(-0.1_dp) * (1-xvals)**5
    pdf(:,-iflv_s) = 0.2_dp*(dbar + ubar)
    pdf(:, iflv_s) = pdf(:,-iflv_s)
    pdf(:, iflv_u) = uv + ubar
    pdf(:,-iflv_u) = ubar
    pdf(:, iflv_d) = dv + dbar
    pdf(:,-iflv_d) = dbar
  end function unpolarized_dummy_pdf

end program tabulation_example

! Program for testing pegasus the same way as has been done with hoppet
! 
! ./prec_and_timing_pegasus -nrep 1 -nxQ 5000 -outputgrid [-ifast {0|1}]
!
! For this to compile you will need to manually add the set of pegasus
! files in the link part of the Makefile, (.../Pegasus/Objects2/*.o,
! once you've removed the "old" files from there; or even
! /Pegasus/Objects2/*[^old].o)
!
!======================================================================
module pegasus_communicator
  integer :: pegasus_ifast
end module pegasus_communicator

program prec_and_timing_pegasus
  use io_utils
  use pegasus_communicator
  use types; use consts_dp
  implicit none
  !-------------------------------
  integer            :: order, order1, order2, nloop, i, nrep, nxQ,olnlnQ
  integer            :: hires
  real(dp)           :: dy, Qinit, Qmax, du, dlnlnQ
  real(dp)           :: ymax
  real(dp)           :: time_start, time_init_done, time_ev_done, time_end
  real(dp), pointer  :: vogt_init(:,:)
  logical            :: output, outputgrid, preev


  ymax  = dble_val_opt('-ymax',11.5_dp)
  Qinit = sqrt(two); Qmax = dble_val_opt('-Qmax',1e4_dp)
  pegasus_ifast = int_val_opt('-ifast',0)


  call cpu_time(time_start)
  CALL INITEVOL (2) ! start pegasus using the subroutine below
  call cpu_time(time_init_done)


  ! decide 
  nrep  = int_val_opt('-nrep',1)
  nxQ = int_val_opt('-nxQ',0)
  output = log_val_opt('-output') .or. log_val_opt('-outputgrid')
  outputgrid  = log_val_opt('-outputgrid')
  if (output) call output_info

  !-- security ----------------------
  if (.not. CheckAllArgsUsed(0)) stop
  !----------------------------------

  call cpu_time(time_ev_done)

  ! evolution & output
  do i = 1, nrep
     ! pegasus input initialisation from the subroutine below
     CALL INITINP (2)
     !CALL INITINP (1) ! init from file


     ! one form of output
     if (outputgrid) then
        call eval_output_grid()
     else
        call eval_output_lines()
     end if

  end do
  call cpu_time(time_end)
  write(0,'(a,4f10.5)') "Timings (init, preevln, evln) = ", &
       &   time_init_done-time_start, &
       &   time_ev_done-time_init_done, &
       &   (time_end-time_ev_done)/nrep
  write(6,'(a)',advance='no') "# "
  call time_stamp(6)
  call system("echo '# host:' `hostname`")
  ! record info about the cpu
  call system("grep -e name -e cache -e MHz /proc/cpuinfo | sed 's/^/# /'")
  if (output) write(6,'(a,4f10.5)') "# Timings (init, preevln, evln) = ", &
       &   time_init_done-time_start, &
       &   time_ev_done-time_init_done, &
       &   (time_end-time_ev_done)/nrep


contains

  !---------------------------------------------------------------
  !! some basic commentary
  subroutine output_info
    write(6,'(a)') '# '//trim(command_line())
    write(6,'(a)') '# Running Pegasus:'
    write(6,'(a,i5)')      '# ifast = ', pegasus_ifast
    write(6,'(a,4i10)')    '# dummy = '
    write(6,'(a,4f10.6)')  '# ymax  = '
    write(6,'(a,4i10)'  )  '# dummy = '
    write(6,'(a,4es10.2)') '# dummy = '

    write(6,'(a,f10.5,a,f10.5)') '# dummy = '
    write(6,'(a,f10.5,a,i5)')    '# dummy = '
  end subroutine output_info


  !-------------------------------------------------------------------
  !! output lines in the y,Q plane
  subroutine eval_output_lines()
    integer nn, j
    real(dp) :: y, Q, pdfval(-6:6),as
    nn = nxQ/4
    do j = 1, nn
       y = j*ymax/nn
       Q = Qmax - j*(Qmax-Qinit)/nn
       call PEGXPARTON(pdfval,as,exp(-y),Q**2)
       if (output .and. i==1) write(6,'(20es20.10)') y,Q,pdfval(0:4)
       !if (output .and. i==1) write(6,'(20es20.8)') y,Q,vogt_init(:,0:3).atx.(grid.with.exp(-y))
    end do

    if (output .and. i==1) write(6,*)
    if (output .and. i==1) write(6,*)
    do j = nn,1,-1
       y = j*ymax/nn
       Q = 4.0_dp + j*5.0_dp/nn
       call PEGXPARTON(pdfval,as,exp(-y),Q**2)
       if (output .and. i==1) write(6,'(20es20.10)') y,Q,pdfval(0:4)
    end do

    if (output .and. i==1) write(6,*)
    if (output .and. i==1) write(6,*)
    do j = nn,1,-1
       y = j*ymax/nn
       Q = Qmax*(1-j*0.2_dp/nn)
       call PEGXPARTON(pdfval,as,exp(-y),Q**2)
       if (output .and. i==1) write(6,'(20es20.10)') y,Q,pdfval(0:4)
    end do

    if (output .and. i==1) write(6,*)
    if (output .and. i==1) write(6,*)
    do j = nn,1,-1
       y = j*ymax/nn
       Q = sqrt(Qinit*Qmax)*(1+j*0.2_dp/nn)
       call PEGXPARTON(pdfval,as,exp(-y),Q**2)
       if (output .and. i==1) write(6,'(20es20.10)') y,Q,pdfval(0:4)
    end do
  end subroutine eval_output_lines


  !----------------------------------------------------------------
  !! output the results on a grid uniform in 
  !! zeta = ln 1/x + grid_a*(1-x)
  subroutine eval_output_grid()
    integer  :: nz, nQ, iz, iQ
    real(dp) :: zmax, zeta, y, Q, zQ, zQmax, pdfval(-6:6), as
    real(dp), parameter :: grid_a = 9, gridQ_a = 3

    nz = nint(sqrt(four*nxQ))
    nQ = nint(sqrt(0.25_dp*nxQ))-1
    !nz=100
    if (output .and. i == 1) write(0,*) 'nz, nQ = ', nz, nQ

    zmax = zeta_of_y(ymax, grid_a)
    zQmax = zeta_of_y(log(Qmax/Qinit), gridQ_a)
    do iQ = 0, nQ
       do iz = 1, nz
          zeta = iz * zmax/nz
          y    = y_of_zeta(zeta, grid_a)
          !zQ = (iQ) * zQmax / nQ
          zQ = (iQ+zeta/zmax) * zQmax / nQ
          Q = max(Qinit,min(Qmax,Qinit * exp(y_of_zeta(zQ, gridQ_a))))
          call PEGXPARTON(pdfval,as,exp(-y),Q**2)
          if (output .and. i == 1) write(6,'(20es20.10)') y,Q,pdfval(-5:5)
       end do
       if (output .and. i == 1) write(6,'(a)') 
    end do

  end subroutine eval_output_grid



  !-----------------------------------------------------------------
  !! return zeta = ln 1/x + a*(1-x)  (x = exp(-y))
  function zeta_of_y(y, a) result(zeta)
    real(dp), intent(in) :: y, a
    real(dp)             :: zeta
    zeta = y + a*(one - exp(-y))
  end function zeta_of_y


  !-----------------------------------------------------------------
  !! return inversion of zeta = ln 1/x + a*(1-x)  (x = exp(-y))
  function y_of_zeta(zeta, a) result(y)
    real(dp), intent(in) :: zeta, a
    real(dp)             :: y, x, diff_from_zero, deriv
    integer             :: iter
    real(dp), parameter :: eps = 1e-12_dp
    integer,  parameter :: maxiter = 100

    ! starting condition (and soln if a = 0)
    y = zeta 
    if (a /= zero) then
       do iter = 0, maxiter
          x = exp(-y);
          diff_from_zero = zeta - y - a*(one-x);
          ! we have found good solution
          if (abs(diff_from_zero) < eps) exit
          deriv = -one  - a*x;
          y = y - diff_from_zero / deriv;
       end do
    end if

    if (iter > maxiter) write(0,*) "y_of_zeta reached maxiter"

  end function y_of_zeta


  subroutine PEGXPARTON(pdfval,as,x,Q2)
    real(dp), intent(out) :: pdfval(-6:6),as
    real(dp), intent(in)  :: x, Q2
    call XPARTON(pdfval,as,x,Q2,-5,5,1)
    call swap(pdfval(1),pdfval(2))
    call swap(pdfval(-1),pdfval(-2))
  end subroutine PEGXPARTON
  
  subroutine swap(a,b)
    real(dp) :: a, b
    real(dp) :: tmp
    tmp = a
    a = b
    b = tmp
  end subroutine swap
  

end program prec_and_timing_pegasus


!
! ..File: usrinit.f
!
!
! ..Initialization parameters for speed, the heavy-flavour treatment,
!    the mode and order of the evolution, and the value of  FR2 = 
!    mu_f^2/mu_r^2  used by INITEVOL (IPAR) if called with  IPAR = 2.
!    See section 4.1 of the manual.
!
! =====================================================================
!
!
SUBROUTINE USRINIT (IFAST, IVFNS, NFF, IMODEV, NPORD, FR2)
  use pegasus_communicator
  ! 
  IMPLICIT DOUBLE PRECISION (A - Z)
  INTEGER IFAST, IVFNS, NFF, IMODEV, NPORD
  !
  IFAST  = pegasus_ifast
  !IFAST  = 1
  IVFNS  = 1
  NFF    = 4
  IMODEV = 1
  NPORD  = 2
  FR2    = 1.D0
  !
  RETURN
END SUBROUTINE USRINIT
!
! =================================================================av==

! ..File: usrinp.f  
!
!
! ..Input values for initial scale and alpha_s, the heavy-quark masses 
!    and the parton-distribution shapes used by  INITINP (IPAR)  if 
!    called with  IPAR = 2.  See section 4.2 of the manual.
!                   
! =====================================================================
!
!
SUBROUTINE USRINP (PUV, PDV, PLM, PLP, PSM, PSP, PGL, M20, ASI,&
     MC2, MB2, MT2, NFORM, IMOMIN, ISSIMP)
  ! 
  IMPLICIT DOUBLE PRECISION (A - Z)
  INTEGER IMOMIN, ISSIMP, NFORM 
  DIMENSION PUV(6), PDV(6), PLM(6), PLP(6), PSM(6), PSP(6), PGL(6)
  !
  M20 = 2D0
  ASI = 0.35000
  !
  ! ..The otherwise irrelevant shift of m_c ensures that the input is
  !   returned for m_c = mu_0 also in the VFNS. Useful for input checks.
  !
  MC2 = 2.0000000017732D0  ! use identical value to what hoppet has
  MB2 = 20.25D0
  MT2 = 3.0625D4
  !
  NFORM  = 1
  IMOMIN = 1
  ISSIMP = 0
  !
  PUV(1) =  2.0D0
  PUV(2) =  0.8D0
  PUV(3) =  3.0D0
  PUV(4) =  0.5D0
  PUV(5) =  0.0D0
  PUV(6) =  0.0D0
  !
  PDV(1) =  1.0D0
  PDV(2) =  0.8D0
  PDV(3) =  4.0D0
  PDV(4) =  0.5D0
  PDV(5) =  0.0D0
  PDV(6) =  0.0D0
  !
  PLM(1) =  0.193987D0
  PLM(2) =  0.9D0
  PLM(3) =  6.0D0
  PLM(4) =  0.5D0
  PLM(5) =  0.0D0
  PLM(6) =  0.0D0
  !           
  PLP(1) =  0.136565D0
  PLP(2) = -0.1D0
  PLP(3) =  6.0D0
  PLP(4) =  0.5D0
  PLP(5) =  0.0D0
  PLP(6) = -0.5D0
  !          
  PSM(1) =  0.0d0
  PSM(2) =  0.9D0
  PSM(3) =  6.0D0
  PSM(4) =  0.5D0
  PSM(5) =  0.0D0
  PSM(6) =  0.0D0
  !          
  PSP(1) =  0.027313d0
  PSP(2) = -0.1D0
  PSP(3) =  6.0D0
  PSP(4) =  0.5D0
  PSP(5) =  0.0D0
  PSP(6) = -0.5D0
  !
  PGL(1) =  1.0D0
  PGL(2) = -0.1D0
  PGL(3) =  5.0D0
  PGL(4) =  0.5D0
  PGL(5) =  0.0D0
  PGL(6) =  0.0D0
  !
  RETURN
END SUBROUTINE USRINP
!
! =================================================================av==

SUBROUTINE USRPINP
end SUBROUTINE USRPINP

SUBROUTINE USRPINIT
end SUBROUTINE USRPINIT

module coefficient_functions_holder_exact
  use types; use warnings_and_errors
  use consts_dp; use convolution_communicator
  use qcd
  use convolution
  use dglap_objects
  use coefficient_functions_holder 
  use coefficient_functions_holder_internal
  implicit none

contains

  ! when we have the exact coefficient functions, this is the actual
  ! implementation of their initialisation. It assumes that the 
  ! the coef_holder, cf, already have nloop and the current nf set.
  !
  ! NB: to aid with conditional compilation, this should only be 
  !     be called from InitCoefHolderExact
  subroutine InitCoefHolderExact_impl(grid, ch)
    type(grid_def), intent(in) :: grid
    type(coef_holder), intent(inout), target :: ch
    !------------------------------
    write(6,*) 'Initialising exact coefficient functions for nf =', nf_int

    if (ch%nloop.ge.3) then
       write(6,*) 'Initialising C2NNLO'
       call InitC2NNLO_e(grid, ch%C2NNLO)
       write(6,*) 'Initialising CLNNLO'
       call InitCLNNLO_e(grid, ch%CLNNLO)
       write(6,*) 'Initialising C3NNLO'
       call InitC3NNLO_e(grid, ch%C3NNLO)
    end if 
        
    if (ch%nloop.ge.4) then
       write(6,*) 'Initialising C2N3LO'
       call InitC2N3LO_e(grid, ch%C2N3LO)
       write(6,*) 'Initialising CLN3LO'
       call InitCLN3LO_e(grid, ch%CLN3LO)
       write(6,*) 'Initialising C3N3LO'
       call InitC3N3LO_e(grid, ch%C3N3LO)
       ! including the fl11 terms for Z/photon exchanges
       write(6,*) 'Initialising C2N3LO_fl11'
       call InitC2N3LO_fl11_e(grid, ch%C2N3LO_fl11)
       write(6,*) 'Initialising CLN3LO_fl11'
       call InitCLN3LO_fl11_e(grid, ch%CLN3LO_fl11)
    end if
    
  end subroutine InitCoefHolderExact_impl

  !======================================================================
  ! NNLO exact coefficient functions
  !======================================================================

  !======================================================================
  ! attempt to write the NNLO C2 coefficient function as a splitting
  ! matrix
  subroutine InitC2NNLO_e(grid, C)
    type(grid_def),  intent(in)    :: grid
    type(split_mat), intent(inout) :: C

    C%nf_int = nf_int
    call cobj_InitSplitLinks(C)

    call InitGridConv(grid, C%NS_plus, cfNNLO_F2NS_plus_e)
    call InitGridConv(grid, C%NS_minus, cfNNLO_F2NS_minus_e)
    ! valence shouldn't come in to F2, so it shouldn't matter
    ! what we put here (explicitly verified for F2Z and F2Wp*F2Wm)
    call InitGridConv(C%NS_V, C%NS_minus) 
    !call InitGridConv(grid, C%NS_V) 

    ! singlet qq is NS+ + pure_singlet
    call InitGridConv(C%qq, C%NS_plus)    ! start with NS+
    call AddWithCoeff(C%qq, cfNNLO_F2PS_e)  ! add in pure singlet piece
    call InitGridConv(grid, C%qg, cfNNLO_F2G_e)   ! the part driven by the gluon
    call InitGridConv(grid, C%gq)  ! zero
    call InitGridConv(grid, C%gg)  ! zero

  end subroutine InitC2NNLO_e

  !======================================================================
  ! attempt to write the NNLO CL coefficient function as a splitting
  ! matrix
  subroutine InitCLNNLO_e(grid, C)
    type(grid_def),  intent(in)    :: grid
    type(split_mat), intent(inout) :: C

    C%nf_int = nf_int
    call cobj_InitSplitLinks(C)

    call InitGridConv(grid, C%NS_plus, cfNNLO_FLNS_plus_e)
    call InitGridConv(grid, C%NS_minus, cfNNLO_FLNS_minus_e)
    ! valence shouldn't come in to F2, so it shouldn't matter
    ! what we put here (explicitly verified for F2Z and F2Wp*F2Wm)
    call InitGridConv(C%NS_V, C%NS_minus) 
    !call InitGridConv(grid, C%NS_V) 

    ! singlet qq is NS+ + pure_singlet
    call InitGridConv(C%qq, C%NS_plus)    ! start with NS+
    call AddWithCoeff(C%qq, cfNNLO_FLPS_e)  ! add in pure singlet piece
    call InitGridConv(grid, C%qg, cfNNLO_FLG_e)   ! the part driven by the gluon
    call InitGridConv(grid, C%gq)  ! zero
    call InitGridConv(grid, C%gg)  ! zero

  end subroutine InitCLNNLO_e

  !======================================================================
  ! attempt to write the NNLO C3 coefficient function as a splitting
  ! matrix
  subroutine InitC3NNLO_e(grid, C)
    type(grid_def),  intent(in)    :: grid
    type(split_mat), intent(inout) :: C

    C%nf_int = nf_int
    call cobj_InitSplitLinks(C)

    ! singlet piece should have no impact on Z case and for the W case
    ! has no impact for even numbers of flavours (odd numbers of light
    ! flavours don't make sense with W, except potentially inside
    ! certain loops). So we simply set it to zero
    call InitGridConv(grid, C%qq)  ! zero
    call InitGridConv(grid, C%qg)  ! zero
    call InitGridConv(grid, C%gq)  ! zero
    call InitGridConv(grid, C%gg)  ! zero

    !-- now fix up pieces so that they can be directly used as a matrix
    call Multiply(C%qg, 2*nf)

    ! all non-singlet pieces are equal to singlet ones
    call InitGridConv(grid, C%NS_plus, cfNNLO_F3NS_plus_e)
    call InitGridConv(grid, C%NS_minus, cfNNLO_F3NS_minus_e)
    ! NS_minus and NS_V are identical according to sentence before
    ! Eq.(3.15) of 1109.3717v2
    call InitGridConv(C%NS_V, C%NS_minus) 

  end subroutine InitC3NNLO_e


  !======================================================================
  ! N3LO exact coefficient functions
  !======================================================================

  !======================================================================
  ! N3LO C2 coefficient function as a splitting matrix
  subroutine InitC2N3LO_e(grid, C)
    type(grid_def),  intent(in)    :: grid
    type(split_mat), intent(inout) :: C

    C%nf_int = nf_int
    call cobj_InitSplitLinks(C)

    call InitGridConv(grid, C%NS_plus, cfN3LO_F2NS_plus_e)
    call InitGridConv(grid, C%NS_minus, cfN3LO_F2NS_minus_e)
    ! valence shouldn't come in to F2, so it shouldn't matter
    ! what we put here (explicitly verified for F2Z and F2Wp*F2Wm)
    call InitGridConv(C%NS_V, C%NS_minus) 
    !call InitGridConv(grid, C%NS_V) 

    ! singlet qq is NS+ + pure_singlet
    call InitGridConv(C%qq, C%NS_plus)    ! start with NS+
    call AddWithCoeff(C%qq, cfN3LO_F2PS_e)  ! add in pure singlet piece
    call InitGridConv(grid, C%qg, cfN3LO_F2G_e)   ! the part driven by the gluon
    call InitGridConv(grid, C%gq)  ! zero
    call InitGridConv(grid, C%gg)  ! zero

  end subroutine InitC2N3LO_e

  !======================================================================
  ! N3LO C2 fl11 coefficient function as a splitting matrix
  ! Only the part that is different for Z boson exchange
  subroutine InitC2N3LO_fl11_e(grid, C)
    type(grid_def),  intent(in)    :: grid
    type(split_mat), intent(inout) :: C

    C%nf_int = nf_int
    call cobj_InitSplitLinks(C)

    call InitGridConv(grid, C%NS_plus, cfN3LO_F2NS_plus_fl11_e)
    call InitGridConv(grid, C%NS_minus, cfN3LO_F2NS_minus_fl11_e)
    ! valence shouldn't come in to F2, so it shouldn't matter
    ! what we put here (explicitly verified for F2Z and F2Wp*F2Wm)
    call InitGridConv(C%NS_V, C%NS_minus) 
    !call InitGridConv(grid, C%NS_V) 

    ! singlet qq is NS+ + pure_singlet
    call InitGridConv(C%qq, C%NS_plus)    ! start with NS+
    call AddWithCoeff(C%qq, cfN3LO_F2PS_fl11_e)  ! add in pure singlet piece
    call InitGridConv(grid, C%qg, cfN3LO_F2G_fl11_e)   ! the part driven by the gluon
    call InitGridConv(grid, C%gq)  ! zero
    call InitGridConv(grid, C%gg)  ! zero

  end subroutine InitC2N3LO_fl11_e

  !======================================================================
  ! N3LO CL coefficient function as a splitting matrix
  subroutine InitCLN3LO_e(grid, C)
    type(grid_def),  intent(in)    :: grid
    type(split_mat), intent(inout) :: C

    C%nf_int = nf_int
    call cobj_InitSplitLinks(C)

    call InitGridConv(grid, C%NS_plus, cfN3LO_FLNS_plus_e)
    call InitGridConv(grid, C%NS_minus, cfN3LO_FLNS_minus_e)
    ! valence shouldn't come in to F2, so it shouldn't matter
    ! what we put here (explicitly verified for F2Z and F2Wp*F2Wm)
    call InitGridConv(C%NS_V, C%NS_minus) 
    !call InitGridConv(grid, C%NS_V) 

    ! singlet qq is NS+ + pure_singlet
    call InitGridConv(C%qq, C%NS_plus)    ! start with NS+
    call AddWithCoeff(C%qq, cfN3LO_FLPS_e)  ! add in pure singlet piece
    call InitGridConv(grid, C%qg, cfN3LO_FLG_e)   ! the part driven by the gluon
    call InitGridConv(grid, C%gq)  ! zero
    call InitGridConv(grid, C%gg)  ! zero

  end subroutine InitCLN3LO_e


  !======================================================================
  ! N3LO CL coefficient function as a splitting matrix
  subroutine InitCLN3LO_fl11_e(grid, C)
    type(grid_def),  intent(in)    :: grid
    type(split_mat), intent(inout) :: C

    C%nf_int = nf_int
    call cobj_InitSplitLinks(C)

    call InitGridConv(grid, C%NS_plus, cfN3LO_FLNS_plus_fl11_e)
    call InitGridConv(grid, C%NS_minus, cfN3LO_FLNS_minus_fl11_e)
    ! valence shouldn't come in to F2, so it shouldn't matter
    ! what we put here (explicitly verified for F2Z and F2Wp*F2Wm)
    call InitGridConv(C%NS_V, C%NS_minus) 
    !call InitGridConv(grid, C%NS_V) 

    ! singlet qq is NS+ + pure_singlet
    call InitGridConv(C%qq, C%NS_plus)    ! start with NS+
    call AddWithCoeff(C%qq, cfN3LO_FLPS_fl11_e)  ! add in pure singlet piece
    call InitGridConv(grid, C%qg, cfN3LO_FLG_fl11_e)   ! the part driven by the gluon
    call InitGridConv(grid, C%gq)  ! zero
    call InitGridConv(grid, C%gg)  ! zero

  end subroutine InitCLN3LO_fl11_e

  !======================================================================
  ! N3LO C3 coefficient function as a splitting matrix
  subroutine InitC3N3LO_e(grid, C)
    type(grid_def),  intent(in)    :: grid
    type(split_mat), intent(inout) :: C

    C%nf_int = nf_int
    call cobj_InitSplitLinks(C)

    ! singlet piece should have no impact on Z case and for the W case
    ! has no impact for even numbers of flavours (odd numbers of light
    ! flavours don't make sense with W, except potentially inside
    ! certain loops). So we simply set it to zero
    call InitGridConv(grid, C%qq)  ! zero
    call InitGridConv(grid, C%qg)  ! zero
    call InitGridConv(grid, C%gq)  ! zero
    call InitGridConv(grid, C%gg)  ! zero

    !-- now fix up pieces so that they can be directly used as a matrix
    call Multiply(C%qg, 2*nf)

    ! all non-singlet pieces are equal to singlet ones
    call InitGridConv(grid, C%NS_plus, cfN3LO_F3NS_plus_e)
    !call SetDefaultConvolutionEps(1d-4)
    call InitGridConv(grid, C%NS_minus, cfN3LO_F3NS_minus_e)
    !call SetDefaultConvolutionEps(1d-7)
    ! NS_minus and NS_V are not identical at N3LO
    call InitGridConv(grid, C%NS_V, cfN3LO_F3NS_val_e) 

  end subroutine InitC3N3LO_e



  !======================================================================
  !======================================================================
  ! NNLO PIECES (exact version)
  !======================================================================
  !======================================================================


  !----------------------------------------------------------------------
  ! This is the coefficient function for the sum F3(nu)+F3(nubar),
  ! corresponding to C3NSP-C3NSN in W. van Neerven's program.
  function cfNNLO_F3NS_minus_e(y) result(res)
    use xc3ns2e
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x
    
    x = exp(-y)
    res = zero
    call set_c3soft(nf_int)
    
    select case(cc_piece)
    case(cc_REAL)
       res = X3NM2A(x, nf_int) + X3NS2B(x, nf_int)
    case(cc_REALVIRT)
       res = X3NM2A(x, nf_int)
    case(cc_VIRT)
       res = - X3NS2B(x, nf_int)
    case(cc_DELTA)
       res = X3NS2C(zero, nf_int)
    end select
    
    res = res * 0.25_dp ! since our convention is to multiply (as/2pi)^2, theirs is to multiply (as/4pi)^2
    if (cc_piece /= cc_DELTA) res = res * x
  end function cfNNLO_F3NS_minus_e

  !----------------------------------------------------------------------
  ! This is the coefficient function for the sum F3(nu)-F3(nubar),
  ! corresponding to C3NSP-C3NSN in W. van Neerven's program.
  function cfNNLO_F3NS_plus_e(y) result(res)
    use xc3ns2e
    use xcdiff2e
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x
    
    x = exp(-y)
    res = zero
    call set_c3soft(nf_int)
    
    select case(cc_piece)
    case(cc_REAL)
       res = X3NM2A(x, nf_int) + XC3DFF2(x) + X3NS2B(x, nf_int)
    case(cc_REALVIRT)
       res = X3NM2A(x, nf_int) + XC3DFF2(x)
    case(cc_VIRT)
       res = - X3NS2B(x, nf_int)
    case(cc_DELTA)
       res = X3NS2C(zero, nf_int)
    end select

    res = res * 0.25_dp ! since our convention is to multiply (as/2pi)^2, theirs is to multiply (as/4pi)^2
    if (cc_piece /= cc_DELTA) res = res * x
  end function cfNNLO_F3NS_plus_e
  

  !----------------------------------------------------------------------
  ! This is the "plus" non-singlet coefficient function (Vogt's
  ! comments say it applies to the electromagnetic F2, and, in
  ! addition to the singlet, that involves (u+ubar) - (d+dbar) type
  ! contributions, which is precisely what a NS+ coefficient function
  ! multiplies.
  function cfNNLO_F2NS_plus_e(y) result(res)
    use xc2ns2e
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x
    
    x = exp(-y)
    res = zero
    call set_c2soft(nf_int)
    select case(cc_piece)
    case(cc_REAL)
       res = X2NP2A(x, nf_int) + X2NS2B(x, nf_int)
    case(cc_REALVIRT)
       res = X2NP2A(x, nf_int)
    case(cc_VIRT)
       res = - X2NS2B(x, nf_int)
    case(cc_DELTA)
       res = X2NS2C(zero, nf_int)
    end select

    res = res * 0.25_dp ! since our convention is to multiply (as/2pi)^2, theirs is to multiply (as/4pi)^2
    if (cc_piece /= cc_DELTA) res = res * x
  end function cfNNLO_F2NS_plus_e

  !----------------------------------------------------------------------
  ! This is the "minus" non-singlet coefficient function (Vogt's
  ! comments say it applies to the charged-current F2, and, in
  ! addition to the singlet, that involves (u-ubar) - (d-dbar) type
  ! contributions, which is precisely what a NS- coefficient function
  ! multiplies.
  function cfNNLO_F2NS_minus_e(y) result(res)
    use xc2ns2e
    use xcdiff2e
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x
    
    x = exp(-y)
    res = zero
    call set_c2soft(nf_int)
    
    select case(cc_piece)
    case(cc_REAL)
       res = X2NP2A(x, nf_int) - XC2DFF2(x) + X2NS2B(x, nf_int)
    case(cc_REALVIRT)
       res = X2NP2A(x, nf_int) - XC2DFF2(x)
    case(cc_VIRT)
       res = - X2NS2B(x, nf_int)
    case(cc_DELTA)
       res = X2NS2C(zero, nf_int)
    end select

    res = res * 0.25_dp ! since our convention is to multiply (as/2pi)^2, theirs is to multiply (as/4pi)^2
    if (cc_piece /= cc_DELTA) res = res * x
  end function cfNNLO_F2NS_minus_e

  !----------------------------------------------------------------------
  ! Pure singlet piece of F2 NNLO coefficient function. To get the full
  ! singlet result, this is to be added to NS_plus (cf. relation just after
  ! Eq.(3.18) of 1109.3717v2
  function cfNNLO_F2PS_e(y) result(res)
    use xc2sg2e
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x
    
    x = exp(-y)
    res = zero

    select case(cc_piece)
    case(cc_REAL)
       res = X2S2A(x, nf_int)
    case(cc_REALVIRT)
       res = X2S2A(x, nf_int)
    case(cc_VIRT)
       res = zero
    case(cc_DELTA)
       res = zero
    end select

    res = res * 0.25_dp ! since our convention is to multiply (as/2pi)^2, theirs is to multiply (as/4pi)^2
    if (cc_piece /= cc_DELTA) res = res * x
  end function cfNNLO_F2PS_e

  !----------------------------------------------------------------------
  ! Pure singlet piece of F2 NNLO coefficient function. To get the full
  ! singlet result, this is to be added to NS_plus (cf. relation just after
  ! Eq.(3.18) of 1109.3717v2
  function cfNNLO_F2G_e(y) result(res)
    use xc2sg2e
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x
    
    x = exp(-y)
    res = zero

    select case(cc_piece)
    case(cc_REAL)
       res = X2G2A(x, nf_int)
    case(cc_REALVIRT)
       res = X2G2A(x, nf_int)
    case(cc_VIRT)
       res = zero
    case(cc_DELTA)
       res = zero
    end select

    res = res * 0.25_dp ! since our convention is to multiply (as/2pi)^2, theirs is to multiply (as/4pi)^2
    if (cc_piece /= cc_DELTA) res = res * x
  end function cfNNLO_F2G_e

  !----------------------------------------------------------------------
  ! This is the "plus" non-singlet coefficient function (Vogt's
  ! comments say it applies to the electromagnetic FL, and, in
  ! addition to the singlet, that involves (u+ubar) - (d+dbar) type
  ! contributions, which is precisely what a NS+ coefficient function
  ! multiplies.
  function cfNNLO_FLNS_plus_e(y) result(res)
    use xclns2e
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x
    
    x = exp(-y)
    res = zero

    select case(cc_piece)
    case(cc_REAL)
       res = XLNP2A(x, nf_int)
    case(cc_REALVIRT)
       res = XLNP2A(x, nf_int)
    case(cc_VIRT)
       res = zero
    case(cc_DELTA)
       res = zero
    end select

    res = res * 0.25_dp ! since our convention is to multiply (as/2pi)^2, theirs is to multiply (as/4pi)^2
    if (cc_piece /= cc_DELTA) res = res * x
  end function cfNNLO_FLNS_plus_e

  !----------------------------------------------------------------------
  ! This is the "minus" non-singlet coefficient function (Vogt's
  ! comments say it applies to the charged-current FL, and, in
  ! addition to the singlet, that involves (u-ubar) - (d-dbar) type
  ! contributions, which is precisely what a NS- coefficient function
  ! multiplies.
  function cfNNLO_FLNS_minus_e(y) result(res)
    use xclns2e
    use xcdiff2e
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x
    
    x = exp(-y)
    res = zero

    select case(cc_piece)
    case(cc_REAL)
       res = XLNP2A(x, nf_int) - XCLDFF2(x)
    case(cc_REALVIRT)
       res = XLNP2A(x, nf_int) - XCLDFF2(x)
    case(cc_VIRT)
       res = zero
    case(cc_DELTA)
       res = zero
    end select

    res = res * 0.25_dp ! since our convention is to multiply (as/2pi)^2, theirs is to multiply (as/4pi)^2
    if (cc_piece /= cc_DELTA) res = res * x
  end function cfNNLO_FLNS_minus_e

  !----------------------------------------------------------------------
  ! Pure singlet piece of FL NNLO coefficient function. To get the full
  ! singlet result, this is to be added to NS_plus (cf. relation just after
  ! Eq.(3.18) of 1109.3717v2
  function cfNNLO_FLPS_e(y) result(res)
    use xclsg2e
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x
    
    x = exp(-y)
    res = zero

    select case(cc_piece)
    case(cc_REAL)
       res = XLS2A(x, nf_int)
    case(cc_REALVIRT)
       res = XLS2A(x, nf_int)
    case(cc_VIRT)
       res = zero
    case(cc_DELTA)
       res = zero
    end select

    res = res * 0.25_dp ! since our convention is to multiply (as/2pi)^2, theirs is to multiply (as/4pi)^2
    if (cc_piece /= cc_DELTA) res = res * x
  end function cfNNLO_FLPS_e

  !----------------------------------------------------------------------
  ! Pure singlet piece of FL NNLO coefficient function. To get the full
  ! singlet result, this is to be added to NS_plus (cf. relation just after
  ! Eq.(3.18) of 1109.3717v2
  function cfNNLO_FLG_e(y) result(res)
    use xclsg2e
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x
    
    x = exp(-y)
    res = zero

    select case(cc_piece)
    case(cc_REAL)
       res = XLG2A(x, nf_int)
    case(cc_REALVIRT)
       res = XLG2A(x, nf_int)
    case(cc_VIRT)
       res = zero
    case(cc_DELTA)
       res = zero
    end select

    res = res * 0.25_dp ! since our convention is to multiply (as/2pi)^2, theirs is to multiply (as/4pi)^2
    if (cc_piece /= cc_DELTA) res = res * x
  end function cfNNLO_FLG_e


  !======================================================================
  !======================================================================
  ! N3LO PIECES (exact)
  !======================================================================
  !======================================================================

  !----------------------------------------------------------------------
  ! This is the coefficient function for the sum F3(nu)+F3(nubar),
  ! corresponding to C3NSP-C3NSN in W. van Neerven's program.
  function cfN3LO_F3NS_val_e(y) result(res)
    use xc3ns3p
    use xc3ns3e
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x
    
    x = exp(-y)
    res = zero
    CALL SET_C3SOFT_N3LO(nf_int)

    select case(cc_piece)
    case(cc_REAL)
       res = X3NM3A(x, -y, nf_int, 1) + X3NS3B(x, -y, nf_int)
    case(cc_REALVIRT)
       res = X3NM3A(x, -y, nf_int, 1)
    case(cc_VIRT)
       res = - X3NS3B(x, -y, nf_int)
    case(cc_DELTA)
       res = X3NS3C(zero, -y, nf_int) 
    end select

    res = res * 0.125_dp ! since our convention is to multiply (as/2pi)^3, theirs is to multiply (as/4pi)^3
    if (cc_piece /= cc_DELTA) res = res * x
  end function cfN3LO_F3NS_val_e

  !----------------------------------------------------------------------
  ! This is the coefficient function for the sum F3(nu)+F3(nubar),
  ! corresponding to C3NSP-C3NSN in W. van Neerven's program.
  function cfN3LO_F3NS_minus_e(y) result(res)
    use xc3ns3e
    use xc3ns3p
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x
    
    x = exp(-y)
    res = zero
    CALL SET_C3SOFT_N3LO(nf_int)

    select case(cc_piece)
    case(cc_REAL)
       res = X3NM3A(x, -y, nf_int, 0) + X3NS3B(x, -y, nf_int)
    case(cc_REALVIRT)
       res = X3NM3A(x, -y, nf_int, 0)
    case(cc_VIRT)
       res = - X3NS3B(x, -y, nf_int)
    case(cc_DELTA)
       res = X3NS3C(zero, -y, nf_int) 
    end select
    
    res = res * 0.125_dp ! since our convention is to multiply (as/2pi)^3, theirs is to multiply (as/4pi)^3
    if (cc_piece /= cc_DELTA) res = res * x
  end function cfN3LO_F3NS_minus_e

  !----------------------------------------------------------------------
  ! This is the coefficient function for the sum F3(nu)-F3(nubar),
  ! corresponding to C3NSP-C3NSN in W. van Neerven's program.
  function cfN3LO_F3NS_plus_e(y) result(res)
    use xc3ns3p
    use xc3ns3e
    use xcdiff3pnew
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x
    
    x = exp(-y)
    res = zero
    CALL SET_C3SOFT_N3LO(nf_int)

    select case(cc_piece)
    case(cc_REAL)
       res = X3NM3A(x, -y, nf_int, 0) + C3Q3DFP(x, -y, nf_int) + X3NS3B(x, -y, nf_int)
    case(cc_REALVIRT)
       res = X3NM3A(x, -y, nf_int, 0) + C3Q3DFP(x, -y, nf_int)
    case(cc_VIRT)
       res = - X3NS3B(x, -y, nf_int)
    case(cc_DELTA)
       res = X3NS3C(zero, -y, nf_int) + c3q3dfPC (zero, nf_int)
    end select

    res = res * 0.125_dp ! since our convention is to multiply (as/2pi)^3, theirs is to multiply (as/4pi)^3
    if (cc_piece /= cc_DELTA) res = res * x
  end function cfN3LO_F3NS_plus_e
  

  !----------------------------------------------------------------------
  ! This is the "plus" non-singlet coefficient function (Vogt's
  ! comments say it applies to the electromagnetic F2, and, in
  ! addition to the singlet, that involves (u+ubar) - (d+dbar) type
  ! contributions, which is precisely what a NS+ coefficient function
  ! multiplies.
  function cfN3LO_F2NS_plus_e(y) result(res)
    use xc2ns3p
    use xc2ns3e
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x
    
    x = exp(-y)
    res = zero
    CALL SET_C2SOFT_N3LO(nf_int)
    select case(cc_piece)
    case(cc_REAL)
       res = X2NP3A(x, -y, nf_int, 1) + X2NS3B(x, -y, nf_int)
    case(cc_REALVIRT)
       res = X2NP3A(x, -y, nf_int, 1)
    case(cc_VIRT)
       res = - X2NS3B(x, -y, nf_int)
    case(cc_DELTA)
       res = X2NP3C(zero, nf_int, 1)        
    end select
    
    res = res * 0.125_dp ! since our convention is to multiply (as/2pi)^3, theirs is to multiply (as/4pi)^3
    if (cc_piece /= cc_DELTA) res = res * x
  end function cfN3LO_F2NS_plus_e
  
  !----------------------------------------------------------------------
  ! This is the "plus" non-singlet coefficient function, but only the fl11 part
  ! 
  function cfN3LO_F2NS_plus_fl11_e(y) result(res)
    use xc2ns3e
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x
    
    x = exp(-y)
    res = zero

    call SET_C2SOFT_N3LO(nf_int)
    select case(cc_piece)
    case(cc_REAL)
       res = X2NP3A(x, -y, nf_int, 0)
    case(cc_REALVIRT)
       res = X2NP3A(x, -y, nf_int, 0)
    case(cc_VIRT)
       res = res
    case(cc_DELTA)
       res = X2NP3C(zero, nf_int, 0) 
    end select

    res = res * 0.125_dp ! since our convention is to multiply (as/2pi)^3, theirs is to multiply (as/4pi)^3
    if (cc_piece /= cc_DELTA) res = res * x
  end function cfN3LO_F2NS_plus_fl11_e

  !----------------------------------------------------------------------
  ! This is the "minus" non-singlet coefficient function (Vogt's
  ! comments say it applies to the charged-current F2, and, in
  ! addition to the singlet, that involves (u-ubar) - (d-dbar) type
  ! contributions, which is precisely what a NS- coefficient function
  ! multiplies.
  function cfN3LO_F2NS_minus_e(y) result(res)
    use xc2ns3p
    use xc2ns3e
    use xcdiff3pnew
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x
    
    x = exp(-y)
    res = zero
    CALL SET_C2SOFT_N3LO(nf_int)
    select case(cc_piece)
    case(cc_REAL)
       res = X2NP3A(x, -y, nf_int, 1) - C2Q3DFP(x, -y, nf_int) + X2NS3B(x, -y, nf_int)
    case(cc_REALVIRT)
       res = X2NP3A(x, -y, nf_int, 1) - C2Q3DFP(x, -y, nf_int)
    case(cc_VIRT)
       res = - X2NS3B(x, -y, nf_int)
    case(cc_DELTA)
       res = X2NP3C(zero, nf_int, 1) - c2q3dfPC (zero, nf_int) 
    end select
 
    res = res * 0.125_dp ! since our convention is to multiply (as/2pi)^3, theirs is to multiply (as/4pi)^3
    if (cc_piece /= cc_DELTA) res = res * x
  end function cfN3LO_F2NS_minus_e


  !----------------------------------------------------------------------
  ! This is the "minus" non-singlet coefficient function but only the fl11 part
  ! 
  function cfN3LO_F2NS_minus_fl11_e(y) result(res)
    use xc2ns3e
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x
    
    x = exp(-y)
    res = zero

    call SET_C2SOFT_N3LO(nf_int)
    select case(cc_piece)
    case(cc_REAL)
       res = X2NP3A(x, -y, nf_int, 0)
    case(cc_REALVIRT)
       res = X2NP3A(x, -y, nf_int, 0)
    case(cc_VIRT)
       res = res
    case(cc_DELTA)
       res = X2NP3C(zero, nf_int, 0) 
    end select

    res = res * 0.125_dp ! since our convention is to multiply (as/2pi)^3, theirs is to multiply (as/4pi)^3
    if (cc_piece /= cc_DELTA) res = res * x
  end function cfN3LO_F2NS_minus_fl11_e

  !----------------------------------------------------------------------
  ! Pure singlet piece of F2 N3LO coefficient function. To get the full
  ! singlet result, this is to be added to NS_plus (cf. relation just after
  ! Eq.(3.18) of 1109.3717v2
  function cfN3LO_F2PS_e(y) result(res)
    use xc2ps3e
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x
    
    x = exp(-y)
    res = zero

    select case(cc_piece)
    case(cc_REAL)
       res = X2S3A(x, nf_int, 1)
    case(cc_REALVIRT)
       res = X2S3A(x, nf_int, 1)
    case(cc_VIRT)
       res = zero
    case(cc_DELTA)
       res = zero
    end select

    res = res * 0.125_dp ! since our convention is to multiply (as/2pi)^3, theirs is to multiply (as/4pi)^3
    if (cc_piece /= cc_DELTA) res = res * x
  end function cfN3LO_F2PS_e
  
  !----------------------------------------------------------------------
  ! Pure singlet piece of F2 N3LO coefficient function.
  ! This is just the fl11 piece
  function cfN3LO_F2PS_fl11_e(y) result(res)
    use xc2ps3e
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x
    
    x = exp(-y)
    res = zero

    select case(cc_piece)
    case(cc_REAL)
       res = X2S3A(x, nf_int, 0)
    case(cc_REALVIRT)
       res = X2S3A(x, nf_int, 0)
    case(cc_VIRT)
       res = zero
    case(cc_DELTA)
       res = X2S3C (x, nf_int)
    end select

    res = res * 0.125_dp ! since our convention is to multiply (as/2pi)^3, theirs is to multiply (as/4pi)^3
    if (cc_piece /= cc_DELTA) res = res * x
  end function cfN3LO_F2PS_fl11_e

  !----------------------------------------------------------------------
  ! Pure singlet piece of F2 N3LO coefficient function. To get the full
  ! singlet result, this is to be added to NS_plus (cf. relation just after
  ! Eq.(3.18) of 1109.3717v2
  function cfN3LO_F2G_e(y) result(res)
    use xc2gl3e
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x
    
    x = exp(-y)
    res = zero

    select case(cc_piece)
    case(cc_REAL)
       res = X2G3A(x, nf_int, 1)
    case(cc_REALVIRT)
       res = X2G3A(x, nf_int, 1)
    case(cc_VIRT)
       res = zero
    case(cc_DELTA)
       res = zero
    end select

    res = res * 0.125_dp ! since our convention is to multiply (as/2pi)^3, theirs is to multiply (as/4pi)^3
    if (cc_piece /= cc_DELTA) res = res * x
  end function cfN3LO_F2G_e

  !----------------------------------------------------------------------
  ! Pure singlet piece of F2 N3LO coefficient function.
  ! this is just the fl11 piece
  function cfN3LO_F2G_fl11_e(y) result(res)
    use xc2gl3e
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x
    
    x = exp(-y)
    res = zero

    select case(cc_piece)
    case(cc_REAL)
       res = X2G3A(x, nf_int, 0)
    case(cc_REALVIRT)
       res = X2G3A(x, nf_int, 0)
    case(cc_VIRT)
       res = zero
    case(cc_DELTA)
       res = zero
    end select

    res = res * 0.125_dp ! since our convention is to multiply (as/2pi)^3, theirs is to multiply (as/4pi)^3
    if (cc_piece /= cc_DELTA) res = res * x
  end function cfN3LO_F2G_fl11_e

  !----------------------------------------------------------------------
  ! This is the "plus" non-singlet coefficient function (Vogt's
  ! comments say it applies to the electromagnetic FL, and, in
  ! addition to the singlet, that involves (u+ubar) - (d+dbar) type
  ! contributions, which is precisely what a NS+ coefficient function
  ! multiplies.
  function cfN3LO_FLNS_plus_e(y) result(res)
    use xclns3e
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x
    
    x = exp(-y)
    res = zero
    select case(cc_piece)
    case(cc_REAL)
       res = XLNP3A(x, nf_int, 1)
    case(cc_REALVIRT)
       res = XLNP3A(x, nf_int, 1)
    case(cc_VIRT)
       res = zero
    case(cc_DELTA)
       res = zero
    end select

    res = res * 0.125_dp ! since our convention is to multiply (as/2pi)^3, theirs is to multiply (as/4pi)^3
    if (cc_piece /= cc_DELTA) res = res * x
  end function cfN3LO_FLNS_plus_e
  
  !----------------------------------------------------------------------
  ! This is the "plus" non-singlet coefficient function.
  ! this is the fl11 part.
  function cfN3LO_FLNS_plus_fl11_e(y) result(res)
    use xclns3e
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x
    
    x = exp(-y)
    res = zero

    select case(cc_piece)
    case(cc_REAL)
       res = XLNP3A(x, nf_int, 0)
    case(cc_REALVIRT)
       res = XLNP3A(x, nf_int, 0)
    case(cc_VIRT)
       res = zero
    case(cc_DELTA)
       res = zero
    end select

    res = res * 0.125_dp ! since our convention is to multiply (as/2pi)^3, theirs is to multiply (as/4pi)^3
    if (cc_piece /= cc_DELTA) res = res * x
  end function cfN3LO_FLNS_plus_fl11_e

  !----------------------------------------------------------------------
  ! This is the "minus" non-singlet coefficient function (Vogt's
  ! comments say it applies to the charged-current FL, and, in
  ! addition to the singlet, that involves (u-ubar) - (d-dbar) type
  ! contributions, which is precisely what a NS- coefficient function
  ! multiplies.
  function cfN3LO_FLNS_minus_e(y) result(res)
    use xclns3e
    use xcdiff3pnew
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x
    
    x = exp(-y)
    res = zero
    select case(cc_piece)
    case(cc_REAL)
       res = XLNP3A(x, nf_int, 1) - CLQ3DFP(x, -y, nf_int)
    case(cc_REALVIRT)
       res = XLNP3A(x, nf_int, 1) - CLQ3DFP(x, -y, nf_int)
    case(cc_VIRT)
       res = zero
    case(cc_DELTA)
       res = zero!
    end select

    res = res * 0.125_dp ! since our convention is to multiply (as/2pi)^3, theirs is to multiply (as/4pi)^3
    if (cc_piece /= cc_DELTA) res = res * x
  end function cfN3LO_FLNS_minus_e
  
  !----------------------------------------------------------------------
  ! This is the "minus" non-singlet coefficient function
  ! this is the fl11 part
  function cfN3LO_FLNS_minus_fl11_e(y) result(res)
    use xclns3p
    use xclns3e
    use xcdiff3pnew
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x
    
    x = exp(-y)
    res = zero
    select case(cc_piece)
    case(cc_REAL)
       res = XLNP3A(x, nf_int, 0) 
    case(cc_REALVIRT)
       res = XLNP3A(x, nf_int, 0) 
    case(cc_VIRT)
       res = zero
    case(cc_DELTA)
       res = zero
    end select

    res = res * 0.125_dp ! since our convention is to multiply (as/2pi)^3, theirs is to multiply (as/4pi)^3
    if (cc_piece /= cc_DELTA) res = res * x
  end function cfN3LO_FLNS_minus_fl11_e

  !----------------------------------------------------------------------
  ! Pure singlet piece of FL N3LO coefficient function. To get the full
  ! singlet result, this is to be added to NS_plus (cf. relation just after
  ! Eq.(3.18) of 1109.3717v2
  function cfN3LO_FLPS_e(y) result(res)
    use xclps3e
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x
    
    x = exp(-y)
    res = zero

    select case(cc_piece)
    case(cc_REAL)
       res = XLS3A(x, nf_int, 1)
    case(cc_REALVIRT)
       res = XLS3A(x, nf_int, 1)
    case(cc_VIRT)
       res = zero
    case(cc_DELTA)
       res = zero
    end select

    res = res * 0.125_dp ! since our convention is to multiply (as/2pi)^3, theirs is to multiply (as/4pi)^3
    if (cc_piece /= cc_DELTA) res = res * x
  end function cfN3LO_FLPS_e

  !----------------------------------------------------------------------
  ! Pure singlet piece of FL N3LO coefficient function.
  ! this is the fl11 part
  function cfN3LO_FLPS_fl11_e(y) result(res)
    use xclps3e
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x
    
    x = exp(-y)
    res = zero

    select case(cc_piece)
    case(cc_REAL)
       res = XLS3A(x, nf_int, 0)
    case(cc_REALVIRT)
       res = XLS3A(x, nf_int, 0)
    case(cc_VIRT)
       res = zero
    case(cc_DELTA)
       res = zero
    end select

    res = res * 0.125_dp ! since our convention is to multiply (as/2pi)^3, theirs is to multiply (as/4pi)^3
    if (cc_piece /= cc_DELTA) res = res * x
  end function cfN3LO_FLPS_fl11_e

  !----------------------------------------------------------------------
  ! Pure singlet piece of FL N3LO coefficient function. To get the full
  ! singlet result, this is to be added to NS_plus (cf. relation just after
  ! Eq.(3.18) of 1109.3717v2
  function cfN3LO_FLG_e(y) result(res)
    use xclgl3e
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x
    
    x = exp(-y)
    res = zero

    select case(cc_piece)
    case(cc_REAL)
       res = XLG3A(x, nf_int, 1)
    case(cc_REALVIRT)
       res = XLG3A(x, nf_int, 1)
    case(cc_VIRT)
       res = zero
    case(cc_DELTA)
       res = zero
    end select

    res = res * 0.125_dp ! since our convention is to multiply (as/2pi)^3, theirs is to multiply (as/4pi)^3
    if (cc_piece /= cc_DELTA) res = res * x
  end function cfN3LO_FLG_e

  !----------------------------------------------------------------------
  ! Pure singlet piece of FL N3LO coefficient function.
  ! this is the fl11 part
  function cfN3LO_FLG_fl11_e(y) result(res)
    use xclgl3e
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x
    
    x = exp(-y)
    res = zero

    select case(cc_piece)
    case(cc_REAL)
       res = XLG3A(x, nf_int, 0)
    case(cc_REALVIRT)
       res = XLG3A(x, nf_int, 0)
    case(cc_VIRT)
       res = zero
    case(cc_DELTA)
       res = zero
    end select

    res = res * 0.125_dp ! since our convention is to multiply (as/2pi)^3, theirs is to multiply (as/4pi)^3
    if (cc_piece /= cc_DELTA) res = res * x
  end function cfN3LO_FLG_fl11_e

    
end module coefficient_functions_holder_exact


!=============================================================================
! This just calls the function in coefficient_functions_holder_exact
subroutine InitCoefHolderExact(grid, ch)
  use types; use coefficient_functions_holder_exact, dummy => InitCoefHolderExact
  implicit none
  type(grid_def), intent(in) :: grid
  type(coef_holder), intent(inout), target :: ch
  call InitCoefHolderExact_impl(grid, ch)
end subroutine InitCoefHolderExact

      module xc2sg2p
      contains
*     
* ..File: xc2sg2p.f    F2_S
*
*
* ..Calculation of the 2-loop x-space MS(bar) coefficient functions 
*    for F2 via compact parametrizations involving only logarithms.
*    Singlet, mu_r = mu_f = Q. Expansion parameter: alpha_s/(4 pi).
*
*  ..The distributions (in the mathematical sense) are given as in eq.
*    (B.26) of Floratos, Kounnas, Lacaze: Nucl. Phys. B192 (1981) 417.
*    The name-endings A, B, and C of the functions below correspond to 
*    the kernel superscripts [2], [3], and [1] in that equation.
*
*  ..The relative accuracy of the coefficient functions, as well as of 
*    the convolution results, amounts to a few thousandth.
*
*  ..Reference: W.L. van Neerven and A. Vogt, 
*               hep-ph/0006154 = Nucl. Phys. B588 (2000) 345
*  ..The user should also cite the original calculations,
*     E.B. Zijlstra and W.L. van Neerven, Phys. Lett. B272 (1991) 127
*     (pure singlet) and Phys. Lett. B273 (1991) 476 (gluon).
*
* 
* =====================================================================
*
*
* ..This is the pure singlet piece, denoted by C2S in WvN's program. 
*    Seven numerical coefficients (all but the one of 1/y, which is 
*    exact up to truncation) are fitted to his results, using x values
*    between 10^-6 and 1-10^-6.
*
       FUNCTION C2S2A (Y, NF)
       IMPLICIT REAL*8 (A-Z)
       INTEGER NF
*
       DL  = LOG (Y)
       OMY = 1.0D0 - Y
       DL1 = LOG (OMY)
*
       C2S2A =   NF * ( 5.290D0 * (1.D0/Y-1.D0) + 4.310D0 * DL**3 -
     $      2.086D0 * DL**2 + 39.78D0 * DL - 0.101D0 * OMY * DL1**3 -
     $      (24.75D0 - 13.80D0 * Y) * DL**2 * DL1 + 30.23D0 * DL * DL1)
*
       RETURN
       END FUNCTION C2S2A
*
* ---------------------------------------------------------------------
*
*
* ..This is the regular gluon piece, denoted by C2G2 in WvN's program. 
*    Nine numerical coefficients are fitted as above, the ones of 1/y, 
*    ln^3(1-y), and ln^2(1-y) are exact up to truncation.
*
       FUNCTION C2G2A (Y, NF)
       IMPLICIT REAL*8 (A-Z)
       INTEGER NF
*
       DL  = LOG (Y)
       OMY = 1.0D0 - Y
       DL1 = LOG (OMY)
*
       C2G2A =   NF * ( 1.D0/Y * (11.90D0 + 1494.D0* DL1) + 5.319D0 * DL
     $      **3- 59.48D0 * DL**2 - 284.8D0 * DL + 392.4D0 - 1483.D0* DL1
     $      + (6.445D0 + 209.4D0 * OMY) * DL1**3 - 24.00D0 * DL1**2
     $      - 724.1D0 * DL**2 * DL1 - 871.8D0 * DL * DL1**2 )
*
       RETURN
       END FUNCTION C2G2A
* 
* ---------------------------------------------------------------------
*
*
* ..This is the 'local' gluon piece, which has no counterpart in WvN's
*    program, as it does not exist in the exact expressions. Here it 
*    is, however, relevant for achieving the highest accuracy of the 
*    convolution, as are the adjustments of the constant in the non-
*    singlet quark coefficient functions. The value is fixed from the 
*    lowest moments. 
*
       FUNCTION C2G2C (Y, NF)
       IMPLICIT REAL*8 (A-Z)
       INTEGER NF
*
       C2G2C = - NF * 0.28D0  
*
       RETURN
       END FUNCTION C2G2C
*
* =================================================================av==
      end module xc2sg2p

program test_qed
  use types; use consts_dp
  use convolution
  use qed_coupling_module
  use qed_splitting_functions
  use splitting_functions
  use qcd_qed_coupling
  use qcd_coupling
  implicit none
  type(grid_def)     :: grid
  type(qed_coupling) :: qed_alpha
  type(grid_conv)    :: Pqq_01, Pqy_01, Pyq_01, Pyy_01
  type(grid_conv)    :: Pqg_11, Pyg_11, Pgg_11
  type(grid_conv)    :: PqqV_11, PqqbarV_11, Pgq_11, Pyq_11
  real(dp), pointer  :: res(:), source(:)
  real(dp) :: moment

  real(dp) :: scales(9) = (/m_electron/two, 0.01_dp, 0.1_dp, 1.0_dp, 1.68_dp, 10.0_dp, 91.2_dp, 100.0_dp, 1000.0_dp/)
  real(dp) :: quark_masses(4:6) = (/ 1.67_dp, 4.78_dp, 173.21_dp/)
  real(dp) :: cpls(2), alphas, mu
  integer  :: i, n
  type(QCDQEDCoupling) :: qcd_qed
  type(running_coupling) :: qcd_cpl
  
  write(6,'(a)') "========== testing QED coupling ========================="
  call InitQEDCoupling(qed_alpha, quark_masses(4), quark_masses(5), quark_masses(6))
  write(6,*) IQEDThresholdAtQ(qed_alpha, 0.2_dp)

  qcd_qed = new_QCDQEDCoupling(0.118_dp, 1/128.6496065_dp, 91.2_dp, &
       & '01 02 03 10 11',&
       & quark_masses, &
       & (/ qcd_mass_scheme_pole, qcd_mass_scheme_pole, qcd_mass_scheme_pole /) )
  write(6,*) coupling_array(qcd_qed%Coupling, 91.2_dp)
  call InitRunningCoupling(0.118_dp, 91.2_dp, nloop=3, quark_masses = quark_masses)
  
  write(6,'(10a13)') 'mu','1/alpha','1/al(new)','diff','alphas','alphas(new)','diff'
  do i = 1, size(scales)
     mu = scales(i)
  !n=200; do i = 0, n
  !   mu = exp(i*log(300.0_dp)/n)
     cpls = coupling_array(qcd_qed%Coupling, mu)
     alphas = zero
     if (mu > 0.5_dp) alphas = Value(mu)
     write(6,'(f13.6,3f13.7,3f13.9)') mu, &
          & one/Value(qed_alpha, mu), 1/cpls(2), one/Value(qed_alpha, mu)-1/cpls(2), &
          & alphas, cpls(1), alphas-cpls(1)
  end do
  !stop !************************************
  
  write(6,'(a)') "========== testing sum rules ========================="
  call setup_grid_def()

  call InitGridConv(grid, Pqq_01, sf_Pqq_01)
  call InitGridConv(grid, Pyq_01, sf_Pyq_01)
  call InitGridConv(grid, Pqy_01, sf_Pqy_01)
  call InitGridConv(grid, Pyy_01, sf_Pyy_01)

  call InitGridConv(grid, Pqg_11, sf_Pqg_11)
  call InitGridConv(grid, Pyg_11, sf_Pyg_11)
  call InitGridConv(grid, Pgg_11, sf_Pgg_11)

  call InitGridConv(grid, PqqV_11, sf_PqqV_11)
  call InitGridConv(grid, PqqbarV_11, sf_PqqbarV_11)
  call InitGridConv(grid, Pgq_11, sf_Pgq_11)
  call InitGridConv(grid, Pyq_11, sf_Pgq_11)
  
  call AllocGridQuant(grid, source)
  call AllocGridQuant(grid, res)

  moment = one
  write(6,*) "looking at moment=",moment
  source = exp(moment * yValues(grid))
  res = Pqq_01 * source
  write(6,*) "Pqq_01 = ", res(grid%ny)/source(grid%ny)
  res = Pyq_01 * source
  write(6,*) "Pyq_01 = ", res(grid%ny)/source(grid%ny)
  res = Pqy_01 * source
  write(6,*) "Pqy_01 = ", res(grid%ny)/source(grid%ny)
  res = Pyy_01 * source
  write(6,*) "Pyy_01 = ", res(grid%ny)/source(grid%ny)
  write(6,*)

  
  res = Pqg_11 * source
  write(6,*) "Pqg_11 = ", res(grid%ny)/source(grid%ny)
  res = Pyg_11 * source
  write(6,*) "Pyg_11 = ", res(grid%ny)/source(grid%ny)
  res = Pgg_11 * source
  write(6,*) "Pgg_11 = ", res(grid%ny)/source(grid%ny)
  res = (two*(Pqg_11*source) + Pyg_11 * source + Pgg_11 * source)
  write(6,*) "(2*Pqg + Pyg + Pgg)_11 = ", res(grid%ny)/source(grid%ny)
  write(6,*)
  
  res = PqqV_11 * source
  write(6,*) "PqqV_11 = ", res(grid%ny)/source(grid%ny)
  res = PqqbarV_11 * source
  write(6,*) "PqqbarV_11 = ", res(grid%ny)/source(grid%ny)
  res = Pgq_11 * source
  write(6,*) "Pgq_11 = ", res(grid%ny)/source(grid%ny)
  res = Pyq_11 * source
  write(6,*) "Pyq_11 = ", res(grid%ny)/source(grid%ny)
  res = (PqqV_11*source + PqqbarV_11*source + Pgq_11*source + Pyq_11*source)
  write(6,*) "(PqqV+PqqbarV+Pgq+Pyq)_11 = ", res(grid%ny)/source(grid%ny)

  
contains
  subroutine setup_grid_def()
    real(dp) :: ymax, dy
    integer  :: order
    type(grid_def) :: gdarray(4)
    ! set up parameters for grid
    order = -6
    ymax  = 20.0_dp  ! you may see significant violations with too small a ymax
    dy    = 0.1_dp
    
    !call SetDefaultEvolutionDu(dy/3.0_dp)  ! generally a good choice
    
    ! set up the grid itself -- we use 4 nested subgrids
    call InitGridDef(gdarray(4),dy/27.0_dp,0.2_dp, order=order)
    call InitGridDef(gdarray(3),dy/9.0_dp,0.5_dp, order=order)
    call InitGridDef(gdarray(2),dy/3.0_dp,2.0_dp, order=order)
    call InitGridDef(gdarray(1),dy,       ymax  ,order=order)
    call InitGridDef(grid,gdarray(1:4),locked=.true.)
    
  end subroutine setup_grid_def

  
end program test_qed

!======================================================================
! Consider the following possibility: want special types for
!      set of LO splitting functions 
!      set of coefficient functions

!----------------------------------------------------------------------
! NB: compared to all normal splitting functions we have multiplied 
! by x, to allow for integration measure. NB: this applies also 
! to the plus functions, which do not care about integration measures?
!
! \int dx f(x)_+  g(x) = \int dy [exp(-y)f(exp(-y))]_+ g(exp(-y))
!
!
module splitting_functions
  use types; use consts_dp; use convolution_communicator
  use coefficient_functions; use qcd; use warnings_and_errors
  !! early estimate of splitting function based on fit to moments
  !!use splitting_functions_nnlo_n
  !! parametrization of exact splitting functions
  !!use splitting_functions_nnlo_p
  ! this one gives a set that depends on imod.
  use splitting_functions_nnlo
  use splitting_functions_n3lo
  implicit none
  private

  public :: sf_Pgg, sf_Pqq, sf_Pgq, sf_Pqg
  public :: sf_P1qqV, sf_P1gg, sf_P1qqbarV, sf_P1qqS, sf_P1qg, sf_P1gq
  public :: sf_P1qqBryan, sf_P1qgBryan, sf_P1minus
  public :: sf_P1fromg, sf_P1fromq
  public :: sf_P1qqV_DIS, sf_P1qg_DIS

  public :: sf_TmSP1qqNS, sf_TP1gg, sf_TP1qq, sf_TP1gq, sf_TP1qg

  public :: sf_A2PShq, sf_A2PShg, sf_A2PShg_vogt
  public :: sf_A2NSqq_H, sf_A2Sgg_H, sf_A2Sgq_H

  public :: sf_P2gg, sf_P2qg2nf, sf_P2PS, sf_P2gq
  public :: sf_P2NSPlus, sf_P2NSMinus, sf_P2NSS

  public :: sf_P3gg, sf_P3qg2nf, sf_P3PS, sf_P3gq
  public :: sf_P3NSPlus, sf_P3NSMinus, sf_P3NSS

  public :: sf_DPqq, sf_DPqg, sf_DPgq, sf_DPgg 
  public :: sf_DP1qqV, sf_DP1qqbarV, sf_DP1qqS
  public :: sf_DP1qg, sf_DP1gq, sf_DP1gg

  public :: sf_S2 ! for outside things that might need it
  

!!$  ! these are of help elsewhere in identifying (run-time) the sets of 
!!$  ! splitting functions that have been used?
!!$  public :: name_xpij2, name_xpns2

  real(dp),  parameter :: four_thirds = four/three

contains
  !----------------------------------------------------------------------
  function sf_Pgg(y) result(res)
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x
    x = exp(-y)
    res = zero

    select case(cc_piece)
    case(cc_REAL,cc_REALVIRT)
       res = two*ca*(x/(one-x) + (one-x)/x + x*(1-x))
    end select
    select case(cc_piece)
    case(cc_VIRT,cc_REALVIRT)
       res = res - two*ca*one/(one-x)
    case(cc_DELTA)
       res = (11.0_dp*ca - four*nf*tr)/6.0_dp
    end select

    if (cc_piece /= cc_DELTA) res = res * x
  end function sf_Pgg

  !----------------------------------------------------------------------
  function sf_Pqq(y) result(res)
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x
    x = exp(-y)
    res = zero

    select case(cc_piece)
    case(cc_REAL,cc_REALVIRT)
       res = cf*(one+x**2)/(one-x)
    end select
    select case(cc_piece)
    case(cc_VIRT,cc_REALVIRT)
       res = res - cf*two/(one-x)
    case(cc_DELTA)
       res = cf*three*half
    end select

    if (cc_piece /= cc_DELTA) res = res * x
  end function sf_Pqq

  !----------------------------------------------------------------------
  function sf_Pgq(y) result(res)
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x
    x = exp(-y)
    res = zero

    select case(cc_piece)
    case(cc_REAL,cc_REALVIRT)
       res = cf*(one + (one-x)**2)/x
    end select
    select case(cc_piece)
    case(cc_VIRT,cc_REALVIRT)
       res = res - zero
    case(cc_DELTA)
       res = zero
    end select

    if (cc_piece /= cc_DELTA) res = res * x
  end function sf_Pgq

  !----------------------------------------------------------------------
  function sf_Pqg(y) result(res)
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x
    x = exp(-y)
    res = zero

    select case(cc_piece)
    case(cc_REAL,cc_REALVIRT)
       res = tr*(x**2 + (one-x)**2)
    end select
    select case(cc_piece)
    case(cc_VIRT,cc_REALVIRT)
       res = res - zero
    case(cc_DELTA)
       res = zero
    end select

    if (cc_piece /= cc_DELTA) res = res * x
  end function sf_Pqg
  


  !======================================================================
  ! From here onwards, the NLO splitting functions
  function sf_P1qqV(y) result(res)
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x
    real(dp) :: lnx, ln1mx, pqq
    x = exp(-y)
    res = zero

    select case(cc_piece)
    case(cc_REAL,cc_REALVIRT)
       lnx = log(x); ln1mx = log(one - x)
       pqq = two/(one-x) - one - x
!!$       res =    cf**2*( -(two*lnx*ln1mx + 1.5_dp*lnx)*pqq&
!!$            & -(1.5_dp + 3.5_dp*x)*lnx - half*(one+x)*lnx**2 - 5*(1-x))&
!!$            & + cf*ca*( (half*lnx**2 + 11/6.0_dp * lnx&
!!$            &          + 67/18.0_dp - pi**2/6.0_dp) * pqq + (1+x)*lnx&
!!$            &        + 20/three*(1-x))&
!!$            & + cf*tf*(-(two/three*lnx + 10/9.0_dp)*pqq - four/three*(1-x))
res=    CF*Tf*((-1.1111111111111112_dp - (2*lnx)/3._dp)*pqq -          &
     &     (4*(1 - x))/3._dp) +                                        &
     &  CA*CF*((3.7222222222222223_dp + (11*lnx)/6._dp + lnx**2/2._dp -& 
     &        Pi**2/6._dp)*pqq + (20*(1 - x))/3._dp + lnx*(1 + x)) +   &
     &  CF**2*(((-3*lnx)/2._dp - 2*ln1mx*lnx)*pqq - 5*(1 - x) -        &
     &     (lnx**2*(1 + x))/2._dp - lnx*(1.5_dp + (7*x)/2._dp))
    end select
    select case(cc_piece)
    case(cc_VIRT,cc_REALVIRT)
       pqq = -two/(1-x)
       res = res + CA*CF*(3.7222222222222223_dp - Pi**2/6._dp)*pqq - (10*CF&
           & *pqq*Tf)/9._dp
    case(cc_DELTA)
       res = -(CF*(0.16666666666666666_dp + (2*Pi**2)/9._dp)*Tf) + CA&
           & *CF*(0.7083333333333334_dp + (11*Pi**2)/18._dp - 3*zeta3) +&
           & CF**2*(0.375_dp - Pi**2/2._dp + 6*zeta3)
    end select

    if (cc_piece /= cc_DELTA) res = res * x
    
  end function sf_P1qqV


  !======================================================================
  ! DIS version of the above.
  ! Currently the formulae are wrong. Use the complete formulae from 
  ! module dglap_holders (where double convolutions are used to work them out).
  function sf_P1qqV_DIS(y) result(res)
    real(dp), intent(in) :: y
    real(dp)             :: res
    
    call wae_error('sf_P1qqV_DIS: DIS scheme splitting functions &
         &currently not supported')
    ! dummy return value to avoid compiler warning
    res = sf_P1qqV(y) - cf_CqF2MSbar(y)*(11*CA - 2*nf)/6.0_dp
  end function sf_P1qqV_DIS

  

  !----------------------------------------------------------------------
  function sf_P1gg(y) result(res)
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x
    real(dp) :: lnx, ln1mx, pgg, S2x, pggmx
    x = exp(-y)
    res = zero

    select case(cc_piece)
    case(cc_REAL,cc_REALVIRT)
       lnx = log(x); ln1mx = log(one - x)
       pgg   = (one/(one-x) + one/x -two + x*(one-x))
       pggmx = (one/(one+x) - one/x -two - x*(one+x))
       S2x   = sf_S2(x)
       res = CF*Tf*(-16 + 4/(3._dp*x) + 8*x + (20*x**2)/3._dp - lnx**2*(2&
           & + 2*x)- lnx*(6 + 10*x)) + CA*Tf*(2 - (20*pgg)/9._dp - 2*x -&
           & (4*lnx*(1 + x))/3._dp + (26*(-(1/x) + x**2))/9._dp) + CA**2&
           & *(pgg*(7.444444444444445_dp - 4*ln1mx*lnx + lnx**2 - Pi**2&
           & /3._dp) + 2*pggmx*S2x + (27*(1 - x))/2._dp + 4*lnx**2*(1 + x)&
           & + (67*(-(1/x) + x**2))/9._dp - lnx*(8.333333333333334_dp -&
           & (11*x)/3._dp + (44*x**2)/3._dp))
    end select
    select case(cc_piece)
    case(cc_VIRT,cc_REALVIRT)
       pgg = -one/(1-x)
       res = res + CA**2*pgg*(7.444444444444445_dp - Pi**2/3._dp) - (20*CA&
           & *pgg*Tf)/9._dp
    case(cc_DELTA)
       res = (-4*CA*Tf)/3._dp - CF*Tf + CA**2*(2.6666666666666665_dp&
           & + 3*zeta3)
    end select

    if (cc_piece /= cc_DELTA) res = res * x
    
  end function sf_P1gg


  !----------------------------------------------------------------------
  function sf_P1qqbarV(y) result(res)
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x
    real(dp) :: lnx, pqqmx, S2x
    x = exp(-y)
    res = zero

    select case(cc_piece)
    case(cc_REAL,cc_REALVIRT)
       lnx = log(x)
       pqqmx = two/(one+x) - one + x
       S2x   = sf_S2(x)
       res = CF*(-CA/2._dp + CF)*(2*pqqmx*S2x + 4*(1 - x) + 2*lnx*(1 + x))
    end select
    select case(cc_piece)
    case(cc_VIRT,cc_REALVIRT)
       res = res + zero
    case(cc_DELTA)
       res = zero
    end select

    if (cc_piece /= cc_DELTA) res = res * x
  end function sf_P1qqbarV

  !----------------------------------------------------------------------
  function sf_P1qqS(y) result(res)
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x
    real(dp) :: lnx, ln1mx
    x = exp(-y)
    res = zero

    select case(cc_piece)
    case(cc_REAL,cc_REALVIRT)
       lnx = log(x); ln1mx = log(one - x)
       res = (CF*TR*(20 - 9*(2 - lnx + lnx**2)*x - 9*(-6 - 5*lnx + lnx&
           & **2)*x**2 + 8*(-7 + 3*lnx)*x**3))/(9._dp*x) 
    end select
    select case(cc_piece)
    case(cc_VIRT,cc_REALVIRT)
       res = res + zero
    case(cc_DELTA)
       res = zero
    end select

    if (cc_piece /= cc_DELTA) res = res * x
  end function sf_P1qqS


  !----------------------------------------------------------------------
  function sf_P1qg(y) result(res)
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x
    real(dp) :: lnx, ln1mx, pqg, pqgmx, S2x
    x = exp(-y)
    res = zero

    select case(cc_piece)
    case(cc_REAL,cc_REALVIRT)
       lnx = log(x); ln1mx = log(one - x)
       pqg   = x**2 + (one-x)**2
       pqgmx = x**2 + (one+x)**2
       S2x   = sf_S2(x)
       res = CF*(half*TR)*(4 + 4*ln1mx + (10 - 4*(ln1mx - lnx) + 2*(-ln1mx&
            & + lnx)& 
           & **2 - (2*Pi**2)/3._dp)* pqg - lnx*(1 - 4*x) - lnx**2*(1 - 2&
           & *x) - 9*x) + CA*(half*TR)*(20.22222222222222_dp - 4*ln1mx + (&
           & -24.22222222222222_dp + 4*ln1mx - 2*ln1mx**2 + (44*lnx)/3._dp&
           & - lnx**2 + Pi**2/3._dp)*pqg + 2*pqgmx*S2x + 40/(9._dp*x) +&
           & (14*x)/9._dp - lnx**2*(2 + 8*x) + lnx*(-12.666666666666666_dp&
           & + (136*x)/3._dp))
    end select
    select case(cc_piece)
    case(cc_VIRT,cc_REALVIRT)
       res = res + zero
    case(cc_DELTA)
       res = zero
    end select

    if (cc_piece /= cc_DELTA) res = res * x
  end function sf_P1qg


  !======================================================================
  ! DIS version of the above
  function sf_P1qg_DIS(y) result(res)
    real(dp), intent(in) :: y
    real(dp)             :: res
    
    call wae_error('sf_P1qg_DIS: DIS scheme splitting functions currently not supported')
    ! dummy return value
    res = sf_P1qg(y) - cf_CgF2MSbar(y)*(11*CA - 2*nf)/6.0_dp
  end function sf_P1qg_DIS


  !----------------------------------------------------------------------
  function sf_P1gq(y) result(res)
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x
    real(dp) :: lnx, ln1mx, pgq, pgqmx,S2x
    x = exp(-y)
    res = zero

    select case(cc_piece)
    case(cc_REAL,cc_REALVIRT)
       lnx = log(x); ln1mx = log(one - x)
       pgq   = (one + (one-x)**2)/x
       pgqmx = -(one + (one+x)**2)/x
       S2x   = sf_S2(x)
       res = CF*Tf*(-((2.2222222222222223_dp + (4*ln1mx)/3._dp)*pgq) - (4&
           & *x)/3._dp) + CF**2*(-2.5_dp - (3*ln1mx + ln1mx**2)*pgq - lnx&
           & **2*(1 - x/2._dp) - (7*x)/2._dp - 2*ln1mx*x + lnx*(2 + (7*x)&
           & /2._dp)) + CA*CF*(3.111111111111111_dp + pgq*(0.5_dp + (11&
           & *ln1mx)/3._dp + ln1mx**2 - 2*ln1mx*lnx + lnx**2/2._dp - Pi**2&
           & /6._dp) + pgqmx*S2x + (65*x)/18._dp + 2*ln1mx*x + (44*x**2)&
           & /9._dp + lnx**2*(4 + x) - lnx*(12 + 5*x + (8*x**2)/3._dp))
    end select
    select case(cc_piece)
    case(cc_VIRT,cc_REALVIRT)
       res = res + zero
    case(cc_DELTA)
       res = zero
    end select

    if (cc_piece /= cc_DELTA) res = res * x
  end function sf_P1gq


  !======================================================================
  ! Alternative versions of the splitting functions, more similar
  ! to what is in the ESW book
  ! and some things for checking sum rules more easily
  function sf_P1qqBryan(y) result(res)
    real(dp), intent(in) :: y
    real(dp)             :: res
    res = sf_P1qqV(y) + sf_P1qqbarV(y) + two*nf * sf_P1qqS(y)
    !res = sf_P1qqBryanTyped(y)
  end function sf_P1qqBryan
  function sf_P1qgBryan(y) result(res)
    real(dp), intent(in) :: y
    real(dp)             :: res
    res = two*nf * sf_P1qg(y)
  end function sf_P1qgBryan
  function sf_P1minus(y) result(res)
    real(dp), intent(in) :: y
    real(dp)             :: res
    res = sf_P1qqV(y) - sf_P1qqbarV(y)
  end function sf_P1minus
  function sf_P1fromq(y) result(res)
    real(dp), intent(in) :: y
    real(dp)             :: res
    res = sf_P1qqBryan(y) + sf_P1gq(y)
  end function sf_P1fromq
  function sf_P1fromg(y) result(res)
    real(dp), intent(in) :: y
    real(dp)             :: res
    res = sf_P1gg(y) + sf_P1qgBryan(y)
  end function sf_P1fromg


  !----------------------------------------------------------------------
  ! Following was useful for debugging purposes...
  function sf_P1qqBryanTyped(y) result(res)
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x
    real(dp) :: lnx, ln1mx, pqq, pqqmx, S2x
    x = exp(-y)
    res = zero

    select case(cc_piece)
    case(cc_REAL,cc_REALVIRT)
       lnx = log(x); ln1mx = log(one - x)
       pqq = two/(one-x) - one - x
       pqqmx = two/(one+x) - one + x
       S2x = sf_S2(x)
       res = CA*CF*((3.7222222222222223_dp + (11*lnx)/6._dp + lnx**2/2._dp&
            & - Pi**2/6._dp)*pqq - pqqmx*S2x + (14*(1 - x))/3._dp) +&
            &  CF**2*(-1 - ((3*lnx)/2._dp + 2*ln1mx*lnx)*pqq + 2*pqqmx*S2x + &
            &     lnx*(0.5_dp - (3*x)/2._dp) + x - (lnx**2*(1 + x))/2._dp) +&
            & CF*Tf*(-5.333333333333333_dp - &
            &     (1.1111111111111112_dp + (2*lnx)/3._dp)*pqq + 40/(9._dp*x) +&
            &     (40*x)/3._dp - (112*x**2)/9._dp - 2*lnx**2*(1 + x) +&
            &     lnx*(2 + 10*x + (16*x**2)/3._dp))

    end select
    select case(cc_piece)
    case(cc_VIRT,cc_REALVIRT)
       pqq = -two/(1-x)
       res = res + CA*CF*(3.7222222222222223_dp - Pi**2/6._dp)*pqq - (10*CF&
           & *pqq*Tf)/9._dp
    case(cc_DELTA)
       res = -(CF*(0.16666666666666666_dp + (2*Pi**2)/9._dp)*Tf) + CA&
           & *CF*(0.7083333333333334_dp + (11*Pi**2)/18._dp - 3*zeta3) +&
           & CF**2*(0.375_dp - Pi**2/2._dp + 6*zeta3)
    end select

    if (cc_piece /= cc_DELTA) res = res * x
    
  end function sf_P1qqBryanTyped

  !======================================================================
  ! P_NS(x)_timelike = P_NS(x)_timelike + (as/2pi)^2 Delta, where the
  ! following function returns Delta.
  !
  ! Typed in from Eq.(6.39) of Curci-Furmanski-Petronzio
  function sf_TmSP1qqNS(y) result(res)
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x, omx, lnx, ln1mx

    x = exp(-y)
    res = zero
    select case(cc_piece)
    case(cc_REAL,cc_REALVIRT)
      omx = one - x
      lnx = log(x); ln1mx = log(omx)
      res = CF**2*( 4.0_dp*(one + x**2)/omx * lnx * ln1mx &
                  + (6.0_dp/omx - 5.0_dp - x)*lnx &
                  + (one+x - two*(1+x**2)/omx)*lnx**2 &
                  )
    end select
    select case(cc_piece)
    case(cc_VIRT,cc_REALVIRT)
       res = res - zero
    case(cc_DELTA)
       res = zero
    end select

    if (cc_piece /= cc_DELTA) res = res * x
  end function sf_TmSP1qqNS

  !======================================================================
  ! The timeline singlet qq splitting function, typed in from ESW 6.16
  ! (with divergences & delta functions taken from the spacelike qqV).
  ! REAL tested against apfel::P1Tnsp+apfel::P1Tps
  function sf_TP1qq(y) result(res)
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x
    real(dp) :: lnx, ln1mx, pqq,pqqmx, S2x
    x = exp(-y)
    res = zero

    select case(cc_piece)
    case(cc_REAL,cc_REALVIRT)
       lnx = log(x); ln1mx = log(one - x)
       pqq   = two/(one-x) - one - x
       pqqmx = two/(one+x) - one + x
       S2x   = sf_S2(x)      
       res=     CF**2 * (-one + x + half*(x-3)*lnx + half*(1+x)*lnx**2&
            &            + (3/2._dp*lnx - 2*lnx**2 + 2*lnx*ln1mx)*pqq&
            &            + 2 * pqqmx * S2x)&
            & + CF*CA * (14/3._dp*(1-x) + &
            &           (11/6._dp*lnx + half*lnx**2 + 67/18._dp-pisq/6._dp)*pqq&
            &            - pqqmx * S2x)&
            & + CF*Tf * ((-52 + 28*x)/3._dp - (10 + 18*x + 16/3._dp*x**2)*lnx&
            &            + 112/9._dp*x**2 - 40/(9*x) + two*(1+x)*lnx**2 &
            &            - (10/9._dp + 2/3._dp*lnx)*pqq)
    end select
    select case(cc_piece)
    case(cc_VIRT,cc_REALVIRT)
       pqq = -two/(1-x)
       res = res + CA*CF*(3.7222222222222223_dp - Pi**2/6._dp)*pqq - (10*CF&
           & *pqq*Tf)/9._dp
    case(cc_DELTA)
       res = -(CF*(0.16666666666666666_dp + (2*Pi**2)/9._dp)*Tf) + CA&
           & *CF*(0.7083333333333334_dp + (11*Pi**2)/18._dp - 3*zeta3) +&
           & CF**2*(0.375_dp - Pi**2/2._dp + 6*zeta3)
    end select

    if (cc_piece /= cc_DELTA) res = res * x
    
  end function sf_TP1qq
  
  !----------------------------------------------------------------------
  ! typed in from Eq. 6.19 of ESW, together with their statement about
  ! endpoint contributions being equal to those for the space-like case
  ! "Real" part tested against apfel::P1Tgg (Regular+Singular)
  function sf_TP1gg(y) result(res)
   real(dp), intent(in) :: y
   real(dp)             :: res
   real(dp)             :: x
   real(dp) :: lnx, ln1mx, pgg, S2x, pggmx
   x = exp(-y)
   res = zero

   select case(cc_piece)
   case(cc_REAL,cc_REALVIRT)
      lnx = log(x); ln1mx = log(one - x)
      pgg   = (one/(one-x) + one/x -two + x*(one-x))
      pggmx = (one/(one+x) - one/x -two - x*(one+x))
      S2x   = sf_S2(x)
      res =   CF*Tf*(-4 + 12*x  -164/9.0_dp*x**2 &
           &         + (10 + 14*x +  16/3._dp*x**2 + 16/(3*x))*lnx&
           &         + 92/(9*x) + 2*(1+x)*lnx**2)&
           &+ CA*Tf*(2*(1-x) + 26/9._dp*(x**2-1/x) &
           &         - 4/3._dp*(1+x)*lnx&
           &         - (20/9._dp + 8/3._dp * lnx) * pgg&
           &         )&
           &+ CA**2*(  27*(1-x)/2 + 67/9.0_dp*(x**2-1/x)&
           &         + (11/3._dp - 25/3._dp*x - 44/(3*x))*lnx&
           &         - 4*(1+x)*lnx**2 + 2*pggmx*S2x &
           &         + (4*lnx*ln1mx - 3*lnx**2 + 22/3._dp*lnx - pisq/3._dp + 67/9._dp)*pgg)
   end select
   select case(cc_piece)
   case(cc_VIRT,cc_REALVIRT)
      pgg = -one/(1-x)
      res = res + CA**2*pgg*(7.444444444444445_dp - Pi**2/3._dp) - (20*CA&
          & *pgg*Tf)/9._dp
   case(cc_DELTA)
      res = (-4*CA*Tf)/3._dp - CF*Tf + CA**2*(2.6666666666666665_dp&
          & + 3*zeta3)
   end select

   if (cc_piece /= cc_DELTA) res = res * x
   
  end function sf_TP1gg

  !----------------------------------------------------------------------
  ! typed in from Eq.(6.18) of ESW; no singular contributions;
  ! 2*nf*sf_TP1gq(y) tested as coinciding with apfel::P1Tqg(nf)/4;
  function sf_TP1gq(y) result(res)
    use special_functions    
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x
    real(dp) :: lnx, ln1mx, pgq, pgqmx, S1x, S2x
    x = exp(-y)
    res = zero

    select case(cc_piece)
    case(cc_REAL,cc_REALVIRT)
       lnx = log(x); ln1mx = log(one - x)
       pgq   = (one + (one-x)**2)/x
       pgqmx = -(one + (one+x)**2)/x
       S1x   = -ddilog(1-x)
       S2x   = sf_S2(x)
       res =    CF**2 * (-half + 9*half*x + (-8+half*x)*lnx&
            &            + 2*x*ln1mx + (1-half*x)*lnx**2 &
            &            + (ln1mx**2 + 4*lnx*ln1mx - 8*S1x - 4*pisq/3)*pgq&
            &           )&
            & + CF*CA * (62/9._dp - 35*x/18 - 44*x**2/9&
            &            + (2 + 12*x + 8*x**2/3) * lnx&
            &            - 2*x*ln1mx - (4+x)*lnx**2 + pgqmx*S2x&
            &            + (-2*lnx*ln1mx - 3*lnx - 3*half*lnx**2 - ln1mx**2&
            &               +8*S1x + 7*pisq/6 + 17/18._dp) * pgq)
    end select
    select case(cc_piece)
    case(cc_VIRT,cc_REALVIRT)
       res = res + zero
    case(cc_DELTA)
       res = zero
    end select

    if (cc_piece /= cc_DELTA) res = res * x
  end function sf_TP1gq

  
  !----------------------------------------------------------------------
  ! typed in from 6.17 of ESW
  ! agrees with 2*nf*apfel::P1Tgq (divided by 4, for different alphas convention)
  ! (note also different 2nf convention and qg/gq labeling)
  function sf_TP1qg(y) result(res)
    use special_functions
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x
    real(dp) :: lnx, ln1mx, pqg, pqgmx, S1x, S2x
    x = exp(-y)
    res = zero

    select case(cc_piece)
    case(cc_REAL,cc_REALVIRT)
       lnx = log(x); ln1mx = log(one - x)
       pqg   = x**2 + (one-x)**2
       pqgmx = x**2 + (one+x)**2
       S1x   = -ddilog(1-x)
       S2x   = sf_S2(x)
       res =   Tf**2 * (-8/3._dp - (16/9._dp + 8/3._dp*(lnx+ln1mx))*pqg)&
            &  + &
            &  CF*Tf * (-2 + 3*x + (-7+8*x)*lnx - 4*ln1mx&
            &           + (1-2*x)*lnx**2 &
            &           + (-2*(lnx+ln1mx)**2 - 2*(ln1mx-lnx) + 16*S1x + 2*pisq - 10)*pqg)&
            &  + &
            &  CA*Tf * (-152/9._dp + 166/9._dp * x - 40/(9*x) &
            &           + (-4/3._dp -76/3._dp*x)*lnx &
            &           + 4*ln1mx + (2 + 8*x)*lnx**2&
            &           + (8*lnx*ln1mx - lnx**2 - 4/3._dp*lnx + 10/3._dp * ln1mx&
            &              + 2*ln1mx**2 - 16*S1x - 7*pisq/3._dp + 178/9._dp)*pqg&
            &           + 2*pqgmx*S2x)
      !!  CF*(half*TR)*(4 + 4*ln1mx + (10 - 4*(ln1mx - lnx) + 2*(-ln1mx&
      !!       & + lnx)& 
      !!      & **2 - (2*Pi**2)/3._dp)* pqg - lnx*(1 - 4*x) - lnx**2*(1 - 2&
      !!      & *x) - 9*x) + CA*(half*TR)*(20.22222222222222_dp - 4*ln1mx + (&
      !!      & -24.22222222222222_dp + 4*ln1mx - 2*ln1mx**2 + (44*lnx)/3._dp&
      !!      & - lnx**2 + Pi**2/3._dp)*pqg + 2*pqgmx*S2x + 40/(9._dp*x) +&
      !!      & (14*x)/9._dp - lnx**2*(2 + 8*x) + lnx*(-12.666666666666666_dp&
      !!      & + (136*x)/3._dp))
    end select
    select case(cc_piece)
    case(cc_VIRT,cc_REALVIRT)
       res = res + zero
    case(cc_DELTA)
       res = zero
    end select

    if (cc_piece /= cc_DELTA) res = res * x
  end function sf_TP1qg


  
  !======================================================================
  ! helper...
  function sf_S2(x) result(S2)
    use special_functions
    real(dp), intent(in) :: x
    real(dp)             :: S2, lnx
    lnx = log(x)
    S2 = -two*ddilog(-x) + half * lnx**2 - two*lnx*log(one+x) - pi**2&
         & /6.0_dp 
  end function sf_S2

  
  !======================================================================
  ! What follows is stuff for VFNS at order(as^2)
  ! It has been hacked in one way or another from the code provided
  ! by W.L. van Neerven (~/src/HEP/vannerven-vfns.f), and appropriate 
  ! citations are
  ! 
  !   M. Buza, Y. Matiounine, J. Smith, R. Migneron, W.L. van Neerven, 
  !   Nucl. Phys. B472 (1996) 611, hep-ph/9601302.
  !   M. Buza, Y. Matiounine, J. Smith, W.L. van Neerven,
  !   Eur. Phys. J. C1 (1998) 301. 
  !
  ! Pieces that are going to be needed for my purposes are those from that
  ! code which are free of logs of mu^2/m^2, since we will for the time being
  ! keep these two scales equal (and later on, if we do not then pieces
  ! with logs will be reconstructed appropriately?)
  !
  ! Thus the pieces needed, in the notation of the second of the above 
  ! papers, are:
  !
  ! For Delta (f_k + f_kbar):
  !   A^{2,NS}_{qq,H}    CODED
  !   A^{2,PS}_{qq,H}    <-- this is zero at O(as^2)
  !   A^{2,S}_{qg,H}     <-- this is zero at O(as^2)
  !
  ! For Delta (f_H + f_Hbar)
  !   A^{2,PS}_{Hq}      CODED
  !   A^{2,S}_{Hg}       CODED
  !
  ! For Delta (G)
  !   A^{2,S}_{gq,H}     CODED
  !   A^{2,S}_{gg,H}     CODED
  !
  ! NB: currently using cernlib version of WGPLG. This should be hacked
  !     out of CERNLIB and inserted explicitly into special functions.
  !----------------------------------------------------------------------

  !----------------------------------------------------------------------
  ! This one hacked out of vanneerven-vfns.f90
  function sf_A2Sgq_H(y) result(res)
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: z
    real(dp) :: ln1mz
    z = exp(-y)
    res = zero

    select case(cc_piece)
    case(cc_REAL,cc_REALVIRT)
       ln1mz = log(one - z)
       res = (four*(two/z-two+z)*ln1mz**2/3.0_dp+8.0_dp*(10.0_dp/z &
            &-10.0_dp+8.0_dp*z)*ln1mz/9.0_dp+(448.0_dp/z-448.0_dp+344.0_dp*z)&
            &/27.0_dp)*cf*tr
    end select
    select case(cc_piece)
    case(cc_VIRT,cc_REALVIRT)
       res = res + zero
    case(cc_DELTA)
       res = zero
    end select

    if (cc_piece /= cc_DELTA) res = res * z
    !-- recall that above results are for (as/4pi)^2, whereas
    !   we actually use (as/2pi)^2
    res = res * 0.25_dp
  end function sf_A2Sgq_H

  !-----------------------------------------------------------------
  ! This one typed in by hand from article
  function sf_A2Sgg_H(y) result(res)
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: z
    real(dp) :: lnz, lnz2, lnz3,ln1mz
    z = exp(-y)
    res = zero

    select case(cc_piece)
    case(cc_REAL,cc_REALVIRT)
       lnz = log(z); lnz2 = lnz*lnz; lnz3 = lnz2*lnz
       ln1mz = log(one - z)
       res = CF*TR*(four_thirds*(1+z)*lnz3+(6+10*z)*lnz2+(32+48*z)*lnz&
            &-8/z+80-48*z-24*z**2) + &
            &CA*TR*((four_thirds*(1+z)*lnz2+(52+88*z)*lnz/9.0_dp&
            &       -four_thirds*z*ln1mz)&
            &     + (224/(1-z)+556/z-628+548*z-700*z**2)/27.0_dp )
    end select
    select case(cc_piece)
    case(cc_VIRT,cc_REALVIRT)
       res = res - CA*TR*224.0_dp/(27.0_dp*(1-z))
    case(cc_DELTA)
       res = -15*CF*TR + CA*TR*10.0_dp/9.0_dp
    end select

    if (cc_piece /= cc_DELTA) res = res * z
    !-- recall that above results are for (as/4pi)^2, whereas
    !   we actually use (as/2pi)^2
    res = res * 0.25_dp
  end function sf_A2Sgg_H


  !-----------------------------------------------------------------
  ! This one partially hacked out of vanneerven-vfns.f90
  function sf_A2NSqq_H(y) result(res)
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: z
    real(dp) :: lnz, lnz2, ln1mz
    z = exp(-y)
    res = zero

    select case(cc_piece)
    case(cc_REAL,cc_REALVIRT)
       lnz = log(z); lnz2 = lnz*lnz
       ln1mz = log(one - z)
       res = ((one+Z*Z)*(2.0D0*lnz2/3.0D0+20.0D0*lnz/9.0D0)&
            &/(one-Z)+8.0D0*(one-Z)*lnz/3.0D0+44.0D0/27.0D0 &
            &-268.0D0*Z/27.0D0 + 224.0_dp/(27.0_dp*(1-z)) )*CF*TR
    end select
    select case(cc_piece)
    case(cc_VIRT,cc_REALVIRT)
       res = res - (224.0_dp/(27.0_dp*(1-z)) )*CF*TR
    case(cc_DELTA)
       res = CF*TR*(-8*zeta3/3.0_dp + 40.0_dp*zeta2/9.0_dp+73.0_dp/18.0_dp)
    end select

    if (cc_piece /= cc_DELTA) res = res * z
    !-- recall that above results are for (as/4pi)^2, whereas
    !   we actually use (as/2pi)^2
    res = res * 0.25_dp
  end function sf_A2NSqq_H


  !-----------------------------------------------------------------
  ! This one largely hacked out of vanneerven-vfns.f90
  function sf_A2PShg(y) result(res)
    use special_functions
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: z
    real(dp) :: lnz, lnz2, lnz3, ln1mz, ln1mz2, ln1mz3
    real(dp) :: ln1pz, ln1pz2
    real(dp) :: S121MZ, S12MZ,S211MZ,S21MZ,S111MZ,S11MZ
    real(dp) :: A01, A02, B01, B02
    !complex(dp) :: WGPLG
    z = exp(-y)
    res = zero

    select case(cc_piece)
    case(cc_REAL,cc_REALVIRT)
       ! these will need to be sorted out properly
       S121MZ=WGPLG(1,2,1.0D0-Z) 
       S12MZ=WGPLG(1,2,-Z) 
       S211MZ=WGPLG(2,1,1.0D0-Z) 
       S21MZ=WGPLG(2,1,-Z) 
       S111MZ=WGPLG(1,1,1.0D0-Z) 
       S11MZ=WGPLG(1,1,-Z) 

       lnz = log(z); lnz2 = lnz*lnz; lnz3 = lnz2*lnz
       ln1mz = log(one - z)
       ln1mz2=ln1mz*ln1mz 
       ln1mz3=ln1mz2*ln1mz 
       ln1pz=log(1.0d0+z) 
       ln1pz2=ln1pz*ln1pz 

       ! C_F.T_r  PART                                                        
       A01=(1-2._dp*z+2._dp*z*z)*(8._dp*zeta3+4._dp*ln1mz3/3._dp &
            &-8._dp*ln1mz*s111mz+8._dp*zeta2*lnz-4._dp*lnz*ln1mz2+2._dp*lnz3 &
            &/3._dp-8._dp*lnz*s111mz+8._dp*s211mz-24._dp*s121mz)               
       A02=-(4._dp+96._dp*z-64._dp*z*z)*s111mz-(4._dp-48._dp*z &
            &+40._dp*z*z)*zeta2-(8._dp+48._dp*z-24._dp*z*z)*lnz*ln1mz &
            &+(4._dp+8._dp*z-12._dp*z*z)*ln1mz2-(1._dp+12._dp*z-20._dp*z*z) &
            &*lnz2-(52._dp*z-48._dp*z*z)*ln1mz-(16._dp+18._dp*z+48._dp*z*z) &
            &*lnz+26._dp-82._dp*z+80._dp*z*z+z*z*(-16._dp*zeta2*lnz &
            &+4._dp*lnz3/3._dp+ 16._dp*lnz*s111mz+ 32._dp*s121mz)              

       ! c_a.t_r  part                                                        
       B01=(1._dp-2._dp*z+2._dp*z*z)*(-4._dp*ln1mz3/3._dp+8._dp*ln1mz &
            &*s111mz-8._dp*s211mz)+(1._dp+2._dp*z+2._dp*z*z)*(-8._dp*zeta2 &
            &*ln1pz-16._dp*ln1pz*s11mz-8._dp*lnz*ln1pz2+&
            &4._dp*lnz2*ln1pz+8._dp*lnz &
            &*s11mz-8._dp*s21mz-16._dp*s12mz)+(16._dp+64._dp*z)*(2._dp*s121mz &
            &+lnz*s111mz)-(4._dp+8._dp*z)*lnz3/3._dp+(8._dp-32._dp*z &
            &+16._dp*z*z)*zeta3-(16._dp+64._dp*z)*zeta2*lnz                    
       B02=(16._dp*z+16._dp*z*z)*(s11mz+lnz*ln1pz)+(32._dp/z/3._dp+12._dp &
            &+64._dp*z-272._dp*z*z/3._dp)*s111mz-(12._dp+48._dp*z &
            &-260._dp*z*z/3._dp+32._dp/z/3._dp)*zeta2-4._dp*z*z*lnz*ln1mz &
            &-(2._dp+8._dp*z-10._dp*z*z)*ln1mz2+&
            &(2._dp+8._dp*z+46._dp*z*z/3._dp)&
            &*lnz2+(4._dp+16._dp*z-16._dp*z*z)*ln1mz-(56._dp/3._dp+172._dp*z &
            &/3._dp+1600._dp*z*z/9._dp)*lnz-448._dp/z/27._dp-4._dp/3._dp &
            &-628._dp*z/3._dp+6352._dp*z*z/27._dp                              

       res = TR*(CF*(A01+A02) + CA*(B01+B02))
    end select
    select case(cc_piece)
    case(cc_VIRT,cc_REALVIRT)
       res = res 
    case(cc_DELTA)
       res = zero
    end select

    if (cc_piece /= cc_DELTA) res = res * z
    !-- recall that above results are for (as/4pi)^2, whereas
    !   we actually use (as/2pi)^2
    res = res * 0.25_dp
  end function sf_A2PShg

  !-----------------------------------------------------------------
  ! This one will use Vogts parameterisation
  function sf_A2PShg_vogt(y) result(res)
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: z
    real(dp) :: A2HGA, A2HGC
    z = exp(-y)
    res = zero

    select case(cc_piece)
    case(cc_REAL,cc_REALVIRT)
       res = A2HGA(z)
    end select
    select case(cc_piece)
    case(cc_VIRT,cc_REALVIRT)
       res = res 
    case(cc_DELTA)
       res = A2HGC(zero)
    end select

    if (cc_piece /= cc_DELTA) res = res * z
    !-- recall that above results are for (as/4pi)^2, whereas
    !   we actually use (as/2pi)^2
    res = res * 0.25_dp
  end function sf_A2PShg_vogt


  !-----------------------------------------------------------------
  ! This one largely hacked out of vanneerven-vfns.f90
  function sf_A2PShq(y) result(res)
    use special_functions
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: z
    real(dp) :: lnz, lnz2, lnz3
    real(dp) :: S121MZ, S111MZ
    real(dp) :: A0
    !complex(dp) :: WGPLG
    z = exp(-y)
    res = zero

    select case(cc_piece)
    case(cc_REAL,cc_REALVIRT)
       ! these will need to be sorted out properly
       S121MZ=WGPLG(1,2,1.0D0-Z) 
       S111MZ=WGPLG(1,1,1.0D0-Z) 

       lnz = log(z); lnz2 = lnz*lnz; lnz3 = lnz2*lnz

       ! C_F.T_r  PART                                                        
       A0=(1._dp+Z)*(32._dp*S121MZ+16._dp*lnz*S111MZ-16._dp*ZETA2 &
            &*lnz-4._dp*lnz3/3._dp)+(32._dp/Z/3._dp+8._dp-8._dp*Z-32._dp &
            &*Z*Z/3._dp)*S111MZ+(-32._dp/Z/3._dp-8._dp+8._dp*Z &
            &+32._dp*Z*Z/3._dp)*ZETA2+(2._dp+10._dp*Z+16._dp*Z*Z/3._dp) &
            &*lnz2-(56._dp/3._dp+88._dp*Z/3._dp+448._dp*Z*Z/9._dp)*lnz &
            &-448._dp/Z/27._dp-4._dp/3._dp-124._dp*Z/3._dp+1600._dp*Z*Z &
            &/27._dp                                                           

       res = TR*CF*A0
    end select
    select case(cc_piece)
    case(cc_VIRT,cc_REALVIRT)
       res = res 
    case(cc_DELTA)
       res = zero
    end select

    if (cc_piece /= cc_DELTA) res = res * z
    !-- recall that above results are for (as/4pi)^2, whereas
    !   we actually use (as/2pi)^2
    res = res * 0.25_dp
  end function sf_A2PShq  

  !======================================================================
  ! polarized splitting functions...
  !======================================================================
  ! LO: from ESW.
  ! Original reference: Altarelli & Parisi NPB126 (1977) 298
  !----------------------------------------------------------------------
  function sf_DPgg(y) result(res)
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x
    x = exp(-y)
    res = zero

    select case(cc_piece)
    case(cc_REAL,cc_REALVIRT)
       res = ca*(two/(one-x)  - four*x + two)
    end select
    select case(cc_piece)
    case(cc_VIRT,cc_REALVIRT)
       res = res - two*ca/(one-x)
    case(cc_DELTA)
       res = (11.0_dp*ca - four*nf*tr)/6.0_dp
    end select

    if (cc_piece /= cc_DELTA) res = res * x
  end function sf_DPgg

  !----------------------------------------------------------------------
  function sf_DPqq(y) result(res)
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x
    x = exp(-y)
    res = zero

    select case(cc_piece)
    case(cc_REAL,cc_REALVIRT)
       res = cf*(two/(1-x) - 1 - x)
    end select
    select case(cc_piece)
    case(cc_VIRT,cc_REALVIRT)
       res = res - cf*two/(one-x)
    case(cc_DELTA)
       res = cf*three*half
    end select

    if (cc_piece /= cc_DELTA) res = res * x
  end function sf_DPqq

  !----------------------------------------------------------------------
  function sf_DPgq(y) result(res)
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x
    x = exp(-y)
    res = zero

    select case(cc_piece)
    case(cc_REAL,cc_REALVIRT)
       res = cf*(two-x)
    end select
    select case(cc_piece)
    case(cc_VIRT,cc_REALVIRT)
       res = res - zero
    case(cc_DELTA)
       res = zero
    end select

    if (cc_piece /= cc_DELTA) res = res * x
  end function sf_DPgq

  !----------------------------------------------------------------------
  function sf_DPqg(y) result(res)
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x
    x = exp(-y)
    res = zero

    select case(cc_piece)
    case(cc_REAL,cc_REALVIRT)
       res = tr*(two*x - one)
    end select
    select case(cc_piece)
    case(cc_VIRT,cc_REALVIRT)
       res = res - zero
    case(cc_DELTA)
       res = zero
    end select

    if (cc_piece /= cc_DELTA) res = res * x
  end function sf_DPqg

  !======================================================================
  ! NLO spin-dependent splitting functions

  ! THE CALCULATION OF THE TWO LOOP SPIN SPLITTING FUNCTIONS P(IJ)(1)(X).
  ! By R. Mertig (NIKHEF, Amsterdam), W.L. van Neerven (Leiden U.),. 
  ! INLO-PUB-6-95, NIKHEF-H-95-031, Jun 1995. 33pp.
  ! Published in Z.Phys.C70:637-654,1996
  ! e-Print Archive: hep-ph/9506451

  ! The spin dependent two loop splitting functions
  ! W. Vogelsang (Rutherford),. RAL-TR-96-020, Mar 1996. 25pp.
  ! Published in Nucl.Phys.B475:47-72,1996
  ! e-Print Archive: hep-ph/9603366

  ! Will use the Vogelsang paper for input. His convention coincides
  ! with the one used above with regards to alphas/two and derivative
  ! wrt ln Q^2. However it differs in use of nf factors. Will stay
  ! consistent with the unpolarized case (i.e. not include 2nf factors).
  !
  ! Tests carried out (NLL): comparison to omega=0 (N=1) momenta, eqs.54. 
  ! All work out (after fixing a line in wrong place), though since Pqg->0
  ! one cannot check normalisation of this one...
  !
  ! He also provides coefficient functions, should one 
  ! wish to implement them...

  !--------------------------------------------------
  ! identical to P1qqV
  function sf_DP1qqV(y) result(res)
    real(dp), intent(in) :: y
    real(dp)             :: res
    res = sf_P1qqV(y)
  end function sf_DP1qqV

  !--------------------------------------------------
  ! identical to -P1qqbarV
  function sf_DP1qqbarV(y) result(res)
    real(dp), intent(in) :: y
    real(dp)             :: res
    res = -sf_P1qqbarV(y)
  end function sf_DP1qqbarV
  
  !----------------------------------------------------------------------
  ! REMEMBER: 2nf factor NOT included!
  function sf_DP1qqS(y) result(res)
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x
    real(dp) :: lnx
    x = exp(-y)
    res = zero
    select case(cc_piece)
    case(cc_REAL,cc_REALVIRT)
       lnx = -y
       res = two*CF*TR*((1-x) - (1-3*x)*lnx - (1+x)*lnx**2)
    end select
    select case(cc_piece)
    case(cc_VIRT,cc_REALVIRT)
    case(cc_DELTA)
       res = zero
    end select
    res = res * half ! Tf->TR accounts for nf; this accounts for 2

    if (cc_piece /= cc_DELTA) res = res * x
  end function sf_DP1qqS
  
  !----------------------------------------------------------------------
  ! REMEMBER: 2nf factor NOT included!
  function sf_DP1qg(y) result(res)
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x
    real(dp) :: lnx, ln1mx, dpqg, dpqgmx, S2x
    x = exp(-y)
    res = zero

    select case(cc_piece)
    case(cc_REAL,cc_REALVIRT)
       lnx = -y; ln1mx = log(one - x)
       dpqg   =  two*x - one
       dpqgmx = -two*x - one
       S2x   = sf_S2(x)
       res = CF*TR*(-22 + 27*x - 9*lnx + 8*(1-x)*ln1mx&
         &         + dpqg*(2*ln1mx**2 - 4*ln1mx*lnx &
         &                + lnx**2 - two/three*pisq))&
         & + CA*TR*((24-22*x) - 8*(1-x)*ln1mx + (2+16*x)*lnx  &
         &         - 2*(ln1mx**2-pisq/6.0_dp)*dpqg &
         &         - (2*S2x - 3*lnx**2) * dpqgmx)
    end select
    select case(cc_piece)
    case(cc_VIRT,cc_REALVIRT)
       res = res + zero
    case(cc_DELTA)
       res = zero
    end select
    res = res * half ! Tf->TR accounts for nf; this accounts for 2

    if (cc_piece /= cc_DELTA) res = res * x
  end function sf_DP1qg


  !----------------------------------------------------------------------
  function sf_DP1gq(y) result(res)
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x
    real(dp) :: lnx, ln1mx, dpgq, dpgqmx,S2x
    x = exp(-y)
    res = zero

    select case(cc_piece)
    case(cc_REAL,cc_REALVIRT)
       lnx = -y; ln1mx = log(one - x)
       dpgq   = 2 - x
       dpgqmx = 2 + x
       S2x   = sf_S2(x)
       res =   CF*Tf*(-four/9.0_dp*(x+4) - four/three*dpgq*ln1mx)&
            &+ CF**2*(-half - half*(4-x)*lnx - dpgqmx*ln1mx&
            &        + (-4 - ln1mx**2 + half*lnx**2)*dpgq)&
            &+ CF*CA*((4-13*x)*lnx + (10+x)*ln1mx/three + (41+35*x)/9.0_dp&
            &        + half*(-2*S2x + 3*lnx**2)*dpgqmx &
            &        + (ln1mx**2 - 2*ln1mx*lnx - pisq/6.0_dp)*dpgq)
    end select
    select case(cc_piece)
    case(cc_VIRT,cc_REALVIRT)
       res = res + zero
    case(cc_DELTA)
       res = zero
    end select

    if (cc_piece /= cc_DELTA) res = res * x
  end function sf_DP1gq


  !----------------------------------------------------------------------
  ! Vogelsang says (p.10) that delta-function parts are just those
  ! of 
  function sf_DP1gg(y) result(res)
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x
    real(dp) :: lnx, ln1mx, S2x, dpgg, dpggmx
    x = exp(-y)
    res = zero

    select case(cc_piece)
    case(cc_REAL,cc_REALVIRT)
       lnx = -y; ln1mx = log(one - x)
       dpgg   = one/(1-x) - 2*x + 1
       dpggmx = one/(1+x) + 2*x + 1
       S2x   = sf_S2(x)
       res = -CA*Tf*(4*(1-x) + four/three*(1+x)*lnx + 20.0_dp/9.0_dp*dpgg)&
            &-CF*Tf*(10*(1-x) + 2*(5-x)*lnx + 2*(1+x)*lnx**2)&
            &+CA**2*((29-67*x)*lnx/three - 9.5_dp*(1-x) + 4*(1+x)*lnx**2&
            &       - 2*S2x*dpggmx  + (67.0_dp/9.0_dp - 4*ln1mx*lnx &
            &                          + lnx**2 - Pi**2/3._dp)*dpgg)
    end select
    select case(cc_piece)
    case(cc_VIRT,cc_REALVIRT)
       dpgg = -one/(1-x)
       res = res + CA**2*dpgg*(67.0_dp/9.0_dp - Pi**2/3._dp) - (20*CA&
           & *dpgg*Tf)/9._dp
    case(cc_DELTA)
       res = (-4*CA*Tf)/3._dp - CF*Tf + CA**2*(8.0_dp/three&
           & + 3*zeta3)
    end select

    if (cc_piece /= cc_DELTA) res = res * x
    
  end function sf_DP1gg

end module splitting_functions

!======================================================================
! This file contains the 4-loop splitting functions as computed by
! Vogt et al. Currently (Jan 2024) only the "guessed" versions are
! available but we keep both the exact and the parametrised versions
! here to enable their implementation later on (although for now they
! return an error). The references for the guessed splitting functions
! are given in 2302.07593, 2307.04158, and 2310.05744.
!
! The non-singlet splitting functions are taken from 1707.08315, with
! some pieces exact, some parametrised and some guessed.

!======================================================================
! interface to exact 3-loop splitting functions, as programmed by Vogt
! (see xpij2e.f and xpns2e.f for details).
!
! There are several things to remember: 
!    . Vogt y == my x
!    . Vogt is normalised to powers of (as/4pi)^4 
!    . colour-factor dependence IS available (taken from qcd module)
!      but only for CF, CA -- TR is fixed to be 1/2
!    . systematic separation in A,B,C functions needs to be
!      taken into account; C function needs to be called with x=0?x
!    . check inclusion of 2nf in qg piece
! 
!----------------------------------------------------------------------
module splitting_functions_n3lo_e
  use types; use consts_dp; use convolution_communicator
  use qcd; use warnings_and_errors
  use xpij2e; use xpns2e
  use dglap_choices
  implicit none
  private

  public :: sf_P3gg, sf_P3qg2nf, sf_P3PS, sf_P3gq
  public :: sf_P3NSPlus, sf_P3NSMinus, sf_P3NSS
  ! these are of help elsewhere in identifying (run-time) the sets of 
  ! splitting functions that have been used?
  public :: name_xpij2, name_xpns2

contains
  function sf_P3gg(y) result(res)
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x

    call wae_Error('Exact N3LO splitting functions not yet available.')

    call sf_VogtValidate
    x = exp(-y)
    res = zero

!    select case(cc_piece)
!    case(cc_REAL,cc_REALVIRT)
!       res = X2GGA(x, nf_int) + X2GGB(x, nf_int)
!    end select
!    select case(cc_piece)
!    case(cc_VIRT,cc_REALVIRT)
!       res = res - X2GGB(x, nf_int)
!    case(cc_DELTA)
!       res = X2GGC(zero, nf_int)
!    end select

    res = res / 16.0_dp   ! compensate (as/4pi)^4 -> (as/2pi)^4
    if (cc_piece /= cc_DELTA) res = res * x
  end function sf_P3gg

  ! ..This is the (regular) pure-singlet splitting functions P_ps^(2).    
  !    P_qq^(2) is obtained by adding the non-singlet quantity P_NS^(2)+. 
  function sf_P3PS(y) result(res)
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x

    call wae_Error('Exact N3LO splitting functions not yet available.')

    call sf_VogtValidate
    x = exp(-y)
    res = zero

!    select case(cc_piece)
!    case(cc_REAL,cc_REALVIRT)
!       res = X2PSA(x, nf_int) + zero
!    end select
!    select case(cc_piece)
!    case(cc_VIRT,cc_REALVIRT)
!       res = res - zero
!    case(cc_DELTA)
!       res = zero
!    end select

    res = res / 16.0_dp   ! compensate (as/4pi)^4 -> (as/2pi)^4
    if (cc_piece /= cc_DELTA) res = res * x
  end function sf_P3PS

  !--------------------------------------------------------------------
  ! this already includes the factor of 2nf
  function sf_P3qg2nf(y) result(res)
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x

    call wae_Error('Exact N3LO splitting functions not yet available.')

    call sf_VogtValidate
    x = exp(-y)
    res = zero

!    select case(cc_piece)
!    case(cc_REAL,cc_REALVIRT)
!       res = X2QGA(x, nf_int)
!    end select
!    select case(cc_piece)
!    case(cc_VIRT,cc_REALVIRT)
!       res = res - zero
!    case(cc_DELTA)
!       res = zero
!    end select

    res = res / 16.0_dp   ! compensate (as/4pi)^4 -> (as/2pi)^4
    if (cc_piece /= cc_DELTA) res = res * x
  end function sf_P3qg2nf


  function sf_P3gq(y) result(res)
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x

    call wae_Error('Exact N3LO splitting functions not yet available.')

    call sf_VogtValidate
    x = exp(-y)
    res = zero

!    select case(cc_piece)
!    case(cc_REAL,cc_REALVIRT)
!       res = X2GQA(x, nf_int)
!    end select
!    select case(cc_piece)
!    case(cc_VIRT,cc_REALVIRT)
!       res = res - zero
!    case(cc_DELTA)
!       res = zero
!    end select

    res = res / 16.0_dp   ! compensate (as/4pi)^4 -> (as/2pi)^4
    if (cc_piece /= cc_DELTA) res = res * x
  end function sf_P3gq

  !------------------------- non-singlet pieces ------------------------
  function sf_P3NSPlus(y) result(res)
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x

    call wae_Error('Exact N3LO splitting functions not yet available.')

    call sf_VogtValidate
    x = exp(-y)
    res = zero

!    select case(cc_piece)
!    case(cc_REAL,cc_REALVIRT)
!       res = X2NSPA(x, nf_int) + X2NSB(x, nf_int)
!    end select
!    select case(cc_piece)
!    case(cc_VIRT,cc_REALVIRT)
!       res = res - X2NSB(x, nf_int)
!    case(cc_DELTA)
!       res = X2NSC(zero, nf_int)
!    end select

    res = res / 16.0_dp   ! compensate (as/4pi)^4 -> (as/2pi)^4
    if (cc_piece /= cc_DELTA) res = res * x
  end function sf_P3NSPlus


  function sf_P3NSMinus(y) result(res)
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x

    call wae_Error('Exact N3LO splitting functions not yet available.')

    call sf_VogtValidate
    x = exp(-y)
    res = zero

!    select case(cc_piece)
!    case(cc_REAL,cc_REALVIRT)
!       res = X2NSMA(x, nf_int) + X2NSB(x, nf_int)
!    end select
!    select case(cc_piece)
!    case(cc_VIRT,cc_REALVIRT)
!       res = res - X2NSB(x, nf_int)
!    case(cc_DELTA)
!       res = X2NSC(zero, nf_int)
!    end select

    res = res / 16.0_dp   ! compensate (as/4pi)^4 -> (as/2pi)^4
    if (cc_piece /= cc_DELTA) res = res * x
  end function sf_P3NSMinus

  !-- according to comments in Vogt code P_S = P_V - P_-
  function sf_P3NSS(y) result(res)
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x

    call wae_Error('Exact N3LO splitting functions not yet available.')

    call sf_VogtValidate
    x = exp(-y)
    res = zero

!    select case(cc_piece)
!    case(cc_REAL,cc_REALVIRT)
!       res = X2NSSA(x, nf_int)
!    end select
!    select case(cc_piece)
!    case(cc_VIRT,cc_REALVIRT)
!       res = res - zero
!    case(cc_DELTA)
!       res = zero
!    end select

    res = res / 16.0_dp   ! compensate (as/4pi)^4 -> (as/2pi)^4
    if (cc_piece /= cc_DELTA) res = res * x
  end function sf_P3NSS

  !----------------------------------------------------------------
  ! The Vogt expressions are valid only for standard colour factors
  ! This routine makes sure that the appropriate conditions hold
  subroutine sf_VogtValidate
    if (tr == half) return
    call wae_Error('sf_VogtValidate: &
         &colour factors must be set to default values', &
         &'in order to use the Vogt splitting function parameterisations')
  end subroutine sf_VogtValidate

end module splitting_functions_n3lo_e


module splitting_functions_n3lo_p
  use types; use consts_dp; use convolution_communicator
  use qcd; use warnings_and_errors
  use xpij2p; use xpns2p
  implicit none
  private

  public :: sf_P3gg, sf_P3qg2nf, sf_P3PS, sf_P3gq
  public :: sf_P3NSPlus, sf_P3NSMinus, sf_P3NSS
  ! these are of help elsewhere in identifying (run-time) the sets of 
  ! splitting functions that have been used?
  public :: name_xpij2, name_xpns2

contains
  function sf_P3gg(y) result(res)
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x

    call wae_Error('Parametrised N3LO splitting functions not yet available.')

    call sf_VogtValidate
    x = exp(-y)
    res = zero

!    select case(cc_piece)
!    case(cc_REAL,cc_REALVIRT)
!       res = P3GGA(x, nf_int) + P3GGB(x, nf_int)
!    end select
!    select case(cc_piece)
!    case(cc_VIRT,cc_REALVIRT)
!       res = res - P3GGB(x, nf_int)
!    case(cc_DELTA)
!       res = P3GGC(zero, nf_int)
!    end select

    res = res / 16.0_dp   ! compensate (as/4pi)^4 -> (as/2pi)^4
    if (cc_piece /= cc_DELTA) res = res * x
  end function sf_P3gg

  ! ..This is the (regular) pure-singlet splitting functions P_ps^(2).    
  !    P_qq^(2) is obtained by adding the non-singlet quantity P_NS^(2)+. 
  function sf_P3PS(y) result(res)
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x

    call wae_Error('Parametrised N3LO splitting functions not yet available.')

    call sf_VogtValidate
    x = exp(-y)
    res = zero

!    select case(cc_piece)
!    case(cc_REAL,cc_REALVIRT)
!       res = P3PSA(x, nf_int) + zero
!    end select
!    select case(cc_piece)
!    case(cc_VIRT,cc_REALVIRT)
!       res = res - zero
!    case(cc_DELTA)
!       res = zero
!    end select

    res = res / 16.0_dp   ! compensate (as/4pi)^4 -> (as/2pi)^4
    if (cc_piece /= cc_DELTA) res = res * x
  end function sf_P3PS

  !--------------------------------------------------------------------
  ! this already includes the factor of 2nf
  function sf_P3qg2nf(y) result(res)
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x

    call wae_Error('Parametrised N3LO splitting functions not yet available.')

    call sf_VogtValidate
    x = exp(-y)
    res = zero

!    select case(cc_piece)
!    case(cc_REAL,cc_REALVIRT)
!       res = P3QGA(x, nf_int)
!    end select
!    select case(cc_piece)
!    case(cc_VIRT,cc_REALVIRT)
!       res = res - zero
!    case(cc_DELTA)
!       res = zero
!    end select

    res = res / 16.0_dp   ! compensate (as/4pi)^4 -> (as/2pi)^4
    if (cc_piece /= cc_DELTA) res = res * x
  end function sf_P3qg2nf


  function sf_P3gq(y) result(res)
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x

    call wae_Error('Parametrised N3LO splitting functions not yet available.')

    call sf_VogtValidate
    x = exp(-y)
    res = zero

!    select case(cc_piece)
!    case(cc_REAL,cc_REALVIRT)
!       res = P3GQA(x, nf_int)
!    end select
!    select case(cc_piece)
!    case(cc_VIRT,cc_REALVIRT)
!       res = res - zero
!    case(cc_DELTA)
!       res = zero
!    end select

    res = res / 16.0_dp   ! compensate (as/4pi)^4 -> (as/2pi)^4
    if (cc_piece /= cc_DELTA) res = res * x
  end function sf_P3gq

  !------------------------- non-singlet pieces ------------------------
  function sf_P3NSPlus(y) result(res)
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x

    call wae_Error('Parametrised N3LO splitting functions not yet available.')

    call sf_VogtValidate
    x = exp(-y)
    res = zero

!    select case(cc_piece)
!    case(cc_REAL,cc_REALVIRT)
!       res = P3NSPA(x, nf_int) + P3NSB(x, nf_int)
!    end select
!    select case(cc_piece)
!    case(cc_VIRT,cc_REALVIRT)
!       res = res - P3NSB(x, nf_int)
!    case(cc_DELTA)
!       res = P3NSPC(zero, nf_int)
!    end select

    res = res / 16.0_dp   ! compensate (as/4pi)^4 -> (as/2pi)^4
    if (cc_piece /= cc_DELTA) res = res * x
  end function sf_P3NSPlus


  function sf_P3NSMinus(y) result(res)
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x

    call wae_Error('Parametrised N3LO splitting functions not yet available.')

    call sf_VogtValidate
    x = exp(-y)
    res = zero

!    select case(cc_piece)
!    case(cc_REAL,cc_REALVIRT)
!       res = P3NSMA(x, nf_int) + P3NSB(x, nf_int)
!    end select
!    select case(cc_piece)
!    case(cc_VIRT,cc_REALVIRT)
!       res = res - P3NSB(x, nf_int)
!    case(cc_DELTA)
!       res = P3NSMC(zero, nf_int)
!    end select

    res = res / 16.0_dp   ! compensate (as/4pi)^4 -> (as/2pi)^4
    if (cc_piece /= cc_DELTA) res = res * x
  end function sf_P3NSMinus

  !-- according to comments in Vogt code P_S = P_V - P_-
  function sf_P3NSS(y) result(res)
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x

    call wae_Error('Parametrised N3LO splitting functions not yet available.')

!    call sf_VogtValidate
!    x = exp(-y)
!    res = zero
!
!    select case(cc_piece)
!    case(cc_REAL,cc_REALVIRT)
!       res = P3NSSA(x, nf_int)
!    end select
!    select case(cc_piece)
!    case(cc_VIRT,cc_REALVIRT)
!       res = res - zero
!    case(cc_DELTA)
!       res = zero
!    end select

    res = res / 16.0_dp   ! compensate (as/4pi)^4 -> (as/2pi)^4
    if (cc_piece /= cc_DELTA) res = res * x
  end function sf_P3NSS

  !----------------------------------------------------------------
  ! The Vogt expressions are valid only for standard colour factors
  ! This routine makes sure that the appropriate conditions hold
  subroutine sf_VogtValidate
    if (ca == three .and. tr == half .and. cf == four/three) return
    call wae_Error('sf_VogtValidate: &
         &colour factors must be set to default values', &
         &'in order to use the Vogt splitting function parameterisations')
  end subroutine sf_VogtValidate

end module splitting_functions_n3lo_p



!======================================================================
! interface to guessed 4-loop splitting functions, as parameterised by Vogt
! (see xpgg3a.f90 xpgq3a.f90 xpps3a.f90 xpqg3a.f90 for details).
!
! There are several things to remember: 
!    . Vogt y == my x
!    . Vogt is normalised to powers of (as/4pi)^4 
!    . colour-factor dependence is not available
!    . systematic separation in A,B,C functions needs to be
!      taken into account; C function needs to be called with x=0?x
!    . check inclusion of 2nf in qg piece
! 
!----------------------------------------------------------------------
module splitting_functions_n3lo_n
  use types; use consts_dp; use convolution_communicator
  use qcd; use dglap_choices; use warnings_and_errors
  use xpgg3a; use xpgg3a_2410; use xpgq3a; use xpgq3a_2404; use&
       & xpqg3a; use xpps3a; use xpns3s; use xpns3p; use xpns3m
  implicit none
  private

  public :: sf_P3gg, sf_P3qg2nf, sf_P3PS, sf_P3gq
  public :: sf_P3NSPlus, sf_P3NSMinus, sf_P3NSS
  ! these are of help elsewhere in identifying (run-time) the sets of 
  ! splitting functions that have been used?
  public :: name_xpgg3, name_xpgq3, name_xpqg3, name_xpps3,&
       & name_xpns3s, name_xpns3m, name_xpns3p

contains
  function sf_P3gg(y) result(res)
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x

    call sf_VogtValidate
    x = exp(-y)
    res = zero

    if(n3lo_splitting_approximation .eq. n3lo_splitting_approximation_up_to_2410_08089) then
       select case(cc_piece)
       case(cc_REAL,cc_REALVIRT)
          res = P3GGA_2410(x, nf_int, n3lo_splitting_variant) + P3GGB_2410(x, nf_int)
       end select
       select case(cc_piece)
       case(cc_VIRT,cc_REALVIRT)
          res = res - P3GGB_2410(x, nf_int)
       case(cc_DELTA)
          res = P3GGC_2410(zero, nf_int, n3lo_splitting_variant)
       end select
    else
       select case(cc_piece)
       case(cc_REAL,cc_REALVIRT)
          res = P3GGA(x, nf_int, n3lo_splitting_variant) + P3GGB(x, nf_int)
       end select
       select case(cc_piece)
       case(cc_VIRT,cc_REALVIRT)
          res = res - P3GGB(x, nf_int)
       case(cc_DELTA)
          res = P3GGC(zero, nf_int)
       end select
    endif
    res = res / 16.0_dp   ! compensate (as/4pi)^4 -> (as/2pi)^4
    if (cc_piece /= cc_DELTA) res = res * x
  end function sf_P3gg

  ! ..This is the (regular) pure-singlet splitting functions P_ps^(2).    
  !    P_qq^(2) is obtained by adding the non-singlet quantity P_NS^(2)+. 
  function sf_P3PS(y) result(res)
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x

    call sf_VogtValidate
    x = exp(-y)
    res = zero

    select case(cc_piece)
    case(cc_REAL,cc_REALVIRT)
       res = P3PSA(x, nf_int, n3lo_splitting_variant) + zero
    end select
    select case(cc_piece)
    case(cc_VIRT,cc_REALVIRT)
       res = res - zero
    case(cc_DELTA)
       res = zero
    end select

    res = res / 16.0_dp   ! compensate (as/4pi)^4 -> (as/2pi)^4
    if (cc_piece /= cc_DELTA) res = res * x
  end function sf_P3PS

  !--------------------------------------------------------------------
  ! this already includes the factor of 2nf
  function sf_P3qg2nf(y) result(res)
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x

    call sf_VogtValidate
    x = exp(-y)
    res = zero

    select case(cc_piece)
    case(cc_REAL,cc_REALVIRT)
       res = P3QGA(x, nf_int, n3lo_splitting_variant)
    end select
    select case(cc_piece)
    case(cc_VIRT,cc_REALVIRT)
       res = res - zero
    case(cc_DELTA)
       res = zero
    end select

    res = res / 16.0_dp   ! compensate (as/4pi)^4 -> (as/2pi)^4
    if (cc_piece /= cc_DELTA) res = res * x
  end function sf_P3qg2nf


  function sf_P3gq(y) result(res)
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x

    call sf_VogtValidate
    x = exp(-y)
    res = zero

    select case(cc_piece)
    case(cc_REAL,cc_REALVIRT)
       if(n3lo_splitting_approximation .eq. n3lo_splitting_approximation_up_to_2310_05744) then
          res = P3GQA(x, nf_int, n3lo_splitting_variant)
       else
          res = P3GQA_2404(x, nf_int, n3lo_splitting_variant)
       endif
    end select
    select case(cc_piece)
    case(cc_VIRT,cc_REALVIRT)
       res = res - zero
    case(cc_DELTA)
       res = zero
    end select

    res = res / 16.0_dp   ! compensate (as/4pi)^4 -> (as/2pi)^4
    if (cc_piece /= cc_DELTA) res = res * x
  end function sf_P3gq

  !------------------------- non-singlet pieces ------------------------
  function sf_P3NSPlus(y) result(res)
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x

    call sf_VogtValidate
    x = exp(-y)
    res = zero

    select case(cc_piece)
    case(cc_REAL,cc_REALVIRT)
       res = P3NSPA(x, nf_int, n3lo_splitting_variant) + P3NSPB(x, nf_int, n3lo_splitting_variant)
    end select
    select case(cc_piece)
    case(cc_VIRT,cc_REALVIRT)
       res = res - P3NSPB(x, nf_int, n3lo_splitting_variant)
    case(cc_DELTA)
       res = P3NSPC(zero, nf_int, n3lo_splitting_variant)
    end select

    res = res / 16.0_dp   ! compensate (as/4pi)^4 -> (as/2pi)^4
    if (cc_piece /= cc_DELTA) res = res * x
  end function sf_P3NSPlus


  function sf_P3NSMinus(y) result(res)
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x

    call sf_VogtValidate
    x = exp(-y)
    res = zero

    select case(cc_piece)
    case(cc_REAL,cc_REALVIRT)
       res = P3NSMA(x, nf_int, n3lo_splitting_variant) + P3NSMB(x, nf_int, n3lo_splitting_variant)
    end select
    select case(cc_piece)
    case(cc_VIRT,cc_REALVIRT)
       res = res - P3NSMB(x, nf_int, n3lo_splitting_variant)
    case(cc_DELTA)
       res = P3NSMC(zero, nf_int, n3lo_splitting_variant)
    end select

    res = res / 16.0_dp   ! compensate (as/4pi)^4 -> (as/2pi)^4
    if (cc_piece /= cc_DELTA) res = res * x
  end function sf_P3NSMinus

  !-- according to comments in Vogt code P_S = P_V - P_-
  function sf_P3NSS(y) result(res)
    real(dp), intent(in) :: y
    real(dp)             :: res
    real(dp)             :: x

    call sf_VogtValidate
    x = exp(-y)
    res = zero

    select case(cc_piece)
    case(cc_REAL,cc_REALVIRT)
       res = P3NSSA(x, nf_int, n3lo_splitting_variant)
    end select
    select case(cc_piece)
    case(cc_VIRT,cc_REALVIRT)
       res = res - zero
    case(cc_DELTA)
       res = zero
    end select

    res = res / 16.0_dp   ! compensate (as/4pi)^4 -> (as/2pi)^4
    if (cc_piece /= cc_DELTA) res = res * x
  end function sf_P3NSS

  !----------------------------------------------------------------
  ! The Vogt expressions are valid only for standard colour factors
  ! This routine makes sure that the appropriate conditions hold
  subroutine sf_VogtValidate
    if (ca == three .and. tr == half .and. cf == four/three) return
    call wae_Error('sf_VogtValidate: &
         &colour factors must be set to default values', &
         &'in order to use the Vogt splitting function parameterisations')
  end subroutine sf_VogtValidate

end module splitting_functions_n3lo_n


!======================================================================
! Modules for extracting selecting the relevant splitting functions, 
! either "n" version, "p" versions. May be extended to
! exact versions at some later stage...
!======================================================================
module sf_n3lo_n_rename
  use splitting_functions_n3lo_n,&
       &sf_n_P3gg      => sf_P3gg     ,&
       &sf_n_P3PS      => sf_P3PS     ,&
       &sf_n_P3qg2nf   => sf_P3qg2nf  ,&
       &sf_n_P3gq      => sf_P3gq     ,&
       &sf_n_P3NSPlus  => sf_P3NSPlus ,&
       &sf_n_P3NSMinus => sf_P3NSMinus,&
       &sf_n_P3NSS     => sf_P3NSS
  implicit none
  private
  public :: sf_n_P3gg, sf_n_P3qg2nf, sf_n_P3PS, sf_n_P3gq
  public :: sf_n_P3NSPlus, sf_n_P3NSMinus, sf_n_P3NSS
end module sf_n3lo_n_rename


module sf_n3lo_p_rename
  use splitting_functions_n3lo_p,&
       &sf_p_P3gg      => sf_P3gg     ,&
       &sf_p_P3PS      => sf_P3PS     ,&
       &sf_p_P3qg2nf   => sf_P3qg2nf  ,&
       &sf_p_P3gq      => sf_P3gq     ,&
       &sf_p_P3NSPlus  => sf_P3NSPlus ,&
       &sf_p_P3NSMinus => sf_P3NSMinus,&
       &sf_p_P3NSS     => sf_P3NSS
  implicit none
  private
  public :: sf_p_P3gg, sf_p_P3qg2nf, sf_p_P3PS, sf_p_P3gq
  public :: sf_p_P3NSPlus, sf_p_P3NSMinus, sf_p_P3NSS
end module sf_n3lo_p_rename


module sf_n3lo_e_rename
  use splitting_functions_n3lo_e,&
       &sf_e_P3gg      => sf_P3gg     ,&
       &sf_e_P3PS      => sf_P3PS     ,&
       &sf_e_P3qg2nf   => sf_P3qg2nf  ,&
       &sf_e_P3gq      => sf_P3gq     ,&
       &sf_e_P3NSPlus  => sf_P3NSPlus ,&
       &sf_e_P3NSMinus => sf_P3NSMinus,&
       &sf_e_P3NSS     => sf_P3NSS
  implicit none
  private
  public :: sf_e_P3gg, sf_e_P3qg2nf, sf_e_P3PS, sf_e_P3gq
  public :: sf_e_P3NSPlus, sf_e_P3NSMinus, sf_e_P3NSS
end module sf_n3lo_e_rename


module splitting_functions_n3lo
  use types; use qcd; use dglap_choices
  use warnings_and_errors
  use sf_n3lo_e_rename
  use sf_n3lo_p_rename
  use sf_n3lo_n_rename
  public :: sf_P3gg, sf_P3qg2nf, sf_P3PS, sf_P3gq
  public :: sf_P3NSPlus, sf_P3NSMinus, sf_P3NSS
contains
  
  
  real(dp) function sf_P3gg     (y) result(res)
    real(dp), intent(in) :: y
    select case(n3lo_splitting_variant)
    case(n3lo_splitting_exact)
       res = sf_e_P3gg(y)
    case(n3lo_splitting_param)
       res = sf_p_P3gg(y)
    case(n3lo_splitting_nfitav, n3lo_splitting_nfiterr1, n3lo_splitting_nfiterr2)
       res = sf_n_P3gg(y)
    case default
       call wae_error('splitting_functions_n3lo','unrecognized imod',&
            &intval=n3lo_splitting_variant)
    end select
  end function sf_P3gg
  
  real(dp) function sf_P3PS     (y) result(res)
    real(dp), intent(in) :: y
    select case(n3lo_splitting_variant)
    case(n3lo_splitting_exact)
       res = sf_e_P3PS(y)
    case(n3lo_splitting_param)
       res = sf_p_P3PS(y)
    case(n3lo_splitting_nfitav, n3lo_splitting_nfiterr1, n3lo_splitting_nfiterr2)
       res = sf_n_P3PS(y)
    case default
       call wae_error('splitting_functions_n3lo','unrecognized imod',&
            &intval=n3lo_splitting_variant)
    end select
  end function sf_P3PS
  
  real(dp) function sf_P3qg2nf  (y) result(res)
    real(dp), intent(in) :: y
    select case(n3lo_splitting_variant)
    case(n3lo_splitting_exact)
       res = sf_e_P3qg2nf(y)
    case(n3lo_splitting_param)
       res = sf_p_P3qg2nf(y)
    case(n3lo_splitting_nfitav, n3lo_splitting_nfiterr1, n3lo_splitting_nfiterr2)
       res = sf_n_P3qg2nf(y)
    case default
       call wae_error('splitting_functions_n3lo','unrecognized imod',&
            &intval=n3lo_splitting_variant)
    end select
  end function sf_P3qg2nf
  
  real(dp) function sf_P3gq     (y) result(res)
    real(dp), intent(in) :: y
    select case(n3lo_splitting_variant)
    case(n3lo_splitting_exact)
       res = sf_e_P3gq(y)
    case(n3lo_splitting_param)
       res = sf_p_P3gq(y)
    case(n3lo_splitting_nfitav, n3lo_splitting_nfiterr1, n3lo_splitting_nfiterr2)
       res = sf_n_P3gq(y)
    case default
       call wae_error('splitting_functions_n3lo','unrecognized imod',&
            &intval=n3lo_splitting_variant)
    end select
  end function sf_P3gq
  
  real(dp) function sf_P3NSPlus (y) result(res)
    real(dp), intent(in) :: y
    select case(n3lo_splitting_variant)
    case(n3lo_splitting_exact)
       res = sf_e_P3NSPlus(y)
    case(n3lo_splitting_param)
       res = sf_p_P3NSPlus(y)
    case(n3lo_splitting_nfitav, n3lo_splitting_nfiterr1, n3lo_splitting_nfiterr2)
       res = sf_n_P3NSPlus(y)
    case default
       call wae_error('splitting_functions_n3lo','unrecognized imod',&
            &intval=n3lo_splitting_variant)
    end select
  end function sf_P3NSPlus
  
  real(dp) function sf_P3NSMinus(y) result(res)
    real(dp), intent(in) :: y
    select case(n3lo_splitting_variant)
    case(n3lo_splitting_exact)
       res = sf_e_P3NSMinus(y)
    case(n3lo_splitting_param)
       res = sf_p_P3NSMinus(y)
    case(n3lo_splitting_nfitav, n3lo_splitting_nfiterr1, n3lo_splitting_nfiterr2)
       res = sf_n_P3NSMinus(y)
    case default
       call wae_error('splitting_functions_n3lo','unrecognized imod',&
            &intval=n3lo_splitting_variant)
    end select
  end function sf_P3NSMinus

  real(dp) function sf_P3NSS(y) result(res)
    real(dp), intent(in) :: y
    select case(n3lo_splitting_variant)
    case(n3lo_splitting_exact)
       res = sf_e_P3NSS(y)
    case(n3lo_splitting_param)
       res = sf_p_P3NSS(y)
    case(n3lo_splitting_nfitav, n3lo_splitting_nfiterr1, n3lo_splitting_nfiterr2)
       res = sf_n_P3NSS(y)
    case default
       call wae_error('splitting_functions_n3lo','unrecognized imod',&
            &intval=n3lo_splitting_variant)
    end select
  end function sf_P3NSS
end module splitting_functions_n3lo

!! An example program using structure functions up to NLO with flavour decomposition. !!
!!
program structure_functions_example_flavour
  use hoppet
  use pdfs_for_benchmarks
  use streamlined_interface
  use structure_functions
  implicit none
  real(dp) :: Qmax, xmur, xmuf, Qmin, ymax, Q, mc, mb, mt, asQ, Q0,&
       & muR_Q, dy, dlnlnQ, minQval, maxQval, muR, muF, x, ytest
  integer  :: nloop_coefs, sc_choice,nloop, order, i, ny, iy 
  real(dp) :: F(-6:7), FLO(-6:7), FNLO(-6:7)
  real(dp) :: Fflav(-6:6,3), FLOflav(-6:6,3), FNLOflav(-6:6,3)
  
  Qmax = 13000.0_dp 
  nloop_coefs = 2
  xmur = one
  xmuf = one
  sc_choice = scale_choice_Q ! Uses Q as the central scale choice
  Qmin = one

  ! Set heavy flavour scheme
  mc = 1.414213563_dp   ! sqrt(2.0_dp) + epsilon
  mb = 4.5_dp
  mt = 175.0_dp
  call hoppetSetPoleMassVFN(mc, mb, mt)

  ! Streamlined initialization
  ! including  parameters for x-grid
  order = -6 ! interpolation order, not perturbative order in alphas!
  ymax  = 16.0_dp
  dy    = 0.05_dp  ! dble_val_opt("-dy",0.1_dp)
  dlnlnQ = dy/4.0_dp
  nloop = 3 
  minQval = min(xmuF*Qmin, Qmin)
  maxQval = max(xmuF*Qmax, Qmax)
  
  ! initialise the grid and dglap holder, using the streamlined
  ! interface for simplicity
  call hoppetStartExtended(ymax,dy,minQval,maxQval,dlnlnQ,nloop,&
         &         order,factscheme_MSbar)

  ! Setup all constants and parameters needed by the structure functions
  call StartStrFct(nloop_coefs, scale_choice = sc_choice, param_coefs&
       & = .true., constant_mu = 91.1876_dp, nflav = 5)

  ! Evolve the PDF
  asQ = 0.35_dp
  Q0 = sqrt(2.0_dp)
  muR_Q = 1.0_dp

  call hoppetEvolve(asQ, Q0, nloop,muR_Q, benchmark_pdf_unpolarized_lha, Q0)

  ! Initialise the structure functions using separate orders
  ! NB: this uses the PDFs that were set up in the streamlined interface
  ! with the hoppetEvolve routine
  !
  ! flavour_decomposition = .true. allows us to get flavour decomposed structure functions
  call InitStrFct(nloop_coefs, .true., xR = xmur, xF = xmuf, flavour_decomposition = .true.)

  Q = 100.0_dp
  muR = Q
  muF = Q

  ymax = log(1e5)
  ny = 10
  print*, 'Standard structure functions at NLO for Q=100 GeV and x=0.01'
  call write_header()
  do iy = ny, 1, -1
    ytest = iy * ymax / ny
    x = exp(-ytest)
    FLO  = F_LO(x,Q,muR,muF)
    FNLO = F_NLO(x,Q,muR,muF)
    F    = StrFct(x,Q,muR,muF)
    write(*,'(15es12.4)') x, F
  enddo

  print*, ''
  print*, 'Struture functions obtained from the flavour decomposed ones'
  call write_header()
  do iy = ny, 1, -1
    ytest = iy * ymax / ny
    x = exp(-ytest)
    do i =-6,6
      FLOflav(i,:) = F_LO_flav(x,Q,muR,muF,i)
      FNLOflav(i,:) = F_NLO_flav(x,Q,muR,muF,i)
      Fflav(i,:)   = StrFct_flav(x,Q,muR,muF,i)
    enddo
    call fill_structure_functions(x,Fflav(:,1),Fflav(:,2),Fflav(:,3),F)
    write(*,'(15es12.4)') x, F
  enddo

contains 

  subroutine write_header()
    integer iSF 
    write(*,'(a)', advance = 'no') "     x   "
    do iSF = -6, 7
      write(*,'(a12)', advance = 'no') "  "//SF_names(iSF)
    end do 
    write(*,*)
  end subroutine write_header

end program structure_functions_example_flavour

! Below a routine that fills all the NC and CC structure functions
! from the flavour decomposed ones. These routines are essentially
! adapted from those that can be found in structure_functions.f90
subroutine fill_structure_functions(x,FL,F2,F3,SF)
  use hoppet
  use streamlined_interface
  use structure_functions
  use coefficient_functions_holder
  implicit none
  real(dp) :: FL(-6:6),F2(-6:6),F3(-6:6),SF(-6:7),x
  real(dp), parameter :: viW = 1/sqrt(two), aiW = viW
  real(dp), save      :: vi2_ai2_avg_W, two_vi_ai_avg_W
  real(dp), save      :: vi2_ai2_Z_down, vi2_ai2_Z_up
  real(dp), save      :: two_vi_ai_Z_down, two_vi_ai_Z_up
  real(dp), save      :: two_vi_Z_down, two_vi_Z_up
  real(dp), save      :: two_ai_Z_down, two_ai_Z_up
  real(dp), parameter :: e_up = 2.0_dp/3.0_dp, e_down = - 1.0_dp/3.0_dp
  real(dp), parameter :: e2_up = 4.0_dp/9.0_dp, e2_down = 1.0_dp/9.0_dp
  real(dp) :: sin_thw_sq, mw, mz , two_xvals
  real(dp) :: ulike, dlike, ubarlike, dbarlike
  integer :: nf_lcl
  
  mw                = 80.377_dp
  mz                = 91.1876_dp

  two_xvals = 2.0_dp * x

  ! compute sin(\theta_w) from W/Z mass
  sin_thw_sq = 1.0_dp - (mw/mz)**2

  ! evaluate parameters needed for the structure functions
  ! cf. Eqs. (3.10+11) of 1109.3717
  vi2_ai2_Z_up     = one/four + (half - (four/three) * sin_thw_sq)**2
  vi2_ai2_Z_down   = one/four + (half - (two/three)  * sin_thw_sq)**2
  two_vi_ai_Z_up   = half - (four/three) * sin_thw_sq
  two_vi_ai_Z_down = half - (two/three)  * sin_thw_sq

  ! cf. Eq.3.20 + 3.17 & 3.18
  ! 1/nf \sum_j=1^nf (vj^2 + aj^2)
  vi2_ai2_avg_W = viW**2 + aiW**2
  ! 1/nf \sum_j=1^nf 2*vj*aj
  two_vi_ai_avg_W = two * viW * aiW

  ! these parameters are needed explicitly for the gamma-Z structure function
  two_vi_Z_up = one - (8.0_dp/three) * sin_thw_sq
  two_vi_Z_down   = -one + (four/three) * sin_thw_sq
  two_ai_Z_up = one
  two_ai_Z_down   = -one

  SF = zero
  nf_lcl = 5
  !--- deal with Z case -----------------------------------------
  SF(iF2Z) = (dlike(F2,nf_lcl) + dbarlike(F2,nf_lcl))*vi2_ai2_Z_down + &
       &       (ulike(F2,nf_lcl) + ubarlike(F2,nf_lcl))*vi2_ai2_Z_up

  ! temporarily put FL into F1;
  SF(iF1Z) = (dlike(FL,nf_lcl) + dbarlike(FL,nf_lcl))*vi2_ai2_Z_down +&
       & (ulike(FL,nf_lcl) + ubarlike(FL,nf_lcl))*vi2_ai2_Z_up
  ! then convert to F1
  SF(iF1Z) = (SF(iF2Z) - SF(iF1Z)) / two_xvals

  SF(iF3Z) = (dlike(F3,nf_lcl) - dbarlike(F3,nf_lcl))*two_vi_ai_Z_down + (ulike(F3,nf_lcl)&
       & - ubarlike(F3,nf_lcl))*two_vi_ai_Z_up
  SF(iF3Z) = SF(iF3Z)/x

  !--- deal with EM case -----------------------------------------
  SF(iF2EM) = (dlike(F2,nf_lcl) + dbarlike(F2,nf_lcl))*e2_down + (ulike(F2,nf_lcl) +&
       & ubarlike(F2,nf_lcl))*e2_up

  ! temporarily put FL into F1;
  SF(iF1EM) = (dlike(FL,nf_lcl) + dbarlike(FL,nf_lcl))*e2_down +&
       & (ulike(FL,nf_lcl) + ubarlike(FL,nf_lcl))*e2_up
  ! then convert to F1
  SF(iF1EM) = (SF(iF2EM) - SF(iF1EM)) / two_xvals

  !--- deal with gamma-Z case
  !-----------------------------------------
  ! equations taken from section 19 of PDG (19.18)
  SF(iF2gZ) = (dlike(F2,nf_lcl) + dbarlike(F2,nf_lcl))*e_down*two_vi_Z_down +&
       & (ulike(F2,nf_lcl) + ubarlike(F2,nf_lcl))*e_up * two_vi_Z_up

  ! temporarily put FL into F1;
  SF(iF1gZ) = (dlike(FL,nf_lcl) + dbarlike(FL,nf_lcl))*e_down*two_vi_Z_down +&
       & (ulike(FL,nf_lcl) + ubarlike(FL,nf_lcl))*e_up * two_vi_Z_up
  ! then convert to F1
  SF(iF1gZ) = (SF(iF2gZ) - SF(iF1gZ)) / two_xvals

  SF(iF3gZ) = (dlike(F3,nf_lcl) - dbarlike(F3,nf_lcl))*e_down*two_ai_Z_down + &
       &        (ulike(F3,nf_lcl) - ubarlike(F3,nf_lcl))*e_up * two_ai_Z_up
  SF(iF3gZ) = SF(iF3gZ)/x

  ! for the W cases, it only makes sense to sum over an even number
  ! of light flavours; so save the actual number of flavours, switch
  ! the module-local nf_lcl variable to the nearest (lower) event
  ! number
  ! for our W calculations; switch back later
  nf_lcl = 4

  ! --- deal with Wm case
  !-----------------------------------------
  SF(iF2Wm) = (ulike(F2,nf_lcl) + dbarlike(F2,nf_lcl))*vi2_ai2_avg_W
  ! temporarily put FL into F1;
  SF(iF1Wm) = (ulike(FL,nf_lcl) + dbarlike(FL,nf_lcl))*vi2_ai2_avg_W
  ! then convert to F1
  SF(iF1Wm) = (SF(iF2Wm) - SF(iF1Wm)) / two_xvals
  SF(iF3Wm) = (ulike(F3,nf_lcl) - dbarlike(F3,nf_lcl))*two_vi_ai_avg_W
  SF(iF3Wm) = SF(iF3Wm)/x

  !--- deal with Wp case -----------------------------------------
  SF(iF2Wp) = (dlike(F2,nf_lcl) + ubarlike(F2,nf_lcl))*vi2_ai2_avg_W
  ! temporarily put FL into F1;
  SF(iF1Wp) = (dlike(FL,nf_lcl) + ubarlike(FL,nf_lcl))*vi2_ai2_avg_W
  ! then convert to F1
  SF(iF1Wp) = (SF(iF2Wp) - SF(iF1Wp)) / two_xvals
  SF(iF3Wp) = (dlike(F3,nf_lcl) - ubarlike(F3,nf_lcl))*two_vi_ai_avg_W
  SF(iF3Wp) = SF(iF3Wp)/x

end subroutine fill_structure_functions

!----------------------------------------------------------------------
function ulike(f,nf) result(res)
  double precision, intent(in) :: f(-6:6)
  integer, intent(in)  :: nf
  double precision             :: res
  res = sum(f(2: nf: 2))
end function ulike
!----------------------------------------------------------------------
function dlike(f,nf) result(res)
  double precision, intent(in) :: f(-6:6)
  integer, intent(in)  :: nf
  double precision             :: res
  res = sum(f(1: nf: 2))
end function dlike
!----------------------------------------------------------------------
function ubarlike(f,nf) result(res)
  double precision, intent(in) :: f(-6:6)
  integer, intent(in)  :: nf
  double precision             :: res
  res = sum(f(-2:-nf:-2))
end function ubarlike
!----------------------------------------------------------------------
function dbarlike(f,nf) result(res)
  double precision, intent(in) :: f(-6:6)
  integer, intent(in)  :: nf
  double precision             :: res
  res = sum(f(-1:-nf:-2))
end function dbarlike

  

! $Id: convolution.f90,v 1.26 2005/07/08 21:19:17 salam Exp $


!! Module defining integers for the different pieces of a splitting function
module convolution_pieces
   use iso_c_binding, only: c_int
   implicit none
   private

   ! if any of the following values are changed, make sure the same
   ! change is made in the C interface (hoppet.h)
   integer(c_int), public, parameter :: cc_REAL=1      !< regular + plus 
   integer(c_int), public, parameter :: cc_VIRT=2      !< -plus
   integer(c_int), public, parameter :: cc_REALVIRT=3  !< regular
   integer(c_int), public, parameter :: cc_DELTA=4     !< delta function
end module convolution_pieces

!======================================================================
!! Module exclusively for communication between convolution and 
!! any routine which might supply convolutions in the v1 interface
!! where a global variable is used to indicate which piece of the
!! splitting function is to be returned.
!======================================================================
module convolution_communicator
   use iso_c_binding
   use types
   use convolution_pieces
   implicit none
   private

   !! The following variable is set by routines like InitGridConv_func
   !! to indicate which part of the splitting function should be returned.
   !! It will be set to one of the cc_X values defined below
   integer(c_int), public, bind(c, name="hoppet_global_cc_piece") :: cc_piece

   ! pass on the public bits of convolution_pieces so that v1 routines
   ! expecting them in convolution_communicator see them
   public :: cc_REAL, cc_VIRT, cc_REALVIRT, cc_DELTA
end module convolution_communicator



!======================================================================
!! All the base types and routines for convolution in y=log(1/x) space
!
! Decide on the following policy: grid details will be copied rather
! than pointed to (avoids danger of object that is pointed to being 
! changed). Not clear if this is really the best policy, but we will
! give it a try...
!
! GPS 04/04/2000
!======================================================================
module convolution
  use types; use consts_dp; use assertions; use warnings_and_errors
  use integrator
  implicit none
  private

  integer, parameter :: conv_UndefinedInt = 1000000004
  ! minimum and maximum number of points for interpolation
  integer, parameter :: npnt_min = 4, npnt_max = 10
  integer, parameter, public :: WeightGridQuand_npnt_max = npnt_max
  integer, parameter, public :: grid_interp_npnt_min = npnt_min !< better-qualified public name
  integer, parameter, public :: grid_interp_npnt_max = npnt_max !< better-qualified public name

  !-------------------------------
  !! Definition of a grid.
  !! Includes possibility of one layer of subsidiary definitions.
  type grid_def
     real(dp) :: dy, ymax, eps
     integer  :: ny, order, nsub = 0
     logical  :: locked
     integer,        pointer :: subiy(:) => null() ! starting points of subsidiary grid
     type(grid_def), pointer :: subgd(:) => null() ! subsidiary grid defs
  end type grid_def

  !--------------------------------------------------
  !! Definition of a convolution object
  type grid_conv
     type(grid_def)           :: grid
     real(dp),        pointer :: conv(:,:) => null()
     !-- support in construction...
     type(grid_conv), pointer :: subgc(:) => null()
  end type grid_conv
  integer, parameter :: FULL=1, UPPR=2
  !-- for standard linear approach with proper end-point treatment.
  ! This must remain zero otherwise inconsistencies will arise
  integer, parameter :: LIN_ORDER=0

  !-------- interfaces and classes for convolution integrand functions --------------

  !! the abstract base class for the convolution integrand function
  !! that will be used to set up a grid_conv
  type, abstract :: conv_ignd
  contains
    procedure(conv_ignd__f), deferred :: f  !< f(y, piece)
  end type conv_ignd

  !! The abstract interface for the conv_ignd%f(y, piece) function
  abstract interface
    function conv_ignd__f(this, y, piece) result(func)
      import dp, conv_ignd
      implicit none
      class(conv_ignd), intent(in) :: this
      real(dp), intent(in) :: y
      integer , intent(in) :: piece
      real(dp)             :: func
    end function conv_ignd__f
  end interface

  !! a derived integrand class object, with 
  !! - a pointer to a conv_ignd object
  !! - a variable `piece` to say which piece of the conv_ignd is to be used
  !! - an implementation of f(y) that calls conv_ignd%f(y,piece)    
  type, extends(ignd_class) :: ignd_class_fromconv
    integer :: piece
    class(conv_ignd), pointer :: conv_ignd_ptr => null()  !< has conv_ignd_ptr%f(y,piece)
  contains
    procedure :: f => ignd_class_fromconv__f  !< f(y)
  end type ignd_class_fromconv

  !! A conv_ignd class that calls a procedure pointer to an ignd_func
  type, extends(conv_ignd) :: conv_ignd_fromfunc    
    procedure(ignd_func), pointer, nopass :: f_ptr => null()
  contains
    procedure :: f => conv_ignd_fromfunc__f  !< f(y, piece)
  end type conv_ignd_fromfunc

  public :: conv_ignd, conv_ignd_fromfunc
  public :: grid_def, grid_conv
  public :: conv_BestIsub

  !-- public routines --
  interface InitGridDef
     module procedure conv_InitGridDef_single, conv_InitGridDef_multi
  end interface InitGridDef
  public :: conv_InitGridDef_single, conv_InitGridDef_multi
  public :: InitGridDef, ValidateGD, GetGridInfoString
  public :: SetDefaultConvolutionEps, DefaultConvolutionEps
  public :: InitGridDefDefault
  interface operator(==)
     module procedure conv_CmpGridDef
  end interface
  public :: operator(==)
  interface Delete ! made public later...
     module procedure Delete_grid_def_0d, Delete_grid_def_1d
  end interface
  public :: xValues, yValues
  public :: MonotonicUniqueIndices, MonotonicUniqueYValues, MonotonicUniqueXValues

  !-- quant routines -----------------------------------------------
  interface AllocGridQuant
     module procedure conv_AllocGridQuant_1d,conv_AllocGridQuant_2d,&
          & conv_AllocGridQuant_3d
  end interface
  public :: AllocGridQuant
  interface InitGridQuant
     module procedure conv_InitGridQuant_func, conv_InitGridQuant_func2d,&
          & conv_InitGridQuant_func_a, conv_InitGridQuant_func2d_a,&
          & conv_InitGridQuant_func_ai, conv_InitGridQuant_func2d_ai
  end interface
  ! standard version gives problems with pgf90 5.1-2 (wrong answers)...
  interface InitGridQuantSub
     module procedure conv_InitGridQuantSub_2d, &
          &conv_InitGridQuantSub_2d_a, conv_InitGridQuantSub_2d_ai
  end interface
  ! This is the workaround suggested by Giulia, across all variants
  ! of the subroutine... Testing with pgf90 however shows that we still 
  ! have the wrong answer (though whether because of this routine
  ! or others has not been established).
  !interface InitGridQuantSub
  !   module procedure conv_InitGridQuantSub_2d_pgf, &
  !        &conv_InitGridQuantSub_2d_a_pgf, conv_InitGridQuantSub_2d_ai_pgf
  !end interface
  
  public :: InitGridQuant, InitGridQuantSub, PrintGridQuant
  public :: InitGridQuantLHAPDF
  interface PrintGridQuant
     module procedure conv_PrintGridQuant_1, conv_PrintGridQuant_2,&
          & conv_PrintGridQuant_3, conv_PrintGridQuant_4
  end interface
  interface EvalGridQuant
     module procedure conv_EvalGridQuant_0d, conv_EvalGridQuant_1d
  end interface
  public :: MomGridQuant, EvalGridQuant, WgtGridQuant, WgtGridQuant_noalloc
  interface Delete
     module procedure conv_DelGridQuant_1d, conv_DelGridQuant_2d
     module procedure conv_DelGridQuant_3d
  end interface
  
  !public :: Delete

  !-- for calculating moments ---
  real(dp)       :: conv_moment_index
  type(grid_def) :: conv_moment_gd
  real(dp), allocatable :: conv_moment_gq(:)
  interface TruncatedMoment
    module procedure conv_TruncatedMoment_1d, conv_TruncatedMoment_2d
  end interface
  public :: TruncatedMoment

  !-- for calculating partonic luminosities
  interface PartonLuminosity
    module procedure conv_Luminosity_multi
  end interface
  public :: PartonLuminosity

  !-- convolution routines -------------------------------------------
  interface AllocGridConv
     module procedure conv_AllocGridConv_0d, conv_AllocGridConv_1d, &
          & conv_AllocGridConv_2d
  end interface
  interface InitGridConv
     module procedure conv_InitGridConv_zero, conv_InitGridConv_zero_1d,&
          & conv_InitGridConv_zero_2d, conv_InitGridConv_func,&
          & conv_InitGridConv_gc, conv_InitGridConv_gc_1d, &
          & conv_InitGridConv_gc_2d, conv_InitGridConv_conv, &
          & conv_InitGridConv_ignd
  end interface
  !-- keep following for historical reasons? Not as of 28/12/01
  !interface conv_GridConvAdd
  !   module procedure conv_GridConvAdd_func, conv_GridConvAdd_gc
  !end interface
  interface SetToZero
     module procedure conv_ZeroGridConv_0d, conv_ZeroGridConv_1d,&
          & conv_ZeroGridConv_2d
  end interface
  interface AddWithCoeff
     module procedure conv_AddGridConv_func, conv_AddGridConv_ignd,&
          & conv_AddGridConv_gc,&
          & conv_AddGridConv_gc_1d, conv_AddGridConv_gc_2d
  end interface
  interface Multiply
     module procedure conv_MultGridConv_0d, conv_MultGridConv_1d, &
          & conv_MultGridConv_2d
  end interface
  interface Delete
     module procedure conv_DelGridConv_0d, conv_DelGridConv_1d, &
          & conv_DelGridConv_2d
  end interface
  interface SetToConvolution
     module procedure conv_ConvGridConv_0d, conv_ConvGridConv_2dx2d
  end interface
  interface SetToCommutator
     module procedure SetToCommutator_gc
  end interface
  

  public :: GridConvAllocated
  public :: AllocGridConv, InitGridConv, Delete
  public :: AddWithCoeff, Multiply, SetToConvolution
  public :: SetToZero, SetToCommutator

  !-- REMEMBER: .conv. seems to have a precedence similar to .or., .and.
  !             and so is lower precednece than any arithmetic operation
  interface operator(.conv.)
     module procedure conv_ConvGridQuant_mat, conv_ConvGridQuant_scalar
  end interface
  public :: operator(.conv.)
  !-- put in this version as well because to ease the writing of 
  !   expressions: * should have the right precedence properties
  !   where .conv. seems to have a very low precedence
  interface operator(*)
     module procedure conv_ConvGridQuant_mat, conv_ConvGridQuant_scalar
  end interface
  public :: operator(*)

  !-- keep this for historical reasons (hopefully not too long)
  interface conv_ConvConv
     module procedure conv_InitGridConv_conv
  end interface
  public :: conv_ConvConv

  !--------------------------
  type gdval
     type(grid_def) :: grid
     real(dp)       :: val
  end type gdval
  public :: gdval
  interface operator(.with.)
     module procedure conv_gdval_gdv, conv_gdval_vgd
  end interface
  public :: operator(.with.)  
  interface operator(.atx.)
     module procedure conv_EvalGridQuant_atx, conv_EvalGridQuant_atx_1d
  end interface
  public :: operator(.atx.)
  interface operator(.aty.)
     module procedure conv_EvalGridQuant_aty, conv_EvalGridQuant_aty_1d
  end interface
  public :: operator(.aty.)

  !-- precision used for integration
  real(dp) :: default_conv_eps=1e-7_dp
  !real(dp), parameter :: default_conv_eps=1e-8_dp
  real(dp), parameter :: warn_tolerance = 1e-3_dp
  
  !-- used for generation of derived convoluters (e.g. exponentiations
  !   of existsing convoluters)
  logical :: override_grid_locking = .false.
  integer :: nconv_with_override_off = 0 ! 
  public :: GetDerivedProbes, SetDerivedConv
  public :: SetDerivedConv_nodealloc
  public :: DisableGridLocking, RestoreGridLocking

  ! actual subroutine is to be found in welcome_message.f90
  interface
     subroutine HoppetWelcomeMessage
     end subroutine HoppetWelcomeMessage
  end interface
  public :: HoppetWelcomeMessage

contains

  !======================================================================
  ! Things just for Grid defs.
  ! updated for multi.
  !
  ! order = 0 -> standard linear
  ! order > 0 -> full (order) treatment
  ! order < 0 -> treatment correct to |order| except at end points 
  !              (this is similar to Ratcliffes proposal, hep-ph/0012376)
  subroutine conv_InitGridDef_single(grid,dy,ymax,order,eps)
    type(grid_def), intent(out) :: grid
    real(dp),       intent(in)  :: dy, ymax
    integer,        intent(in), optional :: order
    real(dp),       intent(in), optional :: eps
    logical, save :: first_call = .true.
    character(len=200) :: err_string1, err_string2
    integer, save     :: nwarn_dy = 4

    if (first_call) then
       first_call = .false.
       call HoppetWelcomeMessage
    end if
    
    !-- this is a plain grid def ---------------------------
    grid%nsub = 0
    nullify(grid%subiy,grid%subgd)
    grid%locked = .false.
    !-------------------------------------------------------

    grid%ymax = ymax
    grid%ny   = nint(ymax / dy)
    if (grid%ny < 2) then
       
       write(err_string1,*) 'InitGridDef: requested too small a number of bins'
       write(err_string2,*) '                 dy and ymax were',dy,ymax
       call wae_error(trim(err_string1),trim(err_string2))
    end if
    
    grid%dy   = ymax / grid%ny
    if (abs(grid%dy/dy - one) > 0.001_dp) then
       write(err_string1,*) 'InitGridDef: requested dy of ', dy
       write(err_string2,*) '                         provided  dy of ', grid%dy
       call wae_warn(nwarn_dy,trim(err_string1),trim(err_string2))
    end if

    if (present(order)) then
       !if (order < LIN_ORDER) then
       !   write(0,*) 'ERROR in InitGridDef: order < 0&
       !        & is not valid in InitGridDef'
       !   stop
       if (abs(order)+1 > grid%ny) then
          call wae_error('InitGridDef: |order|+1 > number of grid points')
       end if
       grid%order = order
    else
       grid%order = LIN_ORDER
    end if
    
    grid%eps = default_or_opt(default_conv_eps, eps)
  end subroutine conv_InitGridDef_single


  !--------------------------------------------------------------
  !! Create a multi-grid grid_def from several individual grid definitions
  !!
  !! - grid: the new grid
  !! - gdarray: the array of individual grid definitions
  !! - locked: if true the grid is locked, with several implications:
  !!   * the grids will be stored in order of increasing dy
  !!   * the grid spacings of the finer grids will be the next coarser grid divided by an integer
  !!   * finer grids must have ymax values that are smaller than the coarser grids
  subroutine conv_InitGridDef_multi(grid,gdarray,locked)
    use sort
    type(grid_def), intent(out) :: grid
    type(grid_def), intent(in)  :: gdarray(:)
    logical,        intent(in), optional :: locked
    !----------------------------------
    integer :: i,indx(size(gdarray))
    real(dp) :: dyratio, approx_ny, new_ymax
    type(grid_def), pointer :: subgd(:) ! shorthand
    ! temp needed for workaround on ifort 8.0.039
    real(dp) :: gdarraydy(size(gdarray))
    character(len=200) :: err_string1, err_string2
    integer, save      :: nwarn_locking = 4

    !-- enforce one layer only
    if (any(gdarray(:)%nsub /= 0)) then
       call wae_error(&
        'ERROR in conv_InitGridDef_multi:',&
        'One of grid defs in array was a compound grid def.',&
        'Only one layer of compounding is currently allowed.')
    end if
    
    grid%nsub = size(gdarray)
    allocate(grid%subiy(grid%nsub+1))
    allocate(grid%subgd(grid%nsub));   subgd => grid%subgd

    grid%locked = default_or_opt(.false.,locked)
    if (grid%locked) then
       ! this calls gives wrong results with ifort-8.0.039
       ! (dummy array gdarray%dy is corrupted in indexx). Issue
       ! submitted 27/01/2004: 225712 
       ! "Corrupted answer on call with array of derived type subcomponents"
       !call indexx(gdarray%dy, indx)

       ! workaround for ifort-8.0.039 
       gdarraydy = gdarray%dy
       call indexx(gdarraydy, indx)
       do i = 1, grid%nsub
          subgd(i) = gdarray(indx(i))
          if (i > 1) then 
             if (subgd(i)%ymax <  subgd(i-1)%ymax) then
                write(err_string1,*) &
                     &'ERROR in conv_InitGridDef_multi: for locking,'
                write(err_string2,*) 'gdarray with smaller dy should&
                     & also have smaller gdarray%ymax'
                call wae_error(trim(err_string1), trim(err_string2))
             end if
          end if
       end do
       
       !-- now ensure that there is proper matching between locked grids
       do i = grid%nsub-1, 1, -1
          ! dyratio must be an integer
          dyratio = subgd(i+1)%dy / subgd(i)%dy
          subgd(i)%dy = subgd(i+1)%dy / nint(dyratio)
          if (abs(dyratio-nint(dyratio)) > warn_tolerance*dyratio) then
             write(err_string1,'(a,i2,a,f18.14)') ' InitGridDef (locking):&
                  & redefined dy(', i,') to be ', subgd(i)%dy
             call wae_warn(nwarn_locking, trim(err_string1))
          end if
          ! after fixing dy one must still have an integer number of bins
          approx_ny = subgd(i)%ymax/subgd(i)%dy
          subgd(i)%ny = ceiling(approx_ny - warn_tolerance)
          new_ymax = subgd(i)%ny * subgd(i)%dy
          if (abs(new_ymax-subgd(i)%ymax) > warn_tolerance*new_ymax) then
             write(err_string1,'(a,i2,a,f18.14)') ' InitGridDef (locking):&
                  & redefined ymax(', i,') to be ', new_ymax
             call wae_warn(nwarn_locking, trim(err_string1))
          end if
          subgd(i)%ymax = new_ymax
          subgd(i)%ny   = nint(subgd(i)%ymax / subgd(i)%dy)
          ! condition on order must still hold
          if (abs(subgd(i)%order)+1 > subgd(i)%ny) then
             write(err_string1,'(a)') 'Error in InitGridDef (locking):'
             write(err_string2,'(a,i2,a)') '       For grid def ',i,' |order|+1 > ny'
             call wae_error(trim(err_string1),trim(err_string2))
          end if
       end do
    else
       !-- no questions asked!      
       subgd(:) = gdarray(:)
    end if
    
    grid%dy       = zero
    grid%ymax     = maxval(subgd(:)%ymax)
    grid%order    = conv_UndefinedInt
    !-- arrays will stretch from 0:grid%ny; so must get this right!
    grid%ny       = sum(subgd(:)%ny) + grid%nsub-1
    
    !-- indicate starting points of arrays
    grid%subiy(1) = 0
    do i = 2, grid%nsub+1
       grid%subiy(i) = grid%subiy(i-1) + subgd(i-1)%ny + 1
    end do
    
  end subroutine conv_InitGridDef_multi

  !======================================================================
  !! create a grid covering ymax and dy, using our default nested grid
  !! setup (as created originally for the streamlined interface)
  subroutine InitGridDefDefault(grid, dy, ymax, order)
    type(grid_def), intent(out) :: grid
    real(dp),       intent(in)  :: ymax, dy
    integer, optional, intent(in) :: order
    !---------------------------------
    type(grid_def) :: gdarray(4)
    integer        :: lcl_order

    lcl_order = default_or_opt(-6, order)

    call InitGridDef(gdarray(4),dy/27.0_dp,0.2_dp, order=lcl_order)
    call InitGridDef(gdarray(3),dy/9.0_dp,0.5_dp,  order=lcl_order)
    call InitGridDef(gdarray(2),dy/3.0_dp,2.0_dp,  order=lcl_order)
    call InitGridDef(gdarray(1),dy,       ymax  ,  order=lcl_order)
    call InitGridDef(grid,gdarray(1:4),locked=.true.)

  end subroutine InitGridDefDefault
  
  
  !======================================================================
  !! Set a string with a compact summary about the grid
  !!
  subroutine GetGridInfoString(grid,string)
    use sort
    type(grid_def),   intent(in)  :: grid
    character(len=*), intent(out) :: string
    !----------------------------------------
    character(len=200) :: my_string ! nice and long!
    character(len=200) :: frmt
    integer, save :: nwarn_len = 4, nwarn_eps = 4
    integer, allocatable  :: indx(:)

    if (grid%nsub == 0) then
       write(my_string,&
            &'("dy=",f5.3,"|ymax=",f0.2,"|order=",i0,"|eps=",es7.1)') &
            & grid%dy,grid%ymax,grid%order,grid%eps
    else 
       allocate(indx(grid%nsub))
       call indexx(-grid%subgd%dy,indx)  ! grid%subgd(indx)%dy == decreasing dy
       if (any(grid%subgd(2:)%eps /= grid%subgd(1)%eps)) &
            &call wae_warn(nwarn_eps,'GetGridInfoString: &
            &subgrids have different eps; only largest printed')
       if (grid%locked) then
          write(frmt,'(a,i0,a,i0,a,i0,a)') &
               &'("dy=",f5.3,',grid%nsub-1 ,&
               &'("/",i0),"|ymax=",f0.2,',grid%nsub-1,&
               &'(":",f0.2),"|order=",sp,i0,',grid%nsub-1,&
               &'(":",i0),ss,"|eps=",es7.1)'
          write(my_string,trim(frmt)) grid%subgd(indx(1))%dy,&
               & nint(grid%subgd(indx(1:grid%nsub-1))%dy/grid%subgd(indx(2:))%dy),&
               & grid%subgd(indx)%ymax, grid%subgd(indx)%order,&
               & maxval(grid%subgd(:)%eps)
       else
          write(frmt,'(a,i0,a,i0,a,i0,a)') &
               &'("dy=",f5.3,',grid%nsub-1 ,&
               &'(":",f5.4),"|ymax=",f0.2,',grid%nsub-1,&
               &'(":",f0.2),"|order=",sp,i0,',grid%nsub-1,&
               &'ss,(":",i0),"|eps=",es7.1)'
          write(my_string,trim(frmt)) grid%subgd(indx(:))%dy,&
               & grid%subgd(indx)%ymax, grid%subgd(indx)%order,&
               & maxval(grid%subgd(:)%eps)
       end if
    end if
    
    if (len_trim(my_string) > len(string)) then
       call wae_warn(nwarn_len,&
            &"GetGridInfoString: too short a string was passed")
       string = my_string(1:len(string))
    else
       string = my_string(1:len_trim(my_string))
    end if
    
  end subroutine GetGridInfoString
  

  !======================================================================
  !! Delete the memory associated with a grid definition
  recursive subroutine Delete_grid_def_0d(grid)
    type(grid_def), intent(inout) :: grid

    if (grid%nsub /= 0) then
       call Delete(grid%subgd(:)) 
       !do isub = 1, grid%nsub
       !   ! following line not strictly needed since (a) we have no more
       !   ! than one level of depth and (b) we do not have anything to
       !   ! delete in the lowest level.
       !   call Delete(grid%subgd(isub)) 
       !end do
       deallocate(grid%subiy)
       deallocate(grid%subgd)
       grid%nsub = 0
    end if
    
  end subroutine Delete_grid_def_0d
  

  !======================================================================
  recursive subroutine Delete_grid_def_1d(grid_array)
    type(grid_def), intent(inout) :: grid_array(:)
    integer :: igrid
    do igrid = 1, size(grid_array)
       call Delete(grid_array(igrid))
    end do
  end subroutine Delete_grid_def_1d
  
  !======================================================================
  !! Returns .true. iff the two grid definitions are equivalent (i.e. they
  !! may be different objects, but correspond to grids with identical 
  !! parameters). 
  !!
  !! Note that we do not check equality of the value of eps
  !! (integration precision) -- whether this is the right choice is
  !! arguable, but since it in no way affects interoperability of two
  !! grids (e.g. for convolutions between grid_conv objects), it's not
  !! too unreasonable.
  recursive function conv_CmpGridDef(gd1,gd2) result(equal)
    type(grid_def), intent(in) :: gd1, gd2
    logical :: equal
    integer :: i
    logical, parameter :: verbose = .false.

    if (gd1%nsub /= gd2%nsub) then
       equal = .false.
       return
    else if (gd1%nsub == 0) then
       if (verbose) write(0,*) gd1%dy,gd2%dy, gd1%ny, gd2%ny, gd1%ymax,gd2%ymax
       equal = (gd1%dy   == gd2%dy) .and. (gd1%ny == gd2%ny) .and.&
            &  (gd1%ymax == gd2%ymax) .and. (gd1%order == gd2%order)
    else
       equal = .true.
       if (.not.associated(gd1%subgd,gd2%subgd)) then
          do i = 1, gd1%nsub
             equal = equal .and. conv_CmpGridDef(gd1%subgd(i),gd2%subgd(i))
          end do
       end if
       equal = equal .and. (gd1%locked .eqv. gd2%locked)
    end if
  end function conv_CmpGridDef

  
  !-- useful to be able to check easily -------------------------
  ! no problem with multi
  subroutine ValidateGD(gd1,gd2,source)
    type(grid_def), intent(in) :: gd1, gd2
    character(len=*), intent(in) :: source
    if (.not. (gd1 == gd2)) then

       call wae_error('Problem validating two grid defs in ',source)
       !write(0,*) 'Problem validating two grid defs in ',source
       !stop
    end if
  end subroutine ValidateGD

  !======================================================================
  !! Return an array containing the y-value of each point on the grid
  recursive function yValues(grid) result(res)
    type(grid_def), intent(in) :: grid
    real(dp)                   :: res(0:grid%ny)
    integer :: iy, isub

    if (grid%nsub /= 0) then
       do isub = 1, grid%nsub
          res(grid%subiy(isub):grid%subiy(isub+1)-1) = yValues(grid%subgd(isub))
       end do
    else
       forall(iy=0:grid%ny) res(iy) = iy*grid%dy
    end if
  end function yValues

  
  !======================================================================
  !! Return an array containing the x-value of each point on the grid
  !!
  function xValues(grid) result(res)
    type(grid_def), intent(in) :: grid
    real(dp)                   :: res(0:grid%ny)

    res = exp(-yValues(grid))
  end function xValues

  !======================================================================
  !! return an array containing a set of indices such that the y-values
  !! are monotonically increasing. The indices assume that the grid starts
  !! at index 0. 
  !!
  !! The size of the returned array is determined dynamically and if the
  !! result is assigned (rather than used immediately), it should be
  !! assigned to an allocatable array. Keep in mind that allocatable array
  !! will start from index 1.
  !! 
  function MonotonicUniqueIndices(grid) result(indices)
    use sort
    type(grid_def), intent(in), target :: grid
    integer,        allocatable        :: indices(:)
    !----
    integer,  allocatable :: igrids(:)
    integer :: tmp_indices(0:grid%ny)
    integer :: ig, igrid, iy, ny 
    real(dp) :: last_y, dy
    real(dp), parameter :: tolerance = 1e-10_dp

    if (grid%nsub == 0) then
      ! no subsidiary grids, so just return the indices
      allocate(indices(0:grid%ny))
      indices = [(iy,iy=0,grid%ny)]
      return
    end if

    ! arrange the grids so that they have increasing dy
    ! (sort not needed in locked case, because they are guaranteed
    ! to come in increasing dy values)
    allocate(igrids(grid%nsub))
    call indexx(grid%subgd(:)%dy, igrids)
 
    ny = -1
    last_y = -one
    do ig = 1, grid%nsub
      igrid = igrids(ig)
      do iy = 0, grid%subgd(igrid)%ny
        dy = grid%subgd(igrid)%dy 
        ! the hard coded tolerance is a bit ugly, but allows us to handle both 
        ! the locked and unlocked cases
        if (dy * iy > last_y + tolerance) then
          ny = ny + 1
          tmp_indices(ny) = iy + grid%subiy(igrid)
          last_y = dy * iy
        end if
      end do
    end do
    indices = tmp_indices(0:ny)
  end function MonotonicUniqueIndices 

  !======================================================================
  !! return an array containing a containing the y values corresponding
  !! to the MonotonicUniqueIndices. 
  !!
  !! If this is assigned to an allocatable array, keep in mind that the
  !! array will start from index 1
  function MonotonicUniqueYValues(grid) result(yvals)
    type(grid_def), intent(in) :: grid
    real(dp), allocatable :: yvals(:)
    !----
    real(dp) :: all_yvals(0:grid%ny)

    all_yvals = yValues(grid)
    yvals = all_yvals(MonotonicUniqueIndices(grid))
  end function MonotonicUniqueYValues

  !======================================================================
  !! return an array containing a containing the y values corresponding
  !! to the MonotonicUniqueIndices
  !!
  !! If this is assigned to an allocatable array, keep in mind that the
  !! array will start from index 1
  function MonotonicUniqueXValues(grid) result(xvals)
    type(grid_def), intent(in) :: grid
    real(dp), allocatable :: xvals(:)
    !----
    real(dp) :: all_yvals(0:grid%ny)

    all_yvals = yValues(grid)
    xvals = exp(-all_yvals(MonotonicUniqueIndices(grid)))
  end function MonotonicUniqueXValues


  !======================================================================
  ! Things just for grid quants
  ! multi makes no difference
  subroutine conv_AllocGridQuant_1d(grid,gq)
    type(grid_def), intent(in) :: grid
    real(dp),       pointer    :: gq(:)
    !integer :: istat
    ! this form of deallocate ought to be OK (?), but on lahey,
    ! compaq+condor (and perhaps elsewhere) it causes problems
    !deallocate(gq,stat=istat)
    allocate(gq(0:grid%ny))
  end subroutine conv_AllocGridQuant_1d

  !----------------------------------------------------------------------
  ! multi makes no difference
  subroutine conv_AllocGridQuant_2d(grid,gq,nl,nh)
    type(grid_def), intent(in) :: grid
    real(dp),       pointer    :: gq(:,:)
    integer,        intent(in) :: nl,nh
    !integer :: istat
    ! this form of deallocate ought to be OK (?), but on lahey,
    ! compaq+condor (and perhaps elsewhere) it causes problems
    !deallocate(gq,stat=istat)
    allocate(gq(0:grid%ny,nl:nh))
  end subroutine conv_AllocGridQuant_2d

  !----------------------------------------------------------------------
  ! multi makes no difference
  subroutine conv_AllocGridQuant_3d(grid,gq, nl2,nh2, nl3,nh3)
    type(grid_def), intent(in) :: grid
    real(dp),       pointer    :: gq(:,:,:)
    integer,        intent(in) :: nl2,nh2,nl3,nh3
    !integer :: istat
    ! this form of deallocate ought to be OK (?), but on lahey,
    ! compaq+condor (and perhaps elsewhere) it causes problems
    !deallocate(gq,stat=istat)
    allocate(gq(0:grid%ny,nl2:nh2,nl3:nh3))
  end subroutine conv_AllocGridQuant_3d
  
  !----------------------------------------------------------
  ! multi makes no difference
  subroutine conv_DelGridQuant_1d(gq)
    real(dp),       pointer    :: gq(:)
    integer :: istat
    deallocate(gq,stat=istat)
  end subroutine conv_DelGridQuant_1d
  !----------------------------------------------------------
  ! multi makes no difference
  subroutine conv_DelGridQuant_2d(gq)
    real(dp),       pointer    :: gq(:,:)
    integer :: istat
    deallocate(gq,stat=istat)
  end subroutine conv_DelGridQuant_2d
  !----------------------------------------------------------
  ! multi makes no difference
  subroutine conv_DelGridQuant_3d(gq)
    real(dp),       pointer    :: gq(:,:,:)
    integer :: istat
    deallocate(gq,stat=istat)
  end subroutine conv_DelGridQuant_3d
  

  
  !----------------------------------------------------------------------
  ! updated for multi
  recursive subroutine conv_InitGridQuant_func(grid, gq, func)
    real(dp),         intent(inout) :: gq(0:)
    type(grid_def),   intent(in)    :: grid
    interface
       function func(x)
         use types; implicit none
         real(dp), intent(in) :: x
         real(dp)             :: func
       end function func
    end interface
    !-----------------------------------------
    integer :: iy, isub, ny

    ny = assert_eq(grid%ny,ubound(gq,dim=1),"conv_InitGridQuant_func")
    if (grid%nsub /= 0) then
       do isub = 1, grid%nsub
          call conv_InitGridQuant_func(grid%subgd(isub), &
               &gq(grid%subiy(isub):grid%subiy(isub+1)-1), func)
       end do
    else
       do iy = 0, ny
          gq(iy) = func(iy*grid%dy)
       end do
    end if
    
  end subroutine conv_InitGridQuant_func


  !----------------------------------------------------------------------
  ! updated for multi
  recursive subroutine conv_InitGridQuant_func_a(grid, gq, func, axtra)
    real(dp),         intent(inout) :: gq(0:)
    type(grid_def),   intent(in)    :: grid
    real(dp),         intent(in)    :: axtra
    interface
       function func(x,axtra)
         use types; implicit none
         real(dp), intent(in) :: x, axtra
         real(dp)             :: func
       end function func
    end interface
    !-----------------------------------------
    integer :: iy, isub, ny

    ny = assert_eq(grid%ny,ubound(gq,dim=1),"conv_InitGridQuant_func")
    if (grid%nsub /= 0) then
       do isub = 1, grid%nsub
          call conv_InitGridQuant_func_a(grid%subgd(isub), &
               &gq(grid%subiy(isub):grid%subiy(isub+1)-1), func, axtra)
       end do
    else
       do iy = 0, ny
          gq(iy) = func(iy*grid%dy, axtra)
       end do
    end if
    
  end subroutine conv_InitGridQuant_func_a


  !----------------------------------------------------------------------
  ! updated for multi
  recursive subroutine conv_InitGridQuant_func_ai(grid, gq, func, axtra, ixtra)
    real(dp),         intent(inout) :: gq(0:)
    type(grid_def),   intent(in)    :: grid
    real(dp),         intent(in)    :: axtra
    integer,          intent(in)    :: ixtra
    interface
       function func(x,axtra,ixtra)
         use types; implicit none
         real(dp), intent(in) :: x, axtra
         integer,  intent(in) :: ixtra
         real(dp)             :: func
       end function func
    end interface
    !-----------------------------------------
    integer :: iy, isub, ny

    ny = assert_eq(grid%ny,ubound(gq,dim=1),"conv_InitGridQuant_func")
    if (grid%nsub /= 0) then
       do isub = 1, grid%nsub
          call conv_InitGridQuant_func_ai(grid%subgd(isub), &
               &gq(grid%subiy(isub):grid%subiy(isub+1)-1), func, axtra, ixtra)
       end do
    else
       do iy = 0, ny
          gq(iy) = func(iy*grid%dy, axtra, ixtra)
       end do
    end if
    
  end subroutine conv_InitGridQuant_func_ai


  !----------------------------------------------------------------------
  ! updated for multi
  recursive subroutine conv_InitGridQuant_func2d(grid, gq, func)
    real(dp),         intent(inout) :: gq(0:,:)
    type(grid_def),   intent(in)    :: grid
    interface
       function func(x,n)
         use types; implicit none
         real(dp), intent(in) :: x
         integer , intent(in) :: n
         real(dp)             :: func(n)
       end function func
    end interface
    !-----------------------------------------
    integer :: iy, isub, ny, n

    ny = assert_eq(grid%ny,ubound(gq,dim=1),"conv_InitGridQuant_func")
    if (grid%nsub /= 0) then
       do isub = 1, grid%nsub
          call conv_InitGridQuant_func2d(grid%subgd(isub), &
               &gq(grid%subiy(isub):grid%subiy(isub+1)-1,:), func)
       end do
    else
       n  = ubound(gq, dim=2)
       do iy = 0, ny
          gq(iy,:) = func(iy*grid%dy, n)
       end do
    end if
  end subroutine conv_InitGridQuant_func2d

  !----------------------------------------------------------------------
  ! version intended for use when there is an extra argument whose
  ! value is fixed and needs to be passed to func
  !
  ! updated for multi
  recursive subroutine conv_InitGridQuant_func2d_a(grid, gq, func, axtra)
    real(dp),         intent(inout) :: gq(0:,:)
    type(grid_def),   intent(in)    :: grid
    real(dp),         intent(in)    :: axtra
    interface
       function func(x,axtra,n)
         use types; implicit none
         real(dp), intent(in) :: x,axtra
         integer , intent(in) :: n
         real(dp)             :: func(n)
       end function func
    end interface
    !-----------------------------------------
    integer :: iy, isub, ny, n

    ny = assert_eq(grid%ny,ubound(gq,dim=1),"conv_InitGridQuant_func2d_a")
    if (grid%nsub /= 0) then
       do isub = 1, grid%nsub
          call conv_InitGridQuant_func2d_a(grid%subgd(isub), &
               &gq(grid%subiy(isub):grid%subiy(isub+1)-1,:), func, axtra)
       end do
    else
       n  = ubound(gq, dim=2)
       do iy = 0, ny
          gq(iy,:) = func(iy*grid%dy, axtra, n)
       end do
    end if
  end subroutine conv_InitGridQuant_func2d_a

  !----------------------------------------------------------------------
  ! version intended for use when there is an extra argument whose
  ! value is fixed and needs to be passed to func
  !
  ! updated for multi
  recursive subroutine conv_InitGridQuant_func2d_ai(grid, gq, func, axtra, ixtra)
    real(dp),         intent(inout) :: gq(0:,:)
    type(grid_def),   intent(in)    :: grid
    real(dp),         intent(in)    :: axtra
    integer,          intent(in)    :: ixtra
    interface
       function func(x,axtra,ixtra,n)
         use types; implicit none
         real(dp), intent(in) :: x,axtra
         integer , intent(in) :: ixtra,n
         real(dp)             :: func(n)
       end function func
    end interface
    !-----------------------------------------
    integer :: iy, isub, ny, n

    ny = assert_eq(grid%ny,ubound(gq,dim=1),"conv_InitGridQuant_func2d_a")
    if (grid%nsub /= 0) then
       do isub = 1, grid%nsub
          call conv_InitGridQuant_func2d_ai(grid%subgd(isub), &
               &gq(grid%subiy(isub):grid%subiy(isub+1)-1,:), func, axtra, ixtra)
       end do
    else
       n  = ubound(gq, dim=2)
       do iy = 0, ny
          gq(iy,:) = func(iy*grid%dy, axtra, ixtra, n)
       end do
    end if
  end subroutine conv_InitGridQuant_func2d_ai


  !----------------------------------------------------------------------
  !! Version added specially for initialising a PDF from a LHAPDF style 
  !! interface.
  recursive subroutine InitGridQuantLHAPDF(grid, gq, LHAsub, Q)
    real(dp),         intent(inout) :: gq(0:,:)
    type(grid_def),   intent(in)    :: grid
    real(dp),         intent(in)    :: Q
    interface
       subroutine LHAsub(x,Q,res)
         use types; implicit none
         real(dp), intent(in)  :: x,Q
         real(dp), intent(out) :: res(*)
       end subroutine LHAsub
    end interface
    !-----------------------------------------
    integer  :: iy, isub, ny
    real(dp) :: f(size(gq,dim=2))

    ny = assert_eq(grid%ny,ubound(gq,dim=1),"conv_InitGridQuant_func")
    if (grid%nsub /= 0) then
       do isub = 1, grid%nsub
          call InitGridQuantLHAPDF(grid%subgd(isub), &
               &gq(grid%subiy(isub):grid%subiy(isub+1)-1,:), LHAsub, Q)
       end do
    else
       do iy = 0, ny
          call LHAsub(exp(-iy*grid%dy), Q, f)
          gq(iy,:) = f
       end do
    end if
  end subroutine InitGridQuantLHAPDF

  !----------------------------------------------------------------------
  ! updated for multi
  recursive subroutine conv_InitGridQuantSub_2d(grid, gq, sub)
    real(dp),         intent(inout) :: gq(0:,:)
    type(grid_def),   intent(in)    :: grid
    interface
       subroutine sub(y,res)
         use types; implicit none
         real(dp), intent(in)  :: y
         real(dp), intent(out) :: res(:)
       end subroutine sub
    end interface
    !-----------------------------------------
    integer :: iy, isub, ny

    ny = assert_eq(grid%ny,ubound(gq,dim=1),"conv_InitGridQuant_func")
    if (grid%nsub /= 0) then
       do isub = 1, grid%nsub
          call conv_InitGridQuantSub_2d(grid%subgd(isub), &
               &gq(grid%subiy(isub):grid%subiy(isub+1)-1,:), sub)
       end do
    else
       do iy = 0, ny
          call sub(iy*grid%dy, gq(iy,:))
       end do
    end if
  end subroutine conv_InitGridQuantSub_2d

  recursive subroutine conv_InitGridQuantSub_2d_a(grid, gq, sub, axtra)
    real(dp),         intent(inout) :: gq(0:,:)
    type(grid_def),   intent(in)    :: grid
    real(dp),         intent(in)    :: axtra
    interface
       subroutine sub(y, axtra, res)
         use types; implicit none
         real(dp), intent(in)  :: y, axtra
         real(dp), intent(out) :: res(:)
       end subroutine sub
    end interface
    !-----------------------------------------
    integer :: iy, isub, ny

    ny = assert_eq(grid%ny,ubound(gq,dim=1),"conv_InitGridQuant_func")
    if (grid%nsub /= 0) then
       do isub = 1, grid%nsub
          call conv_InitGridQuantSub_2d_a(grid%subgd(isub), &
               &gq(grid%subiy(isub):grid%subiy(isub+1)-1,:), sub, axtra)
       end do
    else
       do iy = 0, ny
          call sub(iy*grid%dy, axtra, gq(iy,:))
       end do
    end if
  end subroutine conv_InitGridQuantSub_2d_a

  recursive subroutine conv_InitGridQuantSub_2d_ai(grid, gq, sub, axtra, ixtra)
    real(dp),         intent(inout) :: gq(0:,:)
    type(grid_def),   intent(in)    :: grid
    real(dp),         intent(in)    :: axtra
    integer,          intent(in)    :: ixtra
    interface
       subroutine sub(y, axtra, ixtra, res)
         use types; implicit none
         real(dp), intent(in)  :: y, axtra
         integer,  intent(in)  :: ixtra
         real(dp), intent(out) :: res(:)
       end subroutine sub
    end interface
    !-----------------------------------------
    integer :: iy, isub, ny

    ny = assert_eq(grid%ny,ubound(gq,dim=1),"conv_InitGridQuant_func")
    if (grid%nsub /= 0) then
       do isub = 1, grid%nsub
          call conv_InitGridQuantSub_2d_ai(grid%subgd(isub), &
               &gq(grid%subiy(isub):grid%subiy(isub+1)-1,:), sub, axtra, ixtra)
       end do
    else
       do iy = 0, ny
          call sub(iy*grid%dy, axtra, ixtra, gq(iy,:))
       end do
    end if
  end subroutine conv_InitGridQuantSub_2d_ai


  !======================================================================
  ! Variants for buggy pgf90-5.1.2, using workaround suggested by
  ! Giulia
  !----------------------------------------------------------------------
  ! updated for multi
  recursive subroutine conv_InitGridQuantSub_2d_pgf(grid, gq, sub)
    real(dp),         intent(out)   :: gq(0:,:)
    type(grid_def),   intent(in)    :: grid
    interface
       subroutine sub(y,res)
         use types; implicit none
         real(dp), intent(in)  :: y
         real(dp), intent(out) :: res(:)
       end subroutine sub
    end interface
    !-----------------------------------------
    integer :: iy, isub, ny
    ! -- GZ:make a copy shifting indices to make it compatible with pgf90 
    real(dp) :: gq_cpy(1:size(gq,dim=1),1:size(gq,dim=2))

    ny = assert_eq(grid%ny,ubound(gq,dim=1),"conv_InitGridQuant_func")
    if (grid%nsub /= 0) then
       do isub = 1, grid%nsub
          call conv_InitGridQuantSub_2d(grid%subgd(isub), &
               &gq_cpy(grid%subiy(isub)+1:grid%subiy(isub+1),:), sub)
       end do
    else
       do iy = 0, ny
          call sub(iy*grid%dy, gq_cpy(iy+1,:))
       end do
    end if
    do iy=0,ny
       gq(iy,:) = gq_cpy(iy+1,:)
    end do
  end subroutine conv_InitGridQuantSub_2d_pgf

  recursive subroutine conv_InitGridQuantSub_2d_a_pgf(grid, gq, sub, axtra)
    real(dp),         intent(out)   :: gq(0:,:)
    type(grid_def),   intent(in)    :: grid
    real(dp),         intent(in)    :: axtra
    interface
       subroutine sub(y, axtra, res)
         use types; implicit none
         real(dp), intent(in)  :: y, axtra
         real(dp), intent(out) :: res(:)
       end subroutine sub
    end interface
    !-----------------------------------------
    integer :: iy, isub, ny
    real(dp) :: gq_cpy(1:size(gq,dim=1),1:size(gq,dim=2))

    ny = assert_eq(grid%ny,ubound(gq,dim=1),"conv_InitGridQuant_func")
    if (grid%nsub /= 0) then
       do isub = 1, grid%nsub
          call conv_InitGridQuantSub_2d_a(grid%subgd(isub), &
               &gq_cpy(grid%subiy(isub)+1:grid%subiy(isub+1),:), sub, axtra)
       end do
    else
       do iy = 0, ny
          call sub(iy*grid%dy, axtra, gq_cpy(iy+1,:))
       end do
    end if
    do iy=0,ny
       gq(iy,:) = gq_cpy(iy+1,:)
    end do
  end subroutine conv_InitGridQuantSub_2d_a_pgf

  recursive subroutine conv_InitGridQuantSub_2d_ai_pgf(grid, gq, sub, axtra, ixtra)
    real(dp),         intent(out)   :: gq(0:,:)
    type(grid_def),   intent(in)    :: grid
    real(dp),         intent(in)    :: axtra
    integer,          intent(in)    :: ixtra
    interface
       subroutine sub(y, axtra, ixtra, res)
         use types; implicit none
         real(dp), intent(in)  :: y, axtra
         integer,  intent(in)  :: ixtra
         real(dp), intent(out) :: res(:)
       end subroutine sub
    end interface
    !-----------------------------------------
    integer :: iy, isub, ny
    real(dp) :: gq_cpy(1:size(gq,dim=1),1:size(gq,dim=2))

    ny = assert_eq(grid%ny,ubound(gq,dim=1),"conv_InitGridQuant_func")
    if (grid%nsub /= 0) then
       do isub = 1, grid%nsub
          call conv_InitGridQuantSub_2d_ai(grid%subgd(isub), &
               &gq_cpy(grid%subiy(isub)+1:grid%subiy(isub+1),:), sub, axtra, ixtra)
       end do
    else
       do iy = 0, ny
          call sub(iy*grid%dy, axtra, ixtra, gq_cpy(iy+1,:))
       end do
    end if
    do iy=0,ny
       gq(iy,:) = gq_cpy(iy+1,:)
    end do
  end subroutine conv_InitGridQuantSub_2d_ai_pgf


  !--------------------------------------------------------------------
  ! multi-grid done
  recursive function conv_EvalGridQuant_0d(grid, gq, y) result(f)
    use interpolation
    type(grid_def), intent(in) :: grid
    real(dp), intent(in) :: gq(0:)
    real(dp), intent(in) :: y
    real(dp) :: f
    !-----------------------------------------
    integer :: i, ny, npnt, isub
    real(dp), parameter :: resc_yvals(npnt_max) = (/ (i,i=0,npnt_max-1) /)
    real(dp) :: wgts(npnt_max)
    character(len=200) :: err_string1, err_string2

    !write(0,*) y,grid%ny, ubound(gq,dim=1)
    ny = assert_eq(grid%ny,ubound(gq,dim=1),"EvalGridQuant")
    if (y > grid%ymax*(one+warn_tolerance)) then
       write(err_string1,*) 'EvalGridQuant: &
            &requested function value beyond maximum'
       write(err_string2,*) 'y = ', y, 'ymax=',grid%ymax
       call wae_error(trim(err_string1), trim(err_string2))
       !write(0,*) 'EvalGridQuant: &
       !     &requested function value beyond maximum'
       !write(0,*) 'y = ', y, 'ymax=',grid%ymax
       !stop
    end if
    if (grid%nsub /= 0) then
       isub = conv_BestIsub(grid,y)
       f = EvalGridQuant(grid%subgd(isub), &
            & gq(grid%subiy(isub):grid%subiy(isub+1)-1), y)
    else
       npnt = min(npnt_max, max(npnt_min, abs(grid%order)))
       
       i = min(max(floor(y / grid%dy)-(npnt-1)/2,0),ny-npnt+1)
       call uniform_interpolation_weights(y/grid%dy - i, wgts(1:npnt))
       f = sum(wgts(1:npnt)*gq(i:i+npnt-1))
       !-- this was less efficient...
       !call polint(resc_yvals(1:npnt),gq(i:i+npnt-1),y/grid%dy-i,f,df)
!!$    i = min(grid%ny - 1, floor(y / grid%dy))
!!$    ey = y/grid%dy - i
!!$    f  = (one-ey)*gq(i) + ey*gq(i+1)
    end if
    
  end function conv_EvalGridQuant_0d

  !--------------------------------------------------------------------
  !! 1-D version of grid evaluation.
  !! 
  !! NB: we rewrite everything above so as to avoid unnecessary looping.
  !!     It would be better to have a common routine that gives the
  !!     required set of points and weights?
  recursive function conv_EvalGridQuant_1d(grid, gq, y) result(f)
    use interpolation
    type(grid_def), intent(in) :: grid
    real(dp), intent(in) :: gq(0:,1:)
    real(dp), intent(in) :: y
    real(dp) :: f(size(gq,dim=2))
    !-----------------------------------------
    integer :: i, j, ny, npnt, isub
    !real(dp) :: ey, df
    real(dp), parameter :: resc_yvals(npnt_max) = (/ (i,i=0,npnt_max-1) /)
    real(dp) :: wgts(npnt_max)
    character(len=200) :: err_string1, err_string2

    !write(0,*) y,grid%ny, ubound(gq,dim=1)
    ny = assert_eq(grid%ny,ubound(gq,dim=1),"EvalGridQuant")
    if (y > grid%ymax*(one+warn_tolerance)) then
       write(err_string1,*) 'EvalGridQuant: &
            &requested function value beyond maximum'
       write(err_string2,*) 'y = ', y, 'ymax=',grid%ymax
       call wae_error(trim(err_string1), trim(err_string2))
       !write(0,*) 'EvalGridQuant: &
       !     &requested function value beyond maximum'
       !write(0,*) 'y = ', y, 'ymax=',grid%ymax
       !stop
    end if
    if (grid%nsub /= 0) then
       isub = conv_BestIsub(grid,y)
       f = conv_EvalGridQuant_1d(grid%subgd(isub), &
            & gq(grid%subiy(isub):grid%subiy(isub+1)-1,:), y)
    else
       npnt = min(npnt_max, max(npnt_min, abs(grid%order)))
       
       i = min(max(floor(y / grid%dy)-(npnt-1)/2,0),ny-npnt+1)
       call uniform_interpolation_weights(y/grid%dy - i, wgts(1:npnt))
       do j = 1, size(f)
          f(j) = sum(wgts(1:npnt)*gq(i:i+npnt-1,j))
       end do
       
       !-- this was less efficient...
       !call polint(resc_yvals(1:npnt),gq(i:i+npnt-1),y/grid%dy-i,f,df)
!!$    i = min(grid%ny - 1, floor(y / grid%dy))
!!$    ey = y/grid%dy - i
!!$    f  = (one-ey)*gq(i) + ey*gq(i+1)
    end if
  end function conv_EvalGridQuant_1d

!O  !--------------------------------------------------------------------
!O  !! 1-D version of grid evaluation.
!O  !! 
!O  !! NB: this is currently VERY slow because interpolation is recalculated
!O  !!     from scratch for each component of the grid quantity
!O  function conv_EvalfGridQuant_1d(grid, gq, y) result(f)
!O    type(grid_def), intent(in) :: grid
!O    real(dp), intent(in) :: gq(0:,1:)
!O    real(dp), intent(in) :: y
!O    real(dp) :: f(size(gq,dim=2))
!O    integer :: i
!O    do i = 1, size(gq,dim=2)
!O       f(i) = conv_EvalGridQuant_0d(grid,gq(:,i),y)
!O    end do
!O  end function conv_EvalfGridQuant_1d
  

  !--------------------------------------------------------------------
  ! Returns starting iymin point and a set of weights in order to calculate
  ! the value of the function at y -- one day we might introduce some
  ! option of setting the number of points; but not for now...
  !
  ! Qu: is the relation between number of points and order correct? It seems
  !     like we ought to have abs(grid%order)+1...
  recursive subroutine WgtGridQuant(grid, y, iylo, wgts)
    use interpolation
    type(grid_def), intent(in) :: grid
    real(dp), intent(in)  :: y
    integer,  intent(out) :: iylo
    real(dp), pointer     :: wgts(:)
    !-----------------------------------------
    integer :: ny, npnt, isub
    character(len=200) :: err_string1, err_string2

    ny = grid%ny
    if (grid%nsub /= 0) then
       isub = conv_BestIsub(grid,y)
       call WgtGridQuant(grid%subgd(isub), y, iylo, wgts)
       iylo = iylo + grid%subiy(isub)
    else
       ! nan fails all comparison tests; arrange the tests so that
       ! if we have a nan, then we will get something out of range.
       if (.not.(y <= grid%ymax*(one+warn_tolerance) .and. y >= -warn_tolerance)) then
          write(err_string1,*) 'WgtGridQuant: &
               &requested function value outside y range'
          write(err_string2,*) 'y = ', y, ' but should be 0 < y < ymax=',grid%ymax
          call wae_error(trim(err_string1), trim(err_string2))
          !write(0,*) 'WgtGridQuant: &
          !     &requested function value outside y range'
          !write(0,*) 'y = ', y, ' but should be 0 < y < ymax=',grid%ymax
          !stop
       end if
       
       npnt = min(npnt_max, max(npnt_min, abs(grid%order)))
       allocate(wgts(0:npnt-1))
       
       iylo = min(max(floor(y / grid%dy)-(npnt-1)/2,0),ny-npnt+1)
       call uniform_interpolation_weights(y/grid%dy-iylo, wgts)
    end if
  end subroutine WgtGridQuant
  

  !--------------------------------------------------------------------
  ! Returns starting iymin point and a set of weights in order to calculate
  ! the value of the function at y
  !
  ! Inputs:
  !   - grid  : the grid structure
  !   - y     : the value at which to evaluate the function
  !
  ! Outputs:
  !   - iylo: the lowest grid point for the interpolation
  !   - wgts(0:npnt-1): the weights for the interpolation
  !   - npnt: the number of points to be used in the interpolation
  !
  ! Optional inputs:
  !   If npnt_in is present and positive then it is used to set the number of points
  !   to use in the interpolation; otherwise the number of points is set based on the grid
  !   and the npnt_min and npnt_max parameters at the top of this file.
  !
  ! Qu: is the relation between number of points and order correct? It seems
  !     like we ought to have abs(grid%order)+1...
  recursive subroutine WgtGridQuant_noalloc(grid, y, iylo, wgts, npnt, npnt_in)
    use interpolation
    type(grid_def), intent(in) :: grid
    real(dp), intent(in)  :: y
    integer,  intent(out) :: iylo
    real(dp), intent(out) :: wgts(0:)
    integer , intent(out) :: npnt
    integer , intent(in), optional :: npnt_in
    !-----------------------------------------
    integer :: ny, isub
    character(len=200) :: err_string1, err_string2

    ny = grid%ny
    if (grid%nsub /= 0) then
       isub = conv_BestIsub(grid,y)
       call WgtGridQuant_noalloc(grid%subgd(isub), y, iylo, wgts, npnt, npnt_in)
       iylo = iylo + grid%subiy(isub)
    else
       ! nan fails all comparison tests; arrange the tests so that
       ! if we have a nan, then we will get something out of range.
       if (.not.(y <= grid%ymax*(one+warn_tolerance) .and. y >= -warn_tolerance)) then
          write(err_string1,*) 'WgtGridQuant_noalloc: &
               &requested function value outside y range'
          write(err_string2,*) 'y = ', y, ' but should be 0 < y < ymax=',grid%ymax
          call wae_error(trim(err_string1), trim(err_string2))
       end if
       
       npnt = default_or_opt(-1,npnt_in)
       if (npnt <= 0) npnt = min(npnt_max, max(npnt_min, abs(grid%order)))
       
       iylo = min(max(floor(y / grid%dy)-(npnt-1)/2,0),ny-npnt+1)
       call uniform_interpolation_weights(y/grid%dy-iylo, wgts(0:npnt-1))
    end if
  end subroutine WgtGridQuant_noalloc
  

  !! returns the index of the best subgrid to use for the given y value
  !! 
  !! Mainly intended for internal use. Note also that if any of the logic
  !! here changes, one should also revisit tab_get_grid_ptr(...) in pdf_tabulate.f90, 
  !! which replicates much of the functionality, but is coded separately
  !! for speed reasons.
  function conv_BestIsub(grid,y) result(isub)
    type(grid_def), intent(in) :: grid
    real(dp),       intent(in) :: y
    integer                    :: isub
    !-----------------------------------------
    ! real(dp) :: smallest_ymax
    ! integer  :: i

    ! 2025-09-03 GPS+AK, on M2Pro, this variant seemed to make no timing
    ! difference, even though it avoids loops and exploits the known
    ! ordering of the grid sizes and should bail out quickly in the 
    ! most common (large-y) cases.
    !if (grid%nsub == 4 .and. grid%locked) then
    !  !! in this case, we have a guarantee that grids have increasing ymax
    !  if (y > grid%subgd(3)%ymax) then
    !     isub = 4
    !  else if (y > grid%subgd(2)%ymax) then
    !     isub = 3
    !  else if (y > grid%subgd(1)%ymax) then
    !     isub = 2
    !  else
    !     isub = 1
    !  end if
    !  return
    !end if

    !-- this will probably slow things down, but
    !   for the time being accept this penalty
    ! find the grid with the smallest ymax > y
    if (y>grid%ymax) then
       !isub = sum(maxloc(grid%subgd%ymax))
       isub = maxloc(grid%subgd%ymax,dim=1)
    else
      !! there is a danger this route might need more loops, unless well optimised
      !! by the compiler
      isub = minloc(grid%subgd%ymax,dim=1,mask=(grid%subgd%ymax>=y))

      !! the following avoids two loops, but timing test on 2024-11-29 (Mac M2, -O2)
      !! showed no significant difference in timing
      ! smallest_ymax = 1e200_dp
      ! do i = 1, grid%nsub
      !    if (grid%subgd(i)%ymax > y .and. grid%subgd(i)%ymax < smallest_ymax) then
      !       isub = i
      !       smallest_ymax = grid%subgd(i)%ymax
      !    end if
      ! end do
    end if
  end function conv_BestIsub
  
  !----------------------------------------------------------------------
  ! not yet updated for multi-grid purposes, because would require
  ! a little bit of thought as to how to treat different grid regions
  function MomGridQuant(grid,gq,omega) result(res)
    type(grid_def), intent(in) :: grid
    real(dp), intent(in) :: gq(0:)
    real(dp), intent(in) :: omega
    real(dp) :: res
    !-----------------------------------------
    real(dp) :: weight, weightprod, dy
    integer :: i, ny

    if (grid%nsub /= 0) then
       write(0,*) 'ERROR in MomGridQuant:&
            & multiple grids not yet supported'
    end if
    
    ny = assert_eq(grid%ny,ubound(gq,dim=1),"MomGridQuant")
    dy = grid%dy
    if (omega == zero) then
       weight = grid%dy
       weightprod = one
       res = half*weight*gq(0)
    else
       weightprod = exp(-dy*omega)
       weight = (exp(-dy*omega) - one + dy*omega)/(dy*omega**2)
       res = weight*gq(0)
       weight = weight + &
            & (exp(+dy*omega) - one - dy*omega)/(dy*omega**2)
    end if
    do i = 1, ny
       weight = weight * weightprod
       if (i == ny) weight = weight * half
       res = res + weight*gq(i)
    end do
  end function MomGridQuant
  

  !----------------------------------------------------------------------
  ! Use a non-sophisticated fix for the multi-grid option, just take the
  ! largest of the dy values if none is specified (so as to avoid information
  ! overload).
  subroutine conv_PrintGridQuant_1(grid,gq,dy,dev)
    type(grid_def), intent(in) :: grid
    real(dp), intent(in) :: gq(0:)
    real(dp), intent(in), optional :: dy
    integer,  intent(in), optional :: dev
    real(dp) :: dy_local, y, q
    integer :: ny, i, dev_local
    
    ny = assert_eq(grid%ny,ubound(gq,dim=1),'PrintGridQuant')
    if (grid%nsub /= 0) then
       dy_local = default_or_opt(maxval(grid%subgd%dy),dy)
    else
       dy_local = default_or_opt(grid%dy,dy)
    end if
    dev_local = default_or_opt(6,dev)

    ny = floor(grid%ymax / dy_local)
    do i = 0, ny
       y = i*dy_local
       q = EvalGridQuant(grid, gq, y)
       write(dev_local,*) y, exp(-y),q
    end do
    
  end subroutine conv_PrintGridQuant_1

  !----------------------------------------------------------------------
  ! See conv_PrintGridQuant_1 re multigrid
  subroutine conv_PrintGridQuant_2(grid,gq,gq2,dy,dev)
    type(grid_def), intent(in) :: grid
    real(dp), intent(in) :: gq(0:),gq2(0:)
    real(dp), intent(in), optional :: dy
    integer,  intent(in), optional :: dev
    real(dp) :: dy_local, y,  q,q2
    integer :: ny, i, dev_local
    
    ny = assert_eq(grid%ny,ubound(gq,dim=1),&
         & ubound(gq2,dim=1),'PrintGridQuant')
    if (grid%nsub /= 0) then
       dy_local = default_or_opt(maxval(grid%subgd%dy),dy)
    else
       dy_local = default_or_opt(grid%dy,dy)
    end if
    dev_local = default_or_opt(6,dev)

    ny = floor(grid%ymax / dy_local)
    do i = 0, ny
       y = i*dy_local
       q  = EvalGridQuant(grid, gq, y)
       q2 = EvalGridQuant(grid, gq2, y)
       write(dev_local,'(25es25.16)') y, exp(-y),q, q2
    end do
    
  end subroutine conv_PrintGridQuant_2

  !----------------------------------------------------------------------
  ! See conv_PrintGridQuant_1 re multigrid
  subroutine conv_PrintGridQuant_3(grid,gq,gq2,gq3,dy,dev)
    type(grid_def), intent(in) :: grid
    real(dp), intent(in) :: gq(0:),gq2(0:),gq3(0:)
    real(dp), intent(in), optional :: dy
    integer,  intent(in), optional :: dev
    real(dp) :: dy_local, y, x, q,q2,q3
    integer :: ny, i, dev_local
    
    ny = assert_eq(grid%ny,ubound(gq,dim=1),&
         & ubound(gq2,dim=1),ubound(gq3,dim=1),&
         & 'PrintGridQuant: distributions must be same size')
    if (grid%nsub /= 0) then
       dy_local = default_or_opt(maxval(grid%subgd%dy),dy)
    else
       dy_local = default_or_opt(grid%dy,dy)
    end if
    dev_local = default_or_opt(6,dev)

    ny = floor(grid%ymax / dy_local)
    do i = 0, ny
       y = i*dy_local
       q  = EvalGridQuant(grid, gq, y)
       q2 = EvalGridQuant(grid, gq2, y)
       q3 = EvalGridQuant(grid, gq3, y)
       write(dev_local,'(25es25.16)') y, exp(-y),q, q2, q3
    end do
    
  end subroutine conv_PrintGridQuant_3
  
  !----------------------------------------------------------------------
  ! See conv_PrintGridQuant_1 re multigrid
  subroutine conv_PrintGridQuant_4(grid,gq,gq2,gq3,gq4,dy,dev)
    type(grid_def), intent(in) :: grid
    real(dp), intent(in) :: gq(0:),gq2(0:),gq3(0:),gq4(0:)
    real(dp), intent(in), optional :: dy
    integer,  intent(in), optional :: dev
    real(dp) :: dy_local, y, q,q2,q3, q4
    integer :: ny, i, dev_local
    
    ny = assert_eq(grid%ny,ubound(gq,dim=1),&
         & ubound(gq2,dim=1),ubound(gq3,dim=1),ubound(gq4,dim=1),&
         & 'PrintGridQuant: distributions must be same size')
    if (grid%nsub /= 0) then
       dy_local = default_or_opt(maxval(grid%subgd%dy),dy)
    else
       dy_local = default_or_opt(grid%dy,dy)
    end if
    dev_local = default_or_opt(6,dev)

    ny = floor(grid%ymax / dy_local)
    do i = 0, ny
       y = i*dy_local
       q  = EvalGridQuant(grid, gq, y)
       q2 = EvalGridQuant(grid, gq2, y)
       q3 = EvalGridQuant(grid, gq3, y)
       q4 = EvalGridQuant(grid, gq4, y)
       write(dev_local,'(25es25.16)') y, exp(-y),q, q2, q3, q4
    end do
    
  end subroutine conv_PrintGridQuant_4


  !======================================================================
  ! Routines related to calculations of moments
  !======================================================================

  !---------------------------------------------------------------------
  !! Computes the truncated moment between 0 and min(y,ymax)
  !! of the grid quantity gq with the moment index defined as
  !!
  !! Define the function which is going to be integrated
  !! Multiply the pdf by exp( - y * moment_index)
  !! Moment index are defined as
  !! 
  !!  M(moment_index) = \int_0^ymax dy exp( - y * moment_index) * xpdf(y)
  !! 
  !! or in terms of x, where y = ln(1/x)
  !!
  !!   M(moment_index) = \int_xmin^1 dx x^( moment_index - 1) * xpdf(x)
  !! 
  !! where xpdf(y) is gq .aty. (y .with. gd)
  !-------------------------------------------------------------
  function conv_TruncatedMoment_1d(gd, gq, moment_index, y) result(res)
    use integrator
    type(grid_def), intent(in) :: gd
    real(dp),       intent(in) :: gq(0:), moment_index
    real(dp), intent(in), optional :: y
    real(dp)                   :: res, ymax,yl,yh,eps
    integer :: ny
    !-----------------------------------------------------
    
    res = zero
    
    ! global variables to pass to auxiliary conv_TruncatedMoment_helper
    ! inefficient to make copies, but works around impossibility
    ! of having pointers to intent(in) objects???
    conv_moment_index = moment_index
    conv_moment_gd    = gd
    allocate( conv_moment_gq(0:gd%ny) )
    conv_moment_gq    = gq
    
    ! Check dimensions are correct
    ! write(6,*) gd%ny, ubound(gq,dim=1)
    ny = assert_eq(gd%ny,ubound(gq,dim=1),"EvalGridQuant")
    if( gd%ny .ne. ubound(gq,dim=1) ) &
         & call wae_error("Different dimensions for ",&
         & "grid quantity and grid in conv_TruncatedMoment_1d")

  
    ! Get ymax, upper integration limit
    ymax = default_or_opt(gd%ymax, y)
    ! Warning: the upper integration limit cannot be larger than
    ! ymax from the grid definition
    !write(6,*) ymax
    if (ymax > gd%ymax) call wae_error("Input value for y",&
         & "for computation of truncated moment",&
         & "larger than ymax from grid")
    
    ! Set convolution for integration
    eps = default_conv_eps

    ! Integrate between 0 and ymax
    ! Do the integration in two steps to improve accuracy
    ! Check ymax > two, the indermediate limit
    yl=zero
    yh=ymax
    res = ig_LinWeight(conv_TruncatedMoment_helper,&
         & yl,min(two,ymax),one,one,eps)
    res = res +  ig_LinWeight(conv_TruncatedMoment_helper,&
         & min(two,ymax),ymax, one,one,eps)

    ! Dealocate auxiliary grid quantity
    deallocate( conv_moment_gq )

  end function conv_TruncatedMoment_1d

  !----------------------------------------------------------------------
  ! a 2d version of TruncatedMoment
  function conv_TruncatedMoment_2d(gd, gq, moment_index, y) result(res)
    type(grid_def), intent(in) :: gd
    real(dp),       intent(in) :: gq(0:,:), moment_index
    real(dp), intent(in), optional :: y
    real(dp) :: res(size(gq,dim=2))
    !---------------------------------
    integer :: i
    do i = 1, size(gq,dim=2)
       res(i) = conv_TruncatedMoment_1d(gd, gq(:,i), moment_index, y)
    end do
  end function conv_TruncatedMoment_2d
  
  
  !------------------------------------------------
  ! Auxiliary function for conv_TruncatedMoment_1d
  !------------------------------------------------
  function conv_TruncatedMoment_helper(y) result(res)
    real(dp), intent(in) :: y 
    real(dp) :: res

    res = exp( -y * conv_moment_index ) &
         & * EvalGridQuant(conv_moment_gd,conv_moment_gq,y) 
   
  end function conv_TruncatedMoment_helper
  

  !======================================================================
  ! Routines related to convolutions
  !======================================================================

  !----------------------------------------------------------------------
  !! set the default integration precision
  subroutine SetDefaultConvolutionEps(eps)
    real(dp), intent(in) :: eps
    default_conv_eps = eps
  end subroutine SetDefaultConvolutionEps

  !----------------------------------------------------------------------
  !! set the default integration precision
  real(dp) function DefaultConvolutionEps() result(res)
    res = default_conv_eps
  end function DefaultConvolutionEps
  

  !------------------------------------------------------------------
  ! Just does the memory allocation
  recursive subroutine conv_AllocGridConv_0d(grid,gc)
    type(grid_def),  intent(in)    :: grid
    type(grid_conv), intent(inout) :: gc
    !-------------------------------------------
    integer :: isub
    
    gc%grid = grid
    if (gc%grid%nsub /= 0) then
       nullify(gc%conv) ! avoid doing anything too stupid...
       allocate(gc%subgc(gc%grid%nsub))
       do isub = 1, gc%grid%nsub
          call conv_AllocGridConv_0d(grid%subgd(isub),gc%subgc(isub))
       end do
    else
       nullify(gc%subgc)
       ! this form of deallocate ought to be OK (?), but on lahey,
       ! compaq+condor (and perhaps elsewhere) it causes problems
       !deallocate(gc%conv,stat=istat)
       if (grid%order == LIN_ORDER) then
          allocate(gc%conv(0:grid%ny,2))
       else if (grid%order > LIN_ORDER) then
          allocate(gc%conv(0:grid%ny,0:grid%order+1))
       else
          allocate(gc%conv(0:grid%ny,1))
       end if
    end if
  end subroutine conv_AllocGridConv_0d

  !-----------------------------------------------------------------
  ! Handy to have multi-dimensional versions of the above
  subroutine conv_AllocGridConv_1d(grid,gc)
    type(grid_def),  intent(in)    :: grid
    type(grid_conv), intent(inout) :: gc(:)
    !-------------------------------------------
    integer :: i
    do i = 1, size(gc)
       call conv_AllocGridConv_0d(grid,gc(i))
    end do
  end subroutine conv_AllocGridConv_1d
  subroutine conv_AllocGridConv_2d(grid,gc)
    type(grid_def),  intent(in)    :: grid
    type(grid_conv), intent(inout) :: gc(:,:)
    !-------------------------------------------
    integer :: i,j
    do i = 1, size(gc,dim=2)
       do j = 1, size(gc,dim=1)
          call conv_AllocGridConv_0d(grid,gc(j,i))
       end do
    end do
  end subroutine conv_AllocGridConv_2d


  !======================================================================
  !! Return .true. if the gc is currently allocated, .false. otherwise
  function GridConvAllocated(gc)
    logical :: GridConvAllocated
    type(grid_conv), intent(in) :: gc
    GridConvAllocated = associated(gc%conv) .or. associated(gc%subgc)
    !GridConvAllocated = .false.
  end function GridConvAllocated
  
  !--------------------------------------------------------------------
  ! initialise a grid convolution with zero
  ! Default for alloc is .true.; writing it this way allows
  ! in principle the possibility of a more levels of recursion
  ! in the grid def, should one ever want to have the option...
  recursive subroutine conv_InitGridConv_zero(grid,gc,alloc)
    type(grid_def),  intent(in)    :: grid
    type(grid_conv), intent(inout) :: gc
    logical,         intent(in), optional :: alloc
    !-------------------------------------------
    integer :: isub

    if (default_or_opt(.not.GridConvAllocated(gc),alloc)) then
       call AllocGridConv(grid,gc)
    else
       call ValidateGD(grid, gc%grid, 'conv_InitGridConv_zero')
    end if

    if (grid%nsub /= 0) then
       do isub = 1, grid%nsub
          ! remember not to do double allocate
          call conv_InitGridConv_zero(grid%subgd(isub),&
               &gc%subgc(isub),alloc=.false.)
       end do
    else
       gc%conv = zero
    end if
    
  end subroutine conv_InitGridConv_zero

  !-----------------------------------------------------------------
  ! Handy to have multi-dimensional versions of the above
  subroutine conv_InitGridConv_zero_1d(grid,gc,alloc)
    type(grid_def),  intent(in)    :: grid
    type(grid_conv), intent(inout) :: gc(:)
    logical,         intent(in), optional :: alloc
    !-------------------------------------------
    integer :: i
    do i = 1, size(gc)
       call conv_InitGridConv_zero(grid,gc(i),alloc)
    end do
  end subroutine conv_InitGridConv_zero_1d
  subroutine conv_InitGridConv_zero_2d(grid,gc,alloc)
    type(grid_def),  intent(in)    :: grid
    type(grid_conv), intent(inout) :: gc(:,:)
    logical,         intent(in), optional :: alloc
    !-------------------------------------------
    integer :: i,j
    do i = 1, size(gc,dim=2)
       do j = 1, size(gc,dim=1)
          call conv_InitGridConv_zero(grid,gc(j,i),alloc)
       end do
    end do
  end subroutine conv_InitGridConv_zero_2d
  

  !--------------------------------------------------------------------
  ! initialise a grid convolution with another gc, potentially multiplied
  ! by a factor. Qu: is alloc supposed to be used from outside?
  recursive subroutine conv_InitGridConv_gc(gc,gcin,fact,alloc)
    type(grid_conv), intent(inout) :: gc
    type(grid_conv), intent(in)    :: gcin
    real(dp),        intent(in), optional :: fact
    logical,         intent(in), optional :: alloc
    !-------------------------------------------
    integer :: isub

    if (default_or_opt(.not.GridConvAllocated(gc),alloc)) then
       call AllocGridConv(gcin%grid,gc)
    else
       call ValidateGD(gcin%grid,gc%grid,'conv_InitGridConv_gc')
    end if

    if (gcin%grid%nsub /= 0) then
       do isub = 1, gcin%grid%nsub
          ! remember not to do double allocate
          call conv_InitGridConv_gc(gc%subgc(isub),&
               &gcin%subgc(isub),fact=fact,alloc=.false.)
       end do
    else
       if (present(fact)) then
          gc%conv = gcin%conv * fact
       else
          gc%conv = gcin%conv
       end if
    end if
  end subroutine conv_InitGridConv_gc

  !-----------------------------------------------------------------
  ! Handy to have multi-dimensional versions of the above
  subroutine conv_InitGridConv_gc_1d(gc,gcin,fact,alloc)
    type(grid_conv), intent(inout) :: gc(:)
    type(grid_conv), intent(in)    :: gcin(:)
    real(dp),        intent(in), optional :: fact
    logical,         intent(in), optional :: alloc
    !-------------------------------------------
    integer :: i, ni
    ni = assert_eq(size(gc),size(gcin),'conv_InitGridConv_gc_1d')
    do i = 1, ni
       call conv_InitGridConv_gc(gc(i),gcin(i),fact,alloc)
    end do
  end subroutine conv_InitGridConv_gc_1d
  subroutine conv_InitGridConv_gc_2d(gc,gcin,fact,alloc)
    type(grid_conv), intent(inout) :: gc(:,:)
    type(grid_conv), intent(in)    :: gcin(:,:)
    real(dp),        intent(in), optional :: fact
    logical,         intent(in), optional :: alloc
    !-------------------------------------------
    integer :: i,j,ni,nj
    ni = assert_eq(size(gc,dim=2),size(gcin,dim=2),'conv_InitGridConv_gc_1d')
    nj = assert_eq(size(gc,dim=1),size(gcin,dim=1),'conv_InitGridConv_gc_1d')
    do i = 1, ni
       do j = 1, nj
          call conv_InitGridConv_gc(gc(j,i),gcin(j,i),fact,alloc)
       end do
    end do
  end subroutine conv_InitGridConv_gc_2d


  !----------------------------------------------------------------------
  ! Initialise a convoluter with the function to use in the 
  ! convolution. 
  subroutine conv_InitGridConv_func(grid, gc, func, alloc, split)
    type(grid_def),  intent(in)    :: grid
    type(grid_conv), intent(inout) :: gc
    interface
       function func(y)
         import dp
         !use types; implicit none
         real(dp), intent(in) :: y
         real(dp)             :: func
       end function func
    end interface
    logical,         intent(in), optional :: alloc
    real(dp),        intent(in), optional :: split(:)
    !-------------------------------------------

    !if (default_or_opt(.not.GridConvAllocated(gc),alloc)) call conv_InitGridConv_zero(grid,gc)
    call conv_InitGridConv_zero(grid,gc,alloc)
    
    call AddWithCoeff(gc,func, split=split)
  end subroutine conv_InitGridConv_func

  !----------------------------------------------------------------------
  ! Initialise a convoluter with the function to use in the 
  ! convolution. 
  subroutine conv_InitGridConv_ignd(grid,gc,gc_ignd,alloc, split)
    type(grid_def),    intent(in)    :: grid
    type(grid_conv),   intent(inout) :: gc
    class(conv_ignd),  intent(in)    :: gc_ignd
    logical,           intent(in), optional :: alloc
    real(dp),          intent(in), optional :: split(:)

    !if (default_or_opt(.not.GridConvAllocated(gc),alloc)) call conv_InitGridConv_zero(grid,gc)
    call conv_InitGridConv_zero(grid,gc)
    
    call conv_AddGridConv_ignd(gc, gc_ignd, split=split)
  end subroutine conv_InitGridConv_ignd

  !----------------------------------------------------------------------
  ! Initialise a convoluter with the function to use in the 
  ! convolution. 
  subroutine conv_InitGridConv_conv(gc,gca,gcb,alloc)
    type(grid_conv),  intent(inout) :: gc
    type(grid_conv),  intent(in)    :: gca, gcb
    logical,          intent(in), optional :: alloc
    !-------------------------------------------

    if (default_or_opt(.not.GridConvAllocated(gc),alloc)) then
       call AllocGridConv(gca%grid,gc)
    else
       call ValidateGD(gc%grid, gca%grid,&
            & 'conv_InitGridConv_conv: gc and gca')
    end if
    
    call SetToConvolution(gc,gca, gcb)
  end subroutine conv_InitGridConv_conv

  !------------------------------------------------------------------
  ! Zero the contents of the grid convolution
  !
  recursive subroutine conv_ZeroGridConv_0d(gc)
    type(grid_conv), intent(inout) :: gc
    integer :: isub
    if (gc%grid%nsub /= 0) then
       do isub = 1, gc%grid%nsub
          call SetToZero(gc%subgc(isub))
       end do
    else
       gc%conv = zero
    end if
  end subroutine conv_ZeroGridConv_0d
  ! Handy to have multi-dimensional versions of the above
  subroutine conv_ZeroGridConv_1d(gc)
    type(grid_conv), intent(inout) :: gc(:)
    !-------------------------------------------
    integer :: i
    do i = 1, size(gc)
       call conv_ZeroGridConv_0d(gc(i))
    end do
  end subroutine conv_ZeroGridConv_1d
  subroutine conv_ZeroGridConv_2d(gc)
    type(grid_conv), intent(inout) :: gc(:,:)
    !-------------------------------------------
    integer :: i,j
    do i = 1, size(gc,dim=2)
       do j = 1, size(gc,dim=1)
          call conv_ZeroGridConv_0d(gc(j,i))
       end do
    end do
  end subroutine conv_ZeroGridConv_2d
  
  !--------------------------------------------------------
  ! Remove memory associated with a given gc.
  recursive subroutine conv_DelGridConv_0d(gc)
    type(grid_conv), intent(inout) :: gc
    !-------------------------------------------
    integer :: istat, isub
    
    if (.not. GridConvAllocated(gc)) return

    if (gc%grid%nsub /= 0) then
       do isub = 1, gc%grid%nsub
          call conv_DelGridConv_0d(gc%subgc(isub))
       end do
       deallocate(gc%subgc,stat=istat)
       nullify(gc%subgc)  ! to make sure it isn't left dangling (necessary?)
    else
       deallocate(gc%conv,stat=istat)
       nullify(gc%conv) ! to make sure it isn't left dangling (necessary?)
    end if

    if (istat /= 0) then

       call wae_error('conv_DelGridConv_0d: problems with deallocation')
       !write(0,*) 'ERROR: problems with deallocation in conv_DelGridConv_0d'
       !write(0,*) one/sqrt(sin(zero))
       !stop
    end if
    
  end subroutine conv_DelGridConv_0d
  !-----------------------------------------------------------------
  ! Handy to have multi-dimensional versions of the above
  subroutine conv_DelGridConv_1d(gc)
    type(grid_conv), intent(inout) :: gc(:)
    !-------------------------------------------
    integer :: i
    do i = 1, size(gc)
       call conv_DelGridConv_0d(gc(i))
    end do
  end subroutine conv_DelGridConv_1d
  subroutine conv_DelGridConv_2d(gc)
    type(grid_conv), intent(inout) :: gc(:,:)
    !-------------------------------------------
    integer :: i,j
    do i = 1, size(gc,dim=2)
       do j = 1, size(gc,dim=1)
          call conv_DelGridConv_0d(gc(j,i))
       end do
    end do
  end subroutine conv_DelGridConv_2d


  !--------------------------------------------------------------------
  ! Multiply the given GridConv by the relevant factor
  recursive subroutine conv_MultGridConv_0d(gc,fact)
    type(grid_conv), intent(inout) :: gc
    real(dp),        intent(in)    :: fact
    !-------------------------------------------
    integer :: isub

    if (gc%grid%nsub /= 0) then
       do isub = 1, gc%grid%nsub
          call Multiply(gc%subgc(isub),fact)
       end do
    else
       gc%conv = gc%conv * fact
    end if
    
  end subroutine conv_MultGridConv_0d
  !-----------------------------------------------------------------
  ! Handy to have multi-dimensional versions of the above
  subroutine conv_MultGridConv_1d(gc,fact)
    type(grid_conv), intent(inout) :: gc(:)
    real(dp),        intent(in)    :: fact
    !-------------------------------------------
    integer :: i
    do i = 1, size(gc)
       call conv_MultGridConv_0d(gc(i),fact)
    end do
  end subroutine conv_MultGridConv_1d
  subroutine conv_MultGridConv_2d(gc,fact)
    type(grid_conv), intent(inout) :: gc(:,:)
    real(dp),        intent(in)    :: fact
    !-------------------------------------------
    integer :: i,j
    do i = 1, size(gc,dim=2)
       do j = 1, size(gc,dim=1)
          call conv_MultGridConv_0d(gc(j,i),fact)
       end do
    end do
  end subroutine conv_MultGridConv_2d

  !-------------------------------------------------------------
  !! To gc add a function for convolution
  recursive subroutine conv_AddGridConv_func(gc,func, split)
    use integrator; use convolution_communicator
    type(grid_conv), intent(inout), target :: gc
    real(dp), intent(in), optional :: split(:)
    interface
       function func(y)
         use types; implicit none
         real(dp), intent(in) :: y      !< y=ln(1/x)
         real(dp)             :: func
       end function func
    end interface
    !----------------------------------------------------
    type(conv_ignd_fromfunc) :: gc_ignd
    gc_ignd%f_ptr => func
    call conv_AddGridConv_ignd(gc, gc_ignd, split)
  end subroutine conv_AddGridConv_func


  !! Implements the f(y,piece) function of conv_ignd_fromfunc.
  !! allowing us to access the splitting functions as written
  !! for hoppet v1.
  !!
  !! It uses the piece argument to set the global cc_piece 
  !! and then calls the function pointer this%f_ptr(y)
  function conv_ignd_fromfunc__f(this,y,piece) result(res)
    use convolution_communicator
    class(conv_ignd_fromfunc), intent(in) :: this
    real(dp),                  intent(in) :: y      !< y=ln(1/x)
    integer,                   intent(in) :: piece  !< which piece of the convolution
    real(dp)                              :: res

    ! set the global variable to indicate which piece
    ! of the convolution we are working on
    cc_piece = piece
    ! evaluate a function that uses cc_piece
    res = this%f_ptr(y)
  end function conv_ignd_fromfunc__f


  !! implementation of the f function of ignd_class_fromconv,
  !! i.e. pass through for this%conv_ignd_ptr%f(y,this%piece)
  !!
  !! This is the needed for the ignd_class that is passed 
  !! to the basic integrator  
  function ignd_class_fromconv__f(this,x) result(res)
    use convolution_communicator
    class(ignd_class_fromconv), intent(in) :: this
    real(dp), intent(in)                   :: x      !< named x for consistency with ignd_class__f, but is really y=ln(1/x)
    real(dp)                               :: res
    ! evaluate a function that uses cc_piece
    res = this%conv_ignd_ptr%f(x,this%piece)
  end function ignd_class_fromconv__f


  !-------------------------------------------------------------
  !! To gc add a function for convolution
  recursive subroutine conv_AddGridConv_ignd(gc,ignd, split)
    use integrator; use convolution_communicator
    class(conv_ignd), intent(in),    target :: ignd      !< the conv_ignd (functor) object to integrate
    type(grid_conv),  intent(inout), target :: gc        !< the output grid_conv object
    real(dp), intent(in), optional          :: split(:)  !< optional split points for integrator
    !----------------------------------------------------
    real(dp), pointer :: dy
    integer,  pointer :: ny
    integer  :: order
    real(dp) :: upper,lower, yl,ym,yh
    integer  :: i,j, k
    !------------------------------------------------------
    real(dp) :: res,eps!, nodes(gc%grid%order+1)
    integer  :: il, ih, iy, jy
    real(dp), allocatable :: nodes(:)
    !------------------------------------------------------
    integer :: isub
    type(ignd_class_fromconv) :: ig_ignd

    if (gc%grid%nsub /= 0) then
       do isub = 1, gc%grid%nsub
          call conv_AddGridConv_ignd(gc%subgc(isub),ignd,split)
       end do
       return
    end if

    ig_ignd%conv_ignd_ptr => ignd

    dy => gc%grid%dy
    ny => gc%grid%ny
    order = gc%grid%order
    eps   = gc%grid%eps

    !-- this used to be an automatic, but ran into problems 
    !   with multi-grid splitting functions because compound holder
    !   had an undefined value for gc%grid%order
    allocate(nodes(abs(gc%grid%order)+1))

    ig_ignd%piece = cc_REAL
    if (gc%grid%order == LIN_ORDER) then
       if (present(split)) call wae_error("conv_AddGridConv_func: split not supported for LIN_ORDER")
       do i = 1, ny
          ym = i*dy
          yl = ym - dy
          yh = ym + dy
          lower = ig_LinWeight(ig_ignd,yl,ym,zero,one,eps) ! specify 0 at yl
          upper = ig_LinWeight(ig_ignd,ym,yh,one,zero,eps) ! specify 0 at yh
          gc%conv(i,FULL) = gc%conv(i,FULL) + lower + upper
          gc%conv(i,UPPR) = gc%conv(i,UPPR) + upper
       end do
       !-- see CCN17-62 ----
       ym = zero
       yh = dy
       ig_ignd%piece = cc_REAL
       upper    = ig_LinWeight(ig_ignd,ym,yh,zero,-one,eps)
       ig_ignd%piece = cc_REALVIRT
       upper    = upper + ig_LinWeight(ig_ignd,ym,yh,one,one,eps) 
       ig_ignd%piece = cc_VIRT
       upper    = upper + ig_LinWeight(ig_ignd,yh,-two*log(eps),one,one,eps)
       ig_ignd%piece = cc_DELTA
       upper    = upper + ig_ignd%f(zero)
       gc%conv(0,FULL) = gc%conv(0,FULL) + upper
       gc%conv(0,UPPR) = gc%conv(0,UPPR) + upper
    else if (gc%grid%order < LIN_ORDER) then
       ! should be similar to Ratcliffes proposal (and the sort of thing
       ! regularly done in BFKL). NB Not documented in any CCN -- hopefully
       ! straightforward enough that it can be done in one's head?
       order = -gc%grid%order
       ! limit goes to ny+1 to ensure that everything that can contribute
       ! to entry at ny is covered (otherwise entry at ny is dicontinuous 
       ! relative to earlier entries)
       do i = 1, ny+1
          !-- this is the range of interest
          yl = (i-1) * dy
          yh =  i    * dy
          !-- this is range of nodes for that interval
          il = i-1
          ih = il + order
          nodes = (/ (j,j=il,ih) /) * dy
          do iy = il, min(ih,ny)
             res = conv_GCAf_Helper_ignd(ig_ignd,yl,yh,il,iy,nodes,eps, split=split)
             gc%conv(iy,1) = gc%conv(iy,1) + res
          end do
       end do
       !write(0,*) 'conv_AddGridConv_func: Negative orders not yet supported'
       !stop
    else
      if (present(split)) call wae_error("conv_AddGridConv_func: split not supported for order>0")

       !-- CCN19 p.4 -------------
       ! index 0:          central points
       ! index 1..order+1: for dealing with last order+1 points
       !-- first do central points. Do an interval at a time
       !   i = 1, means interval from 0 to 1
       !-- the first loop is missing something:: it should also be filling up
       !   some pieces in the second loop, at least in some cases
       do i = 1, ny
          !-- this is the range of interest
          yl = (i-1) * dy
          yh =  i    * dy
          !-- these are the interpolation points to be used
          il = max(0,i - (order+2)/2)
          ih = min(ny, il+order)
          il = ih - order
          !-- fill things up?
          nodes = (/ (j,j=il,ih) /) * dy
          do iy = il, ih
             res = conv_GCAf_Helper_ignd(ig_ignd,yl,yh,il,iy,nodes,eps)
             gc%conv(iy,0) = gc%conv(iy,0) + res
             !-- deal properly with special end array --
             !   try to be clever with limits, but there are no guarantees.
             !   It does however seem to work!
             do jy = max(i+order,iy), iy+order
                if (jy <= ny) then
                   gc%conv(jy,order+1-(jy-iy)) &
                        &= gc%conv(jy,order+1-(jy-iy)) + res
                end if
             end do
          end do
       end do
       !-- now deal with integrations close to end points
       ! k represents the end points
       do k = 1, ny
          if (k <= order) then
             yl = max(zero, (k-order)*dy)
             yh = k*dy
             !-- the interpolation points & yes, it is normal for them 
             !   to be negative
             !   it is related to the way the convolution is done for the case 
             !   i < order, i.e. effectively conv(0:order)*gq(order:0:-1)
             !   (actually conv(i, 1:order+1))
             ih = k
             il = k - order
             !-- fill things up
             nodes = (/ (j,j=il,ih) /) * dy
             do iy = il, ih
                res = conv_GCAf_Helper_ignd(ig_ignd,yl,yh,il,iy,nodes,eps)
                gc%conv(k,iy-il+1) = gc%conv(k,iy-il+1) + res
             end do
             cycle
          end if
          ! now do things region by region
          !-- i represents the region that we will study
          do i = max(1,k-order+1), k
             !-- this is the range of interest
             yl = (i-1) * dy
             yh =  i    * dy
             !-- these are the interpolation points to be used
             !   note extra min(k,...) compared to above formula
             il = max(0,i - (order+2)/2)
             ih = min(k,min(ny, il+order)) !-- could simplify expression
             il = ih - order
             nodes = (/ (j,j=il,ih) /) * dy
             do iy = max(il,k-order), ih
                res = conv_GCAf_Helper_ignd(ig_ignd,yl,yh,il,iy,nodes,eps)
                gc%conv(k,order+1-(k-iy)) = &
                     &gc%conv(k,order+1-(k-iy)) + res
             end do
          end do
       end do
    end if
    
    deallocate(nodes)

  end subroutine conv_AddGridConv_ignd

  !---------------------------------------------------------------------
  ! look after some repetitive work...
  !
  ! Guess that this function may do the following:
  !   Work out the weight corresponding to the integral, between yl and yh
  !   of the function func(y) mutiplied by a polynomial which is zero at 
  !   all the nodes (which start from il) except that indicated by iy.
  !
  function conv_GCAf_Helper_ignd(ig_ignd,yl,yh,il,iy,nodes,eps, split) result(res)
    use integrator; use convolution_communicator
    type(ignd_class_fromconv), intent(inout) :: ig_ignd
    real(dp), intent(in) :: yl, yh, nodes(:), eps
    integer,  intent(in) :: il, iy
    real(dp), intent(in), optional :: split(:)
    real(dp)             :: res
    integer :: inode
    inode = iy - il + 1
    res = zero
    if (yl == zero .and. iy == 0) then
       ig_ignd%piece = cc_VIRT
       res = res + ig_LinWeight(ig_ignd, yh,-two*log(eps), one,one, eps, split=split)
       ig_ignd%piece = cc_DELTA
       res = res + ig_ignd%f(zero)
       ig_ignd%piece = cc_REALVIRT
       res = res + ig_LinWeight(ig_ignd, yl, yh, one, one, eps, split=split)
       ig_ignd%piece = cc_REAL
       if (present(split)) then
         if (size(split) > 0) Then
            if (split(1) < yh) Then
               call wae_error("conv_GCAf_Helper: split(1) < yh not supported, with yh = ", dbleval=yh)
            end if
         end if 
       end if
       res = res + ig_PolyWeight_expand(ig_ignd, yl, yh, nodes, inode, eps,wgtadd=-one)
    else
       ig_ignd%piece = cc_REAL
       res = ig_PolyWeight(ig_ignd, yl, yh, nodes, inode, eps, split=split)
    end if
  end function conv_GCAf_Helper_ignd


  !-------------------------------------------------------------
  ! To gc add another grid convolution.
  !
  ! Perhaps there are some inefficiences here (validation may sometimes
  ! be carried out twice), but for the time being, leave it as is.
  recursive subroutine conv_AddGridConv_gc(gc,gcadd,fact)
    type(grid_conv), intent(inout) :: gc
    type(grid_conv), intent(in)  :: gcadd
    real(dp),        intent(in), optional  :: fact
    !----------------------------------------------
    integer :: isub

    call ValidateGD(gc%grid, gcadd%grid, 'conv_AddGridConv_gc')
    if (gc%grid%nsub /= 0) then
       do isub = 1, gc%grid%nsub
          call conv_AddGridConv_gc(gc%subgc(isub),gcadd%subgc(isub),fact)
       end do
    else
       if (present(fact)) then
          gc%conv = gc%conv + gcadd%conv * fact
       else
          gc%conv = gc%conv + gcadd%conv
       end if
    end if
    
  end subroutine conv_AddGridConv_gc
  !-----------------------------------------------------------------
  ! Handy to have multi-dimensional versions of the above
  subroutine conv_AddGridConv_gc_1d(gc,gcadd,fact)
    type(grid_conv), intent(inout) :: gc(:)
    type(grid_conv), intent(in)    :: gcadd(:)
    real(dp),        intent(in), optional :: fact
    !-------------------------------------------
    integer :: i
    do i = 1, size(gc)
       call conv_AddGridConv_gc(gc(i),gcadd(i),fact)
    end do
  end subroutine conv_AddGridConv_gc_1d
  subroutine conv_AddGridConv_gc_2d(gc,gcadd,fact)
    type(grid_conv), intent(inout) :: gc(:,:)
    type(grid_conv), intent(in)    :: gcadd(:,:)
    real(dp),        intent(in), optional    :: fact
    !-------------------------------------------
    integer :: i,j
    do i = 1, size(gc,dim=2)
       do j = 1, size(gc,dim=1)
          call conv_AddGridConv_gc(gc(j,i),gcadd(j,i),fact)
       end do
    end do
  end subroutine conv_AddGridConv_gc_2d


  !--------------------------------------------------------------
  ! Carry out the convolution of gc on gq
  recursive function conv_ConvGridQuant_scalar(gc,gq) result(gqout)
    type(grid_conv),  intent(in)    :: gc
    real(dp),         intent(in)    :: gq(0:)
    real(dp)                        :: gqout(0:ubound(gq,dim=1))
    !---------------------------------------------
    integer :: i, ny !, j
    integer :: order
    integer :: isub, iy, dy_ratio

    if (gc%grid%nsub /= 0) then
       do isub = 1, gc%grid%nsub
          gqout(gc%grid%subiy(isub):gc%grid%subiy(isub+1)-1) = &
               & conv_ConvGridQuant_scalar(gc%subgc(isub),&
               &        gq(gc%grid%subiy(isub):gc%grid%subiy(isub+1)-1))
       end do
        
       if (gc%grid%locked .and. .not.override_grid_locking) then
          ! !-- decant information from finer grids into coarser grids
          ! ! (remember: finest grid has lowest isub)
          ! do isub = 2, gc%grid%nsub
          !    ! the ratio should be an exact integer, but use
          !    ! nint() to avoid the dangers of rounding errors
          !    dy_ratio = nint(gc%grid%subgd(isub)%dy / gc%grid%subgd(isub-1)%dy)
          !    do iy = 0, gc%grid%subgd(isub-1)%ny / dy_ratio
          !       gqout(gc%grid%subiy(isub)+iy) = &
          !            &gqout(gc%grid%subiy(isub-1)+iy*dy_ratio)
          !    end do
          ! end do
          call conv_DecantMultiGridQuant(gc%grid, gqout)
          nconv_with_override_off = nconv_with_override_off + 1
       end if
       return
    end if

    ny = assert_eq(gc%grid%ny,ubound(gq,dim=1),"conv_ConvGridQuant")
    order = gc%grid%order

    !-- Hopefully this will avoid some wasted convolutions?
    if (all(gq == zero)) then
       gqout = zero
       return
    end if
    

    if (order == LIN_ORDER) then
       !-- a test to avoid N^2 operations...
       if (all(gc%conv(:,FULL) == zero)) then
          gqout = zero
          return
       end if
       
       gqout(0) = zero
       do i = 1, ny
          !-- following is legal fortran but it is very slow sometimes
          gqout(i) =  sum(gq(0:i)*gc%conv(i:0:-1,FULL))
          !-- maybe the version that follows will be faster on some compilers
          !   on absoft it definitely is
!!$       gqout(i) = zero
!!$       do j = 0, i
!!$          gqout(i) = gqout(i) + gq(j)*gc%conv(i-j,FULL)
!!$       end do
          !write(0,*) i*gc%grid%dy,gqout(i), gc%conva(1)
          gqout(i) = (gqout(i)-gq(0)*gc%conv(i,UPPR))
       end do
    else if (order < 0) then
       ! Ratcliffes proposal
       !gqout(0) = zero
       ! NB: explicitly do also the i=0 case. Under normal circumstances
       !     it should give zero; however we still let the user enjoy
       !     their folly if they really want to have gq(0)/=0 --- this
       !     is something that comes in handy when generating "derived"
       !     convolutors...
       do i = 0, ny
          gqout(i) = sum(gc%conv(0:i,1)*gq(i:0:-1))
       end do
    else
       gqout = zero
       !-- a test to avoid N^2 operations...
       if (all(gc%conv(:,0) == zero)) return
       !-- current writing is designed to reduce thrashing of cache. 
       !   It is not clear that it actually helps in any way
       !   Commented version theoretically has higher cache thrashing.
       do i = 1, ny
          if (i > order) then
             gqout(i) = sum(gc%conv(0:i-order-1,0)*gq(i:order+1:-1))
          end if
          !-- HIGH CACHE THRASH
          !gqout(i) = gqout(i) + sum(gc%conv(i,1:order+1)*gq(order:0:-1))
       end do
       !-- LOW CACHE THRASH
       do i = 1, order+1
          gqout(:) = gqout(:) + gc%conv(:,i)*gq(order+1-i)
       end do
    end if
    
  end function conv_ConvGridQuant_scalar



  !--------------------------------------------------------------
  ! Carry out the convolution of two convolution functions
  ! It is recommended that if one of them is singular at x=1, then this be 
  ! gca: this helps minimise the discretisation error (in some cases).
  !
  ! NB: subroutine name is not quite consistent with things like
  !     Add or Mult since the operands are completely distinct from the
  !     result.
  recursive subroutine conv_ConvGridConv_0d(gc,gca, gcb, reorder)
    type(grid_conv),  intent(inout) :: gc
    type(grid_conv),  intent(in)    :: gca, gcb
    logical,          intent(in), optional :: reorder
    !---------------------------------------------
    integer :: i, j, order, ix
    !-- these might be better if on the fly, given recursive nature?
    real(dp) :: deltafn(0:gca%grid%ny), res(0:gca%grid%ny)
    integer :: isub

    call ValidateGD(gca%grid, gcb%grid, 'conv_ConvGridConv_0d: gca and gcb')
    if (.not.GridConvAllocated(gc)) then
       call AllocGridConv(gca%grid,gc)
    else
       call ValidateGD(gc%grid, gca%grid, 'conv_ConvGridConv_0d: gc and gca')
    end if
    
    if (gc%grid%nsub /= 0) then
       do isub = 1, gc%grid%nsub
          call conv_ConvGridConv_0d(gc%subgc(isub),&
               &  gca%subgc(isub), gcb%subgc(isub),reorder)
       end do
       return
    end if

    if (default_or_opt(.true.,reorder)) then
       !-- decide which part of conv matrix to use
       select case (gca%grid%order)
       case(LIN_ORDER)
          ix = FULL
       case(LIN_ORDER+1:)
          ix = 0
       case(:LIN_ORDER-1)
          ix = 1
       end select
       
       !-- use as only criterion of singularity that there should be
       !   opposite signs for the first two grid points? This is not
       !   by any means foolproof, but in basic cases it seems to work.
       !   Put the less singular convolutor to the right.
       if (product(gca%conv(0:1,ix)) >= zero .and. &
            & product(gcb%conv(0:1,ix)) < zero) then
          call conv_ConvGridConv_0d(gc,gcb, gca, reorder=.false.)
          return
       end if
    end if


    if (gca%grid%order == LIN_ORDER) then
       !-- this is just a guess. Now we will see if it is right
       gc%conv(:,FULL) = (gca .conv. gcb%conv(:,FULL)) +&
            &gca%conv(:,UPPR) * gcb%conv(0,FULL)
       
       !-- next 3 lines actually calculate LOWER. Then correct it to upper.
       !   Do the convolution of a deltafn by hand in order to
       !   be more efficient: tested that it gave identical answers
       deltafn = gcb%conv(:,FULL) - gcb%conv(:,UPPR)
       deltafn(0) = zero
       gc%conv(:,UPPR) = gca .conv. deltafn
       !gc%conv(:,UPPR) = gca .conv. (gcb .conv. deltafn)
       gc%conv(:,UPPR) = gc%conv(:,FULL) - gc%conv(:,UPPR)
    else if (gca%grid%order < LIN_ORDER) then
       ! the ratcliffe approach
       do i = 0, gc%grid%ny
          gc%conv(i,1) = sum(gca%conv(0:i,1)*gcb%conv(i:0:-1,1))
       end do
       !write(0,*) 'SetToConvolution: Negative orders not yet supported'
       !stop
    else
       order = gca%grid%order
       !-- let us hope that the following works?
       !   in this first incarnation it will be roughly half the optimum
       !   speed because the inner convolution will be done "stupidly",
       !   using O(N^2) steps rather than the possible O(N)
       do j = 0, order+1
          !-- set up a delta function and its convolution
          deltafn = zero; deltafn(j) = one
          !-- try to avoid too much rubbish in the result?
          res = zero
          res = gca .conv. (gcb .conv. deltafn)
          !-- redistribute the result
          if (j /= order+1) then
             gc%conv(:,order+1-j) = res(:)
          else
             gc%conv(0:gca%grid%ny-(order+1),0) = res(order+1:gca%grid%ny)
             !-- The region conv(gca%grid%ny-order:) remains unfilled. This 
             !   is OK since in practice (current incarnation) it never 
             !   gets used.
          end if
       end do
       !-- now remember to test it!
    end if


  end subroutine conv_ConvGridConv_0d

  !--------------------------------------------------------------------
  ! version for automatically doing convolution of two 2x2 arrays
  ! with array multiplication in the usual fortran sense
  subroutine conv_ConvGridConv_2dx2d(gc,gca, gcb)
    type(grid_conv),  intent(inout) :: gc(:,:)
    type(grid_conv),  intent(in)    :: gca(:,:), gcb(:,:)
    !----------------------------------------------------
    integer :: ir, im, ic, nr, nm, nc
    type(grid_conv) :: conv
    
    nr = assert_eq(size(gc,dim=1),size(gca,dim=1) ,'conv_ConvGridConv_2dx2d')
    nc = assert_eq(size(gc,dim=2),size(gcb,dim=2) ,'conv_ConvGridConv_2dx2d')
    nm = assert_eq(size(gca,dim=2),size(gcb,dim=1),'conv_ConvGridConv_2dx2d')
    
    ! allocate gc if need be, with default initialization of zero
    call InitGridConv(gca(1,1)%grid, gc) 
    !call SetToZero(gc)

    call AllocGridConv(gc(1,1)%grid,conv)
    do ic = 1, nc
       do ir = 1, nr
          do im = 1, nm
             call conv_ConvGridConv_0d(conv,gca(ir,im),gcb(im,ic))
             call AddWithCoeff(gc(ir,ic),conv)
          end do
       end do
    end do
    call Delete(conv)
    
  end subroutine conv_ConvGridConv_2dx2d
  
  !--------------------------------------------------------------------------
  ! Returns in gc (assumed preallocated) the commutator of
  ! gca and gcb. Does nothing clever about ordering of
  ! the arrays...
  !
  ! This is a very inefficient version because it does many more convolutions
  ! than are needed. Only for 2x2 arrays does it do a reasonably sensible job.
  !
  subroutine SetToCommutator_gc(gc,gca, gcb)
    type(grid_conv),  intent(inout) :: gc(:,:)
    type(grid_conv),  intent(in)    :: gca(:,:), gcb(:,:)
    !----------------------------------------------------
    type(grid_conv) :: cc(size(gc,dim=1),size(gc,dim=2))
    type(grid_conv) :: prod

    ! allocate gc if need be, with default initialization of zero
    call InitGridConv(gca(1,1)%grid, gc) 
    !call SetToZero(gc)

    ! allocate some more memory
    call AllocGridConv(gc(1,1)%grid,cc)

    !-- use a shortcut for 2-dim arrays; do things long-hand
    !   for others
    if (size(gc,dim=1) == 2 .and. size(gc,dim=2) == 2) then
    !-- for 2x2 arrays we will want to do something along the following lines
    ! (with a similar definition for B).
!> A:=matrix(2,2,[a11,a12,a21,a22]);
!                                                     [a11    a12]
!                                                A := [          ]
!                                                     [a21    a22]
!----------------------------------------------------------------------- 
!> matadd(multiply(A,B),-multiply(B,A));
!  [         a12 b21 - a21 b12           a11 b12 + a12 b22 - b11 a12 - b12 a22]
!  [                                                                          ]
!  [a21 b11 + a22 b21 - b21 a11 - b22 a21          a21 b12 - a12 b21          ]
       call AllocGridConv(gc(1,1)%grid,prod)
       
       ! res11 = a12 b21 - a21 b12
       call SetToConvolution(prod,gca(1,2),gcb(2,1))
       call AddWithCoeff(gc(1,1),prod)
       call SetToConvolution(prod,gca(2,1),gcb(1,2))
       call AddWithCoeff(gc(1,1),prod,-one)
       ! res22 = -res 11
       call AddWithCoeff(gc(2,2),gc(1,1),-one)
       ! res12 = a11 b12 + a12 b22 - b11 a12 - b12 a22
       call SetToConvolution(prod,gca(1,1),gcb(1,2))
       call AddWithCoeff(gc(1,2),prod)
       call SetToConvolution(prod,gca(1,2),gcb(2,2))
       call AddWithCoeff(gc(1,2),prod)
       call SetToConvolution(prod,gca(1,2),gcb(1,1))
       call AddWithCoeff(gc(1,2),prod,-one)
       call SetToConvolution(prod,gca(2,2),gcb(1,2))
       call AddWithCoeff(gc(1,2),prod,-one)
       ! res21 = a21 b11 + a22 b21 - b21 a11 - b22 a21
       call SetToConvolution(prod,gca(2,1),gcb(1,1))
       call AddWithCoeff(gc(2,1),prod)
       call SetToConvolution(prod,gca(2,2),gcb(2,1))
       call AddWithCoeff(gc(2,1),prod)
       call SetToConvolution(prod,gca(1,1),gcb(2,1))
       call AddWithCoeff(gc(2,1),prod,-one)
       call SetToConvolution(prod,gca(2,1),gcb(2,2))
       call AddWithCoeff(gc(2,1),prod,-one)
       
       call Delete(prod)
    else
       call SetToConvolution(cc,gca,gcb)
       call AddWithCoeff(gc,cc)
       call SetToConvolution(cc,gcb,gca)
       call AddWithCoeff(gc,cc,-one)
    end if
    
    call Delete(cc)
  end subroutine SetToCommutator_gc
  


  !--------------------------------------------------------------
  ! Carry out the convolution of gc on gq: but not always the
  ! most efficient way of dealing with the problem...
  function conv_ConvGridQuant_mat(gc,gq) result(gqout)
    type(grid_conv),  intent(in)    :: gc(:,:)
    real(dp),         intent(in)    :: gq(0:,:)
    real(dp)                        :: gqout(0:ubound(gq,dim=1),size(gc,dim=1))
    !---------------------------------------------
    integer :: ny, ic, ir, ncol, nrow

    ny = assert_eq(gc(1,1)%grid%ny,ubound(gq,dim=1),"conv_ConvGridQuant")
    ncol = assert_eq(size(gc,dim=2),size(gq,dim=2),"conv_ConvGridQuant")
    nrow = size(gc,dim=1)

    gqout = zero
    do ir = 1, nrow
       do ic = 1, ncol
          !gqout(:,ir) = gqout(:,ir) + gc(ir,ic) .conv. gq(:,ic)
          gqout(:,ir) = gqout(:,ir) +&
               & conv_ConvGridQuant_scalar(gc(ir,ic), gq(:,ic))
       end do
    end do
  end function conv_ConvGridQuant_mat


  !======================================================================
  !> Evaluates the partonic luminosity associated with two grid quantities
  !> gq1 and gq2 using a "plain" method involving a straightforward sum
  !> of the products of the two (oppositely-ordered) vectors.
  !>
  !> This method can only be used for PDFs that go smoothly to zero for y->0.
  !> Reasonable accuracy of the result is then a consequence of the fact that
  !> integrals that go to zero smoothly at both extremities of the integration
  !> region converge as dy^n with n very high, even without any fancy 
  !> higher-order tricks. Actually, fancy higher-order tricks do worse often.
  !>
  !> This routine is not intended for general use. Instead go for
  !> conv_Luminosity_multi.
  recursive function conv_Luminosity_plain(grid, gq1, gq2) result(lumi)
    type(grid_def), intent(in) :: grid
    real(dp), intent(in) :: gq1(0:), gq2(0:)
    real(dp)             :: lumi(0:grid%ny)
    integer :: i, isub, lo, hi, ny

    ny = assert_eq(grid%ny, ubound(gq1,1),ubound(gq2,1),"conv_Luminosity_plain")
    if (grid%nsub == 0) then
      lumi(0) = zero
      do i = 1, ny
        lumi(i) = sum(gq1(0:i)*gq2(i:0:-1))*grid%dy
      end do
    else 
      do isub = 1, grid%nsub
        lo = grid%subiy(isub)
        hi = lo + grid%subgd(isub)%ny
        lumi(lo:hi) = conv_Luminosity_plain(grid%subgd(isub), gq1(lo:hi), gq2(lo:hi))
      end do
      if (grid%locked) call conv_DecantMultiGridQuant(grid,lumi)
    end if
  end function conv_Luminosity_plain
  

  !======================================================================
  !> Evaluate the partonic luminosity of gq1 and gq2  using tricks to improve
  !> accuracy of the multi-grid case.
  !> 
  !> In particular for a fine grid going from 0:yfine, the coarse
  !> lumi evaluation uses the fine grid information up to 2*yfine, with
  !> interpolation (according to grid%order) of the coarser grid in the regions
  !> where fine information is lacking.
  !> 
  !> Like conv_Luminosity_plain(...), this relies on the PDFs vanishing
  !> suitably smoothly at y = 0.
  function conv_Luminosity_multi(grid, gq1, gq2) result(lumi)
    type(grid_def), intent(in) :: grid
    real(dp), intent(in) :: gq1(0:), gq2(0:)
    real(dp)             :: lumi(0:ubound(gq1,1))
    !-----------------------
    type(grid_def), pointer :: fine, coarse
    integer  :: isub, iy, step

    ! if the grid doesn't have the right structure, we just give up
    if (grid%nsub == 0 .or. .not. grid%locked) then
      ! get our usual guess for the luminosity function and then return
      lumi = conv_Luminosity_plain(grid, gq1, gq2)
      return
    end if

    ! first do lowest isub (has finest spacing)
    lumi(0:grid%subgd(1)%ny) = conv_Luminosity_plain(&
         &                                grid%subgd(1), &
         &                                gq1(0:grid%subgd(1)%ny), &
         &                                gq2(0:grid%subgd(1)%ny))

    ! then do non-trivial bits isub by isub
    do isub = 1, grid%nsub-1
      fine => grid%subgd(isub)
      coarse => grid%subgd(isub+1)
      call conv_Luminosity_multi_do_sub(&
           &                 fine,&
           &                 gq1(grid%subiy(isub):grid%subiy(isub)+fine%ny),&
           &                 gq2(grid%subiy(isub):grid%subiy(isub)+fine%ny),&
           &                 coarse,&
           &                 gq1(grid%subiy(isub+1):grid%subiy(isub+1)+coarse%ny),&
           &                 gq2(grid%subiy(isub+1):grid%subiy(isub+1)+coarse%ny),&
           &                 lumi(grid%subiy(isub+1):grid%subiy(isub+1)+coarse%ny))
    end do

    !-- decant information from finer grids into coarser grids
    call conv_DecantMultiGridQuant(grid,lumi)

  end function conv_Luminosity_multi
  
  !----------------------------------------------------------------------
  !> helper function for lumi_multi, which is responsible for handling
  !> the combined use of fine and coarse grids.
  subroutine conv_Luminosity_multi_do_sub(&
       &           grid_fine, gq1_fine, gq2_fine,&
       &           grid_coarse, gq1_coarse, gq2_coarse, lumi_coarse)
    use interpolation
    type(grid_def), intent(in) :: grid_fine, grid_coarse
    real(dp), intent(in) :: gq1_fine(0:), gq2_fine(0:)
    real(dp), intent(in) :: gq1_coarse(0:), gq2_coarse(0:)
    real(dp), intent(inout) :: lumi_coarse(0:)
    !--------------------------------------
    integer  :: ny_fine, ny_coarse, max_ny_coarse
    real(dp) :: gq1_tmp(0:2*ubound(gq1_fine,1))
    real(dp) :: gq2_tmp(0:2*ubound(gq2_fine,1))
    integer  :: order, range_up, range_down, range_down_last
    integer, parameter :: nmax = 9 ! max order, as uniform_interpolation_weights
    real(dp) :: weights(0:nmax,nint(grid_coarse%dy / grid_fine%dy)-1)
    integer  :: i, step, iy_coarse, iy_fine
    integer  :: offset, last_offset

    step = nint(grid_coarse%dy / grid_fine%dy)

    ! make sure the ny we use is a multiple of step
    ny_coarse = (grid_fine%ny/step)
    ny_fine   = ny_coarse * step

    ! first copy the high-resolution piece across to a temporary array
    gq1_tmp(0:ny_fine) = gq1_fine(0:ny_fine)
    gq2_tmp(0:ny_fine) = gq2_fine(0:ny_fine)
    
    ! next get take the low resolution part and interpolate it
    ! first establish the appropriate range
    max_ny_coarse = min(2*ny_coarse, grid_coarse%ny)
    
    ! decide where we will interpolate
    order = abs(grid_coarse%order)
    if (grid_coarse%ny < order) call wae_error("lumi_multi_do_sub",&
         &"grid_coarse%ny < order, grid_fine%dy = ", dbleval=grid_fine%dy)

    ! first do the trivial points
    gq1_tmp(ny_fine+step:max_ny_coarse*step:step) = &
         &                      gq1_coarse(ny_coarse+1:max_ny_coarse)
    gq2_tmp(ny_fine+step:max_ny_coarse*step:step) = &
         &                      gq2_coarse(ny_coarse+1:max_ny_coarse)

    ! populate the fine grids by interpolation
    last_offset = 2000000000 ! semaphore for first round
    do iy_coarse = ny_coarse, max_ny_coarse-1
      range_down = max(0, iy_coarse-(order)/2)
      range_up   = min(grid_coarse%ny, range_down + order)
      range_down = range_up - order  ! our order check earlier on ensures saftey here
      offset = iy_coarse-range_down
      
      ! now get the weights
      do i = 1, step-1
        if (offset /= last_offset) then
          ! NB: with a tiny bit more work, could avoid repetitive determination
          !     of interpolation weights; but for now ignore this 
          call uniform_interpolation_weights(i*(one/step)+offset, weights(0:order,i))
        end if
        gq1_tmp(iy_coarse*step+i) = sum(weights(0:order,i)*gq1_coarse(range_down:range_up))
        gq2_tmp(iy_coarse*step+i) = sum(weights(0:order,i)*gq2_coarse(range_down:range_up))
      end do
      last_offset = offset
    end do

    ! now do the actual convolutions
    do iy_coarse = ny_coarse+1, max_ny_coarse
      lumi_coarse(iy_coarse) = sum(gq1_tmp(0:iy_coarse*step)&
           &                        * gq2_tmp(iy_coarse*step:0:-1)) * grid_fine%dy
    end do

    ! and then the rest
    do iy_coarse = max_ny_coarse+1, grid_coarse%ny
      lumi_coarse(iy_coarse) = sum(gq1_coarse(0:iy_coarse)&
           &                        * gq2_coarse(iy_coarse:0:-1)) * grid_coarse%dy
    end do
    
  end subroutine conv_Luminosity_multi_do_sub
  
  !======================================================================
  ! Perform the steps to decant information from fine grids into the 
  ! coarse grids of a grid quantity.
  subroutine conv_DecantMultiGridQuant(grid, gq)
    type(grid_def), intent(in) :: grid
    real(dp), intent(inout) :: gq(0:)
    integer :: isub, step, iy
    ! Remember: finest grid has lowest isub
    do isub = 2, grid%nsub
      ! the ratio should be an exact integer, but use
      ! nint() to avoid the dangers of rounding errors
      step = nint(grid%subgd(isub)%dy / grid%subgd(isub-1)%dy)
      do iy = 0, grid%subgd(isub-1)%ny / step
        gq(grid%subiy(isub)+iy) = gq(grid%subiy(isub-1)+iy*step)
      end do
    end do
  end subroutine conv_DecantMultiGridQuant
  

  !======================================================================
  ! things for easier access to a given grid point
  ! (but may not be as fast as just calling the routine)
  function conv_gdval_gdv(grid,val) result(gdv)
    type(grid_def), intent(in) :: grid
    real(dp),       intent(in) :: val
    type(gdval) :: gdv
    gdv%grid  = grid
    gdv%val = val
  end function conv_gdval_gdv
  function conv_gdval_vgd(val,grid) result(gdv)
    type(grid_def), intent(in) :: grid
    real(dp),       intent(in) :: val
    type(gdval) :: gdv
    gdv%grid  = grid
    gdv%val = val
  end function conv_gdval_vgd
  function conv_EvalGridQuant_atx(gq, gdv) result(res)
    real(dp),    intent(in) :: gq(:)
    type(gdval), intent(in) :: gdv
    real(dp) :: res
    res = EvalGridQuant(gdv%grid, gq, -log(gdv%val))
  end function conv_EvalGridQuant_atx
  function conv_EvalGridQuant_atx_1d(gq, gdv) result(res)
    real(dp),    intent(in) :: gq(:,:)
    type(gdval), intent(in) :: gdv
    real(dp) :: res(size(gq,dim=2))
    res = EvalGridQuant(gdv%grid, gq, -log(gdv%val))
  end function conv_EvalGridQuant_atx_1d
  function conv_EvalGridQuant_aty(gq, gdv) result(res)
    real(dp),    intent(in) :: gq(:)
    type(gdval), intent(in) :: gdv
    real(dp) :: res
    res = EvalGridQuant(gdv%grid, gq, gdv%val)
  end function conv_EvalGridQuant_aty
  function conv_EvalGridQuant_aty_1d(gq, gdv) result(res)
    real(dp),    intent(in) :: gq(:,:)
    type(gdval), intent(in) :: gdv
    real(dp) :: res(size(gq,dim=2))
    res = EvalGridQuant(gdv%grid, gq, gdv%val)
  end function conv_EvalGridQuant_aty_1d
  

  !======================================================================
  ! Routines for getting derived convolution operators
  !
  ! See also notes on CCN25-96
  !======================================================================
  ! Allocates and returns an array of probes, each of which must 
  ! be operated on with the convolver, after which the user should
  ! call SetDerivedConv, which formalises the results
  subroutine GetDerivedProbes(grid,probes)
    type(grid_def), intent(in) :: grid
    real(dp),       pointer    :: probes(:,:)
    !---------------------
    integer :: nprobes

    nprobes = 0
    call conv_GetNProbes(grid,nprobes)
    call AllocGridQuant(grid,probes,1,nprobes)
    call conv_SetProbes(grid,probes)

    ! safety measures -- this is a NASTY business, but cannot
    ! thing of another way to ensure & check that grid locking is
    ! off...
    override_grid_locking = .true.
    nconv_with_override_off = 0
  end subroutine GetDerivedProbes

  !----------------------------------------------------------------------
  ! Sets up the "derived" convolution operator.
  !
  ! This routine actually just does the housekeeping -- the actual "hard"
  ! work is done by conv_SetDerivedConv_rec
  !
  ! NB: gc must previously have been allocated
  subroutine SetDerivedConv(gc,probes)
    real(dp),        pointer       :: probes(:,:)
    type(grid_conv), intent(inout) :: gc

    call SetDerivedConv_nodealloc(gc,probes)
    deallocate(probes)
  end subroutine SetDerivedConv

  !----------------------------------------------------------------------
  ! runs through each of the elements of grid and establishes
  ! the number of probes needed. Currently only supports cases
  ! in which there is just a single probe...
  recursive subroutine conv_GetNProbes(grid,nprobes)
    use warnings_and_errors
    type(grid_def), intent(in)  :: grid
    integer,        intent(out) :: nprobes
    !---------
    integer :: nprobes_tmp, isub
    if (grid%nsub /= 0) then
       nprobes = 0
       do isub = 1, grid%nsub
          call conv_GetNProbes(grid%subgd(isub),nprobes_tmp)
          nprobes = max(nprobes, nprobes_tmp)
       end do
    else
       select case(grid%order)
       case(:LIN_ORDER-1)
          nprobes = 1
       case(LIN_ORDER)
          nprobes = 2
       case(LIN_ORDER+1:)
          nprobes = grid%order+2
       end select
    end if
  end subroutine conv_GetNProbes

  !----------------------------------------------------------------------
  ! Sets the exact form of the probes... Only works for order<0 for now.
  recursive subroutine conv_SetProbes(grid,probes)
    type(grid_def), intent(in)  :: grid
    real(dp),       intent(out) :: probes(0:,:)
    integer :: isub, iprobe
    if (grid%nsub /= 0) then
       do isub = 1, grid%nsub
          call conv_SetProbes(grid%subgd(isub),&
               &probes(grid%subiy(isub):grid%subiy(isub+1)-1,:))
       end do
    else
       select case(grid%order)
       case(:LIN_ORDER-1)
          probes(0,1) = one
          probes(1:,:) = zero
       case(LIN_ORDER)
          probes(:,:) = zero
          probes(0,1) = one
          probes(1,2) = one
       case(LIN_ORDER+1:)
          probes = zero
          do iprobe = 1, grid%order+2
             probes(iprobe-1,iprobe) = one
          end do
       end select
    end if
  end subroutine conv_SetProbes
  
  
  !----------------------------------------------------------------------
  ! Does the work in the setup of the "derived" convolution operator.
  recursive subroutine SetDerivedConv_nodealloc(gc,probes)
    use warnings_and_errors
    real(dp),        intent(in)    :: probes(0:,:)
    type(grid_conv), intent(inout) :: gc
    integer :: isub, order, iprobe

    override_grid_locking = .false.
    if (nconv_with_override_off /= 0) call wae_error(&
         &'SetDerivedConv_nodealloc',&
         &'Detected convolutions while lock override off')

    if (gc%grid%nsub /= 0) then
       do isub = 1, gc%grid%nsub
          call SetDerivedConv_nodealloc(gc%subgc(isub),&
               &probes(gc%grid%subiy(isub):gc%grid%subiy(isub+1)-1,:))
       end do
    else
       select case(gc%grid%order)
       case(:LIN_ORDER-1)
          gc%conv = probes
       case(LIN_ORDER)
          gc%conv(0:gc%grid%ny-1,FULL) = probes(1:,2)
          ! fake value here -- but since we will actually only be 
          ! interested in lower for this point, it does not
          ! matter!
          gc%conv(gc%grid%ny,FULL) = zero
          ! actually it is lower that has been calculated here
          gc%conv(0:,UPPR) = probes(0:,1)
          ! now convert it to upper
          gc%conv(0:,UPPR) = gc%conv(0:,FULL) - gc%conv(0:,UPPR)
       case(LIN_ORDER+1:)
          order = gc%grid%order
          ! a safety check -- if I forget anything it should
          ! jump out...
          gc%conv = 1e90_dp ! dummy value to detect uninitialized pieces...
          do iprobe = 1, order+1
             gc%conv(:,iprobe) = probes(:,order+2-iprobe)
          end do
          gc%conv(0:gc%grid%ny-order-1,0) = probes(order+1:,order+2)
          ! originally known, but unknowable with this method (and
          ! irrelevant).
          gc%conv(gc%grid%ny-order:,0) = zero
       end select
    end if
  end subroutine SetDerivedConv_nodealloc
  
  !------------------------------------------------------------
  !! Globally disables grid locking -- use with extreme
  !! care, and when done call RestoreGridLocking
  subroutine DisableGridLocking()
    override_grid_locking = .true.
    nconv_with_override_off = 0
  end subroutine DisableGridLocking

  !------------------------------------------------------------
  !! Globally restores normal grid locking
  subroutine RestoreGridLocking()
   if (nconv_with_override_off /= 0) call wae_error(&
     &'RestoreGridLocking',&
      &'Detected unexpected convolutions with lock override off')
   override_grid_locking = .false.
  end subroutine RestoreGridLocking
end module convolution

!----------------------------------------------------------------------
! A variety of routines that need to be implementation specific
!----------------------------------------------------------------------

!----------------------------------------------------------------------
! Reading and writing very large 2-dim arrays (with unformatted i/o) causes
! problems on certain systems -- so provide routines which split up
! the reading and writing if that is necessary
! Splitting not required for dec.
!----------------------------------------------------------------------
subroutine lcl_write_2d(idev, array)
      implicit none
      integer,         intent(in) :: idev
      real(kind(1d0)), intent(in) :: array(1:, 1:)
      !------------------------------------------------------------
      integer  ulim(2), i

      ulim = ubound(array)
      do i = 1, ulim(2)
         write(idev) real(array(:,i))
      end do
      
end subroutine lcl_write_2d


subroutine lcl_read_2d(idev, array, ifail)
      implicit none
      integer,           intent(in)  :: idev
      real(kind(1d0)),   intent(out) :: array(1:, 1:)
      integer, optional, intent(out) :: ifail
      !------------------------------------------------------------
      real, allocatable :: sngl_prec_buffer(:)
      integer  ulim(2), i!, j

      ulim = ubound(array)
      allocate(sngl_prec_buffer(1:ulim(1)))

      do i = 1, ulim(2)
         !-- data stored in sngl precision
         read(idev, end=10) sngl_prec_buffer(:)
         !-- convert it back into double precision
         array(:,i) = dble(sngl_prec_buffer(:))
      end do

      !-- correct return code ---
      if (present(ifail)) then
         ifail = 0
         return
      end if

10    if (present(ifail)) then
         ifail = -1
         return
      end if
end subroutine lcl_read_2d

!!$subroutine lcl_write_2d(idev, array)
!!$      implicit none
!!$      integer, intent(in) :: idev
!!$      real,    intent(in) :: array(1:, 1:)
!!$      !------------------------------------------------------------
!!$
!!$      write(idev) array(:,:)
!!$end subroutine lcl_write_2d
!!$
!!$
!!$subroutine lcl_read_2d(idev, array)
!!$      implicit none
!!$      integer, intent(in)  :: idev
!!$      real,    intent(out) :: array(1:, 1:)
!!$      !------------------------------------------------------------
!!$
!!$      read(idev) array(:,:)
!!$end subroutine lcl_read_2d



      

!! An example program using structure functions up to N3LO. !!
!!
program structure_functions_example
  use hoppet
  use hoppet_term
  use pdfs_for_benchmarks
  use streamlined_interface
  use structure_functions
  implicit none
  character (len=:), allocatable :: filename
  character (len=:), allocatable :: dirname
  real(dp) :: Qmax, Qmin, ymax, Q, mc, mb, mt, asQ, Q0,&
  & muR_Q, dy, dlnlnQ, minQval, maxQval
  integer  :: order, nloop_max = 4

  integer :: nargs, status
  character(len=256) :: arg
  logical :: dir_exists

  nargs = command_argument_count()
  if (nargs /= 1) then
    write(6,'(a)') bold//'Usage: '//reset//&
            'structure_functions_example <output_directory>'
    stop 1
  end if

  call get_command_argument(1, arg)
  dirname = trim(arg)
  if (dirname(len_trim(dirname):len_trim(dirname)) /= '/') then
    dirname = trim(dirname)//'/'
  end if

  call execute_command_line("test -d "//trim(dirname), exitstat=status)
  dir_exists = (status == 0)
  if (.not. dir_exists) then
    write(6,'(a)') 'Error: output directory does not exist: '//trim(dirname)
    stop 1
  end if

  Qmax = 13000.0_dp 
  Qmin = one
  
  ! Set heavy flavour scheme
  !mc = 1.414213563_dp   ! sqrt(2.0_dp) + epsilon
  !mb = 4.5_dp
  !mt = 175.0_dp
  !call hoppetSetPoleMassVFN(mc, mb, mt)
  call hoppetSetFFN(5)
!  call hoppetSetApproximateDGLAPN3LO(n3lo_splitting_approximation_up_to_2310_05744)
!  call hoppetSetApproximateDGLAPN3LO(n3lo_splitting_approximation_up_to_2404_09701)
  call hoppetSetApproximateDGLAPN3LO(n3lo_splitting_approximation_up_to_2410_08089)
  
  ! Streamlined initialization
  ! including  parameters for x-grid
  order = -6 ! interpolation order, not perturbative order in alphas!
  ymax  = 12.0_dp
  dy    = 0.05_dp  ! dble_val_opt("-dy",0.1_dp)
  dlnlnQ = dy/4.0_dp
  minQval = Qmin
  maxQval = Qmax 

  ! initialise the grid and dglap holder, using the streamlined
  ! interface for simplicity
  call hoppetStartExtended(ymax,dy,minQval,maxQval,dlnlnQ,nloop_max,&
    &         order,factscheme_MSbar)

  ! Setup all constants and parameters needed by the structure functions
  write(6,'(a)') "Filling structure function coefficient tables"
   call StartStrFct(nloop_max, nflav = 5, scale_choice =&
        & scale_choice_Q, param_coefs = .true.)



  filename = trim(dirname)//'n3lo-coef-xmur-1.0-xmuf-1.0-n3lo-evol-xmur-1.0.dat'
  open(unit = 99, file = trim(filename))
  call start_evolve_init_write(4,4,1.0_dp,1.0_dp,1.0_dp,99)

  filename = trim(dirname)//'n3lo-coef-xmur-1.0-xmuf-1.0-n3lo-evol-xmur-0.5.dat'
  open(unit = 99, file = trim(filename))
  call start_evolve_init_write(4,4,1.0_dp,1.0_dp,0.5_dp,99)

  filename = trim(dirname)//'n3lo-coef-xmur-1.0-xmuf-1.0-n3lo-evol-xmur-2.0.dat'
  open(unit = 99, file = trim(filename))
  call start_evolve_init_write(4,4,1.0_dp,1.0_dp,2.0_dp,99)

  filename = trim(dirname)//'n3lo-coef-xmur-1.0-xmuf-1.0-nnlo-evol-xmur-1.0.dat'
  open(unit = 99, file = trim(filename))
  call start_evolve_init_write(4,3,1.0_dp,1.0_dp,1.0_dp,99)

  filename = trim(dirname)//'n3lo-coef-xmur-1.0-xmuf-1.0-nnlo-evol-xmur-0.5.dat'
  open(unit = 99, file = trim(filename))
  call start_evolve_init_write(4,3,1.0_dp,1.0_dp,0.5_dp,99)

  filename = trim(dirname)//'n3lo-coef-xmur-1.0-xmuf-1.0-nnlo-evol-xmur-2.0.dat'
  open(unit = 99, file = trim(filename))
  call start_evolve_init_write(4,3,1.0_dp,1.0_dp,2.0_dp,99)

  filename = trim(dirname)//'n3lo-coef-xmur-1.0-xmuf-1.0-nlo-evol-xmur-1.0.dat'
  open(unit = 99, file = trim(filename))
  call start_evolve_init_write(4,2,1.0_dp,1.0_dp,1.0_dp,99)

  filename = trim(dirname)//'n3lo-coef-xmur-1.0-xmuf-1.0-nlo-evol-xmur-2.0.dat'
  open(unit = 99, file = trim(filename))
  call start_evolve_init_write(4,2,1.0_dp,1.0_dp,2.0_dp,99)

  filename = trim(dirname)//'n3lo-coef-xmur-1.0-xmuf-1.0-nlo-evol-xmur-0.5.dat'
  open(unit = 99, file = trim(filename))
  call start_evolve_init_write(4,2,1.0_dp,1.0_dp,0.5_dp,99)

  filename = trim(dirname)//'n3lo-coef-xmur-2.0-xmuf-1.0-nnlo-evol-xmur-1.0.dat'
  open(unit = 99, file = trim(filename))
  call start_evolve_init_write(4,3,2.0_dp,1.0_dp,1.0_dp,99)

  filename = trim(dirname)//'n3lo-coef-xmur-0.5-xmuf-1.0-nnlo-evol-xmur-1.0.dat'
  open(unit = 99, file = trim(filename))
  call start_evolve_init_write(4,3,0.5_dp,1.0_dp,1.0_dp,99)

  filename = trim(dirname)//'nnlo-coef-xmur-1.0-xmuf-1.0-nnlo-evol-xmur-1.0.dat'
  open(unit = 99, file = trim(filename))
  call start_evolve_init_write(3,3,1.0_dp,1.0_dp,1.0_dp,99)

contains

  subroutine start_evolve_init_write(nloop_coefs,nloop_evolv,xmur,xmuf,xmur_evolv,idev)
    implicit none
    integer,  intent(in) :: nloop_coefs, nloop_evolv, idev
    real(dp), intent(in) :: xmur, xmuf, xmur_evolv
    
    ! Set up all constants and parameters needed by the structure functions
    ! call StartStrFct(nloop_coefs, nflav = 5, xR = xmur, xF = xmuf, scale_choice = scale_choice_Q, &
    !   param_coefs = .true.)

    ! Evolve the PDF
    ! asQ = 0.35_dp
    ! Q0 = sqrt(2.0_dp)
    asQ = 0.30_dp
    Q0 = 2.0_dp
    
    call write_time()
    write(6,'(a)') "Doing evolution to fill PDF table"
    call hoppetEvolve(asQ, Q0, nloop_evolv, xmur_evolv, benchmark_pdf_unpolarized_lha, Q0)
    ! NB: this uses the PDFs that were set up in the streamlined interface
    ! with the hoppetEvolve routine
    call write_time()
    write(6,'(a)') "Filling StrFct tables"
    call InitStrFct(nloop_coefs, .true., xmur, xmuf)
    
    ymax = log(1e5) !ymax=20
    Q = 100.0_dp
    !Q = Q0

    call write_time()
    call write_f(idev, Q, ymax, 100, xmur, xmuf)
    
  end subroutine start_evolve_init_write
  
  ! write the time since the last call to this routine (or since start of the program)
  subroutine write_time()
    implicit none
    real(dp), save :: time, last_time = 0.0_dp
    call cpu_time(time)
    write(6,'(a,f10.4)') "Time since last call: ", time - last_time
    last_time = time
  end subroutine write_time

  subroutine write_f(idev, Qtest, ymax, ny, xmur, xmuf)
    implicit none
    real(dp), intent(in) :: Qtest, ymax
    integer,  intent(in) :: idev, ny
    real(dp), intent(in) :: xmur, xmuf
    
    call write_f1 (idev, Qtest, ymax, ny, muF = xmuf*Qtest, muR = xmur*Qtest)
    call write_f2 (idev, Qtest, ymax, ny, muF = xmuf*Qtest, muR = xmur*Qtest)
    call write_f3 (idev, Qtest, ymax, ny, muF = xmuf*Qtest, muR = xmur*Qtest)
    call write_pdf(idev, Qtest, ymax, ny)
    
  end subroutine write_f

  !> @brief write the F1 structure function to idev
  !!
  !! Writes the W and Z F1 structure functions to a file with equal spacing in log(x)
  !!
  !! @param[in]     idev     file/device to write to
  !! @param[in]     Qtest    Value of Q to use
  !! @param[in]     ymax     Largest value of y = - log(x) to print
  !! @param[in]     ny       number of bins in y to print
  !!
  subroutine write_pdf(idev, Qtest, ymax, ny)
    real(dp), intent(in) :: Qtest, ymax
    integer, intent(in)  :: idev, ny
    real(dp) :: ytest, xval, xpdf_at_xQ(-6:6)
    integer  :: iy
    !F1 Wp Wm Z
    write(idev,'(a,f10.4,a,f10.4)') '# Q = ', Qtest
    write(idev,'(a)') '# x pdf(-6:6)'
    
    do iy = ny, 1, -1
       ytest = iy * ymax / ny
       xval = exp(-ytest)
       call hoppetEval(xval,Qtest,xpdf_at_xQ)
       write(idev,'(14es12.4)') xval, xpdf_at_xQ
    end do
    write(idev,*)
    write(idev,*)
  end subroutine write_pdf
  

  
end program structure_functions_example

#include "inc/ftlMacros.inc"

module test_libome
  use unit_tests
contains
  !! subroutine for testing the hoppet-libome interface
  !! 
  !! reference values can be found in https://arxiv.org/abs/2510.02175, table 2
  subroutine test_libome_interface
    use hoppet_libome_fortran
    use hoppet_term ! for term colours
    use convolution_pieces
    use convolution
    use streamlined_interface
    use iso_c_binding
    implicit none
    real(c_double) :: as4pi, LM, nf_light_cdouble, x, y
    real(c_double) :: res_reg, res_plus, res_delta
    integer(c_int) :: piece
    integer, parameter :: reg   = cc_REALVIRT
    integer, parameter :: delta = cc_DELTA
    integer, parameter :: plus  = cc_VIRT
    integer(c_int), parameter  :: pieces(3) = [reg, plus, delta]
    integer :: ipiece

    if (.not. do_test("test_libome_interface")) return

    ! Example values for testing
    as4pi = 0.1_dp
    LM    = 10._dp
    nf_light_cdouble    = 3.0_dp
    x     = 0.1_dp

    ! check all 3rd order entries from table 2 of https://arxiv.org/pdf/2510.02175
    call sum_check("AqqQNSEven_reg" ,    6.4686126472_dp , AqqQNSEven_ptr , reg,   3)
    call sum_check("AqqQNSEven_plus" ,  -4.7428175642_dp , AqqQNSEven_ptr , plus,  3)
    call sum_check("AqqQNSEven_delta" , -2.6422012017_dp , AqqQNSEven_ptr , delta, 3)

    call sum_check("AqqQNSOdd_reg" ,    6.6927772815_dp  , AqqQNSOdd_ptr , reg,   3)
    call sum_check("AqqQNSOdd_plus" ,  -4.7428175642_dp  , AqqQNSOdd_ptr , plus,  3)
    call sum_check("AqqQNSOdd_delta" , -2.6422012017_dp  , AqqQNSOdd_ptr , delta, 3)

    call sum_check("AggQ_reg" ,   -262.65714922_dp   , AggQ_ptr , reg, 3)
    call sum_check("AggQ_plus" ,    -6.6285411655_dp , AggQ_ptr , plus, 3)
    call sum_check("AggQ_delta" ,   17.958634718_dp  , AggQ_ptr , delta, 3)

    call sum_check("AQqPS_reg" ,    91.950981088_dp  , AQqPS_ptr , reg, 3)
    call sum_check("AqqQPS_reg" ,  -38.624316410_dp  , AqqQPS_ptr , reg, 3)

    call sum_check("AQg_reg" ,    310.17900321_dp    , AQg_ptr , reg, 3)
    call sum_check("AqgQ_reg" ,   -73.710138327_dp   , AqgQ_ptr , reg, 3)
    call sum_check("AgqQ_reg" ,  -120.75198970_dp    , AgqQ_ptr , reg, 3)

    !! Run checks that the LM=0 and LM=eps results agree, since we take
    !! different paths within the libome interface in these two cases
    do ipiece = 1, size(pieces)
      piece = pieces(ipiece)
      call LM_zero_check("AqqQNSEven"//", piece="//to_string(piece), AqqQNSEven_ptr, piece, 3)
      call LM_zero_check("AqqQNSOdd "//", piece="//to_string(piece), AqqQNSOdd_ptr , piece, 3)
      call LM_zero_check("AggQ      "//", piece="//to_string(piece), AggQ_ptr      , piece, 3)
      call LM_zero_check("AQqPS     "//", piece="//to_string(piece), AQqPS_ptr    , piece, 3)
      call LM_zero_check("AqqQPS    "//", piece="//to_string(piece), AqqQPS_ptr   , piece, 3)
      call LM_zero_check("AQg       "//", piece="//to_string(piece), AQg_ptr      , piece, 3)
      call LM_zero_check("AqgQ      "//", piece="//to_string(piece), AqgQ_ptr     , piece, 3)
      call LM_zero_check("AgqQ      "//", piece="//to_string(piece), AgqQ_ptr     , piece, 3)
    end do

    call libome_moment_check_table4()

    call moment_check()

  contains

    !! sums the different orders from ome_piece_hoppet and compares to reference value
    !!
    !! \param name        = name of the OME (for printing)
    !! \param refval      = reference value to compare to
    !! \param ptr         = pointer to the OME object
    !! \param piece       = which piece (cc_REAL, cc_REALVIRT, cc_PLUS, cc_DELTA)
    !! \param max_order   = maximum order in alphas to sum up to
    !!
    subroutine sum_check(name, refval, ptr, piece, max_order)
      use iso_c_binding
      character(len=*), intent(in) :: name
      real(dp)        , intent(in) :: refval
      type(c_ptr), intent(in) :: ptr
      integer(c_int), intent(in) :: piece
      integer(c_int), intent(in) :: max_order
      real(dp) :: res
      integer(c_int) :: order
      real(dp) :: as2pi

      as2pi = as4pi * 2.0_dp
      res = 0.0_dp
      do order = 0, max_order
        res = res + (as2pi**order) * ome_piece_hoppet(ptr, log(1.0_dp/x), piece, order, LM, nf_light_cdouble)
      end do
      if (piece /= cc_DELTA) res = res / x
      if (piece == cc_VIRT) res = -res     ! because we compare to the plus part, which has the opposite sign
      ! table gives 10 digits after the first digit
      ! actual accuracy (email from Arnd Behring) should be 2048 * epsilon(1.0_dp)
      call check_approx_eq(trim(name), res, refval, tol_abs = 1e-10_dp, tol_rel = 1e-10_dp, tol_choice_or = .true.)

    end subroutine sum_check


    subroutine LM_zero_check(name, ptr, piece, order)
      use iso_c_binding
      character(len=*), intent(in) :: name
      type(c_ptr),      intent(in) :: ptr
      integer(c_int),   intent(in) :: piece
      integer(c_int),   intent(in) :: order
      !--
      real(dp), parameter :: LM_eps = 1e-50_dp
      real(dp) :: res_LM0, res_LMeps
      ! to be implemented

      res_LM0   = ome_piece_hoppet(ptr, log(1.0_dp/x), piece, order, LM=0.0_dp , NF=nf_light_cdouble)
      res_LMeps = ome_piece_hoppet(ptr, log(1.0_dp/x), piece, order, LM=LM_eps, NF=nf_light_cdouble)
      call check_approx_eq(name//": LM=0 vs LM=eps", res_LM0, res_LMeps, tol_abs = 1e-10_dp, tol_rel = 1e-10_dp, tol_choice_or = .true.)
    end subroutine LM_zero_check


    subroutine moment_check()
      ! to be implemented
      use qcd, only: qcd_SetNf
      use convolution
      use streamlined_interface
      use mass_thresholds_n3lo
      real(dp) :: moment_N
      type(mass_threshold_mat) :: mtm2, mtm3, mtm3_fortran

      call InitMTMLibOME(grid, mtm2, nloop=3)
      call InitMTMLibOME(grid, mtm3, nloop=4)
      call InitMTMN3LOExactFortran(grid, mtm3_fortran) ! fortran exact except AQg

      moment_N = 2.0_dp

      call check_moment("nloop=3, PShq     ", moment_N,   mtm2%PShq   , dh%allMTM(3,nf_int)%PShq   )
      call check_moment("nloop=3, PShg     ", moment_N,   mtm2%PShg   , dh%allMTM(3,nf_int)%PShg   )
      call check_moment("nloop=3, PSqq_H   ", moment_N,   mtm2%PSqq_H , dh%allMTM(3,nf_int)%PSqq_H )
      call check_moment("nloop=3, NSqq_H   ", moment_N,   mtm2%NSqq_H , dh%allMTM(3,nf_int)%NSqq_H )
      call check_moment("nloop=3, NSmqq_H  ", moment_N,   mtm2%NSmqq_H, dh%allMTM(3,nf_int)%NSmqq_H)      
      call check_moment("nloop=3, Sgg_H    ", moment_N,   mtm2%Sgg_H  , dh%allMTM(3,nf_int)%Sgg_H  )
      call check_moment("nloop=3, Sgq_H    ", moment_N,   mtm2%Sgq_H  , dh%allMTM(3,nf_int)%Sgq_H  )
      call check_moment("nloop=3, Sqg_H    ", moment_N,   mtm2%Sqg_H  , dh%allMTM(3,nf_int)%Sqg_H  )

      ! AQg can differ at the 6e-6 relative level; in the fortran OME code, it is the only
      ! only one that is not exact. It appears to use expansions and, depending on the
      ! system and optimisation level, one can trigger differences, perhaps because of
      ! a combination of rounding errors and how they induce adaptive integration fluctuations
      call check_moment("nloop=4, PShg     ", moment_N,   mtm3%PShg   , mtm3_fortran%PShg, override_tol=1e-5_dp ) 
      ! all others should be precise.
      call check_moment("nloop=4, PShq     ", moment_N,   mtm3%PShq   , mtm3_fortran%PShq   )
      call check_moment("nloop=4, PSqq_H   ", moment_N,   mtm3%PSqq_H , mtm3_fortran%PSqq_H )
      call check_moment("nloop=4, NSqq_H   ", moment_N,   mtm3%NSqq_H , mtm3_fortran%NSqq_H )
      call check_moment("nloop=4, NSmqq_H  ", moment_N,   mtm3%NSmqq_H, mtm3_fortran%NSmqq_H)      
      call check_moment("nloop=4, Sgg_H    ", moment_N,   mtm3%Sgg_H  , mtm3_fortran%Sgg_H  )
      call check_moment("nloop=4, Sgq_H    ", moment_N,   mtm3%Sgq_H  , mtm3_fortran%Sgq_H  )
      call check_moment("nloop=4, Sqg_H    ", moment_N,   mtm3%Sqg_H  , mtm3_fortran%Sqg_H  )

    end subroutine moment_check

    subroutine check_moment(name, momN, gc_test, gc_ref, override_tol)
      use assertions, only : default_or_opt
      use mass_thresholds_n3lo, only : gc_moment
      character(len=*),   intent(in) :: name
      real(dp),           intent(in) :: momN
      type(grid_conv),    intent(in) :: gc_test, gc_ref
      real(dp), optional, intent(in) :: override_tol
      !--
      real(dp) :: res_test, res_ref
      real(dp) :: tol

      tol = default_or_opt(1e-7_dp, override_tol)

      res_test = gc_moment(gc_test, momN)
      res_ref  = gc_moment(gc_ref, momN)
      call check_approx_eq(name, answer=res_test, expected = res_ref, &
                                 tol_abs = tol, tol_rel = tol, tol_choice_or = .true.)
    end subroutine check_moment

  end subroutine test_libome_interface    


  !------------------------------------------------------------------------
  !! run checks against table 4 of https://arxiv.org/abs/2510.02175
  subroutine libome_moment_check_table4()
    use hoppet_libome_fortran
    use qcd, only: qcd_SetNf
    use convolution
    use iso_c_binding
    !--
    type(grid_def) :: grid_bigy
    real(dp) :: as2pi
    real(c_double) :: as4pi, LM, nf_light_cdouble


    as4pi = 0.10_dp
    LM    = 10._dp
    nf_light_cdouble    = 3.0_dp

    call qcd_SetNf(int(nf_light_cdouble)+1)
    as2pi = as4pi * 2.0_dp

    ! set up a grid with a big y range to get good accuracy for low moments
    ! and with a small dy to get good accuracy for high moments
    call InitGridDef(grid_bigy, dy=0.02_dp, ymax=24.0_dp, order=-6)

    call check_moment_sum("AqqQNSEven", AqqQNSEven_ptr, &
                          moment_Ns=[2,4,6], &
                          refvals=[2.552050805_dp, 5.205091550_dp, 6.935755383_dp])

    call check_moment_sum("AQqPS     ", AQqPS_ptr, &
                          moment_Ns=[2,4,6], &
                          refvals=[5.787728157_dp, 1.517439651_dp, 0.726319249_dp])

    call check_moment_sum("AqqQPS    ", AqqQPS_ptr, &
                          moment_Ns=[2,4,6], &
                          refvals=[-1.927340435_dp, -0.287734919_dp, -0.111383030_dp])

    call check_moment_sum("AQg       ", AQg_ptr, &
                          moment_Ns=[2,4,6], &
                          refvals=[-4.267201565_dp, -19.75022897_dp, -21.85267609_dp])

    call check_moment_sum("AqgQ      ", AqgQ_ptr, &
                          moment_Ns=[2,4,6], &
                          refvals=[2.466090032_dp, 3.364276844_dp, 2.718842618_dp])

    call check_moment_sum("AgqQ      ", AgqQ_ptr, &
                          moment_Ns=[2,4,6], &
                          refvals=[-5.412438528_dp, -0.735206982_dp, -0.219958419_dp])

    call check_moment_sum("AggQ      ", AggQ_ptr, &
                          moment_Ns=[2,4,6], &
                          refvals=[2.801111705_dp, 20.85194977_dp, 26.04572674_dp])

    call check_moment_sum("AqqQNSOdd ", AqqQNSOdd_ptr, &
                          moment_Ns=[3,5,7], &
                          refvals=[4.041765636_dp, 6.148438117_dp, 7.610661858_dp])

  contains

    subroutine check_moment_sum(name, ptr, moment_Ns, refvals)
      use mass_thresholds_n3lo

      character(len=*), intent(in) :: name
      type(c_ptr),      intent(in) :: ptr
      integer,          intent(in) :: moment_Ns(:)
      real(dp),         intent(in) :: refvals(:)
      !----
      integer, parameter :: max_order = 3
      integer :: iorder, i
      integer(c_int) :: order
      type(grid_conv) :: A3sum, A3piece
      real(dp) :: moment_N, res


      call InitGridConv(grid_bigy, A3sum) !! sets it to zero
      do iorder = 0, max_order
        call InitGridConv(grid_bigy, A3piece, conv_OME(ptr, order=iorder, nf_light=nf_light_cdouble, LM=LM))        
        call AddWithCoeff(A3sum, A3piece, as2pi**iorder)
      end do

      do i = 1, size(moment_Ns)
        moment_N = real(moment_Ns(i), dp)
        res = gc_moment(A3sum, moment_N)
        call check_approx_eq(&
                    "libome "//name//", momN="//to_string(moment_Ns(i)), &
                     answer=res, expected=refvals(i), &
                     tol_abs=1e-6_dp, tol_rel=1e-6_dp, tol_choice_or=.true.)
      end do

      call Delete(A3sum)
      call Delete(A3piece)
    end subroutine check_moment_sum

  end subroutine libome_moment_check_table4

end module test_libome

#!/bin/bash

dirname=../with-lhapdf/
prog=$dirname/tabulation_n3lo_v130_paper


$prog -o MSHT20nnlo_as118-n3lo-evolu-n3lo-mass -nloop 4 -n3lo-vfns-on 1 -pdf MSHT20nnlo_as118 > MSHT20nnlo_as118-n3lo-evolu-n3lo-mass.log &

exit 0

$prog -o MSHT20nnlo_as118-n3lo-evolu-nnlo-mass -nloop 4 -n3lo-vfns-on 0 -pdf MSHT20nnlo_as118 > MSHT20nnlo_as118-n3lo-evolu-nnlo-mass.log &

$prog -o MSHT20nnlo_as118-nnlo-evolu-nnlo-mass -nloop 3 -n3lo-vfns-on 0 -pdf MSHT20nnlo_as118 > MSHT20nnlo_as118-nnlo-evolu-nnlo-mass.log &

$prog -o NNPDF40_nnlo_pch_as_01180-n3lo-evolu-n3lo-mass -nloop 4 -n3lo-vfns-on 1 -pdf NNPDF40_nnlo_pch_as_01180 > NNPDF40_nnlo_pch_as_01180-n3lo-evolu-n3lo-mass.log &

$prog -o NNPDF40_nnlo_pch_as_01180-n3lo-evolu-nnlo-mass -nloop 4 -n3lo-vfns-on 0 -pdf NNPDF40_nnlo_pch_as_01180 > NNPDF40_nnlo_pch_as_01180-n3lo-evolu-nnlo-mass.log &

$prog -o NNPDF40_nnlo_pch_as_01180-nnlo-evolu-nnlo-mass -nloop 3 -n3lo-vfns-on 0 -pdf NNPDF40_nnlo_pch_as_01180 > NNPDF40_nnlo_pch_as_01180-nnlo-evolu-nnlo-mass.log &

$prog -o toyHERA-n3lo-evolu-n3lo-mass -nloop 4 -n3lo-vfns-on 1 > toyHERA-n3lo-evolu-n3lo-mass.log&

$prog -o toyHERA-n3lo-evolu-nnlo-mass -nloop 4 -n3lo-vfns-on 0 > toyHERA-n3lo-evolu-nnlo-mass.log &

$prog -o toyHERA-nnlo-evolu-nnlo-mass -nloop 3 -n3lo-vfns-on 0 > toyHERA-nnlo-evolu-nnlo-mass.log

#!/bin/bash
#
# This script sets all necessary version-number information across
# Hoppet (including manual). It should be run from the
# top-level Hoppet directory.
#

if [ $# -ne 1 ]
then
 echo "Usage: scripts/set-version.sh version-number"
 exit
fi
t
version=$1
versionNumber=`echo $version | sed 's/-.*//'`
# if there is a dash in the version number, take everything afterwards
# for versionPreRelease, otherwise set versionPreRelease to an empty string
if echo $version | grep -q '-'
then
  versionPreRelease=$(echo $version | sed 's/.*-/-/')
else
  versionPreRelease=""
fi

changedFiles=""
checkChanged() {
  changedFile=$1
  if [ -n "$changedFile" ]; then
    changedFiles="$changedFiles $changedFile"
  fi
  diff $changedFile.bak $changedFile | colordiff
}

bold=$(tput bold)
normal=$(tput sgr0)

echo ${bold}"------------ Will set HOPPET version to $version -----------"${normal}
echo "versionNumber = $versionNumber"
echo "versionPreRelease = $versionPreRelease"

echo
echo ${bold}"------------ Setting it in CMakeLists.txt -------------------"${normal}
sed -i.bak 's/^project.hoppet VERSION [0-9.]*/project(hoppet VERSION '$versionNumber'/' CMakeLists.txt
sed -i.bak 's/^set.PROJECT_VERSION_PRERELEASE.*/set(PROJECT_VERSION_PRERELEASE "'$versionPreRelease'")/' CMakeLists.txt
checkChanged CMakeLists.txt
#diff CMakeLists.txt.bak CMakeLists.txt

echo ${bold}"------------ Setting it in src/welcome_message.f90 ---------------------"${normal}
sed -i.bak 's/private_version_string = .*/private_version_string = "'$version'"/' src/welcome_message.f90
checkChanged src/welcome_message.f90
#diff src/welcome_message.f90.bak src/welcome_message.f90
#AC_INIT([FastJet],[3.0.2-devel])

echo ${bold}"------------ Setting it in pyproject.toml ---------------------"${normal}
sed -i.bak 's/version = .*/version = "'$version'"/' pyproject.toml
checkChanged pyproject.toml

echo ${bold}"------------ Setting it in pyinterface/hoppet.i ---------------------"${normal}
sed -i.bak 's/__version__ = .*/__version__ = "'$version'"/' pyinterface/hoppet.i
checkChanged pyinterface/hoppet.i


# echo
# echo "------------ Setting it in configure.ac ---------------------"
# #sed -i.bak 's/\(AC_INIT.*\)])/\1-'$extralabel'])/' configure.ac
# sed -i.bak 's/^\(AC_INIT(\[.*\],\[\).*/\1'$version'])/' configure.ac
# diff configure.ac.bak configure.ac 
# #AC_INIT([FastJet],[3.0.2-devel])

# # now make sure the windows config file is consistent
# echo
# echo "------------ Setting it in include/fastjet/config_win.h -----"
# cp -p include/fastjet/config_win.h include/fastjet/config_win.h.bak
# cd src
# ./genconfig.sh ../include/fastjet/config_win.h
# cd ..
# diff include/fastjet/config_win.h.bak include/fastjet/config_win.h 

# echo
# echo "------------ Setting it in Doxyfile -------------------------"
# sed -i.bak 's/^\(PROJECT_NUMBER.*=\).*/\1 '$version'/' Doxyfile
# diff Doxyfile.bak Doxyfile


echo
echo ${bold}"------------ Setting it in doc/HOPPET-doc.tex --------------"${normal}
sed -i.bak 's/^\( *\)[^%]*\(%.*VERSION-NUMBER.*\)/\1version '$version'\2/' doc/HOPPET-doc.tex
checkChanged doc/HOPPET-doc.tex

echo
echo ${bold}"------------ Recommended ChangeLog entry --------------------"${normal}
# NB: -e option of echo ensures that \t translates to a tab character
echo -e "\t* CMakeLists.txt:"
# loop over changed files to print out which ones were changed
for f in $changedFiles; do
  if [ "$f" != "CMakeLists.txt" ]; then
    echo -e "\t* $f:"
  fi
done
echo -e "\tchanged version to $version"

#!/usr/bin/env bash
##
## Script to produce a a series of runs of varying accuracy, for easy
## comparisons of accuracy and timing.
##
## This script takes about 5 minutes on an M2Pro and produces
## around 50-90MB of output
##
## Reference results are stored in the 
## https://github.com/hoppet-code/2025-prec-and-timing
## repository

usage="$0 buildDir outputDir"
if [ "$#" -ne 2 ]; then
  echo "Usage: $usage"
  exit 1
fi
build_dir=$1
outdir=$2
#nloop=4
#checkinterp=no
nloop=3


# Set color variables only if output is a terminal
if [ -t 1 ]; then
  term_red='\033[0;31m'
  term_blue='\033[0;34m'
  term_reset='\033[0m'
else
  term_red=''
  term_blue=''
  term_reset=''
fi



dyvals="0.25 0.2 0.15 0.1 0.08 0.07 0.05 0.04 0.03 0.025"
echo -e $term_blue"Running with nloop = $nloop"$term_reset
echo -e $term_blue"Output directory: $outdir"$term_reset
echo "======================"
accdir=$(dirname "$0")
#build_dir=$(dirname "$0")/../../build
compare="$build_dir/benchmarking/compare2files_v2"
common="$build_dir/benchmarking/prec_and_timing -outputgrid -nxQ 5000 -auto-nrep -nrep-eval 100 -nrep-interp 1000000 -nloop $nloop"

# a shortcut for running comamnd and checking output
# Usage: `runthis outname command args`
runthis() {
  outname=$1
  shift 
  $* -o $outname > $outname.log 2>&1 || \
    (echo -e $term_red ERROR when running$term_reset; \
    echo "> $*" ; \
    echo -e $term_red"tail of output in $outname.log:"$term_reset; \
    echo "======================" ; \
    tail -n 10 $outname.log;
    exit 1)
}

if [ ! -d $outdir ]; then
  mkdir $outdir
fi


dyref=0.02
fname_ref=$outdir/nloop$nloop-ref-dy$dyref.dat
mkdir $outdir/nloop$nloop-ref-dy$dyref
echo "Getting a reference run with dy=$dyref ($fname_ref) and default eps"
runthis $fname_ref $common -dy $dyref -nopreev -lhapdf-out $outdir/nloop$nloop-ref-dy$dyref/nloop$nloop-ref-dy$dyref

fname_ref_smalleps=$outdir/nloop$nloop-ref-eps1e-9-dy$dyref.dat
mkdir $outdir/nloop$nloop-ref-eps1e-9-dy$dyref
echo "Getting a reference run with dy=$dyref ($fname_ref_smalleps) and smaller eps"
runthis $fname_ref_smalleps $common -dy $dyref -nopreev -eps 1e-9 -lhapdf-out $outdir/nloop$nloop-ref-eps1e-9-dy$dyref/nloop$nloop-ref-eps1e-9-dy$dyref

# doing runs to get accuracy with default interpolation settings
for dy in $dyvals
do 
  # get a basic "accuracy" run with pre-evolution
  echo -n Running with dy=$dy
  echo -n " preev"
  fname=$outdir/nloop$nloop-preev-dy$dy.dat
  mkdir $outdir/nloop$nloop-preev-dy$dy
  $common -dy $dy -preev -o $fname  -lhapdf-out $outdir/nloop$nloop-preev-dy$dy/nloop$nloop-preev-dy$dy > $fname.log 2>&1
  $compare $fname $fname_ref -summary -protect > $fname.acc.smry 2>&1
  #$compare $fname $fname_ref -channel 11 -protect > $fname.acc.ch11 2>&1

  echo    

done

#!/bin/zsh
# create a tar archive

# deduce version automatically from the appropriate include file
version=`grep HOPPET src/welcome_message.f90 | sed 's/.*HOPPET v. *//' | sed "s/ *' *//"`

origdir=`pwd | sed 's/.*\///'`
echo "Will make an archive of $origdir/"
dirhere=hoppet
dirtar=hoppet-$version
tarname=$dirtar.tgz
tmptarname=tmp-$tarname

# make sure we have Makefile with use CGAL=no

if [[ -e ../$tarname ]]
then
  echo "Tarfile $tarname already exists. Not proceeding."
elif [[ -e /tmp/$dirtar ]]
then
  echo "/tmp/$dirtar already exists, not proceeding"
else
  pushd ..

  echo "Creating tmp-$tarname"
  tar --exclude '.svn*' --exclude '*~' -zcf $tmptarname \
                      $dirhere/(src|example_f77|example_f90|benchmarking|benchmarking)/**/*.(f90|f|h|hh|alg|c|cc|C|eps|cpp|gp|pdf) \
                      $dirhere/doc/HOPPET-v1-doc.tex \
                      $dirhere/doc/*.(eps|sty) \
                      $dirhere/ChangeLog \
                      $dirhere/hoppet-config.in \
                      $dirhere/(src|example_f77|example_f90|benchmarking)/**/Makefile \
                      $dirhere/**/(README|INSTALL|Doxyfile|NEWS|COPYING|mkmk|configure|Makefile) \
                      $dirhere/scripts/*[a-z] \
                      $dirhere/example_f90/*.default_output 

  fulltarloc=`pwd`
  pushd /tmp
  echo "Unpacking it as /tmp/$dirhere"
  tar zxf $fulltarloc/$tmptarname
  mv -v /tmp/$dirhere /tmp/$dirtar
  echo "Repacking it with directory name $dirtar"
  tar zcvf $fulltarloc/$tarname $dirtar
  echo 
  echo "Removing /tmp/$dirhere"
  rm -rf $dirtar
  popd
  rm -v $tmptarname

  echo ""
    # if it's gavin running this then automatically copy the tarfile
    # to the web-space
  # webdir=~salam/www/repository/software/fastjet/
  # if [[ $USER = salam && -e $webdir ]]
  #     then
  #     echo "Copying .tgz file to web-site"
  #     cp -vp $tarname $webdir
  #     echo "************   Remember to edit web page **********"
  # fi

  popd

  # reminders about what to do for svn
  URL=`svn info | grep URL | sed 's/^.*URL: //'`
  tagURL=`echo $URL | sed "s/trunk/tags\/hoppet-$version/"`
  echo "Remember to tag the version:"
  echo "svn copy  -m 'tagged release of release $version' $URL $tagURL"
  echo "Copy it to hepforge:"
  echo "scp -p $fulltarloc/$tarname hepforge:hoppet/public_html/downloads/"
fi

#tar zcf $tarname

#!/bin/bash
#
# script to generate the html for the documentation
#

inname=HOPPET-v1-doc
outname=${inname}l2h

# remove 12 pt: apparently causes cropping problems?
# lstlisting -> verbatim: (lose colours, but get usable code)
echo '\nonstopmode' > $outname.tex
sed -e 's/\[12pt\]//' -e 's/lstlisting/verbatim/g' < $inname.tex >> $outname.tex


# the following go into ~/.latexhtml-init
# # apparently needed for html 4
# $LOWER_CASE_TAGS=1;
# # make sure we have local copies of icons
# $LOCAL_ICONS = 1;
# # try to get rid of black lines
# $DVIPSOPT = ' -E';


# actually run things
#latex $outname.tex
latex -r $outname.tex
latex -r $outname.tex
latex2html -split '+0'\
           -show_section_numbers  -numbered_footnotes \
           $outname.tex
rm $outname.*

#!/bin/bash
# Print colored banner for hoppet 2.0.0 release

# Some colours for printout
RED='\033[0;31m'
GREEN='\033[0;32m'
PURPLE='\033[1;35m'
NC='\033[0m' # No Color
version=$1 # From CMakeLists.txt

echo -e "\n"
echo -e "################################################################################"
echo -e "#${PURPLE}                             HOPPET ${version} RELEASE                             ${NC}#"
echo -e "#                                                                              #"
echo -e "# Note that since the 2.0.0 release, hoppet’s library name has been renamed    #"
echo -e "# from ${RED}hoppet_v1${NC} to ${GREEN}hoppet${NC}, and similarly for the main module and C++ include  #"
echo -e "# file. Users with an existing installation of hoppet (v1) should make sure    #"
echo -e "# that they link with the new library name.                                    #"
echo -e "#                                                                              #"
echo -e "################################################################################"

#!/usr/bin/env bash

usage="$0 buildDir refFile outputDir"
if [ "$#" -ne 3 ]; then
    echo "Usage: $usage"
    exit 1
fi
builddir=$1
ref=$2
outputdir=$3

mkdir -p $outputdir
logfile=$outputdir/LHAPDF-run.log
if [ -f $logfile ]; then
    echo "Warning: $logfile already exists, replacing it"
    mv $logfile $logfile.old
fi
touch $logfile
echo $* >> $logfile
date >> $logfile
echo "Running from: $(pwd)" >> $logfile
echo "Using build dir: $builddir" >> $logfile
echo "Using reference file: $ref" >> $logfile
echo "Using output dir: $outputdir" >> $logfile



for file in nloop3-preev-dy0.025 nloop3-preev-dy0.04 nloop3-preev-dy0.07 nloop3-preev-dy0.1 nloop3-preev-dy0.2 nloop3-ref-dy0.02 nloop3-preev-dy0.03 nloop3-preev-dy0.05 nloop3-preev-dy0.08 nloop3-preev-dy0.15 nloop3-preev-dy0.25 nloop3-ref-eps1e-9-dy0.02
do
    echo "------- Running PDFset $file through LHAPDF" | tee -a $logfile 
    $builddir/benchmarking/lhapdf_timings $file $outputdir >> $logfile 
    $builddir/benchmarking/compare2files_v2 $outputdir/${file}.lhapdf.dat $ref -summary -protect > $outputdir/$file.lhapdf.dat.acc.smry 2>&1 
done

#!/usr/bin/env bash
##
## Script to produce a a series of runs of varying accuracy, for easy
## comparisons of accuracy and timing.
##
## This script takes about 5 minutes on an M2Pro and produces
## around 50-90MB of output
##
## Reference results are stored in the 
## https://github.com/hoppet-code/2025-prec-and-timing
## repository

usage="$0 buildDir outputDir [-nloop=N] [-checkinterp=yes|no] [-4gridswider=yes|no]"
if [ "$#" -lt 2 ]; then
  echo "Usage: $usage"
  exit 1
fi
build_dir=$1
outdir=$2
#nloop=4
#checkinterp=no
# our defaults
nloop=3
checkinterp=yes
fourgridswider=no
# Parse optional arguments
shift 2
while [[ $# -gt 0 ]]; do
  echo $1
  case "$1" in
    -nloop=*|-checkinterp=*|-4gridswider=*)
      opt="${1%%=*}"
      val="${1#*=}"
      case "$opt" in
        -nloop)
          nloop="$val"
          ;;
        -checkinterp)
          checkinterp="$val"
          ;;
        -4gridswider)
          fourgridswider="$val"
          ;;
      esac
      shift
      ;;
    *)
      echo "Unknown option: $3"
      echo "Usage: $usage"
      exit 1
      ;;
  esac
done

# if fourgridswider=yes, we add the option -4grids-wider to extra opts
# and 4gridswider to the name after -dy
extraopts=""
extraname=""
if [ x"$fourgridswider" = x"yes" ]; then
  extraopts="$extraopts -4grids-wider"
  extraname="${extraname}-4gridswider"
fi

# Set color variables only if output is a terminal
if [ -t 1 ]; then
  term_red='\033[0;31m'
  term_blue='\033[0;34m'
  term_reset='\033[0m'
else
  term_red=''
  term_blue=''
  term_reset=''
fi



dyvals="0.25 0.2 0.15 0.1 0.08 0.07 0.05 0.04 0.03 0.025"
echo -e $term_blue"Running with nloop = $nloop"$term_reset
echo -e $term_blue"Output directory: $outdir"$term_reset
echo -e $term_blue"Checking interpolation settings: $checkinterp"$term_reset
echo -e $term_blue"Extra options: $extraopts"$term_reset
echo "======================"
sleep 2
accdir=$(dirname "$0")
#build_dir=$(dirname "$0")/../../build
compare="$build_dir/benchmarking/compare2files_v2"
common="$build_dir/benchmarking/prec_and_timing -outputgrid -nxQ 5000 -auto-nrep -nrep-eval 100 -nrep-interp 1000000 -nloop $nloop $extraopts"

# a shortcut for running comamnd and checking output
# Usage: `runthis outname command args`
runthis() {
  outname=$1
  shift 
  $* -o $outname > $outname.log 2>&1 || \
    (echo -e $term_red ERROR when running$term_reset; \
    echo "> $*" ; \
    echo -e $term_red"tail of output in $outname.log:"$term_reset; \
    echo "======================" ; \
    tail -n 10 $outname.log;
    exit 1)
}

if [ ! -d $outdir ]; then
  mkdir -p $outdir
  if [ ! -d $outdir ]; then
    echo "Could not create output directory $outdir"; exit 1
  fi
fi


dyref=0.02
fname_ref=$outdir/nloop$nloop-ref$extraname-dy$dyref.dat
echo "Getting a reference run with dy=$dyref ($fname_ref) and default eps"
runthis $fname_ref $common -dy $dyref -nopreev 


fname_ref_smalleps=$outdir/nloop$nloop-ref-eps1e-9$extraname-dy$dyref.dat
echo "Getting a reference run with dy=$dyref ($fname_ref_smalleps) and smaller eps"
runthis $fname_ref_smalleps $common -dy $dyref -nopreev -eps 1e-9

# tests with exact splitting functions
dyexact=0.1
echo "Running checks with exact NNLO splitting or threshold functions (dy=$dyexact)"
runthis $outdir/nloop$nloop-exactsp-nopreev$extraname-dy$dyexact.dat $common -dy $dyexact -nopreev -exact-nnlo-sp
runthis $outdir/nloop$nloop-exactspth-nopreev$extraname-dy$dyexact.dat $common -dy $dyexact -nopreev -exact-nnlo-sp -exact-nnlo-th

# doing runs to get accuracy with default interpolation settings
for dy in $dyvals
do 
  # get a basic "accuracy" run without pre-evolution
  echo -n Running with dy=$dy
  echo -n " nopreev"
  fname=$outdir/nloop$nloop-nopreev$extraname-dy$dy.dat
  $common -dy $dy -nopreev -o $fname  > $fname.log 2>&1
  $compare $fname $fname_ref -summary -protect > $fname.acc.smry 2>&1 
  #$compare $fname $fname_ref -channel 11 -protect > $fname.acc.ch11 2>&1

  # get a basic "accuracy" run with pre-evolution
  echo -n " preev"
  fname=$outdir/nloop$nloop-preev$extraname-dy$dy.dat
  $common -dy $dy -preev -o $fname  > $fname.log 2>&1
  $compare $fname $fname_ref -summary -protect > $fname.acc.smry 2>&1
  #$compare $fname $fname_ref -channel 11 -protect > $fname.acc.ch11 2>&1

  if [ x"$checkinterp" = x"yes" ]; then
    for pair in "2 2" "3 3" "4 4" "4 6"
    do
      set -- $pair
      olnlnQ=$1
      oy=$2
      echo -n " oQ$olnlnQ-oY$oy"
      fname=$outdir/nloop$nloop-preev$extraname-oQ$olnlnQ-oY$oy-dy$dy.dat
      runthis $fname $common -dy $dy -preev -olnlnQ $olnlnQ -yinterp-order $oy
      $compare $fname $fname_ref -summary -protect > $fname.acc.smry 2>&1
      #$compare $fname $fname_ref -channel 11 -protect > $fname.acc.ch11 2>&1
    done
  fi
  echo    

done

#!/usr/bin/env bash
# 
# Run this from the CMake build directory
#
# Usage PATH/gen-default-output.sh [-s]
#
# Options:
#
# -s: generate actual output (default is dry-run)
#
# If you change the list of tests, remember to make sure:
#
# - that the list is the same in the top-level CMakeLists.txt
# - that no unrequired files are left in this directory


runs=(\
  benchmarking/prec_and_timing:-dy:0.2:-olnlnQ:2:-yinterp-order:2 \
  benchmarking/prec_and_timing:-dy:0.2:-olnlnQ:3:-yinterp-order:3 \
  benchmarking/prec_and_timing:-dy:0.2:-olnlnQ:4:-yinterp-order:4 \
  benchmarking/prec_and_timing:-dy:0.1:-exact-nnlo-th:-exact-nnlo-sp \
)

dummy=yes
# if the user provides a -s argument, then set dummy to no 
# and generate actual output
if [[ "$1" == "-s" ]]; then
    dummy=no
fi

# Colors for output
blue="\033[0;34m"
yellow="\033[0;33m"
red="\033[0;31m"
green="\033[0;32m"
bold="\033[1m"
reset="\033[0m"

scriptdir=$(dirname "$(realpath "$0")")
echo "Output files will go to $scriptdir"
extraargs="-o /dev/null -output-benchmark"

for run in "${runs[@]}"
do 
    echo "============================================================="
    echo -e "${blue}${bold}Preparing $run${reset}"
    testcmd=$(echo "$run" | sed -e 's/:/ /g')
    testcmd="${testcmd} ${extraargs}"
    outfile=$(echo "$run" | sed -e 's/:/_/g' -e s'|benchmarking/||').default_output
    echo -e "Command is: ${bold}$testcmd${reset}"

    if [[ "$dummy" == "no" ]]; then
        echo -e "Output saved to: $scriptdir/$outfile"
        echo "=============================================================\n"
        $testcmd | tee $scriptdir/$outfile 
    else
        echo -e "${bold}Dry-run${reset}, output would be saved to: $scriptdir/$outfile"
        echo "=============================================================\n"
        #$testcmd
    fi
done

if [[ "$dummy" == "no" ]]; then
    echo -e "${green}${bold}Output saved...${reset}"
else
    echo -e "${red}${bold}Dry run mode: no output was saved (re-run with -s to save output).${reset}"
fi

#!/usr/bin/env bash
#
# Run the evolution_n3lo_tests program for different scales and alpha_s values
# so as to test that we do not break the N3LO accuracy when changing x_muR.

# location of the executable relative to the directory of this script
execdir=`dirname $0`/../

$execdir/evolution_n3lo_tests -nloop 4 -Q 100000000 -Q0 1 -asQ0 0.0125 -o nloop4-asQ0-0.0125-range100000000.dat
$execdir/evolution_n3lo_tests -nloop 4 -Q 10000     -Q0 1 -asQ0 0.025  -o nloop4-asQ0-0.025-range10000.dat
$execdir/evolution_n3lo_tests -nloop 4 -Q 100       -Q0 1 -asQ0 0.05   -o nloop4-asQ0-0.05-range100.dat
$execdir/evolution_n3lo_tests -nloop 4 -Q 10        -Q0 1 -asQ0 0.1    -o nloop4-asQ0-0.1-range10.dat

# This is the checklist for making releases

Typically one copies this over to the release section of the private repo
and then ticks off the items.

- [ ] start on dev branch, make sure everything relevant is merged in
- [ ] run ctest
- [ ] check/update NEWS.md, including release date; commit
- [ ] run `scripts/set-version.sh X.Y.Z`
- [ ] update ChangeLog as per suggestion, adding "Release X.Y.Z"
- [ ] commit and push (on dev branch)
- [ ] check that wheels work, by going to actions, "Build Python Wheels"
      and selecting the dev branch (takes c. 15 minutes)
- [ ] from master `git merge origin/dev; git push` OR create pull request
- [ ] once merged, make a release from https://github.com/hoppet-code/hoppet/releases/new
      tagging it as hoppet-X.Y.Z; as text, include the NEWS.md text
- [ ] go to on github actions and press "Build Python Wheels"
- [ ] run `scripts/set-version.sh X.Y.(Z+1)-dev0` and update ChangeLog

hoppet development team
===========================

Developers past/present
-----------------

* Frederic Dreyer
* [Alexander Karlberg     ](mailto:alexander.karlberg@cern.ch        "email")
* [Paolo Nason            ](mailto:paolo.nason@mib.infn.it           "email")
* [Juan Rojo              ](https://research.vu.nl/en/persons/juan-rojo "homepage")
* [Gavin Salam            ](https://www.physics.ox.ac.uk/our-people/salam "homepage")
* [Giulia Zanderighi      ](https://www.mpp.mpg.de/en/about-us/organization/directors/prof-dr-giulia-zanderighi "homepage")

Additionally, [Andrii Verbytskyi](mailto:andrii.verbytskyi@mpp.mpg.de        "email") contributed significant parts of the CMake infrastructure.

See also the LICENSE file for information on third-party code that has been included.

# libome                                                             {#mainpage}

This library provides numerical implementations of the QCD corrections up to
three-loop order to the massive operator matrix elements (OMEs) of the QCD
twist-2 operators in x-space.

## Overview

There are seven unpolarised OMEs that contribute up to three-loop order:
| OME                                    | name used in libome |
|----------------------------------------|---------------------|
| \f$A_{Qg}\f$                           | `AQg`               |
| \f$A_{gg,Q}\f$                         | `AggQ`              |
| \f$A_{Qq}^\text{PS}\f$                 | `AQqPS`             |
| \f$A_{qq,Q}^\text{PS}\f$               | `AqqQPS`            |
| \f$A_{gq,Q}\f$                         | `AgqQ`              |
| \f$A_{qg,Q}\f$                         | `AqgQ`              |
| \f$A_{qq,Q}^{\text{NS},+}\f$           | `AqqQNSEven`        |
| \f$A_{qq,Q}^{\text{NS},-}\f$           | `AqqQNSOdd`         |
Regarding the analytic continuation, the implementation of all of these OMEs
correspond to the analytic continuation from even moments, except for
\f$A_{qq,Q}^{\text{NS},-}\f$, which is analytically continued from odd moments.

Similarly, there are seven polarised OMEs:
| OME                                 | name used in libome    |
|-------------------------------------|------------------------|
| \f$\Delta A_{Qg}\f$                 | `polAQg`               |
| \f$\Delta A_{gg,Q}\f$               | `polAggQ`              |
| \f$\Delta A_{Qq}^\text{PS}\f$       | `polAQqPS`             |
| \f$\Delta A_{qq,Q}^\text{PS}\f$     | `polAqqQPS`            |
| \f$\Delta A_{gq,Q}\f$               | `polAgqQ`              |
| \f$\Delta A_{qg,Q}\f$               | `polAqgQ`              |
| \f$\Delta A_{qq,Q}^{\text{NS},+}\f$ | `polAqqQNSEven`        |
| \f$\Delta A_{qq,Q}^{\text{NS},-}\f$ | `polAqqQNSOdd`         |
They are analytically continued from odd moments, except for
\f$A_{qq,Q}^{\text{NS},+}\f$, which is analytically continued from even
moments. The polarised OMEs were calculated in the Larin scheme.

The OMEs depend on four parameters:
- the strong coupling \f$a_s = \frac{\alpha_s}{4 \pi} = \frac{g_s}{(4 \pi)^2}\f$
  in the \f$\overline{\text{MS}}\f$ scheme for \f$N_F+1\f$ active flavours
- the logarithm \f$L_M = \log\left(\frac{m^2}{\mu^2}\right)\f$, where \f$m\f$
  is the mass of the heavy quark in the on-shell scheme and \f$\mu\f$ is the
  renormalisation scale
- the number of massless quark flavours \f$N_F\f$
- the Bjorken variable \f$x\f$

The OMEs are distributions in \f$x\f$ with the following general structure
\f[
A(x) = A_\text{reg}(x) + [A_+(x)]_+ + \delta(1-x) A_\delta
\f]
that is, there are regular, plus and delta parts. The library follows the
convention to append the suffix `_reg` to the regular part
\f$A_\text{reg}(x)\f$, the suffix `_plus` to plus distributions \f$A_+(x)\f$ and
the suffix `_delta` to the coefficient \f$A_\delta\f$ of delta distributions.
All OMEs have regular parts, but only the OMEs \f$(\Delta) A_{gg,Q}\f$ and
\f$(\Delta) A_{qq,Q}^{\text{NS},\pm}\f$ have plus and delta parts. 


## Basic usage from C++

To use it from your own C++ code, include the default header
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~{.cpp}
#include <ome/ome.h>
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
which will include all relevant further headers. Everything in this library
lives in the namespace `ome`. You will then have access to constant global
objects that represent the massive OMEs and can be evaluated with numerical
values for the parameters as arguments.

### Evaluation

Evaluation of all orders up to the highest available one (i.e. three loop) then
is possible by simply calling, e.g.,
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~{.cpp}
double as = 0.01, LM = 5., NF = 3., x = 0.2;
double res_reg   = ome::AqqQNSEven_reg(as, LM, NF, x);
double res_plus  = ome::AqqQNSEven_plus(as, LM, NF, x);
double res_delta = ome::AqqQNSEven_delta(as, LM, NF);
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Note that the delta part only depends on `as`, `LM` and `NF`, but not on `x`
since it is only the coefficient of the \f$\delta(1-x)\f$ distribution.

These constant global objects are implemented as nestings of
[laurent_polynomial] classes (and further classes at deeper nesting levels).
If you are interested in these implementation details, see the
[list of public data types](#ome-data-types) for a more detailed description
of how classes are nested to achive this.

### Truncation

Since it is sometimes desiable to evaluate an OME only up to a certain order in
the strong coupling constant, it is possible to truncate the series in
\f$a_s\f$ at a specified order. There is a [truncate] method that implements
this idea
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~{.cpp}
auto trunc_as2 = ome::AQg_reg.truncate(2);
double res_trunc_as2 = trunc_as2(as, LM, NF, x);
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
One technical comment: truncation is a relatively cheap operation. The object
returned by the `truncate` method is a [laurent_polynomial_view] which is a
lightweight object that only refers to a [laurent_polynomial], but does not
contain a copy of the coefficient data itself.

### Coefficient access

It is also possible to isolate a specific coefficient of the (Laurent)
polynomials. For example, if you need only the \f$O(a_s^3)\f$ coefficient
of \f$A_{Qq}^{\text{PS}}\f$ you can extract it via the [access operator]
like so
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~{.cpp}
auto coeff_as3 = ome::AQqPS_reg[3];
double res_coeff_as3 = coeff_as3(LM, NF, x);
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
To evaluate the coefficient, you of course no longer have to pass `as` as an
argument.

It is also possible to then extract the coefficient of, e.g., \f$O(LM^0)\f$ by
using the access operator again
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~{.cpp}
auto coeff_as3_LM0 = ome_coeff_as3[0];
double res_coeff_as3_LM0 = coeff_as3_LM0(NF, x);
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

To find out the minimal and maximal exponents of a (Laurent) polynomial use the
[min_power] and [max_power] methods
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~{.cpp}
int min_pow = ome::AQqPS_reg.min_power();
int max_pow = ome::AQqPS_reg.max_power();
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

Accessing a coefficient outside this range will return an object that will
always evaluate to zero.

### `rpd_distribution` containers

In order to simplify the handling of OMEs as objects with regular, plus and
delta parts, there is a specialised container called [rpd_distribution] which
holds these three parts (or rather those of them that the OME actually has).
The idea is that instead of having to pass around three objects separately (and
having to implement special cases for when one of these parts is absent) you
can instead just pass one [rpd_distribution] container that holds all three.

Since not every OME has all three parts, they are stored in `std::optional`
objects. Thus, the absence of one of the three parts can be modeled using
`std::nullopt`.

For each of the OMEs, there is also a corresponding global [rpd_distribution]
object:
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~{.cpp}
bool has_reg = ome::AggQ.has_regular();
auto reg = ome::AggQ.get_regular(); // equivalent to ome::AggQ_reg object
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

The [rpd_distribution] container also supports truncation and coefficient
access
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~{.cpp}
auto rpd_trunc_as2 = ome::AggQ.truncate(2);
auto rpd_coeff_as2 = ome::AggQ.get_coefficient(2);
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

### Calculating Mellin moments and convolutions

Finally, the library provides simple interfaces to numerically calculate Mellin
moments and convolutions. The numerical integrator is wrapped by an interface
called [integration_engine] for which the library provides a default
implementation, [integration_engine_gsl] based on the GNU Scientific Libarary
and its CQUAD numerical integration routine.

The class [mellin_moment] implements the computation of Mellin moments. For OMEs
it is probably most straightforward to construct the object directly from a
[rpd_distribution] using the factory function [make_mellin_moment]. This
function takes the [rpd_distribution], an [integration_engine] and a list of
values for the numerical parameters that are not being integrated (i.e., `as`,
`LM` and `NF` for OMEs) as arguments. The moment can then be computed using the
[mellin_moment::integrate] method, providing the moment `n` and the absolute and
relative precision target for the numerical integration as arguments.
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~{.cpp}
ome::integration_engine_gsl engine;
ome::mellin_moment<double> mom
  = make_mellin_moment(ome::AgqQ, engine, as, LM, NF);

double eps_abs = 1.e-15, eps_rel = 1.e-10;
int n = 4;
auto res = mom.integrate(n, eps_abs, eps_rel);
if(std::get<0>(res) != ome::integration_status::sucess)
  std::cerr << "Warning: numerical integration did not succeed." << std::endl;

std::cout << std::get<1>(res) << " +- " << std::get<2>(res) << std::endl;
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
The [mellin_moment::integrate] method returns an `std::tuple` of an
[integration_status], a double representing the value of the moment computed
and a double representing and error estimate from the numerical integration.

Similarly, Mellin convolutions can be computed using the [mellin_convolution]
class. It can also be constructed from an [rpd_distribution] using the
[make_mellin_convolution] factory function.
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~{.cpp}
ome::mellin_convolution<double> conv
  = make_mellin_convolution(ome::AgqQ, std::function(test_function)
                            engine, as, LM, NF);
double x_conv = 0.05;
auto res = conv.integrate(x_conv, eps_abs, eps_rel);
if(std::get<0>(res) != ome::integration_status::sucess)
  std::cerr << "Warning: numerical integration did not succeed." << std::endl;

std::cout << std::get<1>(res) << " +- " << std::get<2>(res) << std::endl;
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Here, we pass the function we convolve with as an `std::function`.


## Basic usage from C

While the library is written in C++, it also offers a simplified interface that
can also be [used from C](#c-interface). While it does not
offer the [rpd_distribution] container or the interfaces to numerically
calculate Mellin moments and convolutions, it does allow to evaluate the OMEs,
truncated OMEs or OME coefficients.

In order to use the library in your C code, you still just include the default
header
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~{.c}
#include <ome/ome.h>
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
which only exposes the C interface if it is processed by a C compiler.

For every OME listed above, there exists a set of functions with C linkage
that return the evaluation of that OME. The signature for the functions
to evaluate the full OME follows the schema
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~{.c}
double ome_<name>_reg(double as, double LM, double NF, double x);
double ome_<name>_plus(double as, double LM, double NF, double x);
double ome_<name>_delta(double as, double LM, double NF);
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
where `<rpd>` is either `reg`, `plus` or `delta`. If the OME only has a regular
part, only the `reg` function is provided.

In addition, there is a set of functions for evaluating the OMEs truncated to
a particular order in \f$a_s\f$:
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~{.c}
double ome_<name>_reg_trunc_as(int order_as, double LM, double NF, double x);
double ome_<name>_plus_trunc_as(int order_as, double LM, double NF, double x);
double ome_<name>_delta_trunc_as(int order_as, double LM, double NF);
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

You can also evaluate only a specific coefficient of \f$a_s\f$, \f$L_M\f$ or
\f$N_F\f$:
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~{.c}
double ome_<name>_reg_coeff_as(int order_as, double LM, double NF, double x);
double ome_<name>_plus_coeff_as(int order_as, double LM, double NF, double x);
double ome_<name>_delta_coeff_as(int order_as, double LM, double NF);

double ome_<name>_reg_coeff_as_LM(int order_as, int order_LM, double NF, double x);
double ome_<name>_plus_coeff_plus_LM(int order_as, int order_LM, double NF, double x);
double ome_<name>_delta_coeff_delta_LM(int order_as, int order_LM, double NF);

double ome_<name>_reg_coeff_as_LM_NF(int order_as, int order_LM, int order_NF, double x);
double ome_<name>_plus_coeff_as_LM_NF(int order_as, int order_LM, int order_NF, double x);
double ome_<name>_delta_coeff_as_LM_NF(int order_as, int order_LM, int order_NF, double x);
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

Finally, to determine the exponent ranges of non-vanishing coefficients of the
polynomials in \f$a_s\f$, \f$L_M\f$ or \f$N_F\f$, you can use the following
functions:
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~{.c}
/* minimum and maximum power in as for the whole OME */
int ome_<name>_reg_min_power();
int ome_<name>_reg_max_power();
int ome_<name>_plus_min_power();
int ome_<name>_plus_max_power();
int ome_<name>_delta_min_power();
int ome_<name>_delta_max_power();

/* minimum and maximum power in LM for the specified coefficient of as */
int ome_<name>_reg_coeff_as_min_power(int order_as);
int ome_<name>_reg_coeff_as_max_power(int order_as);
int ome_<name>_plus_coeff_as_min_power(int order_as);
int ome_<name>_plus_coeff_as_max_power(int order_as);
int ome_<name>_delta_coeff_as_min_power(int order_as);
int ome_<name>_delta_coeff_as_max_power(int order_as);

/* minimum and maximum power in NF for the specified coefficient of as and LM */
int ome_<name>_reg_coeff_as_LM_min_power(int order_as, int order_LM);
int ome_<name>_reg_coeff_as_LM_max_power(int order_as, int order_LM);
int ome_<name>_plus_coeff_as_LM_min_power(int order_as, int order_LM);
int ome_<name>_plus_coeff_as_LM_max_power(int order_as, int order_LM);
int ome_<name>_delta_coeff_as_LM_min_power(int order_as, int order_LM);
int ome_<name>_delta_coeff_as_LM_max_power(int order_as, int order_LM);
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~


[laurent_polynomial]: @ref ome::laurent_polynomial "laurent_polynomial"
[laurent_polynomial_view]: @ref ome::laurent_polynomial_view "laurent_polynomial_view"
[truncate]: @ref ome::laurent_polynomial_view::truncate "truncate"
[access operator]: @ref ome::laurent_polynomial_view::operator[] "access operator"
[min_power]: @ref ome::laurent_polynomial_view::min_power "min_power"
[max_power]: @ref ome::laurent_polynomial_view::max_power "max_power"
[rpd_distribution]: @ref ome::rpd_distribution
[integration_engine]: @ref ome::integration_engine "integration_engine"
[integration_engine_gsl]: @ref ome::integration_engine_gsl "integration_engine_gsl"
[mellin_moment]: @ref ome::mellin_moment "mellin_moment"
[make_mellin_moment]: @ref ome::make_mellin_moment "make_mellin_moment"
[mellin_moment::integrate]: @ref ome::mellin_moment::integrate "integrate"
[integration_status]: @ref ome::integration_status "integration_status"
[mellin_convolution]: @ref ome::mellin_convolution "mellin_convolution"
[make_mellin_convolution]: @ref ome::make_mellin_convolution "make_mellin_convolution"
